﻿using System;
using System.Collections.Generic;
using System.Text;

using Cosmos.BaseFrame;
using Cosmos.UserFrame;
using Cosmos.Common;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : Database 관련 클래스 Activator
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    public class Activator : InitServiceAbstract
    {
        /// <summary>
        /// 프로젝트 로드의 주진입점을 정의합니다.
        /// </summary>
        public Activator()
        {
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sClassNm"></param>
        /// <returns></returns>
        public override object InitServiceInstance(string sClassNm)
        {
            //UserLog.WriteLogFile(UserCom.LOG_DEBUG, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      
            //                    "Activator.InitServiceInstance()", "Message : " + sClassNm + " Registration Starting !!!");

            object retObj = null;

            //클래스 찾아오기 위함
            switch (sClassNm)
            {
                case ServiceLists.AGENT_DATABASE.DATABASE_MSSQL:
                    {
                        Cosmos.Database.DatabaseMssql agentClass = new Cosmos.Database.DatabaseMssql();
                        retObj = agentClass;
                        break;
                    }
                case ServiceLists.AGENT_DATABASE.DATABASE_ORACLE:
                    {
                        //Cosmos.Database.DatabaseOracle agentClass = new Cosmos.Database.DatabaseOracle();
                        //retObj = agentClass;
                        break;
                    }
            }

            //UserLog.WriteLogFile(UserCom.LOG_DEBUG, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
            //                    "Activator.InitServiceInstance()", "Message : " + sClassNm + " Registration Completed !!!");

            return retObj;

        }
    }
}
