﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using SPC.Kiosk.Common;
using SPC.Kiosk.Base;
namespace SPC.Kiosk.Popup.Model
{
    /// <summary>
    /// HappyPoint 인증 및 사용 정보
    /// </summary>
    public class M_HappyPointReturn
    {
        /// <summary>
        /// 회원명
        /// </summary>
        public string MemberName { get; set; } = string.Empty;
        /// <summary>
        /// 회원인증번호
        /// </summary>
        public string MemberNumber { get; set; } = string.Empty;
        /// <summary>
        /// 회원인증번호
        /// </summary>
        public string MemberCode { get; set; } = string.Empty;
        /// <summary>
        /// 앱 고객 여부
        /// </summary>
        public bool IsAppMamber { get; set; } = false;
        /// <summary>
        /// MemberLevel
        /// </summary>
        public HappyPointMemberLevel MemberLevel { get; set; } = HappyPointMemberLevel.None;
        /// <summary>
        /// 적립된 포인트
        /// </summary>
        public double MemberPoint { get; set; } = 0;
        /// <summary>
        /// 가용 포인트
        /// </summary>
        public double UseablePoint { get; set; } = 0;
        /// <summary>
        /// 적립 유무
        /// </summary>
        public bool ReservePoint { get; set; } = false;
        /// <summary>
        /// 포인트 사용유무
        /// </summary>
        public bool PointUse { get; set; } = false;
        /// <summary>
        /// 사용 포인트
        /// </summary>
        public double UsingPoints { get; set; } = 0;
        /// <summary>
        /// SPC 직원 유무
        /// </summary>
        public bool IsCompanyMember { get; set; }
        /// <summary>
        /// 단골 매장 유무
        /// </summary>
        public bool IsFavoriteStore { get; set; } = false;
        /// <summary>
        /// 포인트 카드 사용 유무
        /// </summary>
        public bool IsCardNoUsed { get; set; }
        /// <summary>
        /// Password 사용유무
        /// </summary>
        public bool NeedPassword { get; set; }
        /// <summary>
        /// 승인 순번
        /// </summary>
        public long PaySEQ { get; set; } = -1L;
        public List<M_HappyCoupon> MyHappyCoupons { get; set; } = new List<M_HappyCoupon>();
        public List<string> OrderHistoryItems { get; set; }
    }
    /// <summary>
    /// HappyPoint In Card Coupon Data
    /// </summary>
    public class M_HappyCoupon 
    {
        /// <summary>
        /// Coupon 번호
        /// </summary>
        public string Number { get; set; } = string.Empty;
        /// <summary>
        /// Coupon 명
        /// </summary>
        public string Name { get; set; } = string.Empty;
        /// <summary>
        /// 유효기간 시작
        /// </summary>
        public DateTime StartDate { get; set; } = DateTime.MinValue;
        /// <summary>
        /// 유효 기간 종료
        /// </summary>
        public DateTime EndDate { get; set; } = DateTime.MinValue;
        /// <summary>
        /// 사용됨
        /// </summary>
        public bool IsUsed { get; set; } = false;
        /// <summary>
        /// Discount 금액
        /// </summary>
        public double UseAmount { get; set; } = 0d;
        /// <summary>
        /// 승인 순번
        /// </summary>
        public long PaySEQ { get; set; } = -1L;
    }


}