﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using SPC.Kiosk.Common;

namespace SPC.Kiosk.Popup.Model
{
    /// <summary>
    /// 단골 매장 컨트롤용 모델
    /// </summary>
    public class M_StoreAgree
    {
        /// <summary>
        /// 단골 매장 유무
        /// </summary>
        public bool IsFavoriteStore { get; set; } = false;
        /// <summary>
        /// 표시언어
        /// </summary>
        public SupportLanguageType DisplayLanguage { get; set; }
        /// <summary>
        /// 제목
        /// </summary>
        public List<M_Language> Header { get; set; }
        /// <summary>
        /// 배경 이미지
        /// </summary>
        public string BackgroundImage { get; set; }
        /// <summary>
        /// 점포 이미지
        /// </summary>
        public string StoreImage { get; set; }
        /// <summary>
        /// 점포명
        /// </summary>
        public string StoreName { get; set; }
        /// <summary>
        /// 등록 첫번째 안내
        /// </summary>
        public List<M_Language> FirstInfoText { get; set; }
        /// <summary>
        /// 등록 두번째 안내
        /// </summary>
        public List<M_Language> SecondInfoText { get; set; }
        /// <summary>
        /// 환영 안내
        /// </summary>
        public List<M_Language> WelcomeInfoText { get; set; }
        /// <summary>
        /// Button Normal Brush 
        /// </summary>
        public string ButtonNormalBrush { get; set; }
        /// <summary>
        /// Button SwitchOn Brush
        /// </summary>
        public string ButtonSwitchOnBrush { get; set; }
        /// <summary>
        /// Button Text
        /// </summary>
        public List<M_Language> ButtonText { get; set; }
    }
}