﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace SPC.Kiosk.Popup.Model
{
    /// <summary>
    /// 미니팝업 아이콘 타입
    /// </summary>
    public enum MiniPopupIcon
    {
        /// <summary>
        /// 없음
        /// </summary>
        None,
        /// <summary>
        ///  취소
        /// </summary>
        Cancel,
        /// <summary>
        /// 삭제
        /// </summary>
        Delete,
        /// <summary>
        /// 목록 삭제
        /// </summary>
        ListCancel,
        /// <summary>
        /// 할인 취소
        /// </summary>
        DiscountCancel,
        /// <summary>
        /// 상은품 취소
        /// </summary>
        GiftCancel,
        /// <summary>
        /// 주문 취소
        /// </summary>
        OrderCancel,
        /// <summary>
        /// 쿠폰 추가
        /// </summary>
        AddCoupon,
        /// <summary>
        /// 결제
        /// </summary>
        Payment,
    }
    /// <summary>
    /// Number Pad Buttons
    /// </summary>
    public enum NumberPadButton
    {
        /// <summary>
        /// Button0
        /// </summary>
        Button0,
        /// <summary>
        /// Button1
        /// </summary>
        Button1,
        /// <summary>
        /// Button2
        /// </summary>
        Button2,
        /// <summary>
        /// Button3
        /// </summary>
        Button3,
        /// <summary>
        /// Button4
        /// </summary>
        Button4,
        /// <summary>
        /// Button5
        /// </summary>
        Button5,
        /// <summary>
        /// Button6
        /// </summary>
        Button6,
        /// <summary>
        /// Button7
        /// </summary>
        Button7,
        /// <summary>
        /// Button8
        /// </summary>
        Button8,
        /// <summary>
        /// Button9
        /// </summary>
        Button9,
        /// <summary>
        /// ButtonCancel
        /// </summary>
        ButtonCancel,
        /// <summary>
        /// ButtonBack
        /// </summary>
        ButtonBack,
        /// <summary>
        /// None Button
        /// </summary>
        ButtonNone
    }
    /// <summary>
    /// Mobile Coupon Window Type
    /// </summary>
    public enum MobileCouponWindowType
    {
        /// <summary>
        /// 쿠폰조회 시작
        /// </summary>
        CouponStart,
        /// <summary>
        /// 쿠폰사용 시작
        /// </summary>
        CouponUsing,
        /// <summary>
        /// 처리중
        /// </summary>
        Processing,
        /// <summary>
        /// 처리 실패
        /// </summary>
        ProcessingError,
        /// <summary>
        /// 인증 처리 성공
        /// </summary>
        CouponSuccess,
    }
    /// <summary>
    /// 인증창/통신사 할인 WindowType
    /// </summary>
    public enum CertifyWindowType
    {
        /// <summary>
        /// 인증 처리시작
        /// </summary>
        CertifyStart,
        /// <summary>
        /// 인증 처리중
        /// </summary>
        CertifyProcessing,
        /// <summary>
        /// 인증 실패
        /// </summary>
        ProcessingError,
        /// <summary>
        /// 인증 처리 성공
        /// </summary>
        CertifySuccess,
    }
    /// <summary>
    /// Happy Point Coupon Window Type
    /// </summary>
    public enum HappyCouponWindowType
    {
        /// <summary>
        /// 쿠폰 인식
        /// </summary>
        CouponStart,
        /// <summary>
        /// 쿠폰 선택
        /// </summary>
        CouponUsing,
        /// <summary>
        /// 처리중
        /// </summary>
        Processing,
        /// <summary>
        /// 처리 실패
        /// </summary>
        ProcessingError,
        /// <summary>
        /// 처리 성공
        /// </summary>
        CouponSuccess,
    }
    /// <summary>
    /// 포인트 사용 윈도우 타입
    /// </summary>
    public enum PointUsingWindowType
    {
        /// <summary>
        /// 인증 처리시작
        /// </summary>
        CertifyStart,
        /// <summary>
        /// 포인트 사용 시작
        /// </summary>
        PointUsing,
        /// <summary>
        /// 처리중
        /// </summary>
        Processing,
        /// <summary>
        /// 처리 실패
        /// </summary>
        ProcessingError,
        /// <summary>
        /// 처리 성공
        /// </summary>
        CertifySuccess,
    }
    /// <summary>
    /// 결제창 
    /// </summary>
    public enum PaymentWindowType
    {
        None,
        /// <summary>
        /// 결제 수단 요구
        /// </summary>
        PaymentStart,
        /// <summary>
        /// 핀(6자리) 암호 입력창
        /// </summary>
        ReadPinNumber,
        /// <summary>
        /// 싸인 입력창
        /// </summary>
        ReadSign,
        /// <summary>
        /// 결제 처리중
        /// </summary>
        PaymentProcessing,
        /// <summary>
        /// 결제 실패
        /// </summary>
        ProcessingError,
        /// <summary>
        /// 처리 성공
        /// </summary>
        PaymentSuccess
       
    }
    /// <summary>
    /// 결제 후처리창 
    /// </summary>
    public enum PaymentEndWindowType
    {
        None,
        /// <summary>
        /// 현금 영수증
        /// </summary>
        CashReceipt,
        /// <summary>
        /// 결제 처리중
        /// </summary>
        Processing,
        /// <summary>
        /// 진동벨 또는 알림톡 입력
        /// </summary>
        BellOrNotifyTalk,
        /// <summary>
        /// 일반 처리 처리 성공
        /// </summary>
        PaymentSuccess,
        /// <summary>
        /// 알림톡 완료
        /// </summary>
        TalkSuccess,
        /// <summary>
        /// 진동벨/대기번호 완료
        /// </summary>
        WaitNumberSuccess,
    }

    /// <summary>
    /// 통신사 
    /// </summary>
    public enum MobileCompanyType
    {
        /// <summary>
        /// KT
        /// </summary>
        KT_Mobile,
        /// <summary>
        /// SK
        /// </summary>
        SK_Telecom,
        /// <summary>
        /// LG
        /// </summary>
        LG_Uplus
    }
    /// <summary>
    /// 최종 결제 수단
    /// </summary>
    public enum LastPaymentsType
    {
        None,
        /// <summary>
        /// Card 결제
        /// </summary>
        IcCard,
        /// <summary>
        /// 삼성,LG 페이
        /// </summary>
        SsLgPay,
        /// <summary>
        /// 캐시비
        /// </summary>
        CashBee,
        /// <summary>
        /// 해피기프트
        /// </summary>
        HappyGift,
        /// <summary>
        /// 티머니
        /// </summary>
        Tmoney,
        /// <summary>
        /// 임직원결제
        /// </summary>
        SpcEmployee,
        /// <summary>
        /// 스마일 페이
        /// </summary>
        SmilePay,
        /// <summary>
        /// 알리페이
        /// </summary>
        AliPay,
        /// <summary>
        /// 제로페이
        /// </summary>
        ZeroPay,
    }

    public enum PosOptionType
    {
        /// <summary>
        /// 마감시간 설정
        /// </summary>
        OPT800,
        /// <summary>
        /// 자동꺼짐 시간
        /// </summary>
        OPT801,
        /// <summary>
        /// 진동벨 1사용, 0사용안함
        /// </summary>
        OPT802,
        /// <summary>
        /// 알림톡 1사용, 0사용안함
        /// </summary>
        OPT803,
        /// <summary>
        /// 대기번호 1사용, 0사용안함
        /// </summary>
        OPT804,
        /// <summary>
        /// 자동결제 사용여부 1사용, 0사용안함
        /// </summary>
        OPT810,
        /// <summary>
        /// 바코드계산 사용여부 1사용, 0사용안함
        /// </summary>
        OPT811,
        /// <summary>
        /// 직원호출 사용여부
        /// </summary>
        OPT812,
        /// <summary>
        /// 다국어 - 영문사용
        /// </summary>
        OPT813,
        /// <summary>
        /// 다국어 - 일어사용
        /// </summary>
        OPT814,
        /// <summary>
        /// 다국어 - 중국어사용
        /// </summary>
        OPT815,
    }
}