﻿
/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 전문(TRAN,IRT) 상수 선언
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Common
{
    /// <summary>
    /// 마스터 플래그 값 또는 거래 TR에 셋팅 구분 정의
    /// </summary>
    public class ItemConst
    {
        #region TRAN_TYPE(거래구분)
        /// <summary>
        /// 거래구분
        /// </summary>
        public class TRAN_DIV
        {
            /// <summary>
            /// 정상(0xx)
            /// </summary>
            public const string NORMAL = "0";

            /// <summary>
            /// 반품(1xx)
            /// </summary>
            public const string REFUND = "1";
        }
        #endregion

        #region COMM_MSG_TYPE(전문구분)
        /// <summary>
        /// 전문구분
        /// </summary>
        public class COMM_MSG_TYPE
        {
            /// <summary>
            /// 01: TRAN
            /// </summary>
            public const string TRAN = "01";
            /// <summary>
            /// 02: 저널
            /// </summary>
            public const string JOURNAL = "02";
            /// <summary>
            /// 03: 서명
            /// </summary>
            public const string SIGN = "03";
            /// <summary>
            /// 04: 더미
            /// </summary>
            public const string DUMMY = "04";
            /// <summary>
            /// 05: IRT
            /// </summary>
            public const string IRT = "05";
            /// <summary>
            /// 06: POS IRT
            /// </summary>
            public const string POSIRT = "06";
            /// <summary>
            /// 07: LOG(로그 파일)
            /// </summary>
            public const string LOG = "07";
            /// <summary>
            /// 08: MST IRT
            /// </summary>
            public const string MSTIRT = "08";
            /// <summary>
            /// 09: 승인로그
            /// </summary>
            public const string APPRLOG = "09";
            /// <summary>
            /// 10: ETC저널
            /// </summary>
            public const string ETCJNRL = "10";
            /// <summary>
            /// 11: ETC TRAN
            /// </summary>
            public const string ETCTRAN = "11";
            /// <summary>
            /// 12: Cashier Test Log
            /// </summary>
            public const string TESTLOG = "12";
            /// <summary>
            /// 13: 긴급 메세지 전송
            /// </summary>
            public const string EMG_NOTE_SEND = "13";
            
            // 14(SIGN), 15(쉑쉑 주방) 데이터

            /// <summary>
            /// 18: SCALE LOG
            /// </summary>
            public const string SCALE_LOG = "18";
            /// <summary>
            /// 19: 보류 로그 이력
            /// </summary>
            public const string HOLD_LOG = "19";
            //#해피앱 추후적립 start, sskim
            /// <summary>
            /// 20: 해피앱추후적립 이력
            /// </summary>
            public const string HPAPP_AFTER_SAVE = "20";
            //#해피앱 추후적립 end, sskim

            //#20171120 유통기한 바코드 인식률 start, phj
            /// <summary>
            /// 21: 유통기한 바코드 인식률
            /// </summary>
            public const string BAR_SUCESS_RATE = "21";
            //#20171120 유통기한 바코드 인식률 end, phj

            //#20180413 웰컴카드 신규기능 추가 start,phj
            /// <summary>
            /// 22:웰컴카드 승인
            /// </summary>
            public const string WELCOME_INFO = "22";
            //#20180413 웰컴카드 신규기능 추가 end,phj

            //#15945 해피오더 자동주문 상세기능 start
            /// <summary>
            /// 23:해피오더 자동주문 로그 
            /// </summary>
            public const string HPO_AUTOORDER_LOG = "23";
            //#15945 해피오더 자동주문 상세기능 end

            /// <summary>
            /// 2019-03-15 - 1997fx11 : 회권구매이력 수신
            /// </summary>
            public const string HPC_CUST_BUY_HIST = "06";
            /// <summary>
            /// 2019-03-20 - 1997fx11 : 신규상품 수신
            /// </summary>
            public const string NEW_PRODUCT_BY_IRT = "06";
            /// <summary>
            /// 2019-03-20 - 1997fx11 : 시스템정보 전송
            /// </summary>
            public const string SEND_SYSTEM_INFO_BY_IRT = "06";
        }
        #endregion

        #region TRAN_KIND(거래종류)
        public class TRAN_KIND
        {
            /// <summary>
            /// 일반거래
            /// </summary>
            public class NORMAL
            {
                /// <summary>
                /// 거래모드 구분자:일반거래(x0x)
                /// </summary>
                public const string DELIMITER = "0";

                /// <summary>
                /// 매출(x00)
                /// </summary>
                public const string SALE = "00";
            }
            /// <summary>
            /// 미결거래
            /// </summary>
            public class UNDECIDED
            {
                /// <summary>
                /// 거래모드 구분자:미결거래(x1x)
                /// </summary>
                public const string DELIMITER = "1";

                /// <summary>
                /// 예약등록(x10)
                /// </summary>
                public const string RESERVATION_REG = "10";
                /// <summary>
                /// 예약완료(x11)
                /// </summary>
                public const string RESERVATION_COMPLETE = "11";
                //#Rhee, 20180117 미주 픽업코드 추가 Start
                /// <summary>
                /// 예약픽업(x12)
                /// </summary>
                public const string RESERVATION_PICKUP = "12";
                //#Rhee, 20180117 미주 픽업코드 추가 End
            }
            /// <summary>
            /// 대외거래
            /// </summary>
            public class FORIGN
            {
                /// <summary>
                /// 거래모드 구분자:대외거래(x2x)
                /// </summary>
                public const string DELIMITER = "2";

                /// <summary>
                /// O2O(x20)
                /// </summary>
                public const string O2O = "20";
                /// <summary>
                /// 쇼핑몰(x21)
                /// </summary>
                public const string SHOPPINGMALL = "21";
            }
            /// <summary>
            /// 사후거래
            /// </summary>
            public class AFTER
            {
                /// <summary>
                /// 거래모드 구분자:사후거래(x3x)
                /// </summary>
                public const string DELIMITER = "3";

                /// <summary>
                /// 해피포인트 적립(x30)
                /// </summary>
                public const string HP_SAVE = "30";
                /// <summary>
                /// 현금영수증(x31)
                /// </summary>
                public const string CASH_RECEIPT = "31";
            }
            /// <summary>
            /// 충전판매거래
            /// </summary>
            public class CHARGESALE
            {
                /// <summary>
                /// 거래모드 구분자:충전거래(x4x)
                /// </summary>
                public const string DELIMITER = "4";

                /// <summary>
                /// 충전거래(x40)
                /// </summary>
                public const string CHARGE = "40";
                /// <summary>
                /// 환불거래(x41)
                /// </summary>
                public const string REFUND = "41";
                /// <summary>
                /// 선불판매(x42)
                /// </summary>
                public const string PREPAID = "42"; 
                /// <summary>
                /// 상품권판매(x43)
                /// </summary>
                public const string GIFT = "43";
            }
            /// <summary>
            /// 기타거래
            /// </summary>
            public class ETC
            {
                /// <summary>
                /// 거래모드 구분자:기타거래(x5x)
                /// </summary>
                public const string DELIMITER = "5";

                /// <summary>
                /// LOSS(x50)
                /// </summary>
                public const string LOSS = "50";
            }

            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start
            /// <summary>
            /// 해피오더 랜덤박스
            /// </summary>
            public class HPO_LOG
            {
                /// <summary>
                /// 거래모드 구분자:기타거래(x5x)
                /// </summary>
                public const string DELIMITER = "6";

                /// <summary>
                /// 해피오더 랜덤박스
                /// </summary>
                public const string LANDOM_BOX = "60";
            }
            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end

            /// <summary>
            /// 입출금거래
            /// </summary>
            public class STATEMENT
            {
                /// <summary>
                /// 거래모드 구분자:입출금거래(x8x)
                /// </summary>
                public const string DELIMITER = "8";

                /// <summary>
                /// 준비금(x80)
                /// </summary>
                public const string RESERVE_FUND = "80";
                /// <summary>
                /// 마감시재(x81)
                /// </summary>
                public const string CLOSING_MONEY = "81";
                /// <summary>
                /// 기타입출금(x82)
                /// </summary>
                public const string ETC_STATEMENT = "82";
                /// <summary>
                /// 중간정산(x83)
                /// </summary>
                public const string MIDDLE_ADJUSTMENT = "83";
                /// <summary>
                /// 정산(x84)
                /// </summary>
                public const string ADJUSTMENT = "84";
            }
            /// <summary>
            /// 로그거래
            /// </summary>
            public class LOG
            {
                /// <summary>
                /// 거래모드 구분자:로그거래(x9x)
                /// </summary>
                public const string DELIMITER = "9";
                /// <summary>
                /// 거래중지(x90)
                /// </summary>
                public const string STOP = "90";
                /// <summary>
                /// 거래보류(x91)
                /// </summary>
                public const string HOLD_DEAL = "91";
                /// <summary>
                /// 로그인(x92)
                /// </summary>
                public const string LOGIN = "92";
                /// <summary>
                /// 로그오프(x93)
                /// </summary>
                public const string LOGOFF = "93";
                /// <summary>
                /// 돈통 열림(x94)
                /// </summary>
                public const string OPEN_CASH_DRAWER = "94";
                /// <summary>
                /// 아이템 지정 취소(x95)
                /// </summary>
                public const string ITEM_CANCEL = "95";
                /// <summary>
                /// 영수증 재발행(x96)
                /// </summary>
                public const string RE_PRINT = "96";
                /// <summary>
                /// 개점
                /// </summary>
                public const string POS_OPEN = "97";
                /// <summary>
                /// 폐점
                /// </summary>
                public const string POS_CLOSE = "98";
                //17.05.18 dkshin 쇼킹박스 추가
                /// <summary>
                /// 쇼킹박스(x99)
                /// </summary>
                public const string SHOCKING_BOX = "99";
            }
        }
        #endregion

        #region TR_ITEM_ID(결제수단 항목)
        public class TR_ITEM_ID
        {

            /// <summary>
            /// 현금결제 그룹 코드
            /// </summary>
            public const string CASH_ITEM = "00";
            /// <summary>
            /// 현금결제 세부항목
            /// </summary>
            public class CASH
            {
                /// <summary>
                /// 현금코드
                /// </summary>
                public const string CASH_PAY = "00";

            }

            /// <summary>
            /// 수표결제 그룹 코드
            /// </summary>
            public const string CHECK_ITEM = "01";
            /// <summary>
            /// 수표 결제 세부항목
            /// </summary>
            public class CHECK
            {
                /// <summary>
                /// 수표결제
                /// </summary>
                public const string CHECK_PAY = "00";

            }

            /// <summary>
            /// 신용카드결제 그룹 코드
            /// </summary>
            public const string CREDITCARD_ITEM = "02";
            /// <summary>
            /// 신용카드 결제 세부항목
            /// </summary>
            public class CREDITCARD
            {
                /// <summary>
                /// 일반카드
                /// </summary>
                public const string CREDIT_CARD = "00";
                /// <summary>
                /// 제휴카드
                /// </summary>
                public const string PARTNERSHIP_CARD = "01";
            }

            /// <summary>
            /// 제휴 할인(통신사) 코드
            /// </summary>
            public const string MOBILE_COM_POINT = "03";
            /// <summary>
            /// 제휴 할인(통신사) 결제 세부항목
            /// </summary>
            public class MOBILE_COM
            {
                /// <summary>
                /// SKT
                /// </summary>
                public const string MOBILE_SKT = "00";
                /// <summary>
                /// KTF
                /// </summary>
                public const string MOBILE_KTF = "01";
                /// <summary>
                /// LGT
                /// </summary>
                public const string MOBILE_LGT = "02";
                /// <summary>
                /// 오일뱅크
                /// </summary>
                public const string OILBANK_POINT = "03";
                /// <summary>
                /// 현대블루멤버스
                /// </summary>
                public const string HBLUE_M_POINT = "04";
                /// <summary>
                /// 기아레드멤버스
                /// </summary>
                public const string KRED_M_POINT = "05";
                /// <summary>
                /// KT VIP(KT 멤버십VIP초이스)
                /// </summary>
                public const string MOBILE_KT_VIP = "06";
                /// <summary>
                /// KT 멤버십 더블할인 시즌2
                /// </summary>
                public const string MOBILE_KT_DOUBLE = "09";
                //#20180413 웰컴카드 신규기능 추가 start,phj
                /// <summary>
                /// 웰컴카드 할인
                /// </summary>
                public const string WELCOMECARD = "10";
                //#20180413 웰컴카드 신규기능 추가 end,phj
            }

            /// <summary>
            /// 포인트 사용 코드
            /// </summary>
            public const string POINT_ITEM = "04";
            /// <summary>
            /// 포인트 결제 세부항목
            /// </summary>
            public class POINT_USE
            {
                /// <summary>
                /// 해피포인트 사용
                /// </summary> 
                public const string HAPPY_POINT = "00";
                /// <summary>
                /// 삼성포인트
                /// </summary>
                public const string SAMSUNG_POINT = "02";
                /// <summary>
                /// 오케이 캐쉬백
                /// </summary>
                public const string OKCASHBACK_POINT = "03";
                /// <summary>
                /// 해피포인트 사용 - 중국
                /// </summary>
                public const string HAPPY_POINT_USE_CHINA = "04";
                //*** MoonSeokWoo 2017.12.27 Add
                /// <summary>
                /// 현대MPoint
                /// </summary>
                public const string HYUNDAI_MPOINTS = "07";
                //*** MoonSeokWoo 2017.12.27 End
                /// <summary>
                /// 신한포인트
                /// </summary>
                public const string SHINHAN_POINT = "06";

                // grayber@20180102 우리모아포인트 추가 start - 포인트 사용 코드 세부항목 추가
                /// <summary>
                /// 우리모아포인트
                /// </summary>
                public const string WOORIMORE_POINTS = "08";
                // grayber@20180102 우리모아포인트 추가 end

                //grayber@20180208 코레일 마일리지 입력 start - 포인트 사용 세부 코드 추가 '05'
                /// <summary>
                /// 코레일 마일리지
                /// </summary>
                public const string KORAIL_MILEAGE = "05";
                //grayber@20180208 코레일 마일리지 입력 end
            }

            /// <summary>
            /// 상품권 결제 그룹 코드
            /// </summary>
            public const string GIFT_ITEM = "06";
            public class GIFT
            {
                /// <summary>
                /// 통합상품권
                /// </summary>
                public const string GIFT_COM = "00";
                /// <summary>
                /// 파리상품권
                /// </summary>
                public const string GIFT_PC = "01";
                /// <summary>
                /// 비알상품권
                /// </summary>
                public const string GIFT_BBK = "02";
                /// <summary>
                /// 삼립상품권
                /// </summary>
                public const string GIFT_SL = "03";
                /// <summary>
                /// 해피머니 상품권
                /// </summary>
                public const string GIFT_HP = "04";
            }

            /// <summary>
            /// 페이 결제 그룹 코드
            /// </summary>
            public const string PAY_ITEM = "07";
            public class PAY
            {
                /// <summary>
                /// 알리페이
                /// </summary>
                public const string ALIPAY_PAY = "00";
                /// <summary>
                /// 위챗페이
                /// </summary>
                public const string WECHAT_PAY = "01";
                /// <summary>
                /// 스마일페이
                /// </summary>
                public const string SMILE_PAY = "02";
                /// <summary>
                /// T페이
                /// </summary>
                public const string T_PAY = "03";

                // Rhee, 2017/09/04 은련페이 세부결제코드 추가 -- Start
                /// <summary>
                /// T페이
                /// </summary>
                public const string UNION_PAY = "04";
                // Rhee, 2017/09/04 은련페이 세부결제코드 추가 -- End

                /// <summary>
                /// 위챗페이 - Bai Rong
                /// </summary>
                public const string WECHAT_BIORONG_PAY = "05";    //#20170911.001, 중국 위쳇 페이 (바이롱) 결제 코드;girak.kim

                /// <summary>
                /// 샤오청쉬 - 기프트 카드 
                /// </summary>
                public const string XIAO_GIFTCARD_PAY = "06";     //#20170911.001, 중국 샤오청쉬 기프트카드 (바이롱) 결제 코드;girak.kim
            }

            /// <summary>
            /// 할인 쿠폰 그룹
            /// </summary>
            public const string COUPON_ITEM = "08";
            public class COUPON
            {
                /// <summary>
                /// 00:일반 쿠폰
                /// </summary>
                public const string NORMAL = "00";
                /// <summary>
                /// 01:매장 쿠폰
                /// </summary>
                public const string STORE = "01";
                /// <summary>
                /// 02:해피 쿠폰
                /// </summary>
                public const string INCARD = "02";
                /// <summary>
                /// 03:온라인쿠폰(중국)
                /// </summary>
                public const string ONLINE = "03";
                /// <summary>
                /// 04:케익교환권
                /// </summary>
                public const string CAKE_CHANGE = "04";
            }

            /// <summary>
            /// 모바일 캐시 결제 그룹 코드
            /// </summary>
            public const string MOBILECASH_ITEM = "09";
            public class MOBILECASH
            {
                /// <summary>
                /// 티머니
                /// </summary>
                public const string T_MONEY = "00";
                /// <summary>
                /// 캐시비
                /// </summary>
                public const string CASHBEE = "01";
            }

            /// <summary>
            /// 선불카드 결제 그룹 코드
            /// </summary>
            public const string PPCARD_ITEM = "10";
            public class PPCARD
            {
                /// <summary>
                /// 해피기프트카드
                /// </summary>
                public const string HP_GIFT = "00";
                /// <summary>
                /// 선불카드
                /// </summary>
                public const string PP_CARD = "01";
                //#20171018, 해피기프트(코나머니) 결제코드(신용->선불) 변경 Start, srlee
                /// <summary>
                /// 해피기프트카드(코나머니)
                /// </summary>
                public const string HPGIFT_CARD = "02";
                //#20171018, 해피기프트(코나머니) 결제코드(신용->선불) 변경 End, srlee
                /// <summary>
                /// 선불카드(해피조이)
                /// </summary>
                public const string HPPP_CARD = "04";
            }

            /// <summary>
            /// 모바일콘 결제 그룹 코드
            /// </summary>
            public const string MOBILECON_ITEM = "11";
            public class MOBILECON
            {
                /// <summary>
                /// 기프트콘
                /// </summary>
                public const string GIFTCON = "00";
                /// <summary>
                /// 큐피콘
                /// </summary>
                public const string QPCON = "01";
                /// <summary>
                /// 하트콘
                /// </summary>
                public const string HARTCON = "02";
                /// <summary>
                /// 지마켓
                /// </summary>
                public const string G_MARKET = "03";
                /// <summary>
                /// 삼성모바일
                /// </summary>
                public const string SAMSUNG_MOBILE = "04";
                /// <summary>
                /// 신한해피콘
                /// </summary>
                public const string SHINHAN_HPCON = "05";
                /// <summary>
                /// 해피콘
                /// </summary>
                public const string HPCON = "06";
                /// <summary>
                /// 옥션
                /// </summary>
                public const string AUCTIONCON = "07";
                /// <summary>
                /// 이베이
                /// </summary>
                public const string E_BAYCON = "08";
                /// <summary>
                /// 슈퍼브랜드딜
                /// </summary>
                public const string SUPERBRAND = "09";
                /// <summary>
                /// 디몬
                /// </summary>
                public const string TMON = "10";
                /// <summary>
                /// 기프트쇼
                /// </summary>
                public const string GIFTSHOW = "11";

            }

            /// <summary>
            /// 직원 결제 그룹 코드
            /// </summary>
            public const string EMP_PAY_ITEM = "12";
            public class EMP_PAY
            {
                /// <summary>
                /// SPC임직원
                /// </summary>
                public const string SPC = "00";
                /// <summary>
                /// 세브란스
                /// </summary>
                public const string SEVERANCE = "01";
                /// <summary>
                /// 아워홈
                /// </summary>
                public const string OURHOME = "02";
            }

            /// <summary>
            /// 외상 결제 그룹 코드
            /// </summary>
            public const string CREDIT_ITEM = "13";
            public class CREDIT
            {
                /// <summary>
                /// 외상
                /// </summary>
                public const string CREDIT_PAY = "00";

                // Rhee, 2017/09/22 딜리버리 외매(선매) 세부결제코드 추가 -- START
                /// <summary>
                /// 딜리버리 외매(선매) 세부결제코드 추가
                /// </summary>
                public const string CREDIT_PAY_DELIVERY = "01";
                // Rhee, 2017/09/22 딜리버리 외매(선매) 세부결제코드 추가 -- END
            }

            /// <summary>
            /// 외화 결제 그룹 코드
            /// </summary>
            public const string FOREIGNEX_ITEM = "14";
            public class FOREIGNEX
            {
                /// <summary>
                /// 달러
                /// </summary>
                public const string USD = "01";
                /// <summary>
                /// 유로
                /// </summary>
                public const string EUR = "03";
                /// <summary>
                /// 엔
                /// </summary>
                public const string JPY = "02";
                /// <summary>
                /// 위안
                /// </summary>
                public const string CNY = "04";
            }

            /// <summary>
            /// 예약 결제 그룹 코드
            /// </summary>
            public const string RESERVATION_ITEM = "15";
            public class RESERVATION
            {
                /// <summary>
                /// 예약 선금
                /// </summary>
                public const string RESERVATION_PAY = "00";
                /// <summary>
                /// 예약 잔금
                /// </summary>
                public const string BALANCE_PAY = "01";

            }

            /// <summary>
            /// 직원 할인그룹 코드
            /// </summary>
            public const string EMP_DC_ITEM = "16";
            public class EMP_DC
            {
                /// <summary>
                /// SPC임직원할인
                /// </summary>
                public const string SPC = "00";
                /// <summary>
                /// 세브란스할인
                /// </summary>
                public const string SEVERANCE = "01";
                /// <summary>
                /// 삼성카드
                /// </summary>
                public const string SAMSUNGCARD = "02";
                /// <summary>
                /// SPC임직원할인 - 중국
                /// </summary>
                public const string SPC_CHINA = "03";
                /// <summary>
                /// SPC임직원할인(결제)
                /// </summary>
                public const string SPC_PAY = "04";
            }

            /// <summary>
            /// 임의 할인
            /// </summary>
            public const string USER_DC_ITEM = "17";
            public class USER_DC
            {
                /// <summary>
                /// 없음
                /// </summary>
                public const string NORMAL = "00";
                /// <summary>
                /// 서비스(무료)
                /// </summary>
                public const string SERVICE = "01";
                /// <summary>
                /// 임의할인
                /// </summary>
                public const string RANDOMLY = "02";
                /// <summary>
                /// 환경사랑DC
                /// </summary>
                public const string ELOVE = "03";
                /// <summary>
                /// 제품교환권
                /// </summary>
                public const string ITEM_CHAGE_CPN = "04";
                /// <summary>
                /// 입점건물직원할인
                /// </summary>
                public const string IN_EMP_DC = "06";
                /// <summary>
                /// 입점건물직원할인(적립)
                /// </summary>
                public const string IN_EMP_DC_5 = "07";
                /// <summary>
                /// 전체 금액 할인
                /// </summary>
                public const string TOTAL_DC_AMT = "80";
                /// <summary>
                /// 전체 % 할인
                /// </summary>
                public const string TOTAL_DC_RATE = "81";
                /// <summary>
                /// 전체 추가금액 할인
                /// </summary>
                public const string TOTAL_ADDDC_AMT = "82";
                /// <summary>
                /// 카이스트 할인(2017.05.15)
                /// </summary>
                public const string KAIST_DC = "22";
            }

            /// <summary>
            /// 주문
            /// </summary>
            public const string ORDER_ITEM = "18";
            public class ORDER
            {
                /// <summary>
                /// 콜센터 배달결제
                /// </summary>
                public const string CALLCENTER_PAY = "00";
                /// <summary>
                /// 해피오더 결제
                /// </summary>
                public const string HAPPYORDER_PAY = "01";
                /// <summary>
                /// 배달의민족 배달결제
                /// </summary>
                public const string BAEMIN_PAY = "03";
                /// <summary>
                /// 양재오더(오더폼) 결제
                /// </summary>
                public const string ORDERFORM_PAY = "04";
                /// <summary>
                /// 요기요 배달결제(2017.05.15)
                /// </summary>
                public const string YOGIYO_PAY = "05";
                /// <summary>
                /// 해피오더사전예약할인(2017.05.15)
                /// </summary>
                public const string HPORDER_REVDC = "06";
                /// <summary>
                /// 해피오더 요기요
                /// </summary>
                public const string HPORDER_YOGIYO = "07";           //#10906_[BR] 요기요 해피오더 매출 처리 기능 개발_hs
                /// <summary>
                /// 해피오더 해피마켓
                /// </summary>
                public const string HPORDER_HAPPYMARKET = "08";      //#11078_[공통] 해피오더 외부채널 표시 방식 변경 적용 요청_hs
                /// <summary>
                /// 해피오더 배달의민족 
                /// </summary>
                public const string HPORDER_BAEMIN = "09";           //#11078_[공통] 해피오더 외부채널 표시 방식 변경 적용 요청_hs
                /// <summary>
                /// 해피오더 카카오 
                /// </summary>
                public const string HPORDER_KAKAO = "10";            //#11078_[공통] 해피오더 외부채널 표시 방식 변경 적용 요청_hs
                /// <summary>
                /// 해피오더 사전예약
                /// </summary>
                public const string HPORDER_BRMICRO = "11";          //20171215_해피오더 사전예약 결제코드 추가_hs

            }
            /// <summary>
            /// 주문유형구분
            /// </summary>
            public class ORDER_TYPE
            {
                /// <summary>
                /// 픽업
                /// </summary>
                public const string PICKUP = "01";
                /// <summary>
                /// 픽업-현장결제
                /// </summary>
                public const string PICKUP_FIELD_PAY = "02";
                /// <summary>
                /// 배달
                /// </summary>
                public const string DELIVERY = "03";
                /// <summary>
                /// 사전예약
                /// </summary>
                public const string PRE_RESERVATION = "04";
            }

            /// <summary>
            /// 캠페인할인결제
            /// </summary>
            public const string CPI_PAY_ITEM = "19";
            public class CPI_PAY
            {
                /// <summary>
                /// 신용카드 할인결제
                /// </summary>
                public const string CREDIT_CARD = "00";
                /// <summary>
                /// 티머니 할인결제
                /// </summary>
                public const string TMONEY = "51";
                /// <summary>
                /// 캐시비 할인결제
                /// </summary>
                public const string CASHBEE = "52";
                /// <summary>
                /// 스마일페이 할인결제
                /// </summary>
                public const string SMAILE_PAY = "53";
                /// <summary>
                /// 실효포인트 할인결제
                /// </summary>
                public const string HPEXT_PAY = "54";
            }

            /// <summary>
            /// 부가정보(기타수단)
            /// </summary>
            public const string ETC_INFO_ITEM = "80";
            public class ETC_INFO
            {
                /// <summary>
                /// 기타수단 - 현금영수증코드
                /// </summary>
                public const string CASHBILL = "00";
                /// <summary>
                /// 기타수단 - HP포인트 적립
                /// </summary>
                public const string SAVEPOINT = "01";
                /// <summary>
                /// 기타수단 - 해피기프트-충전/환불
                /// </summary>
                public const string HAPPYGIFT = "02";
                /// <summary>
                /// 기타수단 - 빚은몰 주문건수 조회
                /// </summary>
                public const string BIZEUN = "03";
                /// <summary>
                /// 기타수단 - 이지웰 주문건수 조회
                /// </summary>
                public const string EZWEL = "04";
                /// <summary>
                /// 기타수단 - HP포인트 적립 - 중국
                /// </summary>
                public const string POINT_SAVE_CHINA = "05";
                /// <summary>
                /// 기타수단 - OCB 적립
                /// </summary>
                public const string OCB_SAVE = "06";
                /// <summary>
                /// 기타수단 - 온라인쿠폰발행(중국)
                /// </summary>
                public const string ONLINE_CPN = "07";
                //20171019 dkshin 해피기프트(신) 충전 코드 변경(추가)
                /// <summary>
                /// 기타수단 - 해피기프트(신)-충전
                /// </summary>
                public const string HAPPYGIFTNEW_CHARGE = "08";

                //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start
                /// <summary>
                /// 기타수단 - 해피쿠폰 발송
                /// </summary>
                public const string HAPPYCPN_SEND = "09";
                //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end
            }

            /// <summary>
            /// 기타 결제 그룹 코드
            /// </summary>
            public const string PAYETC_ITEM = "99";
            public class PAYETC
            {
                /// <summary>
                /// 잔액교환권
                /// </summary>
                public const string BALANCE_VOUCHER = "00";
                /// <summary>
                /// 식권
                /// </summary>
                public const string MEAL_TIKET = "01";
                /// <summary>
                /// 기타결제
                /// </summary>
                public const string PAYETC_ITEM = "03";

                // grayber@20180115 인천공항 VIP 라운지 start - 결제 수단 코드 추가 '9904'
                /// <summary>
                /// 인천공항 VIP 라운지
                /// </summary>
                public const string VIP_LOUNGE = "04";
                // grayber@20180115 인천공항 VIP 라운지 end
            }
        }
        #endregion

        #region IRT_INQ_TYPE(INQ 종별)
        /// <summary>
        /// INQ 종별
        /// </summary>
        public class IRT_INQ_TYPE
        {
            /// <summary>
            /// 02:서버 시간 조회
            /// </summary>
            public const string SYSDATETIME = "02";
            /// <summary>
            /// 03:프로그램 업데이트 조회
            /// </summary>
            public const string PGMUPDATE = "03";
            /// <summary>
            /// 05: 메시지 전송 요청(긴급/영업 공지 요청)
            /// </summary>
            public const string MSG_TRANSFER_REQ = "05";
            /// <summary>
            /// 06: 파일 변경 완료 요청
            /// </summary>
            public const string PGMUPDATECOMPLTE = "06";
            /// <summary>
            /// 08: 영수증 트란 조회      
            /// </summary>
            public const string TRAN_CALL = "08";
            /// <summary>
            /// 09: 영업개시      
            /// </summary>
            public const string OPEN_REQ = "09";
            /// <summary>
            /// 11:외상고객 조회(잔액) 요청      
            /// </summary>
            public const string SALEONCREDIT_CUSTINQ = "11";
            /// <summary>
            /// 12:선불카드 고객 조회 요청
            /// </summary>
            public const string PRPAIDCARD_INQ = "12";
            /// <summary>
            /// 13:상품권 승인
            /// </summary>
            public const string GIFT_APPROVE_INQ = "13";
            /// <summary>
            /// 14:복권발행      
            /// </summary>
            public const string LOTTERY_NUMBERINQ = "14";
            /// <summary>
            /// 20: 위해상품 판매차단 메시지
            /// </summary>
            public const string HARMFUL_ITEM_MSG_REQ = "20";
            /// <summary>
            /// 25:점포 클레임 송신      
            /// </summary>
            public const string STORECLAIM_MSG_REQ = "25";
            /// <summary>
            /// 26:점포 방문 이력 송신(제조기사 타임 바코드)
            /// </summary>
            public const string STOR_VISIT = "26";
            /// <summary>
            /// 27:PVC 상자재고 송신      
            /// </summary>
            public const string PVCSTOCK_INQ = "27";
            /// <summary>
            /// 28:POS SPEC
            /// </summary>
            public const string POS_SPEC_INQ = "28";
            /// <summary>
            /// 30:잔액교환권 발행
            /// </summary>
            public const string EXCHANGE_TICKET_INQ = "30";
            /// <summary>
            /// 32:선불카드 고객 사용 요청
            /// </summary>
            public const string PRPAIDCARD_USE_REQ = "32";
            /// <summary>
            /// 33:외상사용 요청    
            /// </summary>
            public const string SALEONCREDIT_USE_INQ = "33";
            /// <summary>
            /// 34:최종 거래번호 조회
            /// </summary>
            public const string LAST_TRANNO_INQ = "34";

            /// <summary>
            /// 36:결락 데이터 요청
            /// </summary>
            public const string MISS_TRAN_INQ = "36";

            /// <summary>
            /// 37:시험결과 조회 요청  
            /// </summary>
            public const string TEST_MODE_SEARCH_REQ = "37";
            /// <summary>
            /// 38:시험결과 전송 요청  
            /// </summary>
            public const string TEST_MODE_RESULT_REQ = "38";
            /// <summary>
            /// 41:관공서 방문 알림  
            /// </summary>
            public const string ADMIN_VISIT_INQ = "41";
            /// <summary>
            /// POS 마스터 요청
            /// </summary>
            public const string POSMASTER_REQ = "40";
            /// <summary>
            /// 2019-02-22 - 1997fx11 : Kiosk 요청
            /// </summary>
            public const string KIOSK_REQ = "100";
            /// <summary>
            /// 자료조회
            /// </summary>
            public const string SERVER_INTERFACE_SCH = "42";
            /// <summary>
            /// 해피 기프트 충전이력
            /// </summary>
            public const string HAPPY_GIFT_RECHANGE = "43";

            /// <summary>
            /// 45: 수량 제한 캠페인 수량 조회
            /// </summary>
            public const string POSLINEUPORDER_REQ = "45";
            /// <summary>
            /// 46: 영수증 저널 조회      
            /// </summary>
            public const string JOURNAL_CALL = "46";
            /// <summary>
            /// 47: 이동단말기 조회 요청
            /// </summary>
            public const string VAN_CARDLOG_SEARCH = "47";
            /// <summary>
            /// 48: 이동단말기 등록 요청
            /// </summary>
            public const string VAN_CARDLOG_FINAL = "48";
            /// <summary>
            /// 49: 공지사항 조회
            /// </summary>
            public const string NOTICE_INQ_REQ = "49";
            /// <summary>
            /// 50:점포근태(근태등록요청)
            /// </summary>
            public const string EMP_COMMUTE = "50";
            /// <summary>
            /// 51: 서버FTP 정보 요청/응답
            /// </summary>
            public const string FTPINFO_REQ = "51";
            /// <summary>
            /// 52:점주/알바 모드
            /// </summary>
            public const string ONWER_MODE = "52";
            /// <summary>
            /// 53:점포점검저장여부확인
            /// </summary>
            public const string STORE_SAVE_CHECK = "53";
            /// <summary>
            /// 54:점포점검저장
            /// </summary>
            public const string STORE_CHECK_SAVE = "54";
            /// <summary>
            /// 55:POS TABLE 마스터 저장/조회 요청/응답
            /// </summary>
            public const string POS_TABLE_MST_INQ = "55";
            /// <summary>
            /// 56: HP 횟수 제한 캠페인 횟수 조회
            /// </summary>
            public const string CAMPAIGN_HPCNT_REQ = "56"; 
            /// <summary>
            /// 62:중국 선불카드 번호 조회 요청
            /// </summary>
            public const string PREPAIDCARD_SEL_INQ = "62";
            /// <summary>
            /// 63:중국 선불카드 번호 승인 요청
            /// </summary>
            public const string PREPAIDCARD_APPR_INQ = "63";
            /// <summary>
            /// 65:점포일일장비점검
            /// </summary>
            public const string STR_EQUIP_CHECK = "65";
            /// <summary>
            /// 66:점포일일장비점검 저장
            /// </summary>
            public const string STR_EQUIP_CHECK_SAVE = "66";
            /// <summary>
            /// 67:점포 매입처 조회
            /// </summary>
            public const string POS_SPPRINFO_REQ = "67";
            /// <summary>
            /// 68:상품 정보 조회
            /// </summary>
            public const string POS_ITEMINFO_REQ = "68";
            /// <summary>
            /// 69:POS LOG 파일 조회 요청
            /// </summary>
            public const string POS_LOGFILE_REQ = "69";
            /// <summary>
            /// 71:POS CONFIG 파일 송/수신
            /// </summary>
            public const string POS_CONFIG_UPLOAD = "71";
            //2017-06-02 dkshin 해피앱 추후적립
            /// <summary>
            /// 72:해피앱 추후적립
            /// </summary>
            public const string HPAPP_AFTER_SAVE_UPDATE = "72";

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start
            /// <summary>
            /// 78:고객 구매이력 정보 조회
            /// </summary>
            public const string HPMEMB_BUY_HIST = "78";
            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end

            //#20180413 웰컴카드 신규기능 추가 start,phj
            /// <summary>
            /// 79:웰컴카드 승인
            /// </summary>
            public const string WELCOME_INFO_INQ = "79";
            //#20180413 웰컴카드 신규기능 추가 end,phj

            //#15884 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발 start
            /// <summary>
            /// 80:해피오더 실시간 재고 등록 알람 
            /// </summary>
            public const string HPO_INVENTORY_ALARM = "80";
            //#15884 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발 end

            //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 start
            /// <summary>
            /// 81:장부재고 품목
            /// </summary>
            public const string BOOK_INVENTORY = "81";
            //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 end
        }
        #endregion

        #region IRT_PRT_DIV(INQ_TYPE : 42, 서버 IF 출력구분)
        /// <summary>
        /// PRT 종별
        /// </summary>
        public class IRT_PRT_DIV
        {
            /// <summary>
            /// 22: 행사취합주문      
            /// </summary>
            public const string EVENT_ORDER = "22";
            /// <summary>
            /// 23: 행사취합주문상세    
            /// </summary>
            public const string EVENT_ORDER_DETAIL = "23";
            /// <summary>
            /// 36: 본사반품조회      
            /// </summary>
            public const string RETURN_COMPANY = "36";
            /// <summary>
            /// 37: 본사반품 상세조회    
            /// </summary>
            public const string RETURN_COMPANY_DETAIL = "37";
            /// <summary>
            /// 35: 출하예정내역      
            /// </summary>
            public const string SHIPMENT_LIST = "35";
            /// <summary>
            /// 24: 해피포인트 추후 적립내역    
            /// </summary>
            public const string HP_RATE_REPORT = "24";
            /// <summary>
            /// 25: 해피포인트 추후 적립내역 상세  
            /// </summary>
            public const string HP_RATE_REPORT_DETAIL = "25";
        }
        #endregion

        #region HEAD_ORDER_DIV(주문구분)
        /// <summary>
        /// 주문구분
        /// </summary>
        public class HEAD_ORDER_DIV
        {
            /// <summary>
            /// 일반(0)       
            /// </summary>
            public const string NORMAL = "0";

            /// <summary>
            /// TOMB_STONE(1)
            /// </summary>
            public const string TOMB_STONE = "1";

            /// <summary>
            /// 배달(2)
            /// </summary>
            public const string DELIVERY = "2";

            /// <summary>
            /// 전화주문(3)
            /// </summary>
            public const string TEL_ORDER = "3";

            /// <summary>
            /// 포장(4)
            /// </summary>
            public const string PACKING = "4";
        }
        #endregion

        #region TRAINING_FLAG(연습모드설정)
        /// <summary>
        /// 연습모드 설정
        /// </summary>
        public class TRAINING_FLAG
        {
            /// <summary>
            /// 연습모드 NO (0)
            /// </summary>
            public const string TRAINING_NO = "0";

            /// <summary>
            /// 연습모드 YES (1)
            /// </summary>
            public const string TRAINING_YES = "1";

            ///// <summary>
            ///// 교육장(테스트매장) (2)
            ///// </summary>
            //public const string TEST_STORE_MODE = "2";
        }
        #endregion

        #region PLU_DC_DIV 단품 할인 구분
        /// <summary>
        /// 단품 할인 타입(0000:정상, 1701:무료(서비스), 1702:임의할인, 1704:제품교환권, 1706:입점건물직원할인)
        /// </summary>
        public class PLU_DC_DIV
        {
            /// <summary>
            /// 0000:정상(없음)
            /// </summary>
            public const string NORMAL = "0000";
            /// <summary>
            /// 1701:서비스(무료)
            /// </summary>
            public const string FREE = "1701";
            /// <summary>
            /// 1702:임의할인
            /// </summary>
            public const string POS_DC = "1702";
            /// <summary>
            /// 1703:환경사랑DC
            /// </summary>
            public const string ELOVE_DC = "1703";
            /// <summary>
            /// 1704:제품교환권
            /// </summary>
            public const string ITEM_CHAGE_CPN_DC = "1704";
            /// <summary>
            /// 1706:입점건물직원할인
            /// </summary>
            public const string IN_EMP_DC = "1706";
            /// <summary>
            /// 1707:입점건물직원할인(적립)
            /// </summary>
            public const string IN_EMP_DC_5 = "1707";
            /// <summary>
            /// 1708:해피콘할인
            /// </summary>
            public const string HAPPYCON_DC = "1708";
            /// <summary>
            /// 1709:기프티쇼할인
            /// </summary>
            public const string GIFTSHOW_DC = "1709";
            /// <summary>
            /// 1780:전체금액할인
            /// </summary>
            public const string IN_DC_TOTAMT = "1780";
            /// <summary>
            /// 1781:전체%할인
            /// </summary>
            public const string IN_DC_TOTRATE = "1781";
            /// <summary>
            /// 1782:전체추가할인
            /// </summary>
            public const string IN_DC_ADDAMT = "1782";
            /// <summary>
            /// 1791:세트할인
            /// </summary>
            public const string SET_DC = "1791";

            /// <summary>
            /// 1722:카이스트할인(2017.05.15)
            /// </summary>
            public const string KAIST_DC = "1722";
            /// <summary>
            /// 1806:해피오더사전예약할인(2017.05.15)
            /// </summary>
            public const string HPORDER_REVDC = "1806";
        }
        #endregion

        #region PLU_DC_TYPE 할인 유형
        /// <summary>
        /// 단품 할인 타입(0:없음, 1:소계할인, 2:단품할인)
        /// </summary>
        public class PLU_DC_TYPE
        {
            /// <summary>
            /// 0:정상(없음)
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 1:소계할인
            /// </summary>
            public const string DC_SUM = "1";
            /// <summary>
            /// 2:단품할인
            /// </summary>
            public const string DC_ITEM = "2";

        }
        #endregion

        #region PLU_CPN_DC_TYPE 쿠폰 할인 유형
        /// <summary>
        /// 쿠폰 할인 구분(0000:없음, 0800:쿠폰, 0802:해피쿠폰)
        /// </summary>
        public class PLU_CPN_DC_TYPE
        {
            /// <summary>
            /// 0000:정상(없음)
            /// </summary>
            public const string NORMAL = "0000";
            /// <summary>
            /// 0800:쿠폰
            /// </summary>
            public const string DC_CPN = "0800";
            /// <summary>
            /// 0802:해피쿠폰할인(스템프,복권)
            /// </summary>
            public const string DC_HAPPY_CPN = "0802";
            /// <summary>
            /// 0803:온라인쿠폰(중국)
            /// </summary>
            public const string DC_ONLINE_CPN = "0803";
        }
        #endregion

        #region PLU_ETC_DC_TYPE 기타 할인 유형
        /// <summary>
        /// 기타 할인 구분(0000:없음, 1802:해피오더할인)
        /// </summary>
        public class PLU_ETC_DC_TYPE
        {
            /// <summary>
            /// 0000:정상(없음)
            /// </summary>
            public const string NORMAL = "0000";
            /// <summary>
            /// 1802:해피오더할인
            /// </summary>
            public const string DC_HPORD = "1802";
            /// <summary>
            /// 1806:해피오더 사전예약 할인
            /// </summary>
            public const string DC_PRE_RESERVED = "1806";
        }
        #endregion

        #region PLU_ITEM_DIV(상품구분)
        /// <summary>
        /// 상품구분(0:일반, 1:세트, 2:세트자식, 3:부가상품, 4:세트할인, 5:상품권)
        /// </summary>
        public class PLU_ITEM_DIV
        {
            /// <summary>
            /// 0:일반  
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 1:세트
            /// </summary>
            public const string SET_MAIN = "1";
            /// <summary>
            /// 2:세트자식
            /// </summary>
            public const string SET_DETL = "2";
            /// <summary>
            ///  3:부가상품
            /// </summary>
            public const string OPT_MENU = "3";
            /// <summary>
            /// 4:세트할인
            /// </summary>
            public const string SET_DIS = "4";
            /// <summary>
            /// 5:상품권
            /// </summary>
            public const string GIFT = "5";
            /// <summary>
            /// 6:선불카드
            /// </summary>
            public const string PREPAID = "6";
        }
        #endregion

        #region PLU_FLAVOUR_DIV(플레이어구분)
        /// <summary>
        /// 플레이어구분(0:일반, 1:플레이버선택대상, 2:플레이버)
        /// </summary>
        public class PLU_FLAVOUR_DIV
        {
            /// <summary>
            /// 0:일반  
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 1:플레이버선택대상
            /// </summary>
            public const string FLAVOUR_OWN = "1";
            /// <summary>
            /// 2:플레이버
            /// </summary>
            public const string FLAVOUR = "2";
        }
        #endregion

        #region CPI_CUST_BNFT(캠페인고객혜택)
        /// <summary>
        /// 캠페인고객혜택(01:할인,02:적립,03:할인+적립,04:사은품,05:복권,06:명판,07:복권+명판,08:응모권,09:응모권+명판,10:스템프,11:할인(실효100%),12:사은품+적립,13:할인(실효))
        /// </summary>
        public class CPI_CUST_BNFT
        {
            /// <summary>
            /// 01:할인
            /// </summary>
            public const string DISCOUNT = "01";
            /// <summary>
            /// 02:적립
            /// </summary>
            public const string PNTSAVE = "02";
            /// <summary>
            /// 03:할인+적립
            /// </summary>
            public const string DIS_SAVE = "03";
            /// <summary>
            /// 04:사은품
            /// </summary>
            public const string FREEGIFT = "04";
            /// <summary>
            /// 05:복권
            /// </summary>
            public const string LOTTERY = "05";
            /// <summary>
            /// 06:명판
            /// </summary>
            public const string RECEIPT = "06";
            /// <summary>
            /// 07:복권+명판
            /// </summary>
            public const string LOTT_REC = "07";
            /// <summary>
            /// 08:응모권
            /// </summary>
            public const string ENTRY = "08";
            /// <summary>
            /// 09:응모권+명판
            /// </summary>
            public const string ENTR_REC = "09";
            /// <summary>
            /// 10:스탬프
            /// </summary>
            public const string HP_STAMP = "10";
            /// <summary>
            /// 11:할인(실효100%)
            /// </summary>
            public const string DIS_POINT_ALL = "11";
            /// <summary>
            /// 12:사은품+적립
            /// </summary>
            public const string FREE_SAVE = "12";
            /// <summary>
            /// 13:할인(실효일부)
            /// </summary>
            public const string DIS_POINT = "13";

            //grayber@20171214 캠페인 리펀드 쿠폰 start
			/// <summary>
			/// 0F:리펀드
			/// </summary>
			public const string REFUND = "0F";
            //grayber@20171214 캠페인 리펀드 쿠폰 end
        }
        #endregion

        #region CPI_DC_APPLY_TYPE(할인적용방법)
        /// <summary>
        /// 상품적용방법(01:상품별, 02:상품합산, 03:결합, 04:N+1, 05:전체상품, 06:사은품(삭제), 07:결제금액)
        /// </summary>
        public class CPI_ITEM_APPLY_METHD
        {
            /// <summary>
            /// 01:상품별
            /// </summary>
            public const string PLUITEM = "01";
            /// <summary>
            /// 02:상품합산
            /// </summary>
            public const string PLUSUM = "02";
            /// <summary>
            /// 03:결합
            /// </summary>
            public const string PLULINK = "03";
            /// <summary>
            /// 04:N+M
            /// </summary>
            public const string NPLUS = "04";
            /// <summary>
            /// 05:전체상품
            /// </summary>
            public const string RECTSUM = "05";
            ///// <summary>
            ///// 06:사은품(미사용)
            ///// </summary>
            //public const string FREEGIFT = "06";
            /// <summary>
            /// 07:(전체상품)결제금액
            /// </summary>
            public const string PAYMENT = "07";
        }
        #endregion

        #region CPI_DC_TYPE(할인구분)
        /// <summary>
        /// 할인유형(1:율,2:금액, 3:판매금액)
        /// </summary>
        public class CPI_DC_TYPE
        {
            /// <summary>
            /// 1:할인율
            /// </summary>
            public const string RATE = "1";
            /// <summary>
            /// 2:할인금액
            /// </summary>
            public const string AMT = "2";
            /// <summary>
            /// 3:판매금액
            /// </summary>
            public const string PRICE = "3";
        }
        #endregion

        #region CPI_COND_TYPE 캠페인 조건 유형
        /// <summary>
        /// CPI_COND_TYPE => 캠페인 구성자격 구분(1:수량, 2:금액, 3:최소수량)
        /// </summary>
        public class CPI_COND_TYPE
        {
            /// <summary>
            /// 1:수량
            /// </summary>
            public const string MATCH_QTY = "1";
            /// <summary>
            /// 2:금액
            /// </summary>
            public const string MIN_AMT = "2";
            /// <summary>
            /// 3:최소수량
            /// </summary>
            public const string MIN_QTY = "3";
        }
        #endregion

        #region CPI_TRGT_AMT_TYPE => 캠페인성립금액 구분
        /// <summary>
        /// CPI_TRGT_AMT_TYPE => 캠페인성립금액 구분
        /// </summary>
        public class CPI_TRGT_AMT_TYPE
        {
            /// <summary>
            /// 1:구매금액체크
            /// </summary>
            public const string RECT_AMT = "1";
            /// <summary>
            /// 2:대상상품금액체크
            /// </summary>
            public const string ITEM_AMT = "2";
            /// <summary>
            /// 3:구매금액+대상상품금액체크
            /// </summary>
            public const string RECT_ITEM_AMT = "3";
        }
        #endregion

        #region CPI_TRGT_TYPE => 캠페인대상
        /// <summary>
        /// CPI_TRGT_TYPE => 캠페인대상(1:전체, 2:HPC결제, 3:HPC고객, 4:신용카드, 5:해피앱고객)
        /// </summary>
        public class CPI_TRGT_CUST_TYPE
        {
            /// <summary>
            /// 1:전체
            /// </summary>
            public const string NORMAL = "1";
            /// <summary>
            /// 2:HPC결제
            /// </summary>
            public const string HPC_PAY = "2";
            /// <summary>
            /// 3:HPC고객
            /// </summary>
            public const string HPC_CUST = "3";
            /// <summary>
            /// 4:신용카드
            /// </summary>
            public const string CREDIT_CARD = "4";
            /// <summary>
            /// 5:해피앱고객
            /// </summary>
            public const string HAPPYAPP = "5";
        }
        #endregion

        #region CPI_CUST_PAY_TYPE => 캠페인지불 구분
        /// <summary>
        /// CPI_CUST_PAY_TYPE => 캠페인지불 구분(00:전체, 01:신용카드, 02:캐시비, 03:티머니, 04:스마일페이)
        /// </summary>
        public class CPI_CUST_PAY_TYPE
        {
            /// <summary>
            /// 00:일반
            /// </summary>
            public const string NORMAL = "00";
            /// <summary>
            /// 01:신용카드
            /// </summary>
            public const string CREDTCARD = "01";
            /// <summary>
            /// 02:캐시비
            /// </summary>
            public const string CASHBEE = "02";
            /// <summary>
            /// 03:TMONEY
            /// </summary>
            public const string TMONEY = "03";
            /// <summary>
            /// 04:스마일페이
            /// </summary>
            public const string SMILEPAY = "04";
            /// <summary>
            /// 98:해피포인트적립(POS자체사용)
            /// </summary>
            public const string HP_SAVE = "98";
            /// <summary>
            /// 99:해피포인트사용(POS자체사용)
            /// </summary>
            public const string HP_USE = "99";
        }
        #endregion

        #region CPI_ADD_ACCUM_DIV => HPC추가적립 구분
        /// <summary>
        /// CPI_ADD_ACCUM_DIV => HPC추가적립 구분(0:적립없음, 1:BILL전체, 2:대상상품, 3:행사대상외 구매상품)
        /// </summary>
        public class CPI_ADD_ACCUM_DIV
        {
            /// <summary>
            /// 1:BILL전체
            /// </summary>
            public const string RECT_AMT = "1";
            /// <summary>
            /// 2:대상상품
            /// </summary>
            public const string ITEM_AMT = "2";
            /// <summary>
            /// 3:행사대상외상품
            /// </summary>
            public const string NOT_ITEM_AMT = "3";
        }
        #endregion

        #region SALE_APP_DIV(결제 수단 승인,취소 처리 플래그)
        /// <summary>
        /// 결제 수단 승인/취소 처리 플래그
        /// </summary>
        public class SALE_APP_DIV
        {
            /// <summary>
            /// 정상 승인
            /// </summary>
            public const string APP_NORMAL = "0";
            /// <summary>
            /// 취소/반품 승인
            /// </summary>
            public const string APP_RETURN = "1";
            /// <summary>
            /// 결제 취소
            /// </summary>
            public const string APP_CANCEL = "2";

        }
        #endregion

        #region PAY_CANCEL_DIV(결제 취소 구분)
        /// <summary>
        /// 결제 취소 구분
        /// </summary>
        public class PAY_CANCEL_DIV
        {
            /// <summary>
            /// 정상 : 0
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 취소 : 1
            /// </summary>
            public const string CANCEL = "1";
        }
        #endregion

        #region PAY_APP_DIV(결제 승인 구분)
        /// <summary>
        /// 결제 승인 구분
        /// </summary>
        public class PAY_APP_DIV
        {
            /// <summary>
            /// 정상 : 0
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 강제 : 1
            /// </summary>
            public const string COMPULSION = "1";
            /// <summary>
            /// CAT 단말기 : 2
            /// </summary>
            public const string CAT_TERMINAL = "2";
            /// <summary>
            /// XCHARGE 승인 : 7
            /// </summary>
            public const string X_CHARGE = "7";
            /// <summary>
            /// 전화취소 : 8
            /// </summary>
            public const string PHON_CANCEL = "8";
            /// <summary>
            /// 이동단말기 승인 :9
            /// </summary>
            public const string PDA_APPR = "9";

        }
        #endregion

        #region PAY_CASHBILL_DIV(현금영수증 발행 여부)
        /// <summary>
        /// 현금영수증 발행 여부
        /// </summary>
        public class PAY_CASHBILL_DIV
        {
            /// <summary>
            /// 발행불가
            /// </summary>
            public const string NO = "0";
            /// <summary>
            /// 발행대상
            /// </summary>
            public const string YES = "1";
        }
        #endregion

        #region CREDITCARD_DC_TY(카드 할인 타입 - 삼성패밀리, 삼성포인트)
        /// <summary>
        /// 카드 할인 타입
        /// </summary>
        public class CREDITCARD_DC_TY
        {
            /// <summary>
            /// 삼성패밀리카드
            /// </summary>
            public const string CREDIT_SFC = "SFC";
            /// <summary>
            /// 삼성포인트
            /// </summary>
            public const string CREDIT_SPNT = "SPNT";
            /// <summary>
            /// 우리모아
            /// </summary>
            public const string WOORIMORE_POINTS = "WRM";
            /// <summary>
            /// 현대M
            /// </summary>
            public const string HYUNDAI_M_POINTS = "HM";
            /// <summary>
            /// 신한포인트
            /// </summary>
            public const string SHINHAN_CARD_POINT = "SHP";
        }
        #endregion


        //2018.01.04;미주 상품별 부가세 포함 여부 ;girak.kim;start
        #region TAX_AMT_INCLUDE_YN(상품 마스터 - 상품 부가세 포함 구분, 점포 마스터와 별도임.)
        /// <summary>
        /// 상품 세금 포함 구분( 1: 부가세포함, 2: 부가세 미포함, N:설정하지 않음)
        /// </summary>
        public class MST_ITEM_TAX_AMT_INCLUDE_YN
        {         
            /// <summary>
            /// 포함
            /// </summary>
            public const string INCLUDED = "1";

            /// <summary>
            /// 미포함
            /// </summary>
            public const string NOT_INCLUDED = "2";

            /// <summary>
            /// 설정하지 않음
            /// </summary>
            public const string NONE = "N";

            /// <summary>
            /// NULL
            /// </summary>
            public const string EMPTY = "";

        }
        #endregion

        //2018.01.04;미주 상품별 부가세 포함 여부 ;girk.kim;End


        #region TAX_AMT_INCLUDE_YN(점포 마스터 - 상품 세금 포함 구분)
        /// <summary>
        /// 상품 세금 포함 구분(0 : 미포함, 1: 포함)
        /// </summary>
        public class TAX_AMT_INCLUDE_YN
        {
            /// <summary>
            /// 미포함
            /// </summary>
            public const string NOT_INCLUDED = "0";
            /// <summary>
            /// 포함
            /// </summary>
            public const string INCLUDED = "1";
        }
        #endregion

        #region TAX_AMT_CALC_METHD(점포 마스터 - 거래 세금 계산 방법)
        /// <summary>
        /// 거래 세금 계산 방법(1: 전체금액세금계산후배분 2: 상품별세금계산후합산)
        /// </summary>
        public class TAX_AMT_CALC_METHD
        {
            /// <summary>
            /// 1: 전체금액세금계산후배분
            /// </summary>
            public const string BILL = "1";
            /// <summary>
            /// 2: 상품별세금계산후합산
            /// </summary>
            public const string ITEM = "2";
        }
        #endregion

        #region TAX_AMT_APPLY_DIV(점포 마스터 - 세금적용구분)
        /// <summary>
        /// 세금적용구분(공통코드 M0012 - 1:기본세율적용, 2:상품세율적용)
        /// </summary>
        public class TAX_AMT_APPLY_DIV
        {
            /// <summary>
            /// 1:기본세율적용
            /// </summary>
            public const string BASIC_TAX_APPY = "1";
            /// <summary>
            /// 2:상품세율적용
            /// </summary>
            public const string ITEM_TAX_APPY = "2";
        }
        #endregion

        #region EXCHANGE_TICKET_ISSUE_TYPE (잔액교환권 발행구분)
        /// <summary>
        /// 잔액교환권 발행구분 ( 00:발행 ,01.발행취소 02.조회  03:사용 , 04:사용 취소 )
        /// </summary>
        public class EXCHANGE_TICKET_ISSUE_TYPE
        {
            /// <summary>
            /// 00:발행
            /// </summary>
            public const string MAKE = "00";
            /// <summary>
            /// 01:발행취소
            /// </summary>
            public const string MAKE_CANCEL = "01";
            /// <summary>
            /// 02:조회
            /// </summary>
            public const string SEARCH = "02";
            /// <summary>
            /// 03:사용
            /// </summary>
            public const string USE = "03";
            /// <summary>
            /// 04:사용취소
            /// </summary>
            public const string USE_CANCEL = "04";
        }
        #endregion

        #region EXCHANGE_TICKET_MAKE_TYPE (잔액교환권 발생구분)
        /// <summary>
        /// 잔액교환권 발생구분 ( 1:식권, 2:상품권, 3:잔약교환권)
        /// </summary>
        public class EXCHANGE_TICKET_MAKE_TYPE
        {
            /// <summary>
            /// 0:기본
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 1:식권
            /// </summary>
            public const string MEAL_TICKET = "1";
            /// <summary>
            /// 2:상품권
            /// </summary>
            public const string GIFT = "2";
            /// <summary>
            /// 3:잔액교환권
            /// </summary>
            public const string EXCHANGE_TICKET = "3";
        }
        #endregion

        #region GIFT_APPROVE_DIV 상품권 승인 구분
        /// <summary>
        /// 상품권 승인 구분
        /// </summary>
        public class GIFT_APPROVE_DIV
        {
            /// <summary>
            /// 조회
            /// </summary>
            public const string NORMAL = "10";
            /// <summary>
            /// 승인
            /// </summary>
            public const string APPROVE = "20";
            /// <summary>
            /// 반품
            /// </summary>
            public const string CANCEL = "30";
            /// <summary>
            /// 망취소
            /// </summary>
            public const string NET_CANCEL = "40";
        }
        #endregion

        #region GIFT_APPROVE_PATH 상품권 승인 경로
        /// <summary>
        /// 상품권 승인 결로
        /// </summary>
        public class GIFT_APPROVE_PATH
        {
            /// <summary>
            /// 점포승인/취소
            /// </summary>
            public const string STORE = "1";
            /// <summary>
            /// 자동승인/취소
            /// </summary>
            public const string AUTO = "2";
            /// <summary>
            /// 강제승인/취소
            /// </summary>
            public const string FORCED = "3";
            /// <summary>
            /// 망취소
            /// </summary>
            public const string NET_CANCEL = "4";
            /// <summary>
            /// 본사승인
            /// </summary>
            public const string HEAD_OFFICE = "5";
        }
        #endregion

        #region HAPPYORDER_WORK_TYPE(해피오더 API URL)
        /// <summary>
        /// 해피오더 API URL
        /// </summary>
        public class HAPPYORDER_WORK_TYPE
        {
            /// <summary>
            /// 신규 주문 건수 조회
            /// </summary>
            public const string SELECT_ORDER_COUNT = "/order/select/count";
            /// <summary>
            /// 신규 주문 리스트 조회
            /// </summary>
            public const string SELECT_ORDER_LIST = "/order/select/mainList";
            /// <summary>
            /// 주문 상세 조회
            /// </summary>
            public const string SELECT_ORDER_DETAIL = "/order/select/subList";
            /// <summary>
            /// 주문 상태 변경
            /// </summary>
            public const string UPDATE_STATUS = "/order/updateStatus";
            /// <summary>
            /// 주문 상태 별 건수 조회
            /// </summary>
            public const string SELECT_STATUS_COUNT = "/order/select/statusCount";

            //#20180605 해피오더 개선 start - 20180618
            /// <summary>
            /// 주문 상태 별 건수 조회
            /// </summary>
            public const string SELECT_STATUS_COUNT_PB = "/order/select/statusCountPb";
            //#20180605 해피오더 개선 end - 20180618

            /// <summary>
            /// 망취소 전문
            /// </summary>
            public const string NETWORK_CANCEL = "/order/update";
            /// <summary>
            /// 픽업 지연 리스트 조회
            /// </summary>
            public const string PICKUP_DELAY_LIST = "/order/select/pickupDelayList";
            /// <summary>
            /// 픽업 지연 미픽업
            /// </summary>
            public const string DELAY_NO_PICKUP = "/order/update/delayNoPickup";
            /// <summary>
            /// 상품별 영양정보 조회
            /// </summary>
            public const string SELECT_PRODUCT_NUTRITION = "/order/select/productNutrition";

            //#16366 해피오더 당월누적주문내역 + 당일 해피오더주문 상세내역 자동 출력기능 start
            /// <summary>
            /// 당월누계 데이터 조회
            /// </summary>
            public const string SELECT_MONTH_COUNT = "/order/select/storeSalesTotal";
            //#16366 해피오더 당월누적주문내역 + 당일 해피오더주문 상세내역 자동 출력기능 end
        }
        #endregion

		#region HAPPYORDER_STATUS(해피오더 상태코드)
        /// <summary>
        /// 주문접수           4
        /// 상품준비           5
        /// 사전예약           6
        /// 픽업대기           7
        /// 픽업완료           8
        /// 픽업지연        2000
        /// 픽업지연완료    2008
        /// 픽업지연미픽업  2018
        /// 배달요청        9004
        /// 배달접수        9005
        /// 배달상품준비중  9006
        /// 배달중          9007
        /// 베달완료        9009
        /// 주문취소        300000
        /// 직접배달        9003
        /// </summary>
        public class HAPPYORDER_STATUS
        {
            /// <summary>
            /// 주문접수
            /// </summary>
            public const string ORDER_REG = "4";
            /// <summary>
            /// 상품준비
            /// </summary>
            public const string PRODUCT_READY = "5";
            /// <summary>
            /// 사전예약
            /// </summary>
            public const string PRE_RESERVED = "6";
            /// <summary>
            /// 픽업대기
            /// </summary>
            public const string PICKUP_WAIT = "7";
            /// <summary>
            /// 픽업완료
            /// </summary>
            public const string PICKUP_COMPLETED = "8";
            /// <summary>
            /// 픽업지연
            /// </summary>
            public const string PICKUP_DELAY = "2000";
            /// <summary>
            /// 픽업지연완료
            /// </summary>
            public const string PICKUP_COMPLETED2 = "2008";
            /// <summary>
            /// 픽업지연미픽업
            /// </summary>
            public const string NO_PICKUP_AND_DELAY = "2018";
            /// <summary>
            /// 배달요청
            /// </summary>
            public const string DELIVERY_REQ = "9004";
            /// <summary>
            /// 배달접수
            /// </summary>
            public const string DELIVERY_REG = "9005";
            /// <summary>
            /// 배달상품준비중
            /// </summary>
            public const string DELIVERY_PRODUCT_READY = "9006";
            /// <summary>
            /// 배달중
            /// </summary>
            public const string DELIVERY_ING = "9007";
            /// <summary>
            /// 배달완료
            /// </summary>
            public const string DELIVERY_COMPLETED = "9009";
            /// <summary>
            /// 주문취소
            /// </summary>
            public const string ORDER_CANCEL = "300000";

            //grayber@20171123 해피오더 직접배달 start
            /// <summary>
            /// 직접배달
            /// </summary>
            public const string DELIVERY_DIRECT = "9003";
            //grayber@20171123 해피오더 직접배달 end
        }
		#endregion

        #region YANGJAEORDER_WORK_TYPE(양재오더 API URL)
        /// <summary>
        /// 양재오더 API URL
        /// </summary>
        public class YANGJAEORDER_WORK_TYPE
        {
            /// <summary>
            /// 신규 주문 건수 조회
            /// </summary>
            public const string SELECT_ORDER_COUNT = "/order/select/count";
            /// <summary>
            /// 신규 주문 리스트 조회
            /// </summary>
            public const string SELECT_ORDER_LIST = "/order/select/mainList";
            /// <summary>
            /// 주문 상세 조회
            /// </summary>
            public const string SELECT_ORDER_DETAIL = "/order/select/subList";
            /// <summary>
            /// 주문 상태 변경
            /// </summary>
            public const string UPDATE_STATUS = "/order/updateStatus";
            /// <summary>
            /// 주문 상태 별 건수 조회
            /// </summary>
            public const string SELECT_STATUS_COUNT = "/order/select/statusCount";
            /// <summary>
            /// 망취소 전문
            /// </summary>
            public const string NETWORK_CANCEL = "/order/update";
            /// <summary>
            /// 픽업 지연 리스트 조회
            /// </summary>
            public const string PICKUP_DELAY_LIST = "/order/select/pickupDelayList";
            /// <summary>
            /// 픽업 지연 미픽업
            /// </summary>
            public const string DELAY_NO_PICKUP = "/order/update/delayNoPickup";
            /// <summary>
            /// 상품별 영양정보 조회
            /// </summary>
            public const string SELECT_PRODUCT_NUTRITION = "/order/select/productNutrition";
            //#16366 해피오더 당월누적주문내역 + 당일 해피오더주문 상세내역 자동 출력기능 start
            /// <summary>
            /// 당월누계 데이터 조회
            /// </summary>
            public const string SELECT_MONTH_COUNT = "/order/select/storeSalesTotal";
            //#16366 해피오더 당월누적주문내역 + 당일 해피오더주문 상세내역 자동 출력기능 end
        }
        #endregion YANGJAEORDER_WORK_TYPE(양재오더 API URL)

        #region YANGJAEORDER_STATUS(양재오더 상태코드)
        /// <summary>
        /// 양재오더 상태코드
        /// </summary>
        public class YANGJAEORDER_STATUS
        {
            /// <summary>
            /// 주문접수
            /// </summary>
            public const string ORDER_REG = "4";
            /// <summary>
            /// 상품준비
            /// </summary>
            public const string PRODUCT_READY = "5";
            /// <summary>
            /// 현장주문완료
            /// </summary>
            public const string FIELD_ORDER_COMPLETED = "6";
            /// <summary>
            /// 픽업대기
            /// </summary>
            public const string PICKUP_WAIT = "7";
            /// <summary>
            /// 픽업완료
            /// </summary>
            public const string PICKUP_COMPLETED = "8";
            /// <summary>
            /// 픽업지연
            /// </summary>
            public const string PICKUP_DELAY = "2000";
            /// <summary>
            /// 픽업지연완료
            /// </summary>
            public const string PICKUP_COMPLETED2 = "2008";
            /// <summary>
            /// 배달요청
            /// </summary>
            public const string DELIVERY_REQ = "9004";
            /// <summary>
            /// 배달접수
            /// </summary>
            public const string DELIVERY_REG = "9005";
            /// <summary>
            /// 배달상품준비중
            /// </summary>
            public const string DELIVERY_PRODUCT_READY = "9006";
            /// <summary>
            /// 배달중
            /// </summary>
            public const string DELIVERY_ING = "9007";
            /// <summary>
            /// 배달완료
            /// </summary>
            public const string DELIVERY_COMPLETED = "9009";
            /// <summary>
            /// 주문취소
            /// </summary>
            public const string ORDER_CANCEL = "300000";
        }
        #endregion YANGJAEORDER_STATUS(양재오더 상태코드)

        #region ORDER_TYPE(해피오더/양재오더 주문유형)
        public class ORDER_TYPE
        {
            /// <summary>
            /// 매장즉시
            /// </summary>
            public const string SHOP_DIRECT = "1";
            /// <summary>
            /// 매장시간
            /// </summary>
            public const string SHOP_TIME = "2";
            /// <summary>
            /// 예약주문
            /// </summary>
            public const string RESERVED_ORDER = "3";
            /// <summary>
            /// 내부배달
            /// </summary>
            public const string INNER_DELIVERY = "4";
            /// <summary>
            /// 외부배달
            /// </summary>
            public const string OUTTER_DELIVERY = "5";
            /// <summary>
            /// 사전예약
            /// </summary>
            public const string PRE_RESERVED = "6";

            //#20180605 해피오더 개선 start
             
            /// <summary>
            /// 즉시픽업
            /// </summary>
            public const string DIRECT_ORDER = "7";
            /// <summary>
            /// 즉시배달
            /// </summary>
            public const string RESERV_ORDER = "8";
             
            //#20180605 해피오더 개선 end

        }
        #endregion ORDER_TYPE(해피오더/양재오더 주문유형)

        #region 디지털메뉴보드 전문 ID
        public class DMB_IRT_ID
        {
            /// <summary>
            /// 판매 개시 전송
            /// </summary>
            public const string SALE_BEGIN = "1000";
            /// <summary>
            /// 상품 등록 전송
            /// </summary>
            public const string PRODUCT_REG = "1010";
            /// <summary>
            /// 포인트 정보 전송
            /// </summary>
            public const string POINT_INFO = "1100";
            /// <summary>
            /// 결제 정보 전송
            /// </summary>
            public const string PAY_INFO = "1110";
            /// <summary>
            /// 판매 완료 전송
            /// </summary>
            public const string SALE_END = "2000";
        }
        #endregion

        //#16569 파스쿠찌 드라이브 스루 기능 개발 요청 start
        #region PAS Drive Thru 전문ID
        public class DT_IRT_ID
        {
            /// <summary>
            /// 판매 개시 전송
            /// </summary>
            public const string SALE_BEGIN = "1000";
            /// <summary>
            /// 상품 등록 전송
            /// </summary>
            public const string PRODUCT_REG = "1010";
            /// <summary>
            /// 상품 일괄 취소
            /// </summary>
            public const string PRODUCT_CANC = "1020";
            /// <summary>
            /// 판매 완료 전송
            /// </summary>
            public const string SALE_END = "2000";

        }
        #endregion PAS Drive Thru 전문ID
        //#16569 파스쿠찌 드라이브 스루 기능 개발 요청 end

        #region IRT_TRAN_TYPE(INQ 종별)
        /// <summary>
        /// TRAN 종별 코드
        /// </summary>
        public class IRT_TRAN_TYPE
        {
            /// <summary>
            /// 01:헤더
            /// </summary>
            public const string TranHeader = "01";
            /// <summary>
            /// 02:상품
            /// </summary>
            public const string TranDetail = "02";
            /// <summary>
            /// 03:결제
            /// </summary>
            public const string TranPay = "03";
            /// <summary>
            /// 04:할인
            /// </summary>
            public const string TranDC = "04";
            /// <summary>
            /// 05:캠페인
            /// </summary>
            public const string TranCpiRslt = "05";
            /// <summary>
            /// 06:기타
            /// </summary>
            public const string TranEtc = "06";
            /// <summary>
            /// 07:입출금
            /// </summary>
            public const string TranDpst = "07";
            /// <summary>
            /// 08:정산
            /// </summary>
            public const string TranAdmt = "08";
            /// <summary>
            /// 09:고객
            /// </summary>
            public const string TranGuestCnt = "09";
            /// <summary>
            /// 10:예약정보
            /// </summary>
            public const string TranReservInfo = "10";
            /// <summary>
            /// 20:ETC헤더
            /// </summary>
            public const string EtcTranHeader = "20";
            /// <summary>
            /// 21:ETC상품
            /// </summary>
            public const string EtcTranDetail = "21";
            /// <summary>
            /// 22:ETC결제
            /// </summary>
            public const string EtcTranPay = "22";
            /// <summary>
            /// 23:ETC기타
            /// </summary>
            public const string EtcTranEtc = "23";
            /// <summary>
            /// 24:ETC입출금
            /// </summary>
            public const string EtcTranDpst = "24";
        }
        #endregion

        #region PGM_DOWN_STATE (프로그램 다운로드 상태)
        /// <summary>
        /// 프로그램 다운로드 상태
        /// </summary>
        public class PGM_DOWN_STATE
        {
            /// <summary>
            /// 1:다운로드 완료
            /// </summary>
            public const string DownLoad_OK = "1";
            /// <summary>
            /// 2:적용 완료
            /// </summary>
            public const string Update_OK = "2";
            /// <summary>
            /// F:다운로드 실패
            /// </summary>
            public const string DownLoad_Fail = "F";
            /// <summary>
            /// E:적용 실패
            /// </summary>
            public const string Update_Fail = "E";
        }
        #endregion 

        #region SALE_SEARCH_TYPE (자료조회 조회구분)
        /// <summary>
        /// 자료조회 조회구분
        /// </summary>
        public class SALE_SEARCH_TYPE
        {
            /// <summary>
            /// 1:자료조회
            /// </summary>
            public const string DATA = "1";

            /// <summary>
            /// 2:매출자료조회
            /// </summary>
            public const string SALE = "2";

            /// <summary>
            /// 3:영수증 메모 조회
            /// </summary>
            public const string MEMO = "3";

            /// <summary>
            /// 4:담당자별 매출 조회
            /// </summary>
            public const string EMP = "4";

        }
        #endregion

        #region EMP_COMMUTE_DIV(출퇴근 구분)
        /// <summary>
        /// 출퇴근 구분
        /// </summary>
        public class EMP_COMMUTE_DIV
        {
            /// <summary>
            /// 1:출근
            /// </summary>
            public const string WORK_START = "1";
            /// <summary>
            /// 2:퇴근
            /// </summary>
            public const string WORK_END = "2";
            /// <summary>
            /// 3:휴식시작
            /// </summary>
            public const string REST_START = "3";
            /// <summary>
            /// 4:휴식종료
            /// </summary>
            public const string REST_END = "4";
            /// <summary>
            /// 5:외출시작
            /// </summary>
            public const string GO_OUT_START = "5";
            /// <summary>
            /// 6:외출종료
            /// </summary>
            public const string GO_OUT_END = "6";
        }
        #endregion

        #region EMP_VISIT_DIV(제조기사 및 직원방문 입력 구분)
        /// <summary>
        /// 제조기사 및 직원방문 입력 구분
        /// </summary>
        public class EMP_VISIT_DIV
        {
            /// <summary>
            /// MS:MOBILE(바코드)
            /// </summary>
            public const string MOBILE = "SM";
            /// <summary>
            /// SS:MSR
            /// </summary>
            public const string MSR = "SS";
            
        }
        #endregion

        #region NOTE_MSG_DIV(공지사항 메시지 구분별 유형)
        /// <summary>
        /// 공지사항 메시지 구분별 유형(00:긴급 01:일반 02:영업)
        /// </summary>
        public class NOTE_MSG_DIV
        {
            /// <summary>
            /// 00:긴급
            /// </summary>
            public const string EMG = "00";
            /// <summary>
            /// 01:일반
            /// </summary>
            public const string NRL = "01";
            /// <summary>
            /// 02:영업
            /// </summary>
            public const string BIZ = "02";
            /// <summary>
            /// 03:전체
            /// </summary>
            public const string ALL = "03";
            /// <summary>
            /// 04:긴급롤링 메세지
            /// </summary>
            public const string ROL = "04";
            /// <summary>
            /// 05:긴급 팝업 메세지
            /// </summary>
            public const string POP = "05";
        }
        #endregion

        #region NOTE_MSG_TYPE(공지사항 공지별유형)
        /// <summary>
        /// 공지사항 공지별유형 (일반 공지:없음 / 긴급공지:1.마스터,2.PGM,3.FILE,4.로그 송신,5.주문 긴급,6.관공서 긴급,7.기타 / 영업 공지:1 본사TODO,2.식품 안전)
        /// </summary>
        public class NOTE_MSG_TYPE
        {   
            
            /// <summary>
            /// 1:긴급_마스터
            /// </summary>
            public const string EMG_MST = "1";
            /// <summary>
            /// 2:긴급_PGM
            /// </summary>
            public const string EMG_PGM = "2";
            /// <summary>
            /// 3:긴급_FILE
            /// </summary>
            public const string EMG_FILE = "3";
            /// <summary>
            /// 4:긴급_로그송신
            /// </summary>
            public const string EMG_LOG = "4";
            /// <summary>
            /// 5:긴급_주문
            /// </summary>
            public const string EMG_ORDER = "5";
            /// <summary>
            /// 6:긴급_관공서
            /// </summary>
            public const string EMG_GOV = "6";
            /// <summary>
            /// 7:긴급_기타
            /// </summary>
            public const string EMG_ETC = "7";
                        
            /// <summary>
            /// 1:본사TODO
            /// </summary>
            public const string BIZ_CMP = "1";
            /// <summary>
            /// 2:식품안전
            /// </summary>
            public const string BIZ_FOOD = "2";

        }
        #endregion

        #region 선불카드 판매 구분 - 중국
        public class PRIPAIDCARD_SALE_TYPE
        {
            /// <summary>
            /// 조회
            /// </summary>
            public const string SELECT = "0";
            /// <summary>
            /// 승인
            /// </summary>
            public const string APPROVE  = "1";
            /// <summary>
            /// 취소
            /// </summary>
            public const string APPROVE_CAN  = "2";
        }
        #endregion 

        #region 위챗페이 승인 구분 - 중국
        public class WECHATPAY_TRAN_TYPE
        {
            /// <summary>
            /// 승인
            /// </summary>
            public const string APPROVE = "72";
            /// <summary>
            /// 취소
            /// </summary>
            public const string REFUND = "62";
        }
        #endregion 

        //#20170911.001, 중국 위쳇 페이 (바이롱) 결제 코드 start;girak.kim;
        #region 위챗페이-바이롱 전문 승인 구분 - 중국
        public class WECHATPAY_BIORONG_TRAN_TYPE
        {
            /// <summary>
            /// 승인
            /// </summary>
            public const string APPROVE = "73";
            /// <summary>
            /// 취소
            /// </summary>
            public const string REFUND = "63";
        }
        #endregion 
        
        #region 기프트카드-바이롱 승인 구분 - 중국
        public class XIAO_GIFTCARD_TRAN_TYPE
        {
            /// <summary>
            /// 승인
            /// </summary>
            public const string APPROVE = "74";
            /// <summary>
            /// 취소
            /// </summary>
            public const string REFUND = "64";
        }
        #endregion 
        //#20170911.001, 중국 위쳇 페이 (바이롱) 결제 코드 end;girak.kim;

        #region CNTRY_DIV(국가구분)
        /// <summary>
        /// 국가구분
        /// </summary>
        public class CNTRY_DIV
        {
            /// <summary>
            /// KR(한국)
            /// </summary>
            public const string KR = "KR";
            /// <summary>
            /// CN(중국)
            /// </summary>
            public const string CN = "CN";
            /// <summary>
            /// US(미국)
            /// </summary>
            public const string US = "US";
            /// <summary>
            /// VN(베트남)
            /// </summary>
            public const string VN = "VN";
            /// <summary>
            /// SG(싱가포르)
            /// </summary>
            public const string SG = "SG";
            /// <summary>
            /// FR(프랑스)
            /// </summary>
            public const string FR = "FR";
        }
        #endregion

        #region CORP_DIV(회사구분)
        /// <summary>
        /// 회사 구분
        /// </summary>
        public class CORP_DIV
        {
            /// <summary>
            /// 파리
            /// </summary>
            public const string PC = "PC";
            /// <summary>
            /// 비알
            /// </summary>
            public const string BR = "BR";
            /// <summary>
            /// 삼립
            /// </summary>
            public const string SL = "SL";
        }
        #endregion

        #region 봉사료 관련 구조체

        #region SERVICE_CHARGE_APPLY_DIV(점포 마스터 - 봉사료 적용 구분)
        /// <summary>
        /// 봉사료 적용대상 구분(0:적용안함, 1:상품당 봉사료 적용, 2:영수증당 봉사료 적용)
        /// </summary>
        public class SERVICE_CHARGE_APPLY_DIV 
        {
            /// <summary>
            /// 0: 적용안함
            /// </summary>
            public const string NONE = "0";
            /// <summary>
            /// 1: 상품당
            /// </summary>
            public const string ITEM = "1";
            /// <summary>
            /// 2: 영수증당
            /// </summary>
            public const string BILL = "2";
        }
        #endregion

        #region SERVICE_CHARGE_DIV(점포 마스터 - 봉사료 구분)
        /// <summary>
        /// 봉사료 구분(공통코드 M0029 0:적용안함, 1:율, 2:금액)
        /// </summary>
        public class SERVICE_CHARGE_DIV
        {
            /// <summary>
            /// 0: 적용안함
            /// </summary>
            public const string NONE = "0";
            /// <summary>
            /// 1: 율
            /// </summary>
            public const string RATE = "1";
            /// <summary>
            /// 2: 금액
            /// </summary>
            public const string AMT = "2";
        }
        #endregion

        #endregion 봉사료 관련 구조체

        #region 보류 로그 상태값
        /// <summary>
        /// 보류 로그 상태값
        /// </summary>
        public class HOLD_STAT_CD
        {
            /// <summary>
            /// 보류
            /// </summary>
            public const string HOLD = "H01";
            /// <summary>
            /// 보류 로드 후 거래 취소
            /// </summary>
            public const string CANCEL = "H44";
            /// <summary>
            /// 보류 로드 후 거래 완료
            /// </summary>
            public const string FINISH = "H99";
            /// <summary>
            /// 보류 후 재 보류
            /// </summary>
            public const string REHOLD = "HRR";
            /// <summary>
            /// 보류 등록 후 삭제
            /// </summary>
            public const string DELETE = "H54";
            /// <summary>
            /// 보류 로드(로그 발생 안함!)
            /// </summary>
            public const string LOAD = "HLD";
        }
        #endregion 
        
        #region 거래 외부전송 인터페이스 정의
        /// <summary>
        /// 거래 외부전송 인터페이스 정의
        /// </summary>
        public class TranInterfaceOutside
        {
            /// <summary>
            /// 한국 - 도로공사
            /// </summary>
            public const string IF_KOR_01 = "KOR_01";
            /// <summary>
            /// 한국 - 공항공사
            /// (사용 안 함)
            /// </summary>
            public const string IF_KOR_02 = "KOR_02";

            //#20180322 휴게소pos매출연동 start,phj
            /// <summary>
            /// 한국 - 휴게소pos매출연동
            /// </summary>
            public const string IF_KOR_03 = "KOR_03";
            //#20180322 휴게소pos매출연동 end,phj

            /// <summary>
            /// 중국 - 무역센터
            /// </summary>
            public const string IF_CHN_01 = "CHN_01";
            /// <summary>
            /// 중국 - 상해쩡따광장
            /// </summary>
            public const string IF_CHN_02 = "CHN_02";
            /// <summary>
            /// 중국 - 왕진활현
            /// </summary>
            public const string IF_CHN_03 = "CHN_03";
            /// <summary>
            /// 중국 - 조양따훼청
            /// </summary>
            public const string IF_CHN_04 = "CHN_04";
            /// <summary>
            /// 중국 - 풍란
            /// </summary>
            public const string IF_CHN_05 = "CHN_05";
            /// <summary>
            /// 중국 - 닝보인상청
            /// </summary>
            public const string IF_CHN_06 = "CHN_06";

            /// <summary>
            /// 싱가폴 - 창이공항
            /// </summary>
            public const string IF_SIN_01 = "SIN_01";
        }
        #endregion 

        #region POS CONFIG 전문 구분자
        /// <summary>
        /// POS CONFIG 전문 구분자
        /// </summary>
        public class POS_CONFIG_INQ_DIV
        {
            /// <summary>
            /// 저장
            /// </summary>
            public const string SAVE = "1";
            /// <summary>
            /// 불러오기 전체
            /// </summary>
            public const string LOAD_ALL = "2";
            /// <summary>
            /// 불러오기 단일
            /// </summary>
            public const string LOAD_ONE = "3";
        }
        #endregion 

        #region POS CONFIG 저장 구분자
        /// <summary>
        /// POS CONFIG 저장 구분자
        /// </summary>
        public class POS_CONFIG_TYPE
        {
            /// <summary>
            /// 저장
            /// </summary>
            public const string SAVE = "1";
            /// <summary>
            /// 불러오기
            /// </summary>
            public const string LOAD = "2";
        }
        #endregion

        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
        #region DC_APPLY_TRGT 할인 대상 유형
        public class DC_APPLY_TRGT
        {
            /// <summary>
            /// 1:전체
            /// </summary>
            public const string DC_TOTAL = "1";
            /// <summary>
            /// 2:특정상품
            /// </summary>
            public const string DC_ITEM = "2";
            /// <summary>
            /// 3:웰컴 기프트
            /// </summary>
            public const string DC_WC_GIFT = "3";


            //#14618 KT 더블할인 개발요청 start,phj
            /// <summary>
            /// 4:KT DOUBLE DC
            /// </summary>
            public const string DC_KT_DOUBLE = "4";
            //#14618 KT 더블할인 개발요청 end,phj

        }
        #endregion
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

        //#20180322 휴게소pos매출연동 start,phj
        #region 도로공사 매출연동
        public class ROAD_SAVE_TYPE
        {
            /// <summary>
            /// 매출
            /// </summary>
            public const string SALE = "S";
            /// <summary>
            /// 마감
            /// </summary>
            public const string CLOSING = "R";
        }
        #endregion
        //#20180322 휴게소pos매출연동 end,phj

        //#20180322 휴게소pos매출연동 start,phj
        #region 도로공사 재전송
        public class RESTPOS_RESEND
        {
            /// <summary>
            /// 매출 -전체
            /// </summary>
            public const string TOT_RESEND = "0";
            /// <summary>
            /// 매출 -단건
            /// </summary>
            public const string EACH_RESEND = "1";
            /// <summary>
            /// 정산 
            /// </summary>
            public const string ADMT_RESEND = "2";
        }
        #endregion
        //#20180322 휴게소pos매출연동 end,phj
    }
}
