﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 마스터 정의
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Common
{
    /// <summary>
    /// 마스터 목록
    /// </summary>
    public class MasterLists
    {
        /// <summary>
        /// MOT메시지 마스터
        /// </summary>
        public class MST_MOT_MSG
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_MOT_MSG";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "01";
        }

        /// <summary>
        /// MOT메시지 마스터 상세
        /// </summary>
        public class MST_MOT_MSG_DTL
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_MOT_MSG_DTL";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "02";
        }

        /// <summary>
        /// POS 마스터
        /// </summary>
        public class MST_POS
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_POS";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "03";
        }

        /// <summary>
        /// POS 설정 마스터
        /// </summary>
        public class MST_POS_SETTNG
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_POS_SETTNG";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "04";
        }

        /// <summary>
        /// POS 옵션 마스터
        /// </summary>
        public class MST_POS_OPTN
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_POS_OPTN";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "05";
        }

        /// <summary>
        /// VAN 마스터
        /// </summary>
        public class MST_VAN
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_VAN";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "06";
        }

        /// <summary>
        /// WEB 연동 버튼 마스터
        /// </summary>
        public class MST_WEB_LNKAGE
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_WEB_LNKAGE";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "07";
        }

        /// <summary>
        /// 공통 마스터
        /// </summary>
        public class MST_CMM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CMM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "08";
        }

        /// <summary>
        /// 기능키 거래유형별 마스터
        /// </summary>
        public class MST_FUNC_KEY_TRADE_TYPEPER
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_FUNC_KEY_TRADE_TYPEPER";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "09";
        }

        /// <summary>
        /// 기능키 그룹 마스터
        /// </summary>
        public class MST_FUNC_KEY_GRP
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_FUNC_KEY_GRP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "10";
        }

        /// <summary>
        /// 기능키 마스터
        /// </summary>
        public class MST_FUNC_KEY
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_FUNC_KEY";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "11";
        }

        /// <summary>
        /// 담당자권한 마스터
        /// </summary>
        public class MST_PIC_AUTH
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PIC_AUTH";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "12";
        }

        /// <summary>
        /// 상품 분류 마스터
        /// </summary>
        public class MST_ITEM_CLSS
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_CLSS";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "13";
        }

        /// <summary>
        /// 메시지 마스터
        /// </summary>
        public class MST_MSG
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_MSG";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "14";
        }

        /// <summary>
        /// 문화 마스터
        /// </summary>
        public class MST_CULTURE
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CULTURE";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "15";
        }

        /// <summary>
        /// 부가메뉴 마스터
        /// </summary>
        public class MST_SUBPRC_MENU
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_SUBPRC_MENU";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "16";
        }

        /// <summary>
        /// 부가메뉴 그룹 마스터
        /// </summary>
       
        public class MST_SUBPRC_MENU_GRP
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_SUBPRC_MENU_GRP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "17";
        }

        /// <summary>
        /// 사용자 마스터
        /// </summary>
        public class MST_USER
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_USER";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "18";
        }

        /// <summary>
        /// 상품 마스터
        /// </summary>
        public class MST_ITEM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "19";
        }

        /// <summary>
        /// 상품 바코드 마스터
        /// </summary>
        public class MST_ITEM_BAR_CD
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_BAR_CD";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "20";
        }

        /// <summary>
        /// 상품권 마스터
        /// </summary>
        public class MST_GIF
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_GIF";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "21";
        }

        /// <summary>
        /// 세트 마스터
        /// </summary>
        public class MST_ITEM_SET
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_SET";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "22";
        }

        /// <summary>
        /// 세트 그룹 마스터
        /// </summary>
        public class MST_ITEM_SET_GRP
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_SET_GRP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "23";
        }

        /// <summary>
        /// 식권 마스터
        /// </summary>
        public class MST_MEAL_TCKT
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_MEAL_TCKT";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "24";
        }

        /// <summary>
        /// 영수증 마스터
        /// </summary>
        public class MST_BILL_MSG
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_BILL_MSG";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "25";
        }

        /// <summary>
        /// 영수증 유형 마스터
        /// </summary>
        public class MST_BILL_TYPE
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_BILL_TYPE";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "26";
        }

        /// <summary>
        /// 영수증 유형 그룹 마스터
        /// </summary>
        public class MST_BILL_TYPE_GRP
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_BILL_TYPE_GRP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "27";
        }

        /// <summary>
        /// 점포 마스터
        /// </summary>
        public class MST_STOR
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_STOR";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "28";
        }

        /// <summary>
        /// 정산지 타입 그룹 마스터
        /// </summary>
        public class MST_ADMT_TYPE_GRP
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ADMT_TYPE_GRP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "29";
        }

        /// <summary>
        /// 정산지 타입 마스터
        /// </summary>
        public class MST_ADMT_TYPE
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ADMT_TYPE";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "30";
        }

        /// <summary>
        /// 주방DEVICE 마스터
        /// </summary>
        public class MST_KTCH_DEVICE
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_KTCH_DEVICE";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "31";
        }

        /// <summary>
        /// 주방DEVICE 상품 마스터
        /// </summary>
        public class MST_KTCH_DEVICE_ITEM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_KTCH_DEVICE_ITEM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "32";
        }

        /// <summary>
        /// 층 마스터
        /// </summary>
        //public class MST_FLOOR
        //{
        //    /// <summary>
        //    /// 테이블ID
        //    /// </summary>
        //    public const string ID = "MST_FLOOR";
        //    /// <summary>
        //    /// 마스터 요청 구분
        //    /// </summary>
        //    public const string DIV = "35";
        //}

        /// <summary>
        /// 캠페인 상품 그룹 관리
        /// </summary>
        public class MST_CPI_COMPNT
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CPI_COMPNT";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "36";
        }

        /// <summary>
        /// 캠페인 마스터
        /// </summary>
        public class MST_CPI
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CPI";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "37";
        }

        /// <summary>
        /// 캠페인 시간 마스터
        /// </summary>
        public class MST_CPI_HOUR
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CPI_HOUR";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "38";
        }

        /// <summary>
        /// 캠페인 상품 마스터
        /// </summary>
        public class MST_CPI_ITEM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CPI_ITEM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "39";
        }

        /// <summary>
        /// 캠페인 출력메시지 마스터
        /// </summary>
        public class MST_CPI_PRT_MSG
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CPI_PRT_MSG";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "40";
        }

        /// <summary>
        /// 캠페인 카드 마스터
        /// </summary>
        public class MST_CPI_CARD
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CPI_CARD";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "41";
        }

        /// <summary>
        /// 캠페인 복권 출력 메시지 관리
        /// </summary>
        public class MST_CPI_LTTR_PRT
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CPI_LTTR_PRT";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "42";
        }

        /// <summary>
        /// 테이블 마스터
        /// </summary>
        //public class MST_TBL
        //{
        //    /// <summary>
        //    /// 테이블ID
        //    /// </summary>
        //    public const string ID = "MST_TBL";
        //    /// <summary>
        //    /// 마스터 요청 구분
        //    /// </summary>
        //    public const string DIV = "43";
        //}

        /// <summary>
        /// 플레이버 마스터
        /// </summary>
        public class MST_FLAVOUR
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_FLAVOUR";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "44";
        }

        /// <summary>
        /// 환율 마스터
        /// </summary>
        public class MST_EXCHG_RATE
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_EXCHG_RATE";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "45";
        }

        /// <summary>
        /// 상품키 구성 마스터
        /// </summary>
        public class MST_ITEM_KEY_COMPNT
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_KEY_COMPNT";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "46";
        }

        /// <summary>
        /// 상품키 대분류 마스터
        /// </summary>
        public class MST_ITEM_KEY_L_CLSS
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_KEY_L_CLSS";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "47";
        }

        /// <summary>
        /// 상품키 분류 배치 마스터
        /// </summary>
        public class MST_ITEM_KEY_CLSS_BATCH
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_KEY_CLSS_BATCH";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "48";
        }

        /// <summary>
        /// 상품키 분류 마스터
        /// </summary>
        public class MST_ITEM_KEY_CLSS
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_KEY_CLSS";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "49";
        }

        /// <summary>
        /// 상품키 마스터
        /// </summary>
        public class MST_ITEM_KEY
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_ITEM_KEY";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "50";
        }

        /// <summary>
        /// 즐겨찾기 마스터
        /// </summary>
        public class MST_BOOKMK
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_BOOKMK";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "51";
        }

        /// <summary>
        /// 마스터 다운로드 정보
        /// </summary>
        public class MST_DOWN_INFO
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_DOWN_INFO";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "52";
        }

        /// <summary>
        /// 이미지 정보 마스터
        /// </summary>
        public class MST_IMAGE_INFO
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_IMAGE_INFO";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "53";
        }

        /// <summary>
        /// 고객화면 마스터
        /// </summary>
        public class MST_CUST_DSP
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CUST_DSP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "54";
        }

        /// <summary>
        /// 시험모드 마스터
        /// </summary>
        public class MST_TEST_MODE
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_TEST_MODE";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "55";
        }

        /// <summary>
        /// 시험모드 상세정보 마스터
        /// </summary>
        public class MST_TEST_MODE_DTL_INFO
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_TEST_MODE_DTL_INFO";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "57";
        }

        /// <summary>
        /// 시험모드 상세 위치
        /// </summary>
        public class MST_TEST_MODE_DTL_LOC
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_TEST_MODE_DTL_LOC";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "58";
        }

        /// <summary>
        /// 결제할인 마스터
        /// </summary>
        public class MST_PAY_DC
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PAY_DC";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "59";
        }

        /// <summary>
        /// 결제할인 쿠폰 마스터
        /// </summary>
        public class MST_PAY_DC_CPN
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PAY_DC_CPN";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "60";
        }

        /// <summary>
        /// 결제할인 쿠폰 상품 마스터
        /// </summary>
        public class MST_PAY_DC_CPN_ITEM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PAY_DC_CPN_ITEM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "61";
        }

        /// <summary>
        /// 기간 제휴사 할인 상품 마스터
        /// </summary>
        public class MST_TERM_COOP_CMP_DC_ITEM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_TERM_COOP_CMP_DC_ITEM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "62";
        }

        /// <summary>
        /// 기간 제휴사 결제 상품 마스터
        /// </summary>
        public class MST_TERM_COOP_CMP_PAY_DC
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_TERM_COOP_CMP_PAY_DC";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "63";
        }

        /// <summary>
        /// 카드 PREFIX 마스터
        /// </summary>
        public class MST_CARD_PREFIX
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_CARD_PREFIX";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "64";
        }

        /// <summary>
        /// 결제 할인 PREFIX 마스터
        /// </summary>
        public class MST_PAY_DC_PRFX
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PAY_DC_PRFX";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "65";
        }

        /// <summary>
        /// 복합매장점포 마스터
        /// </summary>
        public class MST_COMPLEX_SHOP_STOR
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_COMPLEX_SHOP_STOR";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "66";
        }

        /// <summary>
        /// 입출금 계정 코드 마스터
        /// </summary>
        public class MST_DPST_WTHDR_ACC
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_DPST_WTHDR_ACC";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "67";
        }

        /// <summary>
        /// POS 다운 TABLE LIST 마스터
        /// </summary>
        public class MST_POSMST_TABLE_LST
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_POSMST_TABLE_LST";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "68";
        }

        /// <summary>
        /// 상품 조회 조건_금액 마스터
        /// </summary>
        public class MST_PLU_AMT
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PLU_AMT";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "69";
        }

        /// <summary>
        /// 상품 조회 조건_상품 마스터
        /// </summary>
        public class MST_PLU_NM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PLU_NM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "70";
        }

        /// <summary>
        /// 외부 업체 상품 마스터
        /// </summary>
        public class MST_OUT_SD_VEND_ITEM
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_OUT_SD_VEND_ITEM";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "71";
        }

        /// <summary>
        /// 점포점검 스케쥴 마스터
        /// </summary>
        public class MST_STOR_INSPCT
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_STOR_INSPCT";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "72";
        }

        /// <summary>
        /// 점포점검내역 그룹 마스터
        /// </summary>
        public class MST_SALESORG_INSPCT_GRP
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_SALESORG_INSPCT_GRP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "73";
        }

        /// <summary>
        /// 점포점검내역 상세 마스터
        /// </summary>
        public class MST_SALESORG_INSPCT_DTL
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_SALESORG_INSPCT_DTL";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "74";
        }

        /// <summary>
        /// 영수증 설문조사 메시지 마스터
        /// </summary>
        public class MST_SALESORG_SURVY_MSG
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_SALESORG_SURVY_MSG";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "75";
        }

        /// <summary>
        /// 할인 상세 마스터
        /// </summary>
        public class MST_DC_DTL
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_DC_DTL";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "76";
        }

        /// <summary>
        /// 중국 선불카드 마스터
        /// </summary>
        public class MST_PRECARD
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_PRECARD";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "77";
        }

        /// <summary>
        /// 점포 일일 장비 점검 마스터
        /// </summary>
        public class MST_STR_DAILY_INSPCT_LIST
        {
            /// <summary>
            /// 테이블ID
            /// </summary>
            public const string ID = "MST_STR_DAILY_INSPCT_LIST";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "78";
        }

        /// <summary>
        /// 카드사 마스터
        /// </summary>
        public class MST_CARD_CMP
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "MST_CARD_CMP";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "79";
        }

        /// <summary>
        /// 온라인 쿠폰 마스터
        /// </summary>
        public class MST_ONLINE_CPN
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "MST_ONLINE_CPN";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "80";
        }

        /// <summary>
        /// 외부I/F 점포 코드 관리 마스터
        /// </summary>
        public class MST_OUT_SD_VEND_STOR
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "MST_OUT_SD_VEND_STOR";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "81";
        }

        /// <summary>
        /// 레시피 마스터
        /// </summary>
        public class MST_KTCH_ITEM_INFO
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "MST_KTCH_ITEM_INFO";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "82";
        }


        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
        /// <summary>
        /// 온라인 쿠폰 제품군 마스터 MST_CPN_ITEM_GRP_MNG
        /// </summary>
        public class MST_CPN_ITEM_GRP_MNG
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "MST_CPN_ITEM_GRP_MNG";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "83";
        }
        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
        /// <summary>
        /// 온라인 쿠폰 제품군 상세 마스터 MST_CPN_ITEM_GRP_MNG_DTL
        /// </summary>
        public class MST_CPN_ITEM_GRP_MNG_DTL
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "MST_CPN_ITEM_GRP_MNG_DTL";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "84";
        }
        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

        //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start, 20180510
        
        /// <summary>
        /// 고객 구매이력 조회 마스터 STR_SEND_CPN_MST
        /// </summary>
        public class STR_SEND_CPN_MST
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "STR_SEND_CPN_MST";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "85";
        }

        /// <summary>
        /// 고객 구매이력 조회 상세(발송 쿠폰) STR_SEND_CPN_DTL
        /// </summary>
        public class STR_SEND_CPN_DTL
        {
            /// <summary>
            /// 테이블 ID
            /// </summary>
            public const string ID = "STR_SEND_CPN_DTL";
            /// <summary>
            /// 마스터 요청 구분
            /// </summary>
            public const string DIV = "86";
        }

        //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end, 20180510
    }
}
