﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : DLL 및 클래스 정의
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Common
{
    /// <summary>
    /// 서비스 목록(DLL 목록)
    /// </summary>
    public class ServiceLists
    {
        /// <summary>
        /// 네트워크 에이전트
        /// </summary>
        public class AGENT_NETWORK
        {
            public const string DLL = "Agent.Network";
            /// <summary>
            /// 소켓통신 처리
            /// </summary>
            public const string NETWORK_IRT = "NetworkIRT";
            /// <summary>
            /// FTP 처리
            /// </summary>
            public const string NETWORK_FTP = "NetworkFTP";
            /// <summary>
            /// JSON 통신 처리
            /// </summary>
            public const string NETWORK_JSON = "NetworkJSON";
            /// <summary>
            /// SPCN VAN 통신 처리
            /// </summary>
            public const string NETWORK_VAN_SPCN = "NetworkVanSPCN";
            /// <summary>
            /// HTTP 처리
            /// </summary>
            public const string NETWORK_HTTP = "NetworkHttp"; 
        }

        /// <summary>
        /// 서버 체크 데몬
        /// </summary>
        public class AGENT_NETWORK_CHECKOVER
        {
            public const string DLL = "Agent.NetworkCheckOver";
            /// <summary>
            /// 주기적으로 업무 갱신 여부 조회 처리
            /// </summary>
            public const string NetworkCheckOver = "NetworkCheckOver";
        }

        /// <summary>
        /// 네트워크 트란전송 에이전트
        /// </summary>
        public class AGENT_NETWORK_TRANSEND
        {
            public const string DLL = "Agent.NetworkTranSend";
            /// <summary>
            /// Tran/Journal/Sign 전송 처리
            /// </summary>
            public const string NetworkTranSend = "NetworkTranSend";
        }

        /// <summary>
        /// 데이터베이스 에이전트
        /// </summary>
        public class AGENT_DATABASE
        {
            public const string DLL = "Agent.Database";
            /// <summary>
            /// MS SQL
            /// </summary>
            public const string DATABASE_MSSQL = "DatabaseMssql";
            /// <summary>
            /// ORACLE
            /// </summary>
            public const string DATABASE_ORACLE = "DatabaseOracle";

        }

        /// <summary>
        /// KDS 에이전트
        /// </summary>
        public class AGENT_KDS
        {
            public const string DLL = "Agent.KDS";

            public const string KDS_MAIN = "KDSMain";
        }

        /// <summary>
        /// KPS 에이전트
        /// </summary>
        public class AGENT_KPS
        {
            public const string DLL = "Agent.KPS";

            public const string KPS_MAIN = "KPSMain";
        }

        /// <summary>
        /// Measuring 에이전트
        /// </summary>
        public class AGENT_MEASURING
        {
            public const string DLL = "Agent.Measuring";

            public const string MEASURING_MAIN = "MeasuringMain";
        }

        /// <summary>
        /// Background Down 에이전트
        /// </summary>
        public class AGENT_BACKGROUND_DOWN
        {
            public const string DLL = "Agent.BackgroundDown";

            public const string BACKGROUND_DOWN_MAIN = "BackgroundDownMain";
        }

        /// <summary>
        /// IFO 거래 외부 인터페이스
        /// </summary>
        public class AGENT_TranInterfaceOutside
        {
            public const string DLL = "Agent.TranInterfaceOutside";

            public const string TIFO_MAIN = "TranInterfaceOutside";
        }

        /// <summary>
        /// 디바이스 에이전트
        /// </summary>
        public class AGENT_OLEDEVICE
        {
            public const string DLL = "Agent.OLEDevice";
            /// <summary>
            /// Cashdrawer(본체연결, 프린터연결)
            /// </summary>
            public const string DEVICE_CASHDRAWER = "DeviceCashdrawer";
            /// <summary>
            /// 주방용 네트워크 프린터
            /// </summary>
            public const string DEVICE_FOODPRINTER = "DeviceFoodPrinter";
            /// <summary>
            /// LineDisplay
            /// </summary>
            public const string DEVICE_LINEDISPLAY = "DeviceLineDisplay";
            /// <summary>
            /// Msr
            /// </summary>
            public const string DEVICE_MSR = "DeviceMsr";
            /// <summary>
            /// PosPrinter
            /// </summary>
            public const string DEVICE_POSPRINTER = "DevicePosPrinter";
            /// <summary>
            /// Scanner(핸드 스캐너)
            /// </summary>
            public const string DEVICE_SCANNER = "DeviceScanner";
            /// <summary>
            /// 수표조회기
            /// </summary>
            public const string DEVICE_SUPYO = "DeviceSupyo";
            /// <summary>
            /// 통합동글
            /// </summary>
            public const string DEVICE_UNIDONGLE = "DeviceUniDongle";
            /// <summary>
            /// CAT 단말기
            /// </summary>
            public const string DEVICE_CATTERMINAL = "DeviceCatTerminal";
            /// <summary>
            /// IC 리더기
            /// </summary>
            public const string DEVICE_ICREADER = "DeviceICReader";
            /// <summary>
            /// 사인패드
            /// </summary>
            public const string DEVICE_SIGNPAD = "DeviceSignPad";
            /// <summary>
            /// 유선저율(PB 한매장에서 사용)
            /// </summary>
            public const string DEVICE_SCALE = "DeviceScale";
            ///// <summary>
            ///// 무선저울(BR사용)
            ///// </summary>
            //public const string DEVICE_WIRELESSSCALE = "DeviceWirelessScale";
            /// <summary>
            /// 라벨프린터
            /// </summary>
            public const string DEVICE_LABELPRINTER = "DeviceLabelPrinter";
            /// <summary>
            /// 아워홈
            /// </summary>
            public const string DEVICE_OURHOME = "DeviceOurHome";
            /// <summary>
            /// T페이 BLE 동글 
            /// </summary>
            public const string DEVICE_TPAYGLE = "DeviceTPaygle";
            /// <summary>
            /// OCB 직통신
            /// </summary>
            public const string OCB_DIRECT = "OCBDirect";
        }

        /// <summary>
        /// 고객용 화면 처리
        /// </summary>
        public class ASV_CUSTDISPLAY
        {
            public const string DLL = "Asv.CustDisplay";

            /// <summary>
            /// 고객용 화면 처리
            /// </summary>
            public const string CUST_DISPLAY = "CustDisplay";
        }

        /// <summary>
        /// 거래데이터 관리/생성, 정산데이터생성, 영수증 출력
        /// </summary>
        public class ASV_DATA_PROCESS
        {
            public const string DLL = "Asv.DataProcess";
            /// <summary>
            /// 거레합계, 데이터관리
            /// </summary>
            public const string DATA_SERVICE = "DataService";
            /// <summary>
            /// 거래로그 생성
            /// </summary>
            public const string MAKE_TRANLOG = "MakeTranLog";
            /// <summary>
            /// 정산데이터 생성
            /// </summary>
            public const string POS_SALE_EXACT = "PosSaleExact";
            /// <summary>
            /// 거래완료 처리
            /// </summary>
            public const string SALE_COMPLETE = "SaleComplete";
            /// <summary>
            /// 공통 함수
            /// </summary>
            public const string DATA_COMMON = "DataCommon";
            /// <summary>
            /// 영수증 출력(판매)
            /// </summary>
            public const string POS_RECEIPT = "PosReceipt";
            /// <summary>
            /// 영수증 출력(개/폐점....)
            /// </summary>
            public const string POS_RECEIPTOPENCLOSE = "PosReceiptOpenClose";
            /// <summary>
            /// 주문서-영수증프린트로 출력
            /// </summary>
            public const string POS_RECEIPT_ORDERSHEET = "PosReceiptOrderSheet"; 
            /// <summary>
            /// 입출금 저장()
            /// </summary>
            public const string MAKE_SALELOG = "MakeSaleLog";

            //#20180202 결제영수증 발행 안해도 직전영수증 발행시 해당 영수증 출력 start
            /// <summary>
            /// 영수증 출력처리
            /// </summary>
            public const string POS_RECEIPT_BASE = "PosReceiptBase";
            //#20180202 결제영수증 발행 안해도 직전영수증 발행시 해당 영수증 출력 end
        }

        /// <summary>
        /// 마스터 조회, 거래데이터 저장
        /// </summary>
        public class ASV_MASTER
        {
            public const string DLL = "Asv.Master";

            /// <summary>
            /// 마스터 조회
            /// </summary>
            public const string POS_MASTER = "PosMaster";     

            /// <summary>
            /// 캐셔 마스터 조회
            /// </summary>
            public const string CASHIER_MASTER = "CashierMaster";

            /// <summary>
            /// 결제 할인 마스터 조회
            /// </summary>
            public const string PAY_DC_MASTER = "PayDcMaster";

        }
        /// <summary>
        /// 후불 서비스
        /// </summary>
        public class BSV_TABLE
        {
            public const string DLL = "Bsv.Table";

            public const string TABLE_SERVICE = "TableService";

            public const string RESERVATION_SERVICE = "ReservationService";
        }

        /// <summary>
        /// 개/폐점 서비스(프로그램시작/종료, 영업개시/종로,마감등록,정산집계표,캐셔ON/OFF, 입출금)
        /// </summary>
        public class BSV_OPEN_CLOSE
        {
            public const string DLL = "Bsv.OpenClose";
            /// <summary>
            /// 프로그램 시작
            /// </summary>
            public const string PROGRAM_START = "ProgramStart";
            ///// <summary>
            ///// 프로그램 종료 
            ///// </summary>
            //public const string PROGRAM_END = "ProgramEnd";
            /// <summary>
            /// 영업 개시
            /// </summary>
            public const string SALE_OPEN = "SaleOpen";
            ///// <summary>
            ///// 영업종료
            ///// </summary>
            //public const string SALE_CLOSE = "SaleClose";
            /// <summary>
            /// 환경설정(INI)파일저장(PosConfig, PosSaleInfo, PosDownInfo)
            /// </summary>
            public const string SAVE_CONFIGINFO = "SaveConfigInfo";
            /// <summary>
            /// 환경설정(INI)파일 및 기본 마스터 로딩
            /// </summary>
            public const string READ_CONFIGINFO = "ReadConfigInfo";
            /// <summary>
            /// 캐셔 로그온
            /// </summary>
            public const string CASHIER_LOG_ON = "CashierLogOn";
            ///// <summary>
            ///// 캐셔 로그오프
            ///// </summary>
            //public const string CASHIER_LOG_OFF = "CashierLogOff";
            /// <summary>
            /// 기본마스터 로딩 처리
            /// </summary>
            public const string LOAD_MASTER_INFO = "LoadMasterInfo";
            /// <summary>
            /// 입출금 처리
            /// </summary>
            public const string ACC_REMONEY = "AccRemoney";
            /// <summary>
            /// 주변장치 점검
            /// </summary>
            public const string DEVICE_SERVICE = "DeviceService";
            /// <summary>
            /// 기타입출금 처리
            /// </summary>
            public const string ACC_ETC_INOUT = "AccEtcInout";
            /// <summary>
            /// 마감입금
            /// </summary>
            public const string ACC_ADMT = "AccADMT";
            /// <summary>
            /// 점검항목 체크
            /// </summary>
            public const string STORE_CHECK = "StoreCheck";
            /// <summary>
            /// 준비점검 공지사항
            /// </summary>
            public const string PREP_STOR_NOTICE = "PrepStorNotice";
            /// <summary>
            /// 도로공사 I/F
            /// </summary>
            public const string CAL_DATA_IF = "CalDataIF";
            /// <summary>
            /// 점포장비 점검(PB)
            /// </summary>
            public const string STORE_EQUIP_CHECK = "StoreEquipCheck";
        }

        /// <summary>
        /// 결제서비스 
        /// </summary>
        public class BSV_PAYMENT
        {
            public const string DLL = "Bsv.Payment";
            /// <summary>
            /// 현금 결제
            /// </summary>
            public const string CASH = "Cash";
            /// <summary>
            /// 신용카드 결제
            /// </summary>
            public const string CREDITCARD = "CreditCard";
            /// <summary>
            /// 신용카드 결제 - MSR
            /// </summary>
            public const string MSRCARD = "MSRCard";
            /// <summary>
            /// 현금영수증
            /// </summary>
            public const string CASHBILL = "CashBill";
            /// <summary>
            /// 해피포인트 적립
            /// </summary>
            public const string POINTHAPPYPOINT = "PointHappyPoint";
            /// <summary>
            /// 해피포인트 사용
            /// </summary>
            public const string POINTHAPPYPOINTUSE = "PointHappyPointUse";
            /// <summary>
            /// 해피포인트 쿠폰
            /// </summary>
            public const string POINTHAPPYCOUPON = "PointHappyCoupon";
            /// <summary>
            /// 통신사(SKT,KT,LGT) 할인
            /// </summary>
            public const string POINTMOBILECOM = "PointMobileCom";
            /// <summary>
            /// 제휴포인트 사용(OCB,OILBANK,BLUE MEMBER...)
            /// </summary>
            public const string POINTMEMBERUSE = "PointMemberUse";
            /// <summary>
            /// SPC 임직원 할인
            /// </summary>
            public const string SPCEMPLOYEEDC = "SPCEmployeeDC";
            /// <summary>
            /// SPC 임직원 결제
            /// </summary>
            public const string SPCEMPLOYEEUSE = "SPCEmployeeUse";
            /// <summary>
            /// SPC 임직원 할인 - 중국
            /// </summary>
            public const string SPCEMPLOYEEDC_CHINA = "SPCEmployeeDC_China";
            /// <summary>
            /// 쿠폰할인
            /// </summary>
            public const string COUPONDC = "CouponDC";
            /// <summary>
            /// 식권
            /// </summary>
            public const string MEALTICKET = "MealTicket";
            /// <summary>
            /// 케익교환권
            /// </summary>
            public const string CAKECHANGE = "CakeChange";
            /// <summary>
            /// 잔액교환권
            /// </summary>
            public const string EXCHANGETICKET = "ExchangeTicket";
            /// <summary>
            /// 상품권
            /// </summary>
            public const string GIFT = "Gift";
            /// <summary>
            /// 상품권 승인
            /// </summary>
            public const string GIFT_APP = "GiftApp";
            /// <summary>
            /// 입점매장직원할인
            /// </summary>
            public const string iNStorDC = "iNStorDC";
            /// <summary>
            /// 알리페이
            /// </summary>
            public const string ALIPAY = "AliPay";
            /// <summary>
            /// 세브란스병원 임직원 할인
            /// </summary>
            public const string SEVERANCEDC = "SeveranceDC";
            /// <summary>
            /// 모바일쿠폰
            /// </summary>
            public const string MOBILECOUPON = "MobileCoupon";
            /// <summary>
            /// 모바일쿠폰 - 해피콘
            /// </summary>
            public const string MOBILECOUPON_HAPPYCON = "MobileCouponHappyCon";
            /// <summary>
            /// 삼성포인트
            /// </summary>
            public const string POINTSAMSUNG = "PointSamsung";
            /// <summary>
            /// 외상
            /// </summary>
            public const string SALEONCUSTOMER = "SaleOnCustomer";
            /// <summary>
            /// 외화
            /// </summary>
            public const string FOREIGN = "Foreign";
            /// <summary>
            /// 선불카드
            /// </summary>
            public const string PREPAIDCARD = "PrepaidCard";
            /// <summary>
            /// 해피 기프트 사용
            /// </summary>
            public const string HAPPYGIFTUSE = "HappyGiftUse";
            /// <summary>
            /// 해피 기프트 충전
            /// </summary>
            public const string HAPPYGIFTRECHANGE = "HappyGiftReChange";
            /// <summary>
            /// T-Money/ CashBee
            /// </summary>
            public const string TMONEY = "TMoney";
            /// <summary>
            /// 아워홈
            /// </summary>
            public const string OURHOME = "OurHome";           

            /// <summary>
            /// 다운로드 ,DN 거래
            /// </summary>
            public const string VANSPCNCOMMON = "VanSpcnCommon";
            /// <summary>
            /// 결제취소 공통 클래스
            /// </summary>
            public const string PAYMENTCANCEL = "PaymentCancel";
            /// <summary>
            /// 예약 결제
            /// </summary>
            public const string RESERVED_PAY = "ReservedPay";
            /// <summary>
            /// 해피포인트 사후적립
            /// </summary>
            public const string POINTHAPPYPOINTAFTER = "PointHappyPointAfter";
            /// <summary>
            /// 해피포인트 단골매장등록
            /// </summary>
            public const string POINTHPREGULARCUST = "PointHPRegularCust";
            /// <summary>
            /// 해피오더(온라인결제)
            /// </summary>
            public const string HAPPYORDER = "HappyOrder";
            /// <summary>
            /// 배달(콜센터,배달의민족)
            /// </summary>
            public const string SALEDELIVERY = "SaleDelivery";
            /// <summary>
            /// 해피포인트 사용 - 중국
            /// </summary>
            public const string POINTHAPPYPOINT_USE_CHINA = "PointHappyPointUse_China";
            /// <summary>
            /// 해피포인트 적립 - 중국
            /// </summary>
            public const string POINTHAPPYPOINT_SAVE_CHINA = "PointHappyPointSave_China";
            /// <summary>
            /// 해피포인트 적립 - 중국
            /// </summary>
            public const string PREPAIDCARD_CHINA = "PrepaidCard_China";
            /// <summary>
            /// OCB 적립
            /// </summary>
            public const string PNT_OCB_SAVE = "PointOcbSave";
            /// <summary>
            /// 스마일페이
            /// </summary>
            public const string SMAILPAY = "SmilePay";
            /// <summary>
            /// T페이
            /// </summary>
            public const string TPAY = "TPay";
            /// <summary>
            /// 온라인쿠폰(중국)
            /// </summary>
            public const string ONLINE_COUPON = "OnLineCoupon";
            /// <summary>
            /// 온라인쿠폰 발행(중국)
            /// </summary>
            public const string ONLINE_COUPON_PRT = "OnLineCouponPrt";
            /// <summary>
            /// 중국 알리페이/위챗페이
            /// </summary>
            public const string WECHATPAY = "WeChatPay";

            
            /// <summary
            /// 중국 위챗페이(바이롱)
            /// </summary>
            public const string WECHATPAY_BAIRONG = "WeChatPay_BaiRong";//girak.kim,2017.09.11.001

            /// <summary
            /// 중국 위챗페이/샤오청쉬
            /// </summary>
            public const string XIAOCHENGXU_GIFT_CARD = "XiaoChengxuGiftCard";//girak.kim,2017.09.11.001

            

            /// <summary>
            /// 삼성패밀리카드(SFC)할인
            /// </summary>
            public const string SAMSUNG_FAMILY_CARD = "SamsungFamilyCard";
            /// <summary>
            /// 결제할인마스터 참조 할인처리(카이스트할인,해피오더사전예약할인)
            /// </summary>
            public const string PAYDCMST_TO_DC = "PayDcMstToDc";
            //#20170731, 해피기프트카드(코나머니) 개발 Start, srlee
            /// <summary>
            /// 해피기프트카드(코나머니)
            /// </summary>
            public const string HPGIFTCARD = "HappyGiftCard";
            //#20170731, 해피기프트카드(코나머니) 개발 End, srlee

            // #Rhee, 20170922 중국 은련페이 추가 start
            /// <summary>
            /// 중국 은련페이
            /// </summary>
            public const string UNIONPAY = "UnionPay";
            // #Rhee, 20170922 중국 은련페이 추가 end

            //#20171227 인천공항 포스연동 start, phj
            /// <summary>
            /// 인천공항 포스연동
            /// </summary>
            public const string AIRPORT_TRAN = "AirPortTran";
            //#20171227 인천공항 포스연동 end, phj

            // grayber@20180115 인천공항 VIP 라운지 start - 결제 서비스 추가
            /// <summary>
            /// 인천공항 VIP 라운지
            /// </summary>
            public const string VIP_LOUNGE = "VipLounge";
            // grayber@20180115 인천공항 VIP 라운지 end

            //grayber@20180208 코레일 마일리지 입력 start - 결제 관련 서비스 리스트 추가
            /// <summary>
            /// 코레일 마일리지 입력
            /// </summary>
            public const string KORAIL_MAILEAGE = "KorailMileage";
            //grayber@20180208 코레일 마일리지 입력 end


            /// <summary>
            /// 미국 펀치 API 해피 포인트
            /// </summary>
            public const string PUNCHH_HAPPYPOINT_US = "PunchhHappyPoint_US";//girak.kim,2018.02.23

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start
            /// <summary>
            /// 쿠폰 발행
            /// </summary>
            public const string CPN_SEND = "CpnSend";
            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end

            //#20180413 웰컴카드 신규기능 추가 start,phj
            /// <summary>
            /// 웰컴카드 발급화면
            /// </summary>
            public const string WELCOMECARD_ISSUE = "WelcomCard";
            //#20180413 웰컴카드 신규기능 추가 end,phj
        }

        ///// <summary>
        ///// 고객클레임서비스 
        ///// </summary>
        //public class BSV_CUSTOMER
        //{
        //    public const string DLL = "Bsv.Customer";
        //    /// <summary>
        //    /// 고객불편사항조회처리
        //    /// </summary>
        //    public const string CustomerService = "CustomerService";
        //}

        /// <summary>
        /// 판매 등록
        /// </summary>
        public class BSV_SALE
        {
            public const string DLL = "Bsv.Sale";
            /// <summary>
            /// 상품 등록
            /// </summary>
            public const string SALE_PLU_ITEM = "SalePluItem";
            /// <summary>
            /// 세트 상품 구성
            /// </summary>
            public const string SALE_PLU_SET_MENU = "SalePluSetMenu";
            /// <summary>
            /// 영수증 반품 등록
            /// </summary>
            public const string SALE_REFUND = "SaleRefund";
            /// <summary>
            /// 해피포인트 사후 적립
            /// </summary>
            public const string HP_AFTER_SAVE = "HPAfterSave";
            /// <summary>
            /// 해피오더 내역 조회
            /// </summary>
            public const string HAPPY_ORDER_LIST = "HappyOrderList";
            /// <summary>
            /// 당일 거래 복구
            /// </summary>
            public const string SVR2TRAN = "Svr2Tran";
            /// <summary>
            /// 주방프린터 체크
            /// </summary>
            public const string KPS_CHECK = "KPSCheck";
            /// <summary>
            /// 해피버즈
            /// </summary>
            public const string HAPPYBUZZ = "HappyBuzz";
            /// <summary>
            /// 선불카드 판매 (중국)
            /// </summary>
            public const string SALEPRECARD = "SalePreCard";
            /// <summary>
            /// 예약
            /// </summary>
            public const string RESERVATION = "Reservation";
            /// <summary>
            /// 보류
            /// </summary>
            public const string HOLD_DEAL = "HoldDeal";
            // #20170616, 해피앱 스탬프 Start
            /// <summary>
            /// 해피앱 스탬프
            /// </summary>
            public const string HPAPP_STAMP = "HappyAppStamp";
            // #20170616, 해피앱 스탬프 End
        }

        /// <summary>
        /// 캠페인 등록
        /// </summary>
        public class ASV_CAMPAIGN
        {
            public const string DLL = "Asv.Campaign";
            /// <summary>
            /// 켐페인 실행
            /// </summary>
            public const string CAMPAIGN_MAIN = "CampaignMain";
        }

        /// <summary>
        /// 관리, 설정 
        /// </summary>
        public class BSV_ADMIN
        {
            public const string DLL = "Bsv.Admin";
            /// <summary>
            /// 시험모드
            /// </summary>
            public const string TEST_MODE = "TestMode";
            /// <summary>
            /// 간이영수증
            /// </summary>
            public const string ETC_RECEIPT = "EtcReceipt";
            /// <summary>
            /// 고객불만사항
            /// </summary>
            public const string CUSTOMER_CLAIM = "CustomerClaim";
            /// <summary>
            /// 관공서 방문알림 등록
            /// </summary>
            public const string VISIT_GOVERNMENT = "VisitGovernment";
            /// <summary>
            /// PVC 재고등록
            /// </summary>
            public const string ETC_PVC = "EtcPvc";
            /// <summary>
            /// 자료조회
            /// </summary>
            public const string DATASEARCH = "DataSearch";
            /// <summary>
            /// POS스펙전송
            /// </summary>
            public const string POS_SPEC = "PosSpec";
            /// <summary>
            /// 무결성 관리
            /// </summary>
            public const string INTEGRITY = "Integrity";
            /// <summary>
            /// 주변장치 업데이트
            /// </summary>
            public const string DEVICEUPDATE = "DeviceUpdate";
            /// <summary>
            /// 매출 재전송
            /// </summary>
            public const string TRAN_RESEND = "TranResend";
            /// <summary>
            /// POS CONFIG 송/수신
            /// </summary>
            public const string POS_CONFIG = "PosConfigSync";
            /// <summary>
            /// 외부업체 매출재전송
            /// </summary>
            public const string RESEND_TRAN_TO_OUTSIDE = "ResendTranToOutside";
        }
        
        /// <summary>
        /// 판매 기본
        /// </summary>
        public class BSV_BASIC
        {
            public const string DLL = "Bsv.Basic";
            ///// <summary>
            ///// 예약
            ///// </summary>
            //public const string RESERVED_FINSH = "ReservedFinsh";
            /// <summary>
            /// 영수증 조회
            /// </summary>
            public const string SALE_RECEIPT = "SaleReceipt";
            /// <summary>
            /// 해피기프트 조회/충전/취소/판매
            /// </summary>
            public const string HP_GIFT_CHARGE = "HpGift";
            ///// <summary>
            ///// 웹 업무
            ///// </summary>
            //public const string WEB_BIZ = "WebBiz";
            /// <summary>
            /// 웹 업무
            /// </summary>
            public const string WEB_POS = "WebPos";
            /// <summary>
            /// 행사주문취합내역조회
            /// </summary>
            public const string SCH_EVT = "SchEvt";
            /// <summary>
            /// 본사반품내역조회
            /// </summary>
            public const string SCH_RETURN_COMPANY = "SchReturnCompany";
            /// <summary>
            /// 해피포인트추후적립내역조회
            /// </summary>
            public const string SCH_HP_LATE = "SchHpLate";
            /// <summary>
            /// 점착정보
            /// </summary>
            public const string SCH_STOR_ARRV_INFO = "SchStorArrvInfo";
            /// <summary>
            /// 주방주문내역조회
            /// </summary>
            public const string SCH_KTCH_ORDER = "SchKtchOrder";
            /// <summary>
            /// 마스터 다운로드 처리
            /// </summary>
            public const string MASTER_DOWN = "MasterDown";
            /// <summary>
            /// 서명패드 업데이트 처리
            /// </summary>
            public const string SIGNPAD_UPDATE = "SignPadUpdate";
            //#20171016 IC리더기 펌웨어 업데이트 Start, srlee
            /// <summary>
            /// IC리더기 업데이트 처리
            /// </summary>
            public const string ICREADER_UPDATE = "ICReaderUpdate";
            //#20171016 IC리더기 펌웨어 업데이트 End, srlee
            /// <summary>
            /// 직원 출/퇴근 등록
            /// </summary>
            public const string EMP_COMMUTE = "EmpCommute";
            /// <summary>
            /// 직원방문등록
            /// </summary>
            public const string ETC_IN_EMP = "EtcInEmp";
            /// <summary>
            /// POS 공지사항 공통
            /// </summary>
            public const string POS_NOTICE_COM = "PosNoticeCom";
            /// <summary>
            /// 온도정보
            /// </summary>
            public const string TEMP_INFO = "TempInfo";
            /// <summary>
            /// 출하/예정 내역
            /// </summary>
            public const string SCH_SHIPMENT = "SchShipment";
            /// <summary>
            /// 디지털메뉴보드 I/F
            /// </summary>
            public const string DMB_IF = "DmbIF";
            /// <summary>
            /// 매입처 조회
            /// </summary>
            public const string VENDER_SEARCH = "VenderSearch";
        }

    }
}
