﻿using System;
using System.Collections;
using System.Text;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 해피 기프트
// 작  성  자 : 
// 변경  이력 :  
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class HappyGift : PaymentBase, IPaymentUs
    {
        #region 변수 설정 및 생성자
        // 접속정보
        private IDataCommonUs m_cDataCommon = null;
        private string[] aIrtRsp_Search = null;

        public HappyGift()
        {
            m_cDataCommon = (IDataCommonUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_COMMON);
        }
        #endregion 

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            string sRet = UserCom.RST_ERR;


            string sPosMenuKey = "", sWCC = "", sInPutData = "", sCardData = "", sApprNo = "", sApprDate = "", sApprTime = "", sReqNo = "", sTrType = "";
            double nPayAmt = 0;
                        
            try
            {
                sPosMenuKey = aParam[0];                                                                         // 메뉴키
                sWCC = aParam[1];                                                                                // 입력구분
                sInPutData = aParam[2];                                                                          // 입력데이터
                sCardData = aParam[3];                                                                           // 카드데이터
                nPayAmt = CmUtil.DoubleParse(aParam[4]);                                                         // 대상금액

                sApprNo = aParam[6];                                                                             // 승인번호
                sApprDate = DateTime.Now.ToString("yyyyMMdd");                                                   // 승인일자
                sApprTime = DateTime.Now.ToString("HHmmss");                                                     // 승인시간

                sReqNo = "";                                                                                     // 수신자 번호

                m_cPayItem = new Column.TR_PAYMENT.DATA();                                                              // 결과 저장 변수 생성

                m_cPayItem.PAY_WAY_CD = aParam[8];                                                                      // 결제수단
                m_cPayItem.PAY_DTL_CD_01 = aParam[9];                                                                   // 상세코드

                sTrType = PosConst.POS_HAPPYGIFT_INQ_TYPE.SEARCH;                                                // 전문구분                

                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sWCC, sInPutData, sCardData, sReqNo, nPayAmt, 0, 0, "", "", "", "");
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);

                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            return m_cPayItem;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록 
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sTrType = null;

            string sPosMenuKey = "", sWCC = "", sInPutData = "", sCardData = "", sApprNo = "", sApprDate = "", sApprTime = "", sReqNo = "";
            double nPayAmt = 0;


            try
            {
                sPosMenuKey = aParam[0];                                                                         // 메뉴키
                sWCC = aParam[1];                                                                                // 입력구분
                sInPutData = aParam[2];                                                                          // 입력데이터
                sCardData = aParam[3];                                                                           // 카드데이터
                nPayAmt = CmUtil.DoubleParse(aParam[4]);                                                         // 대상금액

                sApprNo = aParam[6];                                                                             // 승인번호

                sApprDate = DateTime.Now.ToString("yyyyMMdd");                                                   // 승인일자
                sApprTime = DateTime.Now.ToString("HHmmss");                                                     // 승인시간

                m_cPayItem = new Column.TR_PAYMENT.DATA();                                                              // 결과 저장 변수 생성

                m_cPayItem.PAY_WAY_CD = aParam[8];                                                                      // 결제수단
                m_cPayItem.PAY_DTL_CD_01 = aParam[9];                                                                   // 상세코드

                sTrType = PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL;                                                     // 전문구분                
                // 승인요청
                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sWCC, sInPutData, sCardData, "", nPayAmt, 0, 0, sApprDate, sApprNo, sApprTime, "");
                if (sRet != UserCom.RST_OK)
                {
                    sTrType = PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL_CANCEL;                                          // 전문구분                
                    // 망취소 요청
                    sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sWCC, sInPutData, sCardData, "", nPayAmt, 0, 0, sApprDate, sApprNo, sApprTime, "2");
                    if (sRet != UserCom.RST_OK) return sRet;

                    return sRet;
                }

                // 결제 아이템 추가
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);                     // 결제 내역 받아 오기
                m_cPayItem.SEQ = alPayItem.Count + 1;
                alPayItem.Add(m_cPayItem);

                m_cDataService.UpdatePluAmount();                                                                       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();                                                                       // 결제 금액 재 계산 처리
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);

                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sTrType = null;


            string sWCC = "", sInPutData = "", sCardData = "", sApprNo = "", sApprDate = "", sApprTime = "", sReqNo = "", sCancelType="";
            double nPayAmt = 0, nBeforeAmt = 0, nAfterAmt = 0;

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return sRet;

                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                sCancelType = aParam[1];                                                                         // 취소구분 (1:강제취소 2:망취소)
                sWCC = m_cPayItem.OCCUR_ENTRY_05;                                                                // 입력구분
                sInPutData = m_cPayItem.OCCUR_ENTRY_01;                                                          // 입력데이터
                sCardData = m_cPayItem.OCCUR_ENTRY_22;                                                           // 카드데이터
                nPayAmt = m_cPayItem.AMT_ENTRY_01;                                                               // 대상금액
                nBeforeAmt = m_cPayItem.AMT_ENTRY_03;                                                            // 거래전잔액
                nAfterAmt = m_cPayItem.AMT_ENTRY_04;                                                             // 거래후잔액
                sApprDate = m_cPayItem.OCCUR_ENTRY_03;                                                           // 승인일자
                sApprNo = m_cPayItem.OCCUR_ENTRY_02;                                                             // 승인번호
                sApprTime = m_cPayItem.OCCUR_ENTRY_04;                                                           // 승인시간
                sReqNo = "";                                                                                     // 수신자 번호

                sTrType = PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL_CANCEL;                                              // 전문구분                

                sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sWCC, sInPutData, sCardData, sReqNo, nPayAmt, nBeforeAmt, nAfterAmt, sApprDate, sApprNo, sApprTime, sCancelType);
                if (sRet != UserCom.RST_OK)
                {
                    sTrType = PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL_CANCEL;                                          // 전문구분                
                    // 망취소 요청
                    sCancelType = "2";
                    sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sWCC, sInPutData, sCardData, sReqNo, nPayAmt, nBeforeAmt, nAfterAmt, sApprDate, sApprNo, sApprTime, sCancelType);
                    if (sRet != UserCom.RST_OK) return sRet;
                }

                m_cPayItem.CANCEL_DIV = PosConst.CANCEL_DIV.CANCEL;

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                //WinManager.ConfirmMessage(sPointType + " " + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0068));

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);

                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sTrType = null;


            string sWCC = "", sInPutData = "", sCardData = "", sApprNo = "", sApprDate = "", sApprTime = "", sReqNo = "", sCancelType = "";
            double nPayAmt = 0, nBeforeAmt = 0, nAfterAmt = 0;

            try
            {
                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                if (m_cPayItem.OCCUR_ENTRY_08.ToString() != ItemConst.PAY_APP_DIV.NORMAL)
                {
                    //임의 등록 이면 승인 없이 데이터 처리
                    //WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0240));
                    m_cPayItem.OCCUR_ENTRY_06 = m_cPayItem.OCCUR_ENTRY_02;
                    m_cPayItem.OCCUR_ENTRY_07 = m_cPayItem.OCCUR_ENTRY_03;

                    sRet = UserCom.RST_OK;
                }
                else
                {
                    sCancelType = aParam[1];                                                                         // 취소구분 (1:강제취소 2:망취소)
                    sWCC = m_cPayItem.OCCUR_ENTRY_05;                                                                // 입력구분
                    sInPutData = m_cPayItem.OCCUR_ENTRY_01;                                                          // 입력데이터
                    sCardData = m_cPayItem.OCCUR_ENTRY_22;                                                           // 카드데이터
                    nPayAmt = m_cPayItem.AMT_ENTRY_01;                                                               // 대상금액
                    nBeforeAmt = m_cPayItem.AMT_ENTRY_03;                                                            // 거래전잔액
                    nAfterAmt = m_cPayItem.AMT_ENTRY_04;                                                             // 거래후잔액
                    sApprDate = m_cPayItem.OCCUR_ENTRY_03;                                                           // 승인일자
                    sApprNo = m_cPayItem.OCCUR_ENTRY_02;                                                             // 승인번호
                    sApprTime = m_cPayItem.OCCUR_ENTRY_04;                                                           // 승인시간
                    sReqNo = "";                                                                                     // 수신자 번호

                    sTrType = PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL_CANCEL;                                              // 전문구분                

                    sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sWCC, sInPutData, sCardData, sReqNo, nPayAmt, nBeforeAmt, nAfterAmt, sApprDate, sApprNo, sApprTime, sCancelType);
                    if (sRet != UserCom.RST_OK)
                    {
                        sTrType = PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL_CANCEL;                                          // 전문구분                
                        // 망취소 요청
                        sCancelType = "2";
                        sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sWCC, sInPutData, sCardData, sReqNo, nPayAmt, nBeforeAmt, nAfterAmt, sApprDate, sApprNo, sApprTime, sCancelType);

                    }
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);

                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region 조회 실행
        /// <summary>
        /// 조회 실행
        /// </summary>
        /// <param name="sTrType"></param>
        /// <param name="siNqType"></param>
        /// <param name="sWCC"></param>
        /// <param name="sInPutData"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <returns></returns>
        public string ExecuteIrt(string sTradeDiv, string sTrType, string sWCC, string sInPutData, string sCardData, string sReqNo, double nPayAmt, double nBeforeAmt, double nAfterAmt, string sApprDate, string sApprNo, string sApprTime, string sCancelType)
        {
            string sRet = UserCom.RST_ERR;
            string[] aIrtRspHDR = null;
            string[] aIrtRspDTL = null; 
            try
            {
                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1" ) return SetTrainingData(sTrType, sWCC, sInPutData, sReqNo, nPayAmt, nBeforeAmt, nAfterAmt, sApprDate, sApprNo, sApprTime, sCancelType);

                // 조회
                sRet = ExecuteSendRecv(sTradeDiv, sTrType, sWCC, sCardData, sReqNo, nPayAmt, sApprDate, sApprNo, sApprTime, sCancelType, ref aIrtRspHDR, ref aIrtRspDTL);
                if (sRet != UserCom.RST_OK) return sRet;

                // 결제구분 (1:결제, 2:할인)
                DataRow dr = PosMstManager.GetMstPayDc(new string[] { m_cPosStatus.Base.CmpCd, m_cPosStatus.Base.StoreNo, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01 });

                m_cPayItem.PAY_AMT = nPayAmt;

                if (m_cPayItem.PAY_AMT <= 0) return UserCom.RST_ERR;

                m_cPayItem.PAY_DTL_CD_02 = "";                                                                          // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "0";                                                                         // 할인금액 아이템 적용여부

                switch  (m_cPayItem.PAY_DTL_CD_01)
                {
                    case ItemConst.TR_ITEM_ID.PPCARD.HP_GIFT:
                        {
                            // --------------------------------------------------------------------------------------------------------------------------------
                            // 해피 기프트
                            // --------------------------------------------------------------------------------------------------------------------------------
                            if (sTrType != PosConst.POS_HAPPYGIFT_INQ_TYPE.SEARCH)
                            {
                                // 승인/취소 응답
                                if (aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.ErrCD].Trim() == "E0010")
                                    // 기취소
                                    m_cPayItem.OCCUR_ENTRY_02 = sApprNo;
                                else
                                    m_cPayItem.OCCUR_ENTRY_02 = aIrtRspDTL[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.ApprNo].Trim();                     // 승인번호

                                m_cPayItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyyyMMdd");                                                      // 승인일자
                                m_cPayItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmmss");                                                        // 승인시간 

                                m_cPayItem.AMT_ENTRY_04 = CmUtil.DoubleParse(aIrtRspDTL[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.BalanceAmt].Trim());   // 상품권잔액
                                m_cPayItem.OCCUR_ENTRY_11 = aIrtRspDTL[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.Exp_DT].Trim();                         // 유효기간
                            }
                            else
                            {
                                // 조회 응답
                                int nNowPos = 0;
                                aIrtRsp_Search = new string[Column.POS_RES_SEL_DTL_HAPPYGIFT.LEN.Length];
                                byte[] bData = Encoding.Default.GetBytes(aIrtRspDTL[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim());
                                ItemColumn.ParseMessage(Column.POS_RES_SEL_DTL_HAPPYGIFT.LEN, Column.POS_RES_SEL_DTL_HAPPYGIFT.TYPE, bData, ref nNowPos, ref aIrtRsp_Search);

                                m_cPayItem.OCCUR_ENTRY_10 = CmUtil.DoubleParse(aIrtRsp_Search[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.GiftBalAmt].Trim()).ToString(); // 상품권금액-최초충전금액
                                m_cPayItem.AMT_ENTRY_03 = CmUtil.DoubleParse(aIrtRsp_Search[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.GiftBalAmt].Trim());   // 상품권잔액
                                m_cPayItem.OCCUR_ENTRY_11 = aIrtRsp_Search[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.Exp_DT].Trim();                         // 유효기간
                                m_cPayItem.OCCUR_ENTRY_12 = aIrtRsp_Search[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.Reg_Dt].Trim();                         // 최초 등록일
                                m_cPayItem.OCCUR_ENTRY_13 = aIrtRsp_Search[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.Gift_State].Trim();                     // 상품권 상태 (00:대기,10:사용가능,20:만기)
                                m_cPayItem.OCCUR_ENTRY_14 = aIrtRsp_Search[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.ReChangeYN].Trim();                     // 충전가능여부

                                m_cPayItem.OCCUR_ENTRY_02 = "";                                                                                     // 승인번호
                                m_cPayItem.OCCUR_ENTRY_03 = "";                                                                                     // 승인일자
                                m_cPayItem.OCCUR_ENTRY_04 = "";                                                                                     // 승인시간
                            }
                            // --------------------------------------------------------------------------------------------------------------------------------
                            break;
                        }
                }

                m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.PAY;                                                    // 할인결제구분 (1:결제, 2:할인)
                m_cPayItem.AMT_ENTRY_01 = nPayAmt;                                                                      // 받은돈

                m_cPayItem.OCCUR_ENTRY_01 = sCardData;                                                                  // 카드번호
                m_cPayItem.OCCUR_ENTRY_05 = sWCC;                                                                       // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                                                                    // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                                                                  // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;                                               // 승인구분
                m_cPayItem.OCCUR_ENTRY_16 = CmUtil.GetDataRowStr(dr, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);              // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                m_cPayItem.OCCUR_ENTRY_22 = sCardData;
                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;                                                  // 빌분리 번호

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }

        /// <summary>
        /// 연습 데이터 설정
        /// </summary>
        /// <param name="sTrType"></param>
        /// <param name="siNqType"></param>
        /// <param name="sWCC"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <returns></returns>
        public string SetTrainingData(string sTrType, string sWCC, string sCardData, string sReqNo, double nPayAmt, double nBeforeAmt, double nAfterAmt, string sApprDate, string sApprNo, string sApprTime, string sCancelType)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 결제구분 (1:결제, 2:할인)
                DataRow dr = PosMstManager.GetMstPayDc(new string[] { m_cPosStatus.Base.CmpCd, m_cPosStatus.Base.StoreNo, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01 });

                // 연습모드이면 연습 데이터 설정
                m_cPayItem.PAY_AMT = nPayAmt;

                m_cPayItem.PAY_DTL_CD_02 = "";                                                                          // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "0";                                                                         // 할인금액 아이템 적용여부
                m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.PAY;                                                    // 할인결제구분 (1:결제, 2:할인)

                m_cPayItem.QTY_ENTRY_01 = 3;                                                                            // 무료횟수
                m_cPayItem.QTY_ENTRY_02 = 6;                                                                            // 총사용횟수

                m_cPayItem.AMT_ENTRY_01 = nPayAmt;                                                                      // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;                                                                            // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = nBeforeAmt;                                                                   // 총포인트
                m_cPayItem.AMT_ENTRY_04 = nAfterAmt;                                                                    // 가용포인트
                m_cPayItem.AMT_ENTRY_05 = 0;                                                                            // 잔여포인트
                m_cPayItem.AMT_ENTRY_08 = 0;

                m_cPayItem.OCCUR_ENTRY_01 = sCardData;                                                                  // 카드번호
                m_cPayItem.OCCUR_ENTRY_02 = "99999999";                                                                 // 승인번호
                m_cPayItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyMMdd");                                            // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmmss");                                            // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sWCC;                                                                       // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                                                                    // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                                                                  // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.COMPULSION;                                           // 승인구분
                m_cPayItem.OCCUR_ENTRY_09 = "";                                                                         // 직원카드번호
                m_cPayItem.OCCUR_ENTRY_10 = "";                                                                         // 대상 상품 코드
                m_cPayItem.OCCUR_ENTRY_11 = "";                                                                          
                m_cPayItem.OCCUR_ENTRY_16 = CmUtil.GetDataRowStr(dr, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);              // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                m_cPayItem.OCCUR_ENTRY_22 = sCardData;

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;                                                  // 빌분리 번호

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sCardData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region 승인 요청/응답
        /// <summary>
        /// 승인 요청/응답
        /// </summary>
        /// <param name="sTrType"></param>
        /// <param name="siNqType"></param>
        /// <param name="sWCC"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <param name="aIrtRsp"></param>
        /// <returns></returns>
        protected string ExecuteSendRecv(string sTradeDiv, string sTrType, string sWCC, string sCardData, string sReqNo, double nPayAmt, string sApprDate, string sApprNo, string sApprTime, string sCancelType,
                                                ref string[] aIrtRspHDR, ref string[] aIrtRspDTL)
        {
            string sSendData = "", sRecvData= "";         // 송수신 전문
            int nNowPos = 0;

            string sServerIP = "";
            string sServerPort = "";
            string sCMPApprID = "";
            string sApprID = "";
            int iRecvTimeOut = 10000;
            string sRecvAppNo = "";
            string sErrMsg = "";

            byte[] bytes = null;

            string sRet = UserCom.RST_ERR;
            try
            {
                if (m_cPayItem.PAY_WAY_CD != ItemConst.TR_ITEM_ID.PPCARD_ITEM) return null;

                // -----------------------------------------------------------------------------------------------------------------------------
                // VAN 정보 조회
                // -----------------------------------------------------------------------------------------------------------------------------
                if (m_cPayItem.OCCUR_ENTRY_16.Trim().Length != 0)
                {
                    // VAN_ID가 있는 경우 VAN_ID로 VAN 정보 조회
                    sServerIP = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.IP);
                    sServerPort = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.PORT);
                    sCMPApprID = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.CMP_APPR_ID);
                    sApprID = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.APPR_ID);
                }
                else
                {
                    // VAN_ID가 미정인 경우 결제수단으로 VAN 정보 조회
                    sServerIP = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.IP);
                    sServerPort = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.PORT);
                    sCMPApprID = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.CMP_APPR_ID);
                    sApprID = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.APPR_ID);
                }
                // -----------------------------------------------------------------------------------------------------------------------------

                if (sServerIP.Trim() == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0565);
                    return sRet;
                }

                // 전문 생성                
                sSendData = GetMakeiNQData(sTrType, sCancelType, sCardData, sReqNo, nPayAmt, sApprDate, sApprNo, sApprTime);

                // 요청 - 승인로그 저장   (판매구분, [0]결제수단, [1]결제상세코드, [2]전문구분, [3]요청구분, [4]카드번호, [5]결제금액, [6]승인번호, [7]승인일자, [8]승인시간, [9]응답상태값, [10]응답메시지, [11]전문)
                m_cDataCommon.SetSaleApprLog(sTradeDiv, new string[] { m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sTrType, "S", sCardData, nPayAmt.ToString(), "", "", "", "", "", sSendData });

                // 유형별 분기 처리
                switch (m_cPayItem.PAY_DTL_CD_01)
                {
                    case ItemConst.TR_ITEM_ID.PPCARD.HP_GIFT:                   // 해피 기프트
                        {
                            // 전문 송수신
                            sRet = m_cDataCommon.ExecuteLenIrt(sServerIP, CmUtil.IntParse(sServerPort), iRecvTimeOut, sSendData, ref sRecvData, 8, 0);
                            if (sRet != UserCom.RST_OK)
                            {
                                WinManager.ErrorMessage(sRet);
                                return sRet;
                            }

                            bytes = Encoding.Default.GetBytes(sRecvData);
                            aIrtRspHDR = new string[Column.POS_HDR_HAPPYGIFT.LEN.Length];

                            ItemColumn.ParseMessage(Column.POS_HDR_HAPPYGIFT.LEN, Column.POS_HDR_HAPPYGIFT.TYPE, bytes, ref nNowPos, ref aIrtRspHDR);

                            nNowPos = 0;
                            // - 'O00' : 승인 그외 : 거절, 기취소 (E0010)
                            if (aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.ResStatus].Trim() != "000")
                            {
                                if (aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.ErrCD].Trim() == "E0010")
                                {
                                    // 기타 오류
                                    bytes = Encoding.Default.GetBytes(CmUtil.MidH(sRecvData, 88, sRecvData.Length));
                                    aIrtRspDTL = new string[Column.POS_RES_ERR_DTL_HAPPYGIFT.LEN.Length];

                                    ItemColumn.ParseMessage(Column.POS_RES_ERR_DTL_HAPPYGIFT.LEN, Column.POS_RES_ERR_DTL_HAPPYGIFT.TYPE, bytes, ref nNowPos, ref aIrtRspDTL);

                                    sErrMsg = aIrtRspDTL[Column.POS_RES_ERR_DTL_HAPPYGIFT.SEQ.ErrMesg].Trim();
                                    sRet = aIrtRspDTL[Column.POS_RES_ERR_DTL_HAPPYGIFT.SEQ.ErrMesg].Trim();

                                    WinManager.ErrorMessage(sRet);

                                    sRet = UserCom.RST_OK; 
                                }
                                else
                                {
                                    // 기타 오류
                                    bytes = Encoding.Default.GetBytes(CmUtil.MidH(sRecvData, 88, sRecvData.Length));
                                    aIrtRspDTL = new string[Column.POS_RES_ERR_DTL_HAPPYGIFT.LEN.Length];

                                    ItemColumn.ParseMessage(Column.POS_RES_ERR_DTL_HAPPYGIFT.LEN, Column.POS_RES_ERR_DTL_HAPPYGIFT.TYPE, bytes, ref nNowPos, ref aIrtRspDTL);

                                    sErrMsg = aIrtRspDTL[Column.POS_RES_ERR_DTL_HAPPYGIFT.SEQ.ErrMesg].Trim();
                                    sRet = aIrtRspDTL[Column.POS_RES_ERR_DTL_HAPPYGIFT.SEQ.ErrMesg].Trim();

                                    WinManager.ErrorMessage(sRet);
                                }

                                // 응답 - 승인로그 저장   (판매구분, [0]결제수단, [1]결제상세코드, [2]전문구분, [3]요청구분, [4]카드번호, [5]결제금액, [6]승인번호, [7]승인일자, [8]승인시간, [9]응답상태값, [10]응답메시지, [11]전문)
                                m_cDataCommon.SetSaleApprLog(sTradeDiv, new string[] { m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sTrType, "R"
                                                            , sCardData, nPayAmt.ToString()
                                                            , sRecvAppNo, aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.SaleDate].Trim(), aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.SaleTime].Trim()
                                                            , aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.ResStatus].Trim()
                                                            , sErrMsg
                                                            , sRecvData });
                                return sRet;
                            }

                            if (aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.TranType].Trim() == PosConst.POS_HAPPYGIFT_INQ_TYPE.SEARCH)
                            {
                                // 조회 정상 상세항목
                                bytes = Encoding.Default.GetBytes(CmUtil.MidH(sRecvData, 88, sRecvData.Length));
                                aIrtRspDTL = new string[Column.POS_RES_SEL_DTL_HAPPYGIFT.LEN.Length];

                                ItemColumn.ParseMessage(Column.POS_RES_SEL_DTL_HAPPYGIFT.LEN, Column.POS_RES_SEL_DTL_HAPPYGIFT.TYPE, bytes, ref nNowPos, ref aIrtRspDTL);
                            }
                            else if (aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.TranType].Trim() == PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL)
                            {
                                // 승인 상세항목
                                bytes = Encoding.Default.GetBytes(CmUtil.MidH(sRecvData, 88, sRecvData.Length));
                                aIrtRspDTL = new string[Column.POS_RES_APP_DTL_HAPPYGIFT.LEN.Length];

                                ItemColumn.ParseMessage(Column.POS_RES_APP_DTL_HAPPYGIFT.LEN, Column.POS_RES_APP_DTL_HAPPYGIFT.TYPE, bytes, ref nNowPos, ref aIrtRspDTL);

                                sRecvAppNo = aIrtRspDTL[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.ApprNo].Trim();
                            }
                            else if (aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.TranType].Trim() == PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL_CANCEL)
                            {
                                // 승인취소 상세항목
                                bytes = Encoding.Default.GetBytes(CmUtil.MidH(sRecvData, 88, sRecvData.Length));
                                aIrtRspDTL = new string[Column.POS_RES_CAN_DTL_HAPPYGIFT.LEN.Length];

                                ItemColumn.ParseMessage(Column.POS_RES_CAN_DTL_HAPPYGIFT.LEN, Column.POS_RES_CAN_DTL_HAPPYGIFT.TYPE, bytes, ref nNowPos, ref aIrtRspDTL);

                                sRecvAppNo = aIrtRspDTL[Column.POS_RES_CAN_DTL_HAPPYGIFT.SEQ.ApprNo].Trim();
                            }

                            break;
                        }
                }

                // 응답 - 승인로그 저장   (판매구분, [0]결제수단, [1]결제상세코드, [2]전문구분, [3]요청구분, [4]카드번호, [5]결제금액, [6]승인번호, [7]승인일자, [8]승인시간, [9]응답상태값, [10]응답메시지, [11]전문)
                m_cDataCommon.SetSaleApprLog(sTradeDiv, new string[] { m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sTrType, "R"
                                                            , sCardData, nPayAmt.ToString()
                                                            , sRecvAppNo, aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.SaleDate].Trim(), aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.SaleTime].Trim()
                                                            , aIrtRspHDR[Column.POS_HDR_HAPPYGIFT.SEQ.ResStatus].Trim()
                                                            , sErrMsg
                                                            , sRecvData });

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sCardData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region 전문 생성
        /// <summary>
        /// 전문 생성
        /// </summary>
        /// <param name="sTrType"></param>
        /// <param name="siNqType"></param>
        /// <param name="sWCC"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <returns></returns>
        protected string GetMakeiNQData(string sTrType, string sCancelType, string sCardData, string sReqNo, double nPayAmt, string sApprDate, string sApprNo, string sApprTime)
        {
            string sSendData = string.Empty;
            string sSendData_Body = string.Empty;
            double nHeaderLen = 0;
            double nBodyLen = 0; 
            string sApprID = null;

            try
            {
                // 유형별 분기
                switch (m_cPayItem.PAY_DTL_CD_01)
                {
                    case ItemConst.TR_ITEM_ID.PPCARD.HP_GIFT:
                        {
                            // -----------------------------------------------------------------------------------------
                            // 해피 기프트
                            // -----------------------------------------------------------------------------------------

                            // 헤더
                            string[] aIrtHeader = new string[Column.POS_HDR_HAPPYGIFT.LEN.Length];

                            // 헤더 길이
                            nHeaderLen = ItemColumn.LenMessage(Column.POS_HDR_HAPPYGIFT.LEN);

                            if (sTrType == PosConst.POS_HAPPYGIFT_INQ_TYPE.SEARCH)
                            {
                                // 조회

                                // Body 요청 전문 생성
                                string[] aIrtBody = new string[Column.POS_RES_SEL_DTL_HAPPYGIFT.LEN.Length];

                                // Body 길이
                                nBodyLen = ItemColumn.LenMessage(Column.POS_RES_SEL_DTL_HAPPYGIFT.LEN);

                                // Body 정보 설정
                                //aIrtBody[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.GiftNo] = sCardData;
                                //aIrtBody[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.GiftAmt] = "0";
                                aIrtBody[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.GiftBalAmt] = "0";
                                aIrtBody[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.Exp_DT] = "";
                                aIrtBody[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.Reg_Dt] = "";
                                aIrtBody[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.Gift_State ] = "";
                                aIrtBody[Column.POS_RES_SEL_DTL_HAPPYGIFT.SEQ.ReChangeYN] = "";

                                sSendData_Body = ItemColumn.MakeMessage(aIrtBody, Column.POS_RES_SEL_DTL_HAPPYGIFT.LEN, Column.POS_RES_SEL_DTL_HAPPYGIFT.TYPE);
                            }
                            else if (sTrType == PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL)
                            {
                                // 승인

                                // Body 요청 전문 생성
                                string[] aIrtBody = new string[Column.POS_RES_APP_DTL_HAPPYGIFT.LEN.Length];

                                // Body 길이
                                nBodyLen = ItemColumn.LenMessage(Column.POS_RES_APP_DTL_HAPPYGIFT.LEN);

                                // Body 정보 설정
                                aIrtBody[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.GiftNo] = sCardData;
                                aIrtBody[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.ApprNo] = "";
                                aIrtBody[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.PayAmt] = nPayAmt.ToString();
                                aIrtBody[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.BalanceAmt] = "0";
                                aIrtBody[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.iTemNm] = "";
                                aIrtBody[Column.POS_RES_APP_DTL_HAPPYGIFT.SEQ.Exp_DT] = "";

                                sSendData_Body = ItemColumn.MakeMessage(aIrtBody, Column.POS_RES_APP_DTL_HAPPYGIFT.LEN, Column.POS_RES_APP_DTL_HAPPYGIFT.TYPE);
                            }
                            else if (sTrType == PosConst.POS_HAPPYGIFT_INQ_TYPE.APPROVAL_CANCEL)
                            {
                                // 취소

                                // Body 요청 전문 생성
                                string[] aIrtBody = new string[Column.POS_RES_CAN_DTL_HAPPYGIFT.LEN.Length];

                                // Body 길이
                                nBodyLen = ItemColumn.LenMessage(Column.POS_RES_CAN_DTL_HAPPYGIFT.LEN);

                                // Body 정보 설정
                                aIrtBody[Column.POS_RES_CAN_DTL_HAPPYGIFT.SEQ.GiftNo] = sCardData;
                                aIrtBody[Column.POS_RES_CAN_DTL_HAPPYGIFT.SEQ.ApprNo] = sApprNo;
                                aIrtBody[Column.POS_RES_CAN_DTL_HAPPYGIFT.SEQ.PayAmt] = nPayAmt.ToString();
                                aIrtBody[Column.POS_RES_CAN_DTL_HAPPYGIFT.SEQ.CancelType] = sCancelType;
                                aIrtBody[Column.POS_RES_CAN_DTL_HAPPYGIFT.SEQ.BalanceAmt] = "0";
                                aIrtBody[Column.POS_RES_CAN_DTL_HAPPYGIFT.SEQ.Exp_DT] = "";

                                sSendData_Body = ItemColumn.MakeMessage(aIrtBody, Column.POS_RES_CAN_DTL_HAPPYGIFT.LEN, Column.POS_RES_CAN_DTL_HAPPYGIFT.TYPE);
                            }

                            // 헤더길이를 전체 길이로 변경
                            nHeaderLen += nBodyLen;

                            // 제휴사 코드
                            sApprID = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.APPR_ID);

                            // 헤더 정보 설정
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.HeadLen] = nHeaderLen.ToString();
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.DocVer] = "0003";
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.BrandID] = sApprID;
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.TranType] = sTrType;
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.StoreCD] = m_cPosStatus.Base.StoreNo;
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.StoreNM] = CmUtil.GetDataRowStr(PosMstManager.GetMstStore(), PosMst.MST_STORE.DATA.STORNM);
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.PosNo] = m_cPosStatus.Base.PosNo;
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.ReqNoChk] = "2";
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.SaleDate] = sApprDate;
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.SaleTime] = sApprTime;
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.ResStatus] = "";
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.ErrCD] = "";
                            aIrtHeader[Column.POS_HDR_HAPPYGIFT.SEQ.BodyLen] = nBodyLen.ToString();

                            sSendData = ItemColumn.MakeMessage(aIrtHeader, Column.POS_HDR_HAPPYGIFT.LEN, Column.POS_HDR_HAPPYGIFT.TYPE);

                            sSendData += sSendData_Body;
                            break;
                            // -----------------------------------------------------------------------------------------
                        }
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sCardData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sSendData;
        }
        #endregion        

    }
}
