﻿using System;
using System.Collections;
using System.Text;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : SPC 임직원 할인 - 중국
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class SPCEmployeeDC_China : PaymentBase, IPaymentUs
    {
        private int iRecvTimeOut = 10000;

        public SPCEmployeeDC_China()
        {
        }

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutData = "", sCardData = "";
            try
            {
                sInPutData = aParam[2];                                                                                 // 입력데이터
                sCardData = aParam[3];                                                                                  // 카드데이터

                string sPosMenuKey = aParam[0];                                                                         // 메뉴키
                string sWCC = aParam[1];                                                                                // 입력구분
                double nPayAmt = CmUtil.DoubleParse(aParam[4]);                                                         // 요청금액

                m_cPayItem = new Column.TR_PAYMENT.DATA();                                                              // 결과 저장 변수 생성
                m_cPayItem.PAY_WAY_CD = ItemConst.TR_ITEM_ID.EMP_DC_ITEM;                                               // 결제수단
                m_cPayItem.PAY_DTL_CD_01 = ItemConst.TR_ITEM_ID.EMP_DC.SPC_CHINA ;                                     // 상세코드

                string siNqType = PosConst.POS_SPC_EMPLOYEE_DC_CHINA_INQ_TYPE.SEARCH;
                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, siNqType, sWCC, sInPutData, sCardData, nPayAmt, "", "");
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            return m_cPayItem;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록 
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutData = "", sCardData = "";

            try
            {

                sInPutData = aParam[2];                                                                                 // 입력데이터
                sCardData = aParam[3];                                                                                  // 카드데이터

                string sPosMenuKey = aParam[0];                                                                         // 메뉴키
                string sWCC = aParam[1];                                                                                // 입력구분
                double nPayAmt = CmUtil.DoubleParse(aParam[4]);                                                         // 대상금액
                string sApprDate = aParam[5];                                                                           // 승인일자
                string sApprNo = aParam[6];                                                                             // 승인번호
                string sCardNo_Can = aParam[7];                     // 일반카드번호

                m_cPayItem = new Column.TR_PAYMENT.DATA();                                                              // 결과 저장 변수 생성

                m_cPayItem.PAY_WAY_CD = ItemConst.TR_ITEM_ID.EMP_DC_ITEM;                                               // 결제수단
                m_cPayItem.PAY_DTL_CD_01 = ItemConst.TR_ITEM_ID.EMP_DC.SPC_CHINA;                                       // 상세코드

                string siNqType = "";
                if (m_cTrnStatus.Head.TradeDiv == ItemConst.TRAN_DIV.NORMAL)
                    siNqType = PosConst.POS_SPC_EMPLOYEE_DC_CHINA_INQ_TYPE.APPROVAL;                                    // 정상
                else
                    siNqType = PosConst.POS_SPC_EMPLOYEE_DC_CHINA_INQ_TYPE.REFUND;                                      // 반품

                // 승인요청
                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, siNqType, sWCC, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo);
                if (sRet != UserCom.RST_OK)
                {
                    return sRet;
                }

                m_cPayItem.OCCUR_ENTRY_14 = sCardNo_Can;
                //m_cPayItem.CanFiller1 = sCardData;

                string sInEncData = "";
                string sMaskData = "";
                sInPutData = sCardNo_Can;
                EncryptedCardNo(sInPutData, ref sMaskData, ref sInEncData);
                m_cPayItem.CanFiller1 = sInEncData;

                SetPluCoopDcAmount(m_cPayItem.PAY_WAY_CD + m_cPayItem.PAY_DTL_CD_01, m_cPayItem.PAY_AMT, nPayAmt);      // 상품아이템에 할인금액 설정

                // 결제 아이템 추가
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);                     // 결제 내역 받아 오기
                m_cPayItem.SEQ = alPayItem.Count + 1;
                alPayItem.Add(m_cPayItem);

                m_cDataService.UpdatePluAmount();                                                                       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();                                                                       // 결제 금액 재 계산 처리
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutData = "", sCardData = "";

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return sRet;

                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                //sInPutData = m_cPayItem.OCCUR_ENTRY_01;                                                                 // 입력데이터
                //sCardData = m_cPayItem.OCCUR_ENTRY_22;                                                                  // 카드데이터

                //sInPutData = m_cPayItem.OCCUR_ENTRY_01;          // 입력데이터
                sInPutData = m_cPayItem.OCCUR_ENTRY_14;          // 입력데이터
                //sCardData = m_cPayItem.CanFiller1;           // 카드데이터

                string sMaskData = "";
                EncryptedCardNo(sInPutData, ref sMaskData, ref sCardData);

                string sWCC = m_cPayItem.OCCUR_ENTRY_05;                                                                // 입력구분
                double nPayAmt = m_cPayItem.AMT_ENTRY_01;                                                               // 대상금액
                string sApprDate = m_cPayItem.OCCUR_ENTRY_03;                                                           // 승인일자
                string sApprNo = m_cPayItem.OCCUR_ENTRY_02;                                                             // 승인번호
                string siNqType = PosConst.POS_SPC_EMPLOYEE_DC_CHINA_INQ_TYPE.REFUND;                                   // 반품

                sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, siNqType, sWCC, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo);
                if (sRet != UserCom.RST_OK)
                {
                    return sRet;
                }

                ClearPluCoopDcAmount();        // 할인금액 삭제

                m_cPayItem.CANCEL_DIV = PosConst.CANCEL_DIV.CANCEL;

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리
                
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutData = "", sCardData = "";

            try
            {
                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                if (m_cPayItem.OCCUR_ENTRY_08.ToString() != ItemConst.PAY_APP_DIV.NORMAL)
                {
                    //임의 등록 이면 승인 없이 데이터 처리
                    //WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0240));
                    m_cPayItem.OCCUR_ENTRY_06 = m_cPayItem.OCCUR_ENTRY_02;
                    m_cPayItem.OCCUR_ENTRY_07 = m_cPayItem.OCCUR_ENTRY_03;

                }
                else
                {
                    //sInPutData = m_cPayItem.OCCUR_ENTRY_01;                                                                 // 입력데이터
                    //sCardData = m_cPayItem.OCCUR_ENTRY_22;                                                                  // 카드데이터

                    //sInPutData = m_cPayItem.OCCUR_ENTRY_01;          // 입력데이터
                    sInPutData = m_cPayItem.OCCUR_ENTRY_14;          // 입력데이터
                    //sCardData = m_cPayItem.CanFiller1;           // 카드데이터

                    string sMaskData = "";
                    EncryptedCardNo(sInPutData, ref sMaskData, ref sCardData);

                    string sWCC = m_cPayItem.OCCUR_ENTRY_05;                                                                // 입력구분
                    double nPayAmt = m_cPayItem.AMT_ENTRY_01;                                                               // 대상금액
                    string sApprDate = m_cPayItem.OCCUR_ENTRY_03;                                                           // 승인일자
                    string sApprNo = m_cPayItem.OCCUR_ENTRY_02;                                                             // 승인번호
                    string siNqType = PosConst.POS_SPC_EMPLOYEE_DC_CHINA_INQ_TYPE.REFUND;                                   // 반품

                    sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, siNqType, sWCC, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo);
                    if (sRet != UserCom.RST_OK)
                    {
                        return sRet;
                    }

                    //ClearPluCoopDcAmount();        // 할인금액 삭제
                }
                
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region 조회 실행
        /// <summary>
        /// 조회 실행
        /// </summary>
        /// <param name="siNqType"></param>
        /// <param name="sWCC"></param>
        /// <param name="sInPutData"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <returns></returns>
        public string ExecuteIrt(string sTradeDiv, string siNqType, string sWCC, string sInPutData, string sCardData, double nPayAmt, string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 카드번호 = 이하 자름
                if (sInPutData.IndexOf("=") > 0) sInPutData = CmUtil.MidH(sInPutData, 0, sInPutData.IndexOf("="));

                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1" ) return SetTrainingData(siNqType, sWCC, sInPutData, nPayAmt, sApprDate, sApprNo);

                string[] aIrtRsp = null;
                // 조회
                sRet = ExecuteSendRecv(sTradeDiv, siNqType, sWCC, sInPutData, nPayAmt, sApprDate, sApprNo, ref aIrtRsp);
                if (sRet != UserCom.RST_OK) return sRet;

                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    // 결제구분 (1:결제, 2:할인)
                    DataRow dr = PosMstManager.GetMstPayDc(new string[] { m_cPosStatus.Base.CmpCd, m_cPosStatus.Base.StoreNo, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01 });

                    m_cPayItem.PAY_AMT = CmUtil.DoubleParse(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.DCAmt]);

                    m_cPayItem.PAY_DTL_CD_02 = "";                                                                          // 캠페인코드
                    m_cPayItem.PAY_DTL_CD_03 = "1";                                                                         // 할인금액 아이템 적용여부
                    m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.DC;                                                     // 할인결제구분 (1:결제, 2:할인)

                    m_cPayItem.AMT_ENTRY_01 = CmUtil.DoubleParse(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.DCAmt]);  // 받은돈
                    m_cPayItem.AMT_ENTRY_02 = 0;                                                                            // 제휴 할인 금액
                    m_cPayItem.AMT_ENTRY_03 = 0;                                                                            // 거래전잔액
                    m_cPayItem.AMT_ENTRY_04 = CmUtil.DoubleParse(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.RemainAmt]); // 거래후잔액
                    m_cPayItem.AMT_ENTRY_05 = 0;
                    m_cPayItem.AMT_ENTRY_06 = nPayAmt;                                                                      // 대상금액

                    m_cPayItem.OCCUR_ENTRY_01 = sInPutData;                                                                 // 카드번호
                    m_cPayItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprNo].Trim();            // 승인번호
                    m_cPayItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprDate].Trim(), 0, 8);  // 승인일자
                    m_cPayItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprDate].Trim(), 8, 6);  // 승인시간
                    m_cPayItem.OCCUR_ENTRY_05 = sWCC;                                                                       // 입력 구분
                    m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                                                                    // 원승인번호
                    m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                                                                  // 원승인일자
                    m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;                                               // 승인구분
                    m_cPayItem.OCCUR_ENTRY_10 = aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.Emp_Name].Trim();          // 직원명
                    m_cPayItem.OCCUR_ENTRY_16 = CmUtil.GetDataRowStr(dr, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);              // VAN 구분
                    m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                    m_cPayItem.OCCUR_ENTRY_22 = sCardData;

                    m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                    m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;                                                  // 빌분리 번호
                }
                else
                {
                    m_cPayItem.AMT_ENTRY_04 = CmUtil.DoubleParse(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.RemainAmt]); // 거래후잔액
                    
                    m_cPayItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprNo].Trim();               // 승인번호
                    m_cPayItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprDate].Trim(), 0, 8);  // 승인일자
                    m_cPayItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprDate].Trim(), 8, 6);  // 승인시간
                    m_cPayItem.OCCUR_ENTRY_05 = sWCC;                                                                       // 입력 구분
                    m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                                                                    // 원승인번호
                    m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                                                                  // 원승인일자
                    m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;                                               // 승인구분
                }

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sCardData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }

        /// <summary>
        /// 연습 데이터 설정
        /// </summary>
        /// <param name="siNqType"></param>
        /// <param name="sWCC"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <returns></returns>
        public string SetTrainingData(string siNqType, string sWCC, string sCardData, double nPayAmt, string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 결제구분 (1:결제, 2:할인)
                DataRow dr = PosMstManager.GetMstPayDc(new string[] { m_cPosStatus.Base.CmpCd, m_cPosStatus.Base.StoreNo, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01 });

                // 연습모드이면 연습 데이터 설정
                m_cPayItem.PAY_AMT = 1000;

                m_cPayItem.PAY_DTL_CD_02 = "";                                                                          // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "1";                                                                         // 할인금액 아이템 적용여부
                m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.DC;                                                     // 할인결제구분 (1:결제, 2:할인)

                m_cPayItem.AMT_ENTRY_01 = 1000;                                                                         // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;                                                                            // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = 0;                                                                            // 총포인트
                m_cPayItem.AMT_ENTRY_04 = 0;                                                                            // 가용포인트
                m_cPayItem.AMT_ENTRY_05 = 0;                                                                            // 잔여포인트

                m_cPayItem.OCCUR_ENTRY_01 = sCardData;                                                                  // 카드번호
                m_cPayItem.OCCUR_ENTRY_02 = "99999999";                                                                 // 승인번호
                m_cPayItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyMMdd");                                            // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmmss");                                            // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sWCC;                                                                       // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                                                                    // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                                                                  // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.COMPULSION;                                           // 승인구분
                m_cPayItem.OCCUR_ENTRY_10 = "TRAINEE";                                                                  // 직원명
                m_cPayItem.OCCUR_ENTRY_16 = CmUtil.GetDataRowStr(dr, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);              // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                m_cPayItem.OCCUR_ENTRY_22 = sCardData;

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;                                                  // 빌분리 번호

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////                
                CmUtil.ZeroFillClear(ref sCardData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region 승인 요청/응답
        /// <summary>
        /// 승인 요청/응답
        /// </summary>
        /// <param name="siNqType"></param>
        /// <param name="sWCC"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <param name="aIrtRsp"></param>
        /// <returns></returns>
        protected string ExecuteSendRecv(string sTradeDiv, string siNqType, string sWCC, string sCardData, double nPayAmt, string sApprDate, string sApprNo, ref string[] aIrtRsp)
        {
            string sSendData = "", sRecvData = "";         // 송수신 전문
            int nNowPos = 0;
            string sRet = UserCom.RST_ERR;

            string sServerIP = "";
            string sServerPort = "";
            string sCMPApprID = "";
            string sApprID = "";
            int iRecvTimeOut = 10000;

            try
            {
                // VAN 정보 조회
                if (m_cPayItem.OCCUR_ENTRY_16.Trim().Length != 0)
                {
                    // VAN_ID가 있는 경우 VAN_ID로 VAN 정보 조회
                    sServerIP = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.IP);
                    sServerPort = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.PORT);
                    sCMPApprID = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.CMP_APPR_ID);
                    sApprID = PosMstManager.GetMstVan(m_cPayItem.OCCUR_ENTRY_16.Trim(), PosMst.MST_VAN.DATA.APPR_ID);
                }
                else
                {
                    // VAN_ID가 미정인 경우 결제수단으로 VAN 정보 조회
                    sServerIP = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.IP);
                    sServerPort = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.PORT);
                    sCMPApprID = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.CMP_APPR_ID);
                    sApprID = PosMstManager.GetMstVan(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_VAN.DATA.APPR_ID);
                }

                if (sServerIP.Trim() == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0565);
                    return sRet;
                }

                // 전문 생성                
                sSendData = GetMakeiNQData(siNqType, sApprID, sWCC, sCardData, nPayAmt, sApprDate, sApprNo);

                // 수신 데이터 길이
                int iRecvDataLen = 337;

                // 요청 - 승인로그 저장   (판매구분, [0]결제수단, [1]결제상세코드, [2]전문구분, [3]요청구분, [4]카드번호, [5]결제금액, [6]승인번호, [7]승인일자, [8]승인시간, [9]응답상태값, [10]응답메시지, [11]전문)
                m_cDataCommon.SetSaleApprLog(sTradeDiv, new string[] { m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, siNqType, "S", sCardData, nPayAmt.ToString(), "", "", "", "", "", sSendData });

                // 전문 송수신
                //sRet = m_cDataCommon.ExecuteExIrt(sServerIP, CmUtil.IntParse(sServerPort), iRecvTimeOut, sSendData, ref sRecvData, iRecvDataLen, "");
                //if (sRet != UserCom.RST_OK)
                //{
                //    WinManager.ErrorMessage(sRet);
                //    return sRet;
                //}
                //byte[] bytes = Encoding.Default.GetBytes(sRecvData);
                //aIrtRsp = new string[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.LEN.Length];

                //ItemColumn.ParseMessage(Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.LEN, Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.TYPE, bytes, ref nNowPos, ref aIrtRsp);

                // 데이터 송신
                byte[] byteSend = Encoding.Default.GetBytes(sSendData);
                // 데이터 수신
                byte[] byteRecv = new byte[4096];
                int nRecvLen = m_cDataCommon.ExecuteTcpClientIrt("ExecuteEmployeeChina", sServerIP, CmUtil.IntParse(sServerPort), 10000, byteSend, ref byteRecv, 0);
                if (nRecvLen <= 0)
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0158);
                    return sRet;
                }
                sRecvData = Encoding.Default.GetString(byteRecv, 0, nRecvLen);
                aIrtRsp = new string[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.LEN.Length];

                nNowPos = 0;
                ItemColumn.ParseMessage(Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.LEN, Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.TYPE, byteRecv, ref nNowPos, ref aIrtRsp);

                // 직원할인 응답 금액 획득방법 ????
                aIrtRsp[16] = sRecvData.Substring(sRecvData.Length - 41, 20);
                aIrtRsp[17] = sRecvData.Substring(sRecvData.Length - 21, 20);

                // 응답 - 승인로그 저장   (판매구분, [0]결제수단, [1]결제상세코드, [2]전문구분, [3]요청구분, [4]카드번호, [5]결제금액, [6]승인번호, [7]승인일자, [8]승인시간, [9]응답상태값, [10]응답메시지, [11]전문)
                m_cDataCommon.SetSaleApprLog(sTradeDiv, new string[] { m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, siNqType, "R"
                                                            , sCardData, nPayAmt.ToString()
                                                            , aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprNo].Trim(), aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprDate].Trim(), DateTime.Now.ToString("HHmmss")
                                                            , aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ResStatus].Trim()
                                                            , aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ResMsg].Trim()  
                                                            , sRecvData });

                // - 'O000' : 승인 그외 : 거절
                if (aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ResStatus].Trim() != "0000")
                {
                    sRet = aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ResStatus].Trim() + " " + aIrtRsp[Column.POS_REQ_SPC_EMPLOYEE_DC_CHINA.SEQ.ResMsg].Trim();
                    WinManager.ErrorMessage(sRet);
                    return sRet;
                }

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sCardData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region 전문 생성
        /// <summary>
        /// 전문 생성
        /// </summary>
        /// <param name="siNqType"></param>
        /// <param name="sApprID"></param>
        /// <param name="sCardData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sApprDate"></param>
        /// <param name="sApprNo"></param>
        /// <returns></returns>
        protected string GetMakeiNQData(string siNqType, string sApprID, string sWcc, string sCardData, double nPayAmt, string sApprDate, string sApprNo)
        {
            string sSendData = string.Empty;
            try
            {
                string[] aIrtBody = new string[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.LEN.Length];

                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.STX] = Convert.ToChar(0x02).ToString();
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.InqLen] = "133";
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.InqType] = siNqType.ToString();

                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.BrandCD] = m_cPosStatus.Base.BrandCd;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.StoreCD] = m_cPosStatus.Base.StoreNo;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.SaleDate] = m_cPosStatus.Base.SaleDate;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.PosNo] = m_cPosStatus.Base.PosNo;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.TradeNo] = m_cPosStatus.Base.TradeNo;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.CashierNo] = m_cPosStatus.Base.CashierNo;

                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.Wcc] = sWcc;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.Emp_Card_No] = sCardData;

                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprDate] = sApprDate;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprNo] = sApprNo;
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.ApprAmt] = nPayAmt.ToString();

                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.Filler] = "";
                aIrtBody[Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.SEQ.ETX] = Convert.ToChar(0x03).ToString();
                

                // 요청 전문 생성
                sSendData = ItemColumn.MakeMessage(aIrtBody, Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.LEN, Column.POS_RES_SPC_EMPLOYEE_DC_CHINA.TYPE);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sCardData);             
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sSendData;
        }
        #endregion

        #region 할인 금액 설정
        /// <summary>
        /// 상품별 할인 금액 설정
        /// </summary>
        /// <param name="sCoopDcDiv"></param>
        /// <param name="nTotDcAmt"></param>
        /// <param name="nTotSaleAmt"></param>
        /// <returns></returns>
        public double SetPluCoopDcAmount(string sCoopDcDiv, double nTotDcAmt, double nTotSaleAmt)
        {
            double nApplyAmt = 0, nDisAmt = 0, nMaxAmt = 0;
            int nMaxRow = 0;

            try
            {
                ArrayList alSaleItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);

                for (int i = 0; i < alSaleItem.Count; i++)
                {
                    Column.TR_PLU.DATA cPluItem = (Column.TR_PLU.DATA)alSaleItem[i];

                    if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                    if (cPluItem.DC_PRMT_YN != "0") continue;

                    nTotDcAmt = CmUtil.MathRounds(nTotDcAmt, m_cPosStatus.Mst.DcRudDwLocMethd, CmUtil.IntParse(m_cPosStatus.Mst.DcRudDwLoc));
                    nDisAmt = CmUtil.DoubleMultiplication(nTotDcAmt, CmUtil.DoubleDivision(cPluItem.BILL_AMT, nTotSaleAmt));
                    nDisAmt = CmUtil.MathRounds(nDisAmt, m_cPosStatus.Mst.ItemRudDwLocMethd, CmUtil.IntParse(m_cPosStatus.Mst.ItemRudDwLoc));

                    cPluItem.EMP_DC_DIV = sCoopDcDiv;
                    cPluItem.EMP_DC_AMT = nDisAmt;

                    m_cDataService.UpdatePluItemAmount(cPluItem);

                    nApplyAmt = CmUtil.DoubleAdd(nApplyAmt, nDisAmt);
                    if (nMaxAmt == 0 || nMaxAmt < cPluItem.BILL_AMT)
                    {
                        nMaxAmt = cPluItem.BILL_AMT;
                        nMaxRow = i;
                    }
                }

                // 자투리 금액 
                if (nTotDcAmt != nApplyAmt)
                {
                    Column.TR_PLU.DATA cPluItem = (Column.TR_PLU.DATA)alSaleItem[nMaxRow];

                    cPluItem.EMP_DC_AMT = CmUtil.DoubleAdd(cPluItem.EMP_DC_AMT, CmUtil.DoubleSubtraction(nTotDcAmt, nApplyAmt));

                    m_cDataService.UpdatePluItemAmount(cPluItem);
                }

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return nTotDcAmt;
        }

        /// <summary>
        /// 상품별 할인 금액 삭제
        /// </summary>
        /// <returns></returns>
        public double ClearPluCoopDcAmount()
        {
            try
            {
                ArrayList alSaleItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);

                for (int i = 0; i < alSaleItem.Count; i++)
                {
                    Column.TR_PLU.DATA cPluItem = (Column.TR_PLU.DATA)alSaleItem[i];

                    if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;    // 지정취소
                    if (cPluItem.DC_PRMT_YN != "0") continue;

                    cPluItem.EMP_DC_DIV = "0000";
                    cPluItem.EMP_DC_AMT = 0;

                    m_cDataService.UpdatePluItemAmount(cPluItem);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return 0;
        }
        #endregion
    }
}
