﻿using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;

using Cosmos.UserFrame;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 전문(TRAN, IRT, VAN) 선언
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Common
{
    /// <summary>
    /// 전문(Tran, IRT, VAN) 정의
    /// </summary>
    public static class Column
    {
        #region 통신헤더
        /// <summary>
        /// 통신해더
        /// </summary>
        public class COMM_HEADER
        {
            public class DATA
            {
                /// <summary>
                /// 전문길이
                /// </summary>
                public string MsgLen;
                /// <summary>
                /// 전문구분
                /// </summary>
                public string MsgType;
                /// <summary>
                /// 회사코드
                /// </summary>
                public string CmpCd;
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public string BrandCd;
                /// <summary>
                /// 점포코드
                /// </summary>
                public string StoreCd;
                /// <summary>
                /// POS번호
                /// </summary>
                public string PosNo;
                ///// <summary>
                ///// 등록번호
                ///// </summary>
                //public string RegNo;
                /// <summary>
                /// 거래번호
                /// </summary>
                public string TradeNo;
                /// <summary>
                /// TRAN일자
                /// </summary>
                public string TranYmd;
                /// <summary>
                /// 시스템일자
                /// </summary>
                public string SysYmd;
                /// <summary>
                /// 시스템시간
                /// </summary>
                public string SysHms;
                /// <summary>
                /// 전문암호화구분(0:평문, 1:암호화)
                /// </summary>
                public string EncType;
                /// <summary>
                /// 에러코드
                /// </summary>
                public string ErrCd;
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int MsgLen = 0;
                public const int MsgType = 1;
                public const int CmpCd = 2;
                public const int BrandCd = 3;
                public const int StoreCd = 4;
                public const int TranYmd = 5;
                public const int PosNo = 6;
                //public const int RegNo = 7;
                public const int TradeNo = 7;
                public const int SysYmd = 8;
                public const int SysHms = 9;
                public const int EncType = 10;
                public const int ErrCd = 11;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 6, 2, 4, 4, 10, 8, 2, 5, 8, 6, 1, 3 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // TRAN 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region 트란헤더
        /// <summary>
        /// 트란해더
        /// </summary>
        public class TRAN_HEADER
        {
            public class DB_DATA
            {
                public const string CMP_CD = "CMP_CD";
                public const string STOR_CD = "STOR_CD";
                public const string SALE_DT = "SALE_DT";
                public const string POS_NO = "POS_NO";
                public const string TRADE_NO = "TRADE_NO";
                public const string TRADE_DIV = "TRADE_DIV";
                public const string TRAIN_MODE_YN = "TRAIN_MODE_YN";
                public const string TRADE_KINDPER = "TRADE_KINDPER";
                public const string SYS_DT = "SYS_DT";
                public const string ORD_TIME = "ORD_TIME";
                public const string PAY_TIME = "PAY_TIME";
                public const string PIC_NO = "PIC_NO";
                public const string ORD_PIC_NO = "ORD_PIC_NO";
                public const string STOR_OWN_PART_TIME_DIV = "STOR_OWN_PART_TIME_DIV";
                public const string ORG_BILL_POSNO = "ORG_BILL_POSNO";
                public const string ORG_BILLDT = "ORG_BILLDT";
                public const string ORG_BILL_NO = "ORG_BILL_NO";
                public const string RTN_RSN_CD = "RTN_RSN_CD";
                public const string RTN_RSN_MEMO = "RTN_RSN_MEMO";
                public const string NONSALES_RSN_CD = "NONSALES_RSN_CD";
                public const string RESERV_NO = "RESERV_NO";
                public const string RESERV_DT = "RESERV_DT";
                public const string CUST_NO = "CUST_NO";
                public const string ORD_DIV = "ORD_DIV";
                public const string FLOOR_CD = "FLOOR_CD";
                public const string TBL_NO = "TBL_NO";
                public const string GUESTFLOOR = "GUESTFLOOR";
                public const string FRGNR_DIV = "FRGNR_DIV";
                public const string CUSTCNT = "CUSTCNT";
                public const string PAY_GNDR_DIV = "PAY_GNDR_DIV";
                public const string PAY_AGE = "PAY_AGE";
                public const string MAN_CMPNPSN_CNT = "MAN_CMPNPSN_CNT";
                public const string WOMAN_CMPNPSN_CNT = "WOMAN_CMPNPSN_CNT";
                public const string QTY = "QTY";
                public const string TOTSALE_AMT = "TOTSALE_AMT";
                public const string TOTDC_AMT = "TOTDC_AMT";
                public const string NET_SALE_AMT = "NET_SALE_AMT";
                public const string ITEM_DC_AMT = "ITEM_DC_AMT";
                public const string CPI_DC_AMT = "CPI_DC_AMT";
                public const string SET_DC_AMT = "SET_DC_AMT";
                public const string ETC_AMT = "ETC_AMT";
                public const string EXCEP_DC_AMT = "EXCEP_DC_AMT";
                public const string TOT_VAT = "TOT_VAT";
                public const string SVC_FEE_AMT = "SVC_FEE_AMT";
                public const string SVC_FEE_VAT = "SVC_FEE_VAT";
                public const string ETC_VAT = "ETC_VAT";
                public const string AF_ACCUM_POINT_AMT = "AF_ACCUM_POINT_AMT";
                public const string AF_ACCUM_POINT_INFO = "AF_ACCUM_POINT_INFO";
                public const string PPCARD_CUSTNM = "PPCARD_CUSTNM";
                public const string AMT_DUTCHPAY_YN = "AMT_DUTCHPAY_YN";
                public const string BILLSPR_CNT = "BILLSPR_CNT";
                public const string ORDER_NO = "ORDER_NO";
                public const string MID_CLOSE_SEQ = "MID_CLOSE_SEQ";
                public const string PPCARD_CUSTID = "PPCARD_CUSTID";
                public const string PACK_TRADE_DIV = "PACK_TRADE_DIV";
                public const string VIP_TY = "VIP_TY";
                //#20170828 해피포인트 적립 제외 버튼 추가 phj, start
                public const string HP_EXCLUDE_YN = "HP_EXCLUDE_YN";
                //#20170828 해피포인트 적립 제외 버튼 추가 phj, end
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int TRADE_DIV = 3;
                public const int TRAIN_MODE_YN = 4;
                public const int TRADE_KINDPER = 5;
                public const int SYS_DT = 6;
                public const int ORD_TIME = 7;
                public const int PAY_TIME = 8;
                public const int PIC_NO = 9;
                public const int ORD_PIC_NO = 10;
                public const int STOR_OWN_PART_TIME_DIV = 11;
                public const int ORG_BILL_POSNO = 12;
                public const int ORG_BILLDT = 13;
                public const int ORG_BILL_NO = 14;
                public const int RTN_RSN_CD = 15;
                public const int RTN_RSN_MEMO = 16;
                public const int NONSALES_RSN_CD = 17;
                public const int RESERV_NO = 18;
                public const int RESERV_DT = 19;
                public const int CUST_NO = 20;
                public const int ORD_DIV = 21;
                public const int FLOOR_CD = 22;
                public const int TBL_NO = 23;
                public const int GUESTFLOOR = 24;
                public const int FRGNR_DIV = 25;
                public const int CUSTCNT = 26;
                public const int PAY_GNDR_DIV = 27;
                public const int PAY_AGE = 28;
                public const int MAN_CMPNPSN_CNT = 29;
                public const int WOMAN_CMPNPSN_CNT = 30;
                public const int QTY = 31;
                public const int TOTSALE_AMT = 32;
                public const int TOTDC_AMT = 33;
                public const int NET_SALE_AMT = 34;
                public const int ITEM_DC_AMT = 35;
                public const int CPI_DC_AMT = 36;
                public const int COOP_CARD_DC_AMT = 37;
                public const int POINT_DC_AMT = 38;
                public const int CPN_DC_AMT = 39;
                public const int EMP_DC_AMT = 40;
                public const int SET_DC_AMT = 41;
                public const int ETC_AMT = 42;
                public const int EXCEP_DC_AMT = 43;
                public const int TOT_VAT = 44;
                public const int SVC_FEE_AMT = 45;
                public const int SVC_FEE_VAT = 46;
                public const int ETC_VAT = 47;
                public const int AF_ACCUM_POINT_AMT = 48;
                public const int AF_ACCUM_POINT_INFO = 49;
                public const int PPCARD_CUSTNM = 50;
                public const int AMT_DUTCHPAY_YN = 51;
                public const int BILLSPR_CNT = 52;
                public const int ORDER_NO = 53;
                public const int SLACK_FIELD = 54;
                public const int MID_CLOSE_SEQ = 55;
                public const int PPCARD_CUSTID = 56;
                public const int PACK_TRADE_DIV = 57;
                public const int VIP_TY = 58;
                //#20170828 해피포인트 적립 제외 버튼 추가 phj, start
                public const int HP_EXCLUDE_YN = 59;
                //#20170828 해피포인트 적립 제외 버튼 추가 phj, end
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = {  };
        }
        #endregion
        
        #region 판매상품
        /// <summary>
        /// Sale Item (판매 상품)
        /// </summary>
        public class TR_PLU
        {
            public const string ITEM = "TR_PLU";

            public class DATA
            {
                /// <summary>
                /// 주문시간
                /// </summary>
                public string ORD_TIME = "";
                /// <summary>
                /// 층코드
                /// </summary>
                public string FLOOR_CD = "";
                /// <summary>
                /// 테이블번호
                /// </summary>
                public string TBL_NO = "";
                /// <summary>
                /// 서브매장코드 
                /// </summary>
                public string SUB_SHOP_CD = "";
                /// 상품코드  
                public string ITEM_PLU_CD = "";
                /// <summary>
                /// 상품구분(0:일반, 1:세트, 2:세트자식, 3:부가상품, 4:세트할인, 5:상품권(추가))
                /// </summary>
                public string ITEM_DIV = "";
                /// <summary>
                /// 판매 수량
                /// </summary>
                public long SALE_QTY = 0;
                /// <summary>
                /// 판매 단가
                /// </summary>        
                public double SALE_PRC = 0;
                /// <summary>
                /// 판매 금액
                /// </summary>         
                public double SALE_AMT = 0;
                /// <summary>
                /// 플레이버 구분(0:관련없음, 1:완료(플레이버를 선택할 수 있는 상품), 2:투입(플레이버상품))
                /// </summary>
                public string FLAVOUR_DIV = "0";
                /// <summary>
                /// 픞레이버 중량
                /// </summary>
                public double FLAVOUR_STOCK = 0;
                /// <summary>
                /// 상품 입력구분(1:SCAN,터치키,2:수입력)
                /// </summary>
                public string ITEM_INPUT_DIV = "1";
                /// <summary>
                /// 상품스캔코드
                /// </summary>
                public string ITEM_BAR_CD = "";
                /// <summary>
                /// TAKE IN/OUT 구분(0:in, 1:out)
                /// </summary>
                public string TAKE_IN_OUT_DIV = "1";
                /// <summary>
                /// 상품 과세 구분
                /// </summary>
                public string ITEM_TAX_DIV = "1";
                /// <summary>
                /// 세금 포함 여부 1:부가세포함, 2:부가세미포함
                /// </summary>
                public string TAX_AMT_INCLUDE_YN = "1";
                /// <summary>
                /// 세금율 코드
                /// </summary>
                public string TAXRATE_CD = "";
                /// <summary>
                /// 적용 세금
                /// </summary>
                public double APPLY_TAX_AMT = 0;
                /// <summary>
                /// 봉사료 금액
                /// </summary>
                public double SVC_FEE_AMT = 0;
                /// <summary>
                /// 봉사료 부가세
                /// </summary>
                public double SVC_FEE_VAT = 0;
                /// <summary>
                /// 봉사료 부가세율 코드
                /// </summary>
                public string SVC_TAXREATE_CD = "";
                /// <summary>
                /// 영수 금액
                /// </summary>
                public double BILL_AMT = 0;
                /// <summary>
                /// 비매출코드 : 0:정상, 1:무료쿠폰, 2시식, 3:비매, 4:서비스, 5:고객증정, 6:간식, 7:교육, 8:bread break(직원시식), 9:Defective(불량), 10:Gift(증정), 11:Donation(기부), 12:Waste(폐기), 13:폐기원료, 14:기타
                /// </summary>
                public string NONSALES_RSN_CD = "0";
                /// <summary>
                /// POS 할인 구분(0000:정상, 1701:무료(서비스), 1702:임의할인, 1704:제품교환권, 1706:입점건물직원할인)
                /// </summary>
                public string DC_DIV = "0000";
                /// <summary>
                /// 할인 유형(0:없음, 1:소계, 2:상품)
                /// </summary>
                public string DC_TYPE = "0";
                /// <summary>
                /// POS 할인 율
                /// </summary>
                public double DC_RATE = 0;
                /// <summary>
                /// POS 단품 할인 금액
                /// </summary>
                public double ITEM_DC_AMT = 0;
                /// <summary>
                /// POS 소계 할인 금액
                /// </summary>
                public double SUM_DC_AMT = 0;
                /// <summary>
                /// 캠페인 성립 수량
                /// </summary>
                public long CPI_DC_QTY = 0;
                /// <summary>
                /// 캠페인 할인 금액
                /// </summary>
                public double CPI_DC_AMT = 0;
                /// <summary>
                /// 제휴카드 할인 구분(0000:없음, 0300:SKT, 0301:KT. 0302:LGT, 0303:OILBANK, 0304:현대차 BLUE MEMBERS, 0305:기아차 RED MEMBERS, 0306:KT VIP)
                /// </summary>
                public string COOP_CARD_DC_DIV = "0000";
                /// <summary>
                /// 제휴카드 할인 금액(SKT,LGT,KT 할인 금액)
                /// </summary>
                public double COOP_CARD_DC_AMT = 0;
                /// <summary>
                /// 포인트 할인 구분(0000:없음, 0400:해피포인트,0402:삼성포인트, 0403:OK CASHBACK)
                /// </summary>
                public string POINT_DC_DIV = "0000";
                /// <summary>
                /// 포인트 할인 금액
                /// </summary>
                public double POINT_DC_AMT = 0;
                /// <summary>
                /// 쿠폰 할인 구분(0000:없음, 0801:쿠폰, 0802:해피쿠폰할인(스템프,복권, 인카드)
                /// </summary>
                public string CPN_DC_DIV = "0000";
                /// <summary>
                /// 쿠폰 할인 금액
                /// </summary>
                public double CPN_DC_AMT = 0;
                /// <summary>
                /// 직원 할인 구분(0000:없음, 1600:SPC임직원할인,1601:세브란스직원할인,1602:삼성 패밀리 할인(SFC), 1603:SPC임직원할인-중국)
                /// </summary>
                public string EMP_DC_DIV = "0000";
                /// <summary>
                /// 직원 할인 금액
                /// </summary>
                public double EMP_DC_AMT = 0;
                /// <summary>
                /// 세트 할인 금액
                /// </summary>
                public double SET_DC_AMT = 0;
                /// <summary>
                /// 기타 할인 구분(0000:없음, 1802:해피오더할인)
                /// </summary>
                public string ETC_DC_DIV = "0000";
                /// <summary>
                /// 기타 할인 금액
                /// </summary>
                public double ETC_DC_AMT = 0;
                /// <summary>
                /// 예외할인구분(0000:없음, 1703 환경사랑DC)
                /// </summary>
                public string EXCEP_DC_DIV = "0000";
                /// <summary>
                /// 예외할인금액
                /// </summary>
                public double EXCEP_DC_AMT = 0;
                /// <summary>
                /// 포장구분
                /// </summary>
                public string PACK_DIV = "0";
                /// <summary>
                /// 세트메뉴코드
                /// </summary>
                public string SET_MENU_CD = "";
                /// <summary>
                /// 부가메뉴구분(1:속성,2:업차지,3:선택메뉴)
                /// </summary>
                public string SUBPRC_MENU_KEY_DIV = "0";
                /// <summary>
                /// 캠페인증정구분
                /// </summary>
                public string CPI_PRESENT_DIV = "0";
                /// <summary>
                /// 빌분리번호
                /// </summary>
                public long BILLSPR_NO = 0;
                /// <summary>
                /// 판매 상품권/선불카드 번호
                /// </summary>
                public string SALE_GIFT_NO = "";
                /// <summary>
                /// 쿠폰번호
                /// </summary>
                public string CPN_NO = "";
                /// <summary>
                /// 일회용품구분
                /// </summary>
                public string DISPO_ITEM_DIV = "0";
                /// <summary>
                /// 취소 구분 0:정상,1:취소,2:결제전환후취소
                /// </summary>
                public string CANCEL_DIV = "0";
                /// <summary>
                /// 취소 일시
                /// </summary>
                public string CANCEL_DATE = "";
                /// <summary>
                /// NOTAX 구분 0:미적용, 1:적용
                /// </summary>
                public string NOTAX_DIV = "0";
                /// <summary>
                /// 선불카드권종(2017.06.27)
                /// </summary>
                public string SLACK_FIELD = "";

                //#20180903 해피오더 매출 생성 시 tr_sale_detail에 구분자 추가 start
                /// <summary>
                /// 해피오더 매출 구분자 
                /// </summary>
                public string HPO_REG_YN = "0";
                //#20180903 해피오더 매출 생성 시 tr_sale_detail에 구분자 추가 end

                //////////////////////////////////////////////////////////////////////////////////////////////////////
                //////////////////////////// 상품등록중 필요 변수 ////////////////////////////////////////////////////
                //////////////////////////////////////////////////////////////////////////////////////////////////////
                /// <summary>
                /// 상품 브랜드 코드
                /// </summary>
                public string ITEM_BRAND_CD = "";
                /// <summary>
                /// 취소 구분(메인상품)
                /// </summary>
                public string CANCEL_DIV_MAIN = "0";
                /// <summary>
                /// 상품명
                /// </summary>
                public string ITEM_NAME = "";
                /// <summary>
                /// 부가 세트 관리 유형(상품종류)
                /// </summary>
                public string SUB_SET_MNG_TYPE = "0";
                ///// <summary>
                ///// 판매 허용 여부
                ///// </summary>
                //public string SALE_PRMT_YN = "";
                /// <summary>
                /// 사은품 여부
                /// </summary>
                public string FREE_GIFT_YN = "";
                /// <summary>
                /// 할인 불가 여부(0:가능, 1:불가)
                /// </summary>
                public string DC_PRMT_YN = "0";
                /// <summary>
                /// 적립 허용 여부
                /// </summary>
                public string ACCUM_PRMT_YN = "";
                /// <summary>
                /// 봉사료 대상 여부
                /// </summary>
                public string SVC_FEE_TRGT_YN = "";
                /// <summary>
                /// 제휴카드 할인 불가 여부(0:가능, 1:불가)
                /// </summary>
                public string COOP_CARD_DC_NOADM_YN = "0";
                /// <summary>
                /// 플레이버 수량
                /// </summary>
                public long FLAVOUR_QTY = 0;
                /// <summary>
                /// 총 할인금액
                /// </summary>
                public double TOT_DC_AMT;
                /// <summary>
                /// 주문 상태
                /// 0:주문중, 1:주문완료, 2:주문수정
                /// </summary>
                public string ORDER_OK_FLAG = "0";
                /// <summary>
                /// 세트 할인 수량
                /// </summary>
                public long SET_DC_QTY;
                /// <summary>
                /// 대분류 코드
                /// </summary>
                public string L_CLSS = "";
                /// <summary>
                /// 중분류 코드
                /// </summary>
                public string M_CLSS = "";
                /// <summary>
                /// 소분류 코드
                /// </summary>
                public string S_CLSS = "";
                /// <summary>
                /// 상품별 캠페인 정보
                /// </summary>
                public ArrayList alTrSaleCpi = null;
                /// <summary>
                /// 세브란스 메뉴 구분(0:미해당, 1:해당)
                /// </summary>
                public string SEVERANCE_MENU_DIV = "0";
                /// <summary>
                /// 더치페이용 수량
                /// </summary>
                public long DUTCH_PAY_TOTQTY = 0;
                /// <summary>
                /// 더치페이용 선택 수량
                /// </summary>
                public long DUTCH_PAY_SELQTY = 0;
                /// <summary>
                /// 더치페이용 아이템 취소 플래그
                /// </summary>
                public string DUTCH_PAY_CAN_DIV = "";
                /// <summary>
                /// 더치페이용 메인 아이템 취소 플래그
                /// </summary>
                public string DUTCH_PAY_MAIN_CAN_DIV = "";
                /// <summary>
                /// 부가메뉴 메인상품 코드
                /// </summary>
                public string SUB_MENU_MAIN_CD = "";
                /// <summary>
                /// 세트메뉴 세트그룹코드
                /// </summary>
                public string SET_PLU_SET_GROUP_CODE = "";
                /// <summary>
                /// 케익 교환권 사용 가능 여부
                /// </summary>
                public string CAKE_EXCHNG_CPN_USE_POSS_YN = "";
                /// <summary>
                /// 캠페인 사은품상품 등록 구분
                /// </summary>
                public string CAMPAIGN_FREEGIFT = "";
                /// <summary>
                /// OPEN ITEM 구분
                /// </summary>
                public string OPEN_ITEM_DIV = "";
                /// <summary>
                /// 부가세율(출력용)
                /// </summary>
                public double TAX_RATE = 0;
                /// <summary>
                /// 상품메모 1
                /// </summary>
                public string ITEM_MEMO_1 = string.Empty;
                /// <summary>
                /// 상품메모 2
                /// </summary>
                public string ITEM_MEMO_2 = string.Empty;
                /// <summary>
                /// 상품메모 3
                /// </summary>
                public string ITEM_MEMO_3 = string.Empty;
                /// <summary>
                /// 원거래 아이템 순번(더치페이 및 후불 처리용)
                /// </summary>
                public int ORG_ITEM_SEQ = 0;
                
                public bool FIRE_KEY = false;
                /// <summary>
                /// 로스 아이템 개별 명칭
                /// </summary>
                public string NONSALES_RSN_NM = string.Empty;
                /// <summary>
                /// 이전수량
                /// </summary>
                public long ORG_QTY = 0;
                /// <summary>
                /// 상품 테크인 부가세 코드
                /// </summary>
                public string ITEM_TAKE_IN_VAT_CD = string.Empty;
                /// <summary>
                /// 상품 테크아웃 부가세 코드
                /// </summary>
                public string ITEM_TAKE_OUT_VAT_CD = string.Empty;

                //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start
                /// <summary>
                /// 상품설명 
                /// </summary>
                public string ITEM_EXPLN = string.Empty;
                /// <summary>
                /// 알레르기성분 
                /// </summary>
                public string ALLERGY = string.Empty;
                /// <summary>
                /// 원산지
                /// </summary>
                public string PLACE_ORIGIN = string.Empty;
                /// <summary>
                /// 영양성분 
                /// </summary>
                public string ITEM_INFO = string.Empty;
                //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end

                public object Clone()
                {
                    return this.MemberwiseClone();
                }

                /// <summary>
                /// 세트할인 그룹코드
                /// </summary>
                public int SET_DC_GROUP_CD = 0;

                /// <summary>
                /// 주문번호 
                /// </summary>
                public string ORDER_NO = string.Empty;
                /// <summary>
                /// 주문차수 
                /// </summary>
                public string ORDER_SEQ = string.Empty;

                //#Rhee, 20180209 미국 상품검색 후 상품 추가시 상품의 중분류로 이동 Start
                /// <summary>
                /// 중분류 그룹코드
                /// </summary>
                public string GRP_SEQ = string.Empty;
                //#Rhee, 20180209 미국 상품검색 후 상품 추가시 상품의 중분류로 이동 End

                //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 start
                /// <summary>
                /// 제조음료 Take In/Out 대상 해당 여부(0:해당안됨 1:해당상품)
                /// </summary>
                public string PROD_TAKEINOUT_YN = "0";

                /// <summary>
                /// 제조음료 Take In/Out 여부(1:Take In, 2:Take Out)
                /// </summary>
                public string PROD_TAKEINOUT_DIV = string.Empty;
                //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 end

            }

            public class DB_DATA
            {
                /// <summary>
                /// 주문시간
                /// </summary>
                public const string ORD_TIME = "ORD_TIME";
                /// <summary>
                /// 층코드
                /// </summary>
                public const string FLOOR_CD = "FLOOR_CD";
                /// <summary>
                /// 테이블번호
                /// </summary>
                public const string TBL_NO = "TBL_NO";
                /// <summary>
                /// 상품 브랜드 코드
                /// </summary>
                public const string ITEM_BRAND_CD = "ITEM_BRAND_CD";
                /// <summary>
                /// 서브매장코드 
                /// </summary>
                public const string SUB_SHOP_CD = "SUB_SHOP_CD";
                /// 상품코드  
                public const string ITEM_PLU_CD = "ITEM_PLU_CD";
                /// <summary>
                /// 상품구분(0:일반, 1:세트, 2:세트자식, 3:부가상품, 4:세트할인, 5:상품권(추가))
                /// </summary>
                public const string ITEM_DIV = "ITEM_DIV";
                /// <summary>
                /// 판매 수량
                /// </summary>
                public const string SALE_QTY = "SALE_QTY";
                /// <summary>
                /// 판매 단가
                /// </summary>        
                public const string SALE_PRC = "SALE_PRC";
                /// <summary>
                /// 판매 금액
                /// </summary>         
                public const string SALE_AMT = "SALE_AMT";
                /// <summary>
                /// 플레이버 구분(0:관련없음, 1:완료(플레이버를 선택할 수 있는 상품), 2:투입(플레이버상품))
                /// </summary>
                public const string FLAVOUR_DIV = "FLAVOUR_DIV";
                /// <summary>
                /// 플레이버 수량
                /// </summary>
                public const string FLAVOUR_QTY = "FLAVOUR_QTY";
                /// <summary>
                /// 픞레이버 중량
                /// </summary>
                public const string FLAVOUR_STOCK = "FLAVOUR_STOCK";
                /// <summary>
                /// 상품 입력구분(0:SCAN,터치키,1:수입력)
                /// </summary>
                public const string ITEM_INPUT_DIV = "ITEM_INPUT_DIV";
                /// <summary>
                /// 상품스캔코드
                /// </summary>
                public const string ITEM_BAR_CD = "ITEM_BAR_CD";
                /// <summary>
                /// TAKE IN/OUT 구분(0:in, 1:out)
                /// </summary>
                public const string TAKE_IN_OUT_DIV = "TAKE_IN_OUT_DIV";
                /// <summary>
                /// 상품 과세 구분
                /// </summary>
                public const string ITEM_TAX_DIV = "ITEM_TAX_DIV";
                /// <summary>
                /// 세금 포함 여부 1:부가세포함, 2:부가세미포함
                /// </summary>
                public const string TAX_AMT_INCLUDE_YN = "TAX_AMT_INCLUDE_YN";
                /// <summary>
                /// 세금율 코드
                /// </summary>
                public const string TAXRATE_CD = "TAXRATE_CD";
                /// <summary>
                /// 적용 세금
                /// </summary>
                public const string APPLY_TAX_AMT = "APPLY_TAX_AMT";
                /// <summary>
                /// 봉사료 금액
                /// </summary>
                public const string SVC_FEE_AMT = "SVC_FEE_AMT";
                /// <summary>
                /// 봉사료 부가세
                /// </summary>
                public const string SVC_FEE_VAT = "SVC_FEE_VAT";
                /// <summary>
                /// 봉사료 부가세율 코드
                /// </summary>
                public const string SVC_TAXREATE_CD = "SVC_TAXREATE_CD";
                /// <summary>
                /// 영수 금액
                /// </summary>
                public const string BILL_AMT = "BILL_AMT";
                /// <summary>
                /// 비매출코드 
                /// </summary>
                public const string NONSALES_RSN_CD = "NONSALES_RSN_CD";
                /// <summary>
                /// POS 할인 구분(00:정상, 01:무료(서비스), 02:임의할인,03:환경사랑DC,04:제품교환권,06:입점건물직원할인, 07:수수료할인)
                /// </summary>
                public const string DC_DIV = "DC_DIV";
                /// <summary>
                /// 할인 유형
                /// </summary>
                public const string DC_TYPE = "DC_TYPE";
                /// <summary>
                /// POS 할인 율
                /// </summary>
                public const string DC_RATE = "DC_RATE";
                /// <summary>
                /// POS 단품 할인 금액
                /// </summary>
                public const string ITEM_DC_AMT = "ITEM_DC_AMT";
                /// <summary>
                /// POS 소계 할인 금액
                /// </summary>
                public const string SUM_DC_AMT = "SUM_DC_AMT";
                /// <summary>
                /// 캠페인 할인 금액
                /// </summary>
                public const string CPI_DC_AMT = "CPI_DC_AMT";
                /// <summary>
                /// 제휴카드 할인 구분(SKT,LGT,KT 할인)
                /// </summary>
                public const string COOP_CARD_DC_DIV = "COOP_CARD_DC_DIV";
                /// <summary>
                /// 제휴카드 할인 금액(SKT,LGT,KT 할인 금액)
                /// </summary>
                public const string COOP_CARD_DC_AMT = "COOP_CARD_DC_AMT";
                /// <summary>
                /// 포인트 할인 구분
                /// </summary>
                public const string POINT_DC_DIV = "POINT_DC_DIV";
                /// <summary>
                /// 포인트 할인 금액
                /// </summary>
                public const string POINT_DC_AMT = "POINT_DC_AMT";
                /// <summary>
                /// 쿠폰 할인 구분(00:없음, 01:쿠폰, 02:해피쿠폰할인(스템프,복권), 03:인카드쿠폰, 04:매장쿠폰)
                /// </summary>
                public const string CPN_DC_DIV = "CPN_DC_DIV";
                /// <summary>
                /// 쿠폰 할인 금액
                /// </summary>
                public const string CPN_DC_AMT = "CPN_DC_AMT";
                /// <summary>
                /// 직원 할인 구분
                /// </summary>
                public const string EMP_DC_DIV = "EMP_DC_DIV";
                /// <summary>
                /// 직원 할인 금액
                /// </summary>
                public const string EMP_DC_AMT = "EMP_DC_AMT";
                /// <summary>
                /// 세트 할인 금액
                /// </summary>
                public const string SET_DC_AMT = "SET_DC_AMT";
                /// <summary>
                /// 기타 할인 구분
                /// </summary>
                public const string ETC_DC_DIV = "ETC_DC_DIV";
                /// <summary>
                /// 기타 할인 금액
                /// </summary>
                public const string ETC_DC_AMT = "ETC_DC_AMT";
                /// <summary>
                /// 예외할인구분
                /// </summary>
                public const string EXCEP_DC_DIV = "EXCEP_DC_DIV";
                /// <summary>
                /// 예외할인금액
                /// </summary>
                public const string EXCEP_DC_AMT = "EXCEP_DC_AMT";
                /// <summary>
                /// 포장구분
                /// </summary>
                public const string PACK_DIV = "PACK_DIV";
                /// <summary>
                /// 판매 상품권/선불카드 번호
                /// </summary>
                public const string SALE_GIFT_NO = "SALE_GIFT_NO";
                /// <summary>
                /// 세트메뉴코드
                /// </summary>
                public const string SET_MENU_CD = "SET_MENU_CD";
                /// <summary>
                /// 캠페인증정구분
                /// </summary>
                public const string CPI_PRESENT_DIV = "CPI_PRESENT_DIV";
                /// <summary>
                /// 쿠폰번호
                /// </summary>
                public const string CPN_NO = "CPN_NO";
                /// <summary>
                /// 빌분리번호
                /// </summary>
                public const string BILLSPR_NO = "BILLSPR_NO";
                /// <summary>
                /// 일회용품구분
                /// </summary>
                public const string DISPO_ITEM_DIV = "DISPO_ITEM_DIV";
                /// <summary>
                /// 취소 구분
                /// </summary>
                public const string CANCEL_DIV = "CANCEL_DIV";
                /// <summary>
                /// 취소 일시
                /// </summary>
                public const string CANCEL_DATE = "CANCEL_DATE";
                /// <summary>
                /// NOTAX 구분 0:미적용, 1:적용
                /// </summary>
                public const string NOTAX_DIV = "NOTAX_DIV";

                //#20180903 해피오더 매출 생성 시 tr_sale_detail에 구분자 추가 start
                /// <summary>
                /// 해피오더 매출 구분자 
                /// </summary>
                public const string HPO_REG_YN = "HPO_REG_YN";
                //#20180903 해피오더 매출 생성 시 tr_sale_detail에 구분자 추가 end
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ  
            {
                public const int ORD_TIME = 3;
                public const int FLOOR_CD = 4;
                public const int TBL_NO = 5;
                public const int SUB_SHOP_CD = 6;
                public const int ITEM_PLU_CD = 7;
                public const int ITEM_DIV = 8;
                public const int SALE_QTY = 9;
                public const int SALE_PRC = 10;
                public const int SALE_AMT = 11;
                public const int FLAVOUR_DIV = 12;
                public const int FLAVOUR_STOCK = 13;
                public const int ITEM_INPUT_DIV = 14;
                public const int ITEM_BAR_CD = 15;
                public const int TAKE_IN_OUT_DIV = 16;
                public const int ITEM_TAX_DIV = 17;
                public const int TAX_AMT_INCLUDE_YN = 18;
                public const int TAXRATE_CD = 19;
                public const int APPLY_TAX_AMT = 20;
                public const int SVC_FEE_AMT = 21;
                public const int SVC_FEE_VAT = 22;               
                public const int SVC_TAXREATE_CD = 23;
                public const int BILL_AMT = 24;
                public const int NONSALES_RSN_CD = 25;
                public const int DC_DIV = 26;
                public const int DC_TYPE = 27;
                public const int DC_RATE = 28;
                public const int ITEM_DC_AMT = 29;
                public const int SUM_DC_AMT = 30;
                public const int CPI_DC_QTY = 31;
                public const int CPI_DC_AMT = 32;
                public const int COOP_CARD_DC_DIV = 33;
                public const int COOP_CARD_DC_AMT = 34;
                public const int POINT_DC_DIV = 35;
                public const int POINT_DC_AMT = 36;
                public const int CPN_DC_DIV = 37;
                public const int CPN_DC_AMT = 38;
                public const int EMP_DC_DIV = 39;
                public const int EMP_DC_AMT = 40;
                public const int SET_DC_AMT = 41;
                public const int ETC_DC_DIV = 42;
                public const int ETC_DC_AMT = 43;
                public const int EXCEP_DC_DIV = 44;
                public const int EXCEP_DC_AMT = 45;
                public const int PACK_DIV = 46;
                public const int SET_MENU_CD = 47;
                public const int SUBPRC_MENU_KEY_DIV = 48;
                public const int CPI_PRESENT_DIV = 49;
                public const int BILLSPR_NO = 50;
                public const int SALE_GIFT_NO = 51;
                public const int CPN_NO = 52;
                public const int SLACK_FIELD = 53;
                public const int DISPO_ITEM_DIV = 54;
                public const int CANCEL_DIV = 55;
                public const int NOTAX_DIV = 56;

                //#20180903 해피오더 매출 생성 시 tr_sale_detail에 구분자 추가 start
                public const int HPO_REG_YN = 57;
                //#20180903 해피오더 매출 생성 시 tr_sale_detail에 구분자 추가 end
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region 결제수단
        /// <summary>
        /// 결제
        /// </summary>
        public class TR_PAYMENT
        {
            public const string ITEM = "TR_PAYMENT";

            public class DATA
            {

                /// <summary>
                /// 순번
                /// </summary>
                public long SEQ = 0;
                /// <summary>
                /// 결제수단코드
                /// </summary>
                public string PAY_WAY_CD = "";
                /// <summary>
                /// 결제금액
                /// </summary>
                public double PAY_AMT = 0;
                /// <summary>
                /// 결제세부코드1
                /// </summary>
                public string PAY_DTL_CD_01 = "";
                /// <summary>
                /// 결제세부코드2
                /// </summary>
                public string PAY_DTL_CD_02 = "";
                /// <summary>
                /// 결제세부코드3
                /// </summary>
                public string PAY_DTL_CD_03 = "";
                /// <summary>
                /// 결제세부코드4
                /// </summary>
                public string PAY_DTL_CD_04 = "";
                /// <summary>
                /// 결제세부코드5
                /// </summary>
                public string PAY_DTL_CD_05 = "";
                /// <summary>
                /// 수량항목1
                /// </summary>
                public double QTY_ENTRY_01 = 0;
                /// <summary>
                /// 수량항목2
                /// </summary>
                public double QTY_ENTRY_02 = 0;
                /// <summary>
                /// 수량항목3
                /// </summary>
                public double QTY_ENTRY_03 = 0;
                /// <summary>
                /// 수량항목4
                /// </summary>
                public double QTY_ENTRY_04 = 0;
                /// <summary>
                /// 수량항목5
                /// </summary>
                public double QTY_ENTRY_05 = 0;
                /// <summary>
                /// 금액항목1
                /// </summary>
                public double AMT_ENTRY_01 = 0;
                /// <summary>
                /// 금액항목2
                /// </summary>
                public double AMT_ENTRY_02 = 0;
                /// <summary>
                /// 금액항목3
                /// </summary>
                public double AMT_ENTRY_03 = 0;
                /// <summary>
                /// 금액항목4
                /// </summary>
                public double AMT_ENTRY_04 = 0;
                /// <summary>
                /// 금액항목5
                /// </summary>
                public double AMT_ENTRY_05 = 0;
                /// <summary>
                /// 금액항목6
                /// </summary>
                public double AMT_ENTRY_06 = 0;
                /// <summary>
                /// 금액항목7
                /// </summary>
                public double AMT_ENTRY_07 = 0;
                /// <summary>
                /// 금액항목8
                /// </summary>
                public double AMT_ENTRY_08 = 0;
                /// <summary>
                /// 금액항목9
                /// </summary>
                public double AMT_ENTRY_09 = 0;
                /// <summary>
                /// 금액항목10
                /// </summary>
                public double AMT_ENTRY_10 = 0;
                /// <summary>
                /// 발생항목1
                /// </summary>
                public string OCCUR_ENTRY_01 = "";
                /// <summary>
                /// 발생항목2
                /// </summary>
                public string OCCUR_ENTRY_02 = "";
                /// <summary>
                /// 발생항목3
                /// </summary>
                public string OCCUR_ENTRY_03 = "";
                /// <summary>
                /// 발생항목4
                /// </summary>
                public string OCCUR_ENTRY_04 = "";
                /// <summary>
                /// 발생항목5
                /// </summary>
                public string OCCUR_ENTRY_05 = "";
                /// <summary>
                /// 발생항목6
                /// </summary>
                public string OCCUR_ENTRY_06 = "";
                /// <summary>
                /// 발생항목7
                /// </summary>
                public string OCCUR_ENTRY_07 = "";
                /// <summary>
                /// 발생항목8
                /// </summary>
                public string OCCUR_ENTRY_08 = "";
                /// <summary>
                /// 발생항목9
                /// </summary>
                public string OCCUR_ENTRY_09 = "";
                /// <summary>
                /// 발생항목10
                /// </summary>
                public string OCCUR_ENTRY_10 = "";
                /// <summary>
                /// 발생항목11
                /// </summary>
                public string OCCUR_ENTRY_11 = "";
                /// <summary>
                /// 발생항목12
                /// </summary>
                public string OCCUR_ENTRY_12 = "";
                /// <summary>
                /// 발생항목13
                /// </summary>
                public string OCCUR_ENTRY_13 = "";
                /// <summary>
                /// 발생항목14
                /// </summary>
                public string OCCUR_ENTRY_14 = "";
                /// <summary>
                /// 발생항목15
                /// </summary>
                public string OCCUR_ENTRY_15 = "";
                /// <summary>
                /// 발생항목16
                /// </summary>
                public string OCCUR_ENTRY_16 = "";
                /// <summary>
                /// 발생항목17
                /// </summary>
                public string OCCUR_ENTRY_17 = "";
                /// <summary>
                /// 발생항목18
                /// </summary>
                public string OCCUR_ENTRY_18 = "";
                /// <summary>
                /// 발생항목19
                /// </summary>
                public string OCCUR_ENTRY_19 = "";
                /// <summary>
                /// 발생항목20
                /// </summary>
                public string OCCUR_ENTRY_20 = "";
                /// <summary>
                /// 발생항목21
                /// </summary>
                public string OCCUR_ENTRY_21 = "";
                /// <summary>
                /// 발생항목22
                /// </summary>
                public string OCCUR_ENTRY_22 = "";
                /// <summary>
                /// 발생항목23
                /// </summary>
                public string OCCUR_ENTRY_23 = "";
                /// <summary>
                /// 발생항목24
                /// </summary>
                public string OCCUR_ENTRY_24 = "";
                /// <summary>
                /// 발생항목25
                /// </summary>
                public string OCCUR_ENTRY_25 = "";
                /// <summary>
                /// 빌분리번호
                /// </summary>
                public long BILLSPR_NO = 0;
                /// <summary>
                /// 취소구분
                /// </summary>
                public string CANCEL_DIV = "0";

                ///////////////////////////////////////////////////////////
                /// <summary>
                /// HP 예약필드(포인트조회 응답정보)
                /// </summary>
                public string HP_RESERVED = "";
                /// <summary>
                /// HP 추가정보(인카드쿠폰 조회 리스트)
                /// </summary>
                public ArrayList HP_CPN_INFO = null;
                /// <summary>
                /// HP 추가정보(포인트조회 추가응답정보)
                /// </summary>
                public string HP_ADD_INFO_SCH = "";
                /// <summary>
                /// HP 추가정보(포인트사용 추가응답정보)
                /// </summary>
                public string HP_ADD_INFO_USE = "";
                /// <summary>
                /// HP 캠페인정보
                /// </summary>
                public string HP_CAMPAIGN_INFO = "";
                /// <summary>
                /// 금액 더치페이 영수증 출력 구분(1:출력, 그외 미출력)
                /// </summary>
                public string DutchPayPrtDiv = "";
                /// <summary>
                /// 소멸예정 포인트(포인트조회 응답정보)
                /// </summary>
                public long HP_EXT_POINT = 0;
                /// <summary>
                /// HP 고객명
                /// </summary>
                public string HP_CUST_NAME = "";

                /// <summary>
                /// 직전취소용필러1(암호화카드데이터)
                /// </summary>
                public string CanFiller1 = "";
                /// <summary>
                /// 직전취소용필러2
                /// </summary>
                public string CanFiller2 = "";
                /// <summary>
                /// 직전취소용필러3
                /// </summary>
                public string CanFiller3 = "";

                //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
                /// <summary>
                /// 해피쿠폰 조회 응답 전문의 제품군 또는 상품코드
                /// </summary>
                public string CpnItemDcCode = "";
                //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {

            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 할인수단
        /// <summary>
        /// 할인수단
        /// </summary>
        public class TR_DC
        {
            public const string ITEM = "TR_DC";

            public class DATA
            {

                /// <summary>
                /// 순번
                /// </summary>
                public long SEQ = 0;
                /// <summary>
                /// 결제수단코드
                /// </summary>
                public string DC_WAY_CD = "";
                /// <summary>
                /// 결제금액
                /// </summary>
                public double DC_AMT = 0;
                /// <summary>
                /// 결제세부코드1
                /// </summary>
                public string DC_DTL_CD_01 = "";
                /// <summary>
                /// 결제세부코드2
                /// </summary>
                public string DC_DTL_CD_02 = "";
                /// <summary>
                /// 결제세부코드3
                /// </summary>
                public string DC_DTL_CD_03 = "";
                /// <summary>
                /// 결제세부코드4
                /// </summary>
                public string DC_DTL_CD_04 = "";
                /// <summary>
                /// 결제세부코드5
                /// </summary>
                public string DC_DTL_CD_05 = "";
                /// <summary>
                /// 수량항목1
                /// </summary>
                public double QTY_ENTRY_01 = 0;
                /// <summary>
                /// 수량항목2
                /// </summary>
                public double QTY_ENTRY_02 = 0;
                /// <summary>
                /// 수량항목3
                /// </summary>
                public double QTY_ENTRY_03 = 0;
                /// <summary>
                /// 수량항목4
                /// </summary>
                public double QTY_ENTRY_04 = 0;
                /// <summary>
                /// 수량항목5
                /// </summary>
                public double QTY_ENTRY_05 = 0;
                /// <summary>
                /// 금액항목1
                /// </summary>
                public double AMT_ENTRY_01 = 0;
                /// <summary>
                /// 금액항목2
                /// </summary>
                public double AMT_ENTRY_02 = 0;
                /// <summary>
                /// 금액항목3
                /// </summary>
                public double AMT_ENTRY_03 = 0;
                /// <summary>
                /// 금액항목4
                /// </summary>
                public double AMT_ENTRY_04 = 0;
                /// <summary>
                /// 금액항목5
                /// </summary>
                public double AMT_ENTRY_05 = 0;
                /// <summary>
                /// 금액항목6
                /// </summary>
                public double AMT_ENTRY_06 = 0;
                /// <summary>
                /// 금액항목7
                /// </summary>
                public double AMT_ENTRY_07 = 0;
                /// <summary>
                /// 금액항목8
                /// </summary>
                public double AMT_ENTRY_08 = 0;
                /// <summary>
                /// 금액항목9
                /// </summary>
                public double AMT_ENTRY_09 = 0;
                /// <summary>
                /// 금액항목10
                /// </summary>
                public double AMT_ENTRY_10 = 0;
                /// <summary>
                /// 발생항목1
                /// </summary>
                public string OCCUR_ENTRY_01 = "";
                /// <summary>
                /// 발생항목2
                /// </summary>
                public string OCCUR_ENTRY_02 = "";
                /// <summary>
                /// 발생항목3
                /// </summary>
                public string OCCUR_ENTRY_03 = "";
                /// <summary>
                /// 발생항목4
                /// </summary>
                public string OCCUR_ENTRY_04 = "";
                /// <summary>
                /// 발생항목5
                /// </summary>
                public string OCCUR_ENTRY_05 = "";
                /// <summary>
                /// 발생항목6
                /// </summary>
                public string OCCUR_ENTRY_06 = "";
                /// <summary>
                /// 발생항목7
                /// </summary>
                public string OCCUR_ENTRY_07 = "";
                /// <summary>
                /// 발생항목8
                /// </summary>
                public string OCCUR_ENTRY_08 = "";
                /// <summary>
                /// 발생항목9
                /// </summary>
                public string OCCUR_ENTRY_09 = "";
                /// <summary>
                /// 발생항목10
                /// </summary>
                public string OCCUR_ENTRY_10 = "";
                /// <summary>
                /// 발생항목11
                /// </summary>
                public string OCCUR_ENTRY_11 = "";
                /// <summary>
                /// 발생항목12
                /// </summary>
                public string OCCUR_ENTRY_12 = "";
                /// <summary>
                /// 발생항목13
                /// </summary>
                public string OCCUR_ENTRY_13 = "";
                /// <summary>
                /// 발생항목14
                /// </summary>
                public string OCCUR_ENTRY_14 = "";
                /// <summary>
                /// 발생항목15
                /// </summary>
                public string OCCUR_ENTRY_15 = "";
                /// <summary>
                /// 발생항목16
                /// </summary>
                public string OCCUR_ENTRY_16 = "";
                /// <summary>
                /// 발생항목17
                /// </summary>
                public string OCCUR_ENTRY_17 = "";
                /// <summary>
                /// 발생항목18
                /// </summary>
                public string OCCUR_ENTRY_18 = "";
                /// <summary>
                /// 발생항목19
                /// </summary>
                public string OCCUR_ENTRY_19 = "";
                /// <summary>
                /// 발생항목20
                /// </summary>
                public string OCCUR_ENTRY_20 = "";
                /// <summary>
                /// 발생항목21
                /// </summary>
                public string OCCUR_ENTRY_21 = "";
                /// <summary>
                /// 발생항목22
                /// </summary>
                public string OCCUR_ENTRY_22 = "";
                /// <summary>
                /// 발생항목23
                /// </summary>
                public string OCCUR_ENTRY_23 = "";
                /// <summary>
                /// 발생항목24
                /// </summary>
                public string OCCUR_ENTRY_24 = "";
                /// <summary>
                /// 발생항목25
                /// </summary>
                public string OCCUR_ENTRY_25 = "";
                /// <summary>
                /// 빌분리번호
                /// </summary>
                public long BILLSPR_NO = 0;
                /// <summary>
                /// 취소구분
                /// </summary>
                public string CANCEL_DIV = "0"; 
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {

            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 기타수단
        /// <summary>
        /// 기타수단
        /// </summary>
        public class TR_ETC
        {
            public const string ITEM = "TR_ETC";

            public class DATA
            {

                /// <summary>
                /// 순번
                /// </summary>
                public long SEQ = 0;
                /// <summary>
                /// 기타 수단 코드
                /// </summary>
                public string ETC_WAY_CD = "";
                /// <summary>
                /// 기타 금액
                /// </summary>
                public double ETC_AMT = 0;
                /// <summary>
                /// 기타 세부코드1
                /// </summary>
                public string ETC_DTL_CD_01 = "";
                /// <summary>
                /// 기타 세부코드2
                /// </summary>
                public string ETC_DTL_CD_02 = "";
                /// <summary>
                /// 기타 세부코드3
                /// </summary>
                public string ETC_DTL_CD_03 = "";
                /// <summary>
                /// 기타 세부코드4
                /// </summary>
                public string ETC_DTL_CD_04 = "";
                /// <summary>
                /// 기타 세부코드5
                /// </summary>
                public string ETC_DTL_CD_05 = "";
                /// <summary>
                /// 수량항목1
                /// </summary>
                public double QTY_ENTRY_01 = 0;
                /// <summary>
                /// 수량항목2
                /// </summary>
                public double QTY_ENTRY_02 = 0;
                /// <summary>
                /// 수량항목3
                /// </summary>
                public double QTY_ENTRY_03 = 0;
                /// <summary>
                /// 수량항목4
                /// </summary>
                public double QTY_ENTRY_04 = 0;
                /// <summary>
                /// 수량항목5
                /// </summary>
                public double QTY_ENTRY_05 = 0;
                /// <summary>
                /// 금액항목1
                /// </summary>
                public double AMT_ENTRY_01 = 0;
                /// <summary>
                /// 금액항목2
                /// </summary>
                public double AMT_ENTRY_02 = 0;
                /// <summary>
                /// 금액항목3
                /// </summary>
                public double AMT_ENTRY_03 = 0;
                /// <summary>
                /// 금액항목4
                /// </summary>
                public double AMT_ENTRY_04 = 0;
                /// <summary>
                /// 금액항목5
                /// </summary>
                public double AMT_ENTRY_05 = 0;
                /// <summary>
                /// 금액항목6
                /// </summary>
                public double AMT_ENTRY_06 = 0;
                /// <summary>
                /// 금액항목7
                /// </summary>
                public double AMT_ENTRY_07 = 0;
                /// <summary>
                /// 금액항목8
                /// </summary>
                public double AMT_ENTRY_08 = 0;
                /// <summary>
                /// 금액항목9
                /// </summary>
                public double AMT_ENTRY_09 = 0;
                /// <summary>
                /// 금액항목10
                /// </summary>
                public double AMT_ENTRY_10 = 0;
                /// <summary>
                /// 발생항목1
                /// </summary>
                public string OCCUR_ENTRY_01 = "";
                /// <summary>
                /// 발생항목2
                /// </summary>
                public string OCCUR_ENTRY_02 = "";
                /// <summary>
                /// 발생항목3
                /// </summary>
                public string OCCUR_ENTRY_03 = "";
                /// <summary>
                /// 발생항목4
                /// </summary>
                public string OCCUR_ENTRY_04 = "";
                /// <summary>
                /// 발생항목5
                /// </summary>
                public string OCCUR_ENTRY_05 = "";
                /// <summary>
                /// 발생항목6
                /// </summary>
                public string OCCUR_ENTRY_06 = "";
                /// <summary>
                /// 발생항목7
                /// </summary>
                public string OCCUR_ENTRY_07 = "";
                /// <summary>
                /// 발생항목8
                /// </summary>
                public string OCCUR_ENTRY_08 = "";
                /// <summary>
                /// 발생항목9
                /// </summary>
                public string OCCUR_ENTRY_09 = "";
                /// <summary>
                /// 발생항목10
                /// </summary>
                public string OCCUR_ENTRY_10 = "";
                /// <summary>
                /// 발생항목11
                /// </summary>
                public string OCCUR_ENTRY_11 = "";
                /// <summary>
                /// 발생항목12
                /// </summary>
                public string OCCUR_ENTRY_12 = "";
                /// <summary>
                /// 발생항목13
                /// </summary>
                public string OCCUR_ENTRY_13 = "";
                /// <summary>
                /// 발생항목14
                /// </summary>
                public string OCCUR_ENTRY_14 = "";
                /// <summary>
                /// 발생항목15
                /// </summary>
                public string OCCUR_ENTRY_15 = "";
                /// <summary>
                /// 발생항목16
                /// </summary>
                public string OCCUR_ENTRY_16 = "";
                /// <summary>
                /// 발생항목17
                /// </summary>
                public string OCCUR_ENTRY_17 = "";
                /// <summary>
                /// 발생항목18
                /// </summary>
                public string OCCUR_ENTRY_18 = "";
                /// <summary>
                /// 발생항목19
                /// </summary>
                public string OCCUR_ENTRY_19 = "";
                /// <summary>
                /// 발생항목20
                /// </summary>
                public string OCCUR_ENTRY_20 = "";
                /// <summary>
                /// 발생항목21
                /// </summary>
                public string OCCUR_ENTRY_21 = "";
                /// <summary>
                /// 발생항목22
                /// </summary>
                public string OCCUR_ENTRY_22 = "";
                /// <summary>
                /// 발생항목23
                /// </summary>
                public string OCCUR_ENTRY_23 = "";
                /// <summary>
                /// 발생항목24
                /// </summary>
                public string OCCUR_ENTRY_24 = "";
                /// <summary>
                /// 발생항목25
                /// </summary>
                public string OCCUR_ENTRY_25 = "";
                /// <summary>
                /// 빌분리번호
                /// </summary>
                public long BILLSPR_NO = 0;
                /// <summary>
                /// 취소구분
                /// </summary>
                public string CANCEL_DIV = "0";

                ///////////////////////////////////////////////////////////
                /// <summary>
                /// 직전취소용필러1(암호화된 트랙정보)
                /// </summary>
                public string CanFiller1 = "";
                /// <summary>
                /// 직전취소용필러2
                /// </summary>
                public string CanFiller2 = "";
                /// <summary>
                /// 직전취소용필러3
                /// </summary>
                public string CanFiller3 = "";


                /// <summary>
                /// HP 예약필드(포인트조회 응답정보)
                /// </summary>
                public string HP_RESERVED = "";
                /// <summary>
                /// HP 캠페인정보(포인트조회 응답정보)
                /// </summary>
                public string HP_CAMPAIGN_INFO = "";
                /// <summary>
                /// HP 추가정보(포인트조회 응답정보)
                /// </summary>
                public string HP_ADD_INFO_SCH = "";
                /// <summary>
                /// HP 추가정보(포인트적립 응답정보)
                /// </summary>
                public string HP_ADD_INFO_SAVE = "";
                /// <summary>
                /// 고객명(포인트조회 응답정보)
                /// </summary>
                public string HP_CUST_NAME = "";
                ///// <summary>
                ///// 앱고객유형(N:일반, Y:앱고객)(포인트조회 응답정보)
                ///// </summary>
                //public string HP_CUST_TYPE = "N";
                /// <summary>
                /// 소멸예정 포인트(포인트조회 응답정보)
                /// </summary>
                public long HP_EXT_POINT = 0;
                ///// <summary>
                ///// HP 추가적립 정보[추가적립여부(1)+추가적립상세코드(2)+본사부담금(7)+매장부담금(7)](포인트조회 설정정보)
                ///// </summary>
                //public string HP_ADD_ACCUME = "";
                /// <summary>
                /// HP 추가정보(인카드쿠폰 조회 리스트)
                /// </summary>
                public ArrayList HP_CPN_INFO = null;
                /// <summary>
                /// 비밀번호 사용여부
                /// </summary>
                public string HP_PASSWORD_YN = "N";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {

            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 정산
        /// <summary>
        /// 정산 정보
        /// </summary>
        public class TR_ADMT
        {
            public const string ITEM = "TR_ADMT";

            public class DATA
            {
                /// <summary>
                /// 정산 유형
                /// </summary>
                public int ADMT_TYPE = 0;
                /// <summary>
                /// 정산 코드
                /// </summary>
                public int ADMT_CD = 0;
                /// <summary>
                /// 수량
                /// </summary>
                public int QTY = 0;
                /// <summary>
                /// 금액
                /// </summary>
                public int AMT = 0;
                /// <summary>
                /// 여유필드1
                /// </summary>
                public int SLACK_FIELD_01 = 0;
                /// <summary>
                /// 여유필드2
                /// </summary>
                public int SLACK_FIELD_02 = 0;
                /// <summary>
                /// 여유필드3
                /// </summary>
                public int SLACK_FIELD_03 = 0;
                /// <summary>
                /// 여유필드4
                /// </summary>
                public int SLACK_FIELD_04 = 0;
                /// <summary>
                /// 여유필드5
                /// </summary>
                public int SLACK_FIELD_05 = 0;

            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int ADMT_TYPE = 3;
                public const int ADMT_CD = 4;
                public const int QTY = 5;
                public const int AMT = 6; 
                public const int SLACK_FIELD_01 = 7;
                public const int SLACK_FIELD_02 = 8;
                public const int SLACK_FIELD_03 = 9;
                public const int SLACK_FIELD_04 = 10;
                public const int SLACK_FIELD_05 = 11;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 객수
        /// <summary>
        /// 객수정보
        /// </summary>
        public class TR_GUEST
        {
            public const string ITEM = "TR_GUEST";

            public class DATA
            {
                /// <summary>
                /// 남성 10대
                /// </summary>
                public int MALE_10L = 0;
                /// <summary>
                /// 남성 20대
                /// </summary>
                public int MALE_20L = 0;
                /// <summary>
                /// 남성 30대
                /// </summary>
                public int MALE_30L = 0;
                /// <summary>
                /// 남성 40대
                /// </summary>
                public int MALE_40L = 0;
                /// <summary>
                /// 남성 50대
                /// </summary>
                public int MALE_50L = 0;
                /// <summary>
                /// 여성 10대
                /// </summary>
                public int FMALE_10L = 0;
                /// <summary>
                /// 여성 20대
                /// </summary>
                public int FMALE_20L = 0;
                /// <summary>
                /// 여성 30대
                /// </summary>
                public int FMALE_30L = 0;
                /// <summary>
                /// 여성 20대
                /// </summary>
                public int FMALE_40L = 0;
                /// <summary>
                /// 여성 50대
                /// </summary>
                public int FMALE_50L = 0;

            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int MALE_10L = 3;
                public const int MALE_20L = 4;
                public const int MALE_30L = 5;
                public const int MALE_40L = 6;
                public const int MALE_50L = 7;
                public const int FMALE_10L = 8;
                public const int FMALE_20L = 9;
                public const int FMALE_30L = 10;
                public const int FMALE_40L = 11;
                public const int FMALE_50L = 12;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 예약 고객 정보
        /// <summary>
        /// 객수정보
        /// </summary>
        public class TR_RESERV_INFO
        {
            public const string ITEM = "TR_RESERV_INFO";

            public class DATA
            {
                /// <summary>
                /// 예약번호
                /// </summary>
                public string RESERV_NO = "";
                /// <summary>
                /// 주분구분 0:온라인,1:오프라인
                /// </summary>
                public string ONOFF_DIV = "";
                /// <summary>
                /// 예약고객번호
                /// </summary>
                public string CUSTNM = "";
                /// <summary>
                /// 예약고객전화번호
                /// </summary>
                public string CUST_PHN_NO = "";
                /// <summary>
                /// 예약일자
                /// </summary>
                public string RESERV_DT = "";
                /// <summary>
                /// 예약시간
                /// </summary>
                public string RESERV_TM = "";
                /// <summary>
                /// 예약메모(주소)
                /// </summary>
                public string RESERV_MEMO = "";
                /// <summary>
                /// 예약 등록 시간
                /// </summary>
                public string RESERV_REG_TM = "";
                /// <summary>
                /// 예약 등록 일자
                /// </summary>
                public string RESERV_REG_DT = "";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int RESERV_NO = 3;
                public const int RESERV_REG_DT = 4;
                public const int RESERV_REG_TM = 5;
                public const int ONOFF_DIV = 6;
                public const int CUSTNM = 7;
                public const int CUST_PHN_NO = 8;
                public const int RESERV_DT = 9;
                public const int RESERV_TM = 10;
                public const int RESERV_MEMO = 11;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 사인(전자서명)
        /// <summary>
        /// 사인(전자서명)
        /// </summary>
        public class TR_SIGN
        {
            public const string ITEM = "TR_SIGN";

            public class DATA
            {
                /// <summary>
                /// 순번
                /// </summary>
                public int SEQ = 0;
                /// <summary>
                /// 결제 순번
                /// </summary>
                public int PAY_SEQ = 0;
                /// <summary>
                /// 사인 시간
                /// </summary>
                public string SIGN_TIME = "";
                /// <summary>
                /// 사인 데이터
                /// </summary>
                public string SIGN_DATA = "";

            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {

            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 입출금(준비금, 마감시재, 기타입출금, 환불)
        /// <summary>
        /// 입출금
        /// </summary>
        public class SALE_DPST_WTHDR
        {
            public const string ITEM = "SALE_DPST_WTHDR";

            public class DATA
            {
                /// <summary>
                /// 순번
                /// </summary>
                public int SEQ = 0;
                /// <summary>
                /// 입출금일자
                /// </summary>
                public string SALE_DT = "";
                /// <summary>
                /// 입출금유형
                /// </summary>
                public string DPST_WTHDR_TYPE = "";
                /// <summary>
                /// 입출금코드
                /// </summary>
                public string DPST_WTHDR_CD = "";
                /// <summary>
                /// 입출금계정
                /// </summary>
                public string DPST_WTHDR_ACC_CD = "";
                /// <summary>
                /// 입출금금액
                /// </summary>
                public double DPST_WTHDR_AMT = 0;
                /// <summary>
                /// 입출금명
                /// </summary>
                public string DPST_WTHDR_NM = "";
                /// <summary>
                /// 입출금수량
                /// </summary>
                public int DPST_WTHDR_QTY = 0;
                /// <summary>
                /// 고객번호
                /// </summary>
                public string CUST_NO = "";
                /// <summary>
                /// 점포결제유형
                /// </summary>
                public string STOR_PAY_TYPE = "";
                /// <summary>
                /// 기타사유
                /// </summary>
                public string ETC_REASON = "";
                /// <summary>
                /// 여유필드01
                /// </summary>
                public string SLACK_FIELD_01 = "";
                /// <summary>
                /// 여유필드02
                /// </summary>
                public string SLACK_FIELD_02 = "";
                /// <summary>
                /// 여유필드03
                /// </summary>
                public string SLACK_FIELD_03 = "";
                /// <summary>
                /// 여유필드04
                /// </summary>
                public string SLACK_FIELD_04 = "";
                /// <summary>
                /// 여유필드05
                /// </summary>
                public string SLACK_FIELD_05 = "";

            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int DPST_WTHDR_TYPE = 3;
                public const int DPST_WTHDR_CD = 4;
                public const int DPST_WTHDR_QTY = 5;
                public const int DPST_WTHDR_AMT = 6;
                public const int DPST_WTHDR_NM = 7;
                public const int CUST_NO = 8;
                public const int STOR_PAY_TYPE = 9;
                public const int ETC_REASON = 10;
                public const int SLACK_FIELD_01 = 11;
                public const int SLACK_FIELD_02 = 12;
                public const int SLACK_FIELD_03 = 13;
                public const int SLACK_FIELD_04 = 14;
                public const int SLACK_FIELD_05 = 15;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 승인로그
        /// <summary>
        /// 승인 로그
        /// </summary>
        public class TR_APPR_LOG
        {
            public const string ITEM = "TR_APPR_LOG";

            public class DATA
            {


            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {

            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region 캠페인 아이템
        /// <summary>
        /// 캠페인 아이템
        /// </summary>
        public class TR_SALE_CPI_RSLT
        {
            public const string ITEM = "TR_SALE_CPI_RSLT";

            public class DATA
            {
                /// <summary>
                /// 켐페인 상품 마스터 정보
                /// </summary>
                public MST_SALE_CPI.DATA_ITEM cMST_CPI_ITEM = new MST_SALE_CPI.DATA_ITEM();
                /// <summary>
                /// 캠페인 타입(01:상품별, 02:상품합산, 03:결합, 04:N+N, 05:전체상품, 06:사은품)  
                /// </summary>
                public string ITEM_APPLY_METHD = "";
                /// <summary>
                /// 명세순번
                /// </summary>
                public long NMTAX_SEQ = 0;
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public string CPI_CD = "";
                /// <summary>
                /// SUB 점포코드
                /// </summary>
                public string SUB_SHOP_CD = "";
                /// <summary>
                /// 상품 PLU 코드
                /// </summary>
                public string ITEM_PLU_CD = "";
                /// <summary>
                /// 할인 수량(상품캠페인)
                /// </summary>
                public long DC_QTY = 0;
                /// <summary>
                /// 캠페인 할인 단가
                /// </summary>
                public double DC_PRC = 0;
                /// <summary>
                /// 캠페인 할인 합계 금액
                /// </summary>
                public double DC_SUM_AMT = 0;
                /// <summary>
                /// 캠페인 고객해택 구분(01:할인,02:적립,03:할인+적립,04:사은품,05:복권,06:명판,07:복권+명판,08:응모권,09:응모권+명판,10:스템프,11:할인(실효100%),12:사은품+적립,13:할인(실효))
                /// </summary>
                public string CPI_CUST_BNFT_TYPE = "";
                /// <summary>
                /// 고객결제유형(00:일반, 01:신용카드, 02:캐시비, 03:티머니)
                /// </summary>
                public string CUST_PAY_TYPE = "01";
                /// <summary>
                /// 추가적립 포인트
                /// </summary>
                public long ACCUM_POINT = 0;
                /// <summary>
                /// 복권/명판 번호  
                /// </summary>
                public string LTTR_NMPLAT_NO = "";
                /// <summary>
                /// 캠페인 고객 구분(1:전체, 2:HPC결제, 3:HPC고객, 4:해피앱고객)
                /// </summary>
                public string TRGT_CUST_TYPE = "";
                /// <summary>
                /// 빌분리 번호
                /// </summary>
                public long BILLSPR_NO = 0;
                /// <summary>
                /// 여유 필드(고객번호 설정)
                /// </summary>
                public string SLACK_FIELD = "";
                /// <summary>
                /// 취소 구분 
                /// </summary>
                public string CANCEL_DIV = "0";

                //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                // 실행중 내부 변수
                //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                /// <summary>
                /// 캠페인 결제할인구분 (1:결제, 2:할인)
                /// </summary>
                public string PAY_DC_DIV = "0";
                /// <summary>
                /// 캠페인 증정구분(사은품)
                /// </summary>
                public string PRESENT_DIV = "0";
                /// <summary>
                /// 기본룰 예외여부(0:일반, 1:예외)
                /// </summary>
                public string BASIC_RULE_EXCEP_YN = "";

                //#20171206 17크리스마스캠페인 start
                //항목 추가 (0:중복적용불가, 1:중복적용가능, 2: 중복적용가능(할인금액포함))
                /// <summary>
                /// 제휴할인그룹 중복 여부(1:중복적용가능, 0:중복적용불가, 2: 중복적용가능(할인금액포함))
                /// </summary>
                public string TELECOM_COOP_DUP_PRMT_YN = "";
                //#20171206 17크리스마스캠페인 end

                //#15583 캠페인 기능 개선 요청 start
                /// <summary>
                /// 모바일쿠폰 그룹 중복 여부(1:중복적용가능, 0:중복적용불가)
                /// </summary>
                public string MOBILE_CPN_DUP_PRMT_YN = "0";

                /// <summary>
                /// 해피쿠폰 중복 여부(1:중복적용가능, 0:중복적용불가)
                /// </summary>
                public string HPY_CPN_DUP_PRMT_YN = "0";
                //#15583 캠페인 기능 개선 요청 end

                /// 기본 HP 적립여부(0:적립없음, 1:적립가능)
                /// </summary>
                public string BASIC_HP_ACCUM_YN = "";
                /// <summary>
                /// 기본 HP 적립기준(0:적립안함, 1:행사상품포함, 2:행사상품제외, 3:사은품제외)
                /// </summary>
                public string BASIC_HP_ACCUM_STD = "";
                /// <summary>
                /// 복권 등수(복권캠페인)
                /// </summary>
                public string LTTR_GRADE = "";
                /// <summary>
                /// 중복 가능여부(1:중복적용 가능, 0:중복적용 불가)
                /// </summary>
                public string DUP_APPLY_YN = "1";
                /// <summary>
                /// 캠페인 상품 중복적용 여부(1:중복적용 가능, 0:중복적용 불가)
                /// </summary>
                public string ITEM_DUP_PRMT_YN = "";

                /// <summary>
                /// HP 스템프 오퍼 ID
                /// </summary>
                public string OFFER_ID = "";
                /// <summary>
                /// HP 스탬프 캠페인 상품 정보(포인트조회 설정정보)
                /// </summary>
                public string HP_STAMP_PLU = "";
                /// <summary>
                /// HP 스템프 캠페인 응답 정보(잔여정보)
                /// </summary>
                public string HP_CAMPAIGN_INFO = "";
                /// <summary>
                /// HP 스템프 캠페인 응답 정보(쿠폰발행정보)
                /// </summary>
                public string HP_STAMP_COUPON_INFO = "";
                /// <summary>
                /// HP 스템프 쿠폰 번호
                /// </summary>
                public string HP_STAMP_COUPON = "";
            }

            public class SEQ
            {
                public const int ITEM_APPLY_METHD = 3;
                public const int NMTAX_SEQ = 4;
                public const int CPI_CD = 5;
                public const int SUB_SHOP_CD = 6;
                public const int ITEM_PLU_CD = 7;
                public const int DC_QTY = 8;
                public const int DC_SUM_AMT = 9;
                public const int CPI_CUST_BNFT_TYPE = 10;
                public const int CUST_PAY_TYPE = 11;
                public const int ACCUM_POINT = 12;
                public const int LTTR_NMPLAT_NO = 13;
                public const int TRGT_CUST_TYPE = 14;
                public const int BILLSPR_NO = 15;
                public const int SLACK_FIELD = 16;
                public const int CANCEL_DIV = 17;
            }
        }
        #endregion

        #region 결제 캠페인 적용 정보
        /// <summary>
        /// 결제 캠페인 적용 정보
        /// </summary>
        public class SALE_CPI_PAY
        {
            public const string ITEM = "SALE_CPI_PAY";
        }
        #endregion

        #region 수량제한 캠페인 조회 정보
        /// <summary>
        /// 수량제한 캠페인 조회 정보
        /// </summary>
        public class SALE_CPI_QTY_LMT
        {
            public const string ITEM = "SALE_CPI_QTY_LMT";
        }
        #endregion

        #region 캠페인 등록정보
        /// <summary>
        /// 캠페인 등록정보
        /// </summary>
        public class MST_SALE_CPI
        {
            public class DATA
            {
                /// <summary>
                /// 캠페인
                /// </summary>
                public string CPI_CD = "";
                /// <summary>
                /// 캠페인명 
                /// </summary>
                public string CPI_NM = "";
                /// <summary>
                /// 시작일 
                /// </summary>
                public string STARTDAY = "";
                /// <summary>
                /// 종료일
                /// </summary>
                public string FNSHDAY = "";
                /// <summary>
                /// 반복 형태(1:지정주, 2:매월지정일)
                /// </summary>
                public string REPT_APPNT_TYPE = "";
                /// <summary>
                /// 반복 주차(11111:1주차,2주차,3주차,4주차,5주차) 
                /// </summary>
                public string REPT_WEEK = "";
                ///// <summary>
                ///// 반복 요일(1111111(일월화수목금토), 0:OFF, 1:ON)
                ///// </summary>
                //public string REPT_DOW = "";
                /// <summary>
                /// 반복 일자 
                /// </summary>
                public string REPT_DT = "";
                /// <summary>
                /// 캠페인 중복적용 여부 (1:중복적용 가능, 0:중복적용 불가) 
                /// </summary>
                public string DUP_APPLY_YN = "";
                /// <summary>
                /// 기본룰 예외 여부 
                /// </summary>
                public string BASIC_RULE_EXCEP_YN = "";

                //#20171206 17크리스마스캠페인 start
                //항목 추가 (0:중복적용불가, 1:중복적용가능, 2: 중복적용가능(할인금액포함))
                /// <summary>
                /// 제휴할인그룹 중복 여부(1:중복적용가능, 0:중복적용불가, 2: 중복적용가능(할인금액포함))
                /// </summary>
                public string TELECOM_COOP_DUP_PRMT_YN = "";
                //#20171206 17크리스마스캠페인 end

                //#15583 캠페인 기능 개선 요청 start
                /// <summary>
                /// 모바일쿠폰 그룹 중복 여부(1:중복적용가능, 0:중복적용불가)
                /// </summary>
                public string MOBILE_CPN_DUP_PRMT_YN = "0";

                /// <summary>
                /// 해피쿠폰 중복 여부(1:중복적용가능, 0:중복적용불가)
                /// </summary>
                public string HPY_CPN_DUP_PRMT_YN = "0";
                //#15583 캠페인 기능 개선 요청 end

                ///// <summary>
                ///// 쿠폰할인그룹 중복 여부 
                ///// </summary>
                //public string CPNDC_GRP_DUP_YN = "";
                ///// <summary>
                ///// 일반할인그룹 중복 여부 
                ///// </summary>
                //public string GNRL_DC_GRP_DUP_YN = "";
                /// <summary>
                /// 캠페인 대상(1:전체, 2:HPC결제, 3:HPC고객, 4:해피앱고객) 
                /// </summary>
                public string TRGT_CUST_TYPE = "";
                /// <summary>
                /// 캠페인고객혜택(01:할인,02:적립,03:할인+적립,04:사은품,05:복권,06:명판,07:복권+명판,08:응모권,09:응모권+명판,10:스템프,11:할인(실효100%),12:사은품+적립,13:할인(실효)) 
                /// </summary>
                public string CPI_CUST_BNFT_TYPE = "";
                /// <summary>
                /// 상품 적용 방법(01:상품별, 02:상품합산, 03:결합, 04:N+N, 05:전체상품, 06:사은품) 
                /// </summary>
                public string ITEM_APPLY_METHD = "";
                /// <summary>
                /// 지불 구분(00:일반, 01:신용카드, 02:캐시비, 03:티머니)
                /// </summary>
                public string CUST_PAY_TYPE = "";
                /// <summary>
                /// 캠페인성립금액 구분(1:구매금액(총매출), 2:대상상품, 3:구매금액+대상상품) 
                /// </summary>
                public string TRGT_AMT_TYPE = "";
                /// <summary>
                /// 캠페인성립금액 
                /// </summary>
                public double TRGT_AMT = 0;
                /// <summary>
                /// 제한 수량
                /// </summary>
                public long LMT_QTY = 0;
                /// <summary>
                /// 수량 제한 기준(1:일별, 2:행사기간별)
                /// </summary>
                public string QTY_LMT_STD = "";
                /// <summary>
                /// HP고객 최대 참여 횟수 
                /// </summary>
                public long HP_CUST_MAX_JOIN_CNT = 0;
                /// <summary>
                /// HP고객 참여 제한 기준(1:일별, 2:행사기간별) 
                /// </summary>
                public string HP_CUST_JOIN_LMT_STD = "";
                /// <summary>
                /// HPC기본적립 기준(0:적립없음, 1:적립가능)
                /// </summary>
                public string BASIC_HP_ACCUM_YN = "";
                /// <summary>
                /// HPC기본적립 구분(0:적립안함,1:적립함,2:행사 상품 제외)
                /// </summary>
                public string BASIC_HP_ACCUM_STD = "";
                /// <summary>
                /// HP추가적립 통신사 구분(0: 일반, 1: SKT, 2: KT,3: LGT)
                /// </summary>
                public string ADD_HP_ACCUM_TELECOM_DIV = "";
                /// <summary>
                /// HPC추가적립 대상기준(0:적립없음, 1:BILL전체, 2:대상상품, 3:행사대상외 구매상품) 
                /// </summary>
                public string ADD_HP_ACCUM_TRGT_STD = "";
                /// <summary>
                /// HPC추가적립 율 
                /// </summary>
                public double ADD_HP_ACCUM_RATE = 0;
                /// <summary>
                /// HPC추가적립 추후적립 가능여부 
                /// </summary>
                public string ADD_HP_ACCUM_AF_DIV = "";
                /// <summary>
                /// HPC추가적립 코드1
                /// </summary>
                public string ADD_HP_ACCUM_CD1 = "";
                /// <summary>
                /// HPC추가적립 코드2 
                /// </summary>
                public string ADD_HP_ACCUM_CD2 = "";
                /// <summary>
                /// OFFER ID(스템프 행사시 클라우드 전송)
                /// </summary>
                public string OFFER_ID = "";
                /// <summary>
                /// 사은품 지급기준(0:대상 아님, 1:금액당 개수, 2:최소금액 이상 개수, 3:수량당 갯수) 
                /// </summary>
                public string FREE_GIFT_PROVD_STD = "";
                /// <summary>
                /// 사은품 지급기준 금액 
                /// </summary>
                public double FREE_GIFT_STD_AMT = 0;
                /// <summary>
                /// 사은품 지급 수량 
                /// </summary>
                public long FREE_GIFT_PROVD_QTY = 0;
                /// <summary>
                /// 사은품 추가판매 여부(1:가능, 0:불가) 
                /// </summary>
                public string FREE_GIFT_ADD_SALE_YN = "";
                /// <summary>
                /// 캠페인 설명 
                /// </summary>
                public string CPI_EXPLN = "";
                /// <summary>
                /// 고객면 리소스 파일 구분(1:이미지, 2:동영상) 
                /// </summary>
                public string CUST_DSP_FILE_DIV = "";
                /// <summary>
                /// 고객면 리소스 파일명 
                /// </summary>
                public string CUST_DSP_FILENM = "";
                /// <summary>
                /// 스템프 수량
                /// </summary>
                public long STAMP_QTY = 0;
                /// <summary>
                /// 사운드파일 구분(00(없음), 01(WAVE), 02(TTS))
                /// </summary>
                public string SOUND_FILE_DIV = "";
                /// <summary>
                /// 사운드파일 명 
                /// </summary>
                public string SOUND_FILE_NM = "";
                /// <summary>
                /// TTS 출력 문구 
                /// </summary>
                public string TTS_DSCRP = "";
                /// <summary>
                /// 파일 PLAY 시점 (1:상품등록, 2:캠페인성립)
                /// </summary>
                public string SOUND_FILE_PLAY_CHK_PNT = "";
                /// <summary>
                /// 사운드 플레이 여부
                /// </summary>
                public bool SOUND_PLAY_YN = false;
                /// <summary>
                /// 참여문의여부
                /// </summary>
                public string JOIN_QUSTN_YN = "";
                /// <summary>
                /// 참여문의여부 결과
                /// </summary>
                public string JOIN_QUSTN_ANSWER = "";
                /// <summary>
                /// 상품 중복 허용 여부(1:중복적용 가능, 0:중복적용 불가) 
                /// </summary>
                public string ITEM_DUP_PRMT_YN = "";
                /// <summary>
                /// 복권 멀티 출력 여부(0:멀티불가, 1:멀티허용)
                /// </summary>
                public string LTTR_MULTI_PRT_YN = "";
                /// <summary>
                /// 캠페인 할인 결제 수단
                /// </summary>
                public string CPI_DC_PAY_WAY = "";
                /// <summary>
                /// 캠페인 영수증명
                /// </summary>
                public string CPI_BILL_NM = "";
                /// <summary>
                /// 캠페인 수량제한메시지
                /// </summary>
                public string QTY_LIMIT_MSG = "";
                /// <summary>
                /// 해피 고객 등급
                /// </summary>
                public string HP_CUST_LVL = "";
                /// <summary>
                /// 할인불가적용여부(0:할인불가미적용, 1:할인불가적용)
                /// </summary>
                public string DC_NOADM_PASS_YN = "";
                /// <summary>
                /// 켐페인 시간
                /// </summary>
                public ArrayList alDATA_HOUR = new ArrayList();
                /// <summary>
                /// 캠페인 구성
                /// </summary>
                public ArrayList alDATA_COMPNT = new ArrayList();
            }

            /// <summary>
            /// 캠페인시간 
            /// </summary>
            public class DATA_HOUR
            {
                /// <summary>
                /// 요일 구분(1:일요일, 2:월요일 ~ 7:토요일)  
                /// </summary>
                public string DOW_DIV = "";
                /// <summary>
                /// 시작 시간 
                /// </summary>
                public string START_HOUR = "";
                /// <summary>
                /// 종료 시간 
                /// </summary>
                public string FNSH_HOUR = "";
            }

            /// <summary>
            /// 캠페인 구성 
            /// </summary>
            public class DATA_COMPNT
            {
                /// <summary>
                /// 구성 그룹
                /// </summary>
                public string CPI_ITEM_GRP_CD = "";
                /// <summary>
                /// 구성조건 유형(1:수량, 2:금액, 3:최소수량)
                /// </summary>
                public string CPI_COND_TYPE = "";
                /// <summary>
                /// 구성조건 수량,금액
                /// </summary>
                public double QTY_AMT = 0;
                /// <summary>
                /// 구성 할인유형(1:율, 2:금액)
                /// </summary>
                public string CPI_DC_TYPE = "";
                /// <summary>
                /// 구성 할인 율,금액
                /// </summary>
                public double DC_RATE_QTY_AMT = 0;
                /// <summary>
                /// 할인 최대 금액
                /// </summary>
                public double DC_MAX_AMT = 0;
            }

            public class DATA_ITEM
            {
                /// <summary>
                /// 상품구성그룹 
                /// </summary>
                public string CPI_ITEM_GRP_CD = "";
                /// <summary>
                /// 캠페인 할인 유형
                /// </summary>
                public string CPI_DC_TYPE = "";
                /// <summary>
                /// 캠페인 할인 율,금액 
                /// </summary>
                public double DC_RATE_AMT = 0;
            }
        }
        #endregion

        #region 층 정보
        /// <summary>
        /// 층 정보
        /// </summary>
        public class MST_FLOOR
        {
            public class FLOOR_DATA
            {
                /// <summary>
                /// 층코드 
                /// </summary>
                public string FLOOR_CD = string.Empty;
                /// <summary>
                /// 층명 
                /// </summary>
                public string FLOOR_NM = string.Empty;

                /// <summary>
                /// 수정일시
                /// </summary>
                public string UPD_DT = string.Empty;
                /// <summary>
                /// 등록일시 
                /// </summary>
                public string REG_DT = string.Empty;
                /// <summary>
                /// 상태 
                /// </summary>
                public PosConst.DB_ROW_STATUS STATUS = PosConst.DB_ROW_STATUS.NONE;
            }
        }
        #endregion

        #region 테이블 정보
        /// <summary>
        /// 테이블 정보
        /// </summary>
        public class MST_TABLE
        {
            public class TABLE_DATA
            {
                /// <summary>
                /// 층 코드
                /// </summary>
                public string FLOOR_CD = string.Empty;
                /// <summary>
                /// 테이블 번호
                /// </summary>
                public string TABLE_NO = string.Empty;
                /// <summary>
                /// 테이블 명
                /// </summary>
                public string TABLE_NM = string.Empty;
                /// <summary>
                /// 테이블 유형(1:테이블, 2:레이블)
                /// </summary>
                public string TABLE_TYPE = string.Empty;
                /// <summary>
                /// 테이블 형태(1:사각, 2:라운드, 3:타원, 4:이미지)
                /// </summary>
                public string TABLE_TYPE__1640 = string.Empty;
                /// <summary>
                /// 배경색
                /// </summary>
                public string BACK_COLOR = string.Empty;
                /// <summary>
                /// 배경이미지
                /// </summary>
                public string BACK_IMAGE = string.Empty;
                /// <summary>
                /// 폰트 색상
                /// </summary>
                public string FONT_COLOR = string.Empty;
                /// <summary>
                /// 폰트 명
                /// </summary>
                public string FONT_NM = string.Empty;
                /// <summary>
                /// 폰트 크기
                /// </summary>
                public int FONT_SIZE = 0;
                /// <summary>
                /// X 좌표
                /// </summary>
                public int X_COORD = 0;
                /// <summary>
                /// Y 좌표
                /// </summary>
                public int Y_COORD = 0;
                /// <summary>
                /// 넓이
                /// </summary>
                public int WIDTH = 0;
                /// <summary>
                /// 높이
                /// </summary>
                public int HEIGHT = 0;
                /// <summary>
                /// 테이블 표시 구분
                /// </summary>
                public string TABLE_DISP_FLAG = string.Empty;
                /// <summary>
                /// 좌석 수
                /// </summary>
                public int SEAT_CNT = 0;
                /// <summary>
                /// 좌석 수 표시 구분
                /// </summary>
                public string SEAT_DISP_FLAG = string.Empty;
                /// <summary>
                /// 테이블 조작 구분
                /// </summary>
                public string OP_FLAG = string.Empty;
                /// <summary>
                /// 조작 층 구분
                /// </summary>
                public string OP_FLOOR_CD = string.Empty;
                /// <summary>
                /// 조작 테이블 번호
                /// </summary>
                public string OP_TABLE_NO = string.Empty;
                /// <summary>
                /// 테이블 사용 구분
                /// </summary>
                public string USE_FLAG = string.Empty;
                /// <summary>
                /// 고객수
                /// </summary>
                public int CUST_CNT = 0;
                /// <summary>
                /// 최초 주문 시간
                /// </summary>
                public string FIRST_ORDER_TIME = string.Empty;
                /// <summary>
                /// 주문금액
                /// </summary>
                public double ORDER_AMT = 0;
                /// <summary>
                /// 예약 구분
                /// </summary>
                public string RESERVATION_FLAG = string.Empty;
                /// <summary>
                /// 예약 시간
                /// </summary>
                public string RESERVATION_TIME = string.Empty;
                /// <summary>
                /// 주문 칼라
                /// </summary>
                public string ORDER_COLOR = string.Empty;
                /// <summary>
                /// 결제완료 칼라
                /// </summary>
                public string PAY_COMPLETE_COLOR = string.Empty;
                /// <summary>
                /// 결제완료 구분
                /// </summary>
                public string PAY_COMPLETE_FLAG = string.Empty;

                /// <summary>
                /// 수정일시
                /// </summary>
                public string UPD_DT = string.Empty;
                /// <summary>
                /// 등록일시 
                /// </summary>
                public string REG_DT = string.Empty;
                /// <summary>
                /// 상태 (추가,수정,삭제)
                /// </summary>
                public PosConst.DB_ROW_STATUS STATUS = PosConst.DB_ROW_STATUS.NONE;

                /// <summary>
                /// 상품총 수량
                /// </summary>
                public int SALE_QTY = 0; 
                /// <summary>
                /// 테이블 출력용 상품목록 
                /// </summary>
                public string ITEM_LIST = string.Empty;

                /// <summary>
                /// 객층정보 (FILLER1 = m_cTrnStatus.Head.PayGndrDiv + "|" + m_cTrnStatus.Head.PayAge)
                /// </summary>
                public string CUST_AGE = string.Empty;
                /// <summary>
                /// 고객상세정보 (FILLER2)
                /// </summary>
                public string CUST_LST = string.Empty;

                /// <summary>
                /// 메모존재여부 
                /// </summary>
                public bool IsMemo = false; 
                /// <summary>
                /// 테이블 그룹 Index
                /// </summary>
                public int TABLE_GROUP_INDEX = -1;

                /// <summary>
                /// 주문담당자
                /// </summary>
                public string ORD_PIC_NM = string.Empty;

                public string GetGroupIndex()
                {
                    return TABLE_GROUP_INDEX > 0 ? TABLE_GROUP_INDEX.ToString() : string.Empty;
                }
            }

            public class TABLE_ITEM
            {
                /// <summary>
                /// 층 코드
                /// </summary>
                public string FLOOR_CD = string.Empty;
                /// <summary>
                /// 테이블 번호
                /// </summary>
                public string TABLE_NO = string.Empty;
                /// <summary>
                /// 순번
                /// </summary>
                public int SEQ = 0;
                /// <summary>
                /// 상품 코드
                /// </summary>
                public string ITEM_PLU_CD = string.Empty;
                /// <summary>
                /// 상품 구분(0:일반, 1:세트)
                /// </summary>
                public string ITEM_DIV = string.Empty;
                /// <summary>
                /// 판매 수량
                /// </summary>
                public int SALE_QTY = 0;
                /// <summary>
                /// 판매 단가
                /// </summary>
                public double SALE_PRC = 0;
                /// <summary>
                /// 판매 금액
                /// </summary>
                public double SALE_AMT = 0;
                /// <summary>
                /// 영수 금액
                /// </summary>
                public double BILL_AMT = 0;
                /// <summary>
                /// 할인 구분(00:정상, 01:무료(서비스), 02:임의할인, 03:환경사랑DC, 04:제품교환권, 05:케익교환권, 06:입점업체할인, 07:수수료할인)
                /// </summary>
                public string DC_DIV = string.Empty;
                /// <summary>
                /// 할인 율
                /// </summary>
                public double DC_RATE = 0;
                /// <summary>
                /// 상품 할인 금액
                /// </summary>
                public double ITEM_DC_AMT = 0;
                /// <summary>
                /// 소계 할인 금액
                /// </summary>
                public double SUM_DC_AMT = 0;
                /// <summary>
                /// 캠페인 할인 금액
                /// </summary>
                public double CPI_DC_AMT = 0;
                /// <summary>
                /// 제휴카드 할인 구분
                /// </summary>
                public string COOP_CARD_DC_DIV = string.Empty;
                /// <summary>
                /// 제휴카드 할인 금액
                /// </summary>
                public double COOP_CARD_DC_AMT = 0;
                /// <summary>
                /// 포인트 할인 구분
                /// </summary>
                public string POINT_DC_DIV = string.Empty;
                /// <summary>
                /// 포인트 할인 금액
                /// </summary>
                public double POINT_DC_AMT = 0;
                /// <summary>
                /// 쿠폰 할인 구분
                /// </summary>
                public string CPN_DC_DIV = string.Empty;
                /// <summary>
                /// 쿠폰 할인 금액
                /// </summary>
                public double CPN_DC_AMT = 0;
                /// <summary>
                /// 직원 할인 구분
                /// </summary>
                public string EMP_DC_DIV = string.Empty;
                /// <summary>
                /// 직원 할인 금액
                /// </summary>
                public double EMP_DC_AMT = 0;
                /// <summary>
                /// 세트 할인 금액
                /// </summary>
                public double SET_DC_AMT = 0;
                /// <summary>
                /// 기타 할인 구분
                /// </summary>
                public string ETC_DC_DIV = string.Empty;
                /// <summary>
                /// 기타 상품 할인
                /// </summary>
                public double ETC_DC = 0;
                /// <summary>
                /// 포장 구분
                /// </summary>
                public string PACK_DIV = string.Empty;
                /// <summary>
                /// 세트메뉴코드
                /// </summary>
                public string SET_MENU_CD = string.Empty;
                /// <summary>
                /// 캠페인 증정 구분
                /// </summary>
                public string CPI_PRESENT_DIV = string.Empty;
                /// <summary>
                /// 주문 메시지1
                /// </summary>
                public string MSG1 = string.Empty;
                /// <summary>
                /// 주문 메시지2
                /// </summary>
                public string MSG2 = string.Empty;
                /// <summary>
                /// 주문 메시지3
                /// </summary>
                public string MSG3 = string.Empty;
                /// <summary>
                /// 메시지 등록 시간
                /// </summary>
                public string MSG_REG_TIME = string.Empty;
                /// <summary>
                /// 주문 시간
                /// </summary>
                public string ORD_TIME = string.Empty;
                /// <summary>
                /// 주문 완료 구분
                /// </summary>
                public string ORD_COMP_DIV = string.Empty;
                /// <summary>
                /// 주문 담당자 번호
                /// </summary>
                public string ORD_PIC_NO = string.Empty;
                /// <summary>
                /// 주문 담당자 명
                /// </summary>
                public string ORD_PIC_NM = string.Empty;
                /// <summary>
                /// 취소 구분
                /// 0:정상, 1:지정취소, 2:소계후 취소
                /// </summary>
                public string CANCEL_DIV = string.Empty;
                /// <summary>
                /// 취소 일시
                /// </summary>
                public string CANCEL_DATE = string.Empty;
                /// <summary>
                /// 상품 명
                /// </summary>
                public string ITEM_NM = string.Empty;
            }
        }
        #endregion

        #region 해피오더 정보
        public class TR_HPORD
        {
            public class HPORD_HEADER
            {
                /// <summary>
                /// 주문번호
                /// </summary>
                public string OrderNum;
                /// <summary>
                /// 결제모듈주문번호
                /// </summary>
                public string OrderPgNum;
                /// <summary>
                /// 주문자명
                /// </summary>
                public string OwnerName;
                /// <summary>
                /// 주문금액
                /// </summary>
                public string OrderMoney;
                /// <summary>
                /// 결제금액
                /// </summary>
                public string PayMoney;
                /// <summary>
                /// 해피포인트 사용금액
                /// </summary>
                public string HappyUseMoney;
                /// <summary>
                /// 수령자명
                /// </summary>
                public string Receiver;
                /// <summary>
                /// 수령자핸드폰
                /// </summary>
                public string ReceiverHp;
                /// <summary>
                /// 주문일자
                /// </summary>
                public string OrderDate;
                /// <summary>
                /// 결제진행상태(1:결제중, 2:결제완료, 3:결제취소, 5:현장주문)
                /// </summary>
                public string PayStatus;
                /// <summary>
                /// 상태값(주문접수:4, 상품준비:5, 픽업대기:7, 픽업완료:8)
                /// </summary>
                public string OrderStatus;
                /// <summary>
                /// 픽업시간
                /// </summary>
                public string PickupTime;
                /// <summary>
                /// 주문타입(1:매장즉시,2:매장시간,3:예약주문, 4:내부배달, 5:외부배달, 6:사전예약)
                /// </summary>
                public string OrderType;
                /// <summary>
                /// 현금영수증 발급용 공급가액
                /// </summary>
                public string CashSupplyPrice;
                /// <summary>
                /// 현금영수증 발급용 부가세
                /// </summary>
                public string CashSurTax;
                /// <summary>
                /// 고객요청사항
                /// </summary>
                public string CustMsg;
                /// <summary>
                /// 픽업/배달 D-Day
                /// </summary>
                public string DDay;
                /// <summary>
                /// 현장결제(Y:현장결제, N:그 외)
                /// </summary>
                public string FieldPay;
                /// <summary>
                /// 배송기사명
                /// </summary>
                public string DeliveryName;
                /// <summary>
                /// 배송기사연락처
                /// </summary>
                public string DeliveryHp;
                /// <summary>
                /// ownerId
                /// </summary>
                public string OwnerId;                //#10906_[BR] 요기요 해피오더 매출 처리 기능 개발_hs
                /// <summary>
                /// ownerId
                /// </summary>
                public string Channel;                //#11078_[공통] 해피오더 외부채널 표시 방식 변경 적용 요청_hs
                /// <summary>
                /// ownerId
                /// </summary>
                public string ChannelName;            //#11078_[공통] 해피오더 외부채널 표시 방식 변경 적용 요청_hs
                //17.08.22 dkshin SS 해피오더
                /// <summary>
                /// 대기번호
                /// </summary>
                public string DailyCode;

                //grayber20180201 해피오더 고객정보 추가 + 원산지 표기 #13780 start
                /// <summary>
                /// 주소지 정보 1
                /// </summary>
                public string Address1;
                /// <summary>
                /// 주소지 정보 2
                /// </summary>
                public string Address2;
                //grayber20180201 해피오더 고객정보 추가 + 원산지 표기 #13780 end

                //#20180612 해피오더 주문알림 start
                public string immediateOrder;
                //#20180612 해피오더 주문알림 end
            }

            public class HPORD_ITEM
            {
                /// <summary>
                /// 주문번호
                /// </summary>
                public string OrderNum;
                /// <summary>
                /// 순번
                /// </summary>
                public string OrderSeq;
                /// <summary>
                /// 상품코드
                /// </summary>
                public string GoodsCode;
                /// <summary>
                /// 상품 바코드
                /// </summary>
                public string Barcode;
                /// <summary>
                /// 상품명
                /// </summary>
                public string GoodsName;
                /// <summary>
                /// 원가
                /// </summary>
                public string SupplyPrice;
                /// <summary>
                /// 판매가
                /// </summary>
                public string SalePrice;
                /// <summary>
                /// 할인가
                /// </summary>
                public string DiscountPrice;
                /// <summary>
                /// 수량
                /// </summary>
                public string Qty;
                /// <summary>
                /// 플레이버 명
                /// </summary>
                public string FlavourName;
                /// <summary>
                /// 플레이버 구분
                /// </summary>
                public string FlavourFlag;
                /// <summary>
                /// 현금영수증 공급가액(부가세제외상품가 * ea)
                /// </summary>
                public string CashTotSupplyPrice;
                /// <summary>
                /// 현금영수증 부가세(부가세 * ea)
                /// </summary>
                public string CashTotSurTax;
                //17.08.22 dkshin SS 해피오더
                /// <summary>
                /// 픽업시간
                /// </summary>
                public string PickupTime;
                //17.08.22 dkshin SS 해피오더
                /// <summary>
                /// 대기번호
                /// </summary>
                public string DailyCode;
            }
         
            //#16366 해피오더 당월누적주문내역 + 당일 해피오더주문 상세내역 자동 출력기능 start
            public class HPORD_MONTHPRT
            {

                /// <summary>
                /// 픽업) 취소 주문은 제외한 주문 카운트
                /// </summary>
                public string pickupOrderCnt;

                /// <summary>
                /// 픽업) 상품 할인 금액을 포함한 실판매가 합계
                /// </summary>
                public string pickupSalePriceTot;

                /// <summary>
                /// 픽업) 상품 할인 금액을 제외한 원가 합계
                /// </summary>
                public string pickupOrgPriceTot;

                /// <summary>
                /// 배달) 취소 주문은 제외한 주문 카운트
                /// </summary>
                public string deliveryOrderCnt;

                /// <summary>
                /// 배달) 상품 할인 금액을 포함한 실판매가 합계
                /// </summary>
                public string deliverySalePriceTot;

                /// <summary>
                /// 배달) 상품 할인 금액을 제외한 원가 합계
                /// </summary>
                public string deliveryOrgPriceTot;
            }
            //#16366 해피오더 당월누적주문내역 + 당일 해피오더주문 상세내역 자동 출력기능 end
        }
        #endregion

        #region 한국공항공사 I/F 정보
        /// <summary>
        /// 영수증정보_HEADER(매출정보)
        /// </summary>
        public class KACReceiptHeader
        {
            private string m_sTranType;     // 매출구분(4)
            public string TRAN_TYPE { get { return m_sTranType; } set { m_sTranType = string.Format("{0, -4}", value); } }

            private string m_sConNo;        // 계약번호(10) (ERP상의 계약 번호)
            public string CON_NO { get { return m_sConNo; } set { m_sConNo = string.Format("{0, -10}", value); } }

            private string m_sSaleDt;       // 영업일자(8)
            public string SALE_DT { get { return m_sSaleDt; } set { m_sSaleDt = string.Format("{0, -8}", value); } }

            private string m_sStoreCd;      // 매장정보(10)
            public string STORE_CD { get { return m_sStoreCd; } set { m_sStoreCd = string.Format("{0, -10}", value); } }

            private string m_sPosNo;        // POS번호(10)
            public string POS_NO { get { return m_sPosNo; } set { m_sPosNo = string.Format("{0, -10}", value); } }

            private string m_sReceiptSeq;   // 등록순번(5) (계약번호+영업일자+점번호+POS번호 로 순차적으로 증가되는 값
            public string RECEIPT_SEQ { get { return m_sReceiptSeq; } set { m_sReceiptSeq = string.Format("{0, -5}", value); } }

            private string m_sReceiptNo;    // 영수증번호(30)
            public string RECEIPT_NO { get { return m_sReceiptNo; } set { m_sReceiptNo = string.Format("{0, -30}", value); } }

            private string m_sItemQty;      // ITEM개수(5)
            public string ITEM_QTY { get { return m_sItemQty; } set { m_sItemQty = string.Format("{0, -5}", value); } }

            private string m_sSaleTm;       // 매출시간(6) (HH24MMSS)
            public string SALE_TM { get { return m_sSaleTm; } set { m_sSaleTm = string.Format("{0, -6}", value); } }

            private string m_sCancelYn;     // 취소여부(1) (0:정상, 1:취소)
            public string CANCEL_YN { get { return m_sCancelYn; } set { m_sCancelYn = string.Format("{0, -1}", value); } }

            private string m_sTotAmt;       // 총금액(15) 
            public string TOT_AMT
            {
                get { return m_sTotAmt; }
                set { m_sTotAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sSaleAmt;      // 매가금액(15) (공급가액)
            public string SALE_AMT
            {
                get { return m_sSaleAmt; }
                set { m_sSaleAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sTaxAmt;       // 부가세금액(15)
            public string TAX_AMT
            {
                get { return m_sTaxAmt; }
                set { m_sTaxAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sCashAmt;      // 현금금액(15)
            public string CASH_AMT
            {
                get { return m_sCashAmt; }
                set { m_sCashAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sCardAmt;      // 카드금액(15)
            public string CARD_AMT
            {
                get { return m_sCardAmt; }
                set { m_sCardAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sEtcAmt;       // 기타금액(15)
            public string ETC_AMT
            {
                get { return m_sEtcAmt; }
                set { m_sEtcAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sCashYn;       // 현금여부(1) (0:복합결제, 1:현금결제만)
            public string CASH_YN { get { return m_sCashYn; } set { m_sCashYn = string.Format("{0, -15}", value); } }

            private string m_sCashReceiptYn;// 현금영수증발행여부(1) (0:발행, 1:미발행)
            public string CASH_RECEIPT_YN { get { return m_sCashReceiptYn; } set { m_sCashReceiptYn = string.Format("{0, -1}", value); } }

            private string m_sBuyNm;        // 구매자명(20)
            public string BUY_NM { get { return m_sBuyNm; } set { m_sBuyNm = string.Format("{0, -20}", value); } }

            private string m_sBuyCounCd;    // 구매자국적코드(3)
            public string BUY_COUN_CD { get { return m_sBuyCounCd; } set { m_sBuyCounCd = string.Format("{0, -3}", value); } }

            private string m_sBuySexCd;     // 구매자성별(1) (0:남, 1:여, 9:기타)
            public string BUY_SEX_CD { get { return m_sBuySexCd; } set { m_sBuySexCd = string.Format("{0, -1}", value); } }

            private string m_sBuyBirthday;  // 구매자생년월일(8) (YYYYMMDD, 없으면 '+0000000')
            public string BUY_BIRTHDAY { get { return m_sBuyBirthday; } set { m_sBuyBirthday = string.Format("{0, -8}", value); } }

            private string m_sBuyAge;       // 구매자나이(5) (없으면 '+0000')
            public string BUY_AGE { get { return m_sBuyAge; } set { m_sBuyAge = string.Format("{0, -5}", value); } }

            private string m_sAirNo;        // 편명(20)
            public string AIR_NO { get { return m_sAirNo; } set { m_sAirNo = string.Format("{0, -20}", value); } }

            private string m_sCreateDt;     // 영수증생성일자(14) (YYYYMMDDHHMMSS)
            public string CREATE_DT { get { return m_sCreateDt; } set { m_sCreateDt = string.Format("{0, -14}", value); } }
        }
        /// <summary>
        /// 영수증정보_ITEM(매출정보)
        /// </summary>
        public class KACReceiptItem
        {
            private string m_sConNo;        // 계약번호(10) (ERP상의 계약 번호)
            public string CON_NO { get { return m_sConNo; } set { m_sConNo = string.Format("{0, -10}", value); } }

            private string m_sSaleDt;       // 영업일자(8)
            public string SALE_DT { get { return m_sSaleDt; } set { m_sSaleDt = string.Format("{0, -8}", value); } }

            private string m_sStoreCd;      // 매장정보(10)
            public string STORE_CD { get { return m_sStoreCd; } set { m_sStoreCd = string.Format("{0, -10}", value); } }

            private string m_sPosNo;        // POS번호(10)
            public string POS_NO { get { return m_sPosNo; } set { m_sPosNo = string.Format("{0, -10}", value); } }

            private string m_sReceiptNo;    // 영수증번호(30)
            public string RECEIPT_NO { get { return m_sReceiptNo; } set { m_sReceiptNo = string.Format("{0, -30}", value); } }

            private string m_sProcSeq;      // 단품SEQ(8)
            public string PROC_SEQ { get { return m_sProcSeq; } set { m_sProcSeq = string.Format("{0, -8}", value); } }

            private string m_sProdCd;       // 단품코드(20)
            public string PROD_CD { get { return m_sProdCd; } set { m_sProdCd = string.Format("{0, -20}", value); } }

            private string m_sProdNm;       // 단품명(100)
            public string PROD_NM { get { return m_sProdNm; } set { m_sProdNm = string.Format("{0, -100}", value); } }

            private string m_sQty;          // 수량(5)
            public string QTY { get { return m_sQty; } set { m_sQty = string.Format("{0:00000}", int.Parse(value)); } }

            private string m_sUnitPrice;    // 단가(15)
            public string UNIT_PRICE { get { return m_sUnitPrice; } set { m_sUnitPrice = string.Format("{0:000000000000000}", double.Parse(value)); } }

            private string m_sAmt;          // 가격(15)
            public string AMT { get { return m_sAmt; } 
                                set { m_sAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); } }

            private string m_sCreateDt;     // 영수증등록일시(14)
            public string CREATE_DT { get { return m_sCreateDt; } set { m_sCreateDt = string.Format("{0, -14}", value); } }
            
        }
        /// <summary>
        /// 마감정보
        /// </summary>
        public class KACCalcData
        {
            private string m_sTranType;     // 매출구분(4)
            public string TRAN_TYPE { get { return m_sTranType; } set { m_sTranType = string.Format("{0, -4}", value); } }

            private string m_sConNo;        // 계약번호(10) (ERP상의 계약 번호)
            public string CON_NO { get { return m_sConNo; } set { m_sConNo = string.Format("{0, -10}", value); } }

            private string m_sSaleDt;       // 마감일자(8)
            public string SALE_DT { get { return m_sSaleDt; } set { m_sSaleDt = string.Format("{0, -8}", value); } }

            private string m_sStoreCd;      // 매장정보(10)
            public string STORE_CD { get { return m_sStoreCd; } set { m_sStoreCd = string.Format("{0, -10}", value); } }

            private string m_sPosNo;        // POS번호(10)
            public string POS_NO { get { return m_sPosNo; } set { m_sPosNo = string.Format("{0, -10}", value); } }

            private string m_sReceiptSeq;   // 등록순번(5) (계약번호+영업일자+점번호+POS번호 로 순차적으로 증가되는 값
            public string RECEIPT_SEQ { get { return m_sReceiptSeq; } set { m_sReceiptSeq = string.Format("{0, -5}", value); } }

            private string m_sReceiptNo;    // 영수증번호(30)
            public string RECEIPT_NO { get { return m_sReceiptNo; } set { m_sReceiptNo = string.Format("{0, -30}", value); } }

            private string m_sSaleTm;       // 매출일시(6)
            public string SALE_TM { get { return m_sSaleTm; } set { m_sSaleTm = string.Format("{0, -6}", value); } }

            private string m_sReceiptQty;   // 영수증발행수(10) (당일 발행한 총 영수증 건수)
            public string RECEIPT_QTY { get { return m_sReceiptQty; } set { m_sReceiptQty = string.Format("{0:0000000000}", int.Parse(value)); } }

            private string m_sTotalAmt;     // 총금액(15)
            public string TOTAL_AMT
            {
                get { return m_sTotalAmt; }
                set { m_sTotalAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sSaleAmt;      // 상품금액(15)
            public string SALE_AMT
            {
                get { return m_sSaleAmt; }
                set { m_sSaleAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sTaxAmt;       // 부가세금액(15)
            public string TAX_AMT
            {
                get { return m_sTaxAmt; }
                set { m_sTaxAmt = double.Parse(value) >= 0 ? string.Format("{0:000000000000000}", double.Parse(value)) : string.Format("{0:00000000000000}", double.Parse(value)); }
            }

            private string m_sCashAmt;      // 현금금액(15)
            public string CASH_AMT { get { return m_sCashAmt; } set { m_sCashAmt = string.Format("{0:000000000000000}", double.Parse(value)); } }

            private string m_sCardAmt;      // 카드금액(15)
            public string CARD_AMT { get { return m_sCardAmt; } set { m_sCardAmt = string.Format("{0:000000000000000}", double.Parse(value)); } }

            private string m_sEtcAmt;       // 기타금액(15)
            public string ETC_AMT { get { return m_sEtcAmt; } set { m_sEtcAmt = string.Format("{0:000000000000000}", double.Parse(value)); } }

            private string m_sCreateDt;     // 영수증등록일시(14)
            public string CREATE_DT { get { return m_sCreateDt; } set { m_sCreateDt = string.Format("{0, -14}", value); } }
        }
        #endregion

        #region TR_CASHIER_TEST 캐셔 시험
        /// <summary>
        /// 캐셔 시험
        /// </summary>
        public class TR_CASHIER_TEST
        {
            public const string ITEM = "TR_CASHIER_TEST";

            public class DATA
            {
                
            }

            public class NAME
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 판매 일자  
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호  
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 시험 종류
                /// </summary>
                public const string TEST_KIND = "TEST_KIND";
                /// <summary>
                /// 시험 일시
                /// </summary>
                public const string TEST_DATE = "TEST_DATE";
                /// <summary>
                /// 판매원 번호
                /// </summary>
                public const string CASHIER_NO = "CASHIER_NO";
                /// <summary>
                /// 시험 항목 ID
                /// </summary>
                public const string TEST_ENTRY_ID = "TEST_ENTRY_ID";
	            /// <summary>
                /// 정답 항목수 
                /// </summary>
                public const string PASS_CNT = "PASS_CNT";
                /// <summary>
                /// 시험 항목수 
                /// </summary>
                public const string TEST_CNT = "TEST_CNT";
                /// <summary>
                /// 시험 합격 여부
                /// </summary>
                public const string TEST_PASS_YN = "TEST_PASS_YN";
                /// <summary>
                /// 시험 항목 명
                /// </summary>
                public const string TEST_ENTRY_NM = "TEST_ENTRY_NM"; 
            }
        }
        #endregion

        #region ETC_STOR_INSPCT_ANSWR_STOR 점포관리 점검응답 점포
        /// <summary>
        /// 점포관리 점검응답 점포
        /// </summary>
        public class ETC_STOR_INSPCT_ANSWR_STOR
        {
            public const string ITEM = "ETC_STOR_INSPCT_ANSWR_STOR";

            public class NAME
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점검 항목 그룹 코드
                /// </summary>
                public const string INSPCT_ENTRY_GRP_CD = "INSPCT_ENTRY_GRP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 시작 일자
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 응답 여부
                /// </summary>
                public const string ANSWR_YN = "ANSWR_YN";
                /// <summary>
                /// 기타내용1
                /// </summary>
                public const string ETC_CTNTS_1 = "ETC_CTNTS_1";
                /// <summary>
                /// 기타내용2
                /// </summary>
                public const string ETC_CTNTS_2 = "ETC_CTNTS_2";
                /// <summary>
                /// 기타내용3
                /// </summary>
                public const string ETC_CTNTS_3 = "ETC_CTNTS_3";
                /// <summary>
                /// 전송 여부
                /// </summary>
                public const string SEND_YN = "SEND_YN";
                /// <summary>
                /// 등록자
                /// </summary>
                public const string REG_USER_ID = "REG_USER_ID";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public const string REG_DATE = "REG_DATE";
                /// <summary>
                /// 수정자
                /// </summary>
                public const string UPD_USER_ID = "UPD_USER_ID";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public const string UPD_DATE = "UPD_DATE";
            }

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public string CMP_CD = "";
                /// <summary>
                /// 점검 항목 그룹 코드
                /// </summary>
                public string INSPCT_ENTRY_GRP_CD = "";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public string STOR_CD = "";
                /// <summary>
                /// 시작 일자
                /// </summary>
                public string START_DT = "";
                /// <summary>
                /// 응답 여부
                /// </summary>
                public string ANSWR_YN = "";
                /// <summary>
                /// 기타내용1
                /// </summary>
                public string ETC_CTNTS_1 = "";
                /// <summary>
                /// 기타내용2
                /// </summary>
                public string ETC_CTNTS_2 = "";
                /// <summary>
                /// 기타내용3
                /// </summary>
                public string ETC_CTNTS_3 = "";
                /// <summary>
                /// 전송 여부
                /// </summary>
                public string SEND_YN = "";
                /// <summary>
                /// 등록자
                /// </summary>
                public string REG_USER_ID = "";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public string REG_DATE = "";
                /// <summary>
                /// 수정자
                /// </summary>
                public string UPD_USER_ID = "";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public string UPD_DATE = "";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int CMP_CD = 1;
                public const int INSPCT_ENTRY_GRP_CD = 2;
                public const int STOR_CD = 3;
                public const int START_DT = 4;
                public const int ANSWR_YN = 5;
                public const int ETC_CTNTS_1 = 6;
                public const int ETC_CTNTS_2 = 7;
                public const int ETC_CTNTS_3 = 8;
                public const int SEND_YN = 9;
                public const int REG_USER_ID = 10;
                public const int REG_DATE = 11;
                public const int UPD_USER_ID = 12;
                public const int UPD_DATE = 13;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region ETC_STOR_INSPCT_ANSWR 점포관리 점검 응답
        /// <summary>
        /// 점포관리 점검 응답
        /// </summary>
        public class ETC_STOR_INSPCT_ANSWR
        {
            public const string ITEM = "ETC_STOR_INSPCT_ANSWR";

            public class NAME
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 브랜드 코드
                /// </summary>
                public const string BRAND_CD = "BRAND_CD";
                /// <summary>
                /// 점검 항목 그룹 코드
                /// </summary>
                public const string INSPCT_ENTRY_GRP_CD = "INSPCT_ENTRY_GRP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 시작 일자
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 점검 항목 대분류 코드
                /// </summary>
                public const string INSPCT_ENTRY_L_CLSS_CD = "INSPCT_ENTRY_L_CLSS_CD";
                /// <summary>
                /// 점검 항목
                /// </summary>
                public const string INSPCT_ENTRY = "INSPCT_ENTRY";
                /// <summary>
                /// 선택 항목 1 여부
                /// </summary>
                public const string SEL_ENTRY_1_YN = "SEL_ENTRY_1_YN";
                /// <summary>
                /// 선택 항목 2 여부
                /// </summary>
                public const string SEL_ENTRY_2_YN = "SEL_ENTRY_2_YN";
                /// <summary>
                /// 선택 항목 3 여부
                /// </summary>
                public const string SEL_ENTRY_3_YN = "SEL_ENTRY_3_YN";
                /// <summary>
                /// 선택 항목 4 여부
                /// </summary>
                public const string SEL_ENTRY_4_YN = "SEL_ENTRY_4_YN";
                /// <summary>
                /// 선택 항목 5 여부
                /// </summary>
                public const string SEL_ENTRY_5_YN = "SEL_ENTRY_5_YN";
                /// <summary>
                /// 점수 1
                /// </summary>
                public const string SCORE_1 = "SCORE_1";
                /// <summary>
                /// 점수 2
                /// </summary>
                public const string SCORE_2 = "SCORE_2";
                /// <summary>
                /// 점수 3
                /// </summary>
                public const string SCORE_3 = "SCORE_3";
                /// <summary>
                /// 점수 4
                /// </summary>
                public const string SCORE_4 = "SCORE_4";
                /// <summary>
                /// 점수 5
                /// </summary>
                public const string SCORE_5 = "SCORE_5";
                /// <summary>
                /// 선택 항목 1 내용
                /// </summary>
                public const string SEL_ENTRY_1_CTNTS = "SEL_ENTRY_1_CTNTS";
                /// <summary>
                /// 선택 항목 2 내용
                /// </summary>
                public const string SEL_ENTRY_2_CTNTS = "SEL_ENTRY_2_CTNTS";
                /// <summary>
                /// 선택 항목 3 내용
                /// </summary>
                public const string SEL_ENTRY_3_CTNTS = "SEL_ENTRY_3_CTNTS";
                /// <summary>
                /// 선택 항목 4 내용
                /// </summary>
                public const string SEL_ENTRY_4_CTNTS = "SEL_ENTRY_4_CTNTS";
                /// <summary>
                /// 선택 항목 5 내용
                /// </summary>
                public const string SEL_ENTRY_5_CTNTS = "SEL_ENTRY_5_CTNTS";
                /// <summary>
                /// 비고
                /// </summary>
                public const string NOTE = "NOTE";
                /// <summary>
                /// 전송 여부
                /// </summary>
                public const string SEND_YN = "SEND_YN";
                /// <summary>
                /// 등록자
                /// </summary>
                public const string REG_USER_ID = "REG_USER_ID";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public const string REG_DATE = "REG_DATE";
                /// <summary>
                /// 수정자
                /// </summary>
                public const string UPD_USER_ID = "UPD_USER_ID";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public const string UPD_DATE = "UPD_DATE";
            }

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public string CMP_CD = "";
                /// <summary>
                /// 브랜드 코드
                /// </summary>
                public string BRAND_CD = "";
                /// <summary>
                /// 점검 항목 그룹 코드
                /// </summary>
                public string INSPCT_ENTRY_GRP_CD = "";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public string STOR_CD = "";
                /// <summary>
                /// 시작 일자
                /// </summary>
                public string START_DT = "";
                /// <summary>
                /// 점검 항목 대분류 코드
                /// </summary>
                public string INSPCT_ENTRY_L_CLSS_CD = "";
                /// <summary>
                /// 점검 항목
                /// </summary>
                public int INSPCT_ENTRY = 0;
                /// <summary>
                /// 선택 항목 1 여부
                /// </summary>
                public string SEL_ENTRY_1_YN = "";
                /// <summary>
                /// 선택 항목 2 여부
                /// </summary>
                public string SEL_ENTRY_2_YN = "";
                /// <summary>
                /// 선택 항목 3 여부
                /// </summary>
                public string SEL_ENTRY_3_YN = "";
                /// <summary>
                /// 선택 항목 4 여부
                /// </summary>
                public string SEL_ENTRY_4_YN = "";
                /// <summary>
                /// 선택 항목 5 여부
                /// </summary>
                public string SEL_ENTRY_5_YN = "";
                /// <summary>
                /// 점수 1
                /// </summary>
                public int SCORE_1 = 0;
                /// <summary>
                /// 점수 2
                /// </summary>
                public int SCORE_2 = 0;
                /// <summary>
                /// 점수 3
                /// </summary>
                public int SCORE_3 = 0;
                /// <summary>
                /// 점수 4
                /// </summary>
                public int SCORE_4 = 0;
                /// <summary>
                /// 점수 5
                /// </summary>
                public int SCORE_5 = 0;
                /// <summary>
                /// 선택 항목 1 내용
                /// </summary>
                public string SEL_ENTRY_1_CTNTS = "";
                /// <summary>
                /// 선택 항목 2 내용
                /// </summary>
                public string SEL_ENTRY_2_CTNTS = "";
                /// <summary>
                /// 선택 항목 3 내용
                /// </summary>
                public string SEL_ENTRY_3_CTNTS = "";
                /// <summary>
                /// 선택 항목 4 내용
                /// </summary>
                public string SEL_ENTRY_4_CTNTS = "";
                /// <summary>
                /// 선택 항목 5 내용
                /// </summary>
                public string SEL_ENTRY_5_CTNTS = "";
                /// <summary>
                /// 비고
                /// </summary>
                public string NOTE = "";
                /// <summary>
                /// 전송 여부
                /// </summary>
                public string SEND_YN = "";
                /// <summary>
                /// 등록자
                /// </summary>
                public string REG_USER_ID = "";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public string REG_DATE = "";
                /// <summary>
                /// 수정자
                /// </summary>
                public string UPD_USER_ID = "";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public string UPD_DATE = "";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int CMP_CD = 1;
                public const int BRAND_CD = 2;
                public const int INSPCT_ENTRY_GRP_CD = 3;
                public const int STOR_CD = 4;
                public const int START_DT = 5;
                public const int INSPCT_ENTRY_L_CLSS_CD = 6;
                public const int INSPCT_ENTRY = 7;
                public const int SEL_ENTRY_1_YN = 8;
                public const int SEL_ENTRY_2_YN = 9;
                public const int SEL_ENTRY_3_YN = 10;
                public const int SEL_ENTRY_4_YN = 11;
                public const int SEL_ENTRY_5_YN = 12;
                public const int SCORE_1 = 13;
                public const int SCORE_2 = 14;
                public const int SCORE_3 = 15;
                public const int SCORE_4 = 16;
                public const int SCORE_5 = 17;
                public const int SEL_ENTRY_1_CTNTS = 18;
                public const int SEL_ENTRY_2_CTNTS = 19;
                public const int SEL_ENTRY_3_CTNTS = 20;
                public const int SEL_ENTRY_4_CTNTS = 21;
                public const int SEL_ENTRY_5_CTNTS = 22;
                public const int NOTE = 23;
                public const int SEND_YN = 24;
                public const int REG_USER_ID = 25;
                public const int REG_DATE = 26;
                public const int UPD_USER_ID = 27;
                public const int UPD_DATE = 28;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region ETC_STOR_EQU_CHECK_LIST 일일점검 점포 장비 리스트
        /// <summary>
        /// 점포관리 점검응답 점포
        /// </summary>
        public class ETC_STOR_EQU_CHECK_LIST
        {
            public const string ITEM = "ETC_STOR_EQU_CHECK_LIST";

            public class NAME
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 점검 일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점검 상태
                /// </summary>
                public const string CHECK_STATE = "CHECK_STATE";
                /// <summary>
                /// 전송 여부
                /// </summary>
                public const string SEND_YN = "SEND_YN";
                /// <summary>
                /// 등록자
                /// </summary>
                public const string REG_USER_ID = "REG_USER_ID";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public const string REG_DATE = "REG_DATE";
                /// <summary>
                /// 수정자
                /// </summary>
                public const string UPD_USER_ID = "UPD_USER_ID";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public const string UPD_DATE = "UPD_DATE";
            }

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public string CMP_CD = "";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public string STOR_CD = "";
                /// <summary>
                /// 점검 일자
                /// </summary>
                public string SALE_DT = "";
                /// <summary>
                /// 응답 여부
                /// </summary>
                public string CHECK_STATE = "";
                /// <summary>
                /// 전송 여부
                /// </summary>
                public string SEND_YN = "";
                /// <summary>
                /// 등록자
                /// </summary>
                public string REG_USER_ID = "";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public string REG_DATE = "";
                /// <summary>
                /// 수정자
                /// </summary>
                public string UPD_USER_ID = "";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public string UPD_DATE = "";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int CMP_CD = 1;
                public const int STOR_CD = 2;
                public const int SALE_DT = 3;
                public const int CHECK_STATE = 4;
                public const int SEND_YN = 5;
                public const int REG_USER_ID = 6;
                public const int REG_DATE = 7;
                public const int UPD_USER_ID = 8;
                public const int UPD_DATE = 9;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion

        #region ETC_STOR_EQU_CHECK_DETAIL 일일점검 점포 장비 상세
        /// <summary>
        /// 점포관리 점검응답 점포
        /// </summary>
        public class ETC_STOR_EQU_CHECK_DETAIL
        {
            public const string ITEM = "ETC_STOR_EQU_CHECK_DETAIL";

            public class NAME
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 점검 일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점검 구분(대분류)
                /// </summary>
                public const string CHECK_DIV_CD = "CHECK_DIV_CD";
                /// <summary>
                /// 점검 장비
                /// </summary>
                public const string CHECK_EQU_CD = "CHECK_EQU_CD";
                /// <summary>
                /// 점검 결과
                /// </summary>
                public const string CHECK_RESULT = "CHECK_RESULT";
                /// <summary>
                /// AS 결과
                /// </summary>
                public const string AS_RESULT = "AS_RESULT";
                /// <summary>
                /// 점포확인 결과
                /// </summary>
                public const string STOR_RESULT = "STOR_RESULT";
                /// <summary>
                /// 등록자
                /// </summary>
                public const string REG_USER_ID = "REG_USER_ID";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public const string REG_DATE = "REG_DATE";
                /// <summary>
                /// 수정자
                /// </summary>
                public const string UPD_USER_ID = "UPD_USER_ID";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public const string UPD_DATE = "UPD_DATE";
            }

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public string CMP_CD = "";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public string STOR_CD = "";
                /// <summary>
                /// 점검 일자
                /// </summary>
                public string SALE_DT = "";
                /// <summary>
                /// 점검 구분(대분류)
                /// </summary>
                public string CHECK_DIV_CD = "";
                /// <summary>
                /// 점검 장비
                /// </summary>
                public string CHECK_EQU_CD = "";
                /// <summary>
                /// 점검 결과
                /// </summary>
                public string CHECK_RESULT = "";
                /// <summary>
                /// AS 결과
                /// </summary>
                public string AS_RESULT = "";
                /// <summary>
                /// 점포확인 결과
                /// </summary>
                public string STOR_RESULT = "";
                /// <summary>
                /// 등록자
                /// </summary>
                public string REG_USER_ID = "";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public string REG_DATE = "";
                /// <summary>
                /// 수정자
                /// </summary>
                public string UPD_USER_ID = "";
                /// <summary>
                /// 갱신 일시
                /// </summary>
                public string UPD_DATE = "";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int CMP_CD = 1;
                public const int STOR_CD = 2;
                public const int SALE_DT = 3;
                public const int CHECK_DIV_CD = 4;
                public const int CHECK_EQU_CD = 5;
                public const int CHECK_RESULT = 6;
                public const int AS_RESULT = 7;
                public const int STOR_RESULT = 8;
                public const int REG_USER_ID = 9;
                public const int REG_DATE = 10;
                public const int UPD_USER_ID = 11;
                public const int UPD_DATE = 12;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion
               

        //*----------------------------------------------------------------------------------------------------------*/
        // IRT 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        
        #region IQ_OPEN_REQ 영업개시 요청
        /// <summary>
        /// 영업개시 요청
        /// </summary>
        public class IQ_OPEN_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 담당자 번호
                /// </summary>
                public const string OP_NO = "OP_NO";
                /// <summary>
                /// 담당자 암호
                /// </summary>
                public const string OP_PWD = "OP_PWD";
                /// <summary>
                /// 영업개시구분
                /// </summary>
                public const string OPEN_TY = "OPEN_TY";
                /// <summary>
                /// 영업개시일시
                /// </summary>
                public const string SYS_DATE = "SYS_DATE";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메세지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        /// <summary>
        /// 영업개시 응답
        /// </summary>
        public class IQ_OPEN_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 담당자 번호
                /// </summary>
                public const string OP_NO = "OP_NO";
                /// <summary>
                /// 담당자 암호
                /// </summary>
                public const string OP_PWD = "OP_PWD";
                /// <summary>
                /// 영업개시구분
                /// </summary>
                public const string OPEN_TY = "OPEN_TY";
                /// <summary>
                /// 영업개시일시
                /// </summary>
                public const string SYS_DATE = "SYS_DATE";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메세지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_LOTTERY_NUMBERINQ 복권번호 발행
        /// <summary>
        /// 복권번호 발행 요청
        /// </summary>
        public class IQ_LOTTERY_NUMBERINQ_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 복권번호
                /// </summary>
                public const string CAMPAIGN_CODE = "CAMPAIGN_CODE";
                /// <summary>
                /// 조회요청구분
                /// </summary>
                public const string INQ_FLAG = "INQ_FLAG";
                /// <summary>
                /// 당첨조건금액
                /// </summary>
                public const string COND_AMT = "COND_AMT";
                /// <summary>
                /// 발행수량
                /// </summary>
                public const string ISSUE_CNT = "ISSUE_CNT";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        /// <summary>
        /// 복권번호 발행 응답
        /// </summary>
        public class IQ_LOTTERY_NUMBERINQ_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STORE_CD = "STORE_CD";
                /// <summary>
                /// 복권번호
                /// </summary>
                public const string LOTTERY_NO = "LOTTERY_NO";
                /// <summary>
                /// 복권등수
                /// </summary>
                public const string LOTTERY_GRADE = "LOTTERY_GRADE";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_EXCHAGE_TICKET_REQ 잔액교환권 발행 요청
        /// <summary>
        /// 잔액교환권 발행 요청
        /// </summary>
        public class IQ_EXCHAGE_TICKET_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// POSNO
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 발급구분
                /// </summary>
                public const string ISSUE_TYPE = "ISSUE_TYPE";
                /// <summary>
                /// 발행번호
                /// </summary>
                public const string TICKET_NO = "TICKET_NO";
                /// <summary>
                /// 발행금액
                /// </summary>
                public const string TICKET_AMT = "TICKET_AMT";
                /// <summary>
                /// 등록사번
                /// </summary>
                public const string USER_ID = "USER_ID";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }

        /// <summary>
        /// 잔액교환권 발행 응답
        /// </summary>
        public class IQ_EXCHAGE_TICKET_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// POSNO
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 발급구분
                /// </summary>
                public const string ISSUE_TYPE = "ISSUE_TYPE";
                /// <summary>
                /// 발행번호
                /// </summary>
                public const string TICKET_NO = "TICKET_NO";
                /// <summary>
                /// 발행금액
                /// </summary>
                public const string TICKET_AMT = "TICKET_AMT";
                /// <summary>
                /// 등록사번
                /// </summary>
                public const string USER_ID = "USER_ID";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_GIFT_APP_REQ 상품권 인증 요청
        /// <summary>
        /// 상품권 인증 요청
        /// </summary>
        public class IQ_GIFT_APP_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 승인구분
                /// </summary>
                public const string INQ_MODE = "INQ_MODE";
                /// <summary>
                /// 거래구분
                /// </summary>
                public const string DEAL_TYPE = "DEAL_TYPE";
                /// <summary>
                /// 승인서버구분
                /// </summary>
                public const string INQ_FLAG = "INQ_FLAG";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// POSNO
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 거래번호
                /// </summary>
                public const string REG_NO = "REG_NO";
                /// <summary>
                /// 요청자
                /// </summary>
                public const string OP_NO = "OP_NO";
                /// <summary>
                /// 입력구분
                /// </summary>
                public const string WCC = "WCC";
                /// <summary>
                /// 승인처리 경로
                /// </summary>
                public const string APPR_PATH = "APPR_PATH";
                /// <summary>
                /// 상품권번호
                /// </summary>
                public const string GIFT_NO = "GIFT_NO";
                /// <summary>
                /// 상품권권종
                /// </summary>
                public const string GIFTVRTY = "GIFTVRTY";
                /// <summary>
                /// 원거래일자
                /// </summary>
                public const string ORG_SALE_DT = "ORG_SALE_DT";
                /// <summary>
                /// 원거래 승인번호
                /// </summary>
                public const string ORG_APPROVE_NO = "ORG_APPROVE_NO";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }

        /// <summary>
        /// 상품권 인증 응답
        /// </summary>
        public class IQ_GIFT_APP_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 승인구분
                /// </summary>
                public const string INQ_MODE = "INQ_MODE";
                /// <summary>
                /// 거래구분
                /// </summary>
                public const string DEAL_TYPE = "DEAL_TYPE";
                /// <summary>
                /// 승인서버구분
                /// </summary>
                public const string INQ_FLAG = "INQ_FLAG";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// POSNO
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 상품권번호
                /// </summary>
                public const string GIFT_NO = "GIFT_NO";
                /// <summary>
                /// 상품권권종
                /// </summary>
                public const string GIFT_TYPE = "GIFT_TYPE";
                /// <summary>
                /// 상품권금액
                /// </summary>
                public const string GIFT_AMT = "GIFT_AMT";
                /// <summary>
                /// 승인일시
                /// </summary>
                public const string APPROVE_DATE = "APPROVE_DATE";
                /// <summary>
                /// 승인번호
                /// </summary>
                public const string APPROVE_NO = "APPROVE_NO";
                /// <summary>
                /// 메시지1
                /// </summary>
                public const string MESSAGE1 = "MESSAGE1";
                /// <summary>
                /// 메시지2
                /// </summary>
                public const string MESSAGE2 = "MESSAGE2";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_SALEONCREDIT_CUSTINQ_REQ 외상고객 조회(잔액)
        /// <summary>
        /// 외상고객 조회(잔액) 요청
        /// </summary>
        public class IQ_SALEONCREDIT_CUSTINQ_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 조회요청구분
                /// </summary>
                public const string INQ_FLAG = "INQ_FLAG";
                /// <summary>
                /// 고객 형태
                /// </summary>
                public const string CUSTOMER_TY = "CUSTOMER_TY";
                /// <summary>
                /// 외상고객 ID
                /// </summary>
                public const string CUSTOMER_ID = "CUSTOMER_ID";
                
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }

        /// <summary>
        /// 외상고객 조회(잔액) 응답
        /// </summary>
        public class IQ_SALEONCREDIT_CUSTINQ_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STORE_CD = "STORE_CD";
                /// <summary>
                /// 조회 TN
                /// </summary>
                public const string INQ_COUNT = "INQ_COUNT";
                /// <summary>
                /// 고객정보
                /// </summary>
                public const string CUSTOMER_VALUE = "CUSTOMER_VALUE";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_STORECLAIM_MSG_REQ 점포 클레임 송신
        /// <summary>
        /// 외상고객 조회(잔액) 요청
        /// </summary>
        public class IQ_STORECLAIM_MSG_REQ
        {
            public const string ITEM = "IQ_STORECLAIM_MSG_REQ";

            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public string INQ_TYPE = "";
                /// <summary>
                /// 점포코드
                /// </summary>
                public string STOR_CD = "";
                /// <summary>
                /// CLAIM 일자
                /// </summary>
                public string SALE_DT = "";
                /// <summary>
                /// 일련번호
                /// </summary>
                public string SEQ = "";
                /// <summary>
                /// 고객 명
                /// </summary>
                public string CUST_NM = "";
                /// <summary>
                /// 남녀구분
                /// </summary>
                public string CUST_SEX = "";
                /// <summary>
                /// 고객연락처
                /// </summary>
                public string CUST_TEL = "";
                /// <summary>
                /// 제조일자
                /// </summary>
                public string LOT_NO = "";
                /// <summary>
                /// 대표제품명
                /// </summary>
                public string ITEM_SNM = "";
                /// <summary>
                /// 실구매일자
                /// </summary>
                public string BUY_DT = "";
                /// <summary>
                /// 처리구분
                /// </summary>
                public string CLAIM_PRC_GB = "";
                /// <summary>
                /// 처리비용
                /// </summary>
                public string CLAIM_PRC_COST = "";
                /// <summary>
                /// 처리내용
                /// </summary>
                public string CLAIM_PRC_MEMO = "";
                /// <summary>
                /// 등록일시
                /// </summary>
                public string REG_YMDHMS = "";
                /// <summary>
                /// 사용자코드
                /// </summary>
                public string USER_ID = "";


            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        /// <summary>
        /// 점포 클레임 송신 응답
        /// </summary>
        public class IQ_STORECLAIM_MSG_RES
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public string INQ_TYPE = "";
                /// <summary>
                /// 점포코드
                /// </summary>
                public string STORE_CD = "";
                /// <summary>
                /// 등록일자
                /// </summary>
                public string SALE_DT = "";
                /// <summary>
                /// 응답코드
                /// </summary>
                public string RES_CD = "";
                /// <summary>
                /// 응답메세지
                /// </summary>
                public string REG_MSG = "";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_SALEONCREDIT_USE_REQ 외상사용 요청
        /// <summary>
        /// 외상사용 요청
        /// </summary>
        public class IQ_SALEONCREDIT_USE_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POSNO
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 매출일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 외상구분
                /// </summary>
                public const string SALE_GBN = "SALE_GBN";
                /// <summary>
                /// 고객번호
                /// </summary>
                public const string CUST_ID = "CUST_ID";
                /// <summary>
                /// 외상금액
                /// </summary>
                public const string SALE_AMT = "SALE_AMT";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }

        /// <summary>
        /// 외상사용 응답
        /// </summary>
        public class IQ_SALEONCREDIT_USE_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 매출일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 결과코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 결과메시지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion 

        #region IQ_PREPAIDCARD_USE_REQ 선블카드 요청
        /// <summary>
        /// 선블카드 사용 요청
        /// </summary>
        public class IQ_PREPAIDCARD_USE_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POSNO
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 매출일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 거래번호
                /// </summary>
                public const string REG_NO = "REG_NO";
                /// <summary>
                /// 판매구분
                /// </summary>
                public const string SALE_GBN = "SALE_GBN";
                /// <summary>
                /// 고객번호
                /// </summary>
                public const string CUST_ID = "CUST_ID";
                /// <summary>
                /// 사용금액
                /// </summary>
                public const string SALE_AMT = "SALE_AMT";
                /// <summary>
                /// 원승인번호
                /// </summary>
                public const string APPR_NO = "APPR_NO";
                /// <summary>
                /// 원승인일자
                /// </summary>
                public const string APPR_DT = "APPR_DT";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }

        /// <summary>
        /// 선블카드 응답
        /// </summary>
        public class IQ_PREPAIDCARD_USE_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";         
                /// <summary>
                /// 매출일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 승인번호
                /// </summary>
                public const string APPR_NO = "APPR_NO";
                /// <summary>
                /// 승인일자
                /// </summary>
                public const string APPR_DT = "APPR_DT";
                /// <summary>
                /// 사용후 잔액
                /// </summary>
                public const string BALANCE_AMT = "BALANCE_AMT";
                /// <summary>
                /// 요청금액
                /// </summary>
                public const string SALE_AMT = "SALE_AMT";
                /// <summary>
                /// 결과코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 결과메시지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_PVCSTOCK_INQ_REQ PVC 상자재고 송신
        /// <summary>
        /// 상자재고 송신
        /// </summary>
        public class IQ_PVCSTOCK_INQ_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// PVC박스(대) 현재고 수량
                /// </summary>
                public const string PVC_L_QTY = "PVC_L_QTY";
                /// <summary>
                /// PVC박스(중) 현재고 수량
                /// </summary>
                public const string PVC_M_QTY = "PVC_M_QTY";
                /// <summary>
                /// PVC박스(소) 현재고 수량
                /// </summary>
                public const string PVC_S_QTY = "PVC_S_QTY";
                /// <summary>
                /// 등록사원
                /// </summary>
                public const string USER_ID = "USER_ID";
                /// <summary>
                /// 등록시간
                /// </summary>
                public const string REG_YMDHMS = "REG_YMDHMS";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        /// <summary>
        /// 상자재고 수신
        /// </summary>
        public class IQ_PVCSTOCK_INQ_RES
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메세지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_TEST_MODE 시험모드 조회,결과
        /// <summary>
        /// 시험모드 조회,결과
        /// </summary>
        public class IQ_TEST_MODE
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 회사코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 판매원번호
                /// </summary>
                public const string CASHIER_NO = "CASHIER_NO";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 시험항목건수
                /// </summary>
                public const string TEST_CNT = "TEST_CNT";
                /// <summary>
                /// 시험항목 정보
                /// </summary>
                public const string TEST_MODE_INFO = "TEST_MODE_INFO";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region POS 마스터 요청/응답
        /// <summary>
        /// POS 마스터 요청
        /// </summary>
        public class IQ_POSMASTER_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string InqType = "INQ_TYPE";
                /// <summary>
                /// 마스터 요청 구분
                /// </summary>
                public const string MasterDiv = "MASTER_DIV";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// SUB점포코드
                /// </summary>
                public const string SubStorCd = "SUB_STOR_CD";
                /// <summary>
                /// 변경 일시
                /// </summary>
                public const string UpdDt = "UPD_DT";
                /// <summary>
                /// 전송데이터 COUNT
                /// </summary>
                public const string DataCount = "DATA_COUNT";
                /// <summary>
                /// 요청코드
                /// </summary>
                public const string ProcCd = "PROC_CD";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string ResCd = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        /// <summary>
        /// POS 마스터 응답
        /// </summary>
        public class IQ_POSMASTER_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// 마스터 Row Count
                /// </summary>
                public const string Count = "COUNT";
                /// <summary>
                /// 마스터 Data
                /// </summary>
                public const string Data = "DATA";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion


        #region Kiosk 요청/응답
        /// <summary>
        /// 2019-02-22 - 1997fx11 : Kiosk 요청
        /// </summary>
        public class IQ_KIOSK_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string InqType = "INQ_TYPE";
                /// <summary>
                /// 마스터 요청 구분
                /// </summary>
                public const string KioskDiv = "KIOSK_DIV";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// SUB점포코드
                /// </summary>
                public const string SubStorCd = "SUB_STOR_CD";
                /// <summary>
                /// 2019-03-19 - 1997fx11 : 고객코드
                /// </summary>
                public const string HpcCustCd = "HPC_CUST_CD";
                /// <summary>
                /// 2019-03-19 - 1997fx11 : 변경 일시
                /// </summary>
                public const string UpdDt = "UPD_DT";
                /// <summary>
                /// 2019-03-19 - 1997fx11 : 전송데이터 COUNT
                /// </summary>
                public const string DataCount = "DATA_COUNT";
                /// <summary>
                /// 2019-03-19 - 1997fx11 : 요청코드
                /// </summary>
                public const string ProcCd = "PROC_CD";
                /// <summary>
                /// 2019-03-19 - 1997fx11 : 응답코드
                /// </summary>
                public const string ResCd = "RES_CD";
                /// <summary>
                /// 2019-03-21 - 1997fx11 : HDD 총용량
                /// </summary>
                public const string HddTotal = "HDD_TOT";
                /// <summary>
                /// 2019-03-21 - 1997fx11 : HDD 사용량
                /// </summary>
                public const string HddUse = "HDD_USE";
                /// <summary>
                /// 2019-03-21 - 1997fx11 : Memory 총용량
                /// </summary>
                public const string MemoryTotal = "MEM_TOT";
                /// <summary>
                /// 2019-03-21 - 1997fx11 : Memory 사용량
                /// </summary>
                public const string MemoryUse = "MEM_USE";
                /// <summary>
                /// 2019-03-21 - 1997fx11 : CPU 사용량
                /// </summary>
                public const string CpuUse = "CPU_USE";
                /// <summary>
                /// 2019-03-21 - 1997fx11 : 마지막 프로그램 Boot 시간
                /// </summary>
                public const string LastBootTime = "LAST_BOOT_TIME";
                /// <summary>
                /// 2019-03-21 - 1997fx11 : 마지막 프로그램 종료 시간
                /// </summary>
                public const string LastShutdownTime = "LAST_SHUTDOWN_TIME";
                /// <summary>
                /// 2019-05-29 - 1997fx11 : Page ID
                /// </summary>
                public const string Page_Id = "PAGE_ID";
                /// <summary>
                /// 2019-05-29 - 1997fx11 : Phone No
                /// </summary>
                public const string Phone_No = "PHONE_NO";
                /// <summary>
                /// 2019-05-30 - 1997fx11 : 점포명
                /// </summary>
                public const string Stor_Nm = "STOR_NM";
                /// <summary>
                /// 2019-05-30 - 1997fx11 : 거래 일시
                /// </summary>
                public const string Trade_Date = "TRADE_DATE";
                /// <summary>
                /// 2019-05-30 - 1997fx11 : 0번째 아이템 명
                /// </summary>
                public const string Prd_Nm = "PRD_NM";
                /// <summary>
                /// 2019-05-30 - 1997fx11 : 배열 Length
                /// </summary>
                public const string Prd_Count = "PRD_COUNT";
                /// <summary>
                /// 2019-05-30 - 1997fx11 : 적립대상금액
                /// </summary>
                public const string After_Save_Point = "AFTER_SAVE_POINT";
                /// <summary>
                /// 2019-05-30 - 1997fx11 : 바코드
                /// </summary>
                public const string Barcode = "BARCODE";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }


        /// <summary>
        /// 2019-02-22 - 1997fx11 : Kiosk 응답
        /// </summary>
        public class IQ_KIOSK_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// 마스터 Row Count
                /// </summary>
                public const string Count = "COUNT";
                /// <summary>
                /// 마스터 Data
                /// </summary>
                public const string Data = "DATA";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion



        #region TRAN LOG 데이터 전송
        public class IQ_TRAN_LOG_REQ
        {
            public class DATA
            {
                /// <summary>
                /// 회사코드
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 판매일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 포스번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 거래번호
                /// </summary>
                public const string TradeNo = "TRADE_NO";
                /// <summary>
                /// 등록번호
                /// </summary>
                public const string RegNo = "REG_NO";
                /// <summary>
                /// 거래구분
                /// </summary>
                public const string TradeDiv = "TRADE_DIV";
                /// <summary>
                /// 연습모드 여부
                /// </summary>
                public const string TrainModeYn = "TRAIN_MODE_YN";
                /// <summary>
                /// 거래종별
                /// </summary>
                public const string TradeKindper = "TRADE_KINDPER";
                /// <summary>
                /// 시스템일시
                /// </summary>
                public const string SysDt = "SYS_DT";
                /// <summary>
                /// 결제시간
                /// </summary>
                public const string PayTime = "PAY_TIME";
                /// <summary>
                /// 원거래판매일자
                /// </summary>
                public const string OrgSaleDt = "ORG_SALE_DT";
                /// <summary>
                /// 원거래포스번호
                /// </summary>
                public const string OrgPosNo = "ORG_POS_NO";
                /// <summary>
                /// 원거래거래번호
                /// </summary>
                public const string OrgTradeNo = "ORG_TRADE_NO";
                /// <summary>
                /// 수량
                /// </summary>
                public const string Qty = "QTY";
                /// <summary>
                /// 총매출금액
                /// </summary>
                public const string TotSaleAmt = "TOTSALE_AMT";
                /// <summary>
                /// 총할인금액
                /// </summary>
                public const string TotDcAmt = "TOTDC_AMT";
                /// <summary>
                /// 순매출금액
                /// </summary>
                public const string NetSaleAmt = "NET_SALE_AMT";
                /// <summary>
                /// 거래데이터
                /// </summary>
                public const string DealData = "DEAL_DATA";
            }
        }
        #endregion

        #region Journal 데이터 전송
        public class IQ_JOURNAL_REQ
        {
            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 판매 일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 등록 번호
                /// </summary>
                public const string RegNo = "REG_NO";
                /// <summary>
                /// 거래 번호
                /// </summary>
                public const string TradeNo = "TRADE_NO";
                /// <summary>
                /// 거래 구분
                /// </summary>
                public const string TradeDiv = "TRADE_DIV";
                /// <summary>
                /// 연습모드 여부
                /// </summary>
                public const string TrainModeYn = "TRAIN_MODE_YN";
                /// <summary>
                /// 거래 종별
                /// </summary>
                public const string TradeKindper = "TRADE_KINDPER";
                /// <summary>
                /// 시스템 일자
                /// </summary>
                public const string SysDt = "SYS_DT";
                /// <summary>
                /// 시스템 시간
                /// </summary>
                public const string SysTime = "SYS_TIME";
                /// <summary>
                /// 담당자 번호
                /// </summary>
                public const string PicNo = "PIC_NO";
                /// <summary>
                /// 영수 금액
                /// </summary>
                public const string BillAmt = "BILL_AMT";
                /// <summary>
                /// 저널 데이터
                /// </summary>
                public const string JournalData = "JOURNAL_DATA";
                
                //grayber@20180212 해피포인트 전자영수증 I/F 개선 #13924 start
                /// <summary>
                /// 해피포인트 적립 승인일자
                /// </summary>
                public const string HpcSaveApprDt = "HPC_SAVE_APPR_DT";
                /// <summary>
                /// 해피포인트 적립 승인번호
                /// </summary>
                public const string HpcSaveApprNo = "HPC_SAVE_APPR_NO";
                /// <summary>
                /// 해피포인트 사용 승인일자
                /// </summary>
                public const string HpcUseApprDt = "HPC_USE_APPR_DT";
                /// <summary>
                /// 해피포인트 사용 승인번호
                /// </summary>
                public const string HpcUseApprNo = "HPC_USE_APPR_NO";
                //grayber@20180212 해피포인트 전자영수증 I/F 개선 #13924 end
            }
        }
        #endregion

        #region 승인 로그 데이터 전송
        public class IQ_APPROVAL_LOG_REQ
        {
            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 판매 일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 거래 번호
                /// </summary>
                public const string TradeNo = "TRADE_NO";
                /// <summary>
                /// 순번
                /// </summary>
                public const string Seq = "SEQ";
                /// <summary>
                /// 판매 구분
                /// </summary>
                public const string TradeDiv = "TRADE_DIV";
                /// <summary>
                /// 결제 구분 코드
                /// </summary>
                public const string PayWayCd = "PAY_WAY_CD";
                /// <summary>
                /// 결제 상세 코드
                /// </summary>
                public const string PayDtlCd = "PAY_DTL_CD";
                /// <summary>
                /// 승인구분
                /// </summary>
                public const string InqType = "INQ_TYPE";
                /// <summary>
                /// 요청구분
                /// </summary>
                public const string TranType = "TRAN_TYPE";
                /// <summary>
                /// 카드 번호
                /// </summary>
                public const string CardNo = "CARD_NO";
                /// <summary>
                /// 응답상태값
                /// </summary>
                public const string ResCd = "RES_CD";
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const string ResMsg = "RES_MSG";
                /// <summary>
                /// 결제금액
                /// </summary>
                public const string PayAmt = "PAY_AMT";
                /// <summary>
                /// 승인 번호
                /// </summary>
                public const string ApprNo = "APPR_NO";
                /// <summary>
                /// 승인 일자
                /// </summary>
                public const string ApprDt = "APPR_DT";
                /// <summary>
                /// 승인 시간
                /// </summary>
                public const string ApprTime = "APPR_TIME";
                /// <summary>
                /// 승인 데이터
                /// </summary>
                public const string ApprLog = "APPR_LOG";
                /// <summary>
                /// 등록자 ID
                /// </summary>
                public const string RegId = "REG_ID";
                /// <summary>
                /// 금액1
                /// </summary>
                public const string AMT_ENTRY_01 = "AMT_ENTRY_01";
                /// <summary>
                /// 금액2
                /// </summary>
                public const string AMT_ENTRY_02 = "AMT_ENTRY_02";
                /// <summary>
                /// 금액3
                /// </summary>
                public const string AMT_ENTRY_03 = "AMT_ENTRY_03";
                /// <summary>
                /// 금액4
                /// </summary>
                public const string AMT_ENTRY_04 = "AMT_ENTRY_04";
                /// <summary>
                /// 금액5
                /// </summary>
                public const string AMT_ENTRY_05 = "AMT_ENTRY_05";
                /// <summary>
                /// 금액6
                /// </summary>
                public const string AMT_ENTRY_06 = "AMT_ENTRY_06";
                /// <summary>
                /// 금액7
                /// </summary>
                public const string AMT_ENTRY_07 = "AMT_ENTRY_07";
                /// <summary>
                /// 금액8
                /// </summary>
                public const string AMT_ENTRY_08 = "AMT_ENTRY_08";
                /// <summary>
                /// 금액9
                /// </summary>
                public const string AMT_ENTRY_09 = "AMT_ENTRY_09";

                /// <summary>
                /// 입력값1
                /// </summary>
                public const string OCCUR_ENTRY_01 = "OCCUR_ENTRY_01";
                /// <summary>
                /// 입력값2
                /// </summary>
                public const string OCCUR_ENTRY_02 = "OCCUR_ENTRY_02";
                /// <summary>
                /// 입력값3
                /// </summary>
                public const string OCCUR_ENTRY_03 = "OCCUR_ENTRY_03";
                /// <summary>
                /// 입력값4
                /// </summary>
                public const string OCCUR_ENTRY_04 = "OCCUR_ENTRY_04";
                /// <summary>
                /// 입력값5
                /// </summary>
                public const string OCCUR_ENTRY_05 = "OCCUR_ENTRY_05";
                /// <summary>
                /// 입력값6
                /// </summary>
                public const string OCCUR_ENTRY_06 = "OCCUR_ENTRY_06";
                /// <summary>
                /// 입력값7
                /// </summary>
                public const string OCCUR_ENTRY_07 = "OCCUR_ENTRY_07";
                /// <summary>
                /// 입력값8
                /// </summary>
                public const string OCCUR_ENTRY_08 = "OCCUR_ENTRY_08";
                /// <summary>
                /// 입력값9
                /// </summary>
                public const string OCCUR_ENTRY_09 = "OCCUR_ENTRY_09";

                /// <summary>
                /// 사용유무
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 계산원 시험 로그 데이터 전송
        public class IQ_CASHIER_TEST_LOG_REQ
        {
            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 판매 일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SeqNo = "SEQ_NO";
                /// <summary>
                /// 시험 종류
                /// </summary>
                public const string TestKind = "TEST_KIND";
                /// <summary>
                /// 시험 일시
                /// </summary>
                public const string TestDate = "TEST_DATE";
                /// <summary>
                /// 계산원 번호
                /// </summary>
                public const string CashierNo = "CASHIER_NO";
                /// <summary>
                /// 시험 항목 ID
                /// </summary>
                public const string TestEntryId = "TEST_ENTRY_ID";
                /// <summary>
                /// 정답 항목 수
                /// </summary>
                public const string PassCnt = "PASS_CNT";
                /// <summary>
                /// 시험 항목 수
                /// </summary>
                public const string TestCnt = "TEST_CNT";
                /// <summary>
                /// 시험 합격 여부
                /// </summary>
                public const string TestPassYn = "TEST_PASS_YN";
            }
        }
        #endregion

        #region KDS 데이터 전송
        /// <summary>
        /// 통신 헤더
        /// </summary>
        public class IQ_KDS_HEADER_REQ
        {
            public class DATA
            {
                /// <summary>
                /// 전문 구분
                /// </summary>
                public const string MSG_TYPE = "MSG_TYPE";
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CO_CD = "CO_CD";
                /// <summary>
                /// 브랜드 코드
                /// </summary>
                public const string BRAND_CD = "BRAND_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STORE_CD = "STORE_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// TRAN 번호
                /// </summary>
                public const string TRAN_NO = "TRAN_NO";
                /// <summary>
                /// TRAN 일자
                /// </summary>
                public const string TRAN_YMD = "TRAN_YMD";
                /// <summary>
                /// 시스템 일자
                /// </summary>
                public const string SYS_YMD = "SYS_YMD";
                /// <summary>
                /// 시스템 시간
                /// </summary>
                public const string SYS_HMS = "SYS_HMS";
                /// <summary>
                /// 에러 코드
                /// </summary>
                public const string ERR_CD = "ERR_CD";
            }
        }
        /// <summary>
        /// 주문 헤더
        /// </summary>
        public class IQ_KDS_ORDER_HEADER_REQ
        {
            public class DATA
            {
                /// <summary>
                /// HEADER 식별ID
                /// </summary>
                public const string TR_HEADER_ID = "TR_HEADER_ID";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 주문 번호
                /// </summary>
                public const string TRAN_NO = "TRAN_NO";
                /// <summary>
                /// 발생 구분
                /// </summary>
                public const string DEAL_TY = "DEAL_TY";
                /// <summary>
                /// POS 구분
                /// </summary>
                public const string POS_TY = "POS_TY";
                /// <summary>
                /// 테이블 명
                /// </summary>
                public const string TABLE_NM = "TABLE_NM";
                /// <summary>
                /// 주문 고객 명
                /// </summary>
                public const string ORDER_CUST_NM = "ORDER_CUST_NM";
                /// <summary>
                /// VIP 여부
                /// </summary>
                public const string VIP_TY = "VIP_TY";
                /// <summary>
                /// 주문 구분
                /// </summary>
                public const string ORDER_TY = "ORDER_TY";
                /// <summary>
                /// 원거래 POS 번호
                /// </summary>
                public const string ORG_POS_NO = "ORG_POS_NO";
                /// <summary>
                /// 원거래 번호
                /// </summary>
                public const string ORG_TRAN_NO = "ORG_TRAN_NO";
            }
        }
        /// <summary>
        /// 주문 명세
        /// </summary>
        public class IQ_KDS_ORDER_ITEM_REQ
        {
            public class DATA
            {
                /// <summary>
                /// ITEM 식별ID
                /// </summary>
                public const string TR_ITEM_ID = "TR_ITEM_ID";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 발생 구분
                /// </summary>
                public const string DEAL_TY = "DEAL_TY";
                /// <summary>
                /// 메뉴 구분
                /// </summary>
                public const string MENU_TY = "MENU_TY";
                /// <summary>
                /// 제품 코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 제품 단축 명
                /// </summary>
                public const string ITEM_NM = "ITEM_NM";
                /// <summary>
                /// 제품 수량
                /// </summary>
                public const string ITEM_QTY = "ITEM_QTY";
                /// <summary>
                /// 메시지 1
                /// </summary>
                public const string MSG_1 = "MSG_1";
                /// <summary>
                /// 메시지 2
                /// </summary>
                public const string MSG_2 = "MSG_2";
                /// <summary>
                /// 메시지 3
                /// </summary>
                public const string MSG_3 = "MSG_3";
            }
        }
        /// <summary>
        /// 주문 전달 메시지
        /// </summary>
        public class IQ_KDS_ORDER_MESSAGE_REQ
        {
            public class DATA
            {
                /// <summary>
                /// MSG 식별ID
                /// </summary>
                public const string TR_MSG_ID = "TR_MSG_ID";
                /// <summary>
                /// 메시지 1
                /// </summary>
                public const string MSG_1 = "MSG_1";
                /// <summary>
                /// 메시지 2
                /// </summary>
                public const string MSG_2 = "MSG_2";
                /// <summary>
                /// 메시지 3
                /// </summary>
                public const string MSG_3 = "MSG_3";
            }
        }
        #endregion KDS 데이터 전송

        #region HPAPP_AFTER_SAVE 거래호출
        /// <summary>
        /// 해피앱 추후적립 거래호출
        /// </summary>
        public class HPAPP_AFTER_SAVE_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 회사코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 거래번호
                /// </summary>
                public const string TRADE_NO = "TRADE_NO";
                /// <summary>
                /// 해피앱 적립상태
                /// </summary>
                public const string SAVE_STATUS = "SAVE_STATUS";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_TRAN_CALL_REQ 영수증 거래호출
        /// <summary>
        /// 영수증 거래호출
        /// </summary>
        public class IQ_TRAN_CALL_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 거래번호
                /// </summary>
                public const string TRADE_NO = "TRADE_NO";
                /// <summary>
                /// 거래시간
                /// </summary>
                public const string PAY_TIME = "PAY_TIME";
                /// <summary>
                /// 반품거래여부
                /// </summary>
                public const string RET_DIV = "RET_DIV";
                /// <summary>
                /// 추가적립여부
                /// </summary>
                public const string ADD_POINT_DIV = "ADD_POINT_DIV";
                /// <summary>
                /// 추가현금영수증 발행여부
                /// </summary>
                public const string ADD_CASH_DIV = "ADD_CASH_DIV";
                /// <summary>
                /// 반품거래정보-일자
                /// </summary>
                public const string RET_SALE_DT = "RET_SALE_DT";
                /// <summary>
                /// 반품거래정보-POSNO
                /// </summary>
                public const string RET_POS_NO = "RET_POS_NO";
                /// <summary>
                /// 반품거래정보-거래번호
                /// </summary>
                public const string RET_TRADE_NO = "RET_TRADE_NO";
                /// <summary>
                /// 거래데이터 길이
                /// </summary>
                public const string TRAN_LEN = "TRAN_LEN";
                /// <summary>
                /// 거래데이터
                /// </summary>
                public const string TRAN_DATA = "TRAN_DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_TRAN_LASTNO_REQ 최종 거래번호 호출
        /// <summary>
        /// 최종 거래번호 호출
        /// </summary>
        public class IQ_TRAN_LASTNO_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 거래번호
                /// </summary>
                public const string TRADE_NO = "TRADE_NO";
                /// <summary>
                /// 등록번호 (ETC)
                /// </summary>
                public const string REG_NO = "REG_NO";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_MISS_TRANNO_REQ 결락 거래번호 조회
        /// <summary>
        /// 결락 거래번호 조회
        /// </summary>
        public class IQ_MISS_TRANNO_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 거래구분 (0:Tran, 1:Etc)
                /// </summary>
                public const string TRADE_DIV = "TRADE_DIV";
                /// <summary>
                /// 마지막 거래번호
                /// </summary>
                public const string REG_NO = "REG_NO";
                /// <summary>
                /// 결락 거래번호
                /// </summary>
                public const string REG_NO_DATA = "REG_NO_DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_POSLINEUPORDER_REQ 수량 제한 캠페인 수량 조회
        /// <summary>
        /// 수량 제한 캠페인 수량 조회
        /// </summary>
        public class IQ_POSLINEUPORDER_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 제한기준(1:일별 2:기간별)
                /// </summary>
                public const string LIMIT_DIV = "LIMIT_DIV";
                /// <summary>
                /// 제한시작일자
                /// </summary>
                public const string LIMIT_ST_DATE = "LIMIT_ST_DATE";
                /// <summary>
                /// 제한종료일자
                /// </summary>
                public const string LIMIT_ED_DATE = "LIMIT_ED_DATE";
                /// <summary>
                /// 캠페인 발행 수량
                /// </summary>
                public const string CPI_CNT = "CPI_CNT";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";

            }
        }
        #endregion

        #region IQ_SYSDATE_REQ 서버 시간 조회
        /// <summary>
        /// 서버 시간 조회
        /// </summary>
        public class IQ_SYSDATE_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string POS_HOUR = "POS_HOUR";
                /// <summary>
                /// 거래번호
                /// </summary>
                public const string REG_NO = "REG_NO";
                /// <summary>
                /// 등록번호
                /// </summary>
                public const string TRADE_NO = "TRADE_NO";
                /// <summary>
                /// 서버일시
                /// </summary>
                public const string SYS_YMDHMS = "SYS_YMDHMS";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_PGMUPDATE_REQ 프로그램 업데이트 목록 요청
        /// <summary>
        /// 프로그램 업데이트 목록 요청
        /// </summary>
        public class IQ_PGMUPDATE_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 그룹
                /// </summary>
                public const string FILE_GROUP = "FILE_GROUP";
                /// <summary>
                /// 상세종별
                /// </summary>
                public const string FILE_KIND = "FILE_KIND";
                /// <summary>
                /// 적용구분
                /// </summary>
                public const string FILE_APP_TY = "FILE_APP_TY";
                /// <summary>
                /// 적용 일시
                /// </summary>
                public const string FILE_YMDHMS = "FILE_YMDHMS";
                /// <summary>
                /// 요청구분(A:전체, U:변경분)
                /// </summary>
                public const string DOWN_DIV = "DOWN_DIV";                
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_PGMUPDATE_RSP 프로그램 업데이트 목록 응답
        /// <summary>
        /// 프로그램 업데이트 목록 응답
        /// </summary>
        public class IQ_PGMUPDATE_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 서버 IP
                /// </summary>
                public const string FILE_HQ_IP = "FILE_HQ_IP";
                /// <summary>
                /// FTP IP
                /// </summary>
                public const string FTP_IP = "FTP_IP";
                /// <summary>
                /// FTP PORT
                /// </summary>
                public const string FTP_PORT = "FTP_PORT";
                /// <summary>
                /// FTP ID
                /// </summary>
                public const string FTP_ID = "FTP_ID";
                /// <summary>
                /// FTP PWD
                /// </summary>
                public const string FTP_PWD = "FTP_PWD";
                /// <summary>
                /// VALUE (배포구분, 적용구분, 적용일시, 파일경로, 파일명, 파일버전)
                /// </summary>
                public const string VALUE  = "VALUE";
                /// <summary>
                /// 요청구분(A:전체, U:변경분)
                /// </summary>
                public const string DOWN_DIV = "DOWN_DIV";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_PGMUPDATE_COMPLETE_REQ 파일 변경 완료 요청
        /// <summary>
        /// 파일 변경 완료 요청
        /// </summary>
        public class IQ_PGMUPDATE_COMPLETE_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 그룹
                /// </summary>
                public const string FILE_GROUP = "FILE_GROUP";
                /// <summary>
                /// 상세종별
                /// </summary>
                public const string FILE_KIND = "FILE_KIND";
                /// <summary>
                /// 적용구분
                /// </summary>
                public const string FILE_APP_TY = "FILE_APP_TY";
                /// <summary>
                /// 파일명
                /// </summary>
                public const string FILE_NM = "FILE_NM";
                /// <summary>
                /// 파일버전
                /// </summary>
                public const string FILE_VER = "FILE_VER";
                /// <summary>
                /// 파일SEQ
                /// </summary>
                public const string FILE_SEQ = "FILE_SEQ";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 요청구분(A:전체, U:변경분)
                /// </summary>
                public const string DOWN_DIV = "DOWN_DIV";
                /// <summary>
                /// 다운로드일자
                /// </summary>
                public const string DEPLOY_DT = "DEPLOY_DT";
                /// <summary>
                /// 배포일자
                /// </summary>
                public const string REG_DT = "REG_DT";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_VAN_CARD_APPLOG(이동단말기 승인 내역)
        /// <summary>
        /// 이동단말기 승인 내역
        /// </summary>
        public class IQ_VAN_CARD_APPLOG
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 거래일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 단말기번호
                /// </summary>
                public const string CATID = "CATID";
                /// <summary>
                /// 거래 데이터 수량
                /// </summary>
                public const string DATA_CNT = "DATA_CNT";
                /// <summary>
                /// 거래 데이터
                /// </summary>
                public const string APPR_DATA = "APPR_DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_VAN_CARD_APPLOG(이동단말기 승인 내역)

        #region IQ_VAN_CARD_APPLOG_FINAL(이동단말기 승인 내역 확정)
        /// <summary>
        /// 이동단말기 승인 내역 확정
        /// </summary>
        public class IQ_VAN_CARD_APPLOG_FINAL
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 거래일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 단말기번호
                /// </summary>
                public const string CATID = "CATID";
                /// <summary>
                /// 거래 일련 번호
                /// </summary>
                public const string TRAN_SEQ = "TRAN_SEQ";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_VAN_CARD_APPLOG_FINAL(이동단말기 승인 내역 확정)

        #region IQ_MSG_SND_REQ/RSP(메시지 전송 요청/응답)
        public class IQ_MSG_SND_REQ
        {
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업 일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 사용자
                /// </summary>
                public const string USER_ID = "USER_ID";
                /// <summary>
                /// 반환용 메시지 코드
                /// </summary>
                public const string MSG_CD = "MSG_CD";
                /// <summary>
                /// 메시지 구분
                /// </summary>
                public const string MSG_DIV = "MSG_DIV";
                /// <summary>
                /// 업데이트 일자1(일반공지 업데이트 일자)
                /// </summary>
                public const string UPD_DT1 = "UPD_DT1";
                /// <summary>
                /// 업데이트 일자2(긴급공지 업데이트 일자)
                /// </summary>
                public const string UPD_DT2 = "UPD_DT2";
                /// <summary>
                /// 업데이트 일자3(영업공지-오늘의할일 업데이트 일자)
                /// </summary>
                public const string UPD_DT3 = "UPD_DT3";
                /// <summary>
                /// 업데이트 일자4(영업공지-식품안전메시지 업데이트 일자)
                /// </summary>
                public const string UPD_DT4 = "UPD_DT4";
            }
        }

        public class IQ_MSG_SND_RSP
        {
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업 일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 사용자 아이디
                /// </summary>
                public const string USER_ID = "USER_ID";
                /// <summary>
                /// 메시지 코드
                /// </summary>
                public const string MSG_CD = "MSG_CD";
                /// <summary>
                /// 공지 구분
                /// </summary>
                public const string MSG_DIV = "MSG_DIV";
                /// <summary>
                /// 공지 구분별 유형
                /// </summary>
                public const string MSG_TYPE = "MSG_TYPE";
                /// <summary>
                /// 메시지 TITLE
                /// </summary>
                public const string MSG_TITLE = "MSG_TITLE";
                /// <summary>
                /// 메시지 내용
                /// </summary>
                public const string MSG_CONT = "MSG_CONT";
                /// <summary>
                /// 마스터 적용 구분
                /// </summary>
                public const string POS_RCV_TYPE = "POS_RCV_TYPE";
                /// <summary>
                /// 프로그램 적용 구분
                /// </summary>
                public const string POS_EXEC_TYPE = "POS_EXEC_TYPE";
                /// <summary>
                /// 팝업 적용 구분
                /// </summary>
                public const string MSG_POPUP = "MSG_POPUP";
                /// <summary>
                /// 시작일자(YYYYMMDD)
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 종료일시(YYYYMMDDHHMMSS)
                /// </summary>
                public const string FNSH_DT = "FNSH_DT";
                /// <summary>
                /// 업데이트 시간
                /// </summary>
                public const string UPD_DATE = "UPD_DATE";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 응답 값
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        }
        #endregion IQ_MSG_SND_REQ(메시지 전송 요청)

        #region IQ_POSMASTERLIST_REQ POS 마스터 수신목록 요청
        public class IQ_POSMASTERLIST_REQ
        {
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 다운 구분
                /// </summary>
                public const string DOWN_DIV = "DOWN_DIV";
                /// <summary>
                /// 다운 마스터 항목
                /// </summary>
                public const string MASTER_LIST = "MASTER_LIST";
            }
        }
        #endregion

        #region IQ_DATA_SEARCH_REQ 자료 조회 요청
        /// <summary>
        /// 자료 조회 요청
        /// </summary>
        public class IQ_DATA_SEARCH_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POSNO
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 직가맹 구분
                /// </summary>
                public const string STOR_TY = "STOR_TY";
                /// <summary>
                /// 전문구분 (서버 i/f 문서 참조)
                /// </summary>
                public const string PRT_DIV  = "PRT_DIV";
                /// <summary>
                /// 시작일자
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 종료일자
                /// </summary>
                public const string END_DT = "END_DT";
                /// <summary>
                /// 주문차수
                /// </summary>
                public const string ORD_SEQ = "ORD_SEQ";
                /// <summary>
                /// 제품군
                /// </summary>
                public const string ORD_GRP = "ORD_GRP";
                /// <summary>
                /// DATA COUNT
                /// </summary>
                public const string DATA_CNT = "DATA_CNT";
                /// <summary>
                /// 응답 데이터
                /// </summary>
                public const string RES_DATA = "RES_DATA";

            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_POS_SPEC(포스 스펙 전송)
        /// <summary>
        /// 포스 스펙 전송
        /// </summary>
        public class IQ_POS_SPEC
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 거래일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// SYSTEM 정보
                /// </summary>
                public const string SYSTEM_DATA = "SYSTEM_DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_POS_SPEC(포스 스펙 전송)

        #region IQ_EMG_NOTE_SEND(긴급메세지 전송)
        /// <summary>
        /// 긴급메세지 전송
        /// </summary>
        public class IQ_EMG_NOTE_SEND
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// 회사코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 메시지 구분별 유형
                /// </summary>
                public const string MSG_CODE = "MSG_CODE";
                /// <summary>
                /// 긴급 공지 유형
                /// </summary>
                public const string MSG_DIV = "MSG_DIV";
                /// <summary>
                /// 시작 시간
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 업데이트 시간
                /// </summary>
                public const string UPD_DT = "UPD_DT";
                /// <summary>
                /// 읽음 플래그
                /// </summary>
                public const string READ_YN = "READ_YN";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_EMG_NOTE_SEND(긴급메세지 전송)

        #region IQ_FTPINFO_REQ 서버 ftp 정보 요청 / 응답
        /// <summary>
        /// IQ_FTPINFO_REQ 서버 ftp 정보 요청 / 응답
        /// </summary>
        public class IQ_FTPINFO_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 체크파일명
                /// </summary>
                public const string FILE_NAME = "FILE_NAME";
                /// <summary>
                /// 로컬파일 날짜
                /// </summary>
                public const string LOCAL_DATE = "LOCAL_DATE";
                /// <summary>
                /// FTP IP
                /// </summary>
                public const string FTP_IP = "FTP_IP";
                /// <summary>
                /// FTP PORT
                /// </summary>
                public const string FTP_PORT = "FTP_PORT";
                /// <summary>
                /// FTP ID
                /// </summary>
                public const string FTP_ID = "FTP_ID";
                /// <summary>
                /// FTP PWD
                /// </summary>
                public const string FTP_PWD = "FTP_PWD";
                /// <summary>
                /// SIGN_PAD_PATH
                /// </summary>
                public const string SIGN_PAD_PATH = "SIGN_PAD_PATH";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region IQ_NOTICE_INQ_REQ/RSP(공지사항 조회 요청/응답)
        /// <summary>
        /// 공지사항 조회 요청
        /// </summary>
        public class IQ_NOTICE_INQ_REQ
        {
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업 일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 메시지 등록 코드
                /// </summary>
                public const string MSG_VALUE = "MSG_VALUE";
                /// <summary>
                /// 응답 코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        }
        /// <summary>
        /// 공지사항 조회 응답
        /// </summary>
        public class IQ_NOTICE_INQ_RSP
        {
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영업 일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 공지 사항 구분
                /// </summary>
                public const string MSG_VALUE = "MSG_VALUE";
                /// <summary>
                /// 응답 코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        }
        #endregion IQ_NOTICE_INQ_REQ/RSP(공지사항 조회 요청/응답)

        #region IQ_FOODMSG_REQ/RSP(위해상품 판매차단 메시지 요청/응답)
        /// <summary>
        /// 위해상품 판매차단 메시지 요청
        /// </summary>
        public class IQ_FOODMSG_REQ
        {
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 요청구분
                /// </summary>
                public const string REQ_DIV = "REQ_DIV";
                /// <summary>
                /// 검사 기간코드
                /// </summary>
                public const string ISPCTN_ORGAN_CD = "ISPCTN_ORGAN_CD";
                /// <summary>
                /// 문서번호
                /// </summary>
                public const string DOC_NO = "DOC_NO";
                /// <summary>
                /// 일련번호
                /// </summary>
                public const string SEQ = "SEQ";
            }
        }
        /// <summary>
        /// 위해상품 판매차단 메시지 응답
        /// </summary>
        public class IQ_FOODMSG_RSP
        {
            public class DATA
            {
                /// <summary>
                /// INQ종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 요청구분
                /// </summary>
                public const string REQ_DIV = "REQ_DIV";
                /// <summary>
                /// 제품수량
                /// </summary>
                public const string DATA_CNT = "DATA_CNT";
                /// <summary>
                /// 검사기간코드
                /// </summary>
                public const string ISPCTN_ORGAN_CD = "ISPCTN_ORGAN_CD";
                /// <summary>
                /// 문서번호
                /// </summary>
                public const string DOC_NO = "DOC_NO";
                /// <summary>
                /// 일련번호
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 제품명
                /// </summary>
                public const string ITEM_NM = "ITEM_NM";
                /// <summary>
                /// 바코드
                /// </summary>
                public const string BAR_CD = "BAR_CD";
                /// <summary>
                /// 응답결과
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        }
        #endregion IQ_FOODMSG_REQ/RSP(위해상품 판매차단 메시지 요청/응답)

        #region IQ_STOR_VISIT(점포 방문 이력 송신(제조기사 타임 바코드))
        /// <summary>
        /// 점포 방문 이력 송신(제조기사 타임 바코드)
        /// </summary>
        public class IQ_STOR_VISIT
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별 = 26
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 방문일자(YYYYMMDD)
                /// </summary>
                public const string VISIT_DT = "VISIT_DT";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 관리 카드 번호
                /// </summary>
                public const string MNG_CARD_NO = "MNG_CARD_NO";
                /// <summary>
                /// 방문시작시간YYYYMMDDHHNN (시분까지)
                /// </summary>
                public const string VISIT_START_HOUR = "VISIT_START_HOUR";
                /// <summary>
                /// 방문종료시간YYYYMMDDHHNN (시분까지)
                /// </summary>
                public const string VISIT_FNSH_HOUR = "VISIT_FNSH_HOUR";
                /// <summary>
                /// 방문 사원 ID
                /// </summary>
                public const string VISIT_USER_ID = "VISIT_USER_ID";
                /// <summary>
                /// 전송 여부(Y/N)
                /// </summary>
                public const string SEND_YN = "SEND_YN";
                /// <summary>
                /// 직무 유형
                /// </summary>
                public const string JOB_TYPE = "JOB_TYPE";
                /// <summary>
                /// 점포제조지원전송여부(Y/N)
                /// </summary>
                public const string PCSMM_SEND_YN = "PCSMM_SEND_YN";
                /// <summary>
                /// MSR 구분(SS:사원 카드 스크래치 MS: 모바일 스캔)
                /// </summary>
                public const string MSR_DIV = "MSR_DIV";
                /// <summary>
                /// 원 바코드 번호
                /// </summary>
                public const string ORG_BAR_CD_NO = "ORG_BAR_CD_NO";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_STOR_VISIT(점포 방문 이력 송신(제조기사 타임 바코드))

        #region IQ_STOR_VISIT_RSP(점포 방문 이력 송신(제조기사 타임 바코드) 응답)
        /// <summary>
        /// 점포 방문 이력 송신(제조기사 타임 바코드) 응답
        /// </summary>
        public class IQ_STOR_VISIT_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별 = 26
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 등록일자(YYYYMMDD)
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 응답 코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답 메세지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_STOR_VISIT(점포 방문 이력 송신(제조기사 타임 바코드))

        #region IQ_EMP_COMMUTE(점포 근태)
        /// <summary>
        /// 점포 근태
        /// </summary>
        public class IQ_EMP_COMMUTE
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별 = 50
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 사원번호
                /// </summary>
                public const string EMP_NO = "EMP_NO";
                /// <summary>
                /// 근무일자(YYYYMMDD)
                /// </summary>
                public const string WORK_DT = "WORK_DT";
                /// <summary>
                /// 근태코드
                /// </summary>
                public const string ROS_CD = "ROS_CD";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 일시YYYYMMDDHHNN (시분까지)
                /// </summary>
                public const string HOUR_STAMP = "HOUR_STAMP";
                /// <summary>
                /// 근태시간HHNN(시분)
                /// </summary>
                public const string ROS_HOUR = "ROS_HOUR";
                /// <summary>
                /// 등록자
                /// </summary>
                public const string REG_ID = "REG_ID";
                /// <summary>
                /// 응답결과
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_EMP_COMMUTE(점포 근태)

        #region IQ_OWNER_MODE(점주/알바모드)
        /// <summary>
        /// 점주/알바모드
        /// </summary>
        public class IQ_OWNER_MODE
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별 = 52
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 사원번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 근무일자(YYYYMMDD)
                /// </summary>
                public const string WORK_DT = "WORK_DT";
                /// <summary>
                /// 근무시간(HHMMSS)
                /// </summary>
                public const string WORK_TIME = "WORK_TIME";
                /// <summary>
                /// 점주 알바 구분
                /// </summary>
                public const string EMP_DIV = "EMP_DIV";
                /// <summary>
                /// 응답결과
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_EMP_COMMUTE(점포 근태)

        #region POS TABLE 마스터 저장요청
        public class IQ_POS_TABLE_MST_INQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별 = 55
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 요청구분 
                /// 1:저장요청, 2:조회요청
                /// </summary>
                public const string INQ_DIV = "INQ_DIV";
                /// <summary>
                /// 테이블/층 저장 데이터 
                /// </summary>
                /// <example>
                /// #~01(층)|필드1|필드2|필드3|필드4~~~
                /// #~01(층)|필드1|필드2|필드3|필드4~~~
                /// #~02(테이블)|필드1|필드2|필드3|필드4~~~
                /// #~02(테이블)|필드1|필드2|필드3|필드4~~~
                /// </example>
                public const string DATA_LIST = "DATA";
                /// <summary>
                /// 응답코드 
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        } 
        #endregion

        #region IQ_STOR_CHECK_LIST_INQ(점포 점검 리스트)
        /// <summary>
        /// 점주/알바모드
        /// </summary>
        public class IQ_STOR_CHECK_LIST_INQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별 = 53
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 요청구분 (1:저장요청, 2: 데이터 요청)
                /// </summary>
                public const string INQ_DIV = "INQ_DIV";
                /// <summary>
                /// 데이터 (Header/Detail)
                /// </summary>
                public const string SAVE_DATA = "DATA";
                /// <summary>
                /// 응답 (저장(1) : 00 외 저정에러 / 데이터 저장 여부 체크(2) : 00 데이터 있음, 01 없음, 99 에러)
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_STOR_CHECK_LIST_INQ(점포 점검 리스트)

        #region IQ_CAMPAIGN_HPCNT_REQ HP 횟수 제한 캠페인 횟수 조회
        /// <summary>
        /// HP 횟수 제한 캠페인 횟수 조회
        /// </summary>
        public class IQ_CAMPAIGN_HPCNT_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 제한기준(1:일별 2:기간별)
                /// </summary>
                public const string LIMIT_DIV = "LIMIT_DIV";
                /// <summary>
                /// 제한시작일자
                /// </summary>
                public const string LIMIT_ST_DATE = "LIMIT_ST_DATE";
                /// <summary>
                /// 제한종료일자
                /// </summary>
                public const string LIMIT_ED_DATE = "LIMIT_ED_DATE";
                /// <summary>
                /// 캠페인 발행 수량
                /// </summary>
                public const string CPI_CNT = "CPI_CNT";
                /// <summary>
                /// 고객번호
                /// </summary>
                public const string CUST_ID = "CUST_ID";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";

            }
        }
        #endregion

        #region IQ_INSTALL_SCHEDULE_INQ (설치/전환 일정 조회 (57))
        /// <summary>
        /// 설치/전환 일정 조회 (57)
        /// </summary>
        public class IQ_INSTALL_SCHEDULE_INQ
        {
            public const string MSG_ID = "57";

            public class DATA
            {
                /// <summary>
                /// INQ 종별 = X0
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 요청구분 
                /// 1:설치정보조회, 2:전환정보조회(POS)
                /// </summary>
                public const string REQ_TYPE = "REQ_TYPE";
                /// <summary>
                /// 설치일자
                /// </summary>
                public const string INSTALL_DATE = "INSTALL_DATE";
                /// <summary>
                /// 설치시간
                /// </summary>
                public const string INSTALL_TIME = "INSTALL_TIME";
                /// <summary>
                /// 시스템오픈일자
                /// </summary>
                public const string SYS_OPEN_DATE = "SYS_OPEN_DATE";
                /// <summary>
                /// 응답코드 (00:정상,01:NO DATA, 그외 오류)
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        } 
        #endregion

        #region SCALE LOG 데이터 전송
        public class IQ_SCALE_LOG_REQ
        {
            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 브랜드 코드
                /// </summary>
                public const string BrandCd = "BRAND_CD";
                /// <summary>
                /// 판매 일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 측정 일자
                /// </summary>
                public const string ScaleDt = "SCALE_DT";
                /// <summary>
                /// 측정 시간
                /// </summary>
                public const string ScaleTm = "SCALE_TM";
                /// <summary>
                /// 중량
                /// </summary>
                public const string Weight = "WEIGHT";
                /// <summary>
                /// 상품명
                /// </summary>
                public const string ItemNm = "ITEM_NM";
                /// <summary>
                /// 정상/미달 구분
                /// </summary>
                public const string NormalYn = "NORMAL_YN";
            }
        }
        #endregion SCALE LOG 데이터 전송

        #region IQ_POS_ITEMINFO (상품 정보 조회 요청/응답)
        public class IQ_POS_ITEMINFO
        {
            public class DATA
            {
                /// <summary>
                /// INQ종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 회사코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 상품코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 상품조회정보
                /// </summary>
                public const string ITEM_DATA = "ITEM_DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        }
        #endregion

        #region IQ_POS_LIVECHECK_REQ (점포 장비점검이력조회)
        public class IQ_POS_LIVECHECK_REQ
        {
            public class DATA
            {
                /// <summary>
                /// INQ종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 회사코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 조회시작일자
                /// </summary>
                public const string FROM_DATE = "FROM_DATE";
                /// <summary>
                /// 조회종료일자
                /// </summary>
                public const string TO_DATE = "TO_DATE";
                /// <summary>
                /// 조회구분
                /// </summary>
                public const string DATA_DIV = "DATA_DIV";
                /// <summary>
                /// RETURN DATA
                /// </summary>
                public const string RETURN_DATA = "DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        }
        #endregion

        #region IQ_POS_LOGFILE_REQ (POS LOG 파일 조회 요청/응답)
        public class IQ_POS_LOGFILE_REQ
        {
            public class DATA
            {
                /// <summary>
                /// INQ종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 요청 LOG 일자
                /// </summary>
                public const string LOG_DT = "LOG_DT";
                /// <summary>
                /// 요청 구분(1:로그요청 확인, 2:POS 수신완료, 3:FTP 송신완료)
                /// </summary>
                public const string REQ_DIV = "REQ_DIV";
                /// <summary>
                /// 전송할 FTP PATH
                /// </summary>
                public const string FTP_PATH = "FTP_PATH";
                /// <summary>
                /// 파일명
                /// </summary>
                public const string FILE_NM = "FILE_NM";
                /// <summary>
                /// FTP_ID
                /// </summary>
                public const string FTP_ID = "FTP_ID";
                /// <summary>
                /// FTP_PWD
                /// </summary>
                public const string FTP_PWD = "FTP_PWD";
                /// <summary>
                /// FTP_IP
                /// </summary>
                public const string FTP_IP = "FTP_IP";
                /// <summary>
                /// FTP_PORT
                /// </summary>
                public const string FTP_PORT = "FTP_PORT";
                /// <summary>
                /// 응답코드
                /// 요청 구분 '1': '00'-정상, '01'-DATA 없음
                /// 요청 구분 '3': '00'-정상, '01'-저장에러
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
        }
        #endregion IQ_POS_LOGFILE_REQ (POS LOG 파일 조회 요청/응답)
        
        #region IQ_STR_EQUP_CHECKSAVE_LIST_INQ(점포 CONFIG 저장)
        /// <summary>
        /// 점포 CONFIG 저장
        /// </summary>
        public class IQ_STR_EQUP_CHECKSAVE_LIST_INQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 요청 구분(1: 저장 요청 2:조회 요청[전체], 3:항목(파일별)
                /// </summary>
                public const string INQ_DIV = "INQ_DIV";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 파일명
                /// </summary>
                public const string FILE_NM = "FILE_NM";
                /// <summary>
                /// 사용자
                /// </summary>
                public const string USER_ID = "USER_ID";
                /// <summary>
                /// 저장 데이터
                /// </summary>
                public const string CONFIG_DATA = "CONFIG_DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion IQ_STR_EQUP_CHECKSAVE_LIST_INQ(점포 CONFIG 저장)

        #region IQ_HPPMEMB_BUY_HIST_REQ 해피포인트 고객 구매이력 조회
        /// <summary>
        /// 서버 시간 조회
        /// </summary>
        public class IQ_HPPMEMB_BUY_HIST_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 해피포인트 고개번호
                /// </summary>
                public const string HP_MEMB_NO = "HP_MEMB_NO";

                //#20180524 구매이력조회 단골여부 전문추가 start,phj
                /// <summary>
                /// 해피포인트 단골고객여부
                /// </summary>
                public const string HP_REGULAR_YN = "HP_REGULAR_YN";
                //#20180524 구매이력조회 단골여부 전문추가 end,phj

                //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start, 20180528
                //쿠폰 발송 횟수 제한 기능
                /// <summary>
                /// 쿠폰 발송 횟수
                /// </summary>
                public const string CPN_SEND_CNT = "CPN_SEND_CNT";
                //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end, 20180528

                /// <summary>
                /// 구매이력
                /// </summary>
                public const string BUYDATA = "DATA";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        //#15884 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발 start
        #region IQ_HPO_INVENTORY_ALRAM 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발
        /// <summary>
        /// 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발
        /// </summary>
        public class IQ_HPO_INVENTORY_ALRAM
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";

                /// <summary>
                /// 응답Y/N
                /// </summary>
                public const string RES_YN = "RES_YN";

                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 2, 4, 10, 2, 1 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion
        //#15884 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발 end

        //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 start
        #region IQ_BOOK_INVENTORY 최초 로그인 시 장부재고 1이상인 품목 영수증 출력
        /// <summary>
        /// 최초 로그인 시 장배재고 1이상인 품목 영수증 출력 
        /// </summary>
        public class IQ_BOOK_INVENTORY
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";

                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SALE_DT = "SALE_DT"; //yyyymmdd

                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";

                /// <summary>
                /// 응답데이터
                /// </summary>
                public const string RES_DATA = "RES_DATA";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 2, 8, 2, 100 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0 };
        }
        #endregion IQ_BOOK_INVENTORY 최초 로그인 시 장부재고 1이상인 품목 영수증 출력
        //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 end

        //*----------------------------------------------------------------------------------------------------------*/
        // VAN 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/

        #region VAN 전문 헤더
        public class POS_VAN_HEADER
        {

            public class DATA
            {

            }

            public class SEQ
            {
                /// <summary>
                /// 전문길이
                /// </summary>
                public const int HdrLen = 0;
                /// <summary>
                /// STX <0x02>
                /// </summary>
                public const int HdrSTX = 1;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int HdrTrDiv = 2;
                /// <summary>
                /// 단말기 번호
                /// </summary>
                public const int HdrCatNo = 3;
                /// <summary>
                /// 업체정보
                /// </summary>
                public const int HdrCompany = 4;
                /// <summary>
                /// 전문번호
                /// </summary>
                public const int HdrDocSeq = 5;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 1, 2, 10, 8, 6 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { 1, 0, 0, 0, 0, 1 };

        }
        #endregion VAN 전문 헤더

        #region 신용카드IC 요청

        public class POS_REQ_CREDITCARDIC
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전
                /// </summary>
                public const int DocVer = 0;
                /// <summary>
                /// POS Entry Mode
                /// </summary>
                public const int EntryMode = 1;
                /// <summary>
                /// Track II
                /// </summary>
                public const int TrackII = 2;
                /// <summary>
                /// FS (0x1c)
                /// </summary>
                public const int TrackIIFS = 3;
                /// <summary>
                /// 할부개월
                /// </summary>
                public const int DivMonth = 4;
                /// <summary>
                /// 총금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 5;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 6;
                /// <summary>
                /// GS
                /// </summary>
                public const int ServiceAmtGS = 7;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 8;
                /// <summary>
                /// Working Key Index - "AA" : 비밀번호 미사용시, "BB" : 암호화되지 않은 비밀번호 사용시, "00"-"99" : 암호화된 비밀번호 사용시
                /// </summary>
                public const int WKI = 9;
                /// <summary>
                /// 비밀번호 - 미사용시 : "0000000000000000", Clear Pin 사용시 : Clear Pin(2) + Space, Encryped Pin 사용시 : Pin Encrypted Block
                /// </summary>
                public const int PassWord = 10;
                /// <summary>
                /// 상품코드 - 미사용시 All Space, OCB 원카드 처리 불가 : "OCBN", 앱카드/삼성페이 거래시 부가서비스 코드 2자리 설정
                /// </summary>
                public const int ItemCode = 11;
                /// <summary>
                /// 사용자정보 - 주민등록번호 뒤 7자리(개인카드) 또는 사업자번호 10자리, (법인카드) (Left Justfied)
                /// </summary>
                public const int CustmerInfo = 12;
                /// <summary>
                /// 전자상거래 보완등급 - 은련카드 : "E" (비밀번호 6자리 암호화 해야 함)
                /// </summary>
                public const int ECSLevel = 13;
                /// <summary>
                /// 도메인
                /// </summary>
                public const int Domain = 14;
                /// <summary>
                /// 업체서버IP
                /// </summary>
                public const int ServerIP = 15;
                /// <summary>
                /// Mall사업자번호
                /// </summary>
                public const int MallBizNo = 16;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int Reserved = 17;
                /// <summary>
                /// 업무 구분 - "D" : 동글거래
                /// </summary>
                public const int BizDiv = 18;
                /// <summary>
                /// 매체구분 - "M" : Mobile, "P" : Plastic
                /// </summary>
                public const int MediaDiv = 19;
                /// <summary>
                /// 이통사구분 - "S" : SKT , "K" : KTF, "L" : LGT
                /// </summary>
                public const int CorporationDiv = 20;
                /// <summary>
                /// 신용카드 종류"V" : VisaWave, "P" : PayPass,- "S" : SKT-RF, "K" : KTF-RF, "L" : LGT-RF, "I" : IR, "B" : BC, "Y" : Pay-On, "A" : 앱카드, "C" : 삼성페이
                /// </summary>
                public const int CardKind = 21;
                ///// <summary>
                ///// ETC
                ///// </summary>
                public const int ETX = 22;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 23;

            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  4,  1,  1, 1,  2,  9,  9, 1,  9,  2, 
                                        16,  6,  13, 1, 40,  20,  10, 4,  1,  1,
                                         1,  1,  1, 1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 3, 0, 1, 1, 1, 0, 1, 0, 
                                         1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 0, 0, 0, 0
                                       };
        }

        #endregion 신용카드IC 요청

        #region 신용카드IC 응답(승인/취소 공통)
        public class POS_RES_CREDITCARDIC
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {

                /// <summary>
                /// 전문버전
                /// </summary>
                public const int DocVer = 0;
                /// <summary>
                /// 거래일시 - 'O' : 승인 'X' : 거절
                /// </summary>
                public const int Status = 1;
                /// <summary>
                /// 거래일시 - YYMMDDhhmm
                /// </summary>
                public const int AppDatatime = 2;
                /// <summary>
                /// Message1 - 승인시 : 카드종류명, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message1 = 3;
                /// <summary>
                /// Message2 - 승인시 : "OK : " 승인번호 8자리, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message2 = 4;
                /// <summary>
                /// 승인번호 - 신용승인번호 또는 거절코드(4)
                /// </summary>
                public const int AppNo = 5;
                /// <summary>
                /// 카드종류명 - 발급사 카드종류명
                /// </summary>
                public const int CardName = 6;
                /// <summary>
                /// 발급사코드 - 발급사 코드 (카드사 코드 Table 참조)
                /// </summary>
                public const int IssueCode = 7;
                /// <summary>
                /// 매입사명 - 전표 매입사명
                /// </summary>
                public const int BuyName = 8;
                /// <summary>
                /// 매입사코드 - 매입사 코드 (카드사 코드 Table 참조)
                /// </summary>
                public const int BuyCode = 9;
                /// <summary>
                /// 가맹점번호
                /// </summary>
                public const int FranchiseNo = 10;
                /// <summary>
                /// Working Key Index - "00"-"99" : 암호화된 비밀번호 사용시
                /// </summary>
                public const int WKI = 11;
                /// <summary>
                /// Working Key - 비밀번호 사용시 : TMK[TPK]
                /// </summary>
                public const int WK = 12;
                /// <summary>
                /// 전송구분  
                /// </summary>
                public const int SendYn = 13;
                /// <summary>
                /// Notice
                /// </summary>
                public const int Notice = 14;
                /// <summary>
                /// 사용자정보
                /// </summary>
                public const int CustomerInfo = 15;
                /// <summary>
                /// 전자상거래 보완등급 - 은련카드 : "E" (비밀번호 6자리 암호화 해야 함)
                /// </summary>
                public const int ECSLevel = 16;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int Reserved = 17;
                /// <summary>
                /// Respone EmvData
                /// </summary>
                public const int EMVData = 18;
                /// <summary>
                /// GS
                /// </summary>
                public const int EVMDataGs = 19;
                /// <summary>
                /// 단말기 기능 수행 - K1 : 다음 거래 전 Key Download 요청, S0 : 2nd Generation 미 수행
                /// </summary>
                public const int DeviceFunc = 20;
                /// <summary>
                /// “0000”예비 필드 길이
                /// </summary>
                public const int Filler = 21;
                /// <summary>
                /// 예비 필드
                /// </summary>
                public const int FillerNew = 22;
                /// <summary>
                /// 0x03
                /// </summary>
                public const int ETX = 23;
                /// <summary>
                /// 0x0D
                /// </summary>
                public const int CR = 24;

            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            //public static int[] LEN = {  4,  1,  10, 16, 16,  8, 16,  2,  16,  2, 
            //                            15,  2,  16,  2, 18, 13,  1,  6, 808,  1,
            //                             2,  4, 256,  1,  1
            //                          };
            public static int[] LEN = {  4,  1,  10, 16, 16,  8, 16,  2,  16,  2, 
                                        15,  2,  16,  2, 18, 13,  1,  6,   1,  1,
                                         2,  4,   1,  1,  1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 
                                         0, 0, 3, 0, 0
                                       };
        }

        #endregion 신용카드IC 응답

        #region 신용카드IC 취소 요청
        public class POS_REQ_CREDITCARDIC_CANCEL
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전
                /// </summary>
                public const int DocVer = 0;
                /// <summary>
                /// POS Entry Mode
                /// </summary>
                public const int EntryMode = 1;
                /// <summary>
                /// Track II
                /// </summary>
                public const int TrackII = 2;
                /// <summary>
                /// FS (0x1c)
                /// </summary>
                public const int TrackIIFS = 3;
                /// <summary>
                /// 할부개월
                /// </summary>
                public const int DivMonth = 4;
                /// <summary>
                /// 총금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 5;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 6;
                /// <summary>
                /// GS
                /// </summary>
                public const int ServiceAmtGS = 7;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 8;
                /// <summary>
                /// Working Key Index - "AA" : 비밀번호 미사용시, "BB" : 암호화되지 않은 비밀번호 사용시, "00"-"99" : 암호화된 비밀번호 사용시
                /// </summary>
                public const int WKI = 9;
                /// <summary>
                /// 비밀번호 - 미사용시 : "0000000000000000", Clear Pin 사용시 : Clear Pin(2) + Space, Encryped Pin 사용시 : Pin Encrypted Block
                /// </summary>
                public const int PassWord = 10;
                /// <summary>
                /// 원거래 승인 번호
                /// </summary>
                public const int OrgAppNo = 11;
                /// <summary>
                /// 원거래 일자
                /// </summary>
                public const int OrgAppDate = 12;
                /// <summary>
                /// 상품코드 - 미사용시 All Space, OCB 원카드 처리 불가 : "OCBN", 앱카드/삼성페이 거래시 부가서비스 코드 2자리 설정
                /// </summary>
                public const int ItemCode = 13;
                /// <summary>
                /// 사용자정보 - 주민등록번호 뒤 7자리(개인카드) 또는 사업자번호 10자리, (법인카드) (Left Justfied)
                /// </summary>
                public const int CustmerInfo = 14;
                /// <summary>
                /// 전자상거래 보완등급 - 은련카드 : "E" (비밀번호 6자리 암호화 해야 함)
                /// </summary>
                public const int ECSLevel = 15;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int Reserved = 16;
                /// <summary>
                /// 업무 구분 - "D" : 동글거래
                /// </summary>
                public const int BizDiv = 17;
                /// <summary>
                /// 매체구분 - "M" : Mobile, "P" : Plastic
                /// </summary>
                public const int MediaDiv = 18;
                /// <summary>
                /// 이통사구분 - "S" : SKT , "K" : KTF, "L" : LGT
                /// </summary>
                public const int CorporationDiv = 19;
                /// <summary>
                /// 신용카드 종류"V" : VisaWave, "P" : PayPass,- "S" : SKT-RF, "K" : KTF-RF, "L" : LGT-RF, "I" : IR, "B" : BC, "Y" : Pay-On, "A" : 앱카드, "C" : 삼성페이
                /// </summary>
                public const int CardKind = 20;
                ///// <summary>
                ///// ETC
                ///// </summary>
                public const int ETX = 21;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 22;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  4,  1,  1, 1,  2,  9,  9, 1,  9,  2, 
                                        16,  8,  6, 6, 13,  1,  6, 1,  1,  1,
                                         1,  1,  1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 3, 0, 1, 1, 1, 0, 1, 0, 
                                         1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 0, 0
                                       };
        }

        #endregion

        #region 신용카드 MSR 요청

        public class POS_REQ_CREDITCARD_MSR
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            { 
                /// <summary>
                /// POS Entry Mode
                /// </summary>
                public const int EntryMode = 0;
                /// <summary>
                /// Track II
                /// </summary>
                public const int TrackII = 1;
                /// <summary>
                /// FS (0x1c)
                /// </summary>
                public const int TrackIIFS = 2;
                /// <summary>
                /// 할부개월
                /// </summary>
                public const int DivMonth = 3;
                /// <summary>
                /// 총금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 4;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 5;
                /// <summary>
                /// GS
                /// </summary>
                public const int ServiceAmtGS = 6;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 7;
                /// <summary>
                /// Working Key Index - "AA" : 비밀번호 미사용시, "BB" : 암호화되지 않은 비밀번호 사용시, "00"-"99" : 암호화된 비밀번호 사용시
                /// </summary>
                public const int WKI = 8;
                /// <summary>
                /// 비밀번호 - 미사용시 : "0000000000000000", Clear Pin 사용시 : Clear Pin(2) + Space, Encryped Pin 사용시 : Pin Encrypted Block
                /// </summary>
                public const int PassWord = 9;
                /// <summary>
                /// 상품코드 - 미사용시 All Space, OCB 원카드 처리 불가 : "OCBN", 앱카드/삼성페이 거래시 부가서비스 코드 2자리 설정
                /// </summary>
                public const int ItemCode = 10;
                /// <summary>
                /// 사용자정보 - 주민등록번호 뒤 7자리(개인카드) 또는 사업자번호 10자리, (법인카드) (Left Justfied)
                /// </summary>
                public const int CustmerInfo = 11;
                /// <summary>
                /// 전자상거래 보완등급 - 은련카드 : "E" (비밀번호 6자리 암호화 해야 함)
                /// </summary>
                public const int ECSLevel = 12;
                /// <summary>
                /// 도메인
                /// </summary>
                public const int Domain = 13;
                /// <summary>
                /// 업체서버IP
                /// </summary>
                public const int ServerIP = 14;
                /// <summary>
                /// Mall사업자번호
                /// </summary>
                public const int MallBizNo = 15;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int Reserved = 16;
                /// <summary>
                /// 업무 구분 - "D" : 동글거래
                /// </summary>
                public const int BizDiv = 17;
                /// <summary>
                /// 매체구분 - "M" : Mobile, "P" : Plastic
                /// </summary>
                public const int MediaDiv = 18;
                /// <summary>
                /// 이통사구분 - "S" : SKT , "K" : KTF, "L" : LGT
                /// </summary>
                public const int CorporationDiv = 19;
                /// <summary>
                /// 신용카드 종류"V" : VisaWave, "P" : PayPass,- "S" : SKT-RF, "K" : KTF-RF, "L" : LGT-RF, "I" : IR, "B" : BC, "Y" : Pay-On, "A" : 앱카드, "C" : 삼성페이
                /// </summary>
                public const int CardKind = 20;
                /// <summary>
                /// IC Chip Data
                /// </summary>
                public const int ICChipData = 21;
                /// <summary>
                /// IC Chip Data GS
                /// </summary>
                public const int ICChipData_GS = 22;
                /// <summary>
                /// Sign Data
                /// </summary>
                public const int SignData = 23;
                /// <summary>
                /// Sign Data GS
                /// </summary>
                public const int SignData_GS = 24; 
                /// <summary>
                /// 등록제 번호
                /// </summary>
                public const int AuthInfo_IC = 25;
                /// <summary>
                /// 예비필드
                /// </summary>
                public const int Filler = 26;
                /// <summary>
                /// 신규 예비필드
                /// </summary>
                public const int Filler_New = 27;
                /// <summary>
                /// ETC
                /// </summary>
                public const int ETX = 28;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 29;

            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1,  37,  1,  2,  9, 9, 1, 9, 2, 16, 6,
                                        13, 1, 40, 20, 10, 4, 1, 1, 1,  1,
                                        1, 1, 1, 1, 48, 4, 1, 1, 1 
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0,  0,  0, 1, 1, 1, 0, 1, 0, 0, 0,
                                         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         3, 0, 3, 0, 0, 0, 3, 0, 0
                                       };
        }

        #endregion 신용카드MSR 요청

        #region 신용카드 MSR 응답(승인/취소 공통)
        public class POS_RES_CREDITCARD_MSR
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            { 
                /// <summary>
                /// 거래일시 - 'O' : 승인 'X' : 거절
                /// </summary>
                public const int Status = 0;
                /// <summary>
                /// 거래일시 - YYMMDDhhmm
                /// </summary>
                public const int AppDatatime = 1;
                /// <summary>
                /// Message1 - 승인시 : 카드종류명, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message1 = 2;
                /// <summary>
                /// Message2 - 승인시 : "OK : " 승인번호 8자리, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message2 = 3;
                /// <summary>
                /// 승인번호 - 신용승인번호 또는 거절코드(4)
                /// </summary>
                public const int AppNo = 4;
                /// <summary>
                /// 카드종류명 - 발급사 카드종류명
                /// </summary>
                public const int CardName = 5;
                /// <summary>
                /// 발급사코드 - 발급사 코드 (카드사 코드 Table 참조)
                /// </summary>
                public const int IssueCode = 6;
                /// <summary>
                /// 매입사명 - 전표 매입사명
                /// </summary>
                public const int BuyName = 7;
                /// <summary>
                /// 매입사코드 - 매입사 코드 (카드사 코드 Table 참조)
                /// </summary>
                public const int BuyCode = 8;
                /// <summary>
                /// 가맹점번호
                /// </summary>
                public const int FranchiseNo = 9;
                /// <summary>
                /// Working Key Index - "00"-"99" : 암호화된 비밀번호 사용시
                /// </summary>
                public const int WKI = 10;
                /// <summary>
                /// Working Key - 비밀번호 사용시 : TMK[TPK]
                /// </summary>
                public const int WK = 11;
                /// <summary>
                /// 전송구분  
                /// </summary>
                public const int SendYn = 12;
                /// <summary>
                /// Notice
                /// </summary>
                public const int Notice = 13;
                /// <summary>
                /// 사용자정보
                /// </summary>
                public const int CustomerInfo = 14;
                /// <summary>
                /// 전자상거래 보완등급 - 은련카드 : "E" (비밀번호 6자리 암호화 해야 함)
                /// </summary>
                public const int ECSLevel = 15;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int Reserved = 16;
                /// <summary>
                /// Respone EmvData
                /// </summary>
                public const int EMVData = 17;
                /// <summary>
                /// GS
                /// </summary>
                public const int EVMDataGs = 18;
                /// <summary>
                /// 단말기 기능 수행 - K1 : 다음 거래 전 Key Download 요청, S0 : 2nd Generation 미 수행
                /// </summary>
                public const int DeviceFunc = 19;
                /// <summary>
                /// “0000”예비 필드 길이
                /// </summary>
                public const int Filler = 20;
                /// <summary>
                /// 예비 필드
                /// </summary>
                public const int FillerNew = 21;
                /// <summary>
                /// 0x03
                /// </summary>
                public const int ETX = 22;
                /// <summary>
                /// 0x0D
                /// </summary>
                public const int CR = 23;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  1,  10, 16, 16,  8, 16,  2,  16,  2, 
                                        15,  2,  16,  2, 18, 13,  1,  6,   1,  1,
                                         2,  4,   1,  1,  1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 
                                         0, 0, 3, 0, 0
                                       };
        }

        #endregion 신용카드MSR 응답
        
        #region 신용카드MSR 취소 요청
        public class POS_REQ_CREDITCARD_MSR_CANCEL
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            { 
                /// <summary>
                /// POS Entry Mode
                /// </summary>
                public const int EntryMode = 0;
                /// <summary>
                /// Track II
                /// </summary>
                public const int TrackII = 1;
                /// <summary>
                /// FS (0x1c)
                /// </summary>
                public const int TrackIIFS = 2;
                /// <summary>
                /// 할부개월
                /// </summary>
                public const int DivMonth = 3;
                /// <summary>
                /// 총금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 4;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 5;
                /// <summary>
                /// GS
                /// </summary>
                public const int ServiceAmtGS = 6;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 7;
                /// <summary>
                /// Working Key Index - "AA" : 비밀번호 미사용시, "BB" : 암호화되지 않은 비밀번호 사용시, "00"-"99" : 암호화된 비밀번호 사용시
                /// </summary>
                public const int WKI = 8;
                /// <summary>
                /// 비밀번호 - 미사용시 : "0000000000000000", Clear Pin 사용시 : Clear Pin(2) + Space, Encryped Pin 사용시 : Pin Encrypted Block
                /// </summary>
                public const int PassWord = 9;
                /// <summary>
                /// 원거래 승인 번호
                /// </summary>
                public const int OrgAppNo = 10;
                /// <summary>
                /// 원거래 일자
                /// </summary>
                public const int OrgAppDate = 11;
                /// <summary>
                /// 상품코드 - 미사용시 All Space, OCB 원카드 처리 불가 : "OCBN", 앱카드/삼성페이 거래시 부가서비스 코드 2자리 설정
                /// </summary>
                public const int ItemCode = 12;
                /// <summary>
                /// 사용자정보 - 주민등록번호 뒤 7자리(개인카드) 또는 사업자번호 10자리, (법인카드) (Left Justfied)
                /// </summary>
                public const int CustmerInfo = 13;
                /// <summary>
                /// 전자상거래 보완등급 - 은련카드 : "E" (비밀번호 6자리 암호화 해야 함)
                /// </summary>
                public const int ECSLevel = 14;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int Reserved = 15;
                /// <summary>
                /// 업무 구분 - "D" : 동글거래
                /// </summary>
                public const int BizDiv = 16;
                /// <summary>
                /// 매체구분 - "M" : Mobile, "P" : Plastic
                /// </summary>
                public const int MediaDiv = 17;
                /// <summary>
                /// 이통사구분 - "S" : SKT , "K" : KTF, "L" : LGT
                /// </summary>
                public const int CorporationDiv = 18;
                /// <summary>
                /// 신용카드 종류"V" : VisaWave, "P" : PayPass,- "S" : SKT-RF, "K" : KTF-RF, "L" : LGT-RF, "I" : IR, "B" : BC, "Y" : Pay-On, "A" : 앱카드, "C" : 삼성페이
                /// </summary>
                public const int CardKind = 19;
                /// <summary>
                /// IC Chip Data
                /// </summary>
                public const int ICChipData = 20;
                /// <summary>
                /// IC Chip Data GS
                /// </summary>
                public const int ICChipData_GS = 21;
                /// <summary>
                /// Sign Data
                /// </summary>
                public const int SignData = 22;
                /// <summary>
                /// Sign Data GS
                /// </summary>
                public const int SignData_GS = 23;
                /// <summary>
                /// 등록제 번호
                /// </summary>
                public const int AuthInfo_IC = 24;
                /// <summary>
                /// 예비필드
                /// </summary>
                public const int Filler = 25;
                /// <summary>
                /// 신규 예비필드
                /// </summary>
                public const int Filler_New = 26;
                ///// <summary>
                ///// ETC
                ///// </summary>
                public const int ETX = 27;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 28;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  1,  37, 1,  2,  9,  9, 1,  9,  2, 
                                        16,  8,  6, 6, 13,  1,  6, 1,  1,  1,
                                         1,  1,  1, 1, 1, 48, 4, 1, 
                                         1,  1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 1, 1, 1, 0, 1, 0, 
                                         1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 3, 0, 3, 0, 0, 0, 3,
                                         0, 0
                                       };
        }

        #endregion

        #region 수표조회 요청

        public class POS_REQ_CHECK
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 수표번호(8) + 발행은행코드(2) + 발행영업점코드(4)
                /// </summary>
                public const int CheckNo = 0;
                /// <summary>
                /// 권종코드 - "13": 10 만원권, "14": 30 만원권,"15": 50 만원권, "16": 100 만원권,"19": 기타
                /// </summary>
                public const int KownCode = 1;
                /// <summary>
                /// 수표금액
                /// </summary>
                public const int CheckAmt = 2;
                /// <summary>
                /// 발행일
                /// </summary>
                public const int IssueDate = 3;
                /// <summary>
                /// 계좌일련번호
                /// </summary>
                public const int AccountNo = 4;
                /// <summary>
                /// Filler
                /// </summary>
                public const int Filler = 5;
                /// <summary>
                /// ETX
                /// </summary>
                public const int ETX = 6;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 7;

            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  14,  2,  10,  6,  6,  20, 1 , 1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 1, 0, 1, 0, 0, 0
                                       };
        }
        #endregion

        #region 수표조회 응답
        public class POS_RES_CHECK
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 거래일시 - 'O' : 승인 'X' : 거절
                /// </summary>
                public const int Status = 0;
                /// <summary>
                /// 거래일시 - YYMMDDhhmm
                /// </summary>
                public const int AppDatatime = 1;
                /// <summary>
                /// Message1 - 승인시 : 카드종류명, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message1 = 2;
                /// <summary>
                /// Message2 - 승인시 : "OK : " 승인번호 8자리, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message2 = 3;
                /// <summary>
                /// Message3 - 승인시 : Space , 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message3 = 4;
                /// <summary>
                /// Message4 - 승인시 : Space , 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message4 = 5;
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int ResponeCode = 6;
                /// <summary>
                /// 예비 필드
                /// </summary>
                public const int Filler = 7;
                /// <summary>
                /// 0x03
                /// </summary>
                public const int ETX = 8;
                /// <summary>
                /// 0x0D
                /// </summary>
                public const int CR = 9;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 10, 16, 16, 16, 16, 4, 16, 1, 1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
                                       };
        }

        #endregion

        #region 현금영수증 요청
        public class POS_REQ_CASHBILL
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전
                /// </summary>
                public const int DocVer = 0;
                /// <summary>
                /// 거래유형 - '0' : 단독현금 '1' : 현금+포인트
                /// </summary>
                public const int TrandKind = 1;
                /// <summary>
                /// POS Entry Mode
                /// </summary>
                public const int EntryMode = 2;
                /// <summary>
                /// 사용자정보
                /// </summary>
                public const int CustmerInfo = 3;
                /// <summary>
                /// 사용자정보(fs)
                /// </summary>
                public const int CustmerInfoFs = 4;
                /// <summary>
                /// 공급가액
                /// </summary>
                public const int NetSaleAmt = 5;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 6;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 7;
                /// <summary>
                /// 총금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 8;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int TradDiv = 9;
                /// <summary>
                /// 포인트Pos Entry Mode -  "S" : Swipe "K" : Key -in
                /// </summary>
                public const int PointEntryMode = 10;
                /// <summary>
                /// Point Track II
                /// </summary>
                public const int PointTrackII = 11;
                /// <summary>
                /// FS (0x1c)
                /// </summary>
                public const int PointTrackIIFS = 12;
                /// <summary>
                /// 상품코드 - 미사용시 All Space, OCB 원카드 처리 불가 : "OCBN", 앱카드/삼성페이 거래시 부가서비스 코드 2자리 설정
                /// </summary>
                public const int ItemCode = 13;
                /// <summary>
                /// 가맹점사용ID - 가맹점 사용필드 사용업체 고유 번호('98':대외 P/G, '99':KSNET P/G)
                /// </summary>
                public const int StoreUserID = 14;
                /// <summary>
                /// 가맹점사용필드- 가맹점 사용 Data Field('98', '99':하위몰사업자 10자리)
                /// </summary>
                public const int StoreUseFild = 15;
                /// <summary>
                /// Filler
                /// </summary>
                public const int Filler = 16;
                /// <summary>
                /// ETC
                /// </summary>
                public const int ETX = 17;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 18;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            //public static int[] LEN = {  4, 1, 1, 1, 1, 9, 9, 9, 9, 1, 
            //                             1, 1, 1, 6, 2,30,67, 1, 1
            //                          };
            public static int[] LEN = {  1, 1, 1, 1, 1, 9, 9, 9, 9, 1, 
                                         1, 1, 1, 6, 2,30,67, 1, 1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            //public static int[] TYPE = { 0, 0, 0, 3, 0, 1, 1, 1, 1, 0,
            //                             0, 3, 0, 0, 0, 0, 0, 0, 0 
            //                           };
            public static int[] TYPE = { 3, 0, 0, 3, 0, 1, 1, 1, 1, 0,
                                         0, 3, 0, 0, 0, 0, 0, 0, 0 
                                       };
        }
        #endregion

        #region 현금영수증 응답 - IC
        public class POS_RES_CASHBILL
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전
                /// </summary>
                public const int DocVer = 0;
                /// <summary>
                /// 거래일시 - 'O' : 승인 'X' : 거절
                /// </summary>
                public const int Status = 1;
                /// <summary>
                /// 거래일시 - YYMMDDhhmm
                /// </summary>
                public const int AppDatatime = 2;
                /// <summary>
                /// Message1 - 승인시 : 카드종류명, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message1 = 3;
                /// <summary>
                /// Message2 - 승인시 : "OK : " 승인번호 8자리, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message2 = 4;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int TradDiv = 5;
                /// <summary>
                /// 승인번호 - 현금영수증 승인번호 또는 거절코드(4)
                /// </summary>
                public const int CashAppNo = 6;
                /// <summary>
                /// 현금 Notice1
                /// </summary>
                public const int Notice1 = 7;
                /// <summary>
                /// 현금 Notice2
                /// </summary>
                public const int Notice2 = 8;
                /// <summary>
                ///거래포인트
                /// </summary>
                public const int UsePoint = 9;
                /// <summary>
                ///가용포인트
                /// </summary>
                public const int SalePoint = 10;
                /// <summary>
                ///누적포인트
                /// </summary>
                public const int RemainPoint = 11;
                /// <summary>
                ///포인트승인번호
                /// </summary>
                public const int PointAppNo = 12;
                /// <summary>
                ///포인트카드명
                /// </summary>
                public const int PointCardName = 13;
                /// <summary>
                /// 포인트가맹점번호
                /// </summary>
                public const int PointStoreNo = 14;
                /// <summary>
                ///포인트Notice1
                /// </summary>
                public const int PointNotice1 = 15;
                /// <summary>
                ///포인트Notice2
                /// </summary>
                public const int PointNotice2 = 16;
                /// <summary>
                ///포인트Notice3
                /// </summary>
                public const int PointNotice3 = 17;
                /// <summary>
                ///포인트Notice4
                /// </summary>
                public const int PointNotice4 = 18;
                /// <summary>
                /// 가맹점사용ID - 가맹점 사용필드 사용업체 고유 번호('98':대외 P/G, '99':KSNET P/G)
                /// </summary>
                public const int StoreUserID = 19;
                /// <summary>
                /// 가맹점사용필드- 가맹점 사용 Data Field('98', '99':하위몰사업자 10자리)
                /// </summary>
                public const int StoreUseFild = 20;
                /// <summary>
                /// Filler
                /// </summary>
                public const int Filler = 21;
                /// <summary>
                ///KEY다운로드요청
                /// </summary>
                public const int ReqKeyDownLoad = 22;
                /// <summary>
                ///예비필드길이
                /// </summary>
                public const int NewFillerLength = 23;
                /// <summary>
                ///신규 예비 필드
                /// </summary>
                public const int NewFiller = 24;
                /// <summary>
                /// ETC
                /// </summary>
                public const int ETX = 25;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 26;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  4,  1, 10, 16, 16,  1,  9, 20, 20, 9, 
                                         9,  9, 12, 16, 15, 40, 40, 40, 40, 2,
                                        30, 66,  2,  4,  1,  1,  1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 
                                         1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 0, 0, 0, 3, 0, 0
                                       };
        }
        #endregion
        
        #region 현금영수증 응답 - MSR
        public class POS_RES_CASHBILL_MSR
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 거래일시 - 'O' : 승인 'X' : 거절
                /// </summary>
                public const int Status = 0;
                /// <summary>
                /// 거래일시 - YYMMDDhhmm
                /// </summary>
                public const int AppDatatime = 1;
                /// <summary>
                /// Message1 - 승인시 : 카드종류명, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message1 = 2;
                /// <summary>
                /// Message2 - 승인시 : "OK : " 승인번호 8자리, 거절시 : 거절 MESSAGE
                /// </summary>
                public const int Message2 = 3;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int TradDiv = 4;
                /// <summary>
                /// 승인번호 - 현금영수증 승인번호 또는 거절코드(4)
                /// </summary>
                public const int CashAppNo = 5;
                /// <summary>
                /// 현금 Notice1
                /// </summary>
                public const int Notice1 = 6;
                /// <summary>
                /// 현금 Notice2
                /// </summary>
                public const int Notice2 = 7;
                /// <summary>
                ///거래포인트
                /// </summary>
                public const int UsePoint = 8;
                /// <summary>
                ///가용포인트
                /// </summary>
                public const int SalePoint = 9;
                /// <summary>
                ///누적포인트
                /// </summary>
                public const int RemainPoint = 10;
                /// <summary>
                ///포인트승인번호
                /// </summary>
                public const int PointAppNo = 11;
                /// <summary>
                ///포인트카드명
                /// </summary>
                public const int PointCardName = 12;
                /// <summary>
                /// 포인트가맹점번호
                /// </summary>
                public const int PointStoreNo = 13;
                /// <summary>
                ///포인트Notice1
                /// </summary>
                public const int PointNotice1 = 14;
                /// <summary>
                ///포인트Notice2
                /// </summary>
                public const int PointNotice2 = 15;
                /// <summary>
                ///포인트Notice3
                /// </summary>
                public const int PointNotice3 = 16;
                /// <summary>
                ///포인트Notice4
                /// </summary>
                public const int PointNotice4 = 17;
                /// <summary>
                /// 가맹점사용ID - 가맹점 사용필드 사용업체 고유 번호('98':대외 P/G, '99':KSNET P/G)
                /// </summary>
                public const int StoreUserID = 18;
                /// <summary>
                /// 가맹점사용필드- 가맹점 사용 Data Field('98', '99':하위몰사업자 10자리)
                /// </summary>
                public const int StoreUseFild = 19;
                /// <summary>
                /// Filler
                /// </summary>
                public const int Filler = 20;
                /// <summary>
                ///KEY다운로드요청
                /// </summary>
                public const int ReqKeyDownLoad = 21;
                /// <summary>
                ///예비필드길이
                /// </summary>
                public const int NewFillerLength = 22;
                /// <summary>
                ///신규 예비 필드
                /// </summary>
                public const int NewFiller = 23;
                /// <summary>
                /// ETC
                /// </summary>
                public const int ETX = 24;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 25;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  1, 10, 16, 16,  1,  9, 20, 20, 9, 
                                         9,  9, 12, 16, 15, 40, 40, 40, 40, 2,
                                        30, 66,  2,  4,  1,  1,  1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 1, 
                                         1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 0, 0, 0, 3, 0, 0
                                       };
        }
        #endregion
        
        #region 현금영수증 취소 요청
        public class POS_REQ_CASHBILL_CANCEL
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전
                /// </summary>
                public const int DocVer = 0;
                /// <summary>
                /// 거래유형 - '0' : 단독현금 '1' : 현금+포인트
                /// </summary>
                public const int TrandKind = 1;
                /// <summary>
                /// POS Entry Mode
                /// </summary>
                public const int EntryMode = 2;
                /// <summary>
                /// 사용자정보
                /// </summary>
                public const int CustmerInfo = 3;
                /// <summary>
                /// 사용자정보(fs)
                /// </summary>
                public const int CustmerInfoFs = 4;
                /// <summary>
                /// 공급가액
                /// </summary>
                public const int NetSaleAmt = 5;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 6;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 7;
                /// <summary>
                /// 총금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 8;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int TradDiv = 9;
                /// <summary>
                /// 원거래 승인 번호
                /// </summary>
                public const int OrgAppNo = 10;
                /// <summary>
                /// 원거래 포인트승인번호
                /// </summary>
                public const int OrgAppNoPoint = 11;
                /// <summary>
                /// 원거래 일자
                /// </summary>
                public const int OrgAppDate = 12;
                /// <summary>
                /// 포인트Pos Entry Mode -  "S" : Swipe "K" : Key -in
                /// </summary>
                public const int PointEntryMode = 13;
                /// <summary>
                /// Point Track II
                /// </summary>
                public const int PointTrackII = 14;
                /// <summary>
                /// FS (0x1c)
                /// </summary>
                public const int PointTrackIIFS = 15;
                /// <summary>
                /// 상품코드 - 미사용시 All Space, OCB 원카드 처리 불가 : "OCBN", 앱카드/삼성페이 거래시 부가서비스 코드 2자리 설정
                /// </summary>
                public const int ItemCode = 16;
                /// <summary>
                /// 가맹점사용ID - 가맹점 사용필드 사용업체 고유 번호('98':대외 P/G, '99':KSNET P/G)
                /// </summary>
                public const int StoreUserID = 17;
                /// <summary>
                /// 가맹점사용필드- 가맹점 사용 Data Field('98', '99':하위몰사업자 10자리)
                /// </summary>
                public const int StoreUseFild = 18;
                /// <summary>
                /// 취소사유코드
                /// </summary>
                public const int CancelReasonCode = 19;
                /// <summary>
                /// Filler
                /// </summary>
                public const int Filler = 20;
                /// <summary>
                /// ETC
                /// </summary>
                public const int ETX = 21;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 22;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  1, 1, 1, 1, 1, 9, 9, 9, 9, 1, 
                                         9,12, 6, 1, 1, 1, 6, 2,30, 1,
                                        66, 1, 1
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 3, 0, 0, 3, 0, 1, 1, 1, 1, 0,
                                         0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
                                         0, 0, 0 
                                       };
        }
        #endregion
        
        #region POINT
        ///// <summary>
        ///// POINT INFO
        ///// </summary>
        //public class POINT
        //{
        //    public const string ITEM = "POINT";

        //    public class DATA
        //    {
        //        /// <summary>
        //        /// 암호화된 포인트 카드 번호
        //        /// </summary>
        //        public string pointNo = "";
        //        /// <summary>
        //        /// 마스킹처리된 포인트 카드 번호
        //        /// </summary>
        //        public string pointMaskNo = "";
        //        /// <summary>
        //        /// 입력 모드 - "S" : Swipe "K" : Key -in ‘B’: 바코드
        //        /// </summary>
        //        public string pointEntryMode = "";
        //        /// <summary>
        //        /// 요청금액
        //        /// </summary>
        //        public string pointAMT = "";
        //        /// <summary>
        //        /// 전문 버전
        //        /// </summary>
        //        public string pointDocVer      = "" ;
        //        /// <summary>
        //        /// STAUTS 0 승인, 1 거절
        //        /// </summary>
        //        public string pointStatus      = "" ;
        //        /// <summary>
        //        /// 거래일시YYMMDDhhmm
        //        /// </summary>
        //        public string pointTrDate      = "" ;
        //        /// <summary>
        //        /// - 승인시 : "카드종류명"- 거절시 : 거절 MESSAGE
        //        /// </summary>
        //        public string pointMessage1    = "" ;
        //        /// <summary>
        //        /// - 승인시 : "OK : " 승인번호 8자리- 거절시 : 거절 MESSAGE
        //        /// </summary>
        //        public string pointMessage2    = "" ;
        //        /// <summary>
        //        /// 승인번호 포인트 승인번호 또는 거절코드(4) 
        //        /// </summary>
        //        public string pointApprNo      = "" ;
        //        /// <summary>
        //        /// 거래포인트 - 거래(발생)포인트(Right Justfied & Leading Zero)
        //        /// </summary>
        //        public double pointTrPoint     = 0 ;
        //        /// <summary>
        //        /// 가용포인트 - 가용포인트(Right Justfied & Lea ding Zero)
        //        /// </summary>
        //        public double pointUsesPoint   = 0 ;
        //        /// <summary>
        //        /// - 누적포인트(Right Justfied & Leading Zero)
        //        /// </summary>
        //        public double pointSavePoint   = 0 ;
        //        /// <summary>
        //        /// - 예비포인트(Right Justfied & Leading Zero)
        //        /// </summary>
        //        public double pointSparePoint  = 0 ;
        //        /// <summary>
        //        /// 가맹점 번호
        //        /// </summary>
        //        public string pointStoreNo     = "" ;
        //        /// <summary>
        //        /// 임직원 포인트
        //        /// </summary>
        //        public string pointNotice1     = "" ;
        //        /// <summary>
        //        /// 임직원 포인트
        //        /// </summary>
        //        public string pointNotice2     = "" ;
        //        /// <summary>
        //        /// 
        //        /// </summary>
        //        public string pointNotice3     = "" ;
        //        /// <summary>
        //        /// 
        //        /// </summary>
        //        public string pointnotice4     = "" ;
        //        /// <summary>
        //        /// 예약필드 스마일페이 현금영수증여부 응답
        //        /// </summary>
        //        public string pointReserved    = "" ;
        //        /// <summary>
        //        /// 캠페인 정보
        //        /// </summary>
        //        public string pointCampaign    = "" ;                
        //        /// <summary>
        //        /// 전문버전 ‘SP0X’일때만 존재, X정수
        //        /// </summary>
        //        public string pointAddRespon   = "" ;                
        //        /// <summary>
        //        /// 전문버전‘SP02’일 때 존재“K1”이면 다음 거래 전 Key Download 요청
        //        /// </summary>
        //        public string pointKeyDownLoad = "" ;
        //        /// <summary>
        //        /// 전문버전‘SP02’일 때 존재“0000”예비 필드 길이
        //        /// </summary>
        //        public string pointFsLen       = "" ;
        //        /// <summary>
        //        /// 전문버전‘SP02’일 때 존재 예비 필드
        //        /// </summary>
        //        public string pointFsField     = "" ;

        //        //--------------------------------추가 정보
        //        /// <summary>
        //        ///1,  4 //해피포인트 응답 코드
        //        /// </summary>                                                
        //        public string pointHPOUTCD = "";
        //        /// <summary>
        //        ///5,  1 //포인트 적립 가능 여부
        //        /// </summary>                 
        //        public string pointHPADDYN = "";
        //        /// <summary>
        //        ///6,  1 //포인트 사용 가능 여부
        //        /// </summary>                 
        //        public string pointHPUSEYN = "";
        //        /// <summary>
        //        ///7,  1 //포인트 사용 비밀번호 적용 여부
        //        /// </summary>                 
        //        public string pointHPUSEPWYN = "";
        //        /// <summary>
        //        ///8,  1 //포인트 전환 가능 여부
        //        /// </summary>                 
        //        public string pointHPCHYN = "";
        //        /// <summary>
        //        ///9,  1 //모바일 앱 요청 여부
        //        /// </summary>                 
        //        public string pointHPAPPYN = "";
        //        /// <summary>
        //        ///10,  2 //카드구분코드
        //        /// </summary>                 
        //        public string pointCARDGBCD = "";
        //        /// <summary>
        //        ///12,  7 //잔여 해피포인트
        //        /// </summary>                 
        //        public string pointJHPPO = "";
        //        /// <summary>
        //        ///19,  7 //잔여 캐시포인트
        //        /// </summary>                 
        //        public string pointJCASHPO = "";
        //        /// <summary>
        //        ///26,  7 //잔여공유 해피포인트
        //        /// </summary>                 
        //        public string pointJSHPPO = "";
        //        /// <summary>
        //        ///33,  7 //잔여공유 캐시포인트
        //        /// </summary>                 
        //        public string pointJSCASHPO = "";
        //        /// <summary>
        //        ///40,  7 //소멸예정 해피포인트
        //        /// </summary>                 
        //        public string pointDELHPPO = "";
        //        /// <summary>
        //        ///47,  7 //소멸예정 캐시포인트
        //        /// </summary>                 
        //        public string pointDELCASHPO = "";
        //        /// <summary>
        //        ///54,  1 //선불카드여부
        //        /// </summary>                 
        //        public string pointSUNCARDYN = "";
        //        /// <summary>
        //        ///55, 10 //선불카드 잔여 금액
        //        /// </summary>                 
        //        public string pointSUNCARDJAMT = "";
        //        /// <summary>
        //        ///65,  5 //회원 등급 코드
        //        /// </summary>                 
        //        public string pointMEMGB = "";
        //        /// <summary>
        //        ///70,  1 //생일여부
        //        /// </summary>                 
        //        public string pointBIRDAYYN = "";
        //        /// <summary>
        //        ///71,  1 //결혼여부
        //        /// </summary>                 
        //        public string pointMERRYYN = "";
        //        /// <summary>
        //        ///72,  3 //회원연령
        //        /// </summary>                 
        //        public string pointMEMAGE = "";
        //        /// <summary>
        //        ///75,  1 //회원성별구분코드
        //        /// </summary>                 
        //        public string pointMEMSEX = "";
        //        /// <summary>
        //        ///76,  4 //보유 쿠폰 개수
        //        /// </summary>                 
        //        public string pointCOUPONCNT = "";
        //        /// <summary>
        //        ///80, 10 //스탬프 정보 내용
        //        /// </summary>                 
        //        public string pointSTAMPINFO = "";
        //        /// <summary>
        //        ///90,241 //회원목록
        //        /// </summary>                 
        //        public string pointMEMINFO = "";
        //        /// <summary>
        //        ///331, 70 //VReserved
        //        /// </summary>                 
        //        public string pointARESERVED = "";
        //    }
        //    /// <summary>
        //    /// 컬럼순서
        //    /// </summary>
        //    public class SEQ
        //    {

        //    }

        //    /// <summary>
        //    /// 컬럼길이
        //    /// </summary>
        //    public static int[] LEN = { };

        //    /// <summary>
        //    /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
        //    /// </summary>
        //    public static int[] TYPE = { };
        //}
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // CAT 단말기 승인 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region  CAT 단말기 승인 요청
        public class POS_REQ_SPCN_CAT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전
                /// </summary>
                public const int TranType = 0;
                /// <summary>
                /// 거래유형
                /// </summary>
                public const int TrandeType = 1;
                /// <summary>
                /// 할부개월 or 현금영수증거래유형(00 : 소득공제,01 : 사업자지출증빙,02 : 자진발급)
                /// </summary>
                public const int DivMonth = 2;
                /// <summary>
                /// 승인금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 3;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 4;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 5;
                /// <summary>
                /// 원거래승인번호
                /// </summary>
                public const int OrgAppNo = 6;
                /// <summary>
                /// 원거래일자
                /// </summary>
                public const int OrgDate = 7;
                /// <summary>
                /// 포인트 거래 구분
                /// </summary>
                public const int PointTradeType = 8;
                /// <summary>
                /// 상품코드
                /// </summary>
                public const int GoodsCode = 9;
                /// <summary>
                /// 전표인쇄여부
                /// </summary>
                public const int PrintFlag = 10;
                /// <summary>
                /// 추가항목
                /// </summary>
                public const int AddItem = 11;

            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  2,  2,  2,  9,  9,  9, 12,  6,  2,  6, 
                                         1,  300
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 
                                         0, 0
                                       };
        }
        #endregion
        //*----------------------------------------------------------------------------------------------------------*/
        // CAT 단말기 수신 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region  CAT 단말기 승인 응답
        public class POS_RES_SPCN_CAT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전
                /// </summary>
                public const int TranType = 0;
                /// <summary>
                /// 거래유형
                /// </summary>
                public const int TrandeType = 1;
                /// <summary>
                /// 거래일시 - 'O0' : 승인 '99' : 망취소 그외 거절
                /// </summary>
                public const int Status = 2;
                /// <summary>
                /// 응답메세지
                /// </summary>
                public const int Message = 3;
                /// <summary>
                /// 단말기번호
                /// </summary>
                public const int TerminalNo = 4;
                /// <summary>
                /// PosEntryMode(01: Key -In, 02 : Swife(M/S), 03 : IC(EMV),04 : Fall )
                /// </summary>
                public const int PosEntryMode = 5;
                /// <summary>
                /// 카드번호 = 6 자리만들어옴
                /// </summary>
                public const int CardBinData = 6;
                /// <summary>
                /// 서비스코드
                /// </summary>
                public const int ServiceCode = 7;
                /// <summary>
                /// 할부개월 or 현금영수증거래유형(00 : 소득공제,01 : 사업자지출증빙,02 : 자진발급)
                /// </summary>
                public const int DivMonth = 8;
                /// <summary>
                /// 거래일시 - YYMMDDhhmm
                /// </summary>
                public const int AppDatatime = 9;
                /// <summary>
                /// 원거래 일자
                /// </summary>
                public const int OrgAppDate = 10;
                /// <summary>
                /// 승인금액 - Right Justfied & Leading Zero , 1원:포인트 조회
                /// </summary>
                public const int TotAmt = 11;
                /// <summary>
                /// 봉사료 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int ServiceAmt = 12;
                /// <summary>
                /// 세금 - Right Justfied & Leading Zero( 미사용시 All '0')
                /// </summary>
                public const int Vat = 13;
                /// <summary>
                /// 승인번호 - 신용승인번호 또는 거절코드(4)
                /// </summary>
                public const int AppNo = 14;
                /// <summary>
                /// 거래 교유 번호
                /// </summary>
                public const int TradeUniqeNo = 15;
                /// <summary>
                /// 발급사코드 - 발급사 코드 (카드사 코드 Table 참조)
                /// </summary>
                public const int IssueCode = 16;
                /// <summary>
                /// 카드종류명 - 발급사 카드종류명
                /// </summary>
                public const int CardName = 17;
                /// <summary>
                /// 가맹점번호
                /// </summary>
                public const int FranchiseNo = 18;
                /// <summary>
                /// 매입구분
                /// </summary>
                public const int BuyType = 19;
                /// <summary>
                /// 매입사코드 - 매입사 코드 (카드사 코드 Table 참조)
                /// </summary>
                public const int BuyCode = 20;
                /// <summary>
                /// 매입사명 - 전표 매입사명
                /// </summary>
                public const int BuyName = 21;
                /// <summary>
                /// 전표인쇄 TVR값
                /// </summary>
                public const int TVR = 22;
                /// <summary>
                /// 전표인쇄TC값
                /// </summary>
                public const int TC = 23;
                /// <summary>
                /// 사용자코드
                /// </summary>
                public const int UserCode = 24;
                /// <summary>
                /// 추가항목
                /// </summary>
                public const int AddItem = 25;

            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  2,  2,  2, 67, 10,  2, 20,  5,  2, 12, 
                                         8,  9,  9,  9, 12, 12,  4, 16, 15,  1,
                                         4, 16, 10, 16,  4,300
                                      };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
                                         0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 
                                         0, 0, 0, 0, 0, 0
                                       };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 샨더단말기 승인 요청 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region  샨더단말기 승인/응답 요청
        public class POS_REQ_SAND_CAT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 작업유형
                /// </summary>
                public const int OperateType = 0;
                /// <summary>
                /// 거래유형
                /// </summary>
                public const int TransType = 1;
                /// <summary>
                /// 카드유형
                /// </summary>
                public const int CardType = 2;
                /// <summary>
                /// 현금등록번호
                /// </summary>
                public const int CashRegNo = 3;
                /// <summary>
                /// 캐셔번호
                /// </summary>
                public const int CasherNo = 4;
                /// <summary>
                /// 거래금액
                /// </summary>
                public const int Amount = 5;
                /// <summary>
                /// 현금추적번호
                /// </summary>
                public const int CashTraceNo = 6;
                /// <summary>
                /// 기존 거래일련번호, 해지 트랜잭션 사용
                /// </summary>
                public const int OrignTrace = 7;
                /// <summary>
                /// 예약필드
                /// </summary>
                public const int Reserved = 8;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  2,  2,  2,  6,  6, 12,  6, 6, 48 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 1, 1, 2, 0, 0, 0 };
        }
        
        public class POS_RES_SAND_CAT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 작업유형
                /// </summary>
                public const int OperateType = 0;
                /// <summary>
                /// 거래유형
                /// </summary>
                public const int TransType = 1;
                /// <summary>
                /// 카드유형
                /// </summary>
                public const int CardType = 2;
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int ResponseCode = 3;
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const int ResponseMsg = 4;
                /// <summary>
                /// 현금등록번호
                /// </summary>
                public const int CashRegNo = 5;
                /// <summary>
                /// 캐셔번호
                /// </summary>
                public const int CasherNo = 6;
                /// <summary>
                /// 거래금액
                /// </summary>
                public const int Amount = 7;
                /// <summary>
                /// 결제배치번호
                /// </summary>
                public const int SettleNum = 8;
                /// <summary>
                /// 사업자번호
                /// </summary>
                public const int MerchantID = 9;
                /// <summary>
                /// 회사명
                /// </summary>
                public const int MerchantName = 10;
                /// <summary>
                /// 단말기 ID
                /// </summary>
                public const int TerminalID = 11;
                /// <summary>
                /// 카드번호
                /// </summary>
                public const int CardNo = 12;
                /// <summary>
                /// 유효기간
                /// </summary>
                public const int Exp_Date = 13;
                /// <summary>
                /// 은행코드
                /// </summary>
                public const int BankNo = 14;
                /// <summary>
                /// 거래일자
                /// </summary>
                public const int TransDate = 15;
                /// <summary>
                /// 거래시간
                /// </summary>
                public const int TransTime = 16;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int Auth_Code = 17;
                /// <summary>
                /// 시스템 참조 번호
                /// </summary>
                public const int SysRefNo = 18;
                /// <summary>
                /// 현금추적번호
                /// </summary>
                public const int CashTraceNo = 19;
                /// <summary>
                /// 원거래일련번호
                /// </summary>
                public const int OriginTrace = 20;
                /// <summary>
                /// Pos 거래일련번호
                /// </summary>
                public const int SysTraceNo = 21;
                /// <summary>
                /// 시스템 일련번호
                /// </summary>
                public const int OrignSysTrace = 22;
                /// <summary>
                /// 예약필드
                /// </summary>
                public const int Reserved = 23;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  2, 2, 2, 2, 40, 6, 6, 12, 6,
                                        15, 40, 8, 19, 4, 6, 8, 6, 6,
                                        12, 6, 6, 6, 6, 48};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                        0, 0, 0, 0, 0, 0, 0, 0, 0,
                                        0, 0, 0, 0, 0, 0};
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 은련단말기 승인 요청 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region  은련단말기 승인/응답 요청
        public class POS_REQ_UNION_CAT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// PosNo
                /// </summary>
                public const int PosNo = 0;
                /// <summary>
                /// 캐셔번호
                /// </summary>
                public const int CasherNo = 1;
                /// <summary>
                /// 거래유형 ('00':승인, '01'취소)
                /// </summary>
                public const int TransType = 2;
                /// <summary>
                /// 결제금액
                /// </summary>
                public const int Amount = 3;
                /// <summary>
                /// 승인일자, 원승인일자
                /// </summary>
                public const int AppDate = 4;
                /// <summary>
                /// 기존 결제 참조번호
                /// </summary>
                public const int OriginVAppno = 5;
                /// <summary>
                /// 기존 인증번호
                /// </summary>
                public const int OriginCAppno = 6;
                /// <summary>
                /// 회신전문 인증용
                /// </summary>
                public const int LRCCheckSum = 7;
                /// <summary>
                /// 전민불서비스인경우에 한하여
                /// </summary>
                public const int AllPeople = 8;

            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 8, 8, 2, 12, 8, 12, 6, 3, 100 }; 

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변, 5:문자형 왼쪽에 공백 추가)
            /// </summary>
            //public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            public static int[] TYPE = { 5, 0, 0, 1, 0, 0, 0, 0, 0 };//값 형식 수정; girak.kim;2017.08.18
        }

        public class POS_RES_UNION_CAT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int ResponseCode = 0;
                /// <summary>
                /// 은행코드
                /// </summary>
                public const int BankNo = 1;
                /// <summary>
                /// 카드번호
                /// </summary>
                public const int CardNo = 2;
                /// <summary>
                /// 인증번호
                /// </summary>
                public const int Auth_Code = 3;
                /// <summary>
                /// 결제금액
                /// </summary>
                public const int Amount = 4;
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const int ResponseMsg = 5;
                /// <summary>
                /// 고객번호
                /// </summary>
                public const int CustomerNo = 6;
                /// <summary>
                /// 단말기ID
                /// </summary>
                public const int TerminalID = 7;
                /// <summary>
                /// 배치번호
                /// </summary>
                public const int BatchNo = 8;
                /// <summary>
                /// 승인일자
                /// </summary>
                public const int AppDate = 9;
                /// <summary>
                /// 승인시간
                /// </summary>
                public const int AppTime = 10;
                /// <summary>
                /// 결제 참조번호
                /// </summary>
                public const int OriginVAppno = 11;
                /// <summary>
                /// 권한 부여번호
                /// </summary>
                public const int GrantNo = 12;
                /// <summary>
                /// 정산일자
                /// </summary>
                public const int EndDate = 13;
                /// <summary>
                /// 회신전문 인증용
                /// </summary>
                public const int LRCCheckSum = 14; 
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {  2, 4, 20, 6, 12, 40, 15, 8, 6, 4, 6, 12, 6, 4, 2};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // POINT 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POINT 전문 헤더
        public class POS_POINT_HEADER
        {

            public class DATA
            {
                /// <summary>
                /// 전문길이
                /// </summary>
                public string ReqLen;
                /// <summary>
                /// STX <0x02>
                /// </summary>
                public string ReqSTX;
                /// <summary>
                /// 거래구분
                /// </summary>
                public string ReqTrDiv;
                /// <summary>
                /// 단말기 번호
                /// </summary>
                public string ReqCatNo;
                /// <summary>
                /// 업체정보
                /// </summary>
                public string ReqCompany;
                /// <summary>
                /// 전문번호
                /// </summary>
                public string ReqDocSeq;
            }

            public class SEQ
            {
                /// <summary>
                /// 전문길이
                /// </summary>
                public const int ReqLen = 0;
                /// <summary>
                /// STX <0x02>
                /// </summary>
                public const int ReqSTX = 1;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int ReqTrDiv = 2;
                /// <summary>
                /// 단말기 번호
                /// </summary>
                public const int ReqCatNo = 3;
                /// <summary>
                /// 업체정보
                /// </summary>
                public const int ReqCompany = 4;
                /// <summary>
                /// 전문번호
                /// </summary>
                public const int ReqDocSeq = 5;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 1, 2, 10, 8, 6 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { 1, 0, 0, 0, 0, 1 };

        }
        #endregion POINT 전문 헤더
        //*----------------------------------------------------------------------------------------------------------*/
        // POINT 통합 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_REQ_POINT
        /// <summary>
        /// POS_REQ_POINT 
        /// </summary>
        public class POS_REQ_POINT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문버전 IC READER SP02 ,기존 SP01
                /// </summary>
                public const int ReqDocVer = 0;
                /// <summary>
                /// POS ENRTY MODE RF카드 R,"S" : Swipe K" Key‘B’: 알리페이 바코드
                /// </summary>
                public const int ReqEntryMode = 1;
                /// <summary>
                /// HPY 조회시, 주민번호, 핸드폰 번호, KTF모바일카드는 "=" 안붙임.
                /// - Swipe:Magnetic Card Track II Data- Key-in:"카드번호=유효기간"- 암호화를 고려 Variable 로 변경
                /// </summary>
                public const int ReqTrack2 = 2;
                /// <summary>
                /// const char FS  = (char)0x1C; //Field Seperate
                /// char FS = (char)Convert.ToInt32("1C", 16); // //Field Seperate
                /// </summary>
                public const int ReqFS = 3;

                /// <summary>
                /// 포인트금액
                /// - Right Justfied & Leading Zero
                /// 알리페이 금액 처리 방법
                /// ex) 1달러 일 때 000000100 (원화 1\ : 1, 달러 1$ : 100)
                /// </summary>
                public const int ReqPointAmt = 4;
                /// <summary>
                /// 판매구분
                /// - '01':현금 '02':신용 '03':직불 '04':자사
                ///'31':해피포인트 기타업무
                /// </summary>
                public const int ReqSaleDiv = 5;
                /// <summary>
                /// 원거래승인번호
                /// </summary>
                public const int ReqOriginSaleNo = 6;
                /// <summary>
                /// 원거래일자
                /// </summary>
                public const int ReqOriginSaleDate = 7;
                /// <summary>
                /// //비밀번호 미사용시 "0000000000000000", 포인트 사용일 경우만 사용
                /// </summary>
                public const int ReqPassWord = 8;
                /// <summary>
                /// "HPY";//포인트구분
                /// </summary>
                public const int ReqPointType = 9;
                /// <summary>
                /// - 상품코드(미사용시 All Space)- SKT 상품코드 사용(PC, PB)
                /// </summary>
                public const int ReqProductCode = 10;
                /// <summary>
                /// 예약필드/추가적립 (적립구분2, 본사부담금9, 매장부담금9) + 20
                /// 해피스탬프 적립 18
                /// </summary>
                public const int ReqReserved = 11;
                /// <summary>
                /// 캠페인 정보 = 
                /// </summary>
                public const int ReqCampaign = 12;
                /// <summary>
                /// const char RS  = (char)0x1E; //#30  char RS = (char)Convert.ToInt32("1E", 16); // // Seperate
                /// </summary>
                public const int ReqRS = 13;
                /// <summary>
                /// 추가정보 - 200
                /// 요청 사용자 ID           10 +
                /// SAP 코드 - POS 점포코드  10 +
                /// POS 번호                 2 + 
                /// VReserved                178 
                /// </summary>
                public const int ReqAddInfo = 14;
                /// <summary>
                /// const char ETX = (char)0x03; //End Text [응답용Asc]
                /// </summary>
                public const int ReqETX = 15;
                /// <summary>
                /// const char CR  = (char)0x0D; // char CR = (char)Convert.ToInt32("0D", 16); 
                /// </summary>
                public const int ReqCR = 16;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = {4,  1,  1,  1, 
                                       9,  2, 12,  6, 16,  3,  6, 38,  1,  1,  1, 1, 1};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = {0,0,3,0,
                                        2,0,0,0,0,0,0,0,3,0,3,0,0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // POINT 응답 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_POINT
        /// <summary>
        /// POS_RES_POINT 
        /// </summary>
        public class POS_RES_POINT
        {
            public const string ITEM = "POS_RES_POINT";

            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문 버전
                /// </summary>
                public const int ResDocVer = 0;
                /// <summary>
                /// STAUTS 0 승인, 1 거절
                /// </summary>
                public const int ResStatus = 1;
                /// <summary>
                /// 거래일시YYMMDDhhmm
                /// </summary>
                public const int ResTrDate = 2;
                /// <summary>
                /// - 승인시 : "카드종류명"- 거절시 : 거절 MESSAGE
                /// </summary>
                public const int ResMessage1 = 3;
                /// <summary>
                /// - 승인시 : "OK : " 승인번호 8자리- 거절시 : 거절 MESSAGE
                /// </summary>
                public const int ResMessage2 = 4;
                /// <summary>
                /// 승인번호 포인트 승인번호 또는 거절코드(4) 
                /// </summary>
                public const int ResApprNo = 5;
                /// <summary>
                /// 거래포인트 - 거래(발생)포인트
                /// </summary>
                public const int ResTrPoint = 6;
                /// <summary>
                /// 가용포인트 - 가용포인트
                /// </summary>
                public const int ResUsesPoint = 7;
                /// <summary>
                /// - 누적포인트
                /// </summary>
                public const int ResSavePoint = 8;
                /// <summary>
                /// - 예비포인트
                /// </summary>
                public const int ResSparePoint = 9;
                /// <summary>
                /// 가맹점 번호
                /// </summary>
                public const int ResStoreNo = 10;
                /// <summary>
                /// 임직원 포인트
                /// </summary>
                public const int ResNotice1 = 11;
                /// <summary>
                /// 임직원 포인트
                /// </summary>
                public const int ResNotice2 = 12;
                /// <summary>
                /// 
                /// </summary>
                public const int ResNotice3 = 13;
                /// <summary>
                /// 
                /// </summary>
                public const int Resnotice4 = 14;
                /// <summary>
                /// 예약필드 스마일페이 현금영수증여부 응답
                /// </summary>
                public const int ResReserved = 15;
                /// <summary>
                /// 캠페인 정보
                /// </summary>
                public const int ResCampaign = 16;
                /// <summary>
                /// const char RS  = (char)0x1E; //#30   char RS = (char)Convert.ToInt32("1E", 16); // // Seperate
                /// </summary>
                public const int ResRS = 17;
                /// <summary>
                /// 전문버전 ‘SP0X’일때만 존재, X정수
                /// </summary>
                public const int ResAddRespon = 18;
                /// <summary>
                /// 0x1D, ‘SP02’일 때 존재
                /// </summary>
                public const int ResGS = 19;
                /// <summary>
                /// 전문버전‘SP02’일 때 존재“K1”이면 다음 거래 전 Key Download 요청
                /// </summary>
                public const int ResKeyDownLoad = 20;
                /// <summary>
                /// 전문버전‘SP02’일 때 존재“0000”예비 필드 길이
                /// </summary>
                public const int ResFsLen = 21;
                /// <summary>
                /// 전문버전‘SP02’일 때 존재 예비 필드
                /// </summary>
                public const int ResFsField = 22;
                /// <summary>
                /// const char ETX = (char)0x03; //End Text [응답용Asc]
                /// </summary>
                public const int ResETX = 23;
                /// <summary>
                /// const char CR  = (char)0x0D; //char CR = (char)Convert.ToInt32("0D", 16); // //
                /// </summary>
                public const int ResCR = 24;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 4,  1, 10, 16,  
                                        16, 12,  9,  9,  9,  9, 15, 40, 40, 40,
                                        40, 55,  1,  1,  1,  1,  2,  4,  1,  1,  1};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = {0,0,0,0,
                                        0,0,0,0,0,0,0,0,0,0,
                                        0,0,4,0,3,0,0,0,3,0,0};
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 해피포인트카드 추가정보
        //*----------------------------------------------------------------------------------------------------------*/
        #region 해피포인트 추가정보(조회시)
        /// <summary>
        /// POINT_ADD_INFO_SEARCH 
        /// </summary>
        public class POINT_ADD_INFO_SEARCH
        {
            public const string ITEM = "POINT_ADD_INFO_SEARCH";
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                ///1,  4 //해피포인트 응답 코드
                /// </summary>                                                
                public const int pointHPOUTCD = 0;
                /// <summary>
                ///5,  1 //포인트 적립 가능 여부
                /// </summary>                 
                public const int pointHPADDYN = 1;
                /// <summary>
                ///6,  1 //포인트 사용 가능 여부
                /// </summary>                 
                public const int pointHPUSEYN = 2;
                /// <summary>
                ///7,  1 //포인트 사용 비밀번호 적용 여부
                /// </summary>                 
                public const int pointHPUSEPWYN = 3;
                /// <summary>
                ///8,  1 //포인트 전환 가능 여부
                /// </summary>                 
                public const int pointHPCHYN = 4;
                /// <summary>
                ///9,  1 //모바일 앱 요청 여부
                /// </summary>                 
                public const int pointHPAPPYN = 5;
                /// <summary>
                ///10,  2 //카드구분코드
                /// </summary>                 
                public const int pointCARDGBCD = 6;
                /// <summary>
                ///12,  7 //잔여 해피포인트
                /// </summary>                 
                public const int pointJHPPOINT = 7;
                /// <summary>
                ///19,  7 //잔여 캐시포인트
                /// </summary>                 
                public const int pointJCASHPOINT = 8;
                /// <summary>
                ///26,  7 //잔여공유 해피포인트
                /// </summary>                 
                public const int pointJSHPPOINT = 9;
                /// <summary>
                ///33,  7 //잔여공유 캐시포인트9
                /// </summary>                 
                public const int pointJSCASHPOINT = 10;
                /// <summary>
                ///40,  7 //소멸예정 해피포인트
                /// </summary>                 
                public const int pointDELHPPOINT = 11;
                /// <summary>
                ///47,  7 //소멸예정 캐시포인트
                /// </summary>                 
                public const int pointDELCASHPOINT = 12;
                /// <summary>
                ///54,  1 //선불카드여부
                /// </summary>                 
                public const int pointSUNCARDYN = 13;
                /// <summary>
                ///55, 10 //선불카드 잔여 금액
                /// </summary>                 
                public const int pointSUNCARDJAMT = 14;
                /// <summary>
                ///65,  5 //회원 등급 코드
                /// </summary>                 
                public const int pointMEMGB = 15;
                /// <summary>
                ///70,  1 //생일여부
                /// </summary>                 
                public const int pointBIRDAYYN = 16;
                /// <summary>
                ///71,  1 //결혼여부
                /// </summary>                 
                public const int pointMERRYYN = 17;
                /// <summary>
                ///72,  3 //회원연령
                /// </summary>                 
                public const int pointMEMAGE = 18;
                /// <summary>
                ///75,  1 //회원성별구분코드
                /// </summary>                 
                public const int pointMEMSEX = 19;
                /// <summary>
                ///76,  4 //보유 쿠폰 개수
                /// </summary>                 
                public const int pointCOUPONCNT = 20;
                /// <summary>
                ///80, 10 //스탬프 정보 내용
                /// </summary>                 
                public const int pointSTAMPINFO = 21;
                /// <summary>
                ///90,241 //회원목록
                /// </summary>                 
                public const int pointMEMINFO = 22;
                /// <summary>
                ///331, 70 //VReserved
                /// </summary>                 
                public const int pointRESERVED = 23;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 4,  1,  1,  1,  1,  1,  2,  7,  7,  7,
                                        7,  7,  7,  1, 10,  5,  1,  1,  3,  1,
                                        //4, 10,  241,  1}; //test_phj
                                        4, 10,  241,  70};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                         0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                         //0, 0, 0, 3 };//test_phj
                                         0, 0, 0, 0};
        }
        #endregion

        #region 해피포인트 추가정보(적립시)
        /// <summary>
        /// POINT_ADD_INFO_SAVE 
        /// </summary>
        public class POINT_ADD_INFO_SAVE
        {
            public const string ITEM = "POINT_ADD_INFO_SAVE";
            //// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 추가적립여부
                /// </summary> 
                public const int AddSaveYN = 0;
                /// <summary>
                /// 추가적립구분
                /// </summary> 
                public const int AddSaveType = 1;
                /// <summary>
                /// 추가브랜드 분담포인트
                /// </summary>
                public const int AddBrandPnt = 2;
                /// <summary>
                /// 추가가맹점 분담포인트
                /// </summary>
                public const int AddStorePnt = 3;
                /// <summary>
                /// 카드구분 코드
                /// </summary>
                public const int CardTypeCd = 4;
                /// <summary>
                /// 추가적립 포인트
                /// </summary> 
                public const int AddSavePnt = 5;
                /// <summary>
                /// 기부 포인트
                /// </summary> 
                public const int DonatePnt = 6;
                /// <summary>
                /// 회원명
                /// </summary> 
                public const int CustName = 7;
                /// <summary>
                /// 생일여부
                /// </summary>
                public const int BirthDayYn = 8;
                /// <summary>
                /// 결혼여부
                /// </summary>
                public const int MarryYn = 9;
                /// <summary>
                /// 회원연령
                /// </summary>
                public const int CustAge = 10;
                /// <summary>
                /// 회원성별구분코드
                /// </summary>
                public const int CustSex = 11;
                /// <summary>
                /// 스템프 정보 내용
                /// </summary>
                public const int StampInfo = 12;
                /// <summary>
                /// 예비
                /// </summary>
                public const int VReserved = 13;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1,  2,  7,  7,  2,  7,  7,  50,  1,  1,
                                        3,  1,  10,  1};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                         0, 0, 0, 3 };
        }
        #endregion

        #region 해피포인트 추가정보(사용시)
        /// <summary>
        /// POINT_ADD_INFO_USE 
        /// </summary>
        public class POINT_ADD_INFO_USE
        {
            public const string ITEM = "POINT_ADD_INFO_USE";
            //// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 카드구분 코드
                /// </summary>
                public const int CardTypeCd = 0;
                /// <summary>
                /// 회원명
                /// </summary> 
                public const int CustName = 1;
                /// <summary>
                /// 생일여부
                /// </summary>
                public const int BirthDayYn = 2;
                /// <summary>
                /// 결혼여부
                /// </summary>
                public const int MarryYn = 3;
                /// <summary>
                /// 회원연령
                /// </summary>
                public const int CustAge = 4;
                /// <summary>
                /// 회원성별구분코드
                /// </summary>
                public const int CustSex = 5;
                /// <summary>
                /// 스템프 정보 내용
                /// </summary>
                public const int StampInfo = 6;
                /// <summary>
                /// 예비
                /// </summary>
                public const int VReserved = 7;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 2,  50,  1,  1,  3,  1, 10,  1};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 3 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // T페이 추가정보
        //*----------------------------------------------------------------------------------------------------------*/
        /// <summary>
        /// T페이 요청 추가정보
        /// </summary>
        public class TPAY_ADDINFO_REQ
        {
            public const string ITEM = "TPAY_ADDINFO_REQ";

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 거래구분코드 
                /// 000040:멤버십 + 할인외금액 승인 
                /// 000040:할인외금액 승인 
                /// </summary>
                public const int TrTypeCode = 0;
                /// <summary>
                /// 멤버십할인 거래금액 (대상금액)
                /// </summary>
                public const int DisDestAmt = 1;
                /// <summary>
                /// 총거래금액 (멤버십할인 거래금액 포함)
                /// </summary>
                public const int TotAmount = 2;
                /// <summary>
                /// 입력구분 (PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE)
                /// 010:KEYIN
                /// 020:SWIPE
                /// 031:BARCODE
                /// 032:BLE
                /// 033:NFC
                /// </summary>
                public const int PosEntryMode = 3;
                /// <summary>
                /// 거래비밀번호
                /// </summary>
                public const int EncPassword = 4;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int VReserved = 5; 
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 6, 12, 12, 3, 40, 127 };
            //public static int[] LEN = { 6, 12, 12, 3, 40 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 2, 2, 0, 0, 0 };
            //public static int[] TYPE = { 0, 2, 2, 0, 0 };
        }

        /// <summary>
        /// T페이 응답 추가정보 
        /// </summary>
        public class TPAY_ADDINFO_RES
        {
            public const string ITEM = "TPAY_ADDINFO_RES";

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 멤버십등급 
                /// 1Byte M:정상멤버십포인트 
                ///       L:최종잔여포인트사용시 
                ///       R:최종멤버십포인트사용후 
                /// 2Byte 0:일반등급
                ///       S:실버등급
                ///       G:골드등급
                ///       V:VIP등급 
                /// </summary>
                public const int MemberLevel = 0;
                /// <summary>
                /// 멤버십할인 승인금액 
                /// </summary>
                public const int DisAmt = 1;
                /// <summary>
                /// 할인외 승인금액
                /// </summary>
                public const int AppAmt = 2;
                /// <summary>
                /// 지불금액 
                /// </summary>
                public const int BillAmt = 3;
                /// <summary>
                /// 잔여한도1
                /// </summary>
                public const int RemainLimit1 = 4;
                /// <summary>
                /// 잔여한도2
                /// </summary>
                public const int RemainLimit2 = 5;
                /// <summary>
                /// Reserved
                /// </summary>
                public const int VReserved = 6; 
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 2, 10, 10, 10, 10, 10, 348 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 2, 2, 2, 2, 2, 0 };
        }

        /// <summary>
        /// TPaygle Interface 
        /// </summary>
        public class TPAY_CONNECT_INFO
        {
            public string DATATIME = string.Empty;

            public string POSID = string.Empty;

            public List<TPAY_PHONE> LIST = new List<TPAY_PHONE>();
        }
        public class TPAY_PHONE
        {
            public string XPT = string.Empty;
            public string NAME = string.Empty;
            public string NICK_NAME = string.Empty;
            public string MDN = string.Empty;
            public string DEVICE_TYPE = string.Empty;
        }

        //*----------------------------------------------------------------------------------------------------------*/
        // HAPPY POINT INCARD COUPON 응답 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_HPCOUPON
        /// <summary>
        /// POS_RES_HPCOUPON 
        /// </summary>
        public class POS_RES_HPCOUPON
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문 버전
                /// </summary>
                public const int ResDocVer = 0;
                /// <summary>
                /// STAUTS 0 승인, 1 거절
                /// </summary>
                public const int ResStatus = 1;
                /// <summary>
                /// 거래일시YYMMDDhhmm
                /// </summary>
                public const int ResTrDate = 2;
                /// <summary>
                /// - 승인시 : "카드종류명"- 거절시 : 거절 MESSAGE
                /// </summary>
                public const int ResMessage1 = 3;
                /// <summary>
                /// - 승인시 : "OK : " 승인번호 8자리- 거절시 : 거절 MESSAGE
                /// </summary>
                public const int ResMessage2 = 4;
                /// <summary>
                /// 승인번호 포인트 승인번호 또는 거절코드(4) 
                /// </summary>
                public const int ResApprNo = 5;
                /// <summary>
                /// 거래포인트 - 거래(발생)포인트(Right Justfied & Leading Zero)
                /// </summary>
                public const int ResTrPoint = 6;
                /// <summary>
                /// 가용포인트 - 가용포인트(Right Justfied & Lea ding Zero)
                /// </summary>
                public const int ResUsesPoint = 7;
                /// <summary>
                /// - 누적포인트(Right Justfied & Leading Zero)
                /// </summary>
                public const int ResSavePoint = 8;
                /// <summary>
                /// - 예비포인트(Right Justfied & Leading Zero)
                /// </summary>
                public const int ResSparePoint = 9;
                /// <summary>
                /// 가맹점 번호
                /// </summary>
                public const int ResStoreNo = 10;
                /// <summary>
                /// 총데이타 건수
                /// </summary>
                public const int ResTotalCnt = 11;
                /// <summary>
                /// 쿠폰 건수
                /// </summary>
                public const int ResCouponCnt = 12;
                /// <summary>
                /// 오퍼명 1
                /// </summary>
                public const int ResOper1 = 13;
                /// <summary>
                /// 쿠폰번호1
                /// </summary>
                public const int ResCouponNo1 = 14;
                /// <summary>
                /// 사용시작일1
                /// </summary>
                public const int ResStart1 = 15;
                /// <summary>
                /// 사용종료일1
                /// </summary>
                public const int ResStop1 = 16;
                /// <summary>
                /// 오퍼명2
                /// </summary>
                public const int ResOper2 = 17;
                /// <summary>
                /// 쿠폰번호2
                /// </summary>
                public const int ResCouponNo2 = 18;
                /// <summary>
                /// 사용시작일2
                /// </summary>
                public const int ResStart2 = 19;
                /// <summary>
                /// 사용종료일2
                /// </summary>
                public const int ResStop2 = 20;
                /// <summary>
                /// 오퍼명3
                /// </summary>
                public const int ResOper3 = 21;
                /// <summary>
                /// 쿠폰번호3
                /// </summary>
                public const int ResCouponNo3 = 22;
                /// <summary>
                /// 사용시작일3
                /// </summary>
                public const int ResStart3 = 23;
                /// <summary>
                /// 사용종료일3
                /// </summary>
                public const int ResStop3 = 24;

                /// <summary>
                /// Filler  fillerset1
                /// </summary>
                public const int ResFiller = 25;
                /// <summary>
                /// RS      fillerset2
                /// </summary>
                public const int ResRS = 26;
                /// <summary>
                /// 추가정보 fillerset3 
                /// </summary>
                public const int ResCmsAddInfo = 27;
                /// <summary>
                /// const char ETX = (char)0x03; //End Text [응답용Asc]
                /// </summary>
                public const int ResETX = 28;
                /// <summary>
                /// const char CR  = (char)0x0D; //char CR = (char)Convert.ToInt32("0D", 16); // //
                /// </summary>
                public const int ResCR = 29;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 4,  1, 10, 16, 16, 12,  9,  9,  9,  9, 
                                       15,  5,  2, 50, 14,  8,  8, 50, 14,  8,
                                        8, 50, 14,  8,  8, 11,  1,  1,  1};
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = {0,0,0,0,0,0,0,0,0,0,
                                        0,0,0,0,0,0,0,0,0,0,
                                        0,0,0,0,0,0,3,0,0};
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 다운로드 통합 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_REQ_DOWNLOAD
        /// <summary>
        /// POS_REQ_DOWNLOAD
        /// </summary>
        public class POS_REQ_DOWNLOAD
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {                /// <summary>
                /// 회선정보 - WIFI:’W’, 전용선:’A’, xDSL:’D’,앱결제(안드로이드:’N’, 아이폰:’I’)
                /// </summary>
                public const int ReqLineInfo = 0;
                /// <summary>
                /// 포스정보 IP 정보
                /// </summary>
                public const int ReqPosIp = 1;
                /// <summary>
                /// 포스 모듈 버전- DLL 버전, 앱버전                
                /// </summary>
                public const int ReqPosDllVer = 2;
                /// <summary>
                /// 포스 일련번호
                /// </summary>
                public const int ReqPosSeq = 3;
                /// <summary>
                /// 사업자번호- 가맹점 사업자 번호
                /// </summary>
                public const int ReqShopAccountNo = 4;
                /// <summary>
                /// FILLER - 앱결제시 핸드폰번호 - 포스 다운로드시 MAC 주소
                /// </summary>
                public const int ReqFiller = 5;
                /// <summary>
                /// const char ETX = (char)0x03; //End Text [응답용Asc]
                /// </summary>
                public const int ReqETX = 6;
                /// <summary>
                /// const char CR  = (char)0x0D; //char CR = (char)Convert.ToInt32("0D", 16); // //
                /// </summary>
                public const int ReqCR = 7;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 15, 15, 10, 10, 20, 1, 1 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 다운로드 통합 응답 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_DOWNLOAD
        /// <summary>
        /// POS_RES_DOWNLOAD
        /// </summary>
        public class POS_RES_DOWNLOAD
        {
            public const string ITEM = "POS_RES_DOWNLOAD";

            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// STAUTS 0 승인, X 거절
                /// </summary>
                public const int ResStatus = 0;
                /// <summary>
                /// 거래일시YYMMDDhhmm
                /// </summary>
                public const int ResTrDate = 1;
                /// <summary>
                /// 
                /// </summary>
                public const int ResMessage1 = 2;
                /// <summary>
                ///  응답코드- 승인시 : "0000" 거절시 : 거절코드 4자리
                /// </summary>
                public const int ResCode = 3;
                /// <summary>
                /// 단말기번호
                /// </summary>
                public const int ResTerminalNo = 4;
                /// <summary>
                /// 사업자번호
                /// </summary>
                public const int ResShopAccountNo = 5;
                /// <summary>
                /// 가맹점명
                /// </summary>
                public const int ResShopName = 6;
                /// <summary>
                /// 대표자명
                /// </summary>
                public const int ResOwner = 7;
                /// <summary>
                /// 가맹점전화번호
                /// </summary>
                public const int ResTellNo = 8;
                /// <summary>
                /// 가맹점 주소
                /// </summary>
                public const int ResStoreAddress = 9;
                /// <summary>
                /// WorkIngKeyIndex 00~99
                /// </summary>
                public const int ResKeyIndex = 10;
                /// <summary>
                /// Working Key
                /// </summary>
                public const int ResKey = 11;
                /// <summary>
                /// Filler
                /// </summary>
                public const int ResFiller = 12;
                /// <summary>
                /// const char ETX = (char)0x03; //End Text [응답용Asc]
                /// </summary>
                public const int ResETX = 13;
                /// <summary>
                /// const char CR  = (char)0x0D; //char CR = (char)Convert.ToInt32("0D", 16); // //
                /// </summary>
                public const int ResCR = 14;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 10, 16, 4, 10, 10, 20, 10, 16, 40, 
                                        2, 16, 50, 1, 1};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = {0,0,0,0,0,0,0,0,0,0,
                                        0,0,0,0,0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 세브란스병원 임직원 할인 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_REQ_SEVERANCEDC
        /// <summary>
        /// POS_REQ_SEVERANCEDC 
        /// </summary>
        public class POS_REQ_SEVERANCEDC
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문길이
                /// </summary>
                public const int Len = 0;
                /// <summary>
                /// 업무구분 (001 고정)
                /// </summary>
                public const int WorkType = 1;
                /// <summary>
                /// 전문구분 (0200:정상, 0420:반품)
                /// </summary>
                public const int MsgType = 2;
                /// <summary>
                /// 거래구분 (10:조회, 20:승인)
                /// </summary>
                public const int iNqType = 3;
                /// <summary> 
                /// 판매구분 (10:직원식, 20:직원할인)
                /// </summary>
                public const int SaleTyep = 4;
                /// <summary>
                /// 거래일시 (YYYYMMDDhhmmss)
                /// </summary>
                public const int SaleTime = 5;
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const int BrandCD = 6;
                /// <summary>
                /// 점포코드
                /// </summary>
                public const int StoreCD = 7;
                /// <summary>
                /// 판매일자
                /// </summary>
                public const int SaleDate = 8;
                /// <summary>
                /// POS번호
                /// </summary>
                public const int POSNo = 9;
                /// <summary>
                /// 영수증번호
                /// </summary>
                public const int TranNo = 10;
                /// <summary>
                /// 요청자
                /// </summary>
                public const int CashierNo = 11;
                /// <summary>
                /// 입력구분 (A:BarCode, K:Keyin)
                /// </summary>
                public const int WCC = 12;
                /// <summary>
                /// 직원카드번호
                /// </summary>
                public const int CardNo = 13;
                /// <summary>
                /// 결제할 직원식 상품 수량 - 일반
                /// </summary>
                public const int iTemQty1 = 14;
                /// <summary>
                /// 판매금액 - 일반
                /// </summary>
                public const int iSaleAmount1 = 15;
                /// <summary>
                /// 결제할 직원식 상품 수량 - 직원
                /// </summary>
                public const int iTemQty2 = 16;
                /// <summary>
                /// 판매금액 - 직원
                /// </summary>
                public const int iSaleAmount2 = 17;
                /// <summary>
                /// 메뉴코드
                /// </summary>
                public const int iTemCD = 18;
                /// <summary>
                /// 메뉴명
                /// </summary>
                public const int iTemNM = 19;
                /// <summary>
                /// 메뉴외 수량
                /// </summary>
                public const int iTemQty3 = 20;
                /// <summary>
                /// 비밀번호
                /// </summary>
                public const int Password = 21;
                /// <summary>
                /// 원승인일시
                /// </summary>
                public const int OrgSaleTime = 22;
                /// <summary>
                /// 원승인번호
                /// </summary>
                public const int OrgAppNo= 23;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 3,  3, 4, 2, 2, 14, 4, 10, 8, 2, 5, 10, 1, 20, 3, 8, 3, 8, 13, 40, 3, 10, 14, 10};
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = {1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0};
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // SPC 임직원 결제 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_SPC_EMPLOYEE_USE
        /// <summary>
        /// POS_RES_SPC_EMPLOYEE_USE 
        /// </summary>
        public class POS_RES_SPC_EMPLOYEE_USE
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문구분
                /// </summary>
                public const int InqType = 0;
                /// <summary>
                /// 전송일자
                /// </summary>
                public const int SendDate = 1;
                /// <summary>
                /// 전송시간
                /// </summary>
                public const int SendTime = 2;
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int ResStatus = 3;
                /// <summary>
                /// 본문길이
                /// </summary>
                public const int BodyLen = 4;
                /// <summary>
                /// 점포코드
                /// </summary>
                public const int StoreCD = 5;
                /// <summary>
                /// 단말기번호
                /// </summary>
                public const int CatID = 6;
                /// <summary>
                /// 거래일자
                /// </summary>
                public const int SaleDate = 7;
                /// <summary>
                /// 거래시간
                /// </summary>
                public const int SaleTime = 8;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int SaleType = 9;
                /// <summary>
                /// 카드번호
                /// </summary>
                public const int CardNo = 10;
                /// <summary>
                /// 비밀번호
                /// </summary>
                public const int Password = 11;
                /// <summary>
                /// 거래금액
                /// </summary>
                public const int SaleAmount = 12;
                /// <summary>
                /// 거래수량
                /// </summary>
                public const int SaleQty = 13;
                /// <summary>
                /// 할인금액
                /// </summary>
                public const int ResUsesPoint = 14;
                /// <summary>
                /// 잔여금액
                /// </summary>
                public const int BalancePoint = 15;
                /// <summary>
                /// 승인일자
                /// </summary>
                public const int ApprDate = 16;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 17;
                /// <summary>
                /// 응답메지시1
                /// </summary>
                public const int RegMsg1 = 18;
                /// <summary>
                /// 응답메지시2
                /// </summary>
                public const int RegMsg2 = 19;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 4,8,6,2,4,15,10,8,6,2,16,10,10,5,10,10,8,12,40,40 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 1,1,1,0,1,0,0,1,1,1,0,0,0,1,1,1,0,0,0,0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // SPC 임직원 결제 응답 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_REQ_SPC_EMPLOYEE_USE
        /// <summary>
        /// POS_REQ_SPC_EMPLOYEE_USE 
        /// </summary>
        public class POS_REQ_SPC_EMPLOYEE_USE
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 전문구분
                /// </summary>
                public const int InqType = 0;
                /// <summary>
                /// 전송일시
                /// </summary>
                public const int SendDate = 1;
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int ResStatus = 2;
                /// <summary>
                /// 본문길이
                /// </summary>
                public const int BodyLen = 3;
                /// <summary>
                /// 점포코드
                /// </summary>
                public const int StoreCD = 4;
                /// <summary>
                /// 단말기번호
                /// </summary>
                public const int CatID = 5;
                /// <summary>
                /// 거래일자
                /// </summary>
                public const int SaleDate = 6;
                /// <summary>
                /// 거래시간
                /// </summary>
                public const int SaleTime = 7;
                /// <summary>
                /// 거래구분
                /// </summary>
                public const int SaleType = 8;
                /// <summary>
                /// 카드번호
                /// </summary>
                public const int CardNo = 9;
                /// <summary>
                /// 비밀번호
                /// </summary>
                public const int Password = 10;
                /// <summary>
                /// 거래금액
                /// </summary>
                public const int SaleAmount = 11;
                /// <summary>
                /// 거래수량
                /// </summary>
                public const int SaleQty = 12;
                /// <summary>
                /// 잔여식대
                /// </summary>
                public const int ResUsesPoint = 13;
                /// <summary>
                /// 잔여금액
                /// </summary>
                public const int BalancePoint = 14;
                /// <summary>
                /// 승인일자
                /// </summary>
                public const int ApprDate = 15;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 16;
                /// <summary>
                /// 메시지1
                /// </summary>
                public const int ResMsg1 = 17;
                /// <summary>
                /// 메시지2
                /// </summary>
                public const int ResMsg2 = 18;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 4, 14, 2, 4, 15, 10, 8, 6, 2, 16, 10, 10, 5, 10, 10, 8, 12, 40, 40 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // SPC 임직원 할인 - 중국 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_SPC_EMPLOYEE_DC_CHINA
        /// <summary>
        /// POS_RES_SPC_EMPLOYEE_DC_CHINA 
        /// </summary>
        public class POS_RES_SPC_EMPLOYEE_DC_CHINA
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// STX
                /// </summary>
                public const int STX = 0;
                /// <summary>
                /// 전체길이
                /// </summary>
                public const int InqLen = 1;
                /// <summary>
                /// 전문구분
                /// </summary>
                public const int InqType = 2;
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const int BrandCD = 3;
                /// <summary>
                /// 점포코드
                /// </summary>
                public const int StoreCD = 4;
                /// <summary>
                /// 영업일자
                /// </summary>
                public const int SaleDate = 5;
                /// <summary>
                /// Pos번호
                /// </summary>
                public const int PosNo = 6;
                /// <summary>
                /// 영수증번호
                /// </summary>
                public const int TradeNo = 7;
                /// <summary>
                /// 담당자코드
                /// </summary>
                public const int CashierNo = 8;
                /// <summary>
                /// 입력구분
                /// </summary>
                public const int Wcc = 9;
                /// <summary>
                /// 직원카드번호
                /// </summary>
                public const int Emp_Card_No = 10;
                /// <summary>
                /// 승인일자
                /// </summary>
                public const int ApprDate = 11;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 12;
                /// <summary>
                /// 승인금액
                /// </summary>
                public const int ApprAmt = 13;
                /// <summary>
                /// Filler
                /// </summary>
                public const int Filler = 14;
                /// <summary>
                /// ETX
                /// </summary>
                public const int ETX = 15;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 3, 9, 4, 10, 8, 2, 5, 10, 1, 21, 8, 12, 20, 20, 1 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // SPC 임직원 할인 - 중국 응답 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_REQ_SPC_EMPLOYEE_DC_CHINA
        /// <summary>
        /// POS_REQ_SPC_EMPLOYEE_DC_CHINA 
        /// </summary>
        public class POS_REQ_SPC_EMPLOYEE_DC_CHINA
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// STX
                /// </summary>
                public const int STX = 0;
                /// <summary>
                /// 전문구분
                /// </summary>
                public const int InqType = 1;
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const int BrandCD = 2;
                /// <summary>
                /// 점포코드
                /// </summary>
                public const int StoreCD = 3;
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int ResStatus = 4;
                /// <summary>
                /// 
                /// </summary>
                public const int Filler1 = 5;
                /// <summary>
                /// 입력구분
                /// </summary>
                public const int Wcc = 6;
                /// <summary>
                /// 직원카드번호
                /// </summary>
                public const int Emp_Card_No = 7;
                /// <summary>
                /// 
                /// </summary>
                public const int Filler2 = 8;
                /// <summary>
                /// 할인율
                /// </summary>
                public const int DCRate = 9;
                /// <summary>
                /// 할인금액
                /// </summary>
                public const int DCAmt = 10;
                /// <summary>
                /// 승인일자
                /// </summary>
                public const int ApprDate = 11;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 12;
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const int ResMsg = 13;
                /// <summary>
                /// 직원명
                /// </summary>
                public const int Emp_Name = 14;
                /// <summary>
                /// 
                /// </summary>
                public const int Filler3 = 15;
                /// <summary>
                /// 총사용액
                /// </summary>
                public const int ToTalUseAmt = 16;
                /// <summary>
                /// 잔여금액
                /// </summary>
                public const int RemainAmt = 17;
                
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 9, 4, 10, 4, 25, 1, 21, 2, 4, 9, 14, 12, 60, 60, 60, 20, 20 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 세브란스병원 임직원 할인 응답 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_SEVERANCEDC
        /// <summary>
        /// POS_RES_SEVERANCEDC 
        /// </summary>
        public class POS_RES_SEVERANCEDC
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 업무구분 (001 고정)
                /// </summary>
                public const int WorkType = 0;
                /// <summary>
                /// 전문구분 (0200:정상, 0420:반품)
                /// </summary>
                public const int MsgType = 1;
                /// <summary>
                /// 거래구분 (10:조회, 20:승인)
                /// </summary>
                public const int iNqType = 2;
                /// <summary> 
                /// 판매구분 (10:직원식, 20:직원할인)
                /// </summary>
                public const int SaleTyep = 3;
                /// <summary>
                /// 응답코드 (0000:정상, 그외 오류)
                /// </summary>
                public const int ResStatus = 4;
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const int BrandCD = 5;
                /// <summary>
                /// 점포코드
                /// </summary>
                public const int StoreCD = 6;
                /// <summary>
                /// 판매일자
                /// </summary>
                public const int SaleDate = 7;
                /// <summary>
                /// POS번호
                /// </summary>
                public const int POSNo = 8;
                /// <summary>
                /// 영수증번호
                /// </summary>
                public const int TranNo = 9;
                /// <summary>
                /// 직원구분 (24:전공의, 25:수련직, 그외 임직원)
                /// </summary>
                public const int Employee_Type = 10;
                /// <summary>
                /// 직원카드번호
                /// </summary>
                public const int EmpCardNo = 11;
                /// <summary>
                /// 사용가능 무료횟수
                /// </summary>
                public const int UseFreeQty = 12;
                /// <summary>
                /// 직원식 결제시 총 사용횟수
                /// </summary>
                public const int ToTalQty = 13;
                /// <summary>
                /// 사용금액
                /// </summary>
                public const int UseAmount = 14;
                /// <summary>
                /// 할인율
                /// </summary>
                public const int iRate = 15;
                /// <summary>
                /// 할인금액
                /// </summary>
                public const int DCAmount = 16;
                /// <summary>
                /// 할인후금액
                /// </summary>
                public const int DCAmountAfter = 17;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int AppNo = 18;
                /// <summary>
                /// 승인일시
                /// </summary>
                public const int AppDate = 19;
                /// <summary>
                /// 결제구분
                /// </summary>
                public const int SaleFlag = 20;
                /// <summary>
                /// 메시지1 - 직원이름, 승인메시지(에러메시지)
                /// </summary>
                public const int Message1 = 21;
                /// <summary>
                /// 메시지2 
                /// </summary>
                public const int Message2 = 22;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 3,4,2,2,4,4,10,8,2,5,2,20,3,3,8,3,8,8,10,14,2,60,60 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0};
        }
        #endregion

        #region 모바일쿠폰 - 해피콘
            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘-헤더 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_HDR_MOBILECOUPON_HPCON_NEW
            /// <summary>
            /// POS_HDR_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_HDR_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 버전 (1)
                    /// </summary>
                    public const int DocVer = 0;
                    /// <summary>
                    /// 전문번호 (100:조회, 101:승인, 102:이력조회, 203:사용승인, 204:취소승인)
                    /// </summary>
                    public const int TranType = 1;
                    /// <summary>
                    /// 지점코드
                    /// </summary>
                    public const int StoreCD = 2;
                    /// <summary>
                    /// 지점명
                    /// </summary>
                    public const int StoreNM = 3;
                    /// <summary>
                    /// 브랜드코드
                    /// </summary>
                    public const int BrandCD = 4;
                    /// <summary>
                    /// 전문크기
                    /// </summary>
                    public const int HeaderLen = 5;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 10, 10, 16, 64, 6, 5 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 조회 - 요청 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_SEL_MOBILECOUPON_HPCON_NEW
            /// <summary>
            /// POS_RES_SEL_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_RES_SEL_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 수입력 구분 (0:바코드, 1:수입력)
                    /// </summary>
                    public const int InType = 1;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 32, 1  };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 1  };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 조회 - 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_MOBILECOUPON_HPCON_NEW
            /// <summary>
            /// POS_REQ_SEL_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_SEL_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 응답코드
                    /// </summary>
                    public const int RecvCD = 0;
                    /// <summary>
                    /// 응답메시지
                    /// </summary>
                    public const int RecvMsg = 1;
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 2;
                    /// <summary>
                    /// 쿠폰명
                    /// </summary>
                    public const int CouponNM = 3;
                    /// <summary>
                    /// 쿠폰 총 가격
                    /// </summary>
                    public const int TotalAmount = 4;
                    /// <summary>
                    /// 동시 사용 제약 (0:제약없음, 1:동시사용) - 1:동시사용인 경우 모든 쿠폰을 한번에 같이 사용해야함
                    /// </summary>
                    public const int DualUseYn = 5;
                    /// <summary>
                    /// 가상 번호 개수
                    /// </summary>
                    public const int VirtualCouponNoCnt = 6;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 10, 128, 32, 128, 10, 1, 5 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0 };
            }

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 조회 - 응답 가상쿠폰개수 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            /// <summary>
            /// POS_REQ_SEL_DTL_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_SEL_DTL_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 가상 쿠폰 번호
                    /// </summary>
                    public const int VitualCouponNo = 0;
                    /// <summary>
                    /// 가상 쿠폰명
                    /// </summary>
                    public const int VitualCouponNM = 1;
                    /// <summary>
                    /// 브랜드 코드
                    /// </summary>
                    public const int BrandCD = 2;
                    /// <summary>
                    /// 브랜드명
                    /// </summary>
                    public const int BrandNM = 3;
                    /// <summary>
                    /// 가상 쿠폰 종류 (0:물품형, 1:금액형)
                    /// </summary> 
                    public const int VitualCouponType = 4;
                    /// <summary>
                    /// 가상 쿠폰 옵션 (0:옵션없음, 1:타상품 교환 불가) - 1:타상품 교환 불가시 POS 상품코드 체크
                    /// </summary>
                    public const int VitualCouponOption = 5;
                    /// <summary>
                    /// 가상 쿠폰 권면가
                    /// </summary>
                    public const int VitualCouponCost = 6;
                    /// <summary>
                    /// 가상 쿠폰 구매가
                    /// </summary>
                    public const int VitualCouponAmount = 7;
                    /// <summary>
                    /// 잔액
                    /// </summary>
                    public const int BalanceAmount = 8;
                    /// <summary>
                    /// 가용 금액
                    /// </summary>
                    public const int UsableAmount = 9;
                    /// <summary>
                    /// 그룹 번호
                    /// </summary>
                    public const int GroupNo = 10;
                    /// <summary>
                    /// 사용 가능 횟수
                    /// </summary>
                    public const int UsebleCnt = 11;
                    /// <summary>
                    /// 유효기간 시작일
                    /// </summary>
                    public const int ValidSrtDate = 12;
                    /// <summary>
                    /// 유효기간 종료일
                    /// </summary>
                    public const int ValidEndDate = 13;
                    /// <summary>
                    /// 가상 쿠폰 상태
                    /// </summary>
                    public const int VitualCouponState = 14;
                    /// <summary>
                    /// 사용 불가 사유
                    /// </summary>
                    public const int NotUseReason = 15;
                    /// <summary>
                    /// 구상 상품 순번 (상품코드)
                    /// </summary>
                    public const int SubiTemCD = 16;
                    /// <summary>
                    /// POS 상품코드 개수
                    /// </summary>
                    public const int PosiTemCnt = 17;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 32, 128, 16, 64, 1, 1, 10, 10, 10, 10, 10, 10, 6, 6, 1, 128, 32, 5 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            }

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 조회 - 응답 POS 상품코드  전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            /// <summary>
            /// POS_REQ_SEL_DTL_POSITEM_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_SEL_DTL_POSITEM_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// POS 상품코드
                    /// </summary>
                    public const int PosiTemCD = 0;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 16 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0 };
            }

            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 승인 - 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_APPR_MOBILECOUPON_HPCON_NEW
            /// <summary>
            /// POS_REQ_APPR_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_APPR_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 응답코드
                    /// </summary>
                    public const int RecvCD = 0;
                    /// <summary>
                    /// 응답메시지
                    /// </summary>
                    public const int RecvMsg = 1;
                    /// <summary>
                    /// 거래번호
                    /// </summary>
                    public const int CouponTradeNo = 2;
                    /// <summary>
                    /// 쿠폰개수
                    /// </summary>
                    public const int CouponQty = 3; 
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 10, 128, 32, 5 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0 };
            }

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 승인 - 응답 전문 정의 - 상세내역
            //*----------------------------------------------------------------------------------------------------------*/
            /// <summary>
            /// POS_REQ_APPR_DTL_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_APPR_DTL_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 가상쿠폰번호
                    /// </summary>
                    public const int VirtualCouponNo = 1;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 2;
                    /// <summary>
                    /// 구성 상품 순번 (상품코드)
                    /// </summary>
                    public const int iTemCD = 3;
                    /// <summary>
                    /// 사용된 금액
                    /// </summary>
                    public const int CouponUseAmount = 4;
                    /// <summary>
                    /// 잔액
                    /// </summary>
                    public const int BallanceAmt = 5;
                    /// <summary>
                    /// 사용 가능 여부
                    /// </summary>
                    public const int UseYn = 6;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 32, 32, 32, 32, 10, 10, 1 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0 };
            }

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 취소 - 응답 전문 정의 - 상세내역
            //*----------------------------------------------------------------------------------------------------------*/
            /// <summary>
            /// POS_REQ_CAN_DTL_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_CAN_DTL_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 가상쿠폰번호
                    /// </summary>
                    public const int VirtualCouponNo = 1;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 2; 
                    /// <summary>
                    /// 사용된 금액
                    /// </summary>
                    public const int CouponUseAmount = 3;
                    /// <summary>
                    /// 잔액
                    /// </summary>
                    public const int BallanceAmt = 4;
                    /// <summary>
                    /// 사용 가능 여부
                    /// </summary>
                    public const int UseYn = 5;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 32, 32, 32, 10, 10, 1 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 이력조회 - 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_LOG_MOBILECOUPON_HPCON_NEW
            /// <summary>
            /// POS_REQ_SEL_LOG_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_SEL_LOG_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 응답코드
                    /// </summary>
                    public const int RecvCD = 0;
                    /// <summary>
                    /// 응답메시지
                    /// </summary>
                    public const int RecvMsg = 1;
                    /// <summary>
                    /// 이력개수
                    /// </summary>
                    public const int iQty = 2;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 10, 128, 5 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0 };
            }

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 이력조회 - 응답 전문 정의 - 상세내역
            //*----------------------------------------------------------------------------------------------------------*/
            /// <summary>
            /// POS_REQ_SEL_LOG_DTL_MOBILECOUPON_HPCON_NEW
            /// </summary>
            public class POS_REQ_SEL_LOG_DTL_MOBILECOUPON_HPCON_NEW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 0;
                    /// <summary>
                    /// 구분
                    /// </summary>
                    public const int CouponState = 1;
                    /// <summary>
                    /// 사용 금액
                    /// </summary>
                    public const int CouponUseAmount = 2;
                    /// <summary>
                    /// 잔액
                    /// </summary>
                    public const int BallanceAmt = 3;
                    /// <summary>
                    /// 사용일시
                    /// </summary>
                    public const int UseDate = 4;
                    /// <summary>
                    /// 매장코드
                    /// </summary>
                    public const int UseStorCD = 5;
                    /// <summary>
                    /// 매장명
                    /// </summary>
                    public const int UseStorNm = 6;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 32, 1, 10, 10, 12, 16, 32 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0 };
            }
            #endregion 
        #endregion

        #region 모바일쿠폰 - 해피콘 이외
            //************************************************************************************************************/
            // 모바일쿠폰 - 해피콘-헤더 전문 정의
            //************************************************************************************************************/
            #region 모바일쿠폰 - 해피콘 헤더
            /// <summary>
            /// POS_HDR_MOBILECOUPON_HPCON
            /// </summary>
            public class POS_HDR_MOBILECOUPON_HPCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 헤더길이
                    /// </summary>
                    public const int HeadLen = 0;
                    /// <summary>
                    /// 버전 (0003)
                    /// </summary>
                    public const int DocVer = 1;
                    /// <summary>
                    /// 요청아이디
                    /// </summary>
                    public const int BrandID = 2;
                    /// <summary>
                    /// 기능코드 (100:조회, 101:승인, 102:취소, 114:환불조회, 115:환불처리요청, 116:환불승인 처리)
                    /// </summary>
                    public const int TranType = 3;
                    /// <summary>
                    /// 지점코드
                    /// </summary>
                    public const int StoreCD = 4;
                    /// <summary>
                    /// 지점명
                    /// </summary>
                    public const int StoreNM = 5;
                    /// <summary>
                    /// POS코드
                    /// </summary>
                    public const int PosNo = 6;
                    /// <summary>
                    /// 수신자번호처리 (1:체크, 2:미체크)
                    /// </summary>
                    public const int ReqNoChk = 7;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int SaleDate = 8;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int SaleTime = 9;
                    /// <summary>
                    /// 상태코드
                    /// </summary>
                    public const int ResStatus = 10;
                    /// <summary>
                    /// 실패코드
                    /// </summary>
                    public const int ErrCD = 11;
                    /// <summary>
                    /// Body 길이
                    /// </summary>
                    public const int BodyLen = 12;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 8, 4, 6, 3, 10, 20, 10, 1, 8, 6, 3, 5, 4 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 };
            }
            #endregion

            //************************************************************************************************************/
            // 모바일쿠폰 - 해피콘 요청-조회 Detail 전문 정의
            //************************************************************************************************************/
            #region POS_REQ_SEL_DTL_MOBILECOUPON_HPCON
            /// <summary>
            /// POS_REQ_SEL_DTL_MOBILECOUPON_HPCON
            /// </summary>
            public class POS_REQ_SEL_DTL_MOBILECOUPON_HPCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 수입력 구분 (0:바코드, 1:수입력)
                    /// </summary>
                    public const int InType = 1;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 2;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 1, 20 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 요청-승인/취소 Detail 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_APP_DTL_MOBILECOUPON_HPCON
            /// <summary>
            /// POS_REQ_APP_DTL_MOBILECOUPON_HPCON
            /// </summary>
            public class POS_REQ_APP_DTL_MOBILECOUPON_HPCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int AppNo = 1;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 2;
                    /// <summary>
                    /// 거래금액
                    /// </summary>
                    public const int PayAmt = 3;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 20, 20, 10 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 1 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 응답-조회(정상) Detail 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_SEL_DTL_MOBILECOUPON_HPCON
            /// <summary>
            /// POS_RES_SEL_DTL_MOBILECOUPON_HPCON
            /// </summary>
            public class POS_RES_SEL_DTL_MOBILECOUPON_HPCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// Product 갯수
                    /// </summary>
                    public const int ProductQty = 1;
                    /// <summary>
                    /// Product_i ID
                    /// </summary>
                    public const int Product_ID = 2;
                    /// <summary>
                    /// Product_i Barcode
                    /// </summary>
                    public const int Product_Barcode = 3;
                    /// <summary>
                    /// Product_i 갯수
                    /// </summary>
                    public const int Product_Qty = 4;
                    /// <summary>
                    /// 공급업체 코드
                    /// </summary>
                    public const int VenderID = 5;
                    /// <summary>
                    /// 원가
                    /// </summary>
                    public const int Cost = 6;
                    /// <summary>
                    /// 제휴사 부담금
                    /// </summary>
                    public const int CatCompAmt = 7;
                    /// <summary>
                    /// 공급업체 부담금
                    /// </summary>
                    public const int VenderAmt = 8;
                    /// <summary>
                    /// 정산구분 (1:선구매, 2:후정산, 3:자체정산)
                    /// </summary>
                    public const int CalculteType = 9;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 4, 13, 13, 4, 15, 10, 10, 10, 1 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 1, 0, 0, 1, 0, 1, 1, 1, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 응답-오류 Detail 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_ERR_DTL_MOBILECOUPON_HPCON
            /// <summary>
            /// POS_RES_ERR_DTL_MOBILECOUPON_HPCON
            /// </summary>
            public class POS_RES_ERR_DTL_MOBILECOUPON_HPCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 에러메시지
                    /// </summary>
                    public const int ErrMesg = 1;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 128 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 응답-오류(E0006) Detail 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_ERR2_DTL_MOBILECOUPON_HPCON
            /// <summary>
            /// POS_RES_ERR2_DTL_MOBILECOUPON_HPCON
            /// </summary>
            public class POS_RES_ERR2_DTL_MOBILECOUPON_HPCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 사용된 지점코드
                    /// </summary>
                    public const int UseStoreCD = 0;
                    /// <summary>
                    /// 사용된 지점명
                    /// </summary>
                    public const int UseStoreNM = 1;
                    /// <summary>
                    /// 쿠폰 사용 년월일
                    /// </summary>
                    public const int UseDate = 2;
                    /// <summary>
                    /// 쿠폰 사용 시분초
                    /// </summary>
                    public const int UseTime = 3;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 10, 20, 8, 6 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 해피콘 응답-승인/취소 Detail 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_APP_DTL_MOBILECOUPON_HPCON
            /// <summary>
            /// POS_RES_APP_DTL_MOBILECOUPON_HPCON
            /// </summary>
            public class POS_RES_APP_DTL_MOBILECOUPON_HPCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int AppNo = 1;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 20 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 지마켓 - 조회 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_MOBILECOUPON_GMARKET
            /// <summary>
            /// POS_REQ_SEL_MOBILECOUPON_GMARKET
            /// </summary>
            public class POS_REQ_SEL_MOBILECOUPON_GMARKET
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 응답값
                    /// </summary>
                    public const int Error_Code = 0;
                    /// <summary>
                    /// 상품코드
                    /// </summary>
                    public const int Goods_No = 1;
                    /// <summary>
                    /// 쿠폰명
                    /// </summary>
                    public const int Coupon_Name = 2;
                    /// <summary>
                    /// 쿠폰금액타입
                    /// </summary>
                    public const int Coupon_Money_Type = 3;
                    /// <summary>
                    /// 쿠폰사용금액
                    /// </summary>
                    public const int Coupon_Money = 4;
                    /// <summary>
                    /// 쿠폰 사용일
                    /// </summary>
                    public const int Coupon_Use_Dt = 5;
                }
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 지마켓 - 취소 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_CAN_MOBILECOUPON_GMARKET
            /// <summary>
            /// POS_REQ_CAN_MOBILECOUPON_GMARKET
            /// </summary>
            public class POS_REQ_CAN_MOBILECOUPON_GMARKET
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 고유번호
                    /// </summary>
                    public const int Trade_No = 0;
                    /// <summary>
                    /// 응답값
                    /// </summary>
                    public const int Error_Code = 1;
                    /// <summary>
                    /// 쿠폰금액타입
                    /// </summary>
                    public const int Coupon_Money_Type = 2;
                    /// <summary>
                    /// 쿠폰사용금액
                    /// </summary>
                    public const int Coupon_Money = 3;
                    /// <summary>
                    /// 승인일자
                    /// </summary>
                    public const int Appr_Dt = 4;
                    /// <summary>
                    /// 승인시간
                    /// </summary>
                    public const int Appr_Time = 5;
                }
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 지마켓 - 승인 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_APP_MOBILECOUPON_GMARKET
            /// <summary>
            /// POS_REQ_APP_MOBILECOUPON_GMARKET
            /// </summary>
            public class POS_REQ_APP_MOBILECOUPON_GMARKET
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 고유번호
                    /// </summary>
                    public const int Trade_No = 0;
                    /// <summary>
                    /// 응답값
                    /// </summary>
                    public const int Error_Code = 1;
                    /// <summary>
                    /// 쿠폰금액타입
                    /// </summary>
                    public const int Coupon_Money_Type = 2;
                    /// <summary>
                    /// 쿠폰사용금액
                    /// </summary>
                    public const int Coupon_Money = 3;
                    /// <summary>
                    /// 주문수량
                    /// </summary>
                    public const int Order_Cnt = 4;
                    /// <summary>
                    /// 쿠폰명
                    /// </summary>
                    public const int Coupon_Name = 5;
                    /// <summary>
                    /// 상품코드
                    /// </summary>
                    public const int Goods_No = 6;
                    /// <summary>
                    /// 상품금액
                    /// </summary>
                    public const int Goods_Price = 7;
                    /// <summary>
                    /// 결제금액
                    /// </summary>
                    public const int Acnt_Money = 8;
                    /// <summary>
                    /// 상품원가
                    /// </summary>
                    public const int Goods_Cost = 9;
                    /// <summary>
                    /// 쿠폰 사용일
                    /// </summary>
                    public const int Coupon_Use_Dt = 10;
                    /// <summary>
                    /// 승인일자
                    /// </summary>
                    public const int Appr_Dt = 11;
                    /// <summary>
                    /// 승인시간
                    /// </summary>
                    public const int Appr_Time = 12;
                }
            }
            #endregion

        #endregion 

        #region 모바일쿠폰 - 기프티콘
            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티콘 - 조회 요청 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_SEL_MOBILECOUPON_GIFTCON
            /// <summary>
            /// POS_RES_SEL_MOBILECOUPON_GIFTCON
            /// </summary>
            public class POS_RES_SEL_MOBILECOUPON_GIFTCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 전문번호
                    /// </summary>
                    public const int TranType = 0;
                    /// <summary>
                    /// 전문상위버전
                    /// </summary>
                    public const int CommTopVer = 1;
                    /// <summary>
                    /// 전문하위버전
                    /// </summary>
                    public const int CommLowVer = 2;
                    /// <summary>
                    /// 기관코드
                    /// </summary>
                    public const int BizNo = 3;
                    /// <summary>
                    /// 전송일자
                    /// </summary>
                    public const int TranDate = 4;
                    /// <summary>
                    /// 전문시간
                    /// </summary>
                    public const int TranTime = 5;
                    /// <summary>
                    /// 추적번호
                    /// </summary>
                    public const int TranUniqueNo = 6;
                    /// <summary>
                    /// 본문길이
                    /// </summary>
                    public const int HeaderLen = 7;
                    /// <summary>
                    /// 응답코드 대분류
                    /// </summary>
                    public const int ResStatus = 8;
                    /// <summary>
                    /// 응답코드 소분류
                    /// </summary>
                    public const int ErrStatus = 9;
                    /// <summary>
                    /// Header Filler
                    /// </summary>
                    public const int HeaderFiller = 10;

                    /// <summary>
                    /// 제휴사코드
                    /// </summary>
                    public const int PartnerShipCD = 11;
                    /// <summary>
                    /// 가맹점코드
                    /// </summary>
                    public const int FranChiseCD = 12;
                    /// <summary>
                    /// 가맹점명
                    /// </summary>
                    public const int FranChiseNM = 13;
                    /// <summary>
                    /// POSNO
                    /// </summary>
                    public const int PosNo = 14;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int SaleDate = 15;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int SaleTime = 16;
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo= 17;
                    /// <summary>
                    /// 수입력구분 (0:바코드, 1:수입력)
                    /// </summary>
                    public const int Wcc = 18;
                    /// <summary>
                    /// 보안설정 (0:사용, 1:미사용)
                    /// </summary>
                    public const int SecurityType = 19;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 20;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int BodyFiller = 21;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 4, 2, 2, 4, 8, 6, 10, 4, 2, 2, 10 
                                          , 6, 10, 80, 16, 8, 6, 20, 1, 1, 11, 50};
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0 
                                           , 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티콘 - 조회 응답 Header 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_HDR_MOBILECOUPON_GIFTCON
            /// <summary>
            /// POS_REQ_SEL_HDR_MOBILECOUPON_GIFTCON
            /// </summary>
            public class POS_REQ_SEL_HDR_MOBILECOUPON_GIFTCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 전문번호
                    /// </summary>
                    public const int TranType = 0;
                    /// <summary>
                    /// 전문상위버전
                    /// </summary>
                    public const int CommTopVer = 1;
                    /// <summary>
                    /// 전문하위버전
                    /// </summary>
                    public const int CommLowVer = 2;
                    /// <summary>
                    /// 기관코드
                    /// </summary>
                    public const int BizNo = 3;
                    /// <summary>
                    /// 전송일자
                    /// </summary>
                    public const int TranDate = 4;
                    /// <summary>
                    /// 전문시간
                    /// </summary>
                    public const int TranTime = 5;
                    /// <summary>
                    /// 추적번호
                    /// </summary>
                    public const int TranUniqueNo = 6;
                    /// <summary>
                    /// 본문길이
                    /// </summary>
                    public const int HeaderLen = 7;
                    /// <summary>
                    /// 응답코드 대분류
                    /// </summary>
                    public const int ResStatus = 8;
                    /// <summary>
                    /// 응답코드 소분류
                    /// </summary>
                    public const int ErrStatus = 9;
                    /// <summary>
                    /// Header Filler
                    /// </summary>
                    public const int HeaderFiller = 10;

                    /// <summary>
                    /// 제휴사코드
                    /// </summary>
                    public const int PartnerShipCD = 11;
                    /// <summary>
                    /// 가맹점코드
                    /// </summary>
                    public const int FranChiseCD = 12;
                    /// <summary>
                    /// 가맹점명
                    /// </summary>
                    public const int FranChiseNM = 13;
                    /// <summary>
                    /// POSNO
                    /// </summary>
                    public const int PosNo = 14;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int SaleDate = 15;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int SaleTime = 16;
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 17;
                    /// <summary>
                    /// 수입력구분 (0:바코드, 1:수입력)
                    /// </summary>
                    public const int Wcc = 18;
                    /// <summary>
                    /// 보안설정 (0:사용, 1:미사용)
                    /// </summary>
                    public const int SecurityType = 19;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 20;
                    /// <summary>
                    /// 사용된 가맹점 코드
                    /// </summary>
                    public const int UseFranChiseCD = 21;
                    /// <summary>
                    /// 사용된 가맹점명
                    /// </summary>
                    public const int UseFranChiseNM = 22;
                    /// <summary>
                    /// 쿠폰 사용 일자
                    /// </summary>
                    public const int CouponUseDate = 23;
                    /// <summary>
                    /// 쿠폰 사용 시간
                    /// </summary>
                    public const int CouponUseTime = 24;
                    /// <summary>
                    /// 판매상품명
                    /// </summary>
                    public const int iTemNM = 25;
                    /// <summary>
                    /// 응답 메시지
                    /// </summary>
                    public const int ReqMessage = 26;

                    /// <summary>
                    /// 교환 상품의 갯수
                    /// </summary>
                    public const int ProductQty = 27;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 4, 2, 2, 4, 8, 6, 10, 4, 2, 2, 10,
                                            6, 10, 80, 16, 8, 6, 20, 1, 1, 11, 10, 80, 8, 6, 80, 64, 4};
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
                                             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티콘 - 조회 응답 Body 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_BODY_MOBILECOUPON_GIFTCON
            /// <summary>
            /// POS_REQ_SEL_BODY_MOBILECOUPON_GIFTCON
            /// </summary>
            public class POS_REQ_SEL_BODY_MOBILECOUPON_GIFTCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 상품코드
                    /// </summary>
                    public const int iTemCD = 0;
                    /// <summary>
                    /// 상품명
                    /// </summary>
                    public const int iTemNM = 1;
                    /// <summary>
                    /// 상품바코드
                    /// </summary>
                    public const int iTemBarCD = 2;
                    /// <summary>
                    /// 상품갯수
                    /// </summary>
                    public const int iTemQty = 3;
                    /// <summary>
                    /// 공급업체코드
                    /// </summary>
                    public const int VenderID = 4;
                    /// <summary>
                    /// 원가
                    /// </summary>
                    public const int Cost = 5;
                    /// <summary>
                    /// 제휴사 부담금
                    /// </summary>
                    public const int CatCompAmt = 6;
                    /// <summary>
                    /// 공급업체 부담금
                    /// </summary>
                    public const int VenderAmt = 7;
                    /// <summary>
                    /// 상품종류
                    /// </summary>
                    public const int iTemType = 8;
                    /// <summary>
                    /// 최소구매금액
                    /// </summary>
                    public const int LimitMessage = 9;
                    /// <summary>
                    /// 최대 할인금액
                    /// </summary>
                    public const int MaxDCAmt = 10;
                    /// <summary>
                    /// 할인금액(할인율)
                    /// </summary>
                    public const int DCAmt = 11;
                    /// <summary>
                    /// Notice
                    /// </summary>
                    public const int Notice = 12;
                    /// <summary>
                    /// 결제 유형 제한
                    /// </summary>
                    public const int LimitTenderType = 13;
                    /// <summary>
                    /// Balance
                    /// </summary>
                    public const int Balance = 14;
                    /// <summary>
                    /// 유효기간 시작일
                    /// </summary>
                    public const int ValidStartDate = 15;
                    /// <summary>
                    /// 유효기간 종료일
                    /// </summary>
                    public const int ValidEndDate = 16;
                    /// <summary>
                    /// 교환가능 요일
                    /// </summary>
                    public const int ChangExpDate = 17;
                    /// <summary>
                    /// 교환가능 시가
                    /// </summary>
                    public const int ChangeExpTime = 18;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int BodyFiller = 19;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 8, 80, 13, 4, 6, 4, 4, 4, 2, 4, 4, 4, 100, 50, 4, 8, 8, 13, 47, 50 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티콘 - 승인 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_APP_MOBILECOUPON_GIFTCON
            /// <summary>
            /// POS_REQ_APP_MOBILECOUPON_GIFTCON
            /// </summary>
            public class POS_REQ_APP_MOBILECOUPON_GIFTCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 전문번호
                    /// </summary>
                    public const int TranType = 0;
                    /// <summary>
                    /// 전문상위버전
                    /// </summary>
                    public const int CommTopVer = 1;
                    /// <summary>
                    /// 전문하위버전
                    /// </summary>
                    public const int CommLowVer = 2;
                    /// <summary>
                    /// 기관코드
                    /// </summary>
                    public const int BizNo = 3;
                    /// <summary>
                    /// 전송일자
                    /// </summary>
                    public const int TranDate = 4;
                    /// <summary>
                    /// 전문시간
                    /// </summary>
                    public const int TranTime = 5;
                    /// <summary>
                    /// 추적번호
                    /// </summary>
                    public const int TranUniqueNo = 6;
                    /// <summary>
                    /// 본문길이
                    /// </summary>
                    public const int HeaderLen = 7;
                    /// <summary>
                    /// 응답코드 대분류
                    /// </summary>
                    public const int ResStatus = 8;
                    /// <summary>
                    /// 응답코드 소분류
                    /// </summary>
                    public const int ErrStatus = 9;
                    /// <summary>
                    /// Header Filler
                    /// </summary>
                    public const int HeaderFiller = 10;

                    /// <summary>
                    /// 제휴사코드
                    /// </summary>
                    public const int PartnerShipCD = 11;
                    /// <summary>
                    /// 가맹점코드
                    /// </summary>
                    public const int FranChiseCD = 12;
                    /// <summary>
                    /// 가맹점명
                    /// </summary>
                    public const int FranChiseNM = 13;
                    /// <summary>
                    /// POSNO
                    /// </summary>
                    public const int PosNo = 14;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int SaleDate = 15;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int SaleTime = 16;
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 17;
                    /// <summary>
                    /// 수입력구분 (0:바코드, 1:수입력)
                    /// </summary>
                    public const int Wcc = 18;
                    /// <summary>
                    /// 보안설정 (0:사용, 1:미사용)
                    /// </summary>
                    public const int SecurityType = 19;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 20;

                    /// <summary>
                    /// 결제 유형
                    /// </summary>
                    public const int LimitTenderType = 21;
                    /// <summary>
                    /// 사용금액, 횟수 (금액차감권:사용금액, 수량차감권:사용횟수)
                    /// </summary>
                    public const int UseAmount = 22;
                    /// <summary>
                    /// 원가
                    /// </summary>
                    public const int Cost = 23;
                    /// <summary>
                    /// 제휴사 부담금
                    /// </summary>
                    public const int CatCompAmt = 24;
                    /// <summary>
                    /// 공급업체 부담금
                    /// </summary>
                    public const int VenderAmt = 25;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int AppNo = 26;
                    /// <summary>
                    /// 승인메시지
                    /// </summary>
                    public const int ReqMessage = 27;
                    /// <summary>
                    /// Balance (금액차감권:남은금액, 수량차감권:남은횟수, 기간권:사용횟수, 차감식 쿠폰이 아닌경우 0으로 반환)
                    /// </summary>
                    public const int Balance = 28;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int BodyFiller  = 29;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 4, 2, 2, 4, 8, 6, 10, 4, 2, 2, 10,
                                            6, 10, 80, 16, 8, 6, 20, 1, 1, 11, 2, 4, 4, 4, 4, 20, 64, 4, 50};
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
                                             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0};
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티콘 - 승인 취소 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_CAN_MOBILECOUPON_GIFTCON
            /// <summary>
            /// POS_REQ_CAN_MOBILECOUPON_GIFTCON
            /// </summary>
            public class POS_REQ_CAN_MOBILECOUPON_GIFTCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 전문번호
                    /// </summary>
                    public const int TranType = 0;
                    /// <summary>
                    /// 전문상위버전
                    /// </summary>
                    public const int CommTopVer = 1;
                    /// <summary>
                    /// 전문하위버전
                    /// </summary>
                    public const int CommLowVer = 2;
                    /// <summary>
                    /// 기관코드
                    /// </summary>
                    public const int BizNo = 3;
                    /// <summary>
                    /// 전송일자
                    /// </summary>
                    public const int TranDate = 4;
                    /// <summary>
                    /// 전문시간
                    /// </summary>
                    public const int TranTime = 5;
                    /// <summary>
                    /// 추적번호
                    /// </summary>
                    public const int TranUniqueNo = 6;
                    /// <summary>
                    /// 본문길이
                    /// </summary>
                    public const int HeaderLen = 7;
                    /// <summary>
                    /// 응답코드 대분류
                    /// </summary>
                    public const int ResStatus = 8;
                    /// <summary>
                    /// 응답코드 소분류
                    /// </summary>
                    public const int ErrStatus = 9;
                    /// <summary>
                    /// Header Filler
                    /// </summary>
                    public const int HeaderFiller = 10;

                    /// <summary>
                    /// 제휴사코드
                    /// </summary>
                    public const int PartnerShipCD = 11;
                    /// <summary>
                    /// 가맹점코드
                    /// </summary>
                    public const int FranChiseCD = 12;
                    /// <summary>
                    /// 가맹점명
                    /// </summary>
                    public const int FranChiseNM = 13;
                    /// <summary>
                    /// POSNO
                    /// </summary>
                    public const int PosNo = 14;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int SaleDate = 15;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int SaleTime = 16;
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 17;
                    /// <summary>
                    /// 수입력구분 (0:바코드, 1:수입력)
                    /// </summary>
                    public const int Wcc = 18;
                    /// <summary>
                    /// 보안설정 (0:사용, 1:미사용)
                    /// </summary>
                    public const int SecurityType = 19;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 20;
                    /// 승인번호
                    /// </summary>
                    public const int AppNo = 21;
                    /// <summary>
                    /// 승인메시지
                    /// </summary>
                    public const int ReqMessage = 22;
                    /// <summary>
                    /// Balance (금액차감권:남은금액, 수량차감권:남은횟수, 기간권:사용횟수, 차감식 쿠폰이 아닌경우 0으로 반환)
                    /// </summary>
                    public const int Balance = 23;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int BodyFiller  = 24;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 4, 2, 2, 4, 8, 6, 10, 4, 2, 2, 10,
                                            6, 10, 80, 16, 8, 6, 20, 1, 1, 11, 20, 64, 4, 50};
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
                                             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0};
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티콘 - 승인 망취소 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_NET_MOBILECOUPON_GIFTCON
            /// <summary>
            /// POS_REQ_NET_MOBILECOUPON_GIFTCON
            /// </summary>
            public class POS_REQ_NET_MOBILECOUPON_GIFTCON
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 전문번호
                    /// </summary>
                    public const int TranType = 0;
                    /// <summary>
                    /// 전문상위버전
                    /// </summary>
                    public const int CommTopVer = 1;
                    /// <summary>
                    /// 전문하위버전
                    /// </summary>
                    public const int CommLowVer = 2;
                    /// <summary>
                    /// 기관코드
                    /// </summary>
                    public const int BizNo = 3;
                    /// <summary>
                    /// 전송일자
                    /// </summary>
                    public const int TranDate = 4;
                    /// <summary>
                    /// 전문시간
                    /// </summary>
                    public const int TranTime = 5;
                    /// <summary>
                    /// 추적번호
                    /// </summary>
                    public const int TranUniqueNo = 6;
                    /// <summary>
                    /// 본문길이
                    /// </summary>
                    public const int HeaderLen = 7;
                    /// <summary>
                    /// 응답코드 대분류
                    /// </summary>
                    public const int ResStatus = 8;
                    /// <summary>
                    /// 응답코드 소분류
                    /// </summary>
                    public const int ErrStatus = 9;
                    /// <summary>
                    /// Header Filler
                    /// </summary>
                    public const int HeaderFiller = 10;

                    /// <summary>
                    /// 제휴사코드
                    /// </summary>
                    public const int PartnerShipCD = 11;
                    /// <summary>
                    /// 가맹점코드
                    /// </summary>
                    public const int FranChiseCD = 12;
                    /// <summary>
                    /// 가맹점명
                    /// </summary>
                    public const int FranChiseNM = 13;
                    /// <summary>
                    /// POSNO
                    /// </summary>
                    public const int PosNo = 14;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int SaleDate = 15;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int SaleTime = 16;
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 17;
                    /// <summary>
                    /// 수입력구분 (0:바코드, 1:수입력)
                    /// </summary>
                    public const int Wcc = 18;
                    /// <summary>
                    /// 보안설정 (0:사용, 1:미사용)
                    /// </summary>
                    public const int SecurityType = 19;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 20;

                    /// <summary>
                    /// 사용금액, 횟수 (금액차감권:사용금액, 수량차감권:사용횟수)
                    /// </summary>
                    public const int UseAmount = 21;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int AppNo = 22;
                    /// <summary>
                    /// 승인메시지
                    /// </summary>
                    public const int ReqMessage = 23;
                    /// <summary>
                    /// Balance (금액차감권:남은금액, 수량차감권:남은횟수, 기간권:사용횟수, 차감식 쿠폰이 아닌경우 0으로 반환)
                    /// </summary>
                    public const int Balance = 24;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int BodyFiller = 25;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 4, 2, 2, 4, 8, 6, 10, 4, 2, 2, 10,
                                            6, 10, 80, 16, 8, 6, 20, 1, 1, 11, 4, 20, 64, 4, 50};
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0,
                                             0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0};
            }
            #endregion
        #endregion 

        #region 모바일쿠폰 - 기프티쇼
            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 - 요청 전문 헤더 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_SEL_MOBILECOUPON_GIFTSHOW_HEADER
            /// <summary>
            /// 모바일쿠폰 - 기프티쇼 - 요청 전문 헤더 정의
            /// </summary>
            public class POS_RES_SEL_MOBILECOUPON_GIFTSHOW_HEADER
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 전문버전
                    /// </summary>
                    public const int CommVer= 0;
                    /// <summary>
                    /// 요청아이디
                    /// </summary>
                    public const int TID = 1;
                    /// <summary>
                    /// 기능코드
                    /// </summary>
                    public const int TrType = 2;
                    /// <summary>
                    /// 지점코드
                    /// </summary>
                    public const int StoreCD = 3;
                    /// <summary>
                    /// 지점명
                    /// </summary>
                    public const int StoreNM = 4;
                    /// <summary>
                    /// POS코드
                    /// </summary>
                    public const int PosNo = 5;
                    /// <summary>
                    /// 수신자번호처리
                    /// </summary>
                    public const int RecvNoProc  = 6;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int TranDate = 7;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int TranTime = 8;
                    /// <summary>
                    /// 상태코드
                    /// </summary>
                    public const int ResStatus = 9;
                    /// <summary>
                    /// 실패코드
                    /// </summary>
                    public const int ErrCD = 10;
                    /// <summary>
                    /// Body길이
                    /// </summary>
                    public const int BodyLen = 11;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 4, 6, 3, 10, 20, 10, 1, 8, 6, 3, 5, 4 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 - 조회 요청 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_SEL_MOBILECOUPON_GIFTSHOW
            /// <summary>
            /// 모바일쿠폰 - 기프티쇼 - 조회 요청 전문 정의
            /// </summary>
            public class POS_RES_SEL_MOBILECOUPON_GIFTSHOW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 입력구분
                    /// </summary>
                    public const int InType = 1;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 2;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 1, 20 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 - 조회 응답 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_MOBILECOUPON_GIFTSHOW_NORMAL
            /// <summary>
            /// 모바일쿠폰 - 기프티쇼 - 조회 응답 전문 정의
            /// </summary>
            public class POS_REQ_SEL_MOBILECOUPON_GIFTSHOW_NORMAL
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// Product 갯수
                    /// </summary>
                    public const int ProductQty = 1;
                    /// <summary>
                    /// Product ID
                    /// </summary>
                    public const int ProductID = 2;
                    /// <summary>
                    /// Product Barcode
                    /// </summary>
                    public const int ProductBarcode = 3;
                    /// <summary>
                    /// ProductCnt
                    /// </summary>
                    public const int ProductCnt = 4;
                    /// <summary>
                    /// 공급업체 코드
                    /// </summary>
                    public const int VenderID = 5;
                    /// <summary>
                    /// 원가
                    /// </summary>
                    public const int Cost = 6;
                    /// <summary>
                    /// 제휴사 부담금
                    /// </summary>
                    public const int CatCompAmt = 7;
                    /// <summary>
                    /// 공급업체 부담금
                    /// </summary>
                    public const int VenderAmt = 8;
                    /// <summary>
                    /// 정산구분 (1:선구매, 2:후정산, 3:자체정산)
                    /// </summary>
                    public const int CalculteType = 9;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 4, 13, 13, 4, 15, 10, 10, 10, 1 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 1, 0, 0, 1, 0, 1, 1, 1, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 조회 응답-오류(E0006) Detail 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_MOBILECOUPON_GIFTSHOW_E0006
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 조회 응답-오류(E0006) Detail 전문 정의
            /// </summary>
            public class POS_REQ_SEL_MOBILECOUPON_GIFTSHOW_E0006
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 사용된 지점코드
                    /// </summary>
                    public const int UseStoreCD = 0;
                    /// <summary>
                    /// 사용된 지점명
                    /// </summary>
                    public const int UseStoreNM = 1;
                    /// <summary>
                    /// 쿠폰 사용 년월일
                    /// </summary>
                    public const int UseDate = 2;
                    /// <summary>
                    /// 쿠폰 사용 시분초
                    /// </summary>
                    public const int UseTime = 3;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 10, 20, 8, 6 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 조회 응답-오류(EXXXX) Detail 전문 정의
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_MOBILECOUPON_GIFTSHOW_ERR
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 조회 응답-오류(EXXXX) Detail 전문 정의
            /// </summary>
            public class POS_REQ_SEL_MOBILECOUPON_GIFTSHOW_ERR
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 에러메시지
                    /// </summary>
                    public const int ReqMessage = 1;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 128 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 조회 응답-금액권인 경우 상태코드 '000'일때 기능코드 200으로 응답
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_SEL_MOBILECOUPON_GIFTSHOW_200
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 조회 응답-금액권인 경우 상태코드 '000'일때 기능코드 200으로 응답
            /// </summary>
            public class POS_RES_SEL_MOBILECOUPON_GIFTSHOW_200
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 잔액
                    /// </summary>
                    public const int BalAmt = 1;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 10 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 1 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 승인 요청 
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_APP_MOBILECOUPON_GIFTSHOW
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 승인 요청 
            /// </summary>
            public class POS_RES_APP_MOBILECOUPON_GIFTSHOW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 1;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 2;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 20, 20 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 승인 응답 
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_APP_MOBILECOUPON_GIFTSHOW_NORMAL
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 승인 응답
            /// </summary>
            public class POS_REQ_APP_MOBILECOUPON_GIFTSHOW_NORMAL
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 1;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 20 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 승인 응답 오류
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_APP_MOBILECOUPON_GIFTSHOW_ERROR
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 승인 응답 오류
            /// </summary>
            public class POS_REQ_APP_MOBILECOUPON_GIFTSHOW_ERROR
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 전달 메시지
                    /// </summary>
                    public const int Message = 1;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 128 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 금액권 차감 요청 
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_APP_AMT_MOBILECOUPON_GIFTSHOW
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 금액권 차감 요청 
            /// </summary>
            public class POS_RES_APP_AMT_MOBILECOUPON_GIFTSHOW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 요청금액
                    /// </summary>
                    public const int SaleAmt = 1;
                    /// <summary>
                    /// 판매상품코드
                    /// </summary>
                    public const int ItemCD = 2;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 3;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 10, 13, 20 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 1, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 금액권 차감 응답 
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_APP_AMT_MOBILECOUPON_GIFTSHOW
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 금액권 차감 응답 
            /// </summary>
            public class POS_REQ_APP_AMT_MOBILECOUPON_GIFTSHOW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 1;
                    /// <summary>
                    /// 잔액
                    /// </summary>
                    public const int BalAmt = 2;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 20, 10 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 1 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 금액권 차감취소 요청 
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_CAN_AMT_MOBILECOUPON_GIFTSHOW
            /// <summary>
            ///  모바일쿠폰 - 기프티쇼 금액권 차감취소 요청 
            /// </summary>
            public class POS_RES_CAN_AMT_MOBILECOUPON_GIFTSHOW
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 쿠폰번호
                    /// </summary>
                    public const int CouponNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 1;
                    /// <summary>
                    /// 요청금액
                    /// </summary>
                    public const int SaleAmt = 2;
                    /// <summary>
                    /// 환불상품코드
                    /// </summary>
                    public const int ItemCD = 3;
                    /// <summary>
                    /// 수신자번호
                    /// </summary>
                    public const int ReqNo = 4;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 12, 20, 10, 13, 20 };
                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
                /// </summary>
                public static int[] TYPE = { 0, 0, 1, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 모바일쿠폰 - 기프티쇼 금액권 차감취소 응답 
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_CAN_AMT_MOBILECOUPON_GIFTSHOW
        /// <summary>
        ///  모바일쿠폰 - 기프티쇼 금액권 차감취소 응답 
        /// </summary>
        public class POS_REQ_CAN_AMT_MOBILECOUPON_GIFTSHOW
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 쿠폰번호
                /// </summary>
                public const int CouponNo = 0;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 1;
                /// <summary>
                /// 잔액
                /// </summary>
                public const int BalAmt = 2;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 12, 20, 10 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 1 };
        }
        #endregion

        #endregion

        #region 해피 기프트
        //*----------------------------------------------------------------------------------------------------------*/
        // 해피 기프트 - 헤더 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_HDR_HAPPYGIFT
        /// <summary>
        /// POS_HDR_HAPPYGIFT
        /// </summary>
        public class POS_HDR_HAPPYGIFT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 헤더길이
                /// </summary>
                public const int HeadLen = 0;
                /// <summary>
                /// 버전 (0003)
                /// </summary>
                public const int DocVer = 1;
                /// <summary>
                /// 요청아이디
                /// </summary>
                public const int BrandID = 2;
                /// <summary>
                /// 기능코드 (100:조회, 101:승인, 102:취소, 114:환불조회, 115:환불처리요청, 116:환불승인 처리)
                /// </summary>
                public const int TranType = 3;
                /// <summary>
                /// 지점코드
                /// </summary>
                public const int StoreCD = 4;
                /// <summary>
                /// 지점명
                /// </summary>
                public const int StoreNM = 5;
                /// <summary>
                /// POS코드
                /// </summary>
                public const int PosNo = 6;
                /// <summary>
                /// 수신자번호처리 (1:체크, 2:미체크)
                /// </summary>
                public const int ReqNoChk = 7;
                /// <summary>
                /// 거래일자
                /// </summary>
                public const int SaleDate = 8;
                /// <summary>
                /// 거래시간
                /// </summary>
                public const int SaleTime = 9;
                /// <summary>
                /// 상태코드
                /// </summary>
                public const int ResStatus = 10;
                /// <summary>
                /// 실패코드
                /// </summary>
                public const int ErrCD = 11;
                /// <summary>
                /// Body 길이
                /// </summary>
                public const int BodyLen = 12;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 8, 4, 6, 3, 10, 20, 10, 1, 8, 6, 3, 5, 4 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 해피 기프트 - 응답-오류 Detail 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_ERR_DTL_HAPPYGIFT
        /// <summary>
        /// POS_RES_ERR_DTL_HAPPYGIFT
        /// </summary>
        public class POS_RES_ERR_DTL_HAPPYGIFT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 상품권번호
                /// </summary>
                public const int GiftNo = 0;
                /// <summary>
                /// 에러메시지
                /// </summary>
                public const int ErrMesg = 1;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 20, 300 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 해피 기프트 - 응답-조회(정상) Detail 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_SEL_DTL_HAPPYGIFT
        /// <summary>
        /// POS_RES_SEL_DTL_HAPPYGIFT
        /// </summary>
        public class POS_RES_SEL_DTL_HAPPYGIFT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            { 
                /// <summary>
                /// 최초충전금액
                /// </summary>
                public const int GiftBalAmt = 0;
                /// <summary>
                /// 유효기간
                /// </summary>
                public const int Exp_DT = 1;
                /// <summary>
                /// 최초 등록일
                /// </summary>
                public const int Reg_Dt = 2;
                /// <summary>
                /// 상품권상태
                /// </summary>
                public const int Gift_State = 3;
                /// <summary>
                /// 충전가능여부
                /// </summary>
                public const int ReChangeYN = 4;
                /// <summary>
                /// 오류메시지
                /// </summary>
                public const int ErrMessage = 5;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary> 
            public static int[] LEN = { 10, 8, 8, 2, 1, 300 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary> 
            public static int[] TYPE = { 1, 0, 0, 0, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 해피 기프트 - 응답 - 승인 Detail 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_APP_DTL_HAPPYGIFT
        /// <summary>
        /// POS_RES_APP_DTL_HAPPYGIFT
        /// </summary>
        public class POS_RES_APP_DTL_HAPPYGIFT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 상품권번호
                /// </summary>
                public const int GiftNo = 0;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 1;
                /// <summary>
                /// 거래금액
                /// </summary>
                public const int PayAmt = 2;
                /// <summary>
                /// 거래후잔액
                /// </summary>
                public const int BalanceAmt = 3;
                /// <summary>
                /// 상품명
                /// </summary>
                public const int iTemNm = 4;
                /// <summary>
                /// 유효기간
                /// </summary>
                public const int Exp_DT = 5;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 20, 20, 10, 10, 100, 8 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 1, 1, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 해피 기프트 - 응답 - 취소 Detail 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_CAN_DTL_HAPPYGIFT
        /// <summary>
        /// POS_RES_CAN_DTL_HAPPYGIFT
        /// </summary>
        public class POS_RES_CAN_DTL_HAPPYGIFT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 상품권번호
                /// </summary>
                public const int GiftNo = 0;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 1;
                /// <summary>
                /// 거래금액
                /// </summary>
                public const int PayAmt = 2;
                /// <summary>
                /// 최소구분
                /// </summary>
                public const int CancelType = 3;
                /// <summary>
                /// 거래후잔액
                /// </summary>
                public const int BalanceAmt = 4;
                /// <summary>
                /// 유효기간
                /// </summary>
                public const int Exp_DT = 5;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 20, 20, 10, 1, 10, 8 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 1, 0, 1, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 해피 기프트 - 충전 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_RECHANGE_DTL_HAPPYGIFT
        /// <summary>
        /// POS_RES_RECHANGE_DTL_HAPPYGIFT
        /// </summary>
        public class POS_RES_RECHANGE_DTL_HAPPYGIFT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 0;
                /// <summary>
                /// 유효기간
                /// </summary>
                public const int Exp_DT = 1;
                /// <summary>
                /// 오류메시지
                /// </summary>
                public const int ErrMessage = 2;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 20, 8, 300 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0 };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 해피 기프트 - 충전취소 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RES_RECHANGE_CAN_DTL_HAPPYGIFT
        /// <summary>
        /// POS_RES_RECHANGE_CAN_DTL_HAPPYGIFT
        /// </summary>
        public class POS_RES_RECHANGE_CAN_DTL_HAPPYGIFT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            { 
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int ApprNo = 0;
                /// <summary>
                /// 오류메시지
                /// </summary>
                public const int ErrMessage = 1; 
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 20, 300 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0 };
        }
        #endregion
        #endregion

        #region IQ_HAPPYGIFT_RECHANGE_TRAN_REQ 해피 기프트 충전 내역 조회 요청
        /// <summary>
        /// 해피 기프트 충전 내역 조회 요청
        /// </summary>
        public class IQ_HAPPYGIFT_RECHANGE_TRAN_REQ
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 조회구분
                /// </summary>
                public const string INQ_FLAG = "INQ_FLAG";
                /// <summary>
                /// 조회시작일
                /// </summary>
                public const string STR_DATE = "STR_DATE";
                /// <summary>
                /// 조회종료일
                /// </summary>
                public const string END_DATE = "END_DATE";
                /// <summary>
                /// 카드번호
                /// </summary>
                public const string CARD_NO = "CARD_NO";

            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }

        /// <summary>
        /// 해피 기프트 충전 내역 조회 응답
        /// </summary>
        public class IQ_HAPPYGIFT_RECHANGE_TRAN_RSP
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STORE_CD = "STORE_CD";
                /// <summary>
                /// 카드번호
                /// </summary>
                public const string CARD_NO = "CARD_NO";
                /// <summary>
                /// 조회 TN
                /// </summary>
                public const string RSLT_COUNT = "RSLT_COUNT";
                /// <summary>
                /// 고객정보
                /// </summary>
                public const string VALUE = "VALUE";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion
        //*----------------------------------------------------------------------------------------------------------*/
        // 서버IF출력 - 공통 - 응답 전문 정의 (14 : 행사주문취합내역List, 15: 행사주문취합내역상세(출력)
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_REQ_SERVER_INTERFACE
        /// <summary>
        /// POS_REQ_SERVER_INTERFACE
        /// </summary>
        public class POS_REQ_SERVER_INTERFACE
        {
            public const string ITEM = "POS_REQ_SERVER_INTERFACE";

            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// 필드 01
                /// </summary>
                public string FIELD_01 = "FIELD_01";
                /// <summary>
                /// 필드 02
                /// </summary>
                public string FIELD_02 = "FIELD_02";
                /// <summary>
                /// 필드 03
                /// </summary>
                public string FIELD_03 = "FIELD_03";
                /// <summary>
                /// 필드 04
                /// </summary>
                public string FIELD_04 = "FIELD_04";
                /// <summary>
                /// 필드 05
                /// </summary>
                public string FIELD_05 = "FIELD_05";
                /// <summary>
                /// 필드 06
                /// </summary>
                public string FIELD_06 = "FIELD_06";
            }
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 룰파일 다운로드 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RULEFILE_DOWNLOAD_REQ
        /// <summary>
        /// POS_RULEFILE_DOWNLOAD_REQ
        /// </summary>
        public class POS_RULEFILE_DOWNLOAD_REQ
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {     
                /// <summary>
                /// 거래형태(H:해피포인트 룰파일)
                /// </summary>
                public const int RuleKind = 0;
                /// <summary>
                /// FILLER
                /// </summary>
                public const int Filler = 1;
                /// <summary>
                /// FS
                /// </summary>
                public const int FS = 2;
                /// <summary>
                /// 룰파일길이
                /// </summary>
                public const int RuleLen = 3;
                /// <summary>
                /// 룰파일정보
                /// </summary>
                public const int RuleInfo = 4;
                /// <summary>
                /// ETX
                /// </summary>
                public const int ETX = 5;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 6;
                
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 37, 1, 4, 1, 1, 1 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 3, 0, 0, };
        }
        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 룰파일 다운로드 응답 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region POS_RULEFILE_DOWNLOAD_RES
        /// <summary>
        /// POS_RULEFILE_DOWNLOAD_RES
        /// </summary>
        public class POS_RULEFILE_DOWNLOAD_RES
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// STAUTS(0 승인, X 거절)
                /// </summary>
                public const int Status = 0;
                /// <summary>
                /// 거래일시(YYMMDDhhmmss)
                /// </summary>
                public const int SysDate = 1;
                /// <summary>
                /// 거래형태(H:해피포인트 룰파일)
                /// </summary>
                public const int RuleKind = 2;
                /// <summary>
                /// 응답코드(0000:정상)
                /// </summary>
                public const int ResCode = 3;
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const int ResMsg = 4;
                /// <summary>
                /// 룰파일길이
                /// </summary>
                public const int RuleLen = 5;
                /// <summary>
                /// 룰파일정보
                /// </summary>
                public const int RuleInfo = 6;
                /// <summary>
                /// ETX
                /// </summary>
                public const int ETX = 7;
                /// <summary>
                /// CR
                /// </summary>
                public const int CR = 8;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 12, 1, 4, 32, 4, 1, 1, 1};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = {0,0,0,0,0,0,3,0,0};
        }
        #endregion

        #region 해피포인트 - 중국
            //*----------------------------------------------------------------------------------------------------------*/
            // 해피포인트 해더 - 중국
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_POINT_HEADER_CHINA
            /// <summary>
            /// POS_POINT_HEADER_CHINA 
            /// </summary>
            public class POS_POINT_HEADER_CHINA
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 전체 전문길이 (전문유형부터 전문끝까지의 길이)
                    /// </summary>
                    public const int InqLen = 0;
                    /// <summary>
                    /// 전문유형
                    /// </summary>
                    public const int InqType = 1;
                    /// <summary>
                    /// 업무구분
                    /// </summary>
                    public const int TranType = 2;
                    /// <summary>
                    /// 단말기번호
                    /// </summary>
                    public const int TeminalID = 3;
                    /// <summary>
                    /// 거래일자
                    /// </summary>
                    public const int SaleDate = 4;
                    /// <summary>
                    /// 거래시간
                    /// </summary>
                    public const int SaleTime = 5;
                    /// <summary>
                    /// 거래고유번호
                    /// </summary>
                    public const int UniqueID = 6;
                    /// <summary>
                    /// 응답코드
                    /// </summary>
                    public const int ResCD = 7;
                    /// <summary>
                    /// 입력구분
                    /// </summary>
                    public const int WCC = 8;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int Filler = 9;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 4, 4, 2, 20, 8, 6, 20, 5, 1, 30 };

                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
                /// </summary>
                public static int[] TYPE = { 1, 1, 1, 0, 1, 1, 0, 1, 1, 0 };
            }
            #endregion 

            //*----------------------------------------------------------------------------------------------------------*/
            // 해피포인트 조회 요청 - 중국
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_SEL_POINT_CHINA
            /// <summary>
            /// POS_RES_SEL_POINT_CHINA 
            /// </summary>
            public class POS_RES_SEL_POINT_CHINA
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 카드번호
                    /// </summary>
                    public const int CardNo = 0; 
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 40 };

                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
                /// </summary>
                public static int[] TYPE = { 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 해피포인트 조회 응답 - 중국
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_SEL_POINT_CHINA
            /// <summary>
            /// POS_REQ_SEL_POINT_CHINA 
            /// </summary>
            public class POS_REQ_SEL_POINT_CHINA
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 카드번호
                    /// </summary>
                    public const int CardNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 1;
                    /// <summary>
                    /// 가용포인트/선불잔액(1)
                    /// </summary>
                    public const int SaleAmt1 = 2;
                    /// <summary>
                    /// 가용포인트/선불잔액(2)
                    /// </summary>
                    public const int SaleAmt2 = 3;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int Filler = 4;
                    /// <summary>
                    /// 메시지1
                    /// </summary>
                    public const int Message1 = 5;
                    /// <summary>
                    /// 메시지2
                    /// </summary>
                    public const int Message2 = 6;
                    /// <summary>
                    /// 메시지3
                    /// </summary>
                    public const int Message3 = 7;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 40, 20, 9, 2, 29, 100, 100, 100 };

                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
                /// </summary>
                public static int[] TYPE = { 0, 0, 1, 1, 0, 0, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 해피포인트 사용/적립/충전 요청 - 중국
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_RES_POINT_CHINA
            /// <summary>
            /// POS_RES_POINT_CHINA 
            /// </summary>
            public class POS_RES_POINT_CHINA
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 카드번호
                    /// </summary>
                    public const int CardNo = 0; 
                    /// <summary>
                    /// 포인트/선불금액(1)
                    /// </summary>
                    public const int SaleAmt1 = 1;
                    /// <summary>
                    /// 포인트/선불금액(2)
                    /// </summary>
                    public const int SaleAmt2 = 2;
                    /// <summary>
                    /// 원거래승인번호
                    /// </summary>
                    public const int OrgApprNo = 3;
                    /// <summary>
                    /// 원거래승인일자
                    /// </summary>
                    public const int OrgSaleDate = 4;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 40, 9, 2, 20, 8 };

                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
                /// </summary>
                public static int[] TYPE = { 0, 1, 1, 0, 0 };
            }
            #endregion

            //*----------------------------------------------------------------------------------------------------------*/
            // 해피포인트 사용/적립/충전 응답 - 중국
            //*----------------------------------------------------------------------------------------------------------*/
            #region POS_REQ_POINT_CHINA
            /// <summary>
            /// POS_REQ_POINT_CHINA 
            /// </summary>
            public class POS_REQ_POINT_CHINA
            {
                //--------------------------------------------------------------------------
                /// <summary>
                /// 컬럼순서
                /// </summary>
                public class SEQ
                {
                    /// <summary>
                    /// 카드번호
                    /// </summary>
                    public const int CardNo = 0;
                    /// <summary>
                    /// 승인번호
                    /// </summary>
                    public const int ApprNo = 1;
                    /// <summary>
                    /// 거래금액1
                    /// </summary>
                    public const int SaleAmt1 = 2;
                    /// <summary>
                    /// 거래금액2
                    /// </summary>
                    public const int SaleAmt2 = 3;
                    /// <summary>
                    /// 거래후잔액1
                    /// </summary>
                    public const int BalanceAmt1 = 4;
                    /// <summary>
                    /// 거래후잔액2
                    /// </summary>
                    public const int BalanceAmt2 = 5;
                    /// <summary>
                    /// Filler
                    /// </summary>
                    public const int Filler = 6;
                    /// <summary>
                    /// 메시지1
                    /// </summary>
                    public const int Message1 = 7;
                    /// <summary>
                    /// 메시지2
                    /// </summary>
                    public const int Message2 = 8;
                    /// <summary>
                    /// 메시지3
                    /// </summary>
                    public const int Message3 = 9;
                }

                /// <summary>
                /// 컬럼길이 - 가변일때는 길이를 1로 고정
                /// </summary>
                public static int[] LEN = { 40, 20, 9, 2, 9, 2, 18, 100, 100, 100 };

                /// <summary>
                /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
                /// </summary>
                public static int[] TYPE = { 0, 0, 1, 1, 1, 1, 0, 0, 0, 0 };
            }
            #endregion

        #endregion

        //*----------------------------------------------------------------------------------------------------------*/
        // 디지털메뉴보드 정보 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region DMB_REQ_HEADER
        /// <summary>
        /// 디지털메뉴보드 요청 헤더
        /// </summary>
        public class DMB_REQ_HEADER
        {
            public class DATA
            {
                /// <summary>
                /// 1.0.0
                /// </summary>
                public string Version = "Version";
                /// <summary>
                /// 
                /// </summary>
                public string Command = "Command";
                /// <summary>
                /// application/json
                /// </summary>
                public string ContentsType = "ContentsType";

                public string BodySize = "BodySize";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int Version = 0;

                public const int Command = 1;

                public const int ContentsType = 2;

                public const int BodySize = 3;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 16, 4, 32, 8 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 1 };
        }
        #endregion DMB_REQ_HEADER

        #region DMB_RSP_HEADER
        /// <summary>
        /// 디지털메뉴보드 응답 헤더
        /// </summary>
        public class DMB_RSP_HEADER
        {
            public class SEQ
            {
                public const int Version = 0;

                public const int Command = 1;

                public const int ContentsType = 2;

                public const int ResCode = 3;

                public const int ResMsg = 4;

                public const int BodySize = 5;
            }

            public static int[] LEN = { 16, 4, 32, 8, 256, 8 };

            public static int[] TYPE = { 0, 0, 0, 0, 0, 1 };
        }
        #endregion DMB_RSP_HEADER

        #region DMB_REQ_SALE_BEGIN
        public class DMB_REQ_SALE_BEGIN
        {
            public class DATA
            {
                public const string CmpCd = "CMP_CD";

                public const string BrandCd = "BRAND_CD";

                public const string StorCd = "STOR_CD";

                public const string PosNo = "POS_NO";

                public const string SaleDt = "SALE_DT";

                public const string BillNo = "BILL_NO";

                public const string SaleTm = "SALE_TM";
            }
        }
        #endregion

        #region DMB_REQ_SALE_END
        public class DMB_REQ_SALE_END
        {
            public class DATA
            {
                public const string CmpCd = "CMP_CD";

                public const string BrandCd = "BRAND_CD";

                public const string StorCd = "STOR_CD";

                public const string PosNo = "POS_NO";

                public const string SaleDt = "SALE_DT";

                public const string BillNo = "BILL_NO";

                public const string SaleTm = "SALE_TM";
            }
        }
        #endregion DMB_REQ_SALE_END

        #region DMB_REQ_PRODUCT_REG
        public class DMB_REQ_PRODUCT_REG
        {
            public class DATA
            {
                public const string CmpCd = "CMP_CD";

                public const string BrandCd = "BRAND_CD";

                public const string StorCd = "STOR_CD";

                public const string PosNo = "POS_NO";

                public const string SaleDt = "SALE_DT";

                public const string BillNo = "BILL_NO";

                public const string ItemCd = "ITEM_CD";

                public const string ItemNm = "ITEM_NM";

                public const string Div = "DIV";
            }
        }
        #endregion

        #region DMB_REQ_POINT_INFO
        /// <summary>
        /// 포인트 정보 요청 BODY
        /// </summary>
        public class DMB_REQ_POINT_INFO
        {
            public class DATA
            {
                public const string CmpCd = "CMP_CD";

                public const string BrandCd = "BRAND_CD";

                public const string StorCd = "STOR_CD";

                public const string PosNo = "POS_NO";

                public const string SaleDt = "SALE_DT";

                public const string BillNo = "BILL_NO";
                /// <summary>
                /// HPC:해피포인트, SKT:T멤버쉽
                /// </summary>
                public const string PointDiv = "POINT_DIV";
                /// <summary>
                /// Y:HPC APP, N:
                /// </summary>
                public const string AppDiv = "APP_DIV";
                /// <summary>
                /// 1:조회, 2:적립, 3:할인, 4:사용, 12:적립취소, 13:할인취소, 14:사용취소
                /// </summary>
                public const string DIV = "DIV";
                /// <summary>
                /// 포인트 사용 금액
                /// </summary>
                public const string Amount = "AMOUNT";
                /// <summary>
                /// 적립, 할인, 사용 포인트
                /// </summary>
                public const string Point = "POINT";
                /// <summary>
                /// 잔여포인트
                /// </summary>
                public const string RPoint = "R_POINT";

                public const string TPoint = "T_POINT";
                /// <summary>
                /// 마스킹된 카드번호
                /// </summary>
                public const string CardNo = "CARD_NO";
                /// <summary>
                /// 고객명(HPC)
                /// </summary>
                public const string CustName = "CUST_NAME";

                public const string CampaignInfo = "CAMPAIGN_INFO";
                /// <summary>
                /// YYYY/MM/DD HH:MM:SS
                /// </summary>
                public const string SaleTm = "SALE_TM";
            }
        }
        #endregion

        //#16569 파스쿠찌 드라이브 스루 기능 개발 요청 start
        //*----------------------------------------------------------------------------------------------------------*/
        // PAS Drive Thru 요청 전문 정의
        //*----------------------------------------------------------------------------------------------------------*/
        #region DT_REQ_HEADER
        /// <summary>
        /// Drive Thru 요청 헤더
        /// </summary>
        public class DT_REQ_HEADER
        {
            public class DATA
            {
                /// <summary>
                /// 버전정보: 1.0.0
                /// </summary>
                public string Version = "Version";
                /// <summary>
                /// 전문ID
                /// </summary>
                public string Command = "Command";
                /// <summary>
                /// TYPE: application/json
                /// </summary>
                public string ContentsType = "ContentsType";
                /// <summary>
                /// 본문길이
                /// </summary>
                public string BodySize = "BodySize";
            }
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int Version = 0;

                public const int Command = 1;

                public const int ContentsType = 2;

                public const int BodySize = 3;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 16, 4, 32, 8 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 1 };
        }
        #endregion DT_REQ_HEADER

        #region DT_REQ_SALE_BEGIN
        public class DT_REQ_SALE_BEGIN
        {
            public class DATA
            {
                /// <summary>
                /// 영업조직
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const string BrandCd = "BRAND_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 포스번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 시스템시간
                /// </summary>
                public const string SaleTm = "SALE_TM";
            }
        }
        #endregion

        #region DT_REQ_PRODUCT_REG
        public class DT_REQ_PRODUCT_REG
        {
            public const string ITEM = "DETAIL";

            public class DATA
            {
                /// <summary>
                /// 영업조직
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const string BrandCd = "BRAND_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 포스번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 순번(부가메뉴인 경우 주메뉴의 순번)
                /// </summary>
                public const string Seq = "SEQ";
                /// <summary>
                /// 주메뉴여부(1:주메뉴, 2:부가메뉴)
                /// </summary>
                public const string ItemDiv = "ITEM_DIV";
                /// <summary>
                /// 제품코드
                /// </summary>
                public const string ItemCd = "ITEM_CD";
                /// <summary>
                /// 제품명
                /// </summary>
                public const string ItemNm = "ITEM_NM";
                /// <summary>
                /// 수량
                /// </summary>
                public const string ItemQty = "ITEM_QTY";
                /// <summary>
                /// 금액
                /// </summary>
                public const string ItemAmt = "ITEM_AMT";
            }
        }
        #endregion DT_REQ_PRODUCT_REG

        #region DT_REQ_PRODUCT_CANC
        public class DT_REQ_PRODUCT_CANC
        {
            public class DATA
            {
                /// <summary>
                /// 영업조직
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const string BrandCd = "BRAND_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 포스번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
            }
        }
        #endregion DT_REQ_PRODUCT_CANC

        #region DT_REQ_SALE_END
        public class DT_REQ_SALE_END
        {
            public class DATA
            {
                /// <summary>
                /// 영업조직
                /// </summary>
                public const string CmpCd = "CMP_CD";
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const string BrandCd = "BRAND_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string StorCd = "STOR_CD";
                /// <summary>
                /// 포스번호
                /// </summary>
                public const string PosNo = "POS_NO";
                /// <summary>
                /// 영업일자
                /// </summary>
                public const string SaleDt = "SALE_DT";
                /// <summary>
                /// 시스템시간
                /// </summary>
                public const string SaleTm = "SALE_TM";
            }
        }
        #endregion DT_REQ_SALE_END

        #region DT_RSP_HEADER
        /// <summary>
        /// Drive Thru 응답 헤더
        /// </summary>
        public class DT_RSP_HEADER
        {
            public class SEQ
            {
                public const int Version = 0;

                public const int Command = 1;

                public const int ContentsType = 2;

                public const int BodySize = 3;

                public const int ResCode = 4;

                public const int ResMsg = 5;

            }

            public static int[] LEN = { 16, 4, 32, 8, 8, 256 };

            public static int[] TYPE = { 0, 0, 0, 0, 0, 1 };
        }
        #endregion DT_RSP_HEADER
        //#16569 파스쿠찌 드라이브 스루 기능 개발 요청 end


        #region POS_REQ_ONLINE_COUPON 온라인쿠폰(중국)
        /// <summary>
        /// POS_REQ_ONLINE_COUPON 
        /// </summary>
        public class POS_REQ_ONLINE_COUPON
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// STX
                /// </summary>
                public const int STX = 0;
                /// <summary>
                /// 전문길이	총 자리수	3	N	　
                /// </summary>
                public const int MsgLen = 1;
                /// <summary>
                /// 업무구분	임직원 인증처리	3	N	001
                /// </summary>
                public const int BusiDiv = 2;
                /// <summary>
                /// 전문구분	승인/반품구분	4	N	0100: 조회, 0200: 정상, 0420: 반품
                /// </summary>
                public const int TranType = 3;
                /// <summary>
                /// 거래구분	요청구분	2	N	10 : 발행20 : 승인
                /// </summary>
                public const int TranKind = 4;
                /// <summary>
                /// 거래일시	거래일시	14	N	YYYYMMDDhhmmss
                /// </summary>
                public const int SysDT = 5;
                /// <summary>
                /// 브랜드코드	브랜드코드	4	AN	
                /// </summary>
                public const int BrandCode = 6;
                /// <summary>
                /// 점포코드	점포코드	10	AN	
                /// </summary>
                public const int StoreCode = 7;
                /// <summary>
                /// 판매일자	판매일자	8	N
                /// </summary>
                public const int SaleDate = 8;
                /// <summary>
                /// POS NO	POS번호	2	N	
                /// </summary>
　              public const int PosNo = 9;
                /// <summary>
                /// 영수증번호	영수증번호	5	N	　
                /// </summary>
                public const int TradeNo = 10;
                /// <summary>
                /// WCC	WCC(리딩구분자)	1	N	A: Barcode, K: Keyin 
                /// </summary>
                public const int WCC = 11;
                /// <summary>
                /// 쿠폰번호	쿠폰번호	20	AN	　
                /// </summary>
                public const int COUPON_NO = 12;
                /// <summary>
                /// 원승인일시	원승인일시	14	N	　
                /// </summary>
                public const int OrgApprDT = 13;
                /// <summary>
                /// 원승인번호	원승인번호	10	N	
                /// </summary>
                public const int OrgApprNo = 14;
                /// <summary>
                /// 총판매금액	총판매금액	9	N	　
                /// </summary>
                public const int TotSaleAmt = 15;
                /// <summary>
                /// 구매상품종류	구매상품종류	3	N	라인이 다를경우 다른상품으로 처리, 상품코드 반복 개수
                /// </summary>
                public const int PluCount = 16;
                /// <summary>
                /// 실구매금액	실구매금액	9	N	할인제외된 금액
                /// </summary>
                public const int NetSaleAmt = 17;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1,  3,  3,  4,  2, 14,  4, 10,  8,  2
                                     ,  5,  1, 20, 14, 10,  9,  3,  9};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = {0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
        }
        /// <summary>
        /// POS_RES_ONLINE_COUPON 
        /// </summary>
        public class POS_RES_ONLINE_COUPON
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// STX
                /// </summary>
                public const int STX = 0;
                /// <summary>
                /// 업무구분	임직원 인증처리	3	N	001
                /// </summary>
                public const int BusiDiv = 1;
                /// <summary>
                /// 전문구분	승인/반품구분	4	N	0100: 조회, 0200: 정상, 0420: 반품
                /// </summary>
                public const int TranType = 2;
                /// <summary>
                /// 거래구분	요청구분	2	N	10 : 발행20 : 승인
                /// </summary>
                public const int TranKind = 3;
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int ResCD = 4;
                /// <summary>
                /// 브랜드코드	브랜드코드	4	AN	
                /// </summary>
                public const int BrandCode = 5;
                /// <summary>
                /// 점포코드	점포코드	10	AN	
                /// </summary>
                public const int StoreCode = 6;
                /// <summary>
                /// 판매일자	판매일자	8	N
                /// </summary>
                public const int SaleDate = 7;
                /// <summary>
                /// POS NO	POS번호	2	N	
                /// </summary>
                public const int PosNo = 8;
                /// <summary>
                /// 영수증번호	영수증번호	5	N	　
                /// </summary>
                public const int TradeNo = 9;
                /// <summary>
                /// 쿠폰번호	쿠폰번호	20	AN	　
                /// </summary>
                public const int CouponNo= 10;
                /// <summary>
                /// 액면금액	9	N	　
                /// </summary>
                public const int TotCpnAmt = 11;
                /// <summary>
                /// 발행금액	9	N	　
                /// </summary>
                public const int NetCpnAmt = 12;
                /// <summary>
                /// 할인금액	9	N	　
                /// </summary>
                public const int DisCpnAmt = 13;
                /// <summary>
                /// 승인번호	승인번호	10	N	
                /// </summary>
                public const int ApprNo = 14;
                /// <summary>
                /// 승인일시	승인일시	14	N	　
                /// </summary>
                public const int ApprDT = 15;  
                /// <summary>
                /// 쿠폰명칭 : 상품권명, 할인권명
                /// </summary>
                public const int CpnName = 16;
                /// <summary>
                /// 에러메시지
                /// </summary>
                public const int ErrMsg = 17;
                /// <summary>
                /// 상품정보(앞자리 3자리: 상품코드 개수, 인정상응답시 해당교환상품코드, 승인에러응답시 상품리스트)
                /// </summary>
                public const int PluInfo = 18;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1,  3,  4,  2,  4,  4, 10,  8,  2,  5
                                     , 20,  9,  9,  9, 10, 14, 60, 200, 1};

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0};
        }
        #endregion

        #region POS_SEL_PREPAIDCARD 선불카드 번호 조회 - 중국
        /// <summary>
        /// 선불카드 번호 조회 - 중국
        /// </summary>
        public class POS_SEL_PREPAIDCARD
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 조회구분 (0:전체, 1:카드번호)
                /// </summary>
                public const string INQ_FLAG = "INQ_FLAG";
                /// <summary>
                /// 권종 또는 카드번호
                /// </summary>
                public const string INQ_GIFT_NO = "INQ_GIFT_NO";
                /// <summary>
                /// DATA
                /// </summary>
                public const string VAULES = "DATA";
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }

        /// <summary>
        /// 선불카드 번호 승인 - 중국
        /// </summary>
        public class POS_APPR_PREPAIDCARD
        {
            /// <summary>
            /// 컬럼명
            /// </summary>
            public class DATA
            {
                /// <summary>
                /// INQ 종별
                /// </summary>
                public const string INQ_TYPE = "INQ_TYPE";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 저장구분 (0:승인, 1:취소)
                /// </summary>
                public const string INQ_FLAG = "INQ_FLAG";
                /// <summary>
                /// 카드번호
                /// </summary>
                public const string INQ_GIFT_NO = "INQ_GIFT_NO"; 
                /// <summary>
                /// 응답코드
                /// </summary>
                public const string RES_CD = "RES_CD";
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const string RES_MSG = "RES_MSG";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ { }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형)
            /// </summary>
            public static int[] TYPE = { };
        }
        #endregion

        #region OCB 직통신
        #region 가맹점등록 및 인증 응답
        //*----------------------------------------------------------------------------------------------------------*/
        // 가맹점등록 및 인증 응답
        //*----------------------------------------------------------------------------------------------------------*/
        /// <summary>
        /// POS_REQ_OCB_AUTHMCHT
        /// </summary>
        public class POS_REQ_OCB_AUTHMCHT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int RES_CD = 0;
                /// <summary>
                /// 맴버십 프로그램ID
                /// </summary>
                public const int PGM_ID = 1;
                /// <summary>
                /// 서비스구분
                /// </summary>
                public const int SERVICE_TYPE = 2;
                /// <summary>
                /// 가맹점명
                /// </summary>
                public const int SHOP_NM = 3;
                /// <summary>
                /// 프로그램 버전
                /// </summary>
                public const int PGM_VER = 4;
                /// <summary>
                /// 쿠폰허용여부
                /// </summary>
                public const int COUPON_USE_YN = 5;
                /// <summary>
                /// KEY IN 허용여부
                /// </summary>
                public const int KEY_IN_USE_YN = 6;
                /// <summary>
                /// 현금영수증 가맹점여부
                /// </summary>
                public const int CASHBILL_USE_YN = 7;
                /// <summary>
                /// 응답메시지
                /// </summary>
                public const int RES_MSG = 8;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 1, 2, 64, 20, 1, 1, 1, 256 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        #region 포인트조회 응답
        //*----------------------------------------------------------------------------------------------------------*/
        // 포인트조회 응답
        //*----------------------------------------------------------------------------------------------------------*/
        /// <summary>
        /// POS_REQ_OCB_INQPOINT
        /// </summary>
        public class POS_REQ_OCB_INQPOINT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int RES_CD = 0;
                /// <summary>
                /// 맴버십 프로그램ID
                /// </summary>
                public const int PGM_ID = 1;
                /// <summary>
                /// 서비스구분
                /// </summary>
                public const int SERVICE_TYPE = 2;
                /// <summary>
                /// 적립가능여부 (Y/N)
                /// </summary>
                public const int SAVEPOINT_YN = 3;
                /// <summary>
                /// 사용가능여부 (Y/N)
                /// </summary>
                public const int USEPOINT_YN = 4;
                /// <summary>
                /// 포인트구분명1
                /// </summary>
                public const int POINTTYPE_NM1 = 5;
                /// <summary>
                /// 발생포인트1
                /// </summary>
                public const int CUR_POINT1 = 6;
                /// <summary>
                /// 가용포인트1
                /// </summary>
                public const int REM_POINT1 = 7;
                /// <summary>
                /// 누적포인트1
                /// </summary>
                public const int ACC_POINT1 = 8;
                /// <summary>
                /// 포인트구분명2
                /// </summary>
                public const int POINTTYPE_NM2 = 9;
                /// <summary>
                /// 발생포인트2
                /// </summary>
                public const int CUR_POINT2 = 10;
                /// <summary>
                /// 가용포인트2
                /// </summary>
                public const int REM_POINT2 = 11;
                /// <summary>
                /// 누적포인트2
                /// </summary>
                public const int ACC_POINT2 = 12;
                /// <summary>
                /// 응답메시지1
                /// </summary>
                public const int RES_MSG1 = 13;
                /// <summary>
                /// 응답메시지2
                /// </summary>
                public const int RES_MSG2 = 14;
                /// <summary>
                /// 응답메시지3
                /// </summary>
                public const int RES_MSG3 = 15;
                /// <summary>
                /// 응답메시지4
                /// </summary>
                public const int RES_MSG4 = 16;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 1, 2, 1, 1, 10, 10, 10, 10, 10, 10, 10, 10, 64, 64, 64 , 64};
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        #region 포인트 적립/사용 응답
        //*----------------------------------------------------------------------------------------------------------*/
        // 포인트 적립/사용 응답
        //*----------------------------------------------------------------------------------------------------------*/
        /// <summary>
        /// POS_REQ_OCB_POINT
        /// </summary>
        public class POS_REQ_OCB_POINT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int RES_CD = 0;
                /// <summary>
                /// 맴버십 프로그램ID
                /// </summary>
                public const int PGM_ID = 1;
                /// <summary>
                /// 서비스구분
                /// </summary>
                public const int SERVICE_TYPE = 2;
                /// <summary>
                /// 승인일자
                /// </summary>
                public const int APPR_DATE = 3;
                /// <summary>
                /// 승인시간
                /// </summary>
                public const int APPR_TIME = 4;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int APPR_NO = 5;
                /// <summary>
                /// 응답메시지1
                /// </summary>
                public const int RES_MSG1 = 6;
                /// <summary>
                /// 응답메시지2
                /// </summary>
                public const int RES_MSG2 = 7;
                /// <summary>
                /// 응답메시지3
                /// </summary>
                public const int RES_MSG3 = 8;
                /// <summary>
                /// 응답메시지4
                /// </summary>
                public const int RES_MSG4 = 9;
                /// <summary>
                /// 포인트구분명1
                /// </summary>
                public const int POINTTYPE_NM1 = 10;
                /// <summary>
                /// 거래발생포인트1
                /// </summary>
                public const int CUR_POINT1 = 11;
                /// <summary>
                /// 상품발생포인트1
                /// </summary>
                public const int ITM_POINT1 = 12;
                /// <summary>
                /// 가맹점수수료1
                /// </summary>
                public const int FEE_AMT1 = 13;
                /// <summary>
                /// 가용포인트1
                /// </summary>
                public const int REM_POINT1 = 14;
                /// <summary>
                /// 누적포인트1
                /// </summary>
                public const int ACC_POINT1 = 15;
                /// <summary>
                /// 포인트구분명2
                /// </summary>
                public const int POINTTYPE_NM2 = 16;
                /// <summary>
                /// 발생포인트2
                /// </summary>
                public const int CUR_POINT2 = 17;
                /// <summary>
                /// 상품발생포인트2
                /// </summary>
                public const int ITM_POINT2 = 18;
                /// <summary>
                /// 가맹점수수료2
                /// </summary>
                public const int FEE_AMT2 = 19;
                /// <summary>
                /// 가용포인트2
                /// </summary>
                public const int REM_POINT2 = 20;
                /// <summary>
                /// 누적포인트2
                /// </summary>
                public const int ACC_POINT2 = 21; 
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 1, 2, 8, 6, 9, 64, 64, 64, 64, 10, 10, 10, 9, 10, 10, 10, 10, 10, 9, 10, 10 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        #region 포인트 적립취소/사용취소/망취소 응답
        //*----------------------------------------------------------------------------------------------------------*/
        // 포인트 적립취소/사용취소/망취소 응답
        //*----------------------------------------------------------------------------------------------------------*/
        /// <summary>
        /// POS_REQ_OCB_CANPOINT
        /// </summary>
        public class POS_REQ_OCB_CANPOINT
        {
            //--------------------------------------------------------------------------
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 응답코드
                /// </summary>
                public const int RES_CD = 0;
                /// <summary>
                /// 맴버십 프로그램ID
                /// </summary>
                public const int PGM_ID = 1;
                /// <summary>
                /// 서비스구분
                /// </summary>
                public const int SERVICE_TYPE = 2;
                /// <summary>
                /// 승인일자
                /// </summary>
                public const int APPR_DATE = 3;
                /// <summary>
                /// 승인시간
                /// </summary>
                public const int APPR_TIME = 4;
                /// <summary>
                /// 승인번호
                /// </summary>
                public const int APPR_NO = 5;
                /// <summary>
                /// 응답메시지1
                /// </summary>
                public const int RES_MSG1 = 6;
                /// <summary>
                /// 응답메시지2
                /// </summary>
                public const int RES_MSG2 = 7;
                /// <summary>
                /// 응답메시지3
                /// </summary>
                public const int RES_MSG3 = 8;
                /// <summary>
                /// 응답메시지4
                /// </summary>
                public const int RES_MSG4 = 9;
                /// <summary>
                /// 포인트구분명1
                /// </summary>
                public const int POINTTYPE_NM1 = 10;
                /// <summary>
                /// 가용포인트1
                /// </summary>
                public const int REM_POINT1 = 11;
                /// <summary>
                /// 누적포인트1
                /// </summary>
                public const int ACC_POINT1 = 12;
                /// <summary>
                /// 실차감포인트1
                /// </summary>
                public const int CAN_POINT1 = 13;
                /// <summary>
                /// 포인트구분명2
                /// </summary>
                public const int POINTTYPE_NM2 = 14;
                /// <summary>
                /// 가용포인트2
                /// </summary>
                public const int REM_POINT2 = 15;
                /// <summary>
                /// 누적포인트2
                /// </summary>
                public const int ACC_POINT2 = 16;
                /// <summary>
                /// 실차감포인트2
                /// </summary>
                public const int CAN_POINT2 = 17;
            }

            /// <summary>
            /// 컬럼길이 - 가변일때는 길이를 1로 고정
            /// </summary>
            public static int[] LEN = { 1, 1, 2, 8, 6, 9, 64, 64, 64, 64, 10, 10, 10, 10, 10, 10, 10, 10 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변형)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        }
        #endregion
        #endregion 

        //#20171227 인천공항 포스연동 start, phj
        #region 인천공항 입주사포스에서 개점구분과 개점일자를 알수있다.
        public class AIRPOS_OPENDATA
        {
            public const string ITEM = "AIRPOS_OPENDATA";
            public class DATA
            {
                /// <summary>
                /// 인천통합포스 개점타입 Y: 개점, N:마감
                /// </summary>
                public string OPEN_TY = "";
                /// <summary>
                /// 인천통합포스 개점일자 YYYYMMDD
                /// </summary>
                public string OPEN_DT = "";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                /// <summary>
                /// 인천통합포스 개점타입 Y: 개점, N:마감
                /// </summary>
                public const int OPEN_TY = 0;
                /// <summary>
                /// 인천통합포스 개점일자 YYYYMMDD
                /// </summary>
                public const int OPEN_DT = 1;
            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 1, 8 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0 };
        }
        #endregion
        //#20171227 인천공항 포스연동 end, phj

        //#20171227 인천공항 포스연동 start, phj
        #region 인천공항 결제수단
        /// <summary>
        /// 결제
        /// </summary>
        public class AIRPOS_PAYMENT
        {
            public const string ITEM = "AIRPOS_PAYMENT";

            public class DATA
            {
                /// <summary>
                /// 판매일자
                /// </summary>
                public string SALE_DT = "";
                /// <summary>
                /// 입주사거래번호
                /// </summary>
                public string BILL_NO = "";
                /// <summary>
                /// 통합POS거래번호
                /// </summary>
                public string IF_BILL_NO = "";
                /// <summary>
                /// 거래구분(0:정상, 1:반품)
                /// </summary>
                public string SALE_TY = "";
                /// <summary>
                /// 결제구분(01:현금(외화), 02:신용, 03:기타, 04:현금승인)
                /// </summary>
                public string PAY_TY = "";
                /// <summary>
                /// 결제명
                /// </summary>
                public string PAY_NM = "";
                /// <summary>
                /// 결제금액
                /// </summary>
                public double PAY_AMT = 0;
                /// <summary>
                /// 통화코드
                /// </summary>
                public string EXC_CD = "";
                /// <summary>
                /// 통화명(USD, EUR, JPY, CNY)
                /// </summary>
                public string EXC_NM = "";
                /// <summary>
                /// 기준환율(1/100)
                /// </summary>
                public double EXC_BASE = 0;
                /// <summary>
                /// 환율(판매일자의 환율)
                /// </summary>
                public double EXC_COST = 0;
                /// <summary>
                /// 결제액(외환) ROUND((결제금액/환율) * 기준환율, 2)
                /// </summary>
                public double EXC_EAMT = 0;
                /// <summary>
                /// 받은돈(외환) 외환입금
                /// </summary>
                public double EXC_IN_EAMT = 0;
                /// <summary>
                /// 받은돈(원) 끝전처리((외환입금 * 환율) / 기준환율)
                /// </summary>
                public double EXC_IN_WAMT = 0;
                /// <summary>
                /// 거스름돈(원) 받은돈(원) - 결제액
                /// </summary>
                public double EXC_CHANGE = 0;
                /// <summary>
                /// 신용카드승인ID
                /// </summary>
                public string CARD_ID = "";
                /// <summary>
                /// 신용카드 할부개월
                /// </summary>
                public string CARD_INST = "";
                /// <summary>
                /// 신용카드 카드사코드
                /// </summary>
                public string CARD_CARD_CD = "";
                /// <summary>
                /// 신용카드 카드사명
                /// </summary>
                public string CARD_CARD_NM = "";
                /// <summary>
                /// 신용카드 매입사코드
                /// </summary>
                public string CARD_PURC_CD = "";
                /// <summary>
                /// 신용카드 매입사명
                /// </summary>
                public string CARD_PURC_NM = "";
                /// <summary>
                /// 신용카드 승인구분(1:POS승인, 2:임의등록)
                /// </summary>
                public string CARD_AP_TY = "";
                /// <summary>
                /// 신용카드 승인번호
                /// </summary>
                public string CARD_AP_NO = "";
                /// <summary>
                /// 신용카드 가맹점번호
                /// </summary>
                public string CARD_MEM_NO = "";
                /// <summary>
                /// 신용카드 승인일자
                /// </summary>
                public string CARD_AP_DT = "";
                /// <summary>
                /// 신용카드 승인시간
                /// </summary>
                public string CARD_AP_TM = "";
                /// <summary>
                /// 신용카드 원거래일자
                /// </summary>
                public string CARD_AP_ORG_DT = "";
                /// <summary>
                /// 신용카드 원거래승인번호
                /// </summary>
                public string CARD_AP_ORG_NO = "";
                /// <summary>
                /// 신용카드 터미널ID
                /// </summary>
                public string CARD_AP_TERMID = "";
                /// <summary>
                /// 기타결제명
                /// </summary>
                public string ETC_NAME = "";
                /// <summary>
                /// 현금승인 승인금액
                /// </summary>
                public double CASH_AP_AMT = 0;
                /// <summary>
                /// 현금승인 거래구분(0:소득공제, 1:지출증빙)
                /// </summary>
                public string CASH_AP_TY = "";
                /// <summary>
                /// 현금승인 승인ID(승인식별자)
                /// </summary>
                public string CASH_AP_ID = "";
                /// <summary>
                /// 현금승인 승인번호
                /// </summary>
                public string CASH_AP_NO = "";
                /// <summary>
                /// 현금승인 승인일자
                /// </summary>
                public string CASH_AP_DT = "";
                /// <summary>
                /// 현금승인 승인시간
                /// </summary>
                public string CASH_AP_TM = "";
                /// <summary>
                /// 현금승인 원거래일자
                /// </summary>
                public string CASH_AP_ORG_DT = "";
                /// <summary>
                /// 현금승인 원거래승인번호
                /// </summary>
                public string CASH_AP_ORG_NO = "";
                /// <summary>
                /// 현금승인 취소사유(1:거래취소, 2:오류발급, 3:기타)
                /// </summary>
                public string CASH_AP_CAN_FG = "";
            }

            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {

            }

            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { };

        }
        #endregion
        //#20171227 인천공항 포스연동 end, phj

        //#20180322 휴게소pos매출연동 start,phj
        #region 휴게소pos 연동

        public class RESTAREA_SALE_HD
        {
            #region TR_SALE_HEADER
            public const string ITEM = "SALE_HD";

            public class DATA
            {
                /// <summary>
                /// [6]기준영업일
                /// </summary>
                public string SALE_DAY = "SALE_DAY";
                /// <summary>
                /// [8]영수증번호
                /// </summary>
                public string BILL_NO = "BILL_NO";
                /// <summary>
                /// [1]판매구분(0:매출,1:반품)
                /// </summary>
                public string SALE_GB = "SALE_GB";
                /// <summary>
                /// [14]실 판매일자(YYYYMMDDhhmmss)
                /// </summary>
                public string SYS_DTIME = "SYS_DTIME";
                /// <summary>
                /// [2]총판매상품건수
                /// </summary>
                public string DETAIL_CNT = "DETAIL_CNT";
                /// <summary>
                /// [2]총전표건수(카드,현금,상품권,...)
                /// </summary>
                public string SLIP_CNT = "SLIP_CNT";
                /// <summary>
                /// [14]총 판매금액
                /// </summary>
                public string TOT_PAN_AMT = "TOT_PAN_AMT";
                /// <summary>
                /// [14]현금판매금액
                /// </summary>
                public string CASH_AMT = "CASH_AMT";
                /// <summary>
                /// [14]카드판매금액
                /// </summary>
                public string CARD_AMT = "CARD_AMT";
                /// <summary>
                /// [14]상품권판매금액
                /// </summary>
                public string GIFT_AMT = "GIFT_AMT";
                /// <summary>
                /// [14]보관/외상주유액
                /// </summary>
                public string SC_AMT = "SC_AMT";
                /// <summary>
                /// [14]선수입금액
                /// </summary>
                
                //20180420 명칭수정 start,phj 
                //기존
                //public string PRE_PAY_AMT = "PRE_APY_AMT";
                //변경
                public string PRE_PAY_AMT = "PRE_PAY_AMT";
                //20180420 명칭수정 end,phj 

                /// <summary>
                /// [14]수수료이익액
                /// </summary>
                public string FEE_PROFIT_AMT = "FEE_PROFIT_AMT";
                /// <summary>
                /// [14]실매출액(부가세포함)
                /// </summary>
                public string REAL_PAN_AMT = "REAL_PAN_AMT";
                /// <summary>
                /// [14]부가세액
                /// </summary>
                public string VAT_AMT = "VAT_AMT";
                /// <summary>
                /// [14]순매출액(부가세제외금액)
                /// </summary>
                public string NET_PAN_AMT = "NET_PAN_AMT";
                /// <summary>
                /// [1]현금영수증 발행 구분(0:미발행, 1:발행)
                /// </summary>
                public string CASH_BILL_GB = "CASH_BILL_GB";
                /// <summary>
                /// [32]원거래영수증번호( 영업일(8)+운영업체코드(3)+휴게소코드(7)+포스그룹코드(2)+포스번호(4)+영수증번호(8) )
                /// </summary>
                public string ORG_BILL_NO = "ORG_BILL_NO";
                /// <summary>
                /// [4]사원번호
                /// </summary>
                public string EMP_ID = "EMP_ID";
                /// <summary>
                /// [1]주유처리구분(0:일반, 1:외상, 2:보관주유, 4:검량, 5:자가소비)
                /// </summary>
                public string OIL_PROC_CB = "OIL_PROC_CB";
                /// <summary>
                /// [14]보너스카드 사용금액(포인트사용금액)
                /// </summary>
                public string BONUS_USE_AMT = "BONUS_USE_AMT";
                /// <summary>
                /// [14]총 DC 금액
                /// </summary>
                public string DC_AMT = "DC_AMT";
                /// <summary>
                /// [14]정상 DC 금액
                /// </summary>
                public string NORM_DC_AMT = "NORM_DC_AMT";
                /// <summary>
                /// [14]보너스카드 DC 금액
                /// </summary>
                public string BONUS_DC_AMT = "BONUS_DC_AMT";
                /// <summary>
                /// [14]임의등록 보너스카드 DC 금액
                /// </summary>
                public string RAND_BONUS_DC_AMT = "RAND_BONUS_DC_AMT";
            }
            #endregion
        }

        public class RESTAREA_SALE_DT
        {
            #region TR_SALE_DETAIL
            public const string ITEM = "SALE_DT";

            public class DATA
            {
                /// <summary>
                /// [2]라인번호
                /// </summary>
                public string LINE_NO = "LINE_NO";
                /// <summary>
                /// [8]매장코드(상품 마스터의 매장코드)
                /// </summary>
                public string SHOP_CD = "SHOP_CD";
                /// <summary>
                /// [10]판매상품 SEQ
                /// </summary>
                public string PROD_SEQ = "PROD_SEQ";
                /// <summary>
                /// [13]바코드(소스코드)
                /// </summary>
                public string SOURCE_CD = "SOURCE_CD";
                /// <summary>
                /// [15]판매수량
                /// </summary>
                public string PAN_QTY = "PAN_QTY";
                /// <summary>
                /// [14] 판매금액
                /// </summary>
                public string TOT_PAN_AMT = "TOT_PAN_AMT";
                /// <summary>
                /// [2] 노즐번호 - Deafult:"00"
                /// </summary>
                public string NOZZLE_NO = "NOZZLE_NO";
                /// <summary>
                /// [15] 판매단가
                /// </summary>
                public string PAN_COST = "PAN_COST";
                /// <summary>
                /// [14]수수료단가
                /// </summary>
                public string FEE_COST = "FEE_COST";
                /// <summary>
                /// [14]주유처리구분(0:일반, 1:외상, 2,보관주유, 4:검량, 5:자가소비)
                /// </summary>
                public string OIL_PROC_GB = "OIL_PROC_GB";
                /// <summary>
                /// [14]선수입금액
                /// </summary>
                public string PRE_PAY_AMT = "PRE_PAY_AMT";
                /// <summary>
                /// [14]수수료금액
                /// </summary>
                public string FEE_AMT = "FEE_AMT";
                /// <summary>
                /// [14]보관/외상에출력
                /// </summary>
                public string SC_AMT = "SC_AMT";
                /// <summary>
                /// [14]실매출액
                /// </summary>
                public string REAL_PAN_AMT = "REAL_PAN_AMT";
                /// <summary>
                /// [14]부가세액
                /// </summary>
                public string VAT_AMT = "VAT_AMT";
                /// <summary>
                /// [14]순매출액(부가세제외금액)
                /// </summary>
                public string NET_PAN_AMT = "NET_PAN_AMT";
                /// <summary>
                /// [14]주유완료일시(YYYYMMDDhhmmss)
                /// </summary>
                public string NOZZLE_END_DTIME = "NOZZLE_END_DTIME";
                /// <summary>
                /// [1]주유면세판매구분(0:일반, 1:면세)
                /// </summary>
                public string DUTY_PAN_GB = "DUTY_PAN_GB";
                /// <summary>
                /// [14]총 DC 금액
                /// </summary>
                public string DC_AMT = "DC_AMT";
                /// <summary>
                /// [14]정상 DC 금액
                /// </summary>
                public string NORM_DC_AMT = "NORM_DC_AMT";
                /// <summary>
                /// [14]보너스카드 DC 금액
                /// </summary>
                public string BONUS_DC_AMT = "BONUS_DC_AMT";

                /// <summary>
                /// [14] 임의등록 보너스카드 DC 금액(미사용)
                /// </summary>
                public string RAND_BONUS_DC_AMT = "RAND_BONUS_DC_AMT";

            }
            #endregion
        }

        public class RESTAREA_SALE_SP
        {
            public const string ITEM = "SALE_SP";

            public class RESTAREA_PAY_CARD
            {
                #region RESTAREA_PAY_CARD
                public const string ITEM = "CARD";

                public class DATA
                {
                    public string SLIP_FG = "SLIP_FG";          //Slip 구분자(‘01’:카드)
                    public string APPR_AMT = "APPR_AMT";         //승인금액
                    public string PURCHASE_CD = "PURCHASE_CD";      //매입사코드
                    public string PURCHASE_CO_NM = "PURCHASE_CO_NM";   //매입사명
                    public string APPR_NO = "APPR_NO";          //승인번호
                    public string APPR_DAY = "APPR_DAY";         //승인일자(YYYYMMDD)
                    public string APPR_TIME = "APPR_TIME";        //승인시간(hhmmss)
                    public string CARD_GB = "CARD_GB";          //카드구분(0:신용카드, 1:선불카드, 2:보너스적립카드3,보너스할인카드)
                    public string DDC_GB = "DDC_GB";           //자동이체구분(0:자동이체, 1:전표매입)
                    public string STD_CARD_CORD_CD = "STD_CARD_CORD_CD"; //표준카드사코드(카드사 마스터)
                    public string VAN_CD = "VAN_CD";           //VAN 사 코드(POS 환경정보)
                    public string CARD_NO = "CARD_NO";          //카드번호(앞 6자리)
                }
                #endregion
            }
            public class RESTAREA_PAY_CASH
            {
                #region RESTAREA_PAY_CASH
                public const string ITEM = "CASH";

                public class DATA
                {
                    public string SLIP_FG = "SLIP_FG";     //Slip 구분자(‘02’:현금)


                    //"00" : 현금, "01" : 상품권, "02" : 모바일쿠폰, "03" : 나이스선불카드, "04" : 마이탐 선불카드
                    public string PROC_TYPE = "PROC_TYPE";   //현금

                    public string APPR_AMT = "APPR_AMT";   //승인금액
                    public string APPR_NO = "APPR_NO";     //승인번호
                    public string APPR_DAY = "APPR_DAY";   //승인일자(YYYYMMDD)
                    public string APPR_TIME = "APPR_TIME"; //승인시간(hhmmss)
                    public string VAN_CD = "VAN_CD";       //VAN 사 코드(POS 환경정보)
                    public string APPR_TYPE = "APPR_TYPE"; //현금영수증 발행 구분 (0:자진발급, 1:소득공제, 2:지출증빙)
                }
                #endregion
            }

            public class RESTAREA_PAY_GIFT
            {
                #region RESTAREA_PAY_GIFT
                public const string ITEM = "GIFT";

                public class DATA
                {
                    public string SLIP_FG = "";          //Slip 구분자(‘03’:상품권)   
                    public string GIFT_CLASS_CD = "";    //상품권분류코드
                    public string GIFT_CARD_CD = "";     //상품권코드
                    public string SANCT_AMT = "";        //결제금액
                }
                #endregion
            }
        }
        #endregion
        //#20180322 휴게소pos매출연동 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj

        #region 웰컴카드
        public class WELCOMECARD
        {
            public const string INQ_TYPE = "INQ_TYPE";
            public const string DATA = "DATA";
            public const string RES_CD = "RES_CD";
        }
        #endregion

        #region 웰컴카드 발급조회

        /// <summary>
        /// 발급조회 요청
        /// </summary>
        public class WELCOMECARD_SEARCH
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0;             //전체 전문길이  
                public const int sMsgDiv = 1;          //구분
                public const int sMsgType = 2;         //전문유형
                public const int sMsgGubun = 3;        //업무구분
                public const int sMsgVersion = 4;      //전문버전
                public const int sYYYYMMDD = 5;        //거래일자
                public const int shhmmss = 6;          //거래시간
                public const int sApprNo = 7;          //승인번호
                public const int sReqCode = 8;         //응답코드
                public const int sCardNo = 9;          //카드번호
                public const int sHPCustNo = 10;       //HPC고객번호
                public const int sSaleDate = 11;       //영업일자
                public const int sStoreCode = 12;      //점포코드
                public const int sPosNo = 13;          //POS번호
                public const int sBillNo = 14;         //BILL번호
                public const int sFiller = 15;         //Filler
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 50 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }

        /// <summary>
        /// 발급조회 응답
        /// </summary>
        public class WELCOMECARD_SEARCH_RECV
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0;          //전체 전문길이
                public const int sMsgDiv = 1;       //구분
                public const int sMsgType = 2;      //전문유형
                public const int sMsgGubun = 3;     //업무구분
                public const int sMsgVersion = 4;   //전문버전
                public const int sYYYYMMDD = 5;     //거래일자
                public const int shhmmss = 6;       //거래시간
                public const int sApprNo = 7;       //승인번호
                public const int sReqCode = 8;      //응답코드
                public const int sCardNo = 9;       //카드번호
                public const int sHPCustNo = 10;    //HPC 고객번호
                public const int sSaleDate = 11;    //영업일자
                public const int sStoreCode = 12;   //점포코드
                public const int sPosNo = 13;       //POS번호
                public const int sBillNo = 14;      //BILL번호
                public const int sCardDiv = 15;     //카드구분 (c: hp cardno /w: real cardno)
                public const int sApprDate = 16;    //승인일시
                public const int sRemainCnt = 17;   //잔여횟수
                public const int sTotDcAmt = 18;    //총할인금액
                public const int sMsg1 = 19;        //MSG1
                public const int sMsg2 = 20;        //MSG2
                public const int sMsg3 = 21;        //MSG3
                public const int sFiller = 22;      //Filler
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            //public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 1, 14, 5, 8, 100, 100, 100, 50 };
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 1, 14, 5, 8, 100, 100, 100, 50 };


            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        #region 웰컴카드 발급요청

        /// <summary>
        /// 발급 요청
        /// </summary>
        public class WELCOMECARD_ISSUE
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0;        //전체 전문길이
                public const int sMsgDiv = 1;     //구분
                public const int sMsgType = 2;    //전문유형
                public const int sMsgGubun = 3;   //업무구분
                public const int sMsgVersion = 4; //전문버전
                public const int sYYYYMMDD = 5;   //거래일자
                public const int shhmmss = 6;     //거래시간
                public const int sApprNo = 7;     //승인번호
                public const int sReqCode = 8;    //응답코드
                public const int sCardNo = 9;     //카드번호
                public const int sHPCCustNo = 10; //HPC고객번호
                public const int sSaleDate = 11;  //영업일자
                public const int sStoreCode = 12; //점포코드
                public const int sPosNo = 13;     //POS번호
                public const int sBillNo = 14;    //BILL번호
                public const int sTelType = 15;   //통신사 구분
                public const int sFiller = 16;    //Filler
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 1, 50 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }

        /// <summary>
        /// 발급 응답
        /// </summary>
        public class WELCOMECARD_ISSUE_RECV
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0;          //전체 전문길이
                public const int sMsgDiv = 1;       //구분
                public const int sMsgType = 2;      //전문유형
                public const int sMsgGubun = 3;     //업무구분
                public const int sMsgVersion = 4;   //전문버전
                public const int sYYYYMMDD = 5;     //거래일자
                public const int shhmmss = 6;       //거래시간
                public const int sApprNo = 7;       //승인번호
                public const int sReqCode = 8;      //응답코드
                public const int sCardNo = 9;       //카드번호
                public const int sHPCCustNo = 10;   //HPC 고객번호
                public const int sSaleDate = 11;    //영업일자
                public const int sStoreCode = 12;   //점포코드
                public const int sPosNo = 13;       //POS번호
                public const int sBillNo = 14;      //BILL번호
                public const int sTelType = 15;     //통신사 구분
                public const int sApprDate = 16;    //승인일시
                public const int sMsg1 = 17;        //MSG1
                public const int sMsg2 = 18;        //MSG2
                public const int sMsg3 = 19;        //MSG3
                public const int sFiller = 20;      //Filler
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 1, 14, 100, 100, 100, 50 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        #region 웰컴카드 발급 POS 고객등록

        /// <summary>
        /// POS 고객등록 요청
        /// </summary>
        public class WELCOMECARD_SERVER_REGISTER
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0;          //전체 전문길이
                public const int sMsgDiv = 1;       //구분
                public const int sMsgType = 2;      //전문유형
                public const int sMsgGubun = 3;     //업무구분
                public const int sMsgVersion = 4;   //전문버전
                public const int sYYYYMMDD = 5;     //거래일자
                public const int shhmmss = 6;       //거래시간
                public const int sApprNo = 7;       //승인번호
                public const int sReqCode = 8;      //응답코드
                public const int sCardNo = 9;       //카드번호
                public const int sHPCCustNo = 10;   //HPC고객번호
                public const int sSaleDate = 11;    //영업일자
                public const int sStoreCode = 12;   //점포코드
                public const int sPosNo = 13;       //POS번호
                public const int sBillNo = 14;      //BILL번호
                public const int sFiller = 15;      //Filler
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 50 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }

        /// <summary>
        /// POS 고객등록 응답
        /// </summary>
        public class WELCOMECARD_SERVER_REGISTER_RECV
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0; // ""; //전체 전문길이   
                public const int sMsgDiv = 1; // "MC"; //구분
                public const int sMsgType = 2; // "2200";//전문유형
                public const int sMsgGubun = 3; // "50";//업무구분
                public const int sMsgVersion = 4; // "V100";//전문버전
                public const int sYYYYMMDD = 5; // ""; //거래일자
                public const int shhmmss = 6; // ""; //거래시간
                public const int sApprNo = 7; // ""; //승인번호
                public const int sReqCode = 8; // ""; //응답코드
                public const int sCardNo = 9; // ""; //카드번호
                public const int sHPCCustNo = 10; // ""; //HPC고객번호
                public const int sSaleDate = 11; // ""; //영업일자 
                public const int sStoreCode = 12; // ""; //점포코드
                public const int sPosNo = 13; // ""; //POS번호
                public const int sBillNo = 14; // ""; //BILL번호
                public const int sApprDate = 15; // ""; //승인일시 YYYYMMDDHHMMSS
                public const int sMsg1 = 16; // ""; //MSG1
                public const int sMsg2 = 17; // ""; //MSG2
                public const int sMsg3 = 18; // ""; //MSG3
                public const int sFiller = 19; // ""; //Filler1
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 14, 100, 100, 100, 50 };

            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        #region 웰컴카드 할인요청

        /// <summary>
        /// 웰컴카드 할인
        /// </summary>
        public class WELCOMECARD_DC
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0; //""; //전체 전문길이
                public const int sMsgDiv = 1; //"MC"; //구분
                public const int sMsgType = 2; //"0100";//전문유형
                public const int sMsgGubun = 3; //"10";//업무구분
                public const int sMsgVersion = 4; //"V100";//전문버전
                public const int sYYYYMMDD = 5; //""; //거래일자
                public const int shhmmss = 6; //""; //거래시간
                public const int sApprNo = 7; //""; //승인번호
                public const int sReqCode = 8; //""; //응답코드
                public const int sCardNo = 9; //""; //카드번호
                public const int sHPCustNo = 10; //""; //HPC카드번호
                public const int sSaleDate = 11; //""; //영업일자
                public const int sStoreCode = 12; //""; //점포코드
                public const int sPosNo = 13; //""; //POS번호
                public const int sBillNo = 14; //""; //BILL번호
                public const int sCard_type = 15; //""; //입력구분
                public const int sTarget_Amt = 16; //""; //대상금액 
                public const int sFiller = 17; //""; //Filler
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 1, 8, 50 };
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }

        /// <summary>
        /// 웰컴카드 할인 응답
        /// </summary>
        public class WELCOMECARD_DC_RECV
        {
            /// <summary>
            /// 컬럼순서
            /// </summary>
            public class SEQ
            {
                public const int sLen = 0;           //전체 전문길이
                public const int sMsgDiv = 1;        //구분
                public const int sMsgType = 2;       //전문유형
                public const int sMsgGubun = 3;      //업무구분
                public const int sMsgVersion = 4;    //전문버전
                public const int sYYYYMMDD = 5;      //거래일자
                public const int shhmmss = 6;        //거래시간
                public const int sApprNo = 7;        //승인번호
                public const int sReqCode = 8;       //응답코드
                public const int sCardNo = 9;        //카드번호
                public const int sHPCustNo = 10;     //HPC고객번호
                public const int sSaleDate = 11;     //영업일자
                public const int sStoreCode = 12;    //점포코드
                public const int sPosNo = 13;        //POS번호
                public const int sBillNo = 14;       //BILL번호
                public const int sCardDiv = 15;      //입력구분 C:실물카드, A:해피App
                public const int sCardType = 16;     //카드구분 => D:할인, S:적립, A:적립/할인
                public const int sApprDate = 17;     //승인일시
                public const int sDC_Rate = 18;      //할인율%
                public const int sDC_Amt = 19;       //할인금액
                public const int sPoint_S = 20;      //본사부담금액
                public const int sPoint_L = 21;      //점포부담금액
                public const int sRemainCnt = 22;    //잔여횟수
                public const int sTotDcAmt = 23;     //총할인금액
                public const int sMsg1 = 24;         //MSG1
                public const int sMsg2 = 25;         //MSG2
                public const int sMsg3 = 26;         //MSG3
                public const int sFiller = 27;       //Filler
            }
            /// <summary>
            /// 컬럼길이
            /// </summary>
            public static int[] LEN = { 4, 2, 4, 2, 4, 8, 6, 20, 5, 16, 20, 8, 10, 2, 5, 1, 1, 14, 4, 7, 7, 7, 5, 8, 100, 100, 100, 50 };
            
            /// <summary>
            /// 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 8:가변암호화, 9:고정암호화)
            /// </summary>
            public static int[] TYPE = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        }
        #endregion

        //#20180413 웰컴카드 신규기능 추가 end,phj
    }

    #region 마스터 파일 정의
    /// <summary>
    /// 마스터파일 정의
    /// </summary>
    public static class PosMst
    {
        #region 상품마스터
        /// <summary>
        /// 상품마스터
        /// </summary>
        public class MST_ITEM
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 상품 브랜드 코드
                /// </summary>
                public const string ITEM_BRAND_CD = "ITEM_BRAN_CD";
                /// <summary>
                /// SUB 점포 코드
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 상품코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 대분류
                /// </summary>
                public const string L_CLSS = "L_CLSS";
                /// <summary>
                /// 중분류
                /// </summary>
                public const string M_CLSS = "M_CLSS";
                /// <summary>
                /// 소분류
                /// </summary>
                public const string S_CLSS = "S_CLSS";
                /// <summary>
                /// 플레이버 구분 
                /// </summary>
                public const string FLAVOUR_DIV = "FLAVOUR_DIV";
                /// <summary>
                /// 플레이버 수량 
                /// </summary>
                public const string FLAVOUR_QTY = "FLAVOUR_QTY";
                /// <summary>
                /// 플레이버 중량
                /// </summary>
                public const string FLAVOUR_STOCK = "FLAVOUR_STOCK";
                /// <summary>
                /// 단축 상품명
                /// </summary>
                public const string SHTCUT_ITEMNM = "SHTCUT_ITEMNM";
                /// <summary>
                /// 상품명
                /// </summary>
                public const string ITEM_NM = "ITEM_NM";
                /// <summary>
                /// TAKE IN 판매 금액
                /// </summary>
                public const string TAKE_IN_SALE_AMT = "TAKE_IN_SALE_AMT";
                /// <summary>
                /// TAKE OUT 판매 금액 
                /// </summary>
                public const string TAKE_OUT_SALE_AMT = "TAKE_OUT_SALE_AMT";
                /// <summary>
                /// 인터페이스 메뉴1
                /// </summary>
                public const string IF_MENU1 = "IF_MENU1";
                /// <summary>
                /// 인터페이스 메뉴2
                /// </summary>
                public const string IF_MENU2 = "IF_MENU2";
                /// <summary>
                /// OPEN ITEM 구분
                /// </summary>
                public const string OPEN_ITEM_DIV = "OPEN_ITEM_DIV";
                /// <summary>
                /// 일회용품구분
                /// </summary>
                public const string DISPO_ITEM_DIV = "DISPO_ITEM_DIV";
                /// <summary>
                /// 부가세트관리유형(상품 종류) 
                /// </summary>
                public const string SUB_SET_MNG_TYPE = "SUB_SET_MNG_TYPE";
                /// <summary>
                /// 상품 세금구분
                /// </summary>
                public const string ITEM_TAX_AMT_DIV = "ITEM_TAX_AMT_DIV";
                ///// <summary>
                ///// 세금포함 구분 
                ///// </summary>
                //public const string TAX_AMT_INCLUDE_YN = "TAX_AMT_INCLUDE_YN";
                public const string TAX_AMT_INCLUDE_YN = "TAX_AMT_INCLUDE_YN";//2018.01.04;기존 주석 처리 되어 있는 것을 미주 상품 부가세 기능으로 인해 다시 사용하도록 추가함 ; girak.kim
                ///// <summary>
                ///// 기본세율
                ///// </summary>
                //public const string BASICTAXRATE = "BASICTAXRATE";
                /// <summary>
                /// TAKE IN 부가세 코드
                /// </summary>
                public const string TAKE_IN_VAT_CD = "TAKE_IN_VAT_CD";
                /// <summary>
                /// TAKE OUT 부가세 코드 
                /// </summary>
                public const string TAKE_OUT_VAT_CD = "TAKE_OUT_VAT_CD";
                /// <summary>
                /// 상품 원가
                /// </summary>
                public const string ITEM_COST = "ITEM_COST";
                /// <summary>
                /// 판매 허용 여부
                /// </summary>
                public const string SALE_PRMT_YN = "SALE_PRMT_YN";
                /// <summary>
                /// 판매 입수
                /// </summary>
                public const string SALE_NOQ = "SALE_NOQ";
                /// <summary>
                /// 사은품 여부(0:사은품아님, 1:사은품)
                /// </summary>
                public const string FREE_GIFT_YN = "FREE_GIFT_YN";
                ///// <summary>
                ///// 부가메뉴 포함 여부
                ///// </summary>
                //public const string SUBPRCMENU_INCLUDEYN = "SUBPRCMENU_INCLUDEYN";
                /// <summary>
                /// 할인 불가 여부(0:가능, 1:불가) 
                /// </summary>
                public const string DC_PRMT_YN = "DC_PRMT_YN";
                /// <summary>
                /// 적립 허용 여부(0:불가, 1:가능)
                /// </summary>
                public const string ACCUM_PRMT_YN = "ACCUM_PRMT_YN";
                ///// <summary>
                ///// 서비스 허용 여부 
                ///// </summary>
                //public const string SVC_PRMT_YN = "SVC_PRMT_YN";
                ///// <summary>
                ///// 주방출력 허용 여부
                ///// </summary>
                //public const string KTCHPRT_PRMT_YN = "KTCHPRT_PRMT_YN";
                /// <summary>
                /// 봉사료 대상 여부
                /// </summary>
                public const string SVC_FEE_TRGT_YN = "SVC_FEE_TRGT_YN";
                /// <summary>
                /// 버튼 상품 이미지 
                /// </summary>
                public const string BTN_ITEM_IMG = "BTN_ITEM_IMG";
                /// <summary>
                /// 신상품 시작 일자 
                /// </summary>
                public const string NEW_ITEM_START_DT = "NEW_ITEM_START_DT";
                /// <summary>
                /// 신상품 종료 일자 
                /// </summary>
                public const string NEW_ITEM_FNSH_DT = "NEW_ITEM_FNSH_DT";
                /// <summary>
                /// 상품유형 - 공통코드 M0047 01:제품, 02:상품, 03:반제품(휴면생지, 케익시트), 04:원료, 05:재료, 06:소모품, 07:유니폼, 08:명찰, 09:설비, 10:장비12:상품권,13:선불카드
                /// </summary>
                public const string ITEM_TYPE = "ITEM_TYPE";
                /// <summary>
                /// 타임바코드여부
                /// </summary>
                public const string TIME_BAR_CD_YN = "TIME_BAR_CD_YN";
                /// <summary>
                /// 유통기한일수 
                /// </summary>
                public const string DISTBT_EXPIRE_NOD = "DISTBT_EXPIRE_NOD";
                /// <summary>
                /// 알콜 상품 유형
                /// </summary>
                public const string ALCOHOL_ITEM_TYPE = "ALCOHOL_ITEM_TYPE";
                /// <summary>
                /// 판매 시작 일자 
                /// </summary>
                public const string SALE_START_DT = "SALE_START_DT";
                /// <summary>
                /// 판매 종료 일자 
                /// </summary>
                public const string SALE_FNSH_DT = "SALE_FNSH_DT";
                /// <summary>
                ///  제휴카드 할인 불가 여부 
                /// </summary>
                public const string COOP_CARD_DC_NOADM_YN = "COOP_CARD_DC_NOADM_YN";
                /// <summary>
                /// 케익 교환권 사용 가능 여부
                /// </summary>
                public const string CAKE_EXCHNG_CPN_USE_POSS_YN = "CAKE_EXCHNG_CPN_USE_POSS_YN";
                /// <summary>
                /// 영양 정보
                /// </summary>
                public const string ITEM_INFO = "ITEM_INFO";
                /// <summary>
                /// 열량 정보 
                /// </summary>
                public const string CALORY_INFO = "CALORY_INFO";
                /// <summary>
                /// 판매상품 이미지
                /// </summary>
                public const string SALE_IMG_FILE_NM = "SALE_IMG_FILE_NM";

                //MoonSeokWoo 2017.11.15 Add
                /// <summary>
                /// 대표상품 코드
                /// </summary>
                public const string RPST_ITEM_CD = "RPST_ITEM_CD";
                //MoonSeokWoo 2017.11.15 Add End 

                //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start
                /// <summary>
                /// 상품설명 
                /// </summary>
                public const string ITEM_EXPLN = "ITEM_EXPLN";

                /// <summary>
                /// 알레르기성분 
                /// </summary>
                public const string ALLERGY = "ALLERGY";

                /// <summary>
                /// 원산지
                /// </summary>
                public const string PLACE_ORIGIN = "PLACE_ORIGIN";
                //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end

                //#15945 해피오더 자동주문 상세기능 start
                /// <summary>
                /// 1: 자동출하상품, 그 외 일반상품 
                /// </summary>
                public const string HP_ORD_DIV = "HP_ORD_DIV";

                /// <summary>
                /// Y: 제조상품, N:완제상품, 공백:기타 
                /// </summary>
                public const string ITEM_PROD_TYPE_YN = "ITEM_PROD_TYPE_YN";
                //#15945 해피오더 자동주문 상세기능 end

                //#17143 [해피오더]자동 주문 처리 개선 start
                /// <summary>
                /// N: 제한상품아님, Y:제한상품
                /// </summary>
                public const string EXE_HPORD = "EXE_HPORD";
                //#17143 [해피오더]자동 주문 처리 개선 end
            }
        }
        #endregion

        #region 상품바코드마스터
        /// <summary>
        /// 상품바코드마스터
        /// </summary>
        public class MST_BARCODE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_BARCODE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 바코드 번호
                /// </summary>
                public const string BAR_CD_NO = "BAR_CD_NO";
                /// <summary>
                /// 상품코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
            }
        }
        #endregion

        #region 기능키 그룹
        /// <summary>
        /// 기능키 그룹
        /// </summary>
        public class MST_FUNC_KEY_GRP
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_FUNC_KEY_GRP";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 기능 그룹 ID 
                /// </summary>
                public const string FUNC_GRP_ID = "FUNC_GRP_ID";
                /// <summary>
                /// 기능 ID
                /// </summary>
                public const string FUNC_ID = "FUNC_ID";
                /// <summary>
                /// 표시 순번
                /// </summary>
                public const string DISP_SEQ = "DISP_SEQ";
                /// <summary>
                /// 기능버튼 크기(0:일반,1:가로확대,2:세로확대,3:가로세로확대)
                /// </summary>
                public const string FUNC_BTN_SIZE = "FUNC_BTN_SIZE";
                /// <summary>
                /// 글자 크기
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 기능버튼 색상 
                /// </summary>
                public const string FUNC_BTN_COLOR = "FUNC_BTN_COLOR";
                /// <summary>
                /// 기능명
                /// </summary>
                public const string FUNC_NM = "FUNC_NM";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 기능키 마스터
        /// <summary>
        /// 기능키 마스터
        /// </summary>
        public class MST_FUNC_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_FUNC_KEY";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 기능 ID 
                /// </summary>
                public const string FUNC_ID = "FUNC_ID";
                /// <summary>
                /// 기능 명
                /// </summary>
                public const string FUNC_NM = "FUNC_NM";
                /// <summary>
                /// ASCII CODE
                /// </summary>
                public const string ASCII_CODE = "ASCII_CODE";
                /// <summary>
                /// 테이블
                /// </summary>
                public const string TBL = "TBL";
                /// <summary>
                /// 상품등록 전
                /// </summary>
                public const string ITEM_REG_BF = "ITEM_REG_BF";
                /// <summary>
                /// 상품등록 후
                /// </summary>
                public const string ITEM_REG_AF = "ITEM_REG_AF";
                /// <summary>
                /// 결제포인트
                /// </summary>
                public const string PAY_POINT = "PAY_POINT";
                /// <summary>
                /// 결제할인
                /// </summary>
                public const string PAY_DC = "PAY_DC";
                /// <summary>
                /// 결제수단
                /// </summary>
                public const string PAY_WAY = "PAY_WAY";
                /// <summary>
                /// 메뉴그룹
                /// </summary>
                public const string MENU_GRP = "MENU_GRP";
                /// <summary>
                /// 설명
                /// </summary>
                public const string EXPLN = "EXPLN";
                /// <summary>
                /// 정상거래
                /// </summary>
                public const string NORMAL = "NORMAL";
                /// <summary>
                /// 반품거래
                /// </summary>
                public const string REFUND = "REFUND";
                /// <summary>
                /// 일반거래
                /// </summary>
                public const string TRN_MODE_0 = "TRN_MODE_0";
                /// <summary>
                /// 미결거래
                /// </summary>
                public const string TRN_MODE_1 = "TRN_MODE_1";
                /// <summary>
                /// 대외거래
                /// </summary>
                public const string TRN_MODE_2 = "TRN_MODE_2";
                /// <summary>
                /// 사후거래
                /// </summary>
                public const string TRN_MODE_3 = "TRN_MODE_3";
                /// <summary>
                /// 충전판매거래
                /// </summary>
                public const string TRN_MODE_4 = "TRN_MODE_4";
                /// <summary>
                /// 기타거래
                /// </summary>
                public const string TRN_MODE_5 = "TRN_MODE_5";
                /// <summary>
                /// 예비거래1
                /// </summary>
                public const string TRN_MODE_6 = "TRN_MODE_6";
                /// <summary>
                /// 예버거래2
                /// </summary>
                public const string TRN_MODE_7 = "TRN_MODE_7";
                /// <summary>
                /// 입출금거래
                /// </summary>
                public const string TRN_MODE_8 = "TRN_MODE_8";
                /// <summary>
                /// 로그거래
                /// </summary>
                public const string TRN_MODE_9 = "TRN_MODE_9";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 상품키 구성 마스터
        /// <summary>
        /// 상품키 구성 마스터
        /// </summary>
        public class MST_ITEM_KEY_COMPNT
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM_KEY_COMPNT";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 화면 타입
                /// </summary>
                public const string POS_SCRN_TYPE = "POS_SCRN_TYPE";
                /// <summary>
                /// 기능버튼 네비게이션 여부
                /// </summary>
                public const string FUNC_SCROLL_USE_YN = "FUNC_SCROLL_USE_YN";
                /// <summary>
                /// 테마 색상
                /// </summary>
                public const string THEME_COLOR = "THEME_COLOR";
                /// <summary>
                /// 로그인 이미지
                /// </summary>
                public const string LOGIN_IMG = "LOGIN_IMG";
                /// <summary>
                /// 브랜드 CI 이미지
                /// </summary>
                public const string BRAND_CI_IMG = "BRAND_CI_IMG";
                /// <summary>
                /// 메인 이미지
                /// </summary>
                public const string MAIN_IMG = "MAIN_IMG";
                /// <summary>
                /// 대기 이미지
                /// </summary>
                public const string WAIT_IMG = "WAIT_IMG";
                /// <summary>
                /// 바로가기 사용 여부
                /// </summary>
                public const string BOOKMK_USE_YN = "BOOKMK_USE_YN";
                /// <summary>
                /// 바로가기 배열
                /// </summary>
                public const string BOOKMK_ITEM_KEY_ARRAY = "BOOKMK_ITEM_KEY_ARRAY";
                ///// <summary>
                ///// 바로가기 행
                ///// </summary>
                //public const string FAVOR_COL = "FAVOR_COL";
                ///// <summary>
                ///// 바로가기 열
                ///// </summary>
                //public const string FAVOR_ROW = "FAVOR_ROW";
                /// <summary>
                /// 본부 상품키 배열
                /// </summary>
                public const string HQ_ITEMKEY_LAYOUT = "HQ_ITEMKEY_LAYOUT";
                /// <summary>
                /// 매장 상품키 배열 
                /// </summary>
                public const string SHOP_ITEMKEY_LAYOUT = "SHOP_ITEMKEY_LAYOUT";
                /// <summary>
                /// 대분류 키 기본 색상
                /// </summary>
                public const string L_CLSS_KEY_BASIC_COLOR = "L_CLSS_KEY_BASIC_COLOR";
                /// <summary>
                /// 대분류 키 기본 FONT 색상
                /// </summary>
                public const string L_CLSS_KEY_BASIC_FONT_COLOR = "L_CLSS_KEY_BASIC_FONT_COLOR";
                /// <summary>
                /// 대분류 키 선택 색상
                /// </summary>
                public const string L_CLSS_KEY_SEL_COLOR = "L_CLSS_KEY_SEL_COLOR";
                /// <summary>
                /// 대분류 키 선택 FONT 색상
                /// </summary>
                public const string L_CLSS_KEY_SEL_FONT_COLOR = "L_CLSS_KEY_SEL_FONT_COLOR";
                /// <summary>
                /// 상품 키 기본 색상 
                /// </summary>
                public const string ITEM_KEY_BASIC_COLOR = "ITEM_KEY_BASIC_COLOR";
                /// <summary>
                /// 상품 키 기본 FONT 색상 
                /// </summary>
                public const string ITEM_KEY_BASIC_FONT_COLOR = "ITEM_KEY_BASIC_FONT_COLOR";
                /// <summary>
                /// 상품 키 선택 색상
                /// </summary>
                public const string ITEM_KEY_SEL_COLOR = "ITEM_KEY_SEL_COLOR";
                /// <summary>
                /// 상품 키 선택 FONT 색상
                /// </summary>
                public const string ITEM_KEY_SEL_FONT_COLOR = "ITEM_KEY_SEL_FONT_COLOR";
                /// <summary>
                /// 고정상품 분류 수
                /// </summary>
                public const string FIX_ITEM_CLSS_CNT = "FIX_ITEM_CLSS_CNT";

                /// <summary>
                /// 서브 점포 코드
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
            }
        }
        #endregion

        #region 상품키 대분류  마스터
        /// <summary>
        /// 대분류 상품 키 마스터
        /// </summary>
        public class MST_ITEM_KEY_L_CLSS
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM_KEY_L_CLSS";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 대분류 코드
                /// </summary>
                public const string L_CLSS_CD = "L_CLSS_CD";
                /// <summary>
                /// 대분류 명 
                /// </summary>
                public const string L_CLSS_NM = "L_CLSS_NM";
                /// <summary>
                /// SUB 매장 코드
                /// </summary>
                public const string SUB_SHOP_CD = "SUB_SHOP_CD";
                /// <summary>
                /// 본부 키 구분 
                /// </summary>
                public const string HQ_KEY_DIV = "HQ_KEY_DIV";
            }
        }
        #endregion

        #region 상품키 중분류 마스터
        /// <summary>
        /// 상품키 중분류 마스터
        /// </summary>
        public class MST_ITEM_KEY_CLSS
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM_KEY_CLSS";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 매장 코드
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 대분류 코드
                /// </summary>
                public const string L_CLSS_CD = "L_CLSS_CD";
                /// <summary>
                /// 고정 여부
                /// </summary>
                public const string FIX_YN = "FIX_YN";
                /// <summary>
                /// 배치 순번
                /// </summary>
                public const string GRP_SEQ = "GRP_SEQ";
                /// <summary>
                /// 상품 그룹 명 
                /// </summary>
                public const string ITEM_GRP_NM = "ITEM_GRP_NM";
                /// <summary>
                /// FONT 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
            }
        }
        #endregion

        #region 상품 키 마스터
        /// <summary>
        /// 상품 키 마스터
        /// </summary>
        public class MST_ITEM_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM_KEY";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 대분류 코드 
                /// </summary>
                public const string L_CLSS_CD = "L_CLSS_CD";
                /// <summary>
                /// 고정 여부
                /// </summary>
                public const string FIX_YN = "FIX_YN";
                /// <summary>
                /// 배치 순번
                /// </summary>
                public const string GRP_SEQ = "GRP_SEQ";
                /// <summary>
                /// 순번 
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 상품 코드 
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// FONT 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
                /// <summary>
                /// 메뉴버튼 사이즈(0:일반,1:가로확대,2:세로확대,3:가로세로확대) 
                /// </summary>
                public const string BTN_SIZE = "BTN_SIZE";
                /// <summary>
                /// 부가 메뉴 팝업 여부 
                /// </summary>
                public const string SUBPRC_MENU_POPUP_YN = "SUBPRC_MENU_POPUP_YN";

                //#20171018 메뉴명 폰트 색상 변경 기능 start
                /// <summary>
                /// 메뉴 폰트 색상
                /// </summary>
                public const string FONT_COLOR = "FONT_COLOR";
                //#20171018 메뉴명 폰트 색상 변경 기능 end
            }
        }
        #endregion

        #region 즐겨찾기 마스터
        /// <summary>
        /// 즐겨찾기 마스터
        /// </summary>
        public class MST_BOOKMK
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_BOOKMK";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 상품 코드 
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 순번 
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 단축 상품 명 
                /// </summary>
                public const string SHTCUT_ITEM_NM = "SHTCUT_ITEM_NM";
                /// <summary>
                /// 상품 단가 
                /// </summary>
                public const string ITEM_PRC = "ITEM_PRC";
                /// <summary>
                /// FONT 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
                /// <summary>
                /// 버튼 크기 
                /// </summary>
                public const string BTN_SIZE = "BTN_SIZE";
                /// <summary>
                /// 부가 메뉴 팝업 여부 
                /// </summary>
                public const string SUBPRC_MENU_POPUP_YN = "SUBPRC_MENU_POPUP_YN";
            }
        }
        #endregion

        #region 메시지 마스터
        /// <summary>
        /// 메시지 마스터
        /// </summary>
        public class MST_MSG
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_MSG";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 언어코드
                /// </summary>
                public const string LANG_CD = "LANG_CD";
                /// <summary>
                /// 메시지유형 
                /// </summary>
                public const string MSG_TYPE = "MSG_TYPE";
                /// <summary>
                /// 메시지번호
                /// </summary>
                public const string MSG_NO = "MSG_NO";
                /// <summary>
                /// 메시지
                /// </summary>
                public const string MSG1 = "MSG1";
                /// <summary>
                /// 메시지
                /// </summary>
                public const string MSG2 = "MSG2";
                /// <summary>
                /// 메시지
                /// </summary>
                public const string MSG3 = "MSG3";
                /// <summary>
                /// 메시지
                /// </summary>
                public const string MSG4 = "MSG4";
                /// <summary>
                /// 메시지
                /// </summary>
                public const string MSG5 = "MSG5";

            }
        }
        #endregion

        #region 옵션 마스터
        /// <summary>
        /// 옵션 마스터
        /// </summary>
        public class MST_POS_OPTN
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_POS_OPTN";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 옵션 코드 
                /// </summary>
                public const string OPTN_CD = "OPTN_CD";
                /// <summary>
                /// 옵션 값
                /// </summary>
                public const string OPTN_VAL = "OPTN_VAL";
                /// <summary>
                /// 옵션 명
                /// </summary>
                public const string OPTN_NM = "OPTN_NM";
                /// <summary>
                /// 옵션 설명
                /// </summary>
                public const string OPTN_EXPLN = "OPTN_EXPLN";

            }
        }
        #endregion

        #region 공통코드 마스터
        /// <summary>
        /// 공통코드 마스터
        /// </summary>
        public class MST_COMMON
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_COMMON";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 국가 코드 
                /// </summary>
                public const string LANG_TYPE = "LANG_TYPE";
                /// <summary>
                /// 공통 그룹 코드 
                /// </summary>
                public const string CMM_GRP_CD = "CMM_GRP_CD";
                /// <summary>
                /// 공통 코드
                /// </summary>
                public const string CMM_CD = "CMM_CD";
                /// <summary>
                /// 코드 명
                /// </summary>
                public const string CD_NM = "ENTRY_NM";
                /// <summary>
                /// 표시 순번
                /// </summary>
                public const string DISP_SEQ = "DISP_SEQ";
                /// <summary>
                /// 상위공통그룹코드
                /// </summary>
                public const string H_RANK_CMM_GRP_CD = "H_RANK_CMM_GRP_CD";
                /// <summary>
                /// 상위공통코드
                /// </summary>
                public const string H_RANK_CMM_CD = "H_RANK_CMM_CD";
                /// <summary>
                /// 영업조직코드
                /// </summary>
                public const string SALES_ORG_CD = "SALES_ORG_CD";
                /// <summary>
                /// 설명
                /// </summary>
                public const string EXPLN = "EXPLN";
                /// <summary>
                /// 문자값_01
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_01 = "CHAR_VAL_TITLE_VAL_01";
                /// <summary>
                /// 문자값_01
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_02 = "CHAR_VAL_TITLE_VAL_02";
                /// <summary>
                /// 문자값_02
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_03 = "CHAR_VAL_TITLE_VAL_03";
                /// <summary>
                /// 문자값_03
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_04 = "CHAR_VAL_TITLE_VAL_04";
                /// <summary>
                /// 문자값_04
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_05 = "CHAR_VAL_TITLE_VAL_05";
                /// <summary>
                /// 문자값_05
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_06 = "CHAR_VAL_TITLE_VAL_06";
                /// <summary>
                /// 문자값_06
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_07 = "CHAR_VAL_TITLE_VAL_07";
                /// <summary>
                /// 문자값_07
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_08 = "CHAR_VAL_TITLE_VAL_08";
                /// <summary>
                /// 문자값_08
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_09 = "CHAR_VAL_TITLE_VAL_09";
                /// <summary>
                /// 문자값_09
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_10 = "CHAR_VAL_TITLE_VAL_10";
                /// <summary>
                /// 문자값_10
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_11 = "CHAR_VAL_TITLE_VAL_11";
                /// <summary>
                /// 문자값_11
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_12 = "CHAR_VAL_TITLE_VAL_12";
                /// <summary>
                /// 문자값_12
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_13 = "CHAR_VAL_TITLE_VAL_13";
                /// <summary>
                /// 문자값_13
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_14 = "CHAR_VAL_TITLE_VAL_14";
                /// <summary>
                /// 문자값_14
                /// </summary>
                public const string CHAR_VAL_TITLE_VAL_15 = "CHAR_VAL_TITLE_VAL_15";
                /// <summary>
                /// 문자값_15
                /// </summary>
                public const string NUM_VAL_TITLE_VAL_01 = "NUM_VAL_TITLE_VAL_01";
                /// <summary>
                /// 문자값_02
                /// </summary>
                public const string NUM_VAL_TITLE_VAL_02 = "NUM_VAL_TITLE_VAL_02";
                /// <summary>
                /// 문자값_03
                /// </summary>
                public const string NUM_VAL_TITLE_VAL_03 = "NUM_VAL_TITLE_VAL_03";
                /// <summary>
                /// 문자값_04
                /// </summary>
                public const string NUM_VAL_TITLE_VAL_04 = "NUM_VAL_TITLE_VAL_04";
                /// <summary>
                /// 숫자값_05
                /// </summary>
                public const string NUM_VAL_TITLE_VAL_05 = "NUM_VAL_TITLE_VAL_05";

            }
        }
        #endregion

        #region 캐셔 마스터
        /// <summary>
        /// 캐셔 마스터
        /// </summary>
        public class MST_USER
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_USER";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 공통 그룹 코드 
                /// </summary>
                public const string CASHIER_ID = "CASHIER_ID";
                /// <summary>
                /// 계산원 구분<1:점주, 2:점장, 3:직원, 4:아르바이트>
                /// </summary>
                public const string CASHIER_DIV = "CASHIER_DIV";
                /// <summary>
                /// 계산원 명
                /// </summary>
                public const string CASHIER_NM = "CASHIER_NM";
                /// <summary>
                /// 계산원 비밀번호
                /// </summary>
                public const string CASHIER_PWD = "CASHIER_PWD";
                /// <summary>
                /// 계산원 웹업무 비밀번호
                /// </summary>
                public const string CASHIER_WEB_POS_PWD = "CASHIER_WEB_POS_PWD";
                /// <summary>
                /// 직원 권한 그룹
                /// </summary>
                public const string EMP_AUTH_GRP = "EMP_AUTH_GRP";
                /// <summary>
                /// 계산원 카드 번호
                /// </summary>
                public const string CASHIER_CARD_NO = "CASHIER_CARD_NO";
                /// <summary>
                /// 반품 비밀번호
                /// </summary>
                public const string RTN_PWD = "RTN_PWD";
                /// <summary>
                /// 예비 필드1
                /// </summary>
                public const string FILLER1 = "FILLER1";
                /// <summary>
                /// 예비 필드2
                /// </summary>
                public const string FILLER2 = "FILLER2";
                /// <summary>
                /// 예비 필드3
                /// </summary>
                public const string FILLER3 = "FILLER3";
                /// <summary>
                /// 예비 필드4
                /// </summary>
                public const string FILLER4 = "FILLER4";
                /// <summary>
                /// 예비 필드5
                /// </summary>
                public const string FILLER5 = "FILLER5";

            }
        }
        #endregion 캐셔 마스터

        #region 점포 마스터
        /// <summary>
        /// 점포 마스터
        /// </summary>
        public class MST_STORE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_STORE";

            public class DATA
            {
                /// <summary>
                ///회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 브랜드 코드
                /// </summary>
                public const string BRAND_CD = "BRAND_CD";
                /// <summary>
                /// 점포 주 명
                /// </summary>
                public const string STOR_OWN_NM = "STOR_OWN_NM";
                /// <summary>
                /// 점포 명
                /// </summary>
                public const string STORNM = "STORNM";
                /// <summary>
                /// 점포 주소
                /// </summary>
                public const string STOR_ADDR = "STOR_ADDR";
                /// <summary>
                /// 사업자 번호
                /// </summary>
                public const string BIZ_PSN_NO = "BIZ_PSN_NO";
                /// <summary>
                /// 전화 번호
                /// </summary>
                public const string TELNO = "TELNO";
                /// <summary>
                /// POS 운영 대수
                /// </summary>
                public const string POS_OPER_LCNT = "POS_OPER_LCNT";
                /// <summary>
                /// 봉사료 구분(공통코드 M0029 0:적용안함, 1:율, 2:금액)
                /// </summary>
                public const string SVC_FEE_DIV = "SVC_FEE_DIV";
                /// <summary>
                /// 봉사료(율 or 금액)
                /// </summary>
                public const string SVC_FEE = "SVC_FEE";
                /// <summary>
                /// 봉사료 적용대상 구분(0:적용안함,1:상품당 봉사료 적용,2:영수증당 봉사료 적용)
                /// </summary>
                public const string SVC_FEE_APPLYTRGT_DIV = "SVC_FEE_APPLYTRGT_DIV";
                /// <summary>
                /// 봉사료세금적용구분
                /// </summary>
                public const string SVC_FEE_TAX_AMT_APPLYDIV = "SVC_FEE_TAX_AMT_APPLYDIV";
                /// <summary>
                /// 부가세 절삭위치
                /// </summary>
                public const string VAT_RUD_DW_LOC = "VAT_RUD_DW_LOC";
                /// <summary>
                /// 부가세절삭방법(공통코드 M0066 1:올림, 2:반올림, 3:버림)
                /// </summary>
                public const string VAT_RUD_DW_METHD = "VAT_RUD_DW_METHD";
                /// <summary>
                /// 할인절삭위치
                /// </summary>
                public const string DC_RUD_DW_LOC = "DC_RUD_DW_LOC";
                /// <summary>
                /// 할인절삭방법(공통코드 M0066 1:올림, 2:반올림, 3:버림)
                /// </summary>
                public const string DC_RUD_DW_METHD = "DC_RUD_DW_METHD";
                /// <summary>
                /// 상품 배분 절삭 위치
                /// </summary>
                public const string ITEM_RUD_DW_LOC = "ITEM_RUD_DW_LOC";
                /// <summary>
                /// 직/가맹 구분(1:직영, 2:가맹)
                /// </summary>
                public const string DRT_FRCS_DIV = "DRT_FRCS_DIV";
                /// <summary>
                /// 해피포인트 적립률
                /// </summary>
                public const string HPY_PNT_ACCUMRATE = "HPY_PNT_ACCUMRATE";
                /// <summary>
                /// POS 화면 타입(1:A타입, 2:B타입, 3:C타입)
                /// </summary>
                public const string POS_SCRN_TYPE = "POS_SCRN_TYPE";
                /// <summary>
                /// 세금적용구분(공통코드 M0012 1:기본세율적용, 2:상품세율적용)
                /// </summary>
                public const string TAX_AMT_APPLY_DIV = "TAX_AMT_APPLY_DIV";
                /// <summary>
                /// 세금 포함 구분(0 : 미포함, 1: 포함)
                /// </summary>
                public const string TAX_AMT_INCLUDE_YN = "TAX_AMT_INCLUDE_YN";
                /// <summary>
                /// 세금 계산 방법(1: 전체금액세금계산후배분 2: 상품별세금계산후합산)
                /// </summary>
                public const string TAX_AMT_CALC_METHD = "TAX_AMT_CALC_METHD";
                /// <summary>
                /// 기본 TAKE IN 세금 코드
                /// </summary>
                public const string BASIC_TAKE_IN_TAX_CD = "BASIC_TAKE_IN_TAX_CD";
                /// <summary>
                /// 기본 TAKE OUT 세금 코드
                /// </summary>
                public const string BASIC_TAKE_OUT_TAX_CD = "BASIC_TAKE_OUT_TAX_CD";
                /// <summary>
                /// 테마 색상(RGB 값)
                /// </summary>
                public const string THEME_COLOR = "THEME_COLOR";
                /// <summary>
                /// 다문화 코드
                /// </summary>
                public const string MLT_CULT_CD = "MLT_CULT_CD";
                /// <summary>
                /// 시차
                /// </summary>
                public const string TIMEGAP = "TIMEGAP";
                /// <summary>
                /// 해피오더 동의 여부(1:동의, 0:미동의)
                /// </summary>
                public const string HPYORD_AGREEYN = "HPYORD_AGREEYN";
                /// <summary>
                /// 상품권 판매 여부(1:판매, 0:미판매)
                /// </summary>
                public const string GIF_SALE_YN = "GIF_SALE_YN";
                /// <summary> 
                /// 영수증 메시지 중복 허용 여부(0:중복, 1:미허용)
                /// </summary>
                public const string BILL_MSG_DUP_PRMT_YN = "BILL_MSG_DUP_PRMT_YN";
                /// <summary>
                /// 영수증 메시지 출력 우선순위(0:본부/팀/매장, 1:매장/팀/본부)
                /// </summary>
                public const string BILL_MSG_PRT_RANK = "BILL_MSG_PRT_RANK";
                /// <summary>
                /// 예약 판매 여부(0:미사용, 1:사용)
                /// </summary>
                public const string RESERV_SALE_YN = "RESERV_SALE_YN";
                /// <summary>
                /// 복합 매장 유형(공통코드 M0069, 0:단독매장,1:복합매장구성점포,2:복합매장점포)
                /// </summary>
                public const string COMPLEX_SHOP_TYPE = "COMPLEX_SHOP_TYPE";
                /// <summary>
                /// 테스트 점포 여부(0:정상 점포, 1: 테스트 점포)
                /// </summary>
                public const string TEST_STOR_YN = "TEST_STOR_YN";
                /// <summary>
                /// CDP 사용여부(1:사용)
                /// </summary>
                public const string CDP_USE_YN = "CDP_USE_YN";
                /// <summary>
                /// CDP 메시지
                /// </summary>
                public const string CDP_MSG = "CDP_MSG";
                /// <summary>
                /// 여전법 인증여부
                /// </summary>
                public const string LOAN_LAW_CERTF_YN = "LOAN_LAW_CERTF_YN";
                /// <summary>
                /// 해피버즈 사용 여부(0:미사용,1:사용)
                /// </summary>
                public const string HAPPY_BUZZ_USE_YN = "HAPPY_BUZZ_USE_YN";
                /// <summary>
                /// 브라우저 키
                /// </summary>
                public const string BROWSER_KEY = "BROWSER_KEY";
                /// <summary>
                /// 회사 구분(PC,BR,SL)
                /// </summary>
                public const string CORP_DIV = "CORP_DIV";
                /// <summary>
                /// 국가 구분(KO,CN
                /// </summary>
                public const string CNTRY_DIV = "CNTRY_DIV";

                /// <summary>
                /// 외부 I/F 유형
                /// </summary>
                public const string ETC_IF_DIV = "ETC_IF_DIV";
                /// <summary>
                /// 외부 I/F FTP IP
                /// </summary>
                public const string ETC_IF_FTP_IP = "ETC_IF_FTP_IP";
                /// <summary>
                /// 외부 I/F FTP PORT
                /// </summary>
                public const string ETC_IF_FTP_PORT = "ETC_IF_FTP_PORT";
                /// <summary>
                /// 외부 I/F FTP ID
                /// </summary>
                public const string ETC_IF_FTP_ID = "ETC_IF_FTP_ID";
                /// <summary>
                /// 외부 I/F FTP PW
                /// </summary>
                public const string ETC_IF_FTP_PW = "ETC_IF_FTP_PW";
                /// <summary>
                /// 외부 I/F FTP PASSIVE
                /// </summary>
                public const string ETC_IF_FTP_PASSIVE = "ETC_IF_FTP_PASSIVE";
                /// <summary>
                /// 외부 I/F FTP PATH
                /// </summary>
                public const string ETC_IF_FTP_PATH = "ETC_IF_FTP_PATH";
                /// <summary>
                /// 외부 I/F URL1
                /// </summary>
                public const string ETC_IF_URL1 = "ETC_IF_URL1";
                /// <summary>
                /// 외부 I/F URL2
                /// </summary>
                public const string ETC_IF_URL2 = "ETC_IF_URL2";
                /// <summary>
                /// 외부 I/F 사용 주체 (1:SVR, 2:POS)
                /// </summary>
                public const string ETC_IF_POS_DIV = "ETC_IF_POS_DIV";        

                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 외부업체 계약번호(ex-도로공사, 공항공사 등)
                /// </summary>
                public const string OUT_SD_VEND_CON_NO = "OUT_SD_VEND_CON_NO";
                /// <summary>
                /// 외부업체 코너코드(도로공사)
                /// </summary>
                public const string OUT_SD_VEND_CRNR_CD = "OUT_SD_VEND_CRNR_CD";

                //#15274 영수증 문구 추가 요청 start
                /// <summary>
                /// 회사명
                /// </summary>
                public const string COMP_NM = "FILLER1";
                //#15274 영수증 문구 추가 요청 end
            }
        }
        #endregion

        #region POS 마스터
        /// <summary>
        /// POS 마스터
        /// </summary>
        public class MST_POS
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_POS";

            public class DATA
            {
                /// <summary>
                ///회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 포스 아이피 
                /// </summary>
                public const string POS_IP = "POS_IP";
                /// <summary>
                /// 선불/후불 구분 
                /// </summary>
                public const string POS_TYPE = "POS_TYPE";
                /// <summary>
                /// 메인포스구분 
                /// </summary>
                public const string MAIN_YN = "MAIN_YN";
                /// <summary>
                /// 영수증 유형그룹 
                /// </summary>
                public const string BILL_TYPEGRP = "BILL_TYPEGRP";
                /// <summary>
                /// 주방프린터 유형 그룹 
                /// </summary>
                public const string KTCHPRINTER_TYPE_GRP = "KTCHPRINTER_TYPE_GRP";
                /// <summary>
                /// 정산지 인쇄 유형 그룹 
                /// </summary>
                public const string ADMT_TYPE_GRP = "ADMT_TYPE_GRP";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 여전법 인증 버전
                /// </summary>
                public const string CERTF_VER = "CERTF_VER";
                /// <summary>
                /// 서브매장코드 (복합매장일 때 사용)
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 서브매장명   (복합매장일 때 사용)
                /// </summary>
                public const string SUB_STOR_NM = "SUB_STOR_NM"; 
            }
        }
        #endregion

        #region MOT메시지 마스터
        /// <summary>
        /// MOT메시지 마스터
        /// </summary>
        public class MST_MOT_MSG
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_MOT_MSG";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 메시지 유형<1:MOT메시지, 2:고객면, 3:결제화면>
                /// </summary>
                public const string MSG_TYPE = "MSG_TYPE";
                /// <summary>
                /// 연결ID<MSG_TY=1->화면ID, MSG_TY=2->고객면STEP, MSG_TY=3->조작버튼ID>
                /// </summary>
                public const string CNNT_ID = "CNNT_ID";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// MOT 명
                /// </summary>
                public const string MOT_NM = "MOT_NM";
                /// <summary>
                /// 이미지명
                /// </summary>
                public const string IMG_NM = "IMG_NM";
                /// <summary>
                /// 사운드파일 구분(00(없음), 01(WAVE), 02(TTS))
                /// </summary>
                public const string SOUND_FILE_DIV = "SOUND_FILE_DIV";
                /// <summary>
                /// 사운드파일 명 
                /// </summary>
                public const string SOUND_FILE_NM = "SOUND_FILE_NM";
                /// <summary>
                /// TTS 출력 문구 
                /// </summary>
                public const string TTS_DSCRP = "TTS_DSCRP";

                //#13753 POS MOT음성 기능 추가 개발요청 start,phj
                /// <summary>
                /// 사용유무 
                /// </summary>
                public const string USE_YN = "USE_YN";
                //#13753 POS MOT음성 기능 추가 개발요청 end,phj
            }
        }
        #endregion MOT메시지 마스터

        #region MOT메시지 마스터 상세
        /// <summary>
        /// MOT메시지 마스터
        /// </summary>
        public class MST_MOT_MSG_DTL
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_MOT_MSG_DTL";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 메시지 유형<1:MOT메시지, 2:고객면, 3:결제화면>
                /// </summary>
                public const string MSG_TYPE = "MSG_TYPE";
                /// <summary>
                /// 연결ID<MSG_TY=1->화면ID, MSG_TY=2->고객면STEP, MSG_TY=3->조작버튼ID>
                /// </summary>
                public const string CNNT_ID = "CNNT_ID";
                /// <summary>
                /// 헤더 순번
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 메세지
                /// </summary>
                public const string MSG = "MSG";
                /// <summary>
                /// 폰트 사이즈
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 폰트 색상
                /// </summary>
                public const string FONT_COLOR = "FONT_COLOR";
                /// <summary>
                ///줄 바꿈 여부
                /// </summary>
                public const string NEW_LINE_YN = "NEW_LINE_YN";
            }
        }
        #endregion MOT메시지 마스터

        #region 문화 마스터
        /// <summary>
        /// 문화 마스터
        /// </summary>
        public class MST_CULTURE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CULTURE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 문화 코드 
                /// </summary>
                public const string CULTURE_CD = "CULTURE_CD";
                /// <summary>
                /// 문화 명 
                /// </summary>
                public const string CULTURE_NM = "CULTURE_NM";
                /// <summary>
                /// 언어 구분 
                /// </summary>
                public const string LANG_TYPE = "LANG_TYPE";
                /// <summary>
                /// 국가 유형 
                /// </summary>
                public const string NATN_TYPE = "NATN_TYPE";
                /// <summary>
                /// 날짜 형식 
                /// </summary>
                public const string DT_PATTERN = "DT_PATTERN";
                /// <summary>
                /// 화폐 기호 
                /// </summary>
                public const string CURR_SYMBL = "CURR_SYMBL";
                /// <summary>
                /// 화폐 명 
                /// </summary>
                public const string CURR_NM = "CURR_NM";
                /// <summary>
                /// 소수점 자리 수 
                /// </summary>
                public const string DEC_PNT_DIGITS = "DEC_PNT_DIGITS";
                /// <summary>
                /// 소수점 기호 
                /// </summary>
                public const string DEC_PNT_SYMBL = "DEC_PNT_SYMBL";
                /// <summary>
                /// 그룹핑 자리 수 
                /// </summary>
                public const string GRP_DIGITS = "GRP_DIGITS";
                /// <summary>
                /// 그룹핑 기호 
                /// </summary>
                public const string GRP_SYMBL = "GRP_SYMBL";
            }
        }
        #endregion

        #region 부가메뉴 마스터
        /// <summary>
        /// 부가메뉴 마스터
        /// </summary>
        public class MST_SUBPRC_MENU
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_SUBPRC_MENU";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드 
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 중분류
                /// </summary>
                public const string M_CLSS = "M_CLSS";
                /// <summary>
                /// 일련번호 
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 부가메뉴 그룹코드 
                /// </summary>
                public const string SUBPRC_MENU_GRP_CD = "SUBPRC_MENU_GRP_CD";
                /// <summary>
                /// 부가메뉴 그룹 명 
                /// </summary>
                public const string SUBPRC_MENU_GRP_NM = "SUBPRC_MENU_GRP_NM";
                /// <summary>
                /// 선택유형
                /// </summary>
                public const string SEL_TYPE = "SEL_TYPE";
                /// <summary>
                /// 사용여부 
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 부가메뉴 그룹 마스터
        /// <summary>
        /// 부가메뉴 그룹 마스터
        /// </summary>
        public class MST_SUBPRC_MENU_GRP
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_SUBPRC_MENU_GRP";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드 
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 부가메뉴 그룹코드 
                /// </summary>
                public const string SUBPRC_MENU_GRP_CD = "SUBPRC_MENU_GRP_CD";
                /// <summary>
                /// 일련번호
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 부가메뉴 키 구분 
                /// </summary>
                public const string SUBPRC_MENU_KEY_DIV = "SUBPRC_MENU_KEY_DIV";
                /// <summary>
                /// 부가메뉴 키 코드 
                /// </summary>
                public const string SUBPRC_MENU_KEY_CD = "SUBPRC_MENU_KEY_CD";
                /// <summary>
                /// 레이블 명 
                /// </summary>
                public const string LABEL_NM = "LABEL_NM";
                /// <summary>
                /// 부가메뉴 키 값 
                /// </summary>
                public const string SUBPRC_MENU_KEY_VAL = "SUBPRC_MENU_KEY_VAL";
                /// <summary>
                /// 폰트 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 폰트 색상
                /// </summary>
                public const string FONT_COLOR = "FONT_COLOR";
                /// <summary>
                /// 업차지 금액
                /// </summary>
                public const string UP_CHARGE_AMT = "UP_CHARGE_AMT";
            }
        }
        #endregion

        #region 세트 메뉴 마스터
        /// <summary>
        /// 세트 메뉴 마스터
        /// </summary>
        public class MST_ITEM_SET
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM_SET";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드 
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 상품 코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 세트 자동구성 구분 
                /// </summary>
                public const string SET_AUTO_DIV = "SET_AUTO_DIV";
                /// <summary>
                /// 일련 번호 
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 자식 상품 구분 
                /// </summary>
                public const string SET_ITEM_DIV = "SET_ITEM_DIV";
                /// <summary>
                /// 자식 상품 코드 
                /// </summary>
                public const string SET_ITEM_CD = "SET_ITEM_CD";
                /// <summary>
                /// 자식 상품 성립수량
                /// </summary>
                public const string SET_ITEM_QTY = "SET_ITEM_QTY";
                /// <summary>
                /// 세트 그룹 명
                /// </summary>
                public const string SET_GRPNM = "SET_GRPNM";
                /// <summary>
                /// 세트 그룹 코드
                /// </summary>
                public const string SET_ITEM_GRP_CD = "SET_ITEM_GRP_CD";
            }
        }
        #endregion

        #region 세트 그룹 마스터
        /// <summary>
        /// 세트 그룹 마스터
        /// </summary>
        public class MST_ITEM_SET_GRP
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM_SET_GRP";
            public const string TABLE_NAME_CHANGE = "MST_ITEM_SET_GRP_CHANGE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드 
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 세트상품 그룹코드
                /// </summary>
                public const string SET_ITEM_GRP_CD = "SET_ITEM_GRP_CD";
                /// <summary>
                /// 일련번호 
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 메뉴 코드 
                /// </summary>
                public const string SET_ITEM_CD = "SET_ITEM_CD";
                /// <summary>
                /// 레이블 명 
                /// </summary>
                public const string LABEL_NM = "LABEL_NM";
                /// <summary>
                /// 세트메뉴 업 금액 
                /// </summary>
                public const string SET_ITEM_UP_PRC = "SET_ITEM_UP_PRC";
                /// <summary>
                /// 폰트 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 폰트 색상 
                /// </summary>
                public const string FONT_COLOR = "FONT_COLOR";
            }
        }
        #endregion

        #region 플레이버 마스터
        /// <summary>
        /// 플레이버 마스터
        /// </summary>
        public class MST_FLAVOUR
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_FLAVOUR";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드 
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 상품 코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 버튼 색상 1 
                /// </summary>
                public const string BTN_COLOR1 = "BTN_COLOR1";
                /// <summary>
                /// 버튼 색상 2
                /// </summary>
                public const string BTN_COLOR2 = "BTN_COLOR2";
                /// <summary>
                /// 폰트 색상 
                /// </summary>
                public const string FONT_COLOR = "FONT_COLOR";
                /// <summary>
                /// 폰트 크기
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 이미지 사용 여부 
                /// </summary>
                public const string IMG_USE_YN = "IMG_USE_YN";
                /// <summary>
                /// 이미지 경로 
                /// </summary>
                public const string IMG_PATH = "IMG_PATH";
                /// <summary>
                /// 상품 위치 
                /// </summary>
                public const string ITEM_LOC = "ITEM_LOC";
                /// <summary>
                /// 사용여부 
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 상품명
                /// </summary>
                public const string SHTCUT_ITEMNM = "SHTCUT_ITEMNM";
            }
        }
        #endregion

        #region 캠페인 마스터
        /// <summary>
        /// 캠페인 마스터
        /// </summary>
        public class MST_CPI
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPI";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 캠페인명 
                /// </summary>
                public const string CPI_NM = "CPI_NM";
                /// <summary>
                /// 시작일 
                /// </summary>
                public const string STARTDAY = "STARTDAY";
                /// <summary>
                /// 종료일
                /// </summary>
                public const string FNSHDAY = "FNSHDAY";
                /// <summary>
                /// 반복 여부
                /// </summary>
                public const string REPT_YN = "REPT_YN";
                /// <summary>
                /// 반복 형태(1:매주, 2:매월지정일)
                /// </summary>
                public const string REPT_APPNT_TYPE = "REPT_APPNT_TYPE";
                /// <summary>
                /// 반복 주차(11111=>1:1주차, 2:2주차, 3:3주차, 4:4주차, 5:5주차) 
                /// </summary>
                public const string REPT_WEEK = "REPT_WEEK";
                /// <summary>
                /// 반복 일자 
                /// </summary>
                public const string REPT_DT = "REPT_DT";
                /// <summary>
                /// 캠페인 중복적용 여부 
                /// </summary>
                public const string DUP_APPLY_YN = "DUP_APPLY_YN";
                /// <summary>
                /// 기본룰 예외 여부 
                /// </summary>
                public const string BASIC_RULE_EXCEP_YN = "BASIC_RULE_EXCEP_YN";

                //#20171206 17크리스마스캠페인 start
                //항목 추가 (0:중복적용불가, 1:중복적용가능, 2: 중복적용가능(할인금액포함))
                /// <summary>
                /// 제휴할인그룹 중복 여부(1:중복적용가능, 0:중복적용불가, 2: 중복적용가능(할인금액포함))
                /// </summary>
                public const string TELECOM_COOP_DUP_PRMT_YN = "TELECOM_COOP_DUP_PRMT_YN";
                //#20171206 17크리스마스캠페인 end

                //#15583 캠페인 기능 개선 요청 start
                /// <summary>
                /// 모바일쿠폰 그룹 중복 여부(1:중복적용가능, 0:중복적용불가)
                /// </summary>
                public const string MOBILE_CPN_DUP_PRMT_YN = "MOBILE_CPN_DUP_PRMT_YN";

                /// <summary>
                /// 해피쿠폰 중복 여부(1:중복적용가능, 0:중복적용불가)
                /// </summary>
                public const string HPY_CPN_DUP_PRMT_YN = "HPY_CPN_DUP_PRMT_YN";
                //#15583 캠페인 기능 개선 요청 end

                ///// <summary>
                ///// 쿠폰할인그룹 중복 여부 
                ///// </summary>
                //public const string CPNDC_GRP_DUP_YN = "CPNDC_GRP_DUP_YN";
                ///// <summary>
                ///// 일반할인그룹 중복 여부 
                ///// </summary>
                //public const string GNRL_DC_GRP_DUP_YN = "GNRL_DC_GRP_DUP_YN";
                /// <summary>
                /// 우선순위 
                /// </summary>
                public const string PRIOR = "PRIOR";
                /// <summary>
                /// 캠페인 대상 고객유형 
                /// </summary>
                public const string TRGT_CUST_TYPE = "TRGT_CUST_TYPE";
                /// <summary>
                /// 캠페인고객혜택
                /// </summary>
                public const string CPI_CUST_BNFT_TYPE = "CPI_CUST_BNFT_TYPE";
                /// <summary>
                /// 상품 적용 방법
                /// </summary>
                public const string ITEM_APPLY_METHD = "ITEM_APPLY_METHD";
                /// <summary>
                /// 고객결제유형(00:일반, 01:신용카드, 02:캐시비, 03:티머니)
                /// </summary>
                public const string CUST_PAY_TYPE = "CUST_PAY_TYPE";
                /// <summary>
                /// 캠페인성립금액 구분(1:구매금액(총매출), 2:대상상품, 3:구매금액+대상상품) 
                /// </summary>
                public const string TRGT_AMT_TYPE = "TRGT_AMT_TYPE";
                /// <summary>
                /// 캠페인성립금액 
                /// </summary>
                public const string TRGT_AMT = "TRGT_AMT";
                /// <summary>
                /// 수량제한 여부
                /// </summary>
                public const string QTY_LMT_YN = "QTY_LMT_YN";
                /// <summary>
                /// 제한수량
                /// </summary>
                public const string LMT_QTY = "LMT_QTY";
                /// <summary>
                /// 수량제한 기준(1:일별, 2:행사기간별)
                /// </summary>
                public const string QTY_LMT_STD = "QTY_LMT_STD";
                /// <summary>
                /// HP고객 최대 참여 제한여부 
                /// </summary>
                public const string HP_CUST_JOIN_LMT_YN = "HP_CUST_JOIN_LMT_YN";
                /// <summary>
                /// HP고객 최대 참여 횟수 
                /// </summary>
                public const string HP_CUST_MAX_JOIN_CNT = "HP_CUST_MAX_JOIN_CNT";
                /// <summary>
                /// HP고객 참여 제한 기준(1:일별, 2:행사기간별) 
                /// </summary>
                public const string HP_CUST_JOIN_LMT_STD = "HP_CUST_JOIN_LMT_STD";
                /// <summary>
                /// HPC기본적립 여부
                /// </summary>
                public const string BASIC_HP_ACCUM_YN = "BASIC_HP_ACCUM_YN";
                /// <summary>
                /// HPC기본적립 구분(0:적립안함,1:적립함,2:행사 상품 제외)
                /// </summary>
                public const string BASIC_HP_ACCUM_STD = "BASIC_HP_ACCUM_STD";
                /// <summary>
                /// HPC추가적립 통신사구분(0: 일반, 1: SKT, 2: KT,3: LGT)
                /// </summary>
                public const string ADD_HP_ACCUM_TELECOM_DIV = "ADD_HP_ACCUM_TELECOM_DIV";
                /// <summary>
                /// HPC추가적립 대상기준(0:적립없음, 1:BILL전체, 2:대상상품, 3:행사대상외 구매상품) 
                /// </summary>
                public const string ADD_HP_ACCUM_TRGT_STD = "ADD_HP_ACCUM_TRGT_STD";
                /// <summary>
                /// HPC추가적립 율 
                /// </summary>
                public const string ADD_HP_ACCUM_RATE = "ADD_HP_ACCUM_RATE";
                /// <summary>
                /// HPC추가적립 추후적립 가능여부 
                /// </summary>
                public const string ADD_HP_ACCUM_AF_DIV = "ADD_HP_ACCUM_AF_DIV";
                /// <summary>
                /// HPC추가적립 코드1
                /// </summary>
                public const string ADD_HP_ACCUM_CD1 = "ADD_HP_ACCUM_CD1";
                /// <summary>
                /// HPC추가적립 코드2 
                /// </summary>
                public const string ADD_HP_ACCUM_CD2 = "ADD_HP_ACCUM_CD2";
                /// <summary>
                /// OFFER ID(스템프 행사시 클라우드 전송)
                /// </summary>
                public const string OFFER_ID = "OFFER_ID";
                /// <summary>
                /// 사은품 지급기준(0:대상 아님, 1:금액당 개수, 2:최소금액 이상 개수) 
                /// </summary>
                public const string FREE_GIFT_PROVD_STD = "FREE_GIFT_PROVD_STD";
                /// <summary>
                /// 사은품 지급기준 금액 
                /// </summary>
                public const string FREE_GIFT_STD_AMT = "FREE_GIFT_STD_AMT";
                /// <summary>
                /// 사은품 지급수량 
                /// </summary>
                public const string FREE_GIFT_PROVD_QTY = "FREE_GIFT_PROVD_QTY";
                /// <summary>
                /// 사은품 추가판매 여부(1:가능, 0:불가) 
                /// </summary>
                public const string FREE_GIFT_ADD_SALE_YN = "FREE_GIFT_ADD_SALE_YN";
                /// <summary>
                /// 캠페인 설명 
                /// </summary>
                public const string CPI_EXPLN = "CPI_EXPLN";
                /// <summary>
                /// 고객면 리소스 파일 구분(1:이미지, 2:동영상) 
                /// </summary>
                public const string CUST_DSP_FILE_DIV = "CUST_DSP_FILE_DIV";
                /// <summary>
                /// 고객면 리소스 파일명 
                /// </summary>
                public const string CUST_DSP_FILENM = "CUST_DSP_FILENM";
                /// <summary>
                /// 스템프수량
                /// </summary>
                public const string STAMP_QTY = "STAMP_QTY";
                /// <summary>
                /// 사운드파일구분(00(없음), 01(WAVE), 02(TTS))
                /// </summary>
                public const string SOUND_FILE_DIV = "SOUND_FILE_DIV";
                /// <summary>
                /// 사운드파일명
                /// </summary>
                public const string SOUND_FILE_NM = "SOUND_FILE_NM";
                /// <summary>
                /// TTS 출력문구
                /// </summary>
                public const string TTS_DSCRP = "TTS_DSCRP";
                /// <summary>
                /// 사운드파일 플레이 시점
                /// </summary>
                public const string SOUND_FILE_PLAY_CHK_PNT = "SOUND_FILE_PLAY_CHK_PNT";
                /// <summary>
                /// 참여문의여부
                /// </summary>
                public const string JOIN_QUSTN_YN = "JOIN_QUSTN_YN";
                /// <summary>
                /// 상품 중복 허용 여부
                /// </summary>
                public const string ITEM_DUP_PRMT_YN = "ITEM_DUP_PRMT_YN";
                /// <summary>
                /// 복권 멀티 출력 여부
                /// </summary>
                public const string LTTR_MULTI_PRT_YN = "LTTR_MULTI_PRT_YN";
                /// <summary>
                /// 캠페인 할인 결제 수단
                /// </summary>
                public const string CPI_DC_PAY_WAY = "CPI_DC_PAY_WAY";
                /// <summary>
                /// 캠페인 영수증명
                /// </summary>
                public const string CPI_BILL_NM = "CPI_BILL_NM";
                /// <summary>
                /// 캠페인 수량제한메시지
                /// </summary>
                public const string QTY_LIMIT_MSG = "QTY_LIMIT_MSG";
                /// <summary>
                /// 해피 고객 등급
                /// </summary>
                public const string HP_CUST_LVL = "HP_CUST_LVL";
                /// <summary>
                /// 할인불가적용여부(0:할인불가미적용, 1:할인불가적용)
                /// </summary>
                public const string DC_NOADM_PASS_YN = "DC_NOADM_PASS_YN";
            }
        }
        #endregion

        #region 캠페인 시간 마스터
        /// <summary>
        /// 캠페인 시간 마스터
        /// </summary>
        public class MST_CPI_HOUR
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPI_HOUR";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 요일 구분(1:일요일, 2:월요일 ~ 7:토요일)  
                /// </summary>
                public const string DOW_DIV = "DOW_DIV";
                /// <summary>
                /// 시작 시간 
                /// </summary>
                public const string START_HOUR = "START_HOUR";
                /// <summary>
                /// 종료 시간 
                /// </summary>
                public const string FNSH_HOUR = "FNSH_HOUR";
            }
        }
        #endregion

        #region 캠페인 구성 마스터
        /// <summary>
        /// 캠페인 구성 마스터
        /// </summary>
        public class MST_CPI_COMPNT
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPI_COMPNT";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 캠페인상품그룹
                /// </summary>
                public const string CPI_ITEM_GRP_CD = "CPI_ITEM_GRP_CD";
                /// <summary>
                /// 캠페인조건유형(1:수량, 2:금액, 3:최소수량)
                /// </summary>
                public const string CPI_COND_TYPE = "CPI_COND_TYPE";
                /// <summary>
                /// 조건 수량 금액
                /// </summary>
                public const string QTY_AMT = "QTY_AMT";
                /// <summary>
                /// 구성 할인유형(1:율, 2:금액)
                /// </summary>
                public const string CPI_DC_TYPE = "CPI_DC_TYPE";
                /// <summary>
                /// 구성 할인 율,금액
                /// </summary>
                public const string DC_RATE_QTY_AMT = "DC_RATE_QTY_AMT";
                /// <summary>
                /// 할인 최대 금액
                /// </summary>
                public const string DC_MAX_AMT = "DC_MAX_AMT";
            }
        }
        #endregion

        #region 캠페인 상품 마스터
        /// <summary>
        /// 캠페인 상품 마스터
        /// </summary>
        public class MST_CPI_ITEM
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPI_ITEM";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// SUB 점포 코드
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 상품구성그룹 
                /// </summary>
                public const string CPI_ITEM_GRP_CD = "CPI_ITEM_GRP_CD";
                /// <summary>
                /// 상품 레벨(1:상품, 2:소분류, 3 중분류, 4:대분류)
                /// </summary>
                public const string ITEM_LVL = "ITEM_LVL";
                /// <summary>
                /// 상품 코드 
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 캠페인 할인 구분 
                /// </summary>
                public const string CPI_DC_TYPE = "CPI_DC_TYPE";
                /// <summary>
                /// 캠페인 할인 율,금액 
                /// </summary>
                public const string DC_RATE_AMT = "DC_RATE_AMT";
            }
        }
        #endregion

        #region 캠페인 출력메시지 마스터
        /// <summary>
        /// 캠페인 출력메시지 마스터
        /// </summary>
        public class MST_CPI_PRT_MSG
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPI_PRT_MSG";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 출력 위치
                /// </summary>
                public const string CPI_BILL_PRT_AREA_TYPE = "CPI_BILL_PRT_AREA_TYPE";
                /// <summary>
                /// 출력 순번
                /// </summary>
                public const string PRT_SEQ = "PRT_SEQ";
                /// <summary>
                /// 출력 구분 
                /// </summary>
                public const string PRT_DIV = "PRT_DIV";
                /// <summary>
                /// 확대 문자 
                /// </summary>
                public const string PRT_EXPAND_TYPE = "PRT_EXPAND_TYPE";
                /// <summary>
                /// BOLD 여부(0:보통, 1:BOLD)
                /// </summary>
                public const string BOLD_YN = "BOLD_YN";
                /// <summary>
                /// 정렬 유형(1:오른쪽, 2:가운데, 3:왼쪽)
                /// </summary>
                public const string ALIGN_TYPE = "ALIGN_TYPE"; 
                /// <summary>
                /// 출력문자열 
                /// </summary>
                public const string MSG_VAL = "MSG_VAL";
            }
        }
        #endregion

        #region 캠페인 복권 출력메시지 마스터
        /// <summary>
        /// 캠페인 출력메시지 마스터
        /// </summary>
        public class MST_CPI_LTTR_PRT
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPI_LTTR_PRT";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 등수
                /// </summary>
                public const string GRADE = "GRADE";
                /// <summary>
                /// 출력 순번
                /// </summary>
                public const string PRT_SEQ = "PRT_SEQ";
                /// <summary>
                /// 출력문자열 
                /// </summary>
                public const string MSG_VAL = "MSG_VAL";
                /// <summary>
                /// 확대 문자(0:보통, 1:굵게, 2:가로확대, 3:세로확대, 4:전체확대) 
                /// </summary>
                public const string PRT_EXPAND_TYPE = "PRT_EXPAND_TYPE";
                /// <summary>
                /// BOLD 여부(0:보통, 1:BOLD)
                /// </summary>
                public const string BOLD_YN = "BOLD_YN";
                /// <summary>
                /// 정렬 유형(1:오른쪽, 2:가운데, 3:왼쪽)
                /// </summary>
                public const string ALIGN_TYPE = "ALIGN_TYPE"; 
            }
        }
        #endregion

        #region 캠페인 카드 마스터
        /// <summary>
        /// 캠페인 카드 마스터
        /// </summary>
        public class MST_CPI_CARD
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPI_CARD";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 캠페인 코드
                /// </summary>
                public const string CPI_CD = "CPI_CD";
                /// <summary>
                /// 카드PREFIX 
                /// </summary>
                public const string CARD_PRFX_CD = "CARD_PRFX_CD";
                /// <summary>
                /// 위치
                /// </summary>
                public const string LOC = "LOC";
                /// <summary>
                /// 체크값
                /// </summary>
                public const string CHECK_VAL = "CHECK_VAL";
            }
        }
        #endregion

        #region 상품권/선불카드 마스터
        /// <summary>
        /// 상품권/선불카드
        /// </summary>
        public class MST_GIFT_PREPAID
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME_GIFT = "MST_GIFT";
            public const string TABLE_NAME_PREPAID = "MST_PREPAID";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드 
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 상품 코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 일련 번호 
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 상품명
                /// </summary>
                public const string ITEM_NM = "ITEM_NM";
            }
        }
        #endregion

        #region 마스터 결제 할인
        /// <summary>
        /// 마스터 결제 할인
        /// </summary>
        public class MST_PAY_DC
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PAY_DC";
            public const string TABLE_NAME_GROUPBY = "MST_PAY_DC_GROUPBY";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 결제 할인 그룹 유형
                /// </summary>
                public const string PAY_DC_GRP_TYPE = "PAY_DC_GRP_TYPE";
                /// <summary>
                /// 결제 할인 코드
                /// </summary>
                public const string PAY_DC_CD = "PAY_DC_CD";
                /// <summary>
                /// 결제 할인 명
                /// </summary>
                public const string PAY_DC_NM = "PAY_DC_NM";
                /// <summary>
                /// ERP 연결 코드
                /// </summary>
                public const string ERP_CNNT_CD = "ERP_CNNT_CD";
                /// <summary>
                /// 결제 할인 유형(1:결제, 2:할인)
                /// </summary>
                public const string PAY_DC_TYPE = "PAY_DC_TYPE";
                /// <summary>
                /// 승인 업체 코드
                /// </summary>
                public const string APPR_VEND_CD = "APPR_VEND_CD";
                /// <summary>
                /// 현금 영수증 발행 여부
                /// </summary>
                public const string CASH_BILL_ISSUE_YN = "CASH_BILL_ISSUE_YN";
                /// <summary>
                /// 잔액 교환권 출력 여부
                /// </summary>
                public const string BLNC_AMT_EXCHNG_CPN_PRT_YN = "BLNC_AMT_EXCHNG_CPN_PRT_YN";
                /// <summary>
                /// 연결 상품 체크 여부
                /// </summary>
                public const string CNNT_ITEM_CHECK_YN = "CNNT_ITEM_CHECK_YN";
                /// <summary>
                /// 제휴사 연결 여부
                /// </summary>
                public const string COOP_CMP_CNNT_YN = "COOP_CMP_CNNT_YN";
                /// <summary>
                /// 정산 대상 여부
                /// </summary>
                public const string ADMT_TRGT_YN = "ADMT_TRGT_YN";
                /// <summary>
                /// 자사 여부
                /// </summary>
                public const string OWN_YN = "OWN_YN";
                /// <summary>
                /// PREFIX 대상 여부
                /// </summary>
                public const string PRFX_TRGT_YN = "PRFX_TRGT_YN";
                /// <summary>
                /// 결제 할인 방법(1:율,2:금액)
                /// </summary>
                public const string PAY_DC_METHD = "PAY_DC_METHD";
                /// <summary>
                /// 결제 할인 값
                /// </summary>
                public const string PAY_DC_VAL = "PAY_DC_VAL";
                /// <summary>
                /// 할인 적용 대상(1:전체, 2:특정상품)
                /// </summary>
                public const string DC_APPLY_TRGT = "DC_APPLY_TRGT";
                /// <summary>
                /// HP 기본 적립 여부(0:불가, 1:가능, 2:제외)
                /// </summary>
                public const string HP_BASIC_ACCUM_YN = "HP_BASIC_ACCUM_YN";
                /// <summary>
                /// 할인 대상 금액 유형(0:대상아님,1:총액,2:결제금액)
                /// </summary>
                public const string DC_TRGT_AMT_TYPE = "DC_TRGT_AMT_TYPE";
                /// <summary>
                /// 캠페인 중복 여부
                /// </summary>
                public const string CPI_DUP_YN = "CPI_DUP_YN";
                /// <summary>
                /// 할인 통신사 중복 여부
                /// </summary>
                public const string DC_TELECOM_DUP_YN = "DC_TELECOM_DUP_YN";
                /// <summary>
                /// 할인 포인트 중복 여부
                /// </summary>
                public const string DC_POINT_DUP_YN = "DC_POINT_DUP_YN";
                /// <summary>
                /// 할인 쿠폰 중복 여부
                /// </summary>
                public const string DC_CPN_DUP_YN = "DC_CPN_DUP_YN";
                /// <summary>
                /// 할인 직원 할인 중복 여부
                /// </summary>
                public const string DC_EMP_DC_DUP_YN = "DC_EMP_DC_DUP_YN";
                /// <summary>
                /// 할인 일반 중복 여부
                /// </summary>
                public const string DC_GNRL_DUP_YN = "DC_GNRL_DUP_YN";
                /// <summary>
                /// 결제 일반 중복 여부
                /// </summary>
                public const string PAY_GNRL_DUP_YN = "PAY_GNRL_DUP_YN";
                /// <summary>
                /// 결제 모바일 중복 여부
                /// </summary>
                public const string PAY_MOBILE_DUP_YN = "PAY_MOBILE_DUP_YN";
                /// <summary>
                /// 결제 포인트 중복 여부
                /// </summary>
                public const string PAY_POINT_DUP_YN = "PAY_POINT_DUP_YN";
                /// <summary>
                /// 판매 POS 출력 순서
                /// </summary>
                public const string SALE_POS_PRT_QUE = "SALE_POS_PRT_QUE";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// HP 추가적립 대상 구분(0:불가, 1:가능, 2:제외)
                /// </summary>
                public const string HP_ADD_ACCUM_DIV = "HP_ADD_ACCUM_DIV";
                /// <summary>
                /// 통신사 할인 대상 구분(0:불가, 1:가능, 2:제외)
                /// </summary>
                public const string MOBILE_DC_DIV = "MOBILE_DC_DIV";
            }
        }
        #endregion

        #region 마스터 결제 할인 쿠폰
        /// <summary>
        /// 마스터 결제 할인 쿠폰
        /// </summary>
        public class MST_PAY_DC_CPN
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PAY_DC_CPN";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 모바일 쿠폰 관리 번호
                /// </summary>
                public const string MOBILE_CPN_MNG_NO = "MOBILE_CPN_MNG_NO";
                /// <summary>
                /// PRODUCT 코드
                /// </summary>
                public const string PRODUCT_CD = "PRODUCT_CD";
                /// <summary>
                /// 결제 할인 그룹 유형
                /// </summary>
                public const string PAY_DC_GRP_TYPE = "PAY_DC_GRP_TYPE";
                /// <summary>
                /// 결제 할인 코드
                /// </summary>
                public const string PAY_DC_CD = "PAY_DC_CD";
                /// <summary>
                /// ERP 연결 코드
                /// </summary>
                public const string ERP_CNNT_CD = "ERP_CNNT_CD";
                /// <summary>
                /// 판매 시작 일자
                /// </summary>
                public const string SALE_START_DT = "SALE_START_DT";
                /// <summary>
                /// 판매 종료 일자
                /// </summary>
                public const string SALE_FNSH_DT = "SALE_FNSH_DT";
                /// <summary>
                /// 영업 조직 코드
                /// </summary>
                public const string SALES_ORG_CD = "SALES_ORG_CD";
                /// <summary>
                /// 설명
                /// </summary>
                public const string EXPLN = "EXPLN";
                /// <summary>
                /// 본사 부담율
                /// </summary>
                public const string HQ_ALLOT_RATE = "HQ_ALLOT_RATE";
                /// <summary>
                /// 점포 부담율
                /// </summary>
                public const string STOR_ALLOT_RATE = "STOR_ALLOT_RATE";
                /// <summary>
                /// 제휴사 부담율
                /// </summary>
                public const string COOP_CMP_ALLOT_RATE = "COOP_CMP_ALLOT_RATE";
                /// <summary>
                /// 소수점 계산 방법(1:올림, 2:반올림, 3:버림)
                /// </summary>
                public const string DEC_PNT_CALC_METHD = "DEC_PNT_CALC_METHD";
                /// <summary>
                /// 계산 소수점 자릿수
                /// </summary>
                public const string CALC_DEC_PNT_DIGT_NO = "CALC_DEC_PNT_DIGT_NO";
                /// <summary>
                /// 상품 체크 여부
                /// </summary>
                public const string ITEM_CHECK_YN = "ITEM_CHECK_YN";
                /// <summary>
                /// PREFIX 정보
                /// </summary>
                public const string PRFX_INFO = "PRFX_INFO";
                /// <summary>
                /// 매수 제한 여부
                /// </summary>
                public const string SHEETCNT_LMT_YN = "SHEETCNT_LMT_YN";
                /// <summary>
                /// 제한 수량
                /// </summary>
                public const string LMT_QTY = "LMT_QTY";
                /// <summary>
                /// 유효 기간 일수
                /// </summary>
                public const string VALID_TERM_NOD = "VALID_TERM_NOD";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 마스터 결제 할인 쿠폰 상품
        /// <summary>
        /// 마스터 결제 할인 쿠폰 상품
        /// </summary>
        public class MST_PAY_DC_CPN_ITEM
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PAY_DC_CPN_ITEM";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 모바일 쿠폰 관리 번호
                /// </summary>
                public const string MOBILE_CPN_MNG_NO = "MOBILE_CPN_MNG_NO";
                /// <summary>
                /// 상품 코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 수량
                /// </summary>
                public const string QTY = "QTY";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 마스터 기간 제휴사 할인 상품
        /// <summary>
        /// 마스터 기간 제휴사 할인 상품
        /// </summary>
        public class MST_TERM_COOP_CMP_DC_ITEM
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_TERM_COOP_CMP_DC_ITEM";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 결제 할인 그룹 유형
                /// </summary>
                public const string PAY_DC_GRP_TYPE = "PAY_DC_GRP_TYPE";
                /// <summary>
                /// 결제 할인 코드
                /// </summary>
                public const string PAY_DC_CD = "PAY_DC_CD";
                /// <summary>
                /// 제휴사 등급 코드
                /// </summary>
                public const string COOP_CMP_GRADE_CD = "COOP_CMP_GRADE_CD";
                /// <summary>
                /// 시작 일자
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 상품 코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 마스터 기간 제휴사 결제 할인
        /// <summary>
        /// 마스터 기간 제휴사 결제 할인
        /// </summary>
        public class MST_TERM_COOP_CMP_PAY_DC
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_TERM_COOP_CMP_PAY_DC";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 결제 할인 그룹 유형
                /// </summary>
                public const string PAY_DC_GRP_TYPE = "PAY_DC_GRP_TYPE";
                /// <summary>
                /// 결제 할인 코드
                /// </summary>
                public const string PAY_DC_CD = "PAY_DC_CD";
                /// <summary>
                /// 제휴사 등급 코드
                /// </summary>
                public const string COOP_CMP_GRADE_CD = "COOP_CMP_GRADE_CD";
                /// <summary>
                /// 시작 일자
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 종료 일자
                /// </summary>
                public const string FNSH_DT = "FNSH_DT";
                /// <summary>
                /// 할인 적용 대상(1:전체, 2:특정상품)
                /// </summary>
                public const string DC_APPLY_TRGT = "DC_APPLY_TRGT";
                /// <summary>
                /// 결제 할인 방법(1:율,2:금액)
                /// </summary>
                public const string PAY_DC_METHD = "PAY_DC_METHD";
                /// <summary>
                /// 결제 할인 값
                /// </summary>
                public const string PAY_DC_VAL = "PAY_DC_VAL";
                /// <summary>
                /// 결제 할인 금액 기준 결제 금액
                /// </summary>
                public const string PAY_DC_AMT_STD_PAY_AMT = "PAY_DC_AMT_STD_PAY_AMT";
                /// <summary>
                /// 결제 할인 소수점 계산 방법(1:올림, 2:반올림, 3:버림)
                /// </summary>
                public const string PAY_DC_DEC_PNT_CALC_METHD = "PAY_DC_DEC_PNT_CALC_METHD";
                /// <summary>
                /// 결제 할인 계산 자릿수
                /// </summary>
                public const string PAY_DC_CALC_DIGT_NO = "PAY_DC_CALC_DIGT_NO";
            }
        }
        #endregion

        #region VAN 마스터
        /// <summary>
        /// VAN 마스터
        /// </summary>
        public class MST_VAN
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_VAN";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string SOTR_CD = "SOTR_CD";
                /// <summary>
                /// VAN코드
                /// </summary>
                public const string APPR_VEND_CD = "APPR_VEND_CD";
                /// <summary>
                /// IP
                /// </summary>
                public const string IP = "IP";
                /// <summary>
                /// PORT
                /// </summary>
                public const string PORT = "PORT";
                /// <summary>
                /// 회사 승인 ID 
                /// </summary>
                public const string CMP_APPR_ID = "CMP_APPR_ID";
                /// <summary>
                /// 회사 승인패스워드 
                /// </summary>
                public const string CMP_APPR_PWD = "CMP_APPR_PWD";
                /// <summary>
                /// 홈페이지
                /// </summary>
                public const string HOME_PAGE = "HOME_PAGE";
                /// <summary>
                /// 승인ID 
                /// </summary>
                public const string APPR_ID = "APPR_ID";
                /// <summary>
                /// 승인패스워드 
                /// </summary>
                public const string APPR_PWD = "APPR_PWD";
                /// <summary>
                /// FILLER1 (아워홈 DB 스키마)
                /// </summary>
                public const string FILLER1 = "FILLER1";
                /// <summary>
                /// FILLER2
                /// </summary>
                public const string FILLER2 = "FILLER2";
                /// <summary>
                /// FILLER3
                /// </summary>
                public const string FILLER3 = "FILLER3";
                /// <summary>
                /// FILLER4
                /// </summary>
                public const string FILLER4 = "FILLER4";
                /// <summary>
                /// FILLER5
                /// </summary>
                public const string FILLER5 = "FILLER5";
                /// <summary>
                /// MSR PORT
                /// </summary>
                public const string MSR_PORT = "MSR_PORT";
            }
        }
        #endregion

        #region 카드 프리픽스 마스터
        /// <summary>
        /// 카드 프리픽스 마스터
        /// </summary>
        public class MST_CARD_PREFIX
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CARD_PREFIX";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 프리픽스코드
                /// </summary>
                public const string PRFX_CD = "PRFX_CD";
                /// <summary>
                /// 카드구분(B:현대오일뱅크, C:신용카드, H:HP, L:LG, S:SK)
                /// </summary>
                public const string CARD_DIV = "CARD_DIV";
                /// <summary>
                /// 프리픽스명
                /// </summary>
                public const string PRFX_NM = "PRFX_NM";
                /// <summary>
                /// 카드사코드
                /// </summary>
                public const string CARD_CMP_CD = "CARD_CMP_CD";
                /// <summary>
                /// 위치
                /// </summary>
                public const string LOC = "LOC";
                /// <summary>
                /// 체크값
                /// </summary>
                public const string CHECK_VAL = "CHECK_VAL";
                /// <summary>
                /// 은행코드(공통코드 M0021)
                /// </summary>
                public const string BANK_CD = "BANK_CD";
                /// <summary>
                /// 제휴카드구분(공통코드 M0087)
                /// </summary>
                public const string COOP_CARD_DIV = "COOP_CARD_DIV";
            }
        }
        #endregion

        #region 쿠폰할인 키 마스터
        /// <summary>
        /// 쿠폰할인 키 마스터
        /// </summary>
        public class MST_COUPON_DC_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CMM";

            public class DATA
            {
                /// <summary>
                /// SEQ
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const string BRAN_CD = "BRAND_CD";
                /// <summary>
                /// 쿠폰코드 
                /// </summary>
                public const string CPN_DC_CD = "CPN_DC_CD";
                /// <summary>
                /// 쿠폰명
                /// </summary>
                public const string CPN_DC_NM = "CPN_DC_NM";
                /// <summary>
                /// 쿠폰구분
                /// </summary>
                public const string CPN_TYPE = "CPN_TYPE";
                /// <summary>
                /// 할인율 
                /// </summary>
                public const string DC_RATE = "DC_RATE";                
                /// <summary>
                /// FONT 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
                /// <summary>
                /// 버튼 크기 
                /// </summary>
                public const string BTN_SIZE = "BTN_SIZE";
                /// <summary>
                /// 이미지 
                /// </summary>
                public const string BTN_ITEM_IMG = "BTN_ITEM_IMG";
            }
        }
        #endregion

        #region 식권 키 마스터
        /// <summary>
        /// 식권 키 마스터
        /// </summary>
        public class MST_MEALTICKET_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_MEAL_TCKT";

            public class DATA
            {
                /// <summary>
                /// SEQ
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const string BRAN_CD = "BRAND_CD";
                /// <summary>
                /// 식권번호 
                /// </summary>
                public const string MEALTICKET_CD = "MEALTICKET_CD";
                /// <summary>
                /// 식권명칭
                /// </summary>
                public const string MEALTICKET_NM = "MEALTICKET_NM";
                /// <summary>
                /// 식권구분 (잔액교환권 가능여부)
                /// </summary>
                public const string MEALTICKET_TYPE = "MEALTICKET_TYPE";
                /// <summary>
                /// 식권금액 
                /// </summary>
                public const string MEALTICKET_AMOUNT = "MEALTICKET_AMOUNT"; 
                /// <summary>
                /// FONT 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
                /// <summary>
                /// 버튼 크기 
                /// </summary>
                public const string BTN_SIZE = "BTN_SIZE";
                /// <summary>
                /// 이미지 
                /// </summary>
                public const string BTN_ITEM_IMG = "BTN_ITEM_IMG";
                /// <summary>
                /// 거스름 가능 여부
                /// </summary>
                public const string CHANGE_PAYMNT_YN = "CHANGE_PAYMNT_YN";
                /// <summary>
                /// 필수입력 여부
                /// </summary>
                public const string NO_INPUT_YN = "NO_INPUT_YN";
            }
        }
        #endregion

        #region 상품권 키 마스터
        /// <summary>
        /// 상품권 키 마스터
        /// </summary>
        public class MST_GIFT_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_GIFT";

            public class DATA
            {
                /// <summary>
                /// SEQ
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 브랜드코드
                /// </summary>
                public const string BRAN_CD = "BRAND_CD";
                /// <summary>
                /// 상품권번호
                /// </summary>
                public const string GIFT_CD = "GIFT_CD";
                /// <summary>
                /// 상품권명
                /// </summary>
                public const string GIFT_NM = "GIFT_NM";
                /// <summary>
                /// 승인서버 구분
                /// </summary>
                public const string APPR_SVR_DIV = "APPR_SVR_DIV";                
                /// <summary>
                /// 승인구분
                /// </summary>
                public const string APPR_TYPE = "APPR_TYPE";
                /// <summary>
                /// 해피포인트카드 적립 여부
                /// </summary>
                public const string HPPOINT_TYPE = "HPPOINT_TYPE";
                /// <summary>
                /// 필수 입력 여부
                /// </summary>
                public const string MNDTRY_INPUT_YN = "MNDTRY_INPUT_YN";                
                /// <summary>
                /// 상품권금액
                /// </summary>
                public const string GIFT_AMT = "GIFT_AMT";
                /// <summary>
                /// FONT 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
                /// <summary>
                /// 버튼 크기 
                /// </summary>
                public const string BTN_SIZE = "BTN_SIZE";
                /// <summary>
                /// 이미지 
                /// </summary>
                public const string BTN_ITEM_IMG = "BTN_ITEM_IMG";
                /// <summary>
                /// 해피머니 상품권 여부
                /// </summary>
                public const string HPY_GIF_DIV = "HPY_GIF_DIV";
                /// <summary>
                /// 거스름 지불 여부 (1:지급, 0:미지급)
                /// </summary>
                public const string CHANGE_PAYMNT_YN = "CHANGE_PAYMNT_YN";
            }
        }
        #endregion

        #region 상품조회 조건 금액 마스터
        /// <summary>
        /// 상품조회 조건 금액 마스터
        /// </summary>
        public class MST_PLU_AMT
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PLU_AMT";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 표시순번
                /// </summary>
                public const string PLU_SEQ = "PLU_SEQ";
                /// <summary>
                /// 표시명
                /// </summary>
                public const string PLU_AMT_NM = "PLU_AMT_NM";
                /// <summary>
                /// ????
                /// </summary>
                public const string P_POSITION = "P_POSITION";
                /// <summary>
                /// 시작금액
                /// </summary>
                public const string FROM_AMT = "FROM_AMT";
                /// <summary>
                /// 끝금액
                /// </summary>
                public const string TO_AMT = "TO_AMT";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 상품조회 조건 이름 마스터
        /// <summary>
        /// 상품조회 조건 이름 마스터
        /// </summary>
        public class MST_PLU_NM
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PLU_NM";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 키모드(한글,영문,숫자)
                /// </summary>
                public const string KEY_MODE = "KEY_MODE";
                /// <summary>
                /// 표시순번
                /// </summary>
                public const string PLU_SEQ = "PLU_SEQ";
                /// <summary>
                /// 표시명
                /// </summary>
                public const string PLU_NM = "PLU_NM";
                /// <summary>
                /// ????
                /// </summary>
                public const string P_POSITION = "P_POSITION";
                /// <summary>
                /// 시작키 1
                /// </summary>
                public const string PLU_1_FR = "PLU_1_FR";
                /// <summary>
                /// 끝키 1
                /// </summary>
                public const string PLU_1_TO = "PLU_1_TO";
                /// <summary>
                /// 시작키 2
                /// </summary>
                public const string PLU_2_FR = "PLU_2_FR";
                /// <summary>
                /// 끝키 2
                /// </summary>
                public const string PLU_2_TO = "PLU_2_TO";
                /// <summary>
                /// 시작키 3
                /// </summary>
                public const string PLU_3_FR = "PLU_3_FR";
                /// <summary>
                /// 끝키 3
                /// </summary>
                public const string PLU_3_TO = "PLU_3_TO";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 상품조회 데이터
        /// <summary>
        /// 상품조회 데이터
        /// </summary>
        public class MST_ITEM_SEARCH
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_ITEM_SEARCH";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// SUB 점포 코드 
                /// </summary>
                public const string SUB_STOR_CD = "SUB_STOR_CD";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 상품코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 메뉴명
                /// </summary>
                public const string SHTCUT_ITEMNM = "SHTCUT_ITEMNM";
                /// <summary>
                /// TAKE IN 금액
                /// </summary>
                public const string TAKE_IN_SALE_AMT = "TAKE_IN_SALE_AMT";
                /// <summary>
                /// TAKE OUT 금액
                /// </summary>
                public const string TAKE_OUT_SALE_AMT = "TAKE_OUT_SALE_AMT";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 복합 매장 점포(서브 매장)
        /// <summary>
        /// 복합 매장 점포(서브 매장)
        /// </summary>
        public class MST_COMPLEX_SHOP_STOR
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_COMPLEX_SHOP_STOR";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 복합 매장 점포 코드(SUB 점포 코드)
                /// </summary>
                public const string COMPLEX_SHOP_STOR_CD = "COMPLEX_SHOP_STOR_CD";
                /// <summary>
                /// 복합 매장 점포 명
                /// </summary>
                public const string COMPLEX_SHOP_STOR_NM = "COMPLEX_SHOP_STOR_NM";
                /// <summary>
                /// 표시순번
                /// </summary>
                public const string DISP_SEQ = "DISP_SEQ";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region MST_TEST_MODE 시험모드 마스터
        /// <summary>
        /// 시험모드 마스터
        /// </summary>
        public class MST_TEST_MODE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_TEST_MODE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 시험항목 ID 
                /// </summary>
                public const string TEST_ENTRY_ID = "TEST_ENTRY_ID";
                /// <summary>
                /// 표시 순번
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 시험항목 명 
                /// </summary>
                public const string TEST_ENTRY_NM = "TEST_ENTRY_NM";
                /// <summary>
                /// 오류허용횟수 
                /// </summary>
                public const string ERR_PRMT_CNT = "ERR_PRMT_CNT";
                /// <summary>
                /// 시험제한시간 
                /// </summary>
                public const string TEST_LMT_TIME = "TEST_LMT_TIME";
                /// <summary>
                /// 시험항목 설명1 
                /// </summary>
                public const string TEST_ENTRY_EXPLN1 = "TEST_ENTRY_EXPLN1";
                /// <summary>
                /// 시험항목 설명2 
                /// </summary>
                public const string TEST_ENTRY_EXPLN2 = "TEST_ENTRY_EXPLN2";
                /// <summary>
                /// 시험항목 설명3 
                /// </summary>
                public const string TEST_ENTRY_EXPLN3 = "TEST_ENTRY_EXPLN3";
                /// <summary>
                /// 시험항목 설명4 
                /// </summary>
                public const string TEST_ENTRY_EXPLN4 = "TEST_ENTRY_EXPLN4";
                /// <summary>
                /// 시험항목 설명5 
                /// </summary>
                public const string TEST_ENTRY_EXPLN5 = "TEST_ENTRY_EXPLN5";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 시험완료여부
                /// </summary>
                public const string TEST_PASS_YN = "TEST_PASS_YN";
                ///// <summary>
                ///// 시험일시
                ///// </summary>
                //public const string TEST_DATE = "TEST_DATE";
                ///// <summary>
                ///// 전송구분
                ///// </summary>
                //public const string SEND_DIV = "SEND_DIV";
            }
        }
        #endregion

        #region MST_TEST_MODE_DTL_INFO 시험모드 상세정보
        /// <summary>
        /// 시험모드 상세정보
        /// </summary>
        public class MST_TEST_MODE_DTL_INFO
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_TEST_MODE_DTL_INFO";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 시험항목 ID 
                /// </summary>
                public const string TEST_ENTRY_ID = "TEST_ENTRY_ID";
                /// <summary>
                /// 시험상세 순번
                /// </summary>
                public const string DTL_SEQ = "DTL_SEQ";
                /// <summary>
                /// 상세순번 설명
                /// </summary>
                public const string DTL_SEQ_EXPLN = "DTL_SEQ_EXPLN";
                /// <summary>
                /// POS 화면유형(0:공통, 1:화면타입별) 
                /// </summary>
                public const string POS_SCRN_TYPE = "POS_SCRN_TYPE";
                /// <summary>
                /// 화면표시시간(0:무한, 그외초)
                /// </summary>
                public const string SCRN_DISP_HOUR = "SCRN_DISP_HOUR";
                /// <summary>
                /// 숫자패드 사용 유형(0:미사용, 1:팝업, 2:판매) 
                /// </summary>
                public const string NUM_PAD_USE_TYPE = "NUM_PAD_USE_TYPE";
                /// <summary>
                /// 입력박스 사용 여부(0:미사용, 1:사용) 
                /// </summary>
                public const string INPUT_BOX_USE_YN = "INPUT_BOX_USE_YN";
                /// <summary>
                /// 입력박스 데이터 길이 최소(0:미사용) 
                /// </summary>
                public const string INPUT_BOX_DATA_MIN_LEN = "INPUT_BOX_DATA_MIN_LEN";
                /// <summary>
                /// 입력박스 데이터 길이 최대(0:미사용) 
                /// </summary>
                public const string INPUT_BOX_DATA_MAX_LEN = "INPUT_BOX_DATA_MAX_LEN";
                /// <summary>
                /// 입력박스 프리픽스 체크값
                /// </summary>
                public const string INPUT_BOX_CHECK_PREFIX = "INPUT_BOX_CHECK_PREFIX";
                /// <summary>
                /// 장치 사용 유형 (00:미사용, 01:SCAN, 02:MSR)
                /// </summary>
                public const string DEVICE_USE_TYPE = "DEVICE_USE_TYPE";
                /// <summary>
                /// 장치 데이터 길이 최소
                /// </summary>
                public const string DEVICE_DATA_MIN_LEN = "DEVICE_DATA_MIN_LEN";
                /// <summary>
                /// 장치 데이터 길이 최대
                /// </summary>
                public const string DEVICE_DATA_MAX_LEN = "DEVICE_DATA_MAX_LEN";
                /// <summary>
                /// 장치 프리픽스 체크 값
                /// </summary>
                public const string DEVICE_PREFIX_CHECK = "DEVICE_PREFIX_CHECK";
                /// <summary>
                /// 터치사용여부
                /// </summary>
                public const string TOUCH_USE_YN = "TOUCH_USE_YN";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region MST_TEST_MODE_DTL_LOC 시험모드 상세위치
        /// <summary>
        /// 시험모드 상세위치
        /// </summary>
        public class MST_TEST_MODE_DTL_LOC
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_TEST_MODE_DTL_LOC";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 시험항목 ID 
                /// </summary>
                public const string TEST_ENTRY_ID = "TEST_ENTRY_ID";
                /// <summary>
                /// 시험상세 순번
                /// </summary>
                public const string DTL_SEQ = "DTL_SEQ";
                /// <summary>
                /// POS 화면유형(0:공통, 그외:화면타입) 
                /// </summary>
                public const string POS_SCRN_TYPE = "POS_SCRN_TYPE";
                /// <summary>
                /// 이미지파일명 
                /// </summary>
                public const string IMG_FILE_NM = "IMG_FILE_NM";
                /// <summary>
                /// 숫자패드 시작 위치 X 
                /// </summary>
                public const string NUM_PAD_START_LOC_X = "NUM_PAD_START_LOC_X";
                /// <summary>
                /// 숫자패드 시작 위치 Y 
                /// </summary>
                public const string NUM_PAD_START_LOC_Y = "NUM_PAD_START_LOC_Y";
                /// <summary>
                /// 입력박스 시작 위치 X 
                /// </summary>
                public const string INPUT_BOX_START_LOC_X = "INPUT_BOX_START_LOC_X";
                /// <summary>
                /// 입력박스 시작 위치 Y 
                /// </summary>
                public const string INPUT_BOX_START_LOC_Y = "INPUT_BOX_START_LOC_Y";
                /// <summary>
                /// 입력박스 종료 위치 X 
                /// </summary>
                public const string INPUT_BOX_FNSH_LOC_X = "INPUT_BOX_FNSH_LOC_X";
                /// <summary>
                /// 입력박스 종료 위치 Y 
                /// </summary>
                public const string INPUT_BOX_FNSH_LOC_Y = "INPUT_BOX_FNSH_LOC_Y";
                /// <summary>
                /// 터치 시작 위치 X 
                /// </summary>
                public const string TOUCH_START_LOC_X = "TOUCH_START_LOC_X";
                /// <summary>
                /// 터치 시작 위치 Y 
                /// </summary>
                public const string TOUCH_START_LOC_Y = "TOUCH_START_LOC_Y";
                /// <summary>
                /// 터치 종료 위치 X 
                /// </summary>
                public const string TOUCH_FNSH_LOC_X = "TOUCH_FNSH_LOC_X";
                /// <summary>
                /// 터치 종료 위치 Y 
                /// </summary>
                public const string TOUCH_FNSH_LOC_Y = "TOUCH_FNSH_LOC_Y"; 
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region MST_BILL_MSG 영수증 마스터
        /// <summary>
        /// 영수증 마스터
        /// </summary>
        public class MST_BILL_MSG
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_BILL_MSG";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 용도 구분(1:상단, 2:하단, 3:카드)
                /// </summary>
                public const string PRT_LOC = "PRT_LOC";
                /// <summary>
                /// 작성자 구분(1:본사, 2:팀, 3:점포)
                /// </summary>
                public const string WRITE_DIV = "WRITE_DIV";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 출력시작 일자
                /// </summary>
                public const string PRT_START_DT = "PRT_START_DT";
                /// <summary>
                /// 출력종료 일자 
                /// </summary>
                public const string PRT_FNSH_DT = "PRT_FNSH_DT";
                /// <summary>
                /// 출력시작 시간
                /// </summary>
                public const string PRT_START_HOUR = "PRT_START_HOUR";
                /// <summary>
                /// 출력종료 시간 
                /// </summary>
                public const string PRT_FNSH_HOUR = "PRT_FNSH_HOUR";
                /// <summary>
                /// 확대 문자(0:보통, 1:굵게, 2:가로확대, 3:세로확대, 4:전체확대)
                /// </summary>
                public const string EXPAND_CHAR = "EXPAND_CHAR";
                /// <summary>
                /// BOLD 여부(0:보통, 1:BOLD)
                /// </summary>
                public const string BOLD_YN = "BOLD_YN";
                /// <summary>
                /// 정렬 유형(1:오른쪽, 2:가운데, 3:왼쪽)
                /// </summary>
                public const string ALIGN_TYPE = "ALIGN_TYPE";
                /// <summary>
                /// 문자열
                /// </summary>
                public const string CHAR_ROW = "CHAR_ROW";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region MST_BILL_TYPE 영수증 유형 마스터
        /// <summary>
        /// 영수증 유형 마스터
        /// </summary>
        public class MST_BILL_TYPE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_BILL_TYPE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 영수증 유형그룹 코드
                /// </summary>
                public const string BILL_TYPE_GRP_CD = "BILL_TYPE_GRP_CD";
                /// <summary>
                /// 영수증 유형 구분('00':영수증상단, '01':결제정보, '02':신용카드, '03':포인트적립, '04':포인트사용, '99':영수증하단)
                /// </summary>
                public const string BILL_TYPE_DIV = "BILL_TYPE_DIV";
                /// <summary>
                /// 일련번호
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 정렬구분(1:오른쪽, 2:가운데, 3:왼쪽)
                /// </summary>
                public const string SORT_DIV = "SORT_DIV";
                /// <summary>
                /// 크기구분(0:보통, 1:굵게, 2:가로확대, 3:세로확대, 4:전체확대)
                /// </summary>
                public const string SIZE_DIV = "SIZE_DIV";
                /// <summary>
                /// 영수증 유형 태그
                /// </summary>
                public const string BILL_TYPE_TAG = "BILL_TYPE_TAG";
                /// <summary>
                /// BOLD 여부(0:보통, 1:BOLD)
                /// </summary>
                public const string BOLD_YN = "BOLD_YN";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region MST_WEB_LINKAGE 웹업무 마스터
        /// <summary>
        /// 웹업무 마스터
        /// </summary>
        public class MST_WEB_LINKAGE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_WEB_LINKAGE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 일련번호 
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 구분 
                /// </summary>
                public const string DIV = "DIV";
                /// <summary>
                /// 화면표시순서 
                /// </summary>
                public const string DISP_SEQ = "DISP_SEQ";
                /// <summary>
                /// 화면표시여부 
                /// </summary>
                public const string DISP_YN = "DISP_YN";
                /// <summary>
                /// 메뉴명 
                /// </summary>
                public const string MENU_NM = "MENU_NM";
                /// <summary>
                /// WEB MENU ID
                /// </summary>
                public const string WEB_MENU_ID = "WEB_MENU_ID";
                /// <summary>
                /// FUNC ID
                /// </summary>
                public const string FUNC_ID = "FUNC_ID";
                /// <summary>
                /// PARAM
                /// </summary>
                public const string PARAM = "PARAM";
                /// <summary>
                /// FILLER1 
                /// </summary>
                public const string FILLER1 = "FILLER1";
                /// <summary>
                /// FILLER2 
                /// </summary>
                public const string FILLER2 = "FILLER2";
                /// <summary>
                /// FILLER3 
                /// </summary>
                public const string FILLER3 = "FILLER3";
                /// <summary>
                /// FILLER4 
                /// </summary>
                public const string FILLER4 = "FILLER4";
                /// <summary>
                /// FILLER5 
                /// </summary>
                public const string FILLER5 = "FILLER5";
                /// <summary>
                /// UPD_DT 
                /// </summary>
                public const string UPD_DT = "UPD_DT";
                /// <summary>
                /// REG_DT 
                /// </summary>
                public const string REG_DT = "REG_DT";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 외화 환율 마스터
        /// <summary>
        /// 외화 환율 마스터
        /// </summary>
        public class MST_FOREIGN_RATE_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_EXCHG_RATE";

            public class DATA
            {
                /// <summary>
                /// 외화 코드
                /// </summary>
                public const string EXCHG_RATE_CD = "EXCHG_RATE_CD";
                /// <summary>
                /// 외화 명
                /// </summary>
                public const string EXCHG_RATE_NM = "EXCHG_RATE_NM";
                /// <summary>
                /// 외화 환율
                /// </summary>
                public const string EXCHG_RATE_AMT = "EXCHG_RATE_AMT";
                /// <summary>
                /// 외화 단위
                /// </summary>
                public const string EXCHG_RATE_UNIT = "EXCHG_RATE_UNIT";
            }
        }
        #endregion

        #region MST_CUST_DSP 고객화면 마스터
        /// <summary>
        /// 고객화면 마스터
        /// </summary>
        public class MST_CUST_DSP
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CUST_DSP";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 표시 종류 
                /// </summary>
                public const string DISP_KIND = "DISP_KIND";
                ///// <summary>
                ///// 표시 구분 
                ///// </summary>
                //public const string DISP_DIV = "DISP_DIV";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 파일 타입 
                /// </summary>
                public const string FILE_TYPE = "FILE_TYPE";
                /// <summary>
                /// 시작 일자 
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// 종료 일자 
                /// </summary>
                public const string FNSH_DT = "FNSH_DT";
                /// <summary>
                /// 표시시간 
                /// </summary>
                public const string FILE_TIME = "FILE_TIME";
                /// <summary>
                /// 파일명
                /// </summary>
                public const string FILE_NM = "FILE_NM";	 
                /// <summary>
                /// FILLER1 
                /// </summary>
                public const string FILLER1 = "FILLER1";
                /// <summary>
                /// FILLER2 
                /// </summary>
                public const string FILLER2 = "FILLER2";
                /// <summary>
                /// FILLER3 
                /// </summary>
                public const string FILLER3 = "FILLER3";
                /// <summary>
                /// FILLER4 
                /// </summary>
                public const string FILLER4 = "FILLER4";
                /// <summary>
                /// FILLER5 
                /// </summary>
                public const string FILLER5 = "FILLER5";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 시작시간
                /// </summary>
                public const string START_HOUR = "START_HOUR";
                /// <summary>
                /// 종료시간
                /// </summary>
                public const string FNSH_HOUR = "FNSH_HOUR";
                /// <summary>
                /// 적용요일
                /// </summary>
                public const string DOW = "DOW";
            }
        }
        #endregion

        #region 입출금 계정 마스터
        /// <summary>
        /// 입출금 계정 마스터
        /// </summary>
        public class MST_DPST_WTHDR_ACC
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_DPST_WTHDR_ACC";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 직가맹 구분 
                /// </summary>
                public const string DRT_FRCS_DIV = "DRT_FRCS_DIV";
                /// <summary>
                /// 입출금 계정 코드
                /// </summary>
                public const string DPST_WTHDR_ACC_CD = "DPST_WTHDR_ACC_CD";
                /// <summary>
                /// 입출금 계정 명
                /// </summary>
                public const string DPST_WTHDR_ACC_NM = "DPST_WTHDR_ACC_NM";
                /// <summary>
                /// 입출금 유형
                /// </summary>
                public const string DPST_WTHDR_TYPE = "DPST_WTHDR_TYPE";
                /// <summary>
                /// 계정 코드
                /// </summary>
                public const string ACC_CD = "ACC_CD";
                /// <summary>
                /// 손익 유형
                /// </summary>
                public const string PRNLS_TYPE = "PRNLS_TYPE";
                /// <summary>
                /// 매입처 입력 유형
                /// </summary>
                public const string SPPLR_INPUT_TYPE = "SPPLR_INPUT_TYPE";
                /// <summary>
                /// 판매 POS 사용 여부
                /// </summary>
                public const string SALE_POS_USE_YN = "SALE_POS_USE_YN";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";

            }
        }
        #endregion 입출금 계정 마스터

        #region MST_KTCH_DEVICE 주방Device 마스터
        /// <summary>
        /// 긴급 공지 메세지 마스터
        /// </summary>
        public class MST_KTCH_DEVICE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_KTCH_DEVICE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 주방 시스템 코드
                /// </summary>
                public const string KTCH_SYS_CD = "KTCH_SYS_CD";
                /// <summary>
                /// 주방 시스템 명
                /// </summary>
                public const string KTCH_SYS_NM = "KTCH_SYS_NM";
                /// <summary>
                /// 주방 시스템 구분 1:KPS, 2:KVS, 3:KDS
                /// </summary>
                public const string KTCH_SYS_DIV = "KTCH_SYS_DIV";
                /// <summary>
                /// 주방 시스템 사용 구분 
                /// 1:RS232(Serial), 2:Databae, 3:Socket(LAN)
                /// </summary>
                public const string KTCH_SYS_USE_DIV = "KTCH_SYS_USE_DIV";
                /// <summary>
                /// 주방프린터 통신 포트
                /// </summary>
                public const string KTCH_PRINTER_COMM_PORT = "KTCH_PRINTER_COMM_PORT";
                /// <summary>
                /// 주방프린터 통신 속도
                /// </summary>
                public const string KTCH_PRINTER_COMM_SPEED = "KTCH_PRINTER_COMM_SPEED";
                /// <summary>
                /// 주방프린터 OPOS 명
                /// </summary>
                public const string KTCH_PRINTER_OPOS_NM = "KTCH_PRINTER_OPOS_NM";

                /// <summary>
                /// 주방프린터 IP
                /// </summary>
                public const string KTCH_PRINTER_IP = "KTCH_PRINTER_IP";
                /// <summary>
                /// 주방프린터 포트 
                /// </summary>
                public const string KTCH_PRINTER_PORT = "KTCH_PRINTER_PORT";  

                /// <summary>
                /// 주방모니터 IP
                /// </summary>
                public const string KTCH_DSP_IP = "KTCH_DSP_IP";
                /// <summary>
                /// 주방모니터 PORT
                /// </summary>
                public const string KTCH_DSP_PORT = "KTCH_DSP_PORT";
                /// <summary>
                /// 주방모니터 DB 명
                /// </summary>
                public const string KTCH_DSP_DB_NM = "KTCH_DSP_DB_NM";
                /// <summary>
                /// 주방모니터 DB 사용자ID
                /// </summary>
                public const string KTCH_DSP_DB_USER_ID = "KTCH_DSP_DB_USER_ID";
                /// <summary>
                /// 주방모니터 DB 암호
                /// </summary>
                public const string KTCH_DSP_DB_PW = "KTCH_DSP_DB_PW";
                ///// <summary>
                ///// 주방프린터백업1
                ///// </summary>
                //public const string KTCH_PRINTER_BAK1 = "KTCH_PRINTER_BAK1";
                ///// <summary>
                ///// 주방프린터백업2
                ///// </summary>
                //public const string KTCH_PRINTER_BAK2 = "KTCH_PRINTER_BAK2";
                ///// <summary>
                ///// 주방프린터백업3
                ///// </summary>
                //public const string KTCH_PRINTER_BAK3 = "KTCH_PRINTER_BAK3";
                ///// <summary>
                ///// 주방프린터백업4
                ///// </summary>
                //public const string KTCH_PRINTER_BAK4 = "KTCH_PRINTER_BAK4";
                ///// <summary>
                ///// 주방프린터백업5
                ///// </summary>
                //public const string KTCH_PRINTER_BAK5 = "KTCH_PRINTER_BAK5";
                ///// <summary>
                ///// 주방프린터백업6
                ///// </summary>
                //public const string KTCH_PRINTER_BAK6 = "KTCH_PRINTER_BAK6";
                /// <summary>
                /// 필러1
                /// </summary>
                public const string FILLER1 = "FILLER1";
                /// <summary>
                /// 필러2
                /// </summary>
                public const string FILLER2 = "FILLER2";
                /// <summary>
                /// 필러3
                /// </summary>
                public const string FILLER3 = "FILLER3";
                /// <summary>
                /// 필러4
                /// </summary>
                public const string FILLER4 = "FILLER4";
                /// <summary>
                /// 필러5
                /// </summary>
                public const string FILLER5 = "FILLER5";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion MST_KTCH_DEVICE 주방Device 마스터

        #region 프로그램 업데이트 목록
        /// <summary>
        /// 프로그램 업데이트 목록
        /// </summary>
        public class MST_PGM_VER
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PGM_VER_NEW";

            public class DATA
            {
                /// <summary>
                /// 그룹
                /// </summary>
                public const string FILE_GROUP = "FILE_GROUP";
                /// <summary>
                /// 종별(01:프로그램, 02:프로그램(기타), 03:객면컨텐츠, 04:상품이미지, 20:영수증로고이미지)
                /// </summary>
                public const string KIND = "KIND";
                /// <summary>
                /// 파일 Seq
                /// </summary>
                public const string FILE_SEQ = "FILE_SEQ";
                /// <summary>
                /// 버젼
                /// </summary>
                public const string FILE_VER = "FILE_VER";
                /// <summary>
                /// 파일명
                /// </summary>
                public const string FILE_NM = "FILE_NM";
                /// <summary>
                /// 다운로드일자
                /// </summary>
                public const string DEPLOY_DT = "DEPLOY_DT";
                /// <summary>
                /// 배포일자
                /// </summary>
                public const string REG_DT = "REG_DT";
            }
        }
        #endregion 프로그램 업데이트 목록

        #region 담당자 권한 마스터
        /// <summary>
        /// 담당자 권한 마스터
        /// </summary>
        public class MST_PIC_AUTH
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PIC_AUTH";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 계산원 ID
                /// </summary>
                public const string CASHIER_ID = "CASHIER_ID";
                /// <summary>
                /// 기능 ID
                /// </summary>
                public const string FUNC_ID = "FUNC_ID";
                /// <summary>
                /// 관리 권한
                /// </summary>
                public const string MNG_AUTH = "MNG_AUTH";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion 담당자 권한 마스터

        #region 공지사항(긴급,일반,영업공지)
        /// <summary>
        /// 공지사항(긴급,일반,영업공지)
        /// </summary>
        public class MST_EMG_NOTE
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_EMG_NOTE";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 포스 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 메세지 코드
                /// </summary>
                public const string MSG_CODE = "MSG_CODE";
                /// <summary>
                /// 메시지 구분별 유형(00:긴급 01:일반 02:영업)
                /// </summary>
                public const string MSG_DIV = "MSG_DIV";
                /// <summary>
                /// 공지별유형(0:없음 1.마스터 ,2.PGM)
                /// </summary>
                public const string MSG_TYPE = "MSG_TYPE";
                /// <summary>
                /// 제목
                /// </summary>
                public const string MSG_TITLE = "MSG_TITLE";
                /// <summary>
                /// 내용
                /// </summary>
                public const string MSG_CONTENTS = "MSG_CONTENTS";
                /// <summary>
                /// 시작일자
                /// </summary>
                public const string START_DT = "START_DT";
                /// <summary>
                /// (0: 없음 1.즉시 적용 2.다음 실행시 3. 재부팅시) - MSG_TYPE 통합(사용 안함 2017-01-13)
                /// </summary>
                public const string POS_EXEC_TYPE = "POS_EXEC_TYPE";
                /// <summary>
                /// 팝업 적용 여부(0:NO 1:POPUP)
                /// </summary>
                public const string POPUP_YN = "POPUP_YN";
                /// <summary>
                /// 종료시간
                /// </summary>
                public const string FNSH_HOUR = "FNSH_HOUR";
                /// <summary>
                /// 읽음여부
                /// </summary>
                public const string READ_YN = "READ_YN";
                /// <summary>
                /// 다운로드 여부 (1:예, 0:아니오)
                /// </summary>
                public const string DOWN_YN = "DOWN_YN";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion 공지사항(긴급,일반,영업공지)

        #region 점포점검스케줄 마스터 (준비점검공지사항 / 판매준비점검)
        /// <summary>
        /// 점포점검스케줄 마스터 (준비점검공지사항 / 판매준비점검)
        /// </summary>
        public class MST_STOR_INSPCT
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_STOR_INSPCT";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점검 항목 그룹 코드
                /// </summary>
                public const string INSPCT_ENTRY_GRP_CD = "INSPCT_ENTRY_GRP_CD";
                /// <summary>
                /// 점검 항목 그룹 명
                /// </summary>
                public const string INSPCT_ENTRY_GRP_NM = "INSPCT_ENTRY_GRP_NM";
                /// <summary>
                /// POS 구분
                /// </summary>
                public const string POS_DIV = "POS_DIV";
                /// <summary>
                /// 판매 POS 알람 유형
                /// </summary>
                public const string SALE_POS_ALARM_TYPE = "SALE_POS_ALARM_TYPE";
                /// <summary>
                /// 배점 관리 여부
                /// </summary>
                public const string SCORE_MNG_YN = "SCORE_MNG_YN";
                /// <summary>
                /// 순서
                /// </summary>
                public const string QUE = "QUE";
                /// <summary>
                /// 판매 POS 알람 날짜 지정 유형
                /// </summary>
                public const string SALE_POS_ALARM_DT_APPNT_TYPE = "SALE_POS_ALARM_DT_APPNT_TYPE";
                /// <summary>
                /// 일자 1
                /// </summary>
                public const string DATE_1 = "DATE_1";
                /// <summary>
                /// 일자 2
                /// </summary>
                public const string DATE_2 = "DATE_2";
                /// <summary>
                /// 주
                /// </summary>
                public const string WEEK = "WEEK";
                /// <summary>
                /// 요일
                /// </summary>
                public const string DOW = "DOW";
                /// <summary>
                /// 시작 시간
                /// </summary>
                public const string START_HOUR = "START_HOUR";
                /// <summary>
                /// 종료 시간
                /// </summary>
                public const string FNSH_HOUR = "FNSH_HOUR";
                /// <summary>
                /// SV 확정 여부
                /// </summary>
                public const string SV_CONFRM_YN = "SV_CONFRM_YN";
                /// <summary>
                /// 응답 가능 일 수
                /// </summary>
                public const string ANSWR_POSS_DAY_CNT = "ANSWR_POSS_DAY_CNT";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 수정 일시
                /// </summary>
                public const string UPD_DT = "UPD_DT";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public const string REG_DT = "REG_DT";
            }
        }
        #endregion 점포점검스케줄 마스터 (준비점검공지사항 / 판매준비점검)

        #region 준비점검내역헤더마스터 (준비점검공지사항)
        /// <summary>
        /// 준비점검내역마스터 (준비점검공지사항)
        /// </summary>
        public class MST_SALESORG_INSPCT_GRP
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_SALESORG_INSPCT_GRP";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 브랜드 코드
                /// </summary>
                public const string BRAND_CD = "BRAND_CD";
                /// <summary>
                /// 점검 항목 그룹 코드
                /// </summary>
                public const string INSPCT_ENTRY_GRP_CD = "INSPCT_ENTRY_GRP_CD";
                /// <summary>
                /// 점검 항목 대분류 코드
                /// </summary>
                public const string INSPCT_ENTRY_L_CLSS_CD = "INSPCT_ENTRY_L_CLSS_CD";
                /// <summary>
                /// 점검 항목 대분류 이름
                /// </summary>
                public const string INSPCT_ENTRY_L_CLSS_NM = "INSPCT_ENTRY_L_CLSS_NM";
                /// <summary>
                /// 점검 그룹 구분
                /// </summary>
                public const string INSPCT_GRP_DIV = "INSPCT_GRP_DIV";
                /// <summary>
                /// 총 점수
                /// </summary>
                public const string TOT_SCORE = "TOT_SCORE";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 수정 일시
                /// </summary>
                public const string UPD_DT = "UPD_DT";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public const string REG_DT = "REG_DT";
            }
        }
        #endregion 준비점검내역헤더마스터 (준비점검공지사항)

        #region 준비점검내역상세마스터 (준비점검공지사항)
        /// <summary>
        /// 준비점검내역마스터 (준비점검공지사항)
        /// </summary>
        public class MST_SALESORG_INSPCT_DTL
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_SALESORG_INSPCT_DTL";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 브랜드 코드
                /// </summary>
                public const string BRAND_CD = "BRAND_CD";
                /// <summary>
                /// 점검 항목 그룹 코드
                /// </summary>
                public const string INSPCT_ENTRY_GRP_CD = "INSPCT_ENTRY_GRP_CD";
                /// <summary>
                /// 점검 항목 대분류 코드
                /// </summary>
                public const string INSPCT_ENTRY_L_CLSS_CD = "INSPCT_ENTRY_L_CLSS_CD";
                /// <summary>
                /// 점검 항목
                /// </summary>
                public const string INSPCT_ENTRY = "INSPCT_ENTRY";
                /// <summary>
                /// 점검 항목 명
                /// </summary>
                public const string INSPCT_ENTRY_NM = "INSPCT_ENTRY_NM";
                /// <summary>
                /// 입력 구분
                /// </summary>
                public const string INPUT_DIV = "INPUT_DIV";
                /// <summary>
                /// 선택 항목 개수
                /// </summary>
                public const string SEL_ENTRY_CNT = "SEL_ENTRY_CNT";
                /// <summary>
                /// 선택 항목 1
                /// </summary>
                public const string SEL_ENTRY_1 = "SEL_ENTRY_1";
                /// <summary>
                ///선택 항목 2
                /// </summary>
                public const string SEL_ENTRY_2 = "SEL_ENTRY_2";
                /// <summary>
                /// 선택 항목 3
                /// </summary>
                public const string SEL_ENTRY_3 = "SEL_ENTRY_3";
                /// <summary>
                /// 선택 항목 4
                /// </summary>
                public const string SEL_ENTRY_4 = "SEL_ENTRY_4";
                /// <summary>
                /// 선택 항목 5
                /// </summary>
                public const string SEL_ENTRY_5 = "SEL_ENTRY_5";
                /// <summary>
                /// 순서
                /// </summary>
                public const string QUE = "QUE";
                /// <summary>
                /// 비고 필수 입력 여부
                /// </summary>
                public const string NOTE_MNDTRY_INPUT_YN = "NOTE_MNDTRY_INPUT_YN";
                /// <summary>
                /// 대상 구분
                /// </summary>
                public const string TRGT_DIV = "TRGT_DIV";
                /// <summary>
                /// 실행 주기 구분
                /// </summary>
                public const string EXEC_CYCLE_DIV = "EXEC_CYCLE_DIV";
                /// <summary>
                /// 비고 이미지 파일 명
                /// </summary>
                public const string NOTE_IMG_FILE_NM = "NOTE_IMG_FILE_NM";
                /// <summary>
                /// 비고 이미지 파일 ID
                /// </summary>
                public const string NOTE_IMG_FILE_ID = "NOTE_IMG_FILE_ID";
                /// <summary>
                /// 비고
                /// </summary>
                public const string NOTE = "NOTE";
                /// <summary>
                /// 사용 여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 수정 일시
                /// </summary>
                public const string UPD_DT = "UPD_DT";
                /// <summary>
                /// 등록 일시
                /// </summary>
                public const string REG_DT = "REG_DT";
            }
        }
        #endregion 준비점검내역상세마스터 (준비점검공지사항)

        #region 영수증 설문조사 마스터
        /// <summary>
        /// 영수증 설문조사 마스터
        /// </summary>
        public class MST_SALESORG_SURVY_MSG
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_SALESORG_SURVY_MSG";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드 
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 출력시작 일자
                /// </summary>
                public const string APLY_START_DT = "APLY_START_DT";
                /// <summary>
                /// 순번
                /// </summary>
                public const string SEQ_NO = "SEQ_NO";
                /// <summary>
                /// 출력순번
                /// </summary>
                public const string PRT_SEQ = "PRT_SEQ";
                /// <summary>
                /// 출력종료 일자 
                /// </summary>
                public const string APPLY_FNSH_DT = "PRT_FNSH_DT";
                /// <summary>
                /// 출력시작 시간
                /// </summary>
                public const string APPLY_START_HOUR = "PRT_START_HOUR";
                /// <summary>
                /// 적용요일
                /// </summary>
                public const string DOW = "DOW";
                /// <summary>
                /// 문자열
                /// </summary>
                public const string MSG_VAL = "MSG_VAL";
                /// <summary>
                /// 확대 문자(0:보통, 1:굵게, 2:가로확대, 3:세로확대, 4:전체확대)
                /// </summary>
                public const string PRT_EXPAND_TYPE = "PRT_EXPAND_TYPE";
                /// <summary>
                /// BOLD 여부(0:보통, 1:BOLD)
                /// </summary>
                public const string BOLD_YN = "BOLD_YN";
                /// <summary>
                /// 정렬 유형(1:오른쪽, 2:가운데, 3:왼쪽)
                /// </summary>
                public const string ALIGN_TYPE = "ALIGN_TYPE";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
            }
        }
        #endregion

        #region 선불카드-판매 마스터
        /// <summary>
        /// 선불카드-판매 마스터
        /// </summary>
        public class MST_PRECARD_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_PRECARD";

            public class DATA
            {
                /// <summary>
                /// SEQ
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD"; 
                /// <summary>
                /// 권종
                /// </summary>
                public const string CODE = "CODE";
                /// <summary>
                /// 명
                /// </summary>
                public const string NAME = "NAME"; 
                /// <summary>
                /// 금액 
                /// </summary>
                public const string AMOUNT = "AMOUNT";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
            }
        }
        #endregion

        #region 카드사 키 마스터
        /// <summary>
        /// 카드사 키 마스터
        /// </summary>
        public class MST_CARD_CMP_KEY
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CARD_CMP";

            public class DATA
            {
                /// <summary>
                /// SEQ
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 코드
                /// </summary>
                public const string CARD_CMP_CD = "CARD_CMP_CD";                
                /// <summary>
                /// 명
                /// </summary>
                public const string CARD_CMP_NM = "CARD_CMP_NM";
                /// <summary>
                /// 구분
                /// </summary>
                public const string TERM_DIV = "TERM_DIV"; 
                /// <summary>
                /// FONT 크기 
                /// </summary>
                public const string FONT_SIZE = "FONT_SIZE";
                /// <summary>
                /// 배경 색상 
                /// </summary>
                public const string BACKGR_COLOR = "BACKGR_COLOR";
                /// <summary>
                /// 버튼 크기 
                /// </summary>
                public const string BTN_SIZE = "BTN_SIZE";
                /// <summary>
                /// 이미지 
                /// </summary>
                public const string BTN_ITEM_IMG = "BTN_ITEM_IMG";
            }
        }
        #endregion

        #region 일일점검 마스터
        /// <summary>
        /// 일일점검 마스터
        /// </summary>
        public class MST_STR_DAILY_INSPCT_LIST
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_STR_DAILY_INSPCT_LIST";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 일일점검코드
                /// </summary>
                public const string INSPCT_CD = "INSPCT_CD";
                /// <summary>
                /// 사용구분
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 업데이트 일자
                /// </summary>
                public const string UPD_DT = "UPD_DT";
                /// <summary>
                /// 등록 일자
                /// </summary>
                public const string REG_DT = "REG_DT";
            }
        }
        #endregion


        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
        #region 온라인 쿠폰 MST_CPN_ITEM_GRP_MNG
        /// <summary>
        /// 온라인 쿠폰 제품군 테이블 (MST_CPN_ITEM_GRP_MNG)
        /// </summary>
        public class MST_CPN_ITEM_GRP_MNG
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPN_ITEM_GRP_MNG";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 제품군코드
                /// </summary>
                public const string ITEM_GRP_CD = "ITEM_GRP_CD";
                /// <summary>
                /// 사용구분
                /// </summary>
                public const string ITEM_GRP_NM = "ITEM_GRP_NM";
                /// <summary>
                /// 업데이트 일자
                /// </summary>
                public const string UPD_DT = "UPD_DATE";
                /// <summary>
                /// 등록 일자
                /// </summary>
                public const string REG_DT = "REG_DATE";

                //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 start
                public const string GUBUN = "GUBUN";
                //#20180502 온라인쿠폰 제품군, 상품코드 할인 적용 기능 적용 end
            }
        }
        #endregion
        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
        #region 온라인 쿠폰 MST_CPN_ITEM_GRP_MNG_DTL
        /// <summary>
        /// 온라인 쿠폰 제품군 상품 테이블 (MST_CPN_ITEM_GRP_MNG_DTL)
        /// </summary>
        public class MST_CPN_ITEM_GRP_MNG_DTL
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "MST_CPN_ITEM_GRP_MNG_DTL";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 제품군코드
                /// </summary>
                public const string ITEM_GRP_CD = "ITEM_GRP_CD";
                /// <summary>
                /// 제품코드
                /// </summary>
                public const string ITEM_CD = "ITEM_CD";
                /// <summary>
                /// 업데이트 일자
                /// </summary>
                public const string UPD_DT = "UPD_DATE";
                /// <summary>
                /// 등록 일자
                /// </summary>
                public const string REG_DT = "REG_DATE";
            }
        }
        #endregion
        //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

        //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start, 20180510
        
        #region 고객 구매이력 조회 마스터 STR_SEND_CPN_MST
        /// <summary>
        /// 고객 구매이력 조회 마스터 (STR_SEND_CPN_MST)
        /// </summary>
        public class STR_SEND_CPN_MST
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "STR_SEND_CPN_MST";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 해피콕점포여부
                /// </summary>
                public const string HAPPY_YN = "HAPPY_YN";
                /// <summary>
                /// 구매이력출력여부
                /// </summary>
                public const string PRINT_YN = "PRINT_YN";
                /// <summary>
                /// 쿠폰발송기능
                /// </summary>
                public const string SEND_YN = "SEND_YN";
                /// <summary>
                /// 업데이트 일자
                /// </summary>
                public const string UPD_DT = "UPD_DATE";
                /// <summary>
                /// 등록 일자
                /// </summary>
                public const string REG_DT = "REG_DATE";

                //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start, 20180528
                //쿠폰 발송 횟수 제한 기능
                /// <summary>
                /// 일 쿠폰 발송 가능 횟수
                /// </summary>
                public const string CPN_SEND_LIMIT_CNT = "CPN_SEND_LIMIT_CNT";
                //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end, 20180528
            }
        }
        #endregion

        #region 고객 구매이력 조회 상세(발송 쿠폰) STR_SEND_CPN_DTL
        /// <summary>
        /// 고객 구매이력 조회 상세(발송 쿠폰) (STR_SEND_CPN_DTL)
        /// </summary>
        public class STR_SEND_CPN_DTL
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "STR_SEND_CPN_DTL";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 점포코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// 쿠폰코드(공통코드:T0037)
                /// </summary>
                public const string CODE = "CODE";
                /// <summary>
                /// 사용여부
                /// </summary>
                public const string USE_YN = "USE_YN";
                /// <summary>
                /// 업데이트 일자
                /// </summary>
                public const string UPD_DT = "UPD_DATE";
                /// <summary>
                /// 등록 일자
                /// </summary>
                public const string REG_DT = "REG_DATE";
            }
        }
        #endregion

        //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end, 20180510


        #region NHS 부가옵션
        /// <summary>
        /// 2019-05-08 - 1997fx11 : 14.NHS부가옵션
        /// </summary>
        public class NHS_OPTN_MST
        {
            public const string TABLE_NAME = "NHS_OPTN_MST";

            public class DATA
            {
                public const string CMP_CD = "CMP_CD";
                public const string SALES_ORG_CD = "SALES_ORG_CD";
                public const string ITEM_OPTN_GRP_CD = "ITEM_OPTN_GRP_CD";
                public const string ITEM_OPTN_CD = "ITEM_OPTN_CD";
                public const string ITEM_OPTN_NM = "ITEM_OPTN_NM";
                public const string KIND = "KIND";
                public const string OPTN_MTD = "OPTN_MTD";
                public const string KIND_CODE = "KIND_CODE";
                public const string AMT = "AMT";
                public const string MIN_AMT = "MIN_AMT";
                public const string MAX_AMT = "MAX_AMT";
            }
        }
        #endregion
    }
    #endregion

    #region 준비금 업무 정의
    /// <summary>
    /// 준비금 업무 정의
    /// </summary>
    public static class PosAcc
    {
        #region 준비금 조회 데이터
        /// <summary>
        /// 상품조회 데이터
        /// </summary>
        public class ACC_REMONEY_SEARCH
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "ACC_REMONEY_SEARCH";

            public class DATA
            {
                /// <summary>
                /// NO
                /// </summary>
                public const string NO = "NO";
                /// <summary>
                /// 캐셔 이름
                /// </summary>
                public const string CASHIER_NM = "CASHIER_NM";
                /// <summary>
                /// 준비금(합계) 
                /// </summary>
                public const string TOTSALE_AMT = "TOTSALE_AMT";
                /// <summary>
                /// 입력시간 
                /// </summary>
                public const string PAY_TIME = "PAY_TIME";
            }
        }
        #endregion
    }
    #endregion

    #region 매출 TR 컬럼 정의
    /// <summary>
    /// 
    /// </summary>
    public static class PosTr
    {
        #region 판매상품(TR_SALE_DETAIL)
        /// <summary>
        /// TR_SALE_DETAIL (판매 상품)
        /// </summary>
        public class TR_SALE_DETAIL
        {
            public const string ITEM = "TR_SALE_DETAIL";

            public class DATA
            {
                /// <summary>
                /// 주문시간
                /// </summary>
                public const string ORD_TIME = "ORD_TIME";
                /// <summary>
                /// 층코드
                /// </summary>
                public const string FLOOR_CD = "FLOOR_CD";
                /// <summary>
                /// 테이블번호
                /// </summary>
                public const string TBL_NO = "TBL_NO";
                /// <summary>
                /// 상품 브랜드 코드
                /// </summary>
                public const string ITEM_BRAND_CD = "ITEM_BRAND_CD";
                /// <summary>
                /// 서브매장코드 
                /// </summary>
                public const string SUB_SHOP_CD = "SUB_SHOP_CD";
                /// 상품코드  
                public const string ITEM_PLU_CD = "ITEM_PLU_CD";
                /// <summary>
                /// 상품구분(0:일반, 1:세트, 2:세트자식, 3:부가상품, 4:세트할인, 5:상품권(추가))
                /// </summary>
                public const string ITEM_DIV = "ITEM_DIV";
                /// <summary>
                /// 판매 수량
                /// </summary>
                public const string SALE_QTY = "SALE_QTY";
                /// <summary>
                /// 판매 단가
                /// </summary>        
                public const string SALE_PRC = "SALE_PRC";
                /// <summary>
                /// 판매 금액
                /// </summary>         
                public const string SALE_AMT = "SALE_AMT";
                /// <summary>
                /// 플레이버 구분(0:관련없음, 1:완료(플레이버를 선택할 수 있는 상품), 2:투입(플레이버상품))
                /// </summary>
                public const string FLAVOUR_DIV = "FLAVOUR_DIV";
                /// <summary>
                /// 플레이버 수량
                /// </summary>
                public const string FLAVOUR_QTY = "FLAVOUR_QTY";
                /// <summary>
                /// 픞레이버 중량
                /// </summary>
                public const string FLAVOUR_STOCK = "FLAVOUR_STOCK";
                /// <summary>
                /// 상품 입력구분(0:SCAN,터치키,1:수입력)
                /// </summary>
                public const string ITEM_INPUT_DIV = "ITEM_INPUT_DIV";
                /// <summary>
                /// 상품스캔코드
                /// </summary>
                public const string ITEM_BAR_CD = "ITEM_BAR_CD";
                /// <summary>
                /// TAKE IN/OUT 구분(0:in, 1:out)
                /// </summary>
                public const string TAKE_IN_OUT_DIV = "TAKE_IN_OUT_DIV";
                /// <summary>
                /// 상품 과세 구분
                /// </summary>
                public const string ITEM_TAX_DIV = "ITEM_TAX_DIV";
                /// <summary>
                /// 세금 포함 여부 1:부가세포함, 2:부가세미포함
                /// </summary>
                public const string TAX_AMT_INCLUDE_YN = "TAX_AMT_INCLUDE_YN";
                /// <summary>
                /// 세금율 코드
                /// </summary>
                public const string TAXRATE_CD = "TAXRATE_CD";
                /// <summary>
                /// 적용 세금
                /// </summary>
                public const string APPLY_TAX_AMT = "APPLY_TAX_AMT";
                /// <summary>
                /// 봉사료 금액
                /// </summary>
                public const string SVC_FEE_AMT = "SVC_FEE_AMT";
                /// <summary>
                /// 봉사료 부가세
                /// </summary>
                public const string SVC_FEE_VAT = "SVC_FEE_VAT";
                /// <summary>
                /// 봉사료 부가세율 코드
                /// </summary>
                public const string SVC_TAXREATE_CD = "SVC_TAXREATE_CD";
                /// <summary>
                /// 영수 금액
                /// </summary>
                public const string BILL_AMT = "BILL_AMT";
                /// <summary>
                /// 비매출코드 
                /// </summary>
                public const string NONSALES_RSN_CD = "NONSALES_RSN_CD";
                /// <summary>
                /// POS 할인 구분(00:정상, 01:무료(서비스), 02:임의할인,03:환경사랑DC,04:제품교환권,06:입점건물직원할인, 07:수수료할인)
                /// </summary>
                public const string DC_DIV = "DC_DIV";
                /// <summary>
                /// 할인 유형
                /// </summary>
                public const string DC_TYPE = "DC_TYPE";
                /// <summary>
                /// POS 할인 율
                /// </summary>
                public const string DC_RATE = "DC_RATE";
                /// <summary>
                /// POS 단품 할인 금액
                /// </summary>
                public const string ITEM_DC_AMT = "ITEM_DC_AMT";
                /// <summary>
                /// POS 소계 할인 금액
                /// </summary>
                public const string SUM_DC_AMT = "SUM_DC_AMT";
                /// <summary>
                /// 캠페인 할인 금액
                /// </summary>
                public const string CPI_DC_AMT = "CPI_DC_AMT";
                /// <summary>
                /// 제휴카드 할인 구분(SKT,LGT,KT 할인)
                /// </summary>
                public const string COOP_CARD_DC_DIV = "COOP_CARD_DC_DIV";
                /// <summary>
                /// 제휴카드 할인 금액(SKT,LGT,KT 할인 금액)
                /// </summary>
                public const string COOP_CARD_DC_AMT = "COOP_CARD_DC_AMT";
                /// <summary>
                /// 포인트 할인 구분
                /// </summary>
                public const string POINT_DC_DIV = "POINT_DC_DIV";
                /// <summary>
                /// 포인트 할인 금액
                /// </summary>
                public const string POINT_DC_AMT = "POINT_DC_AMT";
                /// <summary>
                /// 쿠폰 할인 구분(00:없음, 01:쿠폰, 02:해피쿠폰할인(스템프,복권), 03:인카드쿠폰, 04:매장쿠폰)
                /// </summary>
                public const string CPN_DC_DIV = "CPN_DC_DIV";
                /// <summary>
                /// 쿠폰 할인 금액
                /// </summary>
                public const string CPN_DC_AMT = "CPN_DC_AMT";
                /// <summary>
                /// 직원 할인 구분
                /// </summary>
                public const string EMP_DC_DIV = "EMP_DC_DIV";
                /// <summary>
                /// 직원 할인 금액
                /// </summary>
                public const string EMP_DC_AMT = "EMP_DC_AMT";
                /// <summary>
                /// 세트 할인 금액
                /// </summary>
                public const string SET_DC_AMT = "SET_DC_AMT";
                /// <summary>
                /// 기타 할인 구분
                /// </summary>
                public const string ETC_DC_DIV = "ETC_DC_DIV";
                /// <summary>
                /// 기타 할인 금액
                /// </summary>
                public const string ETC_DC_AMT = "ETC_DC_AMT";
                /// <summary>
                /// 예외할인구분
                /// </summary>
                public const string EXCEP_DC_DIV = "EXCEP_DC_DIV";
                /// <summary>
                /// 예외할인금액
                /// </summary>
                public const string EXCEP_DC_AMT = "EXCEP_DC_AMT";
                /// <summary>
                /// 포장구분
                /// </summary>
                public const string PACK_DIV = "PACK_DIV";
                /// <summary>
                /// 판매 상품권/선불카드 번호
                /// </summary>
                public const string SALE_GIFT_NO = "SALE_GIFT_NO";
                /// <summary>
                /// 세트메뉴코드
                /// </summary>
                public const string SET_MENU_CD = "SET_MENU_CD";
                /// <summary>
                /// 캠페인증정구분
                /// </summary>
                public const string CPI_PRESENT_DIV = "CPI_PRESENT_DIV";
                /// <summary>
                /// 쿠폰번호
                /// </summary>
                public const string CPN_NO = "CPN_NO";
                /// <summary>
                /// 빌분리번호
                /// </summary>
                public const string BILLSPR_NO = "BILLSPR_NO";
                /// <summary>
                /// 취소 구분
                /// </summary>
                public const string CANCEL_DIV = "CANCEL_DIV";
                /// <summary>
                /// 취소 일시
                /// </summary>
                public const string CANCEL_DATE = "CANCEL_DATE";
                /// <summary>
                /// NOTAX 구분 0:미적용, 1:적용
                /// </summary>
                public const string NOTAX_DIV = "NOTAX_DIV";

                //////////////////////////////////////////////////////////////////////////////////////////////////////
                //////////////////////////// 상품등록중 필요 변수 ////////////////////////////////////////////////////
                //////////////////////////////////////////////////////////////////////////////////////////////////////
                /// <summary>
                /// 취소 구분(메인상품)
                /// </summary>
                public const string CANCEL_DIV_MAIN = "CANCEL_DIV_MAIN";
                /// <summary>
                /// 상품명
                /// </summary>
                public const string ITEM_NAME = "ITEM_NAME";
                /// <summary>
                /// 부가 세트 관리 유형(상품종류)
                /// </summary>
                public const string SUB_SET_MNG_TYPE = "SUB_SET_MNG_TYPE";
                ///// <summary>
                ///// 판매 허용 여부
                ///// </summary>
                //public const string SALE_PRMT_YN = "";
                /// <summary>
                /// 사은품 여부
                /// </summary>
                public const string FREE_GIFT_YN = "FREE_GIFT_YN";
                /// <summary>
                /// 할인 불가 여부(0:가능, 1:불가)
                /// </summary>
                public const string DC_PRMT_YN = "DC_PRMT_YN";
                /// <summary>
                /// 적립 허용 여부
                /// </summary>
                public const string ACCUM_PRMT_YN = "ACCUM_PRMT_YN";
                /// <summary>
                /// 봉사료 대상 여부
                /// </summary>
                public const string SVC_FEE_TRGT_YN = "SVC_FEE_TRGT_YN";
                /// <summary>
                /// 제휴카드 할인 불가 여부(0:가능, 1:불가)
                /// </summary>
                public const string COOP_CARD_DC_NOADM_YN = "COOP_CARD_DC_NOADM_YN";
                /// <summary>
                /// 총 할인금액
                /// </summary>
                public const string TOT_DC_AMT = "TOT_DC_AMT";
                /// <summary>
                /// 주문 상태
                /// </summary>
                public const string ORDER_OK_FLAG = "ORDER_OK_FLAG";
                /// <summary>
                /// 세트 할인 수량
                /// </summary>
                public const string SET_DC_QTY = "SET_DC_QTY";
                /// <summary>
                /// 부가메모구분(0:일반, 1:부가메모)
                /// </summary>
                public const string SUB_MEMO_DIV = "SUB_MEMO_DIV";
                /// <summary>
                /// 중분류 코드
                /// </summary>
                public const string M_CLSS = "M_CLSS";
                /// <summary>
                /// 상품별 캠페인 정보
                /// </summary>
            }
        }
        #endregion
    }
    #endregion


    #region 고객불만사항 업무 정의
    /// <summary>
    /// 고객불만사항 업무 정의
    /// </summary>
    public static class PosEtc
    {
        #region 고객불만사항 조회 데이터
        /// <summary>
        /// 상품조회 데이터
        /// </summary>
        public class CUSTOMER_CLAIM_INFO
        {
            /// <summary>
            /// 테이블명
            /// </summary>
            public const string TABLE_NAME = "CUSTOMER_CLAIM_INFO";

            public class DATA
            {
                /// <summary>
                /// 접수일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 순번 
                /// </summary>
                public const string SEQ = "SEQ";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 고객명
                /// </summary>
                public const string CUST_NM = "CUST_NM";
                /// <summary>
                /// 고객성별
                /// </summary>
                public const string CUST_SEX = "CUST_SEX";
                /// <summary>
                /// 고객전화번호
                /// </summary>
                public const string CUST_TEL = "CUST_TEL";
                /// <summary>
                /// 처리비용
                /// </summary>
                public const string CLAIM_PRC_COST = "CLAIM_PRC_COST";
                /// <summary>
                /// 대표제품
                /// </summary>
                public const string ITEM_SNM = "ITEM_SNM";
                /// <summary>
                /// 구매일자
                /// </summary>
                public const string BUY_DT = "BUY_DT";
                /// <summary>
                /// 제품코드
                /// </summary>
                public const string LOT_NO = "LOT_NO";
                /// <summary>
                /// 처리구분
                /// </summary>
                public const string CLAIM_PRC_GB = "CLAIM_PRC_GB";
                /// <summary>
                /// 처리내용
                /// </summary>
                public const string CLAIM_PRC_MEMO = "CLAIM_PRC_MEMO";
            }
        }
        #endregion

        #region 입출금 (ETC_SALE_DPST_WTHDR)
        /// <summary>
        /// TR_SALE_DPST_WTHDR (입출금)
        /// </summary>
        public class ETC_SALE_DPST_WTHDR
        {
            public const string ITEM = "ETC_SALE_DPST_WTHDR";

            public class DATA
            {
                /// <summary>
                /// 회사 코드
                /// </summary>
                public const string CMP_CD = "CMP_CD";
                /// <summary>
                /// 판매 일자
                /// </summary>
                public const string SALE_DT = "SALE_DT";
                /// <summary>
                /// 점포 코드
                /// </summary>
                public const string STOR_CD = "STOR_CD";
                /// <summary>
                /// POS 번호
                /// </summary>
                public const string POS_NO = "POS_NO";
                /// <summary>
                /// 거래 번호
                /// </summary>
                public const string TRADE_NO = "TRADE_NO";
                /// 순번  
                public const string SEQ = "SEQ";
                /// <summary>
                /// 입출금유형(80:준비금, 81:마감시재, 82:기타입출금, 환불:41)
                /// </summary>
                public const string DPST_WTHDR_TYPE = "DPST_WTHDR_TYPE";
                /// <summary>
                /// 입출금 계정
                /// </summary>
                public const string DPST_WTHDR_ACC_CD = "DPST_WTHDR_ACC_CD";
                /// <summary>
                /// 입출금 코드(01:입금,02:출금)
                /// </summary>        
                public const string DPST_WTHDR_CD = "DPST_WTHDR_CD";
                /// <summary>
                /// 입출금 수량
                /// </summary>         
                public const string DPST_WTHDR_QTY = "DPST_WTHDR_QTY";
                /// <summary>
                /// 입출금 금액
                /// </summary>
                public const string DPST_WTHDR_AMT = "DPST_WTHDR_AMT";
                /// <summary>
                /// 입출금 명(입출금 종류이름(예:공중전화 등))
                /// </summary>
                public const string DPST_WTHDR_NM = "DPST_WTHDR_NM";
                /// <summary>
                /// 고객 번호(외상시 고객번호)
                /// </summary>
                public const string CUST_NO = "CUST_NO";
                /// <summary>
                /// 점포결제유형
                /// </summary>
                public const string STOR_PAY_TYPE = "STOR_PAY_TYPE";
                /// <summary>
                /// 기타사유
                /// </summary>
                public const string ETC_REASON = "ETC_REASON";
                /// <summary>
                /// 여유 필드 01
                /// </summary>
                public const string SLACK_FIELD_01 = "SLACK_FIELD_01";
                /// <summary>
                /// 여유 필드 02
                /// </summary>
                public const string SLACK_FIELD_02 = "SLACK_FIELD_02";
                /// <summary>
                /// 여유 필드 03
                /// </summary>
                public const string SLACK_FIELD_03 = "SLACK_FIELD_03";
                /// <summary>
                /// 여유 필드 04
                /// </summary>
                public const string SLACK_FIELD_04 = "SLACK_FIELD_04";
                /// <summary>
                /// 여유 필드 05
                /// </summary>
                public const string SLACK_FIELD_05 = "SLACK_FIELD_05";

            }
        }
        #endregion
    }
    #endregion


    #region 전문 생성 및 분해 처리
    public class ItemColumn
    {
        /// <summary>
        /// 전문 생성 처리
        /// </summary>
        /// <param name="aItemData"></param>
        /// <param name="aItemLen"></param>
        /// <param name="aItemType"></param>
        /// <returns></returns>
        public static string MakeMessage(string[] aItemData, int[] aItemLen, int[] aItemType)
        {
            return MakeMessage(aItemData, aItemLen, aItemType, "", "");
        }
        public static string MakeMessage(string[] aItemData, int[] aItemLen, int[] aItemType, string sPosNo, string sTranNo)
        {
            string sRetData = "";

            for (int i = 0; i < aItemLen.Length; i++)
            {
                if (aItemLen[i] == 0) continue;
                if (aItemData[i] == null) aItemData[i] = "";

                if (aItemLen[i] == -1)
                {
                    sRetData += aItemData[i];
                    continue;
                }

                // 컬럼타입(0:문자형, 1:숫자형, 2:금액형, 3:가변)
                if (aItemType[i] == 1)          // 숫자형
                {
                    string sNumData = "";
                    if (CmUtil.LongParse(aItemData[i]) < 0)
                    {
                        sNumData = "-" + System.Math.Abs(CmUtil.LongParse(aItemData[i])).ToString().PadLeft(aItemLen[i] - 1, '0');
                    }
                    else
                    {
                        sNumData = aItemData[i].PadLeft(aItemLen[i], '0');
                    }
                    sRetData += UsUtil.RPadH(sNumData, aItemLen[i]);

                }
                else if (aItemType[i] == 2)     // 금액형
                {
                    string sNumData = "";
                    if (CmUtil.DoubleParse(aItemData[i]) < 0)
                    {
                        sNumData = "-" + System.Math.Abs(CmUtil.DoubleParse(aItemData[i])).ToString().PadLeft(aItemLen[i] - 1, '0');
                    }
                    else
                    {
                        sNumData = aItemData[i].PadLeft(aItemLen[i], '0');
                    }
                    sRetData += UsUtil.RPadH(sNumData, aItemLen[i]);
                }
                else if (aItemType[i] == 3 || aItemType[i] == 4)     // 가변
                {
                    sRetData += aItemData[i]; //Trim(); 가변은 데이터 넘기는 부분에 trim이 필요할 경우 처리해야 한다.
                }
                else if (aItemType[i] == 5) // 문자형이고 왼쪽에 공백 추가;girak.kim;2017.08.18
                {
                    sRetData += UsUtil.LPadH(aItemData[i], aItemLen[i]);
                }
                else                            // 문자형
                {
                    sRetData += UsUtil.RPadH(aItemData[i], aItemLen[i]);
                }

            }
            return sRetData;
        }

        /// <summary>
        /// 전문 분해 처리
        /// </summary>
        /// <param name="aItemLen"></param>
        /// <param name="aData"></param>
        /// <param name="nNowPos"></param>
        /// <param name="aItemData"></param>
        /// <returns></returns>
        public static int ParseMessage(int[] aItemLen, int[] aItemType, byte[] aData, ref int nNowPos, ref string[] aItemData)
        {
            return ParseMessage(aItemLen, aItemType, aData, ref nNowPos, ref aItemData, "", "");
        }
        public static int ParseMessage(int[] aItemLen, int[] aItemType, byte[] aData, ref int nNowPos, ref string[] aItemData, string sPosNo, string sTranNo)
        {
            for (int i = 0; i < aItemLen.Length; i++)
            {
                if (aItemLen[i] == 0 || aItemLen[i] == -1) continue;

                try
                {
                    if (aData.Length < nNowPos + aItemLen[i])
                    {
                        if (aData.Length > nNowPos)
                        {
                            byte[] byValue = new byte[aData.Length - nNowPos];
                            Array.Copy(aData, nNowPos, byValue, 0, aData.Length - nNowPos);
                            aItemData[i] = Encoding.Default.GetString(byValue, 0, byValue.Length);
                        }
                        else
                            aItemData[i] = "";
                    }
                    else
                    {
                        if (aItemType[i] == 3 || aItemType[i] == 4)   //가변데이터 처리
                        {
                            int iDataLen = 0;
                            aItemData[i] = ParseIndexOf(aItemType[i], nNowPos, aData, ref iDataLen);
                            nNowPos += iDataLen;
                            continue;
                        }
                        else
                        {
                            byte[] byValue = new byte[aItemLen[i]];
                            Array.Copy(aData, nNowPos, byValue, 0, aItemLen[i]);
                            aItemData[i] = Encoding.Default.GetString(byValue, 0, byValue.Length);
                        }

                    }
                }
                catch (Exception ex)
                {
                    UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name, "ItemColumn.ParsMessage()", "Exception.[" + i.ToString() + "]" + ex.Message);
                }
                nNowPos += aItemLen[i];
            }
            return nNowPos;
        }

        /// <summary>
        /// 전문 가변 필드 처리
        /// </summary>
        /// <param name="Start"></param>
        /// <param name="byVal"></param>
        /// <param name="DataLen"></param>
        /// <returns></returns>
        public static string ParseIndexOf(int nType, int Start, byte[] byVal, ref int DataLen)
        {
            string sData = "";

            DataLen = 0;

            for (int i = Start; i < byVal.Length; i++)
            {

                if (nType == 4)
                {
                    // RS 만 구분 필드로 체크
                    if (byVal[i] == PosConst.VAN_HEXA_BYTE.RS)
                    {
                        DataLen = i - Start;
                        if (DataLen > 0)
                        {
                            byte[] byValue = new byte[DataLen];
                            Array.Copy(byVal, Start, byValue, 0, DataLen);
                            sData = Encoding.Default.GetString(byValue, 0, byValue.Length);
                        }
                        break;
                    }
                }
                else
                {
                    if (byVal[i] == PosConst.VAN_HEXA_BYTE.GS || byVal[i] == PosConst.VAN_HEXA_BYTE.ETX || byVal[i] == PosConst.VAN_HEXA_BYTE.RS)
                    {
                        DataLen = i - Start;
                        if (DataLen > 0)
                        {
                            byte[] byValue = new byte[DataLen];
                            Array.Copy(byVal, Start, byValue, 0, DataLen);
                            sData = Encoding.Default.GetString(byValue, 0, byValue.Length);
                        }
                        break;
                    }
                }
            }
            return sData;
        }


        /// <summary>
        /// 전문 분해 처리
        /// </summary>
        /// <param name="aItemLen"></param>
        /// <param name="sData"></param>
        /// <param name="nPos"></param>
        /// <param name="aItemData"></param>
        /// <returns></returns>
        public static int ParseMessage(int[] aItemLen, int[] aItemType, string sData, int nPos, ref string[] aItemData)
        {
            byte[] bytData = Encoding.Default.GetBytes(sData);

            return ParseMessage(aItemLen, aItemType, bytData, ref nPos, ref aItemData, "", "");
        }
        /// <summary>
        /// 전문 분해 처리
        /// </summary>
        /// <param name="aItemLen"></param>
        /// <param name="bytData"></param>
        /// <param name="nPos"></param>
        /// <param name="aItemData"></param>
        /// <returns></returns>
        public static int ParseMessage(int[] aItemLen, int[] aItemType, byte[] bytData, int nPos, ref string[] aItemData)
        {
            return ParseMessage(aItemLen, aItemType, bytData, ref nPos, ref aItemData, "", "");
        }

        /// <summary>
        /// 메시지 길이 얻기
        /// </summary>
        /// <param name="aItemLen"></param>
        /// <returns></returns>
        public static int LenMessage(int[] aItemLen)
        {
            int nLen = 0;

            for (int i = 0; i < aItemLen.Length; i++)
            {
                if (aItemLen[i] == 0 || aItemLen[i] == -1) continue;

                nLen += aItemLen[i];
            }

            return nLen;
        }

        /// <summary>
        /// 통신해더 전문을 생성 한다.
        /// </summary>
        /// <param name="nMsgLen"></param>
        /// <param name="sMsgType"></param>
        /// <param name="sMsgKind"></param>
        /// <returns></returns>
        public static string MakeCommHeader(int nMsgLen, string sMsgType)
        {
            try
            {
                PosStatus m_cPosStatus = (PosStatus)((StateServer)StateServer.GetInstance()).POS;

                string[] aCommHead = new string[Column.COMM_HEADER.LEN.Length];

                // 통신헤더의 전문 길이는 통신헤더길이 제외
                // 박동철B, 조충연K - 2016.0818
                //int nHeadLen = nMsgLen + LenMessage(Column.COMM_HEADER.LEN);
                int nHeadLen = nMsgLen;
                aCommHead[Column.COMM_HEADER.SEQ.MsgLen] = nHeadLen.ToString();
                aCommHead[Column.COMM_HEADER.SEQ.MsgType] = sMsgType;
                aCommHead[Column.COMM_HEADER.SEQ.CmpCd] = m_cPosStatus.Base.CmpCd;
                aCommHead[Column.COMM_HEADER.SEQ.BrandCd] = m_cPosStatus.Base.BrandCd;
                aCommHead[Column.COMM_HEADER.SEQ.StoreCd] = m_cPosStatus.Base.StoreNo;
                aCommHead[Column.COMM_HEADER.SEQ.PosNo] = m_cPosStatus.Base.PosNo;
                //aCommHead[Column.COMM_HEADER.SEQ.RegNo] = m_cPosStatus.Base.RegNo;
                aCommHead[Column.COMM_HEADER.SEQ.TradeNo] = m_cPosStatus.Base.TradeNo;
                aCommHead[Column.COMM_HEADER.SEQ.TranYmd] = m_cPosStatus.Base.SaleDate;
                aCommHead[Column.COMM_HEADER.SEQ.SysYmd] = DateTime.Now.ToString("yyyyMMdd");
                aCommHead[Column.COMM_HEADER.SEQ.SysHms] = DateTime.Now.ToString("HHmmss");
                aCommHead[Column.COMM_HEADER.SEQ.EncType] = "0";
                aCommHead[Column.COMM_HEADER.SEQ.ErrCd] = "000";

                return ItemColumn.MakeMessage(aCommHead, Column.COMM_HEADER.LEN, Column.COMM_HEADER.TYPE);
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name, "ItemColumn.MakeCommHeader()", "Exception." + ex.Message);
            }
            return "";
        }
        /// <summary>
        /// 통신헤더 전문을 생성
        /// </summary>
        /// <param name="nMsgLen"></param>
        /// <param name="sMsgType"></param>
        /// <param name="sBrandCd"></param>
        /// <returns></returns>
        public static string MakeCommHeader(int nMsgLen, string sMsgType, string sBrandCd)
        {
            try
            {
                PosStatus m_cPosStatus = (PosStatus)((StateServer)StateServer.GetInstance()).POS;

                string[] aCommHead = new string[Column.COMM_HEADER.LEN.Length];

                // 통신헤더의 전문 길이는 통신헤더길이 제외
                // 박동철B, 조충연K - 2016.0818
                //int nHeadLen = nMsgLen + LenMessage(Column.COMM_HEADER.LEN);
                int nHeadLen = nMsgLen;
                aCommHead[Column.COMM_HEADER.SEQ.MsgLen] = nHeadLen.ToString();
                aCommHead[Column.COMM_HEADER.SEQ.MsgType] = sMsgType;
                aCommHead[Column.COMM_HEADER.SEQ.CmpCd] = m_cPosStatus.Base.CmpCd;
                aCommHead[Column.COMM_HEADER.SEQ.BrandCd] = sBrandCd;
                aCommHead[Column.COMM_HEADER.SEQ.StoreCd] = m_cPosStatus.Base.StoreNo;
                aCommHead[Column.COMM_HEADER.SEQ.PosNo] = m_cPosStatus.Base.PosNo;
                //aCommHead[Column.COMM_HEADER.SEQ.RegNo] = m_cPosStatus.Base.RegNo;
                aCommHead[Column.COMM_HEADER.SEQ.TradeNo] = m_cPosStatus.Base.TradeNo;
                aCommHead[Column.COMM_HEADER.SEQ.TranYmd] = m_cPosStatus.Base.SaleDate;
                aCommHead[Column.COMM_HEADER.SEQ.SysYmd] = DateTime.Now.ToString("yyyyMMdd");
                aCommHead[Column.COMM_HEADER.SEQ.SysHms] = DateTime.Now.ToString("HHmmss");
                aCommHead[Column.COMM_HEADER.SEQ.EncType] = "0";
                aCommHead[Column.COMM_HEADER.SEQ.ErrCd] = "000";

                return ItemColumn.MakeMessage(aCommHead, Column.COMM_HEADER.LEN, Column.COMM_HEADER.TYPE);
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name, "ItemColumn.MakeCommHeader()", "Exception." + ex.Message);
            }
            return "";
        }

        /// <summary>
        /// POS IRT 헤더 전문을 생성 한다.
        /// </summary>
        /// <param name="nMsgLen">데이터길이</param>
        /// <returns></returns>
        public static string MakePosIrtHeader(int nMsgLen)
        {
            try
            {

            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name, "ItemColumn.MakePosIrtHeader()", "Exception." + ex.Message);
            }
            return "";
        }

        ///// <summary>
        ///// 거래해더 전문을 생성 한다.
        ///// </summary>
        ///// <param name="nMsgLen">데이터길이</param>
        ///// <returns></returns>
        //public static string MakeTranHeader(int nMsgLen)
        //{
        //    try
        //    {
        //        TranStatus m_cTrnStatus = (TranStatus)((StateServer)StateServer.GetInstance()).TRAN;
        //        PosStatus m_cPosStatus = (PosStatus)((StateServer)StateServer.GetInstance()).POS;

        //        string[] aTranHead = new string[Column.TRAN_HEADER.LEN.Length];

        //        aTranHead[Column.TRAN_HEADER.SEQ.CoCd] = m_cTrnStatus.Head.CmpCd;
        //        aTranHead[Column.TRAN_HEADER.SEQ.StoreCd] = m_cTrnStatus.Head.StoreCd;
        //        aTranHead[Column.TRAN_HEADER.SEQ.SaleDate] = m_cTrnStatus.Head.SaleDate;
        //        aTranHead[Column.TRAN_HEADER.SEQ.PosNo] = m_cTrnStatus.Head.PosNo;
        //        //aTranHead[Column.TRAN_HEADER.SEQ.RegNo] = m_cTrnStatus.Head.RegNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.TradeNo] = m_cTrnStatus.Head.TradeNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.TradeDiv] = m_cTrnStatus.Head.TradeDiv;
        //        aTranHead[Column.TRAN_HEADER.SEQ.TrainModeYn] = m_cTrnStatus.Head.TrainModeYn;
        //        aTranHead[Column.TRAN_HEADER.SEQ.TradeKind] = m_cTrnStatus.Head.TradeKind;
        //        aTranHead[Column.TRAN_HEADER.SEQ.SysYmd] = m_cTrnStatus.Head.SysYmd;
        //        aTranHead[Column.TRAN_HEADER.SEQ.OrderHms] = m_cTrnStatus.Head.OrderHms;
        //        aTranHead[Column.TRAN_HEADER.SEQ.PayHms] = m_cTrnStatus.Head.PayHms;
        //        aTranHead[Column.TRAN_HEADER.SEQ.CashierId] = m_cTrnStatus.Head.CashierId;
        //        aTranHead[Column.TRAN_HEADER.SEQ.OrderPicNo] = m_cTrnStatus.Head.OrderPicNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.OwnPartDiv] = m_cTrnStatus.Head.OwnPartDiv;
        //        aTranHead[Column.TRAN_HEADER.SEQ.OrgPosNo] = m_cTrnStatus.Head.OrgPosNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.OrgTradeNo] = m_cTrnStatus.Head.OrgTradeNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.RtnReasonCd] = m_cTrnStatus.Head.RtnReasonCd;
        //        aTranHead[Column.TRAN_HEADER.SEQ.RtnReasonMemo] = m_cTrnStatus.Head.RtnReasonMemo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.NonSaleRsnCd] = m_cTrnStatus.Head.NonSaleRsnCd;
        //        aTranHead[Column.TRAN_HEADER.SEQ.ReserveNo] = m_cTrnStatus.Head.ReserveNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.ReserveYmd] = m_cTrnStatus.Head.ReserveYmd;
        //        aTranHead[Column.TRAN_HEADER.SEQ.MemberCustNo] = m_cTrnStatus.Head.MemberCustNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.OrderFlag] = m_cTrnStatus.Head.OrderFlag;
        //        aTranHead[Column.TRAN_HEADER.SEQ.FloorCd] = m_cTrnStatus.Head.FloorCd;
        //        aTranHead[Column.TRAN_HEADER.SEQ.TableNo] = m_cTrnStatus.Head.TableNo;
        //        aTranHead[Column.TRAN_HEADER.SEQ.CustFloor] = m_cTrnStatus.Head.CustFloor;
        //        aTranHead[Column.TRAN_HEADER.SEQ.ForeignFlag] = m_cTrnStatus.Head.ForeignFlag;
        //        aTranHead[Column.TRAN_HEADER.SEQ.CustCnt] = (m_cTrnStatus.Head.CustCnt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.PayGndrDiv] = m_cTrnStatus.Head.PayGndrDiv;
        //        aTranHead[Column.TRAN_HEADER.SEQ.PayAge] = m_cTrnStatus.Head.PayAge.ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.ManCmpnpsnCnt] = m_cTrnStatus.Head.ManCmpnpsnCnt.ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.WomanCmpnpsnCnt] = m_cTrnStatus.Head.WomanCmpnpsnCnt.ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.TotQty] = (m_cTrnStatus.Head.TotQty).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.TotSaleAmt] = (m_cTrnStatus.Head.TotSaleAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.TotDcAmt] = (m_cTrnStatus.Head.TotDcAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.NetSaleAmt] = (m_cTrnStatus.Head.NetSaleAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.ItemDcAmt] = (m_cTrnStatus.Head.ItemDcAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.CpiDcAmt] = (m_cTrnStatus.Head.CpiDcAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.SetDcAmt] = (m_cTrnStatus.Head.SetDcAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.EtcAmt] = (m_cTrnStatus.Head.EtcDcAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.TotVatAmt] = (m_cTrnStatus.Head.TotVatAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.SvcFeeAmt] = (m_cTrnStatus.Head.SvcFeeAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.SvcFeeVat] = (m_cTrnStatus.Head.SvcFeeVat).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.EtcVatAmt] = (m_cTrnStatus.Head.EtcVatAmt).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.AftSavePoint] = (m_cTrnStatus.Head.AftSavePoint).ToString();
        //        aTranHead[Column.TRAN_HEADER.SEQ.AmtDutchPayYn] = m_cTrnStatus.Head.AmtDutchPayYn;
        //        aTranHead[Column.TRAN_HEADER.SEQ.BillSplitCnt] = (m_cTrnStatus.Head.BillSplitCnt).ToString();

        //        return ItemColumn.MakeMessage(aTranHead, Column.TRAN_HEADER.LEN, Column.TRAN_HEADER.TYPE);
        //    }
        //    catch (Exception ex)
        //    {
        //        UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name, "ItemColumn.MakeTranHeader()", "Exception." + ex.Message);
        //    }
        //    return "";
        //}


        // Rhee, 2017.10.23, 포스별 매출 조회기능 추가 Start
        /// <summary>
        /// 통신헤더 전문을 생성
        /// </summary>
        /// <param name="nMsgLen"></param>
        /// <param name="sMsgType"></param>
        /// <param name="sCmpCd"></param>
        /// <param name="sPosNo"></param>
        /// <returns></returns>
        public static string MakeCommHeader(int nMsgLen, string sMsgType, string sCmpCd, string sPosNo)
        {
            try
            {
                PosStatus m_cPosStatus = (PosStatus)((StateServer)StateServer.GetInstance()).POS;

                string[] aCommHead = new string[Column.COMM_HEADER.LEN.Length];

                // 통신헤더의 전문 길이는 통신헤더길이 제외
                // 박동철B, 조충연K - 2016.0818
                //int nHeadLen = nMsgLen + LenMessage(Column.COMM_HEADER.LEN);
                int nHeadLen = nMsgLen;
                aCommHead[Column.COMM_HEADER.SEQ.MsgLen] = nHeadLen.ToString();
                aCommHead[Column.COMM_HEADER.SEQ.MsgType] = sMsgType;
                aCommHead[Column.COMM_HEADER.SEQ.CmpCd] = sCmpCd;
                aCommHead[Column.COMM_HEADER.SEQ.BrandCd] = m_cPosStatus.Base.BrandCd;
                aCommHead[Column.COMM_HEADER.SEQ.StoreCd] = m_cPosStatus.Base.StoreNo;
                aCommHead[Column.COMM_HEADER.SEQ.PosNo] = sPosNo;
                //aCommHead[Column.COMM_HEADER.SEQ.RegNo] = m_cPosStatus.Base.RegNo;
                aCommHead[Column.COMM_HEADER.SEQ.TradeNo] = m_cPosStatus.Base.TradeNo;
                aCommHead[Column.COMM_HEADER.SEQ.TranYmd] = m_cPosStatus.Base.SaleDate;
                aCommHead[Column.COMM_HEADER.SEQ.SysYmd] = DateTime.Now.ToString("yyyyMMdd");
                aCommHead[Column.COMM_HEADER.SEQ.SysHms] = DateTime.Now.ToString("HHmmss");
                aCommHead[Column.COMM_HEADER.SEQ.EncType] = "0";
                aCommHead[Column.COMM_HEADER.SEQ.ErrCd] = "000";

                return ItemColumn.MakeMessage(aCommHead, Column.COMM_HEADER.LEN, Column.COMM_HEADER.TYPE);
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name, "ItemColumn.MakeCommHeader()", "Exception." + ex.Message);
            }
            return "";
        }
        // Rhee, 2017.10.23, 포스별 매출 조회기능 추가 End


    }
    #endregion
}
