﻿using System.Collections;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 메시지 관리
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.CommonManager
{
    /// <summary>
    /// POS 메시지 정의
    /// </summary>
    public class POS_MESSAGE
    {
        #region ** POS 메시지 종류 **
        /// <summary>
        /// POS 메시지 종류
        /// </summary>
        public class TYPE
        {
            /// <summary>
            /// 단어(레이블, 버튼)
            /// </summary>
            public const string LABEL = "1";
            /// <summary>
            /// 문장(에러, 확인, 질문)
            /// </summary>
            public const string ERROR = "2";
            /// <summary>
            /// 안내(팝업화면)
            /// </summary>
            public const string GUIDE = "3";
            /// <summary>
            /// 출력(영수증)
            /// </summary>
            public const string PRINT = "4";
            /// <summary>
            /// 정산(정산코드명)
            /// </summary>
            public const string EXACT = "5";
        };
        #endregion

        #region ** 단어(레이블, 버튼, 그리드) **
        /// <summary>
        /// 단어(레이블, 버튼, 그리드)
        /// </summary>
        public class LABEL
        {
            /// <summary>
            /// 개점
            /// </summary>
            public const string MSG_0001 = "0001";
            /// <summary>
            /// 판매
            /// </summary>
            public const string MSG_0002 = "0002";
            /// <summary>
            /// 입출금/마감
            /// </summary>
            public const string MSG_0003 = "0003";
            /// <summary>
            /// 조회
            /// </summary>
            public const string MSG_0004 = "0004";
            /// <summary>
            /// 관리
            /// </summary>
            public const string MSG_0005 = "0005";
            /// <summary>
            /// 연습모드
            /// </summary>
            public const string MSG_0006 = "0006";
            /// <summary>
            /// 기타
            /// </summary>
            public const string MSG_0007 = "0007";
            /// <summary>
            /// 종료
            /// </summary>
            public const string MSG_0008 = "0008";
            /// <summary>
            /// 확인
            /// </summary>
            public const string MSG_0009 = "0009";
            /// <summary>
            /// 취소
            /// </summary>
            public const string MSG_0010 = "0010";
            /// <summary>
            /// Login
            /// </summary>
            public const string MSG_0011 = "0011";
            /// <summary>
            /// ID
            /// </summary>
            public const string MSG_0012 = "0012";
            /// <summary>
            /// Password
            /// </summary>
            public const string MSG_0013 = "0013";
            /// <summary>
            /// No
            /// </summary>
            public const string MSG_0014 = "0014";
            /// <summary>
            /// 상품명
            /// </summary>
            public const string MSG_0015 = "0015";
            /// <summary>
            /// 단가
            /// </summary>
            public const string MSG_0016 = "0016";
            /// <summary>
            /// 수량
            /// </summary>
            public const string MSG_0017 = "0017";
            /// <summary>
            /// 할인
            /// </summary>
            public const string MSG_0018 = "0018";
            /// <summary>
            /// 금액
            /// </summary>
            public const string MSG_0019 = "0019";
            /// <summary>
            /// 비고
            /// </summary>
            public const string MSG_0020 = "0020";
            /// <summary>
            /// 삭제
            /// </summary>
            public const string MSG_0021 = "0021";
            /// <summary>
            /// 취소수량
            /// </summary>
            public const string MSG_0022 = "0022";
            /// <summary>
            /// 확인메시지
            /// </summary>
            public const string MSG_0023 = "0023";
            /// <summary>
            /// 선택메시지
            /// </summary>
            public const string MSG_0024 = "0024";
            /// <summary>
            /// 예
            /// </summary>
            public const string MSG_0025 = "0025";
            /// <summary>
            /// 아니요
            /// </summary>
            public const string MSG_0026 = "0026";
            /// <summary>
            /// 에러메시지
            /// </summary>
            public const string MSG_0027 = "0027";
            /// <summary>
            /// 확정
            /// </summary>
            public const string MSG_0028 = "0028";
            /// <summary>
            /// 대문자 영문
            /// </summary>
            public const string MSG_0029 = "0029";
            /// <summary>
            /// 소문자 영문
            /// </summary>
            public const string MSG_0030 = "0030";
            /// <summary>
            /// 숫자
            /// </summary>
            public const string MSG_0031 = "0031";
            /// <summary>
            /// 지우기
            /// </summary>
            public const string MSG_0032 = "0032";
            /// <summary>
            /// 알바
            /// </summary>
            public const string MSG_0033 = "0033";
            /// <summary>
            /// 점주
            /// </summary>
            public const string MSG_0034 = "0034";
            /// <summary>
            /// 수량/총금액
            /// </summary>
            public const string MSG_0035 = "0035";
            /// <summary>
            /// 할인금액
            /// </summary>
            public const string MSG_0036 = "0036";
            /// <summary>
            /// 받을금액
            /// </summary>
            public const string MSG_0037 = "0037";
            /// <summary>
            /// 기타
            /// </summary>
            public const string MSG_0038 = "0038";
            /// <summary>
            /// WEB
            /// </summary>
            public const string MSG_0039 = "0039";
            /// <summary>
            /// 닫기
            /// </summary>
            public const string MSG_0040 = "0040";
            /// <summary>
            /// 플레이버 등록
            /// </summary>
            public const string MSG_0041 = "0041";
            /// <summary>
            /// 현금결제
            /// </summary>
            public const string MSG_0042 = "0042";
            /// <summary>
            /// 현금결제금액
            /// </summary>
            public const string MSG_0043 = "0043";
            /// <summary>
            /// 결제 취소
            /// </summary>
            public const string MSG_0044 = "0044";
            /// <summary>
            /// 메인
            /// </summary>
            public const string MSG_0045 = "0045";
            /// <summary>
            /// 포인트카드
            /// </summary>
            public const string MSG_0046 = "0046";
            /// <summary>
            /// 할인적용
            /// </summary>
            public const string MSG_0047 = "0047";
            /// <summary>
            /// 결제방식
            /// </summary>
            public const string MSG_0048 = "0048";
            /// <summary>
            /// 결제금액
            /// </summary>
            public const string MSG_0049 = "0049";
            /// <summary>
            /// 할부기간
            /// </summary>
            public const string MSG_0050 = "0050";
            /// <summary>
            /// 카드번호
            /// </summary>
            public const string MSG_0051 = "0051";
            /// <summary>
            /// 유효기간
            /// </summary>
            public const string MSG_0052 = "0052";
            /// <summary>
            /// 승인번호
            /// </summary>
            public const string MSG_0053 = "0053";
            /// <summary>
            /// 원거래일자
            /// </summary>
            public const string MSG_0054 = "0054";
            /// <summary>
            /// 원승인번호
            /// </summary>
            public const string MSG_0055 = "0055";
            /// <summary>
            /// 이동단말기
            /// </summary>
            public const string MSG_0056 = "0056";
            /// <summary>
            /// 승인
            /// </summary>
            public const string MSG_0057 = "0057";
            /// <summary>
            /// 신용카드(IC)
            /// </summary>
            public const string MSG_0058 = "0058";
            /// <summary>
            /// 현금
            /// </summary>
            public const string MSG_0059 = "0059";
            /// <summary>
            /// 수표
            /// </summary>
            public const string MSG_0060 = "0060";
            /// <summary>
            /// 수표금액
            /// </summary>
            public const string MSG_0061 = "0061";
            /// <summary>
            /// 수표번호
            /// </summary>
            public const string MSG_0062 = "0062";
            /// <summary>
            /// 계좌번호
            /// </summary>
            public const string MSG_0063 = "0063";
            /// <summary>
            /// 발행일자
            /// </summary>
            public const string MSG_0064 = "0064";
            /// <summary>
            /// 현금영수증
            /// </summary>
            public const string MSG_0065 = "0065";
            /// <summary>
            /// 승인금액
            /// </summary>
            public const string MSG_0066 = "0066";
            /// <summary>
            /// 거래구분
            /// </summary>
            public const string MSG_0067 = "0067";
            /// <summary>
            /// 확인번호
            /// </summary>
            public const string MSG_0068 = "0068";
            /// <summary>
            /// 포인트사용
            /// </summary>
            public const string MSG_0069 = "0069";
            /// <summary>
            /// 가용포인트
            /// </summary>
            public const string MSG_0070 = "0070";
            /// <summary>
            /// 누적포인트
            /// </summary>
            public const string MSG_0071 = "0071";
            /// <summary>
            /// SKT
            /// </summary>
            public const string MSG_0072 = "0072";
            /// <summary>
            /// KT
            /// </summary>
            public const string MSG_0073 = "0073";
            /// <summary>
            /// LGT
            /// </summary>
            public const string MSG_0074 = "0074";
            /// <summary>
            /// 반품
            /// </summary>
            public const string MSG_0075 = "0075";
            /// <summary>
            /// 정상
            /// </summary>
            public const string MSG_0076 = "0076";
            /// <summary>
            /// 예약등록
            /// </summary>
            public const string MSG_0077 = "0077";
            /// <summary>
            /// 예약완료
            /// </summary>
            public const string MSG_0078 = "0078";
            /// <summary>
            /// O2O
            /// </summary>
            public const string MSG_0079 = "0079";
            /// <summary>
            /// 쇼핑몰
            /// </summary>
            public const string MSG_0080 = "0080";
            /// <summary>
            /// 해피포인트충전
            /// </summary>
            public const string MSG_0081 = "0081";
            /// <summary>
            /// 해피포인트환불
            /// </summary>
            public const string MSG_0082 = "0082";
            /// <summary>
            /// 상품권판매
            /// </summary>
            public const string MSG_0083 = "0083";
            /// <summary>
            /// LOSS
            /// </summary>
            public const string MSG_0084 = "0084";
            /// <summary>
            /// 준비금
            /// </summary>
            public const string MSG_0085 = "0085";
            /// <summary>
            /// 마감시재
            /// </summary>
            public const string MSG_0086 = "0086";
            /// <summary>
            /// 기타입출금
            /// </summary>
            public const string MSG_0087 = "0087";
            /// <summary>
            /// 중간정산
            /// </summary>
            public const string MSG_0088 = "0088";
            /// <summary>
            /// 정산
            /// </summary>
            public const string MSG_0089 = "0089";
            /// <summary>
            /// 거래중지
            /// </summary>
            public const string MSG_0090 = "0090";
            /// <summary>
            /// 보류
            /// </summary>
            public const string MSG_0091 = "0091";
            /// <summary>
            /// LOGON
            /// </summary>
            public const string MSG_0092 = "0092";
            /// <summary>
            /// LOGOFF
            /// </summary>
            public const string MSG_0093 = "0093";
            /// <summary>
            /// 매출
            /// </summary>
            public const string MSG_0094 = "0094";
            /// <summary>
            /// 선불카드판매
            /// </summary>
            public const string MSG_0095 = "0095";
            /// <summary>
            /// 망취소
            /// </summary>
            public const string MSG_0096 = "0096";
            /// <summary>
            /// 핀패드
            /// </summary>
            public const string MSG_0097 = "0097";
            /// <summary>
            /// 대상금액
            /// </summary>
            public const string MSG_0098 = "0098";
            /// <summary>
            /// 남자
            /// </summary>
            public const string MSG_0099 = "0099";
            /// <summary>
            /// 여자
            /// </summary>
            public const string MSG_0100 = "0100";
            /// <summary>
            /// 50대이상
            /// </summary>
            public const string MSG_0101 = "0101";
            /// <summary>
            /// 40대
            /// </summary>
            public const string MSG_0102 = "0102";
            /// <summary>
            /// 30대
            /// </summary>
            public const string MSG_0103 = "0103";
            /// <summary>
            /// 20대
            /// </summary>
            public const string MSG_0104 = "0104";
            /// <summary>
            /// 10대
            /// </summary>
            public const string MSG_0105 = "0105";
            /// <summary>
            /// 고객등록
            /// </summary>
            public const string MSG_0106 = "0106";
            /// <summary>
            /// 총고객수
            /// </summary>
            public const string MSG_0107 = "0107";
            /// <summary>
            /// 해피포인트 적립
            /// </summary>
            public const string MSG_0108 = "0108";
            /// <summary>
            /// 해피포인트 사용
            /// </summary>
            public const string MSG_0109 = "0109";
            /// <summary>
            /// 현대 OILBANK
            /// </summary>
            public const string MSG_0110 = "0110";
            /// <summary>
            /// 삼성포인트
            /// </summary>
            public const string MSG_0111 = "0111";
            /// <summary>
            /// OK CASHBACK
            /// </summary>
            public const string MSG_0112 = "0112";
            /// <summary>
            /// 현대차 BLUE MEMBERS
            /// </summary>
            public const string MSG_0113 = "0113";
            /// <summary>
            /// 기아차 RED MEMBERS
            /// </summary>
            public const string MSG_0114 = "0114";
            /// <summary>
            /// 주문
            /// </summary>
            public const string MSG_0115 = "0115";
            /// <summary>
            /// 2F
            /// </summary>
            public const string MSG_0116 = "0116";
            /// <summary>
            /// 3F
            /// </summary>
            public const string MSG_0117 = "0117";
            /// <summary>
            /// 4F
            /// </summary>
            public const string MSG_0118 = "0118";
            /// <summary>
            /// 5F
            /// </summary>
            public const string MSG_0119 = "0119";
            /// <summary>
            /// 테이블붙임
            /// </summary>
            public const string MSG_0120 = "0120";
            /// <summary>
            /// 합석
            /// </summary>
            public const string MSG_0121 = "0121";
            /// <summary>
            /// 이동
            /// </summary>
            public const string MSG_0122 = "0122";
            /// <summary>
            /// 테이블해제
            /// </summary>
            public const string MSG_0123 = "0123";
            /// <summary>
            /// 메뉴이동
            /// </summary>
            public const string MSG_0124 = "0124";
            /// <summary>
            /// 예약
            /// </summary>
            public const string MSG_0125 = "0125";
            /// <summary>
            /// 등록
            /// </summary>
            public const string MSG_0126 = "0126";
            /// <summary>
            /// 요청금액
            /// </summary>
            public const string MSG_0127 = "0127";
            /// <summary>
            /// 품질관리 집중시간
            /// </summary>
            public const string MSG_0128 = "0128";
            /// <summary>
            /// 60대
            /// </summary>
            public const string MSG_0129 = "0129";
            /// <summary>
            /// 결제 고객 등록
            /// </summary>
            public const string MSG_0130 = "0130";
            /// <summary>
            /// 재고율정보
            /// </summary>
            public const string MSG_0131 = "0131";
            /// <summary>
            /// IC카드
            /// </summary>
            public const string MSG_0132 = "0132";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0133 = "0133";
            /// <summary>
            /// 적립
            /// </summary>
            public const string MSG_0134 = "0134";
            /// <summary>
            /// 결제완료
            /// </summary>
            public const string MSG_0135 = "0135";
            /// <summary>
            /// 좌석
            /// </summary>
            public const string MSG_0136 = "0136";
            /// <summary>
            /// 고객수
            /// </summary>
            public const string MSG_0137 = "0137";
            /// <summary>
            /// 해피포인트쿠폰
            /// </summary>
            public const string MSG_0138 = "0138";
            /// <summary>
            /// 쿠폰번호
            /// </summary>
            public const string MSG_0139 = "0139";
            /// <summary>
            /// 쿠폰설명
            /// </summary>
            public const string MSG_0140 = "0140";
            /// <summary>
            /// 시작일
            /// </summary>
            public const string MSG_0141 = "0141";
            /// <summary>
            /// 종료일
            /// </summary>
            public const string MSG_0142 = "0142";
            /// <summary>
            /// 인카드쿠폰조회
            /// </summary>
            public const string MSG_0143 = "0143";
            /// <summary>
            /// 선택
            /// </summary>
            public const string MSG_0144 = "0144";
            /// <summary>
            /// 0:소득공제
            /// </summary>
            public const string MSG_0145 = "0145";
            /// <summary>
            /// 1:지출증빙
            /// </summary>
            public const string MSG_0146 = "0146";
            /// <summary>
            /// 결제포인트
            /// </summary>
            public const string MSG_0147 = "0147";
            /// <summary>
            /// 판매원 등록
            /// </summary>
            public const string MSG_0148 = "0148";
            /// <summary>
            /// 판매원 ID
            /// </summary>
            public const string MSG_0149 = "0149";
            /// <summary>
            /// 판매원 이름
            /// </summary>
            public const string MSG_0150 = "0150";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0151 = "0151";
            /// <summary>
            /// 제목
            /// </summary>
            public const string MSG_0152 = "0152";
            /// <summary>
            /// 숨김
            /// </summary>
            public const string MSG_0153 = "0153";
            /// <summary>
            /// 보임
            /// </summary>
            public const string MSG_0154 = "0154";
            /// <summary>
            /// 상품 조회
            /// </summary>
            public const string MSG_0155 = "0155";
            /// <summary>
            /// 상세 내역
            /// </summary>
            public const string MSG_0156 = "0156";
            /// <summary>
            /// 매장공지사항 등록
            /// </summary>
            public const string MSG_0157 = "0157";
            /// <summary>
            /// SPC 임직원 할인
            /// </summary>
            public const string MSG_0158 = "0158";
            /// <summary>
            /// 전체 금액 할인
            /// </summary>
            public const string MSG_0159 = "0159";
            /// <summary>
            /// 전체 % 할인
            /// </summary>
            public const string MSG_0160 = "0160";
            /// <summary>
            /// 할인취소
            /// </summary>
            public const string MSG_0161 = "0161";
            /// <summary>
            /// 할인 대상 금액
            /// </summary>
            public const string MSG_0162 = "0162";
            /// <summary>
            /// 할인율(%)
            /// </summary>
            public const string MSG_0163 = "0163";
            /// <summary>
            /// 소멸예정
            /// </summary>
            public const string MSG_0164 = "0164";
            /// <summary>
            /// 메뉴 이동
            /// </summary>
            public const string MSG_0165 = "0165";
            /// <summary>
            /// 쿠폰할인
            /// </summary>
            public const string MSG_0166 = "0166";
            /// <summary>
            /// 기타할인(입점매장직원할인)
            /// </summary>
            public const string MSG_0167 = "0167";
            /// <summary>
            /// 쿠폰명칭
            /// </summary>
            public const string MSG_0168 = "0168";
            /// <summary>
            /// 수    량
            /// </summary>
            public const string MSG_0169 = "0169";
            /// <summary>
            /// 삼성카드 제휴할인
            /// </summary>
            public const string MSG_0170 = "0170";
            /// <summary>
            /// 외
            /// </summary>
            public const string MSG_0171 = "0171";
            /// <summary>
            /// 알리페이
            /// </summary>
            public const string MSG_0172 = "0172";
            /// <summary>
            /// 바코드번호
            /// </summary>
            public const string MSG_0173 = "0173";
            /// <summary>
            /// 좌석 메모
            /// </summary>
            public const string MSG_0174 = "0174";
            /// <summary>
            /// 층
            /// </summary>
            public const string MSG_0175 = "0175";
            /// <summary>
            /// 테이블
            /// </summary>
            public const string MSG_0176 = "0176";
            /// <summary>
            /// 메모
            /// </summary>
            public const string MSG_0177 = "0177";
            /// <summary>
            /// 상품코드
            /// </summary>
            public const string MSG_0178 = "0178";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0179 = "0179";
            /// <summary>
            /// 상품 메모
            /// </summary>
            public const string MSG_0180 = "0180";

            /*
            /// <summary>
            /// 좌석메모 (미사용)
            /// </summary>
            //public const string MSG_0181 = "0181";
            */

            /// <summary>
            /// 직 원 명
            /// </summary>
            public const string MSG_0183 = "0183";
            /// <summary>
            /// 전공의
            /// </summary>
            public const string MSG_0182 = "0182";
            /// <summary>
            /// 직원구분
            /// </summary>
            public const string MSG_0184 = "0184";
            /// <summary>
            /// 세브란스병원 임직원 할인
            /// </summary>
            public const string MSG_0185 = "0185";
            /// <summary>
            /// 상품 조회
            /// </summary>
            public const string MSG_0186 = "0186";
            /// <summary>
            /// 예약 관리
            /// </summary>
            public const string MSG_0187 = "0187";
            /// <summary>
            /// 예약번호
            /// </summary>
            public const string MSG_0188 = "0188";
            /// <summary>
            /// 예약일자
            /// </summary>
            public const string MSG_0189 = "0189";
            /// <summary>
            /// 예약시간
            /// </summary>
            public const string MSG_0190 = "0190";
            /// <summary>
            /// 담당자
            /// </summary>
            public const string MSG_0191 = "0191";
            /// <summary>
            /// 연락처
            /// </summary>
            public const string MSG_0192 = "0192";
            /// <summary>
            /// 내용
            /// </summary>
            public const string MSG_0193 = "0193";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0194 = "0194";
            /// <summary>
            /// 대상카드
            /// </summary>
            public const string MSG_0195 = "0195";
            /// <summary>
            /// 카드명
            /// </summary>
            public const string MSG_0196 = "0196";
            /// <summary>
            /// 카드 입력
            /// </summary>
            public const string MSG_0197 = "0197";
            /// <summary>
            /// 아워홈 할인
            /// </summary>
            public const string MSG_0198 = "0198";
            /// <summary>
            /// 모바일쿠폰
            /// </summary>
            public const string MSG_0199 = "0199";
            /// <summary>
            /// 쿠폰금액
            /// </summary>
            public const string MSG_0200 = "0200";

            /// <summary>
            /// 기프트콘
            /// </summary>
            public const string MSG_0201 = "0201";
            /// <summary>
            /// 큐티콘
            /// </summary>
            public const string MSG_0202 = "0202";
            /// <summary>
            /// 하트콘
            /// </summary>
            public const string MSG_0203 = "0203";
            /// <summary>
            /// 지마켓
            /// </summary>
            public const string MSG_0204 = "0204";
            /// <summary>
            /// 삼성모바일
            /// </summary>
            public const string MSG_0205 = "0205";
            /// <summary>
            /// 신한해피콘
            /// </summary>
            public const string MSG_0206 = "0206";
            /// <summary>
            /// 해피콘
            /// </summary>
            public const string MSG_0207 = "0207";
            /// <summary>
            /// 옥션
            /// </summary>
            public const string MSG_0208 = "0208";
            /// <summary>
            /// 슈퍼브랜드딜
            /// </summary>
            public const string MSG_0209 = "0209";
            /// <summary>
            /// 디몬
            /// </summary>
            public const string MSG_0210 = "0210";
            /// <summary>
            /// 기프트쇼
            /// </summary>
            public const string MSG_0211 = "0211";
            /// <summary>
            /// 거스름
            /// </summary>
            public const string MSG_0212 = "0212";
            /// <summary>
            /// 부분결제
            /// </summary>
            public const string MSG_0213 = "0213";
            /// <summary>
            /// 전체결제
            /// </summary>
            public const string MSG_0214 = "0214";
            /// <summary>
            /// 결제가능금액
            /// </summary>
            public const string MSG_0215 = "0215";
            ///// <summary>
            ///// (삭제)주문 주방 인쇄
            ///// </summary>
            //public const string MSG_0216 = "0216";
            ///// <summary>
            ///// (삭제)주문 주방 재인쇄
            ///// </summary>
            //public const string MSG_0217 = "0217";
            ///// <summary>
            ///// (삭제)주문취소 주방 인쇄
            ///// </summary>
            //public const string MSG_0218 = "0218";
            ///// <summary>
            ///// (삭제)주문취소 주방 재인쇄
            ///// </summary>
            //public const string MSG_0219 = "0219";
            /// <summary>
            /// 메뉴
            /// </summary>
            public const string MSG_0220 = "0220";

            /// <summary>
            /// 상품유형
            /// </summary>
            public const string MSG_0221 = "0221";
            /// <summary>
            /// 세부매장
            /// </summary>
            public const string MSG_0222 = "0222";
            /// <summary>
            /// 조회조건
            /// </summary>
            public const string MSG_0223 = "0223";
            /// <summary>
            /// 추가
            /// </summary>
            public const string MSG_0224 = "0224";
            /// <summary>
            /// 저장
            /// </summary>
            public const string MSG_0225 = "0225";
            /// <summary>
            /// 전체
            /// </summary>
            public const string MSG_0226 = "0226";
            /// <summary>
            /// 신상품
            /// </summary>
            public const string MSG_0227 = "0227";
            /// <summary>
            /// 누적
            /// </summary>
            public const string MSG_0228 = "0228";
            /// <summary>
            /// 가용
            /// </summary>
            public const string MSG_0229 = "0229";
            /// <summary>
            /// 대상상품선택
            /// </summary>
            public const string MSG_0230 = "0230";
            /// <summary>
            /// 상품금액
            /// </summary>
            public const string MSG_0231 = "0231";
            ///// <summary>
            ///// (삭제)주방 주문취소 메시지
            ///// </summary>
            //public const string MSG_0232 = "0232";
            /// <summary>
            /// 주방 상품 메모
            /// </summary>
            public const string MSG_0233 = "0233";
            /// <summary>
            /// 주방 좌석 메모
            /// </summary>
            public const string MSG_0234 = "0234";
            /// <summary>
            /// 테이블합석
            /// </summary>
            public const string MSG_0235 = "0235";
            /// <summary>
            /// 테이블이동
            /// </summary>
            public const string MSG_0236 = "0236";
            ///// <summary>
            ///// (삭제)주문주방 추가 인쇄
            ///// </summary>
            //public const string MSG_0237 = "0237";
            /// <summary>
            /// 기존 할인 금액
            /// </summary>
            public const string MSG_0238 = "0238";
            /// <summary>
            /// 입력시간
            /// </summary>
            public const string MSG_0239 = "0239";
            /// <summary>
            /// 권종
            /// </summary>
            public const string MSG_0240 = "0240";
            /// <summary>
            /// 매수
            /// </summary>
            public const string MSG_0241 = "0241";
            /// <summary>
            /// 영업일자
            /// </summary>
            public const string MSG_0242 = "0242";
            /// <summary>
            /// 시험모드
            /// </summary>
            public const string MSG_0243 = "0243";
            /// <summary>
            /// 결과전송
            /// </summary>
            public const string MSG_0244 = "0244";
            /// <summary>
            /// 시험시작
            /// </summary>
            public const string MSG_0245 = "0245";
            /// <summary>
            /// 시험항목
            /// </summary>
            public const string MSG_0246 = "0246";
            /// <summary>
            /// 완료여부
            /// </summary>
            public const string MSG_0247 = "0247";
            /// <summary>
            /// 완료
            /// </summary>
            public const string MSG_0248 = "0248";
            /// <summary>
            /// 시험확인
            /// </summary>
            public const string MSG_0249 = "0249";
            /// <summary>
            /// 이전
            /// </summary>
            public const string MSG_0250 = "0250";
            /// <summary>
            /// 다음
            /// </summary>
            public const string MSG_0251 = "0251";
            /// <summary>
            /// 포인트
            /// </summary>
            public const string MSG_0252 = "0252";
            /// <summary>
            /// 신용
            /// </summary>
            public const string MSG_0253 = "0253";
            /// <summary>
            /// 보류일자
            /// </summary>
            public const string MSG_0254 = "0254";
            /// <summary>
            /// 불러오기
            /// </summary>
            public const string MSG_0255 = "0255";
            /// <summary>
            /// 보류일시
            /// </summary>
            public const string MSG_0256 = "0256";
            /// <summary>
            /// 출력
            /// </summary>
            public const string MSG_0257 = "0257";
            /// <summary>
            /// 식권
            /// </summary>
            public const string MSG_0258 = "0258";
            /// <summary>
            /// 식권번호
            /// </summary>
            public const string MSG_0259 = "0259";
            /// <summary>
            /// 식권명칭
            /// </summary>
            public const string MSG_0260 = "0260";
            /// <summary>
            /// 식권금액
            /// </summary>
            public const string MSG_0261 = "0261";
            /// <summary>
            /// 식권수량
            /// </summary>
            public const string MSG_0262 = "0262";
            /// <summary>
            /// 결제
            /// </summary>
            public const string MSG_0263 = "0263";
            /// <summary>
            /// 현금영수증 재발행
            /// </summary>
            public const string MSG_0264 = "0264";
            /// <summary>
            /// 잔액교환권
            /// </summary>
            public const string MSG_0265 = "0265";
            /// <summary>
            /// 교환권
            /// </summary>
            public const string MSG_0266 = "0266";
            /// <summary>
            /// 총 금액
            /// </summary>
            public const string MSG_0267 = "0267";
            /// <summary>
            /// 상품권
            /// </summary>
            public const string MSG_0268 = "0268";
            /// <summary>
            /// 상품권번호
            /// </summary>
            public const string MSG_0269 = "0269";
            /// <summary>
            /// 상품권명칭
            /// </summary>
            public const string MSG_0270 = "0270";
            /// <summary>
            /// 상품권금액
            /// </summary>
            public const string MSG_0271 = "0271";
            /// <summary>
            /// 상품권수량
            /// </summary>
            public const string MSG_0272 = "0272";
            /// <summary>
            /// 상품권 승인
            /// </summary>
            public const string MSG_0273 = "0273";
            /// <summary>
            /// 인증
            /// </summary>
            public const string MSG_0274 = "0274";
            /// <summary>
            /// 처리번호
            /// </summary>
            public const string MSG_0275 = "0275";
            /// <summary>
            /// 교환권번호
            /// </summary>
            public const string MSG_0276 = "0276";
            /// <summary>
            /// 교환권금액
            /// </summary>
            public const string MSG_0277 = "0277";
            /// <summary>
            /// 고객명
            /// </summary>
            public const string MSG_0278 = "0278";
            /// <summary>
            /// 전화번호
            /// </summary>
            public const string MSG_0279 = "0279";
            /// <summary>
            /// 주소/Memo
            /// </summary>
            public const string MSG_0280 = "0280";
            /// <summary>
            /// 예약잔금
            /// </summary>
            public const string MSG_0281 = "0281";
            /// <summary>
            /// 예약선금
            /// </summary>
            public const string MSG_0282 = "0282";
            /// <summary>
            /// 외상
            /// </summary>
            public const string MSG_0283 = "0283";
            /// <summary>
            /// 개인
            /// </summary>
            public const string MSG_0284 = "0284";
            /// <summary>
            /// 법인
            /// </summary>
            public const string MSG_0285 = "0285";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0286 = "0286";
            /// <summary>
            /// 고 객 명
            /// </summary>
            public const string MSG_0287 = "0287";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0288 = "0288";
            /// <summary>
            /// 외상잔액
            /// </summary>
            public const string MSG_0289 = "0289";
            /// <summary>
            /// DC율
            /// </summary>
            public const string MSG_0290 = "0290";
            /// <summary>
            /// 예약취소
            /// </summary>
            public const string MSG_0291 = "0291";
            /// <summary>
            /// 예약일시
            /// </summary>
            public const string MSG_0292 = "0292";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0293 = "0293";
            /// <summary>
            /// 등록일시
            /// </summary>
            public const string MSG_0294 = "0294";

            /// <summary>
            /// 외화
            /// </summary>
            public const string MSG_0295 = "0295";
            /// <summary>
            /// 입금종류
            /// </summary>
            public const string MSG_0296 = "0296";
            /// <summary>
            /// 받은금액(외화) *
            /// </summary>
            public const string MSG_0297 = "0297";
            /// <summary>
            /// 받을금액(외화)
            /// </summary>
            public const string MSG_0298 = "0298";
            /// <summary>
            /// 받은금액((원화))
            /// </summary>
            public const string MSG_0299 = "0299";
            /// <summary>
            /// 거스름금액
            /// </summary>
            public const string MSG_0300 = "0300";
            /// <summary>
            /// 환율
            /// </summary>
            public const string MSG_0301 = "0301";
            /// <summary>
            /// Take In
            /// </summary>
            public const string MSG_0302 = "0302";
            /// <summary>
            /// Take Out
            /// </summary>
            public const string MSG_0303 = "0303";
            /// <summary>
            /// Take In/Out
            /// </summary>
            public const string MSG_0304 = "0304";
            /// <summary>
            /// 선불카드
            /// </summary>
            public const string MSG_0305 = "0305";
            /// <summary>
            /// 고객번호
            /// </summary>
            public const string MSG_0306 = "0306";
            /// <summary>
            /// 선불잔액
            /// </summary>
            public const string MSG_0307 = "0307";
            /// <summary>
            /// 사용금액*
            /// </summary>
            public const string MSG_0308 = "0308";
            /// <summary>
            /// 고객찾기
            /// </summary>
            public const string MSG_0309 = "0309";
            /// <summary>
            /// 정산취소
            /// </summary>
            public const string MSG_0310 = "0310";
            /// <summary>
            /// 주방프린터설정
            /// </summary>
            public const string MSG_0311 = "0311";
            /// <summary>
            /// Check of kitchen Printer
            /// </summary>
            public const string MSG_0312 = "0312";
            /// <summary>
            /// 다운로드
            /// </summary>
            public const string MSG_0313 = "0313";
            /// <summary>
            /// 옵션설정
            /// </summary>
            public const string MSG_0314 = "0314";
            /// <summary>
            /// 영수증설정
            /// </summary>
            public const string MSG_0315 = "0315";
            /// <summary>
            /// 장비설정
            /// </summary>
            public const string MSG_0316 = "0316";
            /// <summary>
            /// 환경설정
            /// </summary>
            public const string MSG_0317 = "0317";
            /// <summary>
            /// 송/수신 설정
            /// </summary>
            public const string MSG_0318 = "0318";
            /// <summary>
            /// 화면설정
            /// </summary>
            public const string MSG_0319 = "0319";
            /// <summary>
            /// 쇼핑몰설정
            /// </summary>
            public const string MSG_0320 = "0320";
            /// <summary>
            /// 기타설정
            /// </summary>
            public const string MSG_0321 = "0321";
            /// <summary>
            /// 매출자료조회
            /// </summary>
            public const string MSG_0322 = "0322";
            /// <summary>
            /// 자료조회
            /// </summary>
            public const string MSG_0323 = "0323";
            /// <summary>
            /// 영수증재발행
            /// </summary>
            public const string MSG_0324 = "0324";
            /// <summary>
            /// 카드승인내역
            /// </summary>
            public const string MSG_0325 = "0325";
            /// <summary>
            /// 출하/예정내역
            /// </summary>
            public const string MSG_0326 = "0326";
            /// <summary>
            /// 해피포인트추후적립
            /// </summary>
            public const string MSG_0327 = "0327";
            /// <summary>
            /// 현금영수증승인내역
            /// </summary>
            public const string MSG_0328 = "0328";
            /// <summary>
            /// 입출금내역
            /// </summary>
            public const string MSG_0329 = "0329";
            /// <summary>
            /// 쇼핑몰주문정보출력
            /// </summary>
            public const string MSG_0330 = "0330";
            /// <summary>
            /// 알리페이인위개입내역
            /// </summary>
            public const string MSG_0331 = "0331";
            /// <summary>
            /// 즐겨찾기등록
            /// </summary>
            public const string MSG_0332 = "0332";
            /// <summary>
            /// 출근/퇴근등록
            /// </summary>
            public const string MSG_0333 = "0333";
            /// <summary>
            /// T-MONEY개시
            /// </summary>
            public const string MSG_0334 = "0334";
            /// <summary>
            /// 환율등록
            /// </summary>
            public const string MSG_0335 = "0335";
            /// <summary>
            /// 그룹/메뉴위치변경
            /// </summary>
            public const string MSG_0336 = "0336";
            /// <summary>
            /// 직원방문등록
            /// </summary>
            public const string MSG_0337 = "0337";
            /// <summary>
            /// PVC상자재고
            /// </summary>
            public const string MSG_0338 = "0338";
            /// <summary>
            /// 플레이버위치변경
            /// </summary>
            public const string MSG_0339 = "0339";
            /// <summary>
            /// 계산기
            /// </summary>
            public const string MSG_0340 = "0340";
            /// <summary>
            /// 관공서방문알림등록
            /// </summary>
            public const string MSG_0341 = "0341";
            /// <summary>
            /// 테이블셋팅
            /// </summary>
            public const string MSG_0342 = "0342";
            /// <summary>
            /// 고객클레임
            /// </summary>
            public const string MSG_0343 = "0343";
            /// <summary>
            /// 간이영수증
            /// </summary>
            public const string MSG_0344 = "0344";
            /// <summary>
            /// 반품건 제외
            /// </summary>
            public const string MSG_0345 = "0345";
            /// <summary>
            /// 거래번호
            /// </summary>
            public const string MSG_0346 = "0346";
            /// <summary>
            /// 거래시간
            /// </summary>
            public const string MSG_0347 = "0347";
            /// <summary>
            /// 판매금액
            /// </summary>
            public const string MSG_0348 = "0348";
            /// <summary>
            /// 내신금액
            /// </summary>
            public const string MSG_0349 = "0349";
            /// <summary>
            /// 내실금액
            /// </summary>
            public const string MSG_0350 = "0350";
            /// <summary>
            /// 해피 기프트
            /// </summary>
            public const string MSG_0351 = "0351";
            /// <summary>
            /// 카드잔액
            /// </summary>
            public const string MSG_0352 = "0352";
            /// <summary>
            /// 결제후 잔액
            /// </summary>
            public const string MSG_0353 = "0353";
            /// <summary>
            /// 조회일자
            /// </summary>
            public const string MSG_0354 = "0354";
            /// <summary>
            /// 충전취소
            /// </summary>
            public const string MSG_0355 = "0355";
            /// <summary>
            /// 충전승인
            /// </summary>
            public const string MSG_0356 = "0356";
            /// <summary>
            /// 충전취소
            /// </summary>
            public const string MSG_0357 = "0357";
            /// <summary>
            /// 환불
            /// </summary>
            public const string MSG_0358 = "0358";
            /// <summary>
            /// 충전금액
            /// </summary>
            public const string MSG_0359 = "0359";
            /// <summary>
            /// 충전/조회
            /// </summary>
            public const string MSG_0360 = "0360";
            /// <summary>
            /// 충전일자
            /// </summary>
            public const string MSG_0361 = "0361";
            /// <summary>
            /// 충전시간
            /// </summary>
            public const string MSG_0362 = "0362";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0363 = "0363";
            /// <summary>
            /// 수기결제
            /// </summary>
            public const string MSG_0364 = "0364";
            /// <summary>
            /// 해피포인트 조회
            /// </summary>
            public const string MSG_0365 = "0365";
            /// <summary>
            /// 이름
            /// </summary>
            public const string MSG_0367 = "0367";
            /// <summary>
            /// 검색구분
            /// </summary>
            public const string MSG_0368 = "0368";
            /// <summary>
            /// 검색코드
            /// </summary>
            public const string MSG_0369 = "0369";
            /// <summary>
            /// 받은금액
            /// </summary>
            public const string MSG_0366 = "0366";
            /// <summary>
            /// POS번호
            /// </summary>
            public const string MSG_0370 = "0370";
            /// <summary>
            /// 거래종류
            /// </summary>
            public const string MSG_0371 = "0371";
            /// <summary>
            /// 내역복원
            /// </summary>
            public const string MSG_0372 = "0372";
            /// <summary>
            /// 묵음상품/쇼킹박스
            /// </summary>
            public const string MSG_0373 = "0373";
            /// <summary>
            /// 선택금액
            /// </summary>
            public const string MSG_0374 = "0374";
            /// <summary>
            /// 추가(수량전체)
            /// </summary>
            public const string MSG_0375 = "0375";
            /// <summary>
            /// 추가(수량1개)
            /// </summary>
            public const string MSG_0376 = "0376";
            /// <summary>
            /// POS
            /// </summary>
            public const string MSG_0377 = "0377";
            /// <summary>
            /// BILL
            /// </summary>
            public const string MSG_0378 = "0378";
            /// <summary>
            /// 영수증 반품
            /// </summary>
            public const string MSG_0379 = "0379";
            /// <summary>
            /// 묶음적용
            /// </summary>
            public const string MSG_0380 = "0380";
            /// <summary>
            /// 묶음취소
            /// </summary>
            public const string MSG_0381 = "0381";
            /// <summary>
            /// 행사주문취합내역조회
            /// </summary>
            public const string MSG_0382 = "0382";
            /// <summary>
            /// 반품 사유
            /// </summary>
            public const string MSG_0383 = "0383";
            /// <summary>
            /// 결제항목
            /// </summary>
            public const string MSG_0384 = "0384";
            /// <summary>
            /// 승인구분
            /// </summary>
            public const string MSG_0385 = "0385";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0386 = "0386";
            /// <summary>
            /// SPC 임직원 결제
            /// </summary>
            public const string MSG_0387 = "0387";
            /// <summary>
            /// 직원명칭
            /// </summary>
            public const string MSG_0388 = "0388";
            /// <summary>
            /// 세브란스 임직원 결제
            /// </summary>
            public const string MSG_0389 = "0389";
            /// <summary>
            /// 사용가능 무료 수량 : {0}
            /// </summary>
            public const string MSG_0390 = "0390";
            /// <summary>
            /// 총          사용 수량 : {0}
            /// </summary>
            public const string MSG_0391 = "0391";
            /// <summary>
            /// 행사정보
            /// </summary>
            public const string MSG_0392 = "0392";
            /// <summary>
            /// 공지사항
            /// </summary>
            public const string MSG_0393 = "0393";
            /// <summary>
            /// 반품승인
            /// </summary>
            public const string MSG_0394 = "0394";
            /// <summary>
            /// 전화취소
            /// </summary>
            public const string MSG_0395 = "0395";
            /// <summary>
            /// 금액(포인트)
            /// </summary>
            public const string MSG_0396 = "0396";
            /// <summary>
            /// 원승인시간
            /// </summary>
            public const string MSG_0397 = "0397";
            /// <summary>
            /// 캠페인코드
            /// </summary>
            public const string MSG_0398 = "0398";
            /// <summary>
            /// 캠페인명
            /// </summary>
            public const string MSG_0399 = "0399";
            /// <summary>
            /// 캠페인 정보
            /// </summary>
            public const string MSG_0400 = "0400";
            /// <summary>
            /// 환불취소
            /// </summary>
            public const string MSG_0401 = "0401";
            /// <summary>
            /// 연습모드(Training Mode)
            /// </summary>
            public const string MSG_0402 = "0402";
            /// <summary>
            /// 잔액조회
            /// </summary>
            public const string MSG_0403 = "0403";
            /// <summary>
            /// 적립종류
            /// </summary>
            public const string MSG_0404 = "0404";
            /// <summary>
            /// 추후적립
            /// </summary>
            public const string MSG_0405 = "0405";
            /// <summary>
            /// 추가적립
            /// </summary>
            public const string MSG_0406 = "0406";
            /// <summary>
            /// 고객불편사항처리조회
            /// </summary>
            public const string MSG_0407 = "0407";
            /// <summary>
            /// 접수일자
            /// </summary>
            public const string MSG_0408 = "0408";
            /// <summary>
            /// 수정
            /// </summary>
            public const string MSG_0409 = "0409";
            /// <summary>
            /// 순번
            /// </summary>
            public const string MSG_0410 = "0410";
            /// <summary>
            /// 처리비용
            /// </summary>
            public const string MSG_0411 = "0411";
            /// <summary>
            /// 대표제품
            /// </summary>
            public const string MSG_0412 = "0412";
            /// <summary>
            /// 처리내용
            /// </summary>
            public const string MSG_0413 = "0413";
            /// <summary>
            /// 판매시간
            /// </summary>
            public const string MSG_0414 = "0414";
            /// <summary>
            /// T-Money
            /// </summary>
            public const string MSG_0415 = "0415";
            /// <summary>
            /// CashBee
            /// </summary>
            public const string MSG_0416 = "0416";
            /// <summary>
            /// 사원번호
            /// </summary>
            public const string MSG_0417 = "0417";
            /// <summary>
            /// 사원명칭
            /// </summary>
            public const string MSG_0418 = "0418";
            /// <summary>
            /// 아워홈
            /// </summary>
            public const string MSG_0419 = "0419";
            /// <summary>
            /// 주문번호
            /// </summary>
            public const string MSG_0420 = "0420";
            /// <summary>
            /// 상태
            /// </summary>
            public const string MSG_0421 = "0421";
            /// <summary>
            /// 내점
            /// </summary>
            public const string MSG_0422 = "0422";
            /// <summary>
            /// 배달
            /// </summary>
            public const string MSG_0423 = "0423";
            /// <summary>
            /// 상품준비
            /// </summary>
            public const string MSG_0424 = "0424";
            /// <summary>
            /// 픽업대기
            /// </summary>
            public const string MSG_0425 = "0425";
            /// <summary>
            /// 픽업완료
            /// </summary>
            public const string MSG_0426 = "0426";
            /// <summary>
            /// 배달요청
            /// </summary>
            public const string MSG_0427 = "0427";
            /// <summary>
            /// 배달중
            /// </summary>
            public const string MSG_0428 = "0428";
            /// <summary>
            /// 주문취소
            /// </summary>
            public const string MSG_0429 = "0429";
            /// <summary>
            /// 당일 거래 복구중
            /// </summary>
            public const string MSG_0430 = "0430";
            /// <summary>
            /// 주문접수
            /// </summary>
            public const string MSG_0431 = "0431";
            /// <summary>
            /// 픽업지연
            /// </summary>
            public const string MSG_0432 = "0432";
            /// <summary>
            /// 배달접수
            /// </summary>
            public const string MSG_0433 = "0433";
            /// <summary>
            /// 배달상품준비중
            /// </summary>
            public const string MSG_0434 = "0434";
            /// <summary>
            /// 배달완료
            /// </summary>
            public const string MSG_0435 = "0435";
            /// <summary>
            /// 주문일자
            /// </summary>
            public const string MSG_0436 = "0436";
            /// <summary>
            /// 해피오더
            /// </summary>
            public const string MSG_0437 = "0437";
            /// <summary>
            /// 더치페이
            /// </summary>
            public const string MSG_0438 = "0438";
            /// <summary>
            /// 단골매장등록
            /// </summary>
            public const string MSG_0439 = "0439";
            /// <summary>
            /// 프로그램 다운로드 중... ({0}%)
            /// </summary>
            public const string MSG_0440 = "0440";
            /// <summary>
            /// 거래 수신 중... ({0}%)
            /// </summary>
            public const string MSG_0441 = "0441";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0442 = "0442";
            /// <summary>
            /// 본사반품조회
            /// </summary>
            public const string MSG_0443 = "0443";
            /// <summary>
            /// 매출수신
            /// </summary>
            public const string MSG_0444 = "0444";
            /// <summary>
            /// 승인일자
            /// </summary>
            public const string MSG_0445 = "0445";
            /// <summary>
            /// 승인시간
            /// </summary>
            public const string MSG_0446 = "0446";
            /// <summary>
            /// 프로그램 업데이트
            /// </summary>
            public const string MSG_0447 = "0447";
            /// <summary>
            /// 선결제금액
            /// </summary>
            public const string MSG_0448 = "0448";
            /// <summary>
            /// 더치페이(금액)
            /// </summary>
            public const string MSG_0449 = "0449";

            /// <summary>
            /// 프로그램 업데이트 중... ({0}%)
            /// </summary>
            public const string MSG_0450 = "0450";
            /// <summary>
            /// 지연완료
            /// </summary>
            public const string MSG_0451 = "0451";
            /// <summary>
            /// 상태변경
            /// </summary>
            public const string MSG_0452 = "0452"; 
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0453 = "0453";
            /// <summary>
            /// 점착정보
            /// </summary>
            public const string MSG_0454 = "0454";
            /// <summary>
            /// 프로그램 업데이트 확인중 입니다. 잠시만 기다려 주십시요.
            /// </summary>
            public const string MSG_0455 = "0455";
            /// <summary>
            /// 시험 결과 조회
            /// </summary>
            public const string MSG_0456 = "0456";
            /// <summary>
            /// 시험 일자
            /// </summary>
            public const string MSG_0457 = "0457";
            /// <summary>
            /// 교육
            /// </summary>
            public const string MSG_0458 = "0458";
            /// <summary>
            /// 【해피오더】 신규({0:00})/픽업({1:00})/배달({2:00})
            /// </summary>
            public const string MSG_0459 = "0459";
            /// <summary>
            /// 전체상품교육
            /// </summary>
            public const string MSG_0460 = "0460";
            /// <summary>
            /// 신상품교육
            /// </summary>
            public const string MSG_0461 = "0461";
            /// <summary>
            /// [[ 제품 이미지 ]]
            /// </summary>
            public const string MSG_0462 = "0462";
            /// <summary>
            /// [[ 시험 설명 ]]
            /// </summary>
            public const string MSG_0463 = "0463";
            /// <summary>
            /// 【빚은몰】 {0:00}
            /// </summary>
            public const string MSG_0464 = "0464";
            /// <summary>
            /// 【이지웰】 {0:00}
            /// </summary>
            public const string MSG_0465 = "0465";
            /// <summary>
            /// 점주WEB
            /// </summary>
            public const string MSG_0466 = "0466";
            /// <summary>
            /// 해피오더 내역조회
            /// </summary>
            public const string MSG_0467 = "0467";
            /// <summary>
            /// 프로그램
            /// </summary>
            public const string MSG_0468 = "0468";
            /// <summary>
            /// 마스터
            /// </summary>
            public const string MSG_0469 = "0469";
            /// <summary>
            /// 컨텐츠
            /// </summary>
            public const string MSG_0470 = "0470";
            /// <summary>
            /// 상품이미지
            /// </summary>
            public const string MSG_0471 = "0471";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0472 = "0472";
            /// <summary>
            /// 상품교육 결과 조회
            /// </summary>
            public const string MSG_0473 = "0473";
            /// <summary>
            /// 정답/전체
            /// </summary>
            public const string MSG_0474 = "0474";
            /// <summary>
            /// 시험시간
            /// </summary>
            public const string MSG_0475 = "0475";
            /// <summary>
            /// 전체상품조회
            /// </summary>
            public const string MSG_0476 = "0476";
            /// <summary>
            /// 신상품조회
            /// </summary>
            public const string MSG_0477 = "0477";
            /// <summary>
            /// 판매시작일
            /// </summary>
            public const string MSG_0478 = "0478";
            /// <summary>
            /// RF카드번호
            /// </summary>
            public const string MSG_0479 = "0479";
            /// <summary>
            /// 바코드
            /// </summary>
            public const string MSG_0480 = "0480";
            /// <summary>
            /// 주방주문내역조회
            /// </summary>
            public const string MSG_0481 = "0481";
            /// <summary>
            /// 다시
            /// </summary>
            public const string MSG_0482 = "0482";
            /// <summary>
            /// 해피오더 바코드 등록
            /// </summary>
            public const string MSG_0483 = "0483";
            /// <summary>
            /// 중간마감
            /// </summary>
            public const string MSG_0484 = "0484";
            /// <summary>
            /// 등록자
            /// </summary>
            public const string MSG_0485 = "0485";
            /// <summary>
            /// 마감입금
            /// </summary>
            public const string MSG_0486 = "0486";
            /// <summary>
            /// 외환
            /// </summary>
            public const string MSG_0487 = "0487";
            /// <summary>
            /// 정산 내역 조회 및 출력
            /// </summary>
            public const string MSG_0488 = "0488";
            /// <summary>
            /// 적요
            /// </summary>
            public const string MSG_0489 = "0489";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0490 = "0490";
            /// <summary>
            /// 백신실행
            /// </summary>
            public const string MSG_0491 = "0491";
            /// <summary>
            /// 프린터초기화
            /// </summary>
            public const string MSG_0492 = "0492";
            /// <summary>
            /// 미완료
            /// </summary>
            public const string MSG_0493 = "0493";
            /// <summary>
            /// 주문구분
            /// </summary>
            public const string MSG_0494 = "0494";
            /// <summary>
            /// 온라인
            /// </summary>
            public const string MSG_0495 = "0495";
            /// <summary>
            /// 오프라인
            /// </summary>
            public const string MSG_0496 = "0496";
            /// <summary>
            /// 세트메뉴변경
            /// </summary>
            public const string MSG_0497 = "0497";
            /// <summary>
            /// 등록된상품
            /// </summary>
            public const string MSG_0498 = "0498";
            /// <summary>
            /// 매장공지사항
            /// </summary>
            public const string MSG_0499 = "0499";
            /// <summary>
            /// 항목
            /// </summary>
            public const string MSG_0500 = "0500";
            /// <summary>
            /// 합계
            /// </summary>
            public const string MSG_0501 = "0501";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0502 = "0502";
            /// <summary>
            /// 마감입금
            /// </summary>
            public const string MSG_0503 = "0503";
            /// <summary>
            /// 잔여포인트
            /// </summary>
            public const string MSG_0504 = "0504";
            /// <summary>
            /// 권한 체크 오류
            /// </summary>
            public const string MSG_0505 = "0505";
            /// <summary>
            /// 권한 체크
            /// </summary>
            public const string MSG_0506 = "0506";
            /// <summary>
            /// 관리자 ID
            /// </summary>
            public const string MSG_0507 = "0507";
            /// <summary>
            /// 관리자 이름
            /// </summary>
            public const string MSG_0508 = "0508";
            /// <summary>
            /// 바코드 출력
            /// </summary>
            public const string MSG_0509 = "0509";
            /// <summary>
            /// 중간입금 취소
            /// </summary>
            public const string MSG_0511 = "0511"; 
            /// <summary>
            /// 마감입금 취소
            /// </summary>
            public const string MSG_0512 = "0512";
            /// <summary>
            /// ● 거래 내역
            /// </summary>
            public const string MSG_0513 = "0513";
            /// <summary>
            /// ● 상세 내역
            /// </summary>
            public const string MSG_0514 = "0514";
            /// <summary>
            /// 마감취소
            /// </summary>
            public const string MSG_0515 = "0515";
            /// <summary>
            /// 시스템일자
            /// </summary>
            public const string MSG_0516 = "0516";
            /// <summary>
            /// 전영업일자
            /// </summary>
            public const string MSG_0517 = "0517"; 
            /// <summary>
            /// 현금 보관함 알람
            /// </summary>
            public const string MSG_0518 = "0518";
            /// <summary>
            /// 차수
            /// </summary>
            public const string MSG_0519 = "0519";
            /// <summary>
            /// 제품군
            /// </summary>
            public const string MSG_0520 = "0520";
            /// <summary>
            /// ● 조회목록
            /// </summary>
            public const string MSG_0521 = "0521";
            /// <summary>
            /// 업무코드
            /// </summary>
            public const string MSG_0522 = "0522";
            /// <summary>
            /// 업무명칭
            /// </summary>
            public const string MSG_0523 = "0523";
            /// <summary>
            /// 출금
            /// </summary>
            public const string MSG_0524 = "0524";
            /// <summary>
            /// 그룹코드
            /// </summary>
            public const string MSG_0525 = "0525";
            /// <summary>
            /// 상세코드
            /// </summary>
            public const string MSG_0526 = "0526";
            /// <summary>
            /// 방문시간
            /// </summary>
            public const string MSG_0527 = "0527";
            /// <summary>
            /// 철수시간
            /// </summary>
            public const string MSG_0528 = "0528";
            /// <summary>
            /// 서명패드 Update
            /// </summary>
            public const string MSG_0529 = "0529";
            /// <summary>
            /// 일자
            /// </summary>
            public const string MSG_0530 = "0530";
            /// <summary>
            /// 명칭
            /// </summary>
            public const string MSG_0531 = "0531";
            /// <summary>
            /// 구분
            /// </summary>
            public const string MSG_0532 = "0532";
            /// <summary>
            /// 결제포인트
            /// </summary>
            public const string MSG_0533 = "0533";
            /// <summary>
            /// 담당자별 매출 조회
            /// </summary>
            public const string MSG_0534 = "0534";
            /// <summary>
            /// 품목
            /// </summary>
            public const string MSG_0535 = "0535";
            /// <summary>
            /// ** 품목별 정산 내역 **
            /// </summary>
            public const string MSG_0536 = "0536";
            /// <summary>
            /// ** 결제 내역 **
            /// </summary>
            public const string MSG_0537 = "0537";
            /// <summary>
            /// 주문서출력
            /// </summary>
            public const string MSG_0538 = "0538";
            /// <summary>
            /// 중량출력
            /// </summary>
            public const string MSG_0539 = "0539";
            /// <summary>
            /// 영업 공지사항
            /// </summary>
            public const string MSG_0540 = "0540";
            /// <summary>
            /// 본사
            /// </summary>
            public const string MSG_0541 = "0541";
            /// <summary>
            /// 식품안전
            /// </summary>
            public const string MSG_0542 = "0542";
            /// <summary>
            /// 해피오더 중량출력
            /// </summary>
            public const string MSG_0543 = "0543";
            /// <summary>
            /// KT VIP
            /// </summary>
            public const string MSG_0544 = "0544";
            /// <summary>
            /// 파인트
            /// </summary>
            public const string MSG_0545 = "0545";
            /// <summary>
            /// 스타워즈파인트
            /// </summary>
            public const string MSG_0546 = "0546";
            /// <summary>
            /// 쿼터
            /// </summary>
            public const string MSG_0547 = "0547";
            /// <summary>
            /// 패밀리
            /// </summary>
            public const string MSG_0548 = "0548";
            /// <summary>
            /// 하프갤론
            /// </summary>
            public const string MSG_0549 = "0549";
            /// <summary>
            /// 그랜드
            /// </summary>
            public const string MSG_0550 = "0550";
            /// <summary>
            /// 기준수치아님
            /// </summary>
            public const string MSG_0551 = "0551";
            /// <summary>
            /// 시재입금
            /// </summary>
            public const string MSG_0552 = "0552";
            /// <summary>
            /// 정산내역
            /// </summary>
            public const string MSG_0553 = "0553";
            /// <summary>
            /// {0} 번째 중간마감중
            /// </summary>
            public const string MSG_0554 = "0554";
            /// <summary>
            /// 시재입금
            /// </summary>
            public const string MSG_0555 = "0555";
            /// <summary>
            /// 시재금총액
            /// </summary>
            public const string MSG_0556 = "0556";
            /// <summary>
            /// 현금과부족
            /// </summary>
            public const string MSG_0557 = "0557";
            /// <summary>
            /// 상품권과부족
            /// </summary>
            public const string MSG_0558 = "0558";
            /// <summary>
            /// 해피오더 주문내역
            /// </summary>
            public const string MSG_0559 = "0559";
            /// <summary>
            /// I/C 중량
            /// </summary>
            public const string MSG_0560 = "0560";
            /// <summary>
            /// 등록일자
            /// </summary>
            public const string MSG_0561 = "0561";
            /// <summary>
            /// 외출시작
            /// </summary>
            public const string MSG_0562 = "0562";
            /// <summary>
            /// 외출종료
            /// </summary>
            public const string MSG_0563 = "0563";
            /// <summary>
            /// 외출
            /// </summary>
            public const string MSG_0564 = "0564";
            /// <summary>
            /// 휴식시작
            /// </summary>
            public const string MSG_0565 = "0565";
            /// <summary>
            /// 휴식종료
            /// </summary>
            public const string MSG_0566 = "0566";
            /// <summary>
            /// 휴식
            /// </summary>
            public const string MSG_0567 = "0567";
            /// <summary>
            /// 출근
            /// </summary>
            public const string MSG_0568 = "0568";
            /// <summary>
            /// 퇴근
            /// </summary>
            public const string MSG_0569 = "0569";
            /// <summary>
            /// 등록내역없음
            /// </summary>
            public const string MSG_0570 = "0570";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0571 = "0571";
            /// <summary>
            /// 상호인증
            /// </summary>
            public const string MSG_0572 = "0572";
            /// <summary>
            /// 무결성 관리
            /// </summary>
            public const string MSG_0573 = "0573";
            /// <summary>
            /// 무결성 검사
            /// </summary>
            public const string MSG_0574 = "0574";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0575 = "0575";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0576 = "0576";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0577 = "0577";
            /// <summary>
            /// 배달(콜센터)
            /// </summary>
            public const string MSG_0578 = "0578";
            /// <summary>
            /// 배달(배달의민족)
            /// </summary>
            public const string MSG_0579 = "0579";
            /// <summary>
            /// RF카드
            /// </summary>
            public const string MSG_0580 = "0580";
            /// <summary>
            /// 긴급메세지
            /// </summary>
            public const string MSG_0581 = "0581";
            /// <summary>
            /// ◆ 무결성 점검 내역
            /// </summary>
            public const string MSG_0582 = "0582";
            /// <summary>
            /// ◆ 상호인증 내역
            /// </summary>
            public const string MSG_0583 = "0583";
            /// <summary>
            /// 성공
            /// </summary>
            public const string MSG_0584 = "0584";
            /// <summary>
            /// 실패
            /// </summary>
            public const string MSG_0585 = "0585";
            /// <summary>
            /// 자동
            /// </summary>
            public const string MSG_0586 = "0586";
            /// <summary>
            /// 수동
            /// </summary>
            public const string MSG_0587 = "0587";
            /// <summary>
            /// POS LOG 조회
            /// </summary>
            public const string MSG_0588 = "0588";
            /// <summary>
            /// 준비점검 공지사항
            /// </summary>
            public const string MSG_0589 = "0589";
            /// <summary>
            /// 이전버전으로 프로그램복구
            /// </summary>
            public const string MSG_0590 = "0590";
            /// <summary>
            /// 현재 버전 {0}을 이전 버전 {1}으로 \n 복구 하시겠습니까?
            /// </summary>
            public const string MSG_0591 = "0591";
            /// <summary>
            /// TEST MODE
            /// </summary>
            public const string MSG_0592 = "0592";
            /// <summary>
            /// ▶ 인증 Ver : 
            /// </summary>
            public const string MSG_0593 = "0593";
            /// <summary>
            /// 환전단위
            /// </summary>
            public const string MSG_0594 = "0594";
            /// <summary>
            /// 숨기기
            /// </summary>
            public const string MSG_0595 = "0595";
            /// <summary>
            /// 매출 재전송
            /// </summary>
            public const string MSG_0596 = "0596";
            /// <summary>
            /// 총 매출 건 수
            /// </summary>
            public const string MSG_0597 = "0597";
            /// <summary>
            /// 전송 성공 건 수
            /// </summary>
            public const string MSG_0598 = "0598";
            /// <summary>
            /// 전송 실패 건 수
            /// </summary>
            public const string MSG_0599 = "0599";
            /// <summary>
            /// 재전송
            /// </summary>
            public const string MSG_0600 = "0600";
            /// <summary>
            /// 상품별 집계
            /// </summary>
            public const string MSG_0601 = "0601";
            /// <summary>
            /// 품목별 집계
            /// </summary>
            public const string MSG_0602 = "0602";
            /// <summary>
            /// 결제별 집계
            /// </summary>
            public const string MSG_0603 = "0603";
            /// <summary>
            /// 기념일배송 출력
            /// </summary>
            public const string MSG_0604 = "0604";
            /// <summary>
            /// IC 리더기
            /// </summary>
            public const string MSG_0605 = "0605";
            /// <summary>
            /// 서명패드
            /// </summary>
            public const string MSG_0606 = "0606";
            /// <summary>
            /// 추가금액할인
            /// </summary>
            public const string MSG_0607 = "0607";
            /// <summary>
            /// ▶ 서명패드 인증 Ver:
            /// </summary>
            public const string MSG_0609 = "0609";
            /// <summary>
            /// ▶ POS S/W 보안 식별정보:
            /// </summary>
            public const string MSG_0610 = "0610";
            /// <summary>
            /// - POS 식별정보:
            /// </summary>
            public const string MSG_0611 = "0611";
            /// <summary>
            /// - POS 버전정보:
            /// </summary>
            public const string MSG_0612 = "0612";
            /// <summary>
            /// 적립예정
            /// </summary>
            public const string MSG_0613 = "0613";
            /// <summary>
            /// 페이온
            /// </summary>
            public const string MSG_0614 = "0614";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0615 = "0615";
            /// <summary>
            /// 모바일쿠폰 - 해피콘
            /// </summary>
            public const string MSG_0616 = "0616";
            /// <summary>
            /// 종류
            /// </summary>
            public const string MSG_0617 = "0617";
            /// <summary>
            /// 가상쿠폰번호
            /// </summary>
            public const string MSG_0618 = "0618";
            /// <summary>
            /// 가상쿠폰명
            /// </summary>
            public const string MSG_0619 = "0619";
            /// <summary>
            /// 비고1
            /// </summary>
            public const string MSG_0620 = "0620";
            /// <summary>
            /// 비고2
            /// </summary>
            public const string MSG_0621 = "0621";
            /// <summary>
            /// 권명가액
            /// </summary>
            public const string MSG_0622 = "0622";
            /// <summary>
            /// 잔액
            /// </summary>
            public const string MSG_0623 = "0623";
            /// <summary>
            /// 가용금액
            /// </summary>
            public const string MSG_0624 = "0624";
            /// <summary>
            /// 물품형
            /// </summary>
            public const string MSG_0625 = "0625";
            /// <summary>
            /// 금액형
            /// </summary>
            public const string MSG_0626 = "0626";
            /// <summary>
            /// 불가사유
            /// </summary>
            public const string MSG_0627 = "0627";
            /// <summary>
            /// FIRE KEY
            /// </summary>
            public const string MSG_0628 = "0628";
            /// <summary>
            /// 사용
            /// </summary>
            public const string MSG_0629 = "0629";
            /// <summary>
            /// 모바일 쿠폰 - 해피콘 이력 조회
            /// </summary>
            public const string MSG_0630 = "0630";
            /// <summary>
            /// 사용일시
            /// </summary>
            public const string MSG_0631 = "0631";
            /// <summary>
            /// 매장코드
            /// </summary>
            public const string MSG_0632 = "0632";
            /// <summary>
            /// 매장명
            /// </summary>
            public const string MSG_0633 = "0633";
            /// <summary>
            /// 폐기
            /// </summary>
            public const string MSG_0634 = "0634";
            /// <summary>
            /// 기본정보
            /// </summary>
            public const string MSG_0635 = "0635";
            /// <summary>
            /// POS 정보
            /// </summary>
            public const string MSG_0636 = "0636";
            /// <summary>
            /// 계정
            /// </summary>
            public const string MSG_0637 = "0637";
            /// <summary>
            /// 회사코드
            /// </summary>
            public const string MSG_0638 = "0638";
            /// <summary>
            /// 점포코드
            /// </summary>
            public const string MSG_0639 = "0639";
            /// <summary>
            /// 디자인유형
            /// </summary>
            public const string MSG_0640 = "0640";
            /// <summary>
            /// 테마유형
            /// </summary>
            public const string MSG_0641 = "0641";
            /// <summary>
            /// 로그레벨
            /// </summary>
            public const string MSG_0642 = "0642";
            /// <summary>
            /// 글로벌
            /// </summary>
            public const string MSG_0643 = "0643";
            /// <summary>
            /// 국가(언어)코드
            /// </summary>
            public const string MSG_0644 = "0644";
            /// <summary>
            /// 문화코드
            /// </summary>
            public const string MSG_0645 = "0645";
            /// <summary>
            /// 폰트
            /// </summary>
            public const string MSG_0646 = "0646";
            /// <summary>
            /// 서버
            /// </summary>
            public const string MSG_0647 = "0647";
            /// <summary>
            /// 통신서버 IP
            /// </summary>
            public const string MSG_0648 = "0648";
            /// <summary>
            /// 도로공사 매출 URL
            /// </summary>
            public const string MSG_0649 = "0649";
            /// <summary>
            /// 도로공사 정산 URL
            /// </summary>
            public const string MSG_0650 = "0650";
            /// <summary>
            /// DB 설정
            /// </summary>
            public const string MSG_0651 = "0651";
            /// <summary>
            /// Source
            /// </summary>
            public const string MSG_0652 = "0652";
            /// <summary>
            /// Catalog
            /// </summary>
            public const string MSG_0653 = "0653";
            /// <summary>
            /// ID
            /// </summary>
            public const string MSG_0654 = "0654";
            /// <summary>
            /// Password
            /// </summary>
            public const string MSG_0655 = "0655";
            /// <summary>
            /// 한국공항공사 I/F
            /// </summary>
            public const string MSG_0656 = "0656";
            /// <summary>
            /// 사용여부
            /// </summary>
            public const string MSG_0657 = "0657";
            /// <summary>
            /// 계약번호
            /// </summary>
            public const string MSG_0658 = "0658";
            /// <summary>
            /// 한국도로공사 I/F
            /// </summary>
            public const string MSG_0659 = "0659";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0660 = "0660";
            /// <summary>
            /// 코너코드
            /// </summary>
            public const string MSG_0661 = "0661";
            /// <summary>
            /// 고객불편사항 등록
            /// </summary>
            public const string MSG_0662 = "0662";
            /// <summary>
            /// 고객정보
            /// </summary>
            public const string MSG_0663 = "0663";
            /// <summary>
            /// 제품정보
            /// </summary>
            public const string MSG_0664 = "0664";
            /// <summary>
            /// 고객처리사항
            /// </summary>
            public const string MSG_0665 = "0665";
            /// <summary>
            /// 접수번호
            /// </summary>
            public const string MSG_0666 = "0666";
            /// <summary>
            /// 대표제품명
            /// </summary>
            public const string MSG_0667 = "0667";
            /// <summary>
            /// 제품코드
            /// </summary>
            public const string MSG_0668 = "0668";
            /// <summary>
            /// (제조일자)
            /// </summary>
            public const string MSG_0669 = "0669";
            /// <summary>
            /// ex) 제품코드 6자리 제조일자
            /// </summary>
            public const string MSG_0670 = "0670";
            /// <summary>
            /// 처리구분
            /// </summary>
            public const string MSG_0671 = "0671";
            /// <summary>
            /// 제품교환
            /// </summary>
            public const string MSG_0672 = "0672";
            /// <summary>
            /// 추가보상
            /// </summary>
            public const string MSG_0673 = "0673";
            /// <summary>
            /// 매출 정보
            /// </summary>
            public const string MSG_0674 = "0674";
            /// <summary>
            /// 영업개시
            /// </summary>
            public const string MSG_0675 = "0675";
            /// <summary>
            /// 개설일시
            /// </summary>
            public const string MSG_0676 = "0676";
            /// <summary>
            /// 마감일시
            /// </summary>
            public const string MSG_0677 = "0677";
            /// <summary>
            /// PGM 버전
            /// </summary>
            public const string MSG_0678 = "0678";
            /// <summary>
            /// PGM 버전Seq
            /// </summary>
            public const string MSG_0679 = "0679";
            /// <summary>
            /// 데이터 업데이트 정보
            /// </summary>
            public const string MSG_0680 = "0680";
            /// <summary>
            /// 일반공지
            /// </summary>
            public const string MSG_0681 = "0681";
            /// <summary>
            /// 긴급공지
            /// </summary>
            public const string MSG_0682 = "0682";
            /// <summary>
            /// 영업공지_1
            /// </summary>
            public const string MSG_0683 = "0683";
            /// <summary>
            /// 영업공지_2
            /// </summary>
            public const string MSG_0684 = "0684";
            /// <summary>
            /// 메시지 번호
            /// </summary>
            public const string MSG_0685 = "0685";
            /// <summary>
            /// 거래번호(TradeNo)
            /// </summary>
            public const string MSG_0686 = "0686";
            /// <summary>
            /// 등록번호(RegNo)
            /// </summary>
            public const string MSG_0687 = "0687";
            /// <summary>
            /// 시작 거래번호
            /// </summary>
            public const string MSG_0688 = "0688";
            /// <summary>
            /// 메시지 Seq No
            /// </summary>
            public const string MSG_0689 = "0689";
            /// <summary>
            /// 영수증 프린터
            /// </summary>
            public const string MSG_0690 = "0690";
            /// <summary>
            /// IC Reader
            /// </summary>
            public const string MSG_0691 = "0691";
            /// <summary>
            /// CAT 단말기
            /// </summary>
            public const string MSG_0692 = "0692";
            /// <summary>
            /// 돈통
            /// </summary>
            public const string MSG_0693 = "0693";
            /// <summary>
            /// 유선저울
            /// </summary>
            public const string MSG_0694 = "0694";
            /// <summary>
            /// 무선저울
            /// </summary>
            public const string MSG_0695 = "0695";
            /// <summary>
            /// 사인패드
            /// </summary>
            public const string MSG_0696 = "0696";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0697 = "0697";
            /// <summary>
            /// 사용유무
            /// </summary>
            public const string MSG_0698 = "0698";
            /// <summary>
            /// 연결유형
            /// </summary>
            public const string MSG_0699 = "0699";
            /// <summary>
            /// 포트번호
            /// </summary>
            public const string MSG_0700 = "0700";
            /// <summary>
            /// 통신속도
            /// </summary>
            public const string MSG_0701 = "0701";
            /// <summary>
            /// Timeout(초)
            /// </summary>
            public const string MSG_0702 = "0702";
            /// <summary>
            /// AutoFlag
            /// </summary>
            public const string MSG_0703 = "0703";
            /// <summary>
            /// MinCnt
            /// </summary>
            public const string MSG_0704 = "0704";
            /// <summary>
            /// 모델
            /// </summary>
            public const string MSG_0705 = "0705";
            /// <summary>
            /// SIGN로그 전송
            /// </summary>
            public const string MSG_0706 = "0706";
            /// <summary>
            /// 시스템정보 전송
            /// </summary>
            public const string MSG_0707 = "0707";
            /// <summary>
            /// 트란 전송
            /// </summary>
            public const string MSG_0708 = "0708";
            /// <summary>
            /// 저널 전송
            /// </summary>
            public const string MSG_0709 = "0709";
            /// <summary>
            /// 트란 조회
            /// </summary>
            public const string MSG_0710 = "0710";
            /// <summary>
            /// 결락 조회
            /// </summary>
            public const string MSG_0711 = "0711";
            /// <summary>
            /// 결제 조회
            /// </summary>
            public const string MSG_0712 = "0712";
            /// <summary>
            /// 업무 조회
            /// </summary>
            public const string MSG_0713 = "0713";
            /// <summary>
            /// 마스터 요청
            /// </summary>
            public const string MSG_0714 = "0714";
            /// <summary>
            /// 결제로그 전송
            /// </summary>
            public const string MSG_0715 = "0715";
            /// <summary>
            /// APP로그 전송
            /// </summary>
            public const string MSG_0716 = "0716";
            /// <summary>
            /// ETC트란 전송
            /// </summary>
            public const string MSG_0717 = "0717";
            /// <summary>
            /// 신규접수
            /// </summary>
            public const string MSG_0718 = "0718";
            /// <summary>
            /// 거래정보
            /// </summary>
            public const string MSG_0719 = "0719";
            /// <summary>
            /// 주변기기
            /// </summary>
            public const string MSG_0720 = "0720";
            /// <summary>
            /// 통신포트
            /// </summary>
            public const string MSG_0721 = "0721";
            /// <summary>
            /// 프로그램 업데이트 적용중 입니다.
            /// </summary>
            public const string MSG_0722 = "0722";
            /// <summary>
            /// 프로그램 업데이트 다운로드중 입니다
            /// </summary>
            public const string MSG_0723 = "0723";
            /// <summary>
            /// 중간정산 하시겠습니까?
            /// </summary>
            public const string MSG_0724 = "0724";
            /// <summary>
            /// 업무마감 하시겠습니까?
            /// </summary>
            public const string MSG_0725 = "0725";
            /// <summary>
            /// 준비점검공지사항
            /// </summary>
            public const string MSG_0726 = "0726";
            /// <summary>
            /// 정답/오답
            /// </summary>
            public const string MSG_0727 = "0727";
            /// <summary>
            /// 적립포인트
            /// </summary>
            public const string MSG_0728 = "0728";
            /// <summary>
            /// 추가포인트
            /// </summary>
            public const string MSG_0729 = "0729";
            /// <summary>
            /// 매입처 조회
            /// </summary>
            public const string MSG_0730 = "0730";
            /// <summary>
            /// 바코드 출력
            /// </summary>
            public const string MSG_0731 = "0731";
            /// <summary>
            /// 당월
            /// </summary>
            public const string MSG_0732 = "0732";
            /// <summary>
            /// 전월
            /// </summary>
            public const string MSG_0733 = "0733";
            /// <summary>
            /// 점
            /// </summary>
            public const string MSG_0734 = "0734";
            /// <summary>
            /// 도착예정시간
            /// </summary>
            public const string MSG_0735 = "0735";
            /// <summary>
            /// 배송상태
            /// </summary>
            public const string MSG_0736 = "0736";
            /// <summary>
            /// 차량최종위치
            /// </summary>
            public const string MSG_0737 = "0737";
            /// <summary>
            /// 케익교환권
            /// </summary>
            public const string MSG_0738 = "0738";
            /// <summary>
            /// 케익교환권번호
            /// </summary>
            public const string MSG_0739 = "0739";
            /// <summary>
            /// 케익교환권금액
            /// </summary>
            public const string MSG_0740 = "0740";
            /// <summary>
            /// 위해상품
            /// </summary>
            public const string MSG_0741 = "0741";
            /// <summary>
            /// 기념일배송
            /// </summary>
            public const string MSG_0742 = "0742";
            /// <summary>
            /// 판매 준비 점검
            /// </summary>
            public const string MSG_0743 = "0743";
            /// <summary>
            /// 유통기한 점검 체크리스트
            /// </summary>
            public const string MSG_0744 = "0744";
            /// <summary>
            /// 식품안전의 날 점검
            /// </summary>
            public const string MSG_0745 = "0745";
            /// <summary>
            /// 마스터 백업
            /// </summary>
            public const string MSG_0746 = "0746";
            /// <summary>
            /// 점검항목
            /// </summary>
            public const string MSG_0747 = "0747";
            /// <summary>
            /// 점검여부
            /// </summary>
            public const string MSG_0748 = "0748";
            /// <summary>
            /// 사은품 등록
            /// </summary>
            public const string MSG_0749 = "0749";
            /// <summary>
            /// 사은수량
            /// </summary>
            public const string MSG_0750 = "0750";
            /// <summary>
            /// 추가판매가능
            /// </summary>
            public const string MSG_0751 = "0751";
            /// <summary>
            /// 추가판매불가
            /// </summary>
            public const string MSG_0752 = "0752";
            /// <summary>
            /// 전체사은품
            /// </summary>
            public const string MSG_0753 = "0753";
            /// <summary>
            /// 지급사은품
            /// </summary>
            public const string MSG_0754 = "0754";
            /// <summary>
            /// 수량합계
            /// </summary>
            public const string MSG_0755 = "0755";
            /// <summary>
            /// 금액합계
            /// </summary>
            public const string MSG_0756 = "0756";
            /// <summary>
            /// 사은품명
            /// </summary>
            public const string MSG_0757 = "0757";
            /// <summary>
            /// 등록금액
            /// </summary>
            public const string MSG_0758 = "0758";
            /// <summary>
            /// 할인합계
            /// </summary>
            public const string MSG_0759 = "0759";
            /// <summary>
            /// OK
            /// </summary>
            public const string MSG_0760 = "0760";
            /// <summary>
            /// NG
            /// </summary>
            public const string MSG_0761 = "0761";
            /// <summary>
            /// PASS
            /// </summary>
            public const string MSG_0762 = "0762";
            /// <summary>
            /// 기념일배송 주문정보 출력
            /// </summary>
            public const string MSG_0763 = "0763";
            /// <summary>
            /// 출력파일
            /// </summary>
            public const string MSG_0764 = "0764";
            /// <summary>
            /// 주문관리 페이지 접속하기
            /// </summary>
            public const string MSG_0765 = "0765";
            /// <summary>
            /// 오늘은 "식품 안전의 날" 입니다.
            /// </summary>
            public const string MSG_0766 = "0766";
            /// <summary>
            /// 보건증 만료일
            /// </summary>
            public const string MSG_0767 = "0767";
            /// <summary>
            /// 주요 원료 유통기한 만료일
            /// </summary>
            public const string MSG_0768 = "0768";
            /// <summary>
            /// 기타 사항
            /// </summary>
            public const string MSG_0769 = "0769";
            /// <summary>
            /// 해피포인트 사용 - 중국
            /// </summary>
            public const string MSG_0770 = "0770";
            /// <summary>
            /// 잔액교환권 ({0})매
            /// </summary>
            public const string MSG_0771 = "0771";
            /// <summary>
            /// 사용매수:
            /// </summary>
            public const string MSG_0772 = "0772";
            /// <summary>
            /// 결재금액:
            /// </summary>
            public const string MSG_0773 = "0773";
            /// <summary>
            /// 스캐너초기화
            /// </summary>
            public const string MSG_0774 = "0774";
            /// <summary>
            /// 초기화
            /// </summary>
            public const string MSG_0775 = "0775";
            /// <summary>
            /// 이름표 출력
            /// </summary>
            public const string MSG_0776 = "0776";
            /// <summary>
            /// 스캐너 초기화 셋팅 출력
            /// </summary>
            public const string MSG_0777 = "0777";
            /// <summary>
            /// 무선스캐너 PC용
            /// </summary>
            public const string MSG_0778 = "0778";
            /// <summary>
            /// 무선스캐너 모바일용
            /// </summary>
            public const string MSG_0779 = "0779";
            /// <summary>
            /// 무선스캐너 인식율향상
            /// </summary>
            public const string MSG_0780 = "0780";
            /// <summary>
            /// iOS키패드
            /// </summary>
            public const string MSG_0781 = "0781";
            /// <summary>
            /// ▶▶ 결제후 잔액 금액:
            /// </summary>
            public const string MSG_0782 = "0782";
            /// <summary>
            /// ▶▶ 식권 결제후 잔액 금액:
            /// </summary>
            public const string MSG_0783 = "0783";
            /// <summary>
            /// ▶▶ 상품권 결제후 잔액 금액:
            /// </summary>
            public const string MSG_0784 = "0784";
            /// <summary>
            /// 식권 매출전표 [잔액교환권 포함]
            /// </summary>
            public const string MSG_0785 = "0785";
            /// <summary>
            /// 상품권 매출전표 [잔액교환권 포함]
            /// </summary>
            public const string MSG_0786 = "0786";
            /// <summary>
            /// 마스터 (전체)
            /// </summary>
            public const string MSG_0787 = "0787";
            /// <summary>
            /// 마스터 (변경분)
            /// </summary>
            public const string MSG_0788 = "0788"; 
            /// <summary>
            /// 해피포인트
            /// </summary>
            public const string MSG_0789 = "0789";
            /// <summary>
            /// 내역
            /// </summary>
            public const string MSG_0790 = "0790";
            /// <summary>
            /// 잔액교환권번호
            /// </summary>
            public const string MSG_0791 = "0791";
            /// <summary>
            /// 잔액교환권금액
            /// </summary>
            public const string MSG_0792 = "0792";
            /// <summary>
            /// 브랜드코드
            /// </summary>
            public const string MSG_0793 = "0793";
            /// <summary>
            /// 해피포인트 적립 - 중국
            /// </summary>
            public const string MSG_0794 = "0794";
            /// <summary>
            /// 교통카드
            /// </summary>
            public const string MSG_0795 = "0795";
            /// <summary>
            /// 해피머니 상품권 취급시 유의사항
            /// </summary>
            public const string MSG_0796 = "0796";
            /// <summary>
            /// 해피머니 상품권 도움말
            /// </summary>
            public const string MSG_0797 = "0797";
            /// <summary>
            /// 입출금
            /// </summary>
            public const string MSG_0798 = "0798";
            /// <summary>
            /// 설정
            /// </summary>
            public const string MSG_0799 = "0799";
            /// <summary>
            /// 다운로드/업데이트
            /// </summary>
            public const string MSG_0800 = "0800";
            /// <summary>
            /// 인증/체크
            /// </summary>
            public const string MSG_0801 = "0801";
            /// <summary>
            /// 매출조회
            /// </summary>
            public const string MSG_0802 = "0802";
            /// <summary>
            /// 재발행/점검
            /// </summary>
            public const string MSG_0803 = "0803";
            /// <summary>
            /// 기타조회
            /// </summary>
            public const string MSG_0804 = "0804";
            /// <summary>
            /// 기타등록
            /// </summary>
            public const string MSG_0805 = "0805";
            /// <summary>
            /// 기타기능
            /// </summary>
            public const string MSG_0806 = "0806";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0807 = "0807";
            /// <summary>
            /// 교육상품
            /// </summary>
            public const string MSG_0808 = "0808";
            /// <summary>
            /// {0}분 경과
            /// </summary>
            public const string MSG_0809 = "0809";
            /// <summary>
            /// 테이블 편집
            /// </summary>
            public const string MSG_0810 = "0810";
            /// <summary>
            /// 테이블 속성
            /// </summary>
            public const string MSG_0811 = "0811";
            /// <summary>
            /// 상품목록
            /// </summary>
            public const string MSG_0812 = "0812";
            /// <summary>
            /// 층 관리 
            /// </summary>
            public const string MSG_0813 = "0813";
            /// <summary>
            /// 테이블 관리
            /// </summary>
            public const string MSG_0814 = "0814";
            /// <summary>
            /// 코드
            /// </summary>
            public const string MSG_0815 = "0815";
            /// <summary>
            /// 명
            /// </summary>
            public const string MSG_0816 = "0816";
            /// <summary>
            /// 지움
            /// </summary>
            public const string MSG_0817 = "0817";
            /// <summary>
            /// 선불카드 사용 - 중국
            /// </summary>
            public const string MSG_0818 = "0818";
            /// <summary>
            /// 픽업/배달일시
            /// </summary>
            public const string MSG_0819 = "0819";
            /// <summary>
            /// 테이블 번호 
            /// </summary>
            public const string MSG_0820 = "0820";
            /// <summary>
            /// 테이블 이름
            /// </summary>
            public const string MSG_0821 = "0821";
            /// <summary>
            /// 폰트 크기
            /// </summary>
            public const string MSG_0822 = "0822";
            /// <summary>
            /// 위치 (X,Y)
            /// </summary>
            public const string MSG_0823 = "0823";
            /// <summary>
            /// 크기 (W,H)
            /// </summary>
            public const string MSG_0824 = "0824";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0825 = "0825";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0826 = "0826";
            /// <summary>
            /// OKCASHBACK 적립
            /// </summary>
            public const string MSG_0827 = "0827";
            /// <summary>
            /// 대기번호
            /// </summary>
            public const string MSG_0828 = "0828";
            /// <summary>
            /// 행사
            /// </summary>
            public const string MSG_0829 = "0829";
            /// <summary>
            /// 묶음
            /// </summary>
            public const string MSG_0830 = "0830";
            /// <summary>
            /// 단골고객해지
            /// </summary>
            public const string MSG_0831 = "0831";
            /// <summary>
            /// 픽업
            /// </summary>
            public const string MSG_0832 = "0832";
            /// <summary>
            /// 오늘 픽업/배달 주문서출력
            /// </summary>
            public const string MSG_0833 = "0833";
            /// <summary>
            /// 스마일페이
            /// </summary>
            public const string MSG_0834 = "0834";
            /// <summary>
            /// T 페이
            /// </summary>
            public const string MSG_0835 = "0835";
            /// <summary>
            /// BLE 결제
            /// </summary>
            public const string MSG_0836 = "0836";
            /// <summary>
            /// 오더폼 내점
            /// </summary>
            public const string MSG_0837 = "0837";
            /// <summary>
            /// 오더폼 배달
            /// </summary>
            public const string MSG_0838 = "0838";
            /// <summary>
            /// 현장주문완료
            /// </summary>
            public const string MSG_0839 = "0839";
            /// <summary>
            /// 주변장치 상태 조회
            /// </summary>
            public const string MSG_0840 = "0840";
            /// <summary>
            /// 해피버즈 등록
            /// </summary>
            public const string MSG_0841 = "0841";
            /// <summary>
            /// 해피버즈 현황
            /// </summary>
            public const string MSG_0842 = "0842";
            /// <summary>
            /// 추가지급
            /// </summary>
            public const string MSG_0843 = "0843";
            /// <summary>
            /// 등록취소
            /// </summary>
            public const string MSG_0844 = "0844";
            /// <summary>
            /// 해피콕
            /// </summary>
            public const string MSG_0845 = "0845";
            /// <summary>
            /// 현장결제
            /// </summary>
            public const string MSG_0846 = "0846";
            /// <summary>
            /// ▶ 주변장치 상태
            /// </summary>
            public const string MSG_0847 = "0847";
            /// <summary>
            /// ▶ 네트워크 상태
            /// </summary>
            public const string MSG_0848 = "0848";

            /// <summary>
            /// 프린터
            /// </summary>
            public const string MSG_0849 = "0849";
            /// <summary>
            /// 스캐너
            /// </summary>
            public const string MSG_0850 = "0850";
            /// <summary>
            /// IC리더기
            /// </summary>
            public const string MSG_0851 = "0851";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0852 = "0852";
            /// <summary>
            /// 라벨프린터
            /// </summary>
            public const string MSG_0853 = "0853";
            /// <summary>
            /// CAT단말기
            /// </summary>
            public const string MSG_0854 = "0854";
            /// <summary>
            /// 전자저울
            /// </summary>
            public const string MSG_0855 = "0855";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0856 = "0856";
            /// <summary>
            /// MSR
            /// </summary>
            public const string MSG_0857 = "0857";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0858 = "0858";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0859 = "0859";
            /// <summary>
            /// SERVER
            /// </summary>
            public const string MSG_0860 = "0860";
            /// <summary>
            /// 미사용
            /// </summary>
            public const string MSG_0861 = "0861";
            /// <summary>
            /// 오류
            /// </summary>
            public const string MSG_0862 = "0862";
            /// <summary>
            /// 사용전 잔액
            /// </summary>
            public const string MSG_0863 = "0863";
            /// <summary>
            /// 사용후 잔액
            /// </summary>
            public const string MSG_0864 = "0864";
            /// <summary>
            /// 일반결제 
            /// </summary>
            public const string MSG_0865 = "0865";
            /// <summary>
            /// 통합결제 
            /// </summary>
            public const string MSG_0866 = "0866";
            /// <summary>
            /// 제품명 
            /// </summary>
            public const string MSG_0867 = "0867";
            /// <summary>
            /// 할인만 처리
            /// </summary>
            public const string MSG_0868 = "0868";
            /// <summary>
            /// 통합결제(할인+결제)\n화면으로 이동
            /// </summary>
            public const string MSG_0869 = "0869";
            /// <summary>
            /// 판매일자
            /// </summary>
            public const string MSG_0870 = "0870";
            /// <summary>
            /// 포인트금액
            /// </summary>
            public const string MSG_0871 = "0871";
            /// <summary>
            /// 반품구분
            /// </summary>
            public const string MSG_0872 = "0872";
            /// <summary>
            /// 한국공항공사 매출재전송
            /// </summary>
            public const string MSG_0873 = "0873";
            /// <summary>
            /// 도로공사 매출재전송
            /// </summary>
            public const string MSG_0874 = "0874";
            /// <summary>
            /// 전송일자
            /// </summary>
            public const string MSG_0875 = "0875";
            /// <summary>
            /// 해피포인트 추후적립 내역
            /// </summary>
            public const string MSG_0876 = "0876";
            /// <summary>
            /// 이력조회
            /// </summary>
            public const string MSG_0877 = "0877";
            /// <summary>
            /// POP카드
            /// </summary>
            public const string MSG_0878 = "0878";
            /// <summary>
            /// 고정너비 폰트
            /// </summary>
            public const string MSG_0879 = "0879";
            /// <summary>
            /// 간편출력
            /// </summary>
            public const string MSG_0881 = "0881";
            /// <summary>
            /// 프로그램 다운로드
            /// </summary>
            public const string MSG_0882 = "0882";
            /// <summary>
            /// 이미지 다운로드
            /// </summary>
            public const string MSG_0883 = "0883";
            /// <summary>
            /// 마스터 다운로드
            /// </summary>
            public const string MSG_0884 = "0884";
            /// <summary>
            /// 최신 프로그램을 다운로드 하거나 이전버전으로 프로그램 복구를 하실수 있습니다.
            /// </summary>
            public const string MSG_0885 = "0885";
            /// <summary>
            /// 최신 상품 및 고객화면등 이미지를 수신 하실 수 있습니다.
            /// </summary>
            public const string MSG_0886 = "0886";
            /// <summary>
            /// 최신 상품 단가 및 단축키 정보를 수신 하실 수 있습니다.
            /// </summary>
            public const string MSG_0887 = "0887";
            /// <summary>
            /// 30분 전
            /// </summary>
            public const string MSG_0888 = "0888";
            /// <summary>
            /// 1시간 전
            /// </summary>
            public const string MSG_0889 = "0889";
            /// <summary>
            /// 1시간 30분 전
            /// </summary>
            public const string MSG_0890 = "0890";
            /// <summary>
            /// 2시간 전
            /// </summary>
            public const string MSG_0891 = "0891";
            /// <summary>
            /// 알람사용
            /// </summary>
            public const string MSG_0892 = "0892";
            /// <summary>
            /// 로그 Viewer
            /// </summary>
            public const string MSG_0893 = "0893";
            /// <summary>
            /// 로그
            /// </summary>
            public const string MSG_0894 = "0894";
            /// <summary>
            /// 고객번호채번
            /// </summary>
            public const string MSG_0895 = "0895";
            /// <summary>
            /// 미발급
            /// </summary>
            public const string MSG_0896 = "0896";
            /// <summary>
            /// 자진발급
            /// </summary>
            public const string MSG_0897 = "0897";
            /// <summary>
            /// 영업정보
            /// </summary>
            public const string MSG_0898 = "0898";
            /// <summary>
            /// 마스터 배치
            /// </summary>
            public const string MSG_0899 = "0899";
            /// <summary>
            /// 통신서버 Port
            /// </summary>
            public const string MSG_0900 = "0900";
            /// <summary>
            /// 입고처리
            /// </summary>
            public const string MSG_0901 = "0901";
            /// <summary>
            /// 생산등록
            /// </summary>
            public const string MSG_0902 = "0902";
            /// <summary>
            /// 상단 텍스트 로고 출력
            /// </summary>
            public const string MSG_0903 = "0903";
            /// <summary>
            /// 브랜드구분
            /// </summary>
            public const string MSG_0904 = "0904";
            /// <summary>
            /// 우리모아포인트
            /// </summary>
            public const string MSG_0905 = "0905";
            /// <summary>
            /// 현대M포인트
            /// </summary>
            public const string MSG_0906 = "0906";
            /// <summary>
            /// 거래처명
            /// </summary>
            public const string MSG_0907 = "0907";
            /// <summary>
            /// 사전예약
            /// </summary>
            public const string MSG_0908 = "0908";
            /// <summary>
            /// LOGO 업로드
            /// </summary>
            public const string MSG_0909 = "0909";
            /// <summary>
            /// 일반
            /// </summary>
            public const string MSG_0910 = "0910";
            /// <summary>
            /// 세트
            /// </summary>
            public const string MSG_0911 = "0911";
            /// <summary>
            /// 구성상품
            /// </summary>
            public const string MSG_0912 = "0912";
            /// <summary>
            /// 부가상품
            /// </summary>
            public const string MSG_0913 = "0913";
            /// <summary>
            /// 세트할인
            /// </summary>
            public const string MSG_0914 = "0914";
            /// <summary>
            /// 상품권(추가)
            /// </summary>
            public const string MSG_0915 = "0915";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0916 = "0916";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0917 = "0917";
            /// <summary>
            /// 미등록
            /// </summary>
            public const string MSG_0918 = "0918";
            /// <summary>
            /// 회차
            /// </summary>
            public const string MSG_0919 = "0919";
            /// <summary>
            /// 배송 기사명
            /// </summary>
            public const string MSG_0920 = "0920";
            /// <summary>
            /// 배송 차량번호
            /// </summary>
            public const string MSG_0921 = "0921";
            /// <summary>
            /// 배송기사 연락처
            /// </summary>
            public const string MSG_0922 = "0922";
            /// <summary>
            /// 배송추적
            /// </summary>
            public const string MSG_0923 = "0923";
            /// <summary>
            /// 미도착
            /// </summary>
            public const string MSG_0924 = "0924";
            /// <summary>
            /// 출발대기
            /// </summary>
            public const string MSG_0925 = "0925";
            /// <summary>
            /// 배송중
            /// </summary>
            public const string MSG_0926 = "0926";
            /// <summary>
            /// 배송완료
            /// </summary>
            public const string MSG_0927 = "0927";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0928 = "0928";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0929 = "0929";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0930 = "0930";
            ///// <summary>
            ///// 
            ///// </summary>
            //public const string MSG_0931 = "0931";
            /// <summary>
            /// ※ 배송차량이 출발전이면 도착예정시간이 안내되지 않습니다. (배송상태란에 "출발대기"로 표시)
            /// </summary>
            public const string MSG_0932 = "0932";
            /// <summary>
            /// ※ 배송상태가 "배송중" 또는 "배송완료" 상태임에도 예정시간이 안내되지 않을 경우 배송기사에게 문의바랍니다.
            /// </summary>
            public const string MSG_0933 = "0933";
            /// <summary>
            /// ※ 점착정보안내 시스템과 관련한 문의사항은 배송관리팀(031-737-8406)으로 연락바랍니다.
            /// </summary>
            public const string MSG_0934 = "0934";
            /// <summary>
            /// ※ 차수를 선택하면 배송차량 정보가 안내됩니다.
            /// </summary>
            public const string MSG_0935 = "0935";
            /// <summary>
            /// ※ 3차, 4차 : 냉동전용배송
            /// </summary>
            public const string MSG_0936 = "0936";
            /// <summary>
            /// 해당 정보는 참고용이며, 실제 시간과 차이가 있을 수 있습니다.
            /// </summary>
            public const string MSG_0937 = "0937";
            /// <summary>
            /// 종
            /// </summary>
            public const string MSG_0938 = "0938";
            /// <summary>
            /// CDP
            /// </summary>
            public const string MSG_0939 = "0939";
            /// <summary>
            /// 수련직
            /// </summary>
            public const string MSG_0940 = "0940";
            /// <summary>
            /// POS 운영 이미지
            /// </summary>
            public const string MSG_0941 = "0941";
            /// <summary>
            /// 고객면 이미지
            /// </summary>
            public const string MSG_0942 = "0942";
            /// <summary>
            /// 상품 이미지
            /// </summary>
            public const string MSG_0943 = "0943";
            /// <summary>
            /// 캠페인 이미지
            /// </summary>
            public const string MSG_0944 = "0944";
            /// <summary>
            /// 시험모드 이미지
            /// </summary>
            public const string MSG_0945 = "0945";
            /// <summary>
            /// 매장즉시
            /// </summary>
            public const string MSG_0946 = "0946";
            /// <summary>
            /// 픽업 완료
            /// </summary>
            public const string MSG_0947 = "0947";
            /// <summary>
            /// 주문 취소
            /// </summary>
            public const string MSG_0948 = "0948";
            /// <summary>
            /// 픽업시간
            /// </summary>
            public const string MSG_0949 = "0949";
            /// <summary>
            /// 주문일시
            /// </summary>
            public const string MSG_0950 = "0950";
            /// <summary>
            /// 수 령 자
            /// </summary>
            public const string MSG_0951 = "0951";
            /// <summary>
            /// 연 락 처
            /// </summary>
            public const string MSG_0952 = "0952";
            /// <summary>
            /// 배달시간
            /// </summary>
            public const string MSG_0953 = "0953";
            /// <summary>
            /// 배달기사
            /// </summary>
            public const string MSG_0954 = "0954";
            /// <summary>
            /// 라이더요청
            /// </summary>
            public const string MSG_0955 = "0955";
            /// <summary>
            /// 라이더접수
            /// </summary>
            public const string MSG_0956 = "0956";
            /// <summary>
            /// 합계금액
            /// </summary>
            public const string MSG_0957 = "0957";
            /// <summary>
            /// 온라인쿠폰
            /// </summary>
            public const string MSG_0958 = "0958";
            /// <summary>
            /// 임직원
            /// </summary>
            public const string MSG_0959 = "0959";
            /// <summary>
            /// 교환권(온라인쿠폰)
            /// </summary>
            public const string MSG_0960 = "0960";
            /// <summary>
            /// 증정권(온라인쿠폰)
            /// </summary>
            public const string MSG_0961 = "0961";
            /// <summary>
            /// 금액권(온라인쿠폰)
            /// </summary>
            public const string MSG_0962 = "0962";
            /// <summary>
            /// 할인권(온라인쿠폰)
            /// </summary>
            public const string MSG_0963 = "0963";
            /// <summary>
            /// 상품지정할인권(온라인쿠폰)
            /// </summary>
            public const string MSG_0964 = "0964";
            /// <summary>
            /// 일일점검리스트
            /// </summary>
            public const string MSG_0965 = "0965";
            /// <summary>
            /// AS완료
            /// </summary>
            public const string MSG_0966 = "0966";
            /// <summary>
            /// 점포완료
            /// </summary>
            public const string MSG_0967 = "0967";
            /// <summary>
            /// 장비명
            /// </summary>
            public const string MSG_0968 = "0968";
            /// <summary>
            /// 중점 Check 사항
            /// </summary>
            public const string MSG_0969 = "0969";
            /// <summary>
            /// 점검
            /// </summary>
            public const string MSG_0970 = "0970";
            /// <summary>
            /// 알리페이/위챗페이
            /// </summary>
            public const string MSG_0971 = "0971";
            /// <summary>
            /// 주방출력
            /// </summary>
            public const string MSG_0972 = "0972";
            /// <summary>
            /// 출력안함
            /// </summary>
            public const string MSG_0973 = "0973";
            /// <summary>
            /// 사업자번호
            /// </summary>
            public const string MSG_0974 = "0974";
            /// <summary>
            /// 매입처명
            /// </summary>
            public const string MSG_0975 = "0975";
            /// <summary>
            /// 신용카드할인결제
            /// </summary>
            public const string MSG_0976 = "0976";
            /// <summary>
            /// 티머니할인결제
            /// </summary>
            public const string MSG_0977 = "0977";
            /// <summary>
            /// 캐시비할인결제
            /// </summary>
            public const string MSG_0978 = "0978";
            /// <summary>
            /// 스마일페이할인결제
            /// </summary>
            public const string MSG_0979 = "0979";
            /// <summary>
            /// 결락 전송중 . . . (0%)
            /// </summary>
            public const string MSG_0980 = "0980";
            /// <summary>
            /// 부가세/봉사료
            /// </summary>
            public const string MSG_0981 = "0981";
            /// <summary>
            /// 율
            /// </summary>
            public const string MSG_0982 = "0982";
            /// <summary>
            /// 적용방법
            /// </summary>
            public const string MSG_0983 = "0983";
            /// <summary>
            /// 적용금액(율)
            /// </summary>
            public const string MSG_0984 = "0984";
            /// <summary>
            /// 봉사료
            /// </summary>
            public const string MSG_0985 = "0985";
            /// <summary>
            /// 사용점포
            /// </summary>
            public const string MSG_0986 = "0986";
            /// <summary>
            /// 매입처정보
            /// </summary>
            public const string MSG_0987 = "0987";
            /// <summary>
            /// 영수증 로고 이미지
            /// </summary>
            public const string MSG_0988 = "0988";
            /// <summary>
            /// 점포
            /// </summary>
            public const string MSG_0989 = "0989";
            /// <summary>
            /// 양호
            /// </summary>
            public const string MSG_0990 = "0990";
            /// <summary>
            /// 불량
            /// </summary>
            public const string MSG_0991 = "0991";
            /// <summary>
            /// 업무구분
            /// </summary>
            public const string MSG_0992 = "0992";
            /// <summary>
            /// 기타사유
            /// </summary>
            public const string MSG_0993 = "0993";
            /// <summary>
            /// 미점검
            /// </summary>
            public const string MSG_0994 = "0994";
            /// <summary>
            /// 이상무
            /// </summary>
            public const string MSG_0995 = "0995";
            /// <summary>
            /// 점검중
            /// </summary>
            public const string MSG_0996 = "0996";
            /// <summary>
            /// 점검완료
            /// </summary>
            public const string MSG_0997 = "0997";
            /// <summary>
            /// 개(수량/총금액 구분자)
            /// </summary>
            public const string MSG_0998 = "0998";
            /// <summary>
            /// 번호필수
            /// </summary>
            public const string MSG_0999 = "0999";
            /// <summary>
            /// OCB 가맹점 인증중 입니다. 잠시만 기다려 주십시요.
            /// </summary>
            public const string MSG_1000 = "1000";
            /// <summary>
            /// OCB 가맹점 등록중 입니다. 잠시만 기다려 주십시요.
            /// </summary>
            public const string MSG_1001 = "1001";
            /// <summary>
            /// VIP POINT
            /// </summary>
            public const string MSG_1002 = "1002";
            /// <summary>
            /// TO STAY
            /// </summary>
            public const string MSG_1003 = "1003";
            /// <summary>
            /// TO GO
            /// </summary>
            public const string MSG_1004 = "1004";
            /// <summary>
            /// TO DELIVERY
            /// </summary>
            public const string MSG_1005 = "1005";
            /// <summary>
            /// VIP
            /// </summary>
            public const string MSG_1006 = "1006";
            /// <summary>
            /// 직원
            /// </summary>
            public const string MSG_1007 = "1007";
            /// <summary>
            /// SPC 임직원 할인(결제)
            /// </summary>
            public const string MSG_1008 = "1008";
            /// <summary>
            /// 【해피오더】 일반({0:00})/배달({1:00})/예약({2:00})
            /// </summary>
            public const string MSG_1009 = "1009";
            /// <summary>
            /// 기타결제
            /// </summary>
            public const string MSG_1010 = "1010";
            /// <summary>
            /// 건강한 다음
            /// </summary>
            public const string MSG_1011 = "1011";
            /// <summary>
            /// 세대를 위한
            /// </summary>
            public const string MSG_1012 = "1012";
            /// <summary>
            /// 행복한 나눔...
            /// </summary>
            public const string MSG_1013 = "1013";
            /// <summary>
            /// 생일 초 수량 계산
            /// </summary>
            public const string MSG_1014 = "1014";
            /// <summary>
            /// 생년입력
            /// </summary>
            public const string MSG_1015 = "1015";
            /// <summary>
            /// 계산
            /// </summary>
            public const string MSG_1016 = "1016";
            /// <summary>
            /// 생일초
            /// </summary>
            public const string MSG_1017 = "1017";
            /// <summary>
            /// 제품\r\n검색
            /// </summary>
            public const string MSG_1018 = "1018";
            /// <summary>
            /// IC리더기 업데이트
            /// </summary>
            public const string MSG_1019 = "1019";
            /// <summary>
            /// 현재 통신불량상태입니다. 인터넷 확인하세요.
            /// </summary>
            public const string MSG_1020 = "1020";
            /// <summary>
            /// 할인구분
            /// </summary>
            public const string MSG_1021 = "1021";
            /// <summary>
            /// 선택상품할인
            /// </summary>
            public const string MSG_1022 = "1022";
            /// <summary>
            /// 예외할인
            /// </summary>
            public const string MSG_1023 = "1023";
            /// <summary>
            /// KT멤버십 더블할인
            /// </summary>
            public const string MSG_1024 = "1024";
            /// <summary>
            /// 일마감-점검처리내역
            /// </summary>
            public const string MSG_1025 = "1025";
            /// <summary>
            /// 마스터 (캠페인-전체)
            /// </summary>
            public const string MSG_1026 = "1026";
            //#20170731, 해피기프트카드(코나머니) 개발 Start, srlee
            /// <summary>
            /// 해피기프트카드(코나머니)
            /// </summary>
            public const string MSG_1027 = "1027";
            //#20170731, 해피기프트카드(코나머니) 개발 End, srlee
            /// <summary>
            /// 해피오더 요기요 주문내역
            /// </summary>
            public const string MSG_1028 = "1028";                      //#10906_[BR] 요기요 해피오더 매출 처리 기능 개발_hs
            /// <summary>
            /// 제휴할인(통합)
            /// </summary>
            public const string MSG_1029 = "1029";                      // 제휴카드(통합) 할인 처리(2017.08.29) -- START

            //#20170906 T페이 고도화 작업 phj, start
            /// <summary>
            /// * 결제비밀번호 필요
            /// </summary>
            public const string MSG_1030 = "1030";
            //#20170906 T페이 고도화 작업 phj, end

            //#20170906 T페이 고도화 작업 phj, start
            /// <summary>
            /// * 결제비밀번호 불필요
            /// </summary>
            public const string MSG_1031 = "1031";
            //#20170906 T페이 고도화 작업 phj, end

            // #20170915 분류별 정산 내역 추가 start, phj
            /// <summary>
            /// 분류
            /// </summary>
            public const string MSG_1032 = "1032";

            /// <summary>
            /// 분류별 정산 내역
            /// </summary>
            public const string MSG_1033 = "1033";
            // #20170915 분류별 정산 내역 추가 end, phj

            //#20170918 기념일 배송 출력 start
            /// <summary>
            /// 기념일 배송 출력
            /// </summary>
            public const string MSG_1034 = "1034";
            //#20170918 기념일 배송 출력 end

            // #Rhee, 20170921 간편조회 번역 누락 추가 start
            /// <summary>
            /// 간편조회
            /// </summary>
            public const string MSG_1035 = "1035";
            // #Rhee, 20170921 간편조회 번역 누락 추가 end

            // #Rhee, 20170922 딜리버리 외매(선매) 추가 start
            /// <summary>
            /// 딜리버리 외매(선매)
            /// </summary>
            public const string MSG_1036 = "1036";
            // #Rhee, 20170922 딜리버리 외매(선매) 추가 end

            // #Rhee, 20170922 은련페이 추가 start
            /// <summary>
            /// 은련모바일페이
            /// </summary>
            public const string MSG_1037 = "1037";
            // #Rhee, 20170922 은련페이 추가 end


            /// <summary>
            /// 위쳇페이 바이롱
            /// </summary>
            public const string MSG_1040 = "1040";          //2017.09.11.001, 위쳇페이 바이롱;girak.kim

            /// <summary>
            /// 기프트 카드
            /// </summary>
            public const string MSG_1041 = "1041";          //2017.09.11.001, 기프트 카드;girak.kim

            /// <summary>
            /// 매장배달중
            /// </summary>
            public const string MSG_1060 = "1060";          // 2017.10.26 MoonSeokWoo 매장배달중
            /// <summary>
            /// 매장배달완료
            /// </summary>
            public const string MSG_1061 = "1061";          // 2017.10.26 MoonSeokWoo 매장배달

            /// <summary>
            /// 일
            /// </summary>
            public const string MSG_1062 = "1062";          // 2017.11.08 MoonSeokWoo 일
            /// <summary>
            /// 월
            /// </summary>
            public const string MSG_1063 = "1063";          // 2017.11.08 MoonSeokWoo 월
            /// <summary>
            /// 화
            /// </summary>
            public const string MSG_1064 = "1064";          // 2017.11.08 MoonSeokWoo 화
            /// <summary>
            /// 수
            /// </summary>
            public const string MSG_1065 = "1065";          // 2017.11.08 MoonSeokWoo 수
            /// <summary>
            /// 목
            /// </summary>
            public const string MSG_1066 = "1066";          // 2017.11.08 MoonSeokWoo 목
            /// <summary>
            /// 금
            /// </summary>
            public const string MSG_1067 = "1067";          // 2017.11.08 MoonSeokWoo 금
            /// <summary>
            /// 토
            /// </summary>
            public const string MSG_1068 = "1068";          // 2017.11.08 MoonSeokWoo 토

            /// <summary>
            /// 환전
            /// </summary>
            public const string MSG_1070 = "1070";

            //#20171113 담당자별 매출 조회 분류별 제품 나오도록 수정 start,phj
            /// <summary>
            /// 소계
            /// </summary>
            public const string MSG_1075 = "1075";

            /// <summary>
            /// ** 분류별 제품내역 **
            /// </summary>
            public const string MSG_1076 = "1076";
            //#20171113 담당자별 매출 조회 분류별 제품 나오도록 수정 end,phj

            //#20171107 통제관리 start, phj 
            /// <summary>
            /// 통제 비밀번호를 입력해주세요.
            /// </summary>
            public const string MSG_1078 = "1078";
            //#20171107 통제관리 end, phj

            //#12283 PB 천안신세계_해피포인트 부정적립 경구 문구 삽입요청 start, phj
            /// <summary>
            /// * 포인트 부정 적립은 민/형사상 처벌 대상이 될 수 있습니다.
            /// </summary>
            public const string MSG_1079 = "1079";
            //#12283 PB 천안신세계_해피포인트 부정적립 경구 문구 삽입요청 end, phj
            
            //grayber@20171123 해피오더 직접배달 start
            /// <summary>
            /// 직접배달
            /// </summary>
            public const string MSG_1080 = "1080";
            //grayber@20171123 해피오더 직접배달 end
            
            //*** MoonSeokWoo 2017.12.12 Add
            /// <summary>
            /// 신한포인트
            /// </summary>
            public const string MSG_1081 = "1081";
            //*** MoonSeokWoo 2017.12.12 End

            //#20171227 인천공항 포스연동 start, phj
            /// <summary>
            /// 인천공항 포스연동
            /// </summary>
            public const string MSG_1082 = "1082";
            //#20171227 인천공항 포스연동 end, phj


            //2017.12.19;ACC_MST 메뉴안에 "점포결제유형";girak.kim
            /// <summary>
            /// 점포결제유형
            /// </summary>
            public const string MSG_1083 = "1083";
            //2017.12.19;ACC_MST 메뉴안에 "점포결제유형";girak.kim End

            // grayber@20180115 인천공항 VIP 라운지 start - 메시지 추가 (VIP 라운지)
            /// <summary>
            /// VIP 라운지
            /// </summary>
            public const string MSG_1084 = "1084";
            // grayber@20180115 인천공항 VIP 라운지 end

            //#Rhee, 20180117 미주 예약픽업 추가 Srtat
            /// <summary>
            /// 예약픽업
            /// </summary>
            public const string MSG_1085 = "1085";
            //#Rhee, 20180117 미주 예약픽업 추가 End

            //#Rhee, 20180201 잠금해제 메시지 추가 start
            /// <summary>
            /// 잠금해제 
            /// </summary>
            public const string MSG_1086 = "1086";
            //#Rhee, 20180201 잠금해제 메시지 추가 end

            //grayber@20180201
            /// <summary>
            /// 주 소 지
            /// </summary>
            public const string MSG_1087 = "1087";
            //grayber@20180201

            //#13753 POS MOT음성 기능 추가 개발요청 start
            /// <summary>
            /// 미사용
            /// </summary>
            public const string MSG_1088 = "1088";

            /// <summary>
            /// 맞이인사&HP표준
            /// </summary>
            public const string MSG_1089 = "1089";

            /// <summary>
            /// 해피포인트사용
            /// </summary>
            public const string MSG_1090 = "1090";

            /// <summary>
            /// 현금영수증
            /// </summary>
            public const string MSG_1091 = "1091";

            /// <summary>
            /// 구매영수증
            /// </summary>
            public const string MSG_1092 = "1092";

            /// <summary>
            /// 사용
            /// </summary>
            public const string MSG_1093 = "1093";

            /// <summary>
            /// 음성MOT 설정 
            /// </summary>
            public const string MSG_1094 = "1094";
            //#13753 POS MOT음성 기능 추가 개발요청 end

            //grayber@20180213 [BR] 핸드팩 중량 출력 대상 제품 추가 요청 start
            /// <summary>
            /// 패밀리+
            /// </summary>
            public const string MSG_1095 = "1095";
            //grayber@20180213 [BR] 핸드팩 중량 출력 대상 제품 추가 요청 end

			//grayber@20180208 코레일 마일리지 입력 start - 메시지 추가 '1096'
            /// <summary>
            /// 코레일 마일리지
            /// </summary>
            public const string MSG_1096 = "1096";
            //grayber@20180208 코레일 마일리지 입력 end

            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
            /// <summary>
            /// 웰컴 기프트 
            /// </summary>
            public const string MSG_1097 = "1097";
            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

             
            //#20180327 영수증 출력 여부 버튼 명칭 변경 start
            /// <summary>
            /// 발행
            /// </summary>
            public const string MSG_1113 = "1113";
            /// <summary>
            /// 미발행
            /// </summary>
            public const string MSG_1114 = "1114";
            
            //#20180327 영수증 출력 여부 버튼 명칭 변경 end



            //#20180322 휴게소pos매출연동 start,phj
            /// <summary>
            /// 전체 재전송
            /// </summary>
            public const string MSG_1115 = "1115";

            /// <summary>
            /// 단건 재전송
            /// </summary>
            public const string MSG_1116 = "1116";

            /// <summary>
            /// 정산 재전송
            /// </summary>
            public const string MSG_1117 = "1117";
            //#20180322 휴게소pos매출연동 end,phj


            //#14618 KT 더블할인 개발요청 start,phj
            /// <summary>
            /// KT 더블할인
            /// </summary>
            public const string MSG_1118 = "1118";
            //#14618 KT 더블할인 개발요청 end,phj

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start
            /// <summary>
            /// 발송
            /// </summary>
            public const string MSG_1119 = "1119";

            /// <summary>
            /// 유형
            /// </summary>
            public const string MSG_1120 = "1120";

            /// <summary>
            /// 할인
            /// </summary>
            public const string MSG_1121 = "1121";

            /// <summary>
            /// 쿠폰 발송
            /// </summary>
            public const string MSG_1122 = "1122";

            /// <summary>
            /// 단골여부
            /// </summary>
            public const string MSG_1123 = "1123";

            /// <summary>
            /// 방문횟수
            /// </summary>
            public const string MSG_1124 = "1124";

            /// <summary>
            /// 최근1개월
            /// </summary>
            public const string MSG_1125 = "1125";

            /// <summary>
            /// 전월
            /// </summary>
            public const string MSG_1126 = "1126";

            /// <summary>
            /// 객단가
            /// </summary>
            public const string MSG_1127 = "1127";

            /// <summary>
            /// 선호제품유형
            /// </summary>
            public const string MSG_1128 = "1128";

            /// <summary>
            /// 최근 구매일
            /// </summary>
            public const string MSG_1129 = "1129";

            /// <summary>
            /// 최근 케익 구매일
            /// </summary>
            public const string MSG_1130 = "1130";

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end


            //#20180413 웰컴카드 신규기능 추가 start,phj

            /// <summary>
            /// 멤버십카드 발급
            /// </summary>
            public const string MSG_1131 = "1131";

            /// <summary>
            /// 해피포인트 조회(고객등록)
            /// </summary>
            public const string MSG_1132 = "1132";

            /// <summary>
            /// 해피APP 고객등록 
            /// </summary>
            public const string MSG_1133 = "1133";

            /// <summary>
            /// 발급
            /// </summary>
            public const string MSG_1134 = "1134";

            /// <summary>
            /// 해피APP 고객
            /// </summary>
            public const string MSG_1135 = "1135";

            /// <summary>
            /// 멤버십카드 등록
            /// </summary>
            public const string MSG_1136 = "1136";

            /// <summary>
            /// MC 카드가 등록되었습니다.
            /// </summary>
            public const string MSG_1137 = "1137";

            /// <summary>
            /// 멤버십할인
            /// </summary>
            public const string MSG_1138 = "1138";

            /// <summary>
            /// 멤버십할인 적용 하시겠습니까?
            /// </summary>
            public const string MSG_1139 = "1139";

            /// <summary>
            /// 발급 처리 되었습니다.
            /// 해피APP에 멤버십카드 등록 시 할인혜택 연장이 가능합니다.
            /// 등록 하시겠습니까? (msg)
            /// </summary>
            public const string MSG_1140 = "1140";


            /// <summary>
            /// 발급처리되지 않은 카드입니다. 발급처리 하시겠어요? --> 
            /// 발급 처리 되지 않은 카드입니다. 
            /// 발급 처리 하시겠습니까? (msg) 
            /// </summary>
            public const string MSG_1141 = "1141";

            /// <summary>
            /// 발급 처리 되었습니다.멤버십 할인 적용하시겠습니까?  --> 
            /// 발급 처리 되었습니다. 
            /// 멤버십 할인 적용하시겠습니까? (msg) 
            /// </summary>
            public const string MSG_1142 = "1142";

            /// <summary>
            /// 해피포인트있으세요? HPC고객등록해드릴까요? --> 
            /// 해피APP에 멤버십카드 등록 시 할인혜택 연장이 가능합니다.
            /// 등록 하시겠습니까? (msg)
            /// </summary>
            public const string MSG_1143 = "1143";

            /// <summary>
            /// 멤버십카드 바코드를 스캔해주세요. (msg)
            /// </summary>
            public const string MSG_1144 = "1144";

            /// <summary>
            /// 완료 되었습니다. (msg)
            /// </summary>
            public const string MSG_1145 = "1145";

            /// <summary>
            /// 통신사를 선택해주세요.
            /// </summary>
            public const string MSG_1146 = "1146";

            /// <summary>
            /// 이미 고객등록 된 해피포인트 입니다.
            /// </summary>
            public const string MSG_1147 = "1147";

            /// <summary>
            /// 같은 번호로 이미 고객등록 된 해피포인트 입니다.
            /// </summary>
            public const string MSG_1148 = "1148";

            /// <summary>
            /// 해피APP고객등록 대상자가 아닙니다.
            /// </summary>
            public const string MSG_1149 = "1149";

            /// <summary>
            /// 해피APP고객등록 성공했습니다.
            /// </summary>
            public const string MSG_1150 = "1150";

            /// <summary>
            /// 해피APP고객등록 실패했습니다.
            /// </summary>
            public const string MSG_1151 = "1151";

            /// <summary>
            /// 해피앱 고객등록 할 수 없습니다. 미발급 된 번호 입니다.
            /// </summary>
            public const string MSG_1152 = "1152";

            /// <summary>
            /// 제휴할인 데이터 인서트 오류
            /// </summary>
            public const string MSG_1153 = "1153";

            /// <summary>
            /// 해피포인트 회원이 아닙니다. 회원가입 후 진행 해주세요.
            /// </summary>
            public const string MSG_1154 = "1154";

            /// <summary>
            /// 멤버십 할인 받으실 수 없습니다.
            /// </summary>
            public const string MSG_1155 = "1155";

            //#20180413 웰컴카드 신규기능 추가 end,phj


            //#20180607 해피오더 리스트 전체 조회 기능 추가 start
            /// <summary>
            /// 전체
            /// </summary>
            public const string MSG_1156 = "1156";
            //#20180607 해피오더 리스트 전체 조회 기능 추가 end

            //#20180413 웰컴카드 신규기능 추가 start, 20180621
            /// <summary>
            /// [※ 핸드폰 번호로도 등록 가능합니다.]
            /// </summary>
            public const string MSG_1158 = "1158";

            /// <summary>
            /// 누적/가용포인트
            /// </summary>
            public const string MSG_1159 = "1159";

            /// <summary>
            /// 멤버십카드
            /// </summary>
            public const string MSG_1160 = "1160";

            //#20180413 웰컴카드 신규기능 추가 end, 20180621

            //#20180629 결제할인수단 마스터에서 통신사를 미사용 처리시 멤버십카드 발급시 통신사 선택 항목이 안나오는 증상 수정 start
            /// <summary>
            /// T 멤버십
            /// </summary>
            public const string MSG_1161 = "1161";

            /// <summary>
            /// KT 멤버십
            /// </summary>
            public const string MSG_1162 = "1162";

            /// <summary>
            /// LGU+
            /// </summary>
            public const string MSG_1163 = "1163";
            //#20180629 결제할인수단 마스터에서 통신사를 미사용 처리시 멤버십카드 발급시 통신사 선택 항목이 안나오는 증상 수정 end

            //#15897 요청)점포생산제품 바코드 출력기능 수정요청 start
            /// <summary>
            /// 점포 생산 상품 바코드 라벨 출력
            /// </summary>
            public const string MSG_1164 = "1164";
            //#15897 요청)점포생산제품 바코드 출력기능 수정요청 end

            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start

            /// <summary>
            /// 쇼킹박스 구성제품 정보
            /// </summary>
            public const string MSG_1165 = "1165";

            /// <summary>
            /// - 원산지
            /// </summary>
            public const string MSG_1166 = "1166";

            /// <summary>
            /// - 영양정보
            /// </summary>
            public const string MSG_1167 = "1167";

            /// <summary>
            /// - 알레르기성분
            /// </summary>
            public const string MSG_1168 = "1168";

            /// <summary>
            /// - 상품설명
            /// </summary>
            public const string MSG_1169 = "1169";

            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end

            //#15945 해피오더 자동주문 상세기능 start
            /// <summary>
            /// 예 (자동출하+상품준비 변경)
            /// </summary>
            public const string MSG_1170 = "1170";

            /// <summary>
            /// 아니요 (상품준비 변경)
            /// </summary>
            public const string MSG_1171 = "1171";
            //#15945 해피오더 자동주문 상세기능 end

            //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 start
            /// <summary>
            /// 제조음료 TAKE IN/OUT 설정
            /// </summary>
            public const string MSG_1172 = "1172";

            /// <summary>
            /// 제조음료 Take In/Out 팝업기능
            /// </summary>
            public const string MSG_1173 = "1173";

            /// <summary>
            /// 제조음료 Take In/Out 기본값
            /// </summary>
            public const string MSG_1174 = "1174";

            /// <summary>
            /// 제조음료 Take In/Out 설정
            /// </summary>
            public const string MSG_1175 = "1175";

            /// <summary>
            /// 고객님, 음료는 드시고 가시나요?음료는 머그컵(유리잔)에 제공해 드리는데 괜찮으세요?
            /// </summary>
            public const string MSG_1176 = "1176";

            /// <summary>
            /// 전체 Take In
            /// </summary>
            public const string MSG_1177 = "1177";

            /// <summary>
            /// 전체 Take Out
            /// </summary>
            public const string MSG_1178 = "1178";
            //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 end

            //#15884 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발 start
            /// <summary>
            /// 실시간 추가 재고 
            /// </summary>
            public const string MSG_1179 = "1179";

            /// <summary>
            /// [닫기]
            /// </summary>
            public const string MSG_1180 = "1180";
            //#15884 해피오더 실시간 추가재고 등록메뉴 및 알람기능 개발 end

            //#16401 해피오더)주문내역 바코드 리딩 시 자동 완료처리 start
            /// <summary>
            /// 해피오더 주문 자동처리 
            /// </summary>
            public const string MSG_1181 = "1181";
            //#16401 해피오더)주문내역 바코드 리딩 시 자동 완료처리 end

            //#16577 결제창 내부 봉투 추가 기능 도입 start
            /// <summary>
            /// 봉투 추가
            /// </summary>
            public const string MSG_1182 = "1182";

            /// <summary>
            /// 고객님, 종이봉투(100)원인데 구입하시겠어요?
            /// </summary>
            public const string MSG_1183 = "1183";

            /// <summary>
            /// 초기화
            /// </summary>
            public const string MSG_1184 = "1184";

            /// <summary>
            /// 적용
            /// </summary>
            public const string MSG_1185 = "1185";

            /// <summary>
            /// 소계
            /// </summary>
            public const string MSG_1186 = "1186";

            /// <summary>
            /// 합계(구매제품포함)
            /// </summary>
            public const string MSG_1187 = "1187";

            /// <summary>
            /// 오픈 금액 입력 창 상품 안내 문구
            /// </summary>
            public const string MSG_1188 = "1188";
            //#16577 결제창 내부 봉투 추가 기능 도입 end

            //#17141 [해피오더]배달영수증 주소 추가 start
            /// <summary>
            /// 고 객 명 
            /// </summary>
            public const string MSG_1189 = "1189";
            //#17141 [해피오더]배달영수증 주소 추가 end
        }

        #endregion

        #region ** 문장(에러, 확인, 질문) **
        /// <summary>
        /// 문장(에러, 확인, 질문)
        /// </summary>
        public class ERROR
        {
            /// <summary>
            /// 캐셔번호를 정확하게 입력 하여 주세요.
            /// </summary>
            public const string MSG_0001 = "0001";
            /// <summary>
            /// 캐셔 비밀번호를 정확하게 입력 하여 주세요.
            /// </summary>
            public const string MSG_0002 = "0002";
            /// <summary>
            /// 영수증 출력을 실패 하였습니다.
            /// </summary>
            public const string MSG_0003 = "0003";
            /// <summary>
            /// 거래데이터 저장을 실패 하였습니다.
            /// </summary>
            public const string MSG_0004 = "0004";
            /// <summary>
            /// 서버 와 통신을 실패 하였습니다.
            /// </summary>
            public const string MSG_0005 = "0005";
            /// <summary>
            /// 등록되지 않은 담장자 입니다
            /// </summary>
            public const string MSG_0006 = "0006";
            /// <summary>
            /// 담당자 비밀번호가 틀립니다
            /// </summary>
            public const string MSG_0007 = "0007";
            /// <summary>
            /// 저널데이터 저장을 실패 하였습니다
            /// </summary>
            public const string MSG_0008 = "0008";
            /// <summary>
            /// POS 시스템 담당자에게 연락 하여 주세요
            /// </summary>
            public const string MSG_0009 = "0009";
            /// <summary>
            /// 등록되지 않은 상품코드 입니다
            /// </summary>
            public const string MSG_0010 = "0010";
            /// <summary>
            /// 판매 불가 상품 입니다
            /// </summary>
            public const string MSG_0011 = "0011";
            /// <summary>
            /// 주문완료 후 취소를 해지 할 수 없습니다
            /// </summary>
            public const string MSG_0012 = "0012";
            /// <summary>
            /// 지정취소 할 수 없는 상품 입니다
            /// </summary>
            public const string MSG_0013 = "0013";
            /// <summary>
            /// 수량변경 할 수 없는 상품 입니다
            /// </summary>
            public const string MSG_0014 = "0014";
            /// <summary>
            /// 주문완료 후 수량변경을 할 수 없습니다
            /// </summary>
            public const string MSG_0015 = "0015";
            /// <summary>
            /// 변경 할 수 없는 상품 수량 입니다
            /// </summary>
            public const string MSG_0016 = "0016";
            /// <summary>
            /// 해당 상품은 취소한 상품 입니다
            /// </summary>
            public const string MSG_0017 = "0017";
            /// <summary>
            /// 부가메뉴 그룹 데이터가 없습니다
            /// </summary>
            public const string MSG_0018 = "0018";
            /// <summary>
            /// 부가메뉴 그룹 상세 데이터가 없습니다
            /// </summary>
            public const string MSG_0019 = "0019";
            /// <summary>
            /// 판매 대기 중 처리 할 수 없는 기능 입니다
            /// </summary>
            public const string MSG_0020 = "0020";
            /// <summary>
            /// 상품 등록 중 처리 할 수 없는 기능 입니다
            /// </summary>
            public const string MSG_0021 = "0021";
            /// <summary>
            /// 부가메뉴 등록 중 처리 할 수 없는 기능 입니다
            /// </summary>
            public const string MSG_0022 = "0022";
            /// <summary>
            /// 세트상품 등록 중 처리 할 수 없는 기능 입니다
            /// </summary>
            public const string MSG_0023 = "0023";
            /// <summary>
            /// 부가메뉴 등록 중 입니다. 부가메뉴만 취소 할 수 있습니다.
            /// </summary>
            public const string MSG_0024 = "0024";
            /// <summary>
            /// 부가메뉴 등록 중 입니다. 부가메뉴만 변경 할 수 있습니다.
            /// </summary>
            public const string MSG_0025 = "0025";
            /// <summary>
            /// 부가메뉴를 등록 할 수 없는 상품 입니다
            /// </summary>
            public const string MSG_0026 = "0026";
            /// <summary>
            /// 주문완료 후 변경 할 수 없습니다
            /// </summary>
            public const string MSG_0027 = "0027";
            /// <summary>
            /// 세트상품 마스터 정보가 없습니다
            /// </summary>
            public const string MSG_0028 = "0028";
            /// <summary>
            /// 플레이버 마스터 정보가 없습니다
            /// </summary>
            public const string MSG_0029 = "0029";
            /// <summary>
            /// 플레이버를 등록 할 수 없는 상품 입니다
            /// </summary>
            public const string MSG_0030 = "0030";
            /// <summary>
            /// 플레이버 등록 중 입니다. 플레이버만 취소 할 수 있습니다.
            /// </summary>
            public const string MSG_0031 = "0031";
            /// <summary>
            /// 플레이버 등록 중 입니다. 플레이버만 변경 할 수 있습니다.
            /// </summary>
            public const string MSG_0032 = "0032";
            /// <summary>
            /// 플레이버 등록 중 처리 할 수 없는 기능 입니다
            /// </summary>
            public const string MSG_0033 = "0033";
            /// <summary>
            /// 받을금액이 존재 하지 않습니다
            /// </summary>
            public const string MSG_0034 = "0034";
            /// <summary>
            /// 입력한 금액이 너무 큰 금액 입니다
            /// </summary>
            public const string MSG_0035 = "0035";
            /// <summary>
            /// 입력한 금액은 입력 불가 단위 입니다
            /// </summary>
            public const string MSG_0036 = "0036";
            /// <summary>
            /// 카드 번호를 정확하게 입력 하세요.
            /// </summary>
            public const string MSG_0037 = "0037";
            /// <summary>
            /// 승인금액을 입력하세요.
            /// </summary>
            public const string MSG_0038 = "0038";
            /// <summary>
            /// 받을 금액을 초과 할 수 없습니다.
            /// </summary>
            public const string MSG_0039 = "0039";
            /// <summary>
            /// 승인번호를 정확히 입력하세요.
            /// </summary>
            public const string MSG_0040 = "0040";
            /// <summary>
            /// 원거래 일자를 확인하세요.
            /// </summary>
            public const string MSG_0041 = "0041";
            /// <summary>
            /// 사은품 판매가 불가 합니다. 취소 하세요\n사은품명 : {0}\n등록수량 : {1}  지급수량 : {2}\n취소 해야 할 수량 : {3}
            /// </summary>
            public const string MSG_0042 = "0042";
            /// <summary>
            /// 조회후 승인 처리 하세요.
            /// </summary>
            public const string MSG_0043 = "0043";
            /// <summary>
            /// 수표를 정상 조회 하지 않았습니다. 강제로 결제 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0044 = "0044";
            /// <summary>
            /// 수표 금액을 입력하세요.
            /// </summary>
            public const string MSG_0045 = "0045";
            /// <summary>
            /// 수표 번호를 확인 하세요.
            /// </summary>
            public const string MSG_0046 = "0046";
            /// <summary>
            /// 수표 발행일자를 확인 하세요.
            /// </summary>
            public const string MSG_0047 = "0047";
            /// <summary>
            /// 서버 와 통신을 실패 하였습니다.
            /// </summary>
            public const string MSG_0048 = "0048";
            /// <summary>
            /// 할인 금액을 입력하지 않았거나 너무 큽니다.
            /// </summary>
            public const string MSG_0049 = "0049";
            /// <summary>
            /// 할인 적용 불가능한 상품 입니다.
            /// </summary>
            public const string MSG_0050 = "0050";
            /// <summary>
            /// 할인 율을 입력하지 않았거나 너무 큽니다.
            /// </summary>
            public const string MSG_0051 = "0051";
            /// <summary>
            /// 할인 구분 이상! POS 시스템 담당자에게 연락하여 주세요.
            /// </summary>
            public const string MSG_0052 = "0052";
            /// <summary>
            /// 등록된 할인을 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0053 = "0053";
            /// <summary>
            /// 현재 거래 유형에서 사용할 수 없는 기능입니다.
            /// </summary>
            public const string MSG_0054 = "0054";
            /// <summary>
            /// 사은품 판매가 불가 합니다. 취소 하세요\n사은품명 : {0}
            /// </summary>
            public const string MSG_0055 = "0055";
            /// <summary>
            /// 상품키 구성 마스터가 없습니다
            /// </summary>
            public const string MSG_0056 = "0056";
            /// <summary>
            /// 메뉴키 대분류 마스터가 없습니다
            /// </summary>
            public const string MSG_0057 = "0057";
            /// <summary>
            /// 메뉴키 중분류 마스터가 없습니다
            /// </summary>
            public const string MSG_0058 = "0058";
            /// <summary>
            /// 메뉴키 마스터가 없습니다
            /// </summary>
            public const string MSG_0059 = "0059";
            /// <summary>
            /// 해당 카드 승인 취소가 실패했습니다. 카드사에 승인 내역을 확인 하세요.
            /// </summary>
            public const string MSG_0060 = "0060";
            /// <summary>
            /// 해당 카드 승인 내역이 취소 처리 되었습니다.
            /// </summary>
            public const string MSG_0061 = "0061";
            /// <summary>
            /// 승인받은 카드번호와 다릅니다. 카드를 확인하세요.
            /// </summary>
            public const string MSG_0062 = "0062";
            /// <summary>
            /// 이미 다른 할인이 등록된 상품입니다. 기존 할인을 취소후 등록 하세요
            /// </summary>
            public const string MSG_0063 = "0063";
            /// <summary>
            /// 등록된 서비스를 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0064 = "0064";
            /// <summary>
            /// 번호를입력하세요
            /// </summary>
            public const string MSG_0065 = "0065";
            /// <summary>
            /// 해피포인트 적립에 실패하였습니다
            /// </summary>
            public const string MSG_0066 = "0066";
            /// <summary>
            /// 할인 되었습니다
            /// </summary>
            public const string MSG_0067 = "0067";
            /// <summary>
            /// 할인 취소 되었습니다
            /// </summary>
            public const string MSG_0068 = "0068";
            /// <summary>
            /// 적립 취소 되었습니다
            /// </summary>
            public const string MSG_0069 = "0069";
            /// <summary>
            /// 적립 할 수 없는 카드 입니다
            /// </summary>
            public const string MSG_0070 = "0070";
            /// <summary>
            /// 사용 포인트를 정확하게 입력 하세요
            /// </summary>
            public const string MSG_0071 = "0071";
            /// <summary>
            /// 사용 포인트가 가용 포인트 보다 클수 없습니다
            /// </summary>
            public const string MSG_0072 = "0072";
            /// <summary>
            /// 사용 포인트가 받을금액 보다 클수 없습니다
            /// </summary>
            public const string MSG_0073 = "0073";
            /// <summary>
            /// 비밀번호를 입력 하여 주세요
            /// </summary>
            public const string MSG_0074 = "0074";
            /// <summary>
            /// 수량을 입력하지 않았거나 너무 큽니다.
            /// </summary>
            public const string MSG_0075 = "0075";
            /// <summary>
            /// 상품권 상품은 상품권 판매거래만 등록 가능합니다.
            /// </summary>
            public const string MSG_0076 = "0076";
            /// <summary>
            /// 선불카드 상품은 선불카드 판매거래만 등록 가능합니다.
            /// </summary>
            public const string MSG_0077 = "0077";
            /// <summary>
            /// 층 정보를 조회하는데 실패 하였습니다.
            /// </summary>
            public const string MSG_0078 = "0078";
            /// <summary>
            /// 층 정보가 없습니다.
            /// </summary>
            public const string MSG_0079 = "0079";
            /// <summary>
            /// 쿠폰번호를 정확하게 입력 하세요
            /// </summary>
            public const string MSG_0080 = "0080";
            /// <summary>
            /// 테이블 정보를 조회하는데 실패 하였습니다.
            /// </summary>
            public const string MSG_0081 = "0081";
            /// <summary>
            /// 테이블 정보가 없습니다.
            /// </summary>
            public const string MSG_0082 = "0082";
            /// <summary>
            /// 테이블을 사용중 입니다.
            /// </summary>
            public const string MSG_0083 = "0083";
            /// <summary>
            /// 테이블 결제완료 해제 하시겠습니까?
            /// </summary>
            public const string MSG_0084 = "0084";
            /// <summary>
            /// 테이블 결제완료 실패 하였습니다.
            /// </summary>
            public const string MSG_0085 = "0085";
            /// <summary>
            /// 테이블 상태를 갱신하는데 실패 하였습니다.
            /// </summary>
            public const string MSG_0086 = "0086";
            /// <summary>
            /// 주문 정보를 조회하는데 실패 하였습니다.
            /// </summary>
            public const string MSG_0087 = "0087";
            /// <summary>
            /// 주문데이터 저장 없이 종료 하시겠습니까?
            /// </summary>
            public const string MSG_0088 = "0088";
            /// <summary>
            /// 매장 공지사항 등록이 실패 하였습니다.
            /// </summary>
            public const string MSG_0089 = "0089";
            /// <summary>
            /// 테이블붙임 대상 테이블과 같은 테이블을 선택하셨습니다. 테이블붙임 할 수 없습니다.
            /// </summary>
            public const string MSG_0090 = "0090";
            /// <summary>
            /// 테이블을 사용중 입니다. 테이블붙임 할 수 없습니다.
            /// </summary>
            public const string MSG_0091 = "0091";
            /// <summary>
            /// 이미 테이블붙임 되어 있습니다.
            /// </summary>
            public const string MSG_0092 = "0092";
            /// <summary>
            /// 테이블붙임 하시겠습니까?
            /// </summary>
            public const string MSG_0093 = "0093";
            /// <summary>
            /// 테이블붙임 실패 하였습니다.
            /// </summary>
            public const string MSG_0094 = "0094";
            /// <summary>
            /// 카드 읽기 실패 카드를 다시 읽혀 주세요.
            /// </summary>
            public const string MSG_0095 = "0095";
            /// <summary>
            /// 비밀번호를 입력 받지 못했습니다. 은련카드를 승인 할 수 없습니다.
            /// </summary>
            public const string MSG_0096 = "0096";
            /// <summary>
            /// 테이블붙임 되어 있지 않습니다. 테이블붙임 해제 할 수 없습니다.
            /// </summary>
            public const string MSG_0097 = "0097";
            /// <summary>
            /// 테이블붙임 해제 하시겠습니까?
            /// </summary>
            public const string MSG_0098 = "0098";
            /// <summary>
            /// 테이블붙임 해제 실패 하였습니다.
            /// </summary>
            public const string MSG_0099 = "0099";
            /// <summary>
            /// 같은 테이블을 선택하셨습니다. 테이블합석 할 수 없습니다.
            /// </summary>
            public const string MSG_0100 = "0100";
            /// <summary>
            /// 미주문 테이블은 합석 할 수 없습니다.
            /// </summary>
            public const string MSG_0101 = "0101";
            /// <summary>
            /// 테이블을 사용중 입니다. 합석 할 수 없습니다.
            /// </summary>
            public const string MSG_0102 = "0102";
            /// <summary>
            /// 테이블붙임 되어 있습니다. 합석 할 수 없습니다.
            /// </summary>
            public const string MSG_0103 = "0103";
            /// <summary>
            /// 테이블 합석 실패 하였습니다.
            /// </summary>
            public const string MSG_0104 = "0104";
            /// <summary>
            /// 테이블 합석 하시겠습니까?
            /// </summary>
            public const string MSG_0105 = "0105";
            /// <summary>
            /// 미주문 테이블은 이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0106 = "0106";
            /// <summary>
            /// 테이블을 사용중 입니다. 이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0107 = "0107";
            /// <summary>
            /// 테이블붙임 되어 있습니다. 이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0108 = "0108";
            /// <summary>
            /// 같은 테이블을 선택하셨습니다. 테이블이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0109 = "0109";
            /// <summary>
            /// 테이블 이동 실패 하였습니다.
            /// </summary>
            public const string MSG_0110 = "0110";
            /// <summary>
            /// 테이블 이동 하시겠습니까?
            /// </summary>
            public const string MSG_0111 = "0111";
            /// <summary>
            /// 결제 진행 중 처리 할 수 없는 기능 입니다
            /// </summary>
            public const string MSG_0112 = "0112";
            /// <summary>
            /// 기존 할인을 취소후 시도하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0113 = "0113";
            /// <summary>
            /// 해피포인트 적립을 하시겠습니까?
            /// </summary>
            public const string MSG_0114 = "0114";
            /// <summary>
            /// 해피포인트 적립을 재시도 하시겠습니까?
            /// </summary>
            public const string MSG_0115 = "0115";
            /// <summary>
            /// 미주문 테이블은 메뉴이동 의 첫번째 테이블로 선택 할 수 없습니다.
            /// </summary>
            public const string MSG_0116 = "0116";
            /// <summary>
            /// 테이블을 사용중 입니다. 메뉴이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0117 = "0117";
            /// <summary>
            /// 테이블붙임 되어 있습니다. 메뉴이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0118 = "0118";
            /// <summary>
            /// 같은 테이블을 선택하셨습니다. 메뉴이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0119 = "0119";
            /// <summary>
            /// 세트자식 상품은 메뉴이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0120 = "0120";
            /// <summary>
            /// 세트할인 상품은 메뉴이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0121 = "0121";
            /// <summary>
            /// 부가상품은 메뉴이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0122 = "0122";
            /// <summary>
            /// 선택된 할인 대상 상품이 없습니다.
            /// </summary>
            public const string MSG_0123 = "0123";
            /// <summary>
            /// 할인 적용을 하시겠습니까?
            /// </summary>
            public const string MSG_0124 = "0124";
            /// <summary>
            /// 삼성패밀리 카드 회원이 아닙니다.
            /// </summary>
            public const string MSG_0125 = "0125";
            /// <summary>
            /// 승인 버튼 클릭후 카드 승인 받으세요.
            /// </summary>
            public const string MSG_0126 = "0126";
            /// <summary>
            /// 복권 발행 조회를 실패 하였습니다
            /// </summary>
            public const string MSG_0127 = "0127";
            /// <summary>
            /// 미주문 테이블에는 좌석메모를 남길 수 없습니다.
            /// </summary>
            public const string MSG_0128 = "0128";
            /// <summary>
            /// 메시지를 정확하게 입력하여 주세요.
            /// </summary>
            public const string MSG_0129 = "0129";
            /// <summary>
            /// 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0130 = "0130";
            /// <summary>
            /// 승인 금액이 할인 금액 보다 같거나 작을 수 없습니다.
            /// </summary>
            public const string MSG_0131 = "0131";
            /// <summary>
            /// 알 수 없는 오류가 발생했습니다.
            /// </summary>
            public const string MSG_0132 = "0132";
            /// <summary>
            /// 예약 등록에 실패 하였습니다.
            /// </summary>
            public const string MSG_0133 = "0133";
            /// <summary>
            /// 할인 대상 상품이 없습니다
            /// </summary>
            public const string MSG_0134 = "0134";
            /// <summary>
            /// 대상금액이 가용포인트보다 많습니다.
            /// </summary>
            public const string MSG_0135 = "0135";
            /// <summary>
            /// 입력된 금액이 없습니다.
            /// </summary>
            public const string MSG_0136 = "0136";
            /// <summary>
            /// 적립 대상 상품이 없습니다
            /// </summary>
            public const string MSG_0137 = "0137";
            /// <summary>
            /// 쿠폰금액이 받을금액 보다 클수 없습니다.
            /// </summary>
            public const string MSG_0138 = "0138";
            /// <summary>
            /// 포인트 사용이 불가 합니다
            /// </summary>
            public const string MSG_0139 = "0139";
            /// <summary>
            /// 해당 VAN 정보가 존재 하지 않습니다.
            /// </summary>
            public const string MSG_0140 = "0140";
            /// <summary>
            /// 캠페인 적용되어 포인트 사용금액 변경 할수 없습니다. 캠페인 할인금액 : 
            /// </summary>
            public const string MSG_0141 = "0141";
            /// <summary>
            /// 테이블을 선택해 주세요.
            /// </summary>
            public const string MSG_0142 = "0142";
            /// <summary>
            /// - 사용된 지점 : 
            /// </summary>
            public const string MSG_0143 = "0143";
            /// <summary>
            /// - 쿠폰 일시 : 
            /// </summary>
            public const string MSG_0145 = "0145";
            /// <summary>
            /// 이미 사용된 쿠폰 입니다.
            /// </summary>
            public const string MSG_0147 = "0147";
            /// <summary>
            /// 쿠폰 결제가 가능한 상품이 없습니다.
            /// </summary>
            public const string MSG_0149 = "0149";
            /// <summary>
            /// 쿠폰금액이 결제 가능 상품의 금액보다 클수 없습니다.
            /// </summary>
            public const string MSG_0150 = "0150";
            /// <summary>
            /// 제휴사 VIP고객 등급의 할인 상품 정보가 없습니다
            /// </summary>
            public const string MSG_0151 = "0151";
            /// <summary>
            /// 제휴사 VIP고객 해당 제품은 수량 1개만 적용 가능합니다
            /// </summary>
            public const string MSG_0152 = "0152";
            /// <summary>
            /// 제휴사 VIP고객 행사 외의 상품은 별도 결제 바랍니다
            /// </summary>
            public const string MSG_0153 = "0153";
            /// <summary>
            /// 제휴사 VIP고객 행사 상품이 등록되지 않았습니다
            /// </summary>
            public const string MSG_0154 = "0154";
            /// <summary>
            /// 세트메뉴는 등록 할 수 없습니다.
            /// </summary>
            public const string MSG_0155 = "0155";
            /// <summary>
            /// 부가메뉴는 등록 할 수 없습니다.
            /// </summary>
            public const string MSG_0156 = "0156";
            /// <summary>
            /// 메모 등록이 실패 하였습니다.
            /// </summary>
            public const string MSG_0157 = "0157";
            /// <summary>
            /// 통신을 실패 하였습니다. 잠시 후 다시 시도 하세요
            /// </summary>
            public const string MSG_0158 = "0158";
            /// <summary>
            /// NO TAX 적용  불가 상품 입니다.
            /// </summary>
            public const string MSG_0159 = "0159";
            /// <summary>
            /// 쿠폰 대상 상품만 구매가 가능합니다.
            /// </summary>
            public const string MSG_0160 = "0160";
            /// <summary>
            /// 진행중인 시험이 없습니다
            /// </summary>
            public const string MSG_0161 = "0161";
            /// <summary>
            /// 시험통과 결과를 전송하지 않았습니다. 그래도 종료 하시겠습니까?
            /// </summary>
            public const string MSG_0162 = "0162";
            /// <summary>
            /// 시험 상세 정보가 없습니다
            /// </summary>
            public const string MSG_0163 = "0163";
            /// <summary>
            /// 오류횟수 초과로 시험을 통과하지 못하였습니다
            /// </summary>
            public const string MSG_0164 = "0164";
            /// <summary>
            /// 시험을 통과 하였습니다
            /// </summary>
            public const string MSG_0165 = "0165";
            /// <summary>
            /// 시험 상세 이미지가 없습니다
            /// </summary>
            public const string MSG_0166 = "0166";
            /// <summary>
            /// 시험 상세 위치 정보가 없습니다
            /// </summary>
            public const string MSG_0167 = "0167";
            /// <summary>
            /// 다음화면 진행시 시험을 통과 할수 없습니다. 그래도 진행 하시겠습니까?
            /// </summary>
            public const string MSG_0168 = "0168";
            /// <summary>
            /// 입력박스 테이터를 확인 하세요
            /// </summary>
            public const string MSG_0169 = "0169";
            /// <summary>
            /// 입력장치 유형을 확인 하세요
            /// </summary>
            public const string MSG_0170 = "0170";
            /// <summary>
            /// 입력장치 테이터를 확인 하세요
            /// </summary>
            public const string MSG_0171 = "0171";
            /// <summary>
            /// 터치 선택 위치를 확인 하세요
            /// </summary>
            public const string MSG_0172 = "0172";
            /// <summary>
            /// 시험결과 저장을 실패 하였습니다
            /// </summary>
            public const string MSG_0173 = "0173";
            /// <summary>
            /// 시험결과 서버 요청을 실패 하였습니다
            /// </summary>
            public const string MSG_0174 = "0174";
            /// <summary>
            /// 0 원 상품은 추가할 수 없습니다.
            /// </summary>
            public const string MSG_0175 = "0175";
            /// <summary>
            /// 시험결과를 전송 하였습니다.
            /// </summary>
            public const string MSG_0176 = "0176";
            /// <summary>
            /// 식권 선택후 사용하여 주십시요.
            /// </summary>
            public const string MSG_0177 = "0177";
            /// <summary>
            /// 준비금이 등록 되었습니다.
            /// </summary>
            public const string MSG_0178 = "0178";
            /// <summary>
            /// 간이영수증이 출력되었습니다.
            /// </summary>
            public const string MSG_0179 = "0179";
            /// <summary>
            /// 고객 불만사항이 접수 되었습니다.
            /// </summary>
            public const string MSG_0180 = "0180";
            /// <summary>
            /// 저장 후 출력하세요.
            /// </summary>
            public const string MSG_0181 = "0181";
            /// <summary>
            /// 출력되었습니다.
            /// </summary>
            public const string MSG_0182 = "0182";
            /// <summary>
            /// 관공서에서 점포를 방문했다는 기록이 본사로 전달됩니다. 전송하시겠습니까?
            /// </summary>
            public const string MSG_0183 = "0183";
            /// <summary>
            /// 전일자 마감처리 되지 않았습니다.전일 마감 후 개점처리 하십시요.
            /// </summary>
            public const string MSG_0184 = "0184";
            /// <summary>
            /// 영업 마감 처리가 되었습니다. 처리 할 수 없습니다
            /// </summary>
            public const string MSG_0185 = "0185";
            /// <summary>
            /// 영업일자를 확인하여 주십시오.
            /// </summary>
            public const string MSG_0186 = "0186";
            /// <summary>
            /// 잔액교환권 발행 요청이 실패 하였습니다.
            /// </summary>
            public const string MSG_0187 = "0187";
            /// <summary>
            /// 영업개시 통신에 실패하였습니다. 수동개설 하시겠습니까?
            /// </summary>
            public const string MSG_0188 = "0188";
            /// <summary>
            /// 상품권번호를 확인 하세요.
            /// </summary>
            public const string MSG_0189 = "0189";
            /// <summary>
            /// 개점처리를 취소하였습니다.
            /// </summary>
            public const string MSG_0190 = "0190";
            /// <summary>
            /// 상품권 선택후 사용하여 주십시요.
            /// </summary>
            public const string MSG_0191 = "0191";
            /// <summary>
            /// 캠페인 할인이 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0192 = "0192";
            /// <summary>
            /// 통신사 할인이 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0193 = "0193";
            /// <summary>
            /// 포인트 할인이 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0194 = "0194";
            /// <summary>
            /// 쿠폰 할인이 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0195 = "0195";
            /// <summary>
            /// 직원 할인이 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0196 = "0196";
            /// <summary>
            /// 일반 할인이 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0197 = "0197";
            /// <summary>
            /// 이미 결제가 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0198 = "0198";
            /// <summary>
            /// 모바일 결제가 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0199 = "0199";
            /// <summary>
            /// 포인트 결제가 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0200 = "0200";
            /// <summary>
            /// 해피포인트가 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0201 = "0201";
            /// <summary>
            /// 개점 정보 초기화에 실패하였습니다. 전산팀에 연락 주십시오.
            /// </summary>
            public const string MSG_0202 = "0202";
            /// <summary>
            /// 이미 개점 처리 되었습니다.
            /// </summary>
            public const string MSG_0203 = "0203";
            /// <summary>
            /// 개점 처리 완료 되었습니다.
            /// </summary>
            public const string MSG_0204 = "0204";
            /// <summary>
            /// 개점 처리에 실패하였습니다. 전산팀에 연락 주십시오.
            /// </summary>
            public const string MSG_0205 = "0205";
            /// <summary>
            /// 개점 처리를 취소하였습니다.
            /// </summary>
            public const string MSG_0206 = "0206";
            /// <summary>
            /// 상품권 승인 요청이 실패 하였습니다.
            /// </summary>
            public const string MSG_0207 = "0207";
            /// <summary>
            /// 더 이상 추가 하실 수 없습니다.
            /// </summary>
            public const string MSG_0208 = "0208";
            /// <summary>
            /// 잔액교환권 발행 가능한 금액이 없습니다.
            /// </summary>
            public const string MSG_0209 = "0209";
            /// <summary>
            /// 이미 등록된 상품권 입니다.
            /// </summary>
            public const string MSG_0210 = "0210";
            /// <summary>
            /// 잔액교환권 번호를 확인 하세요..
            /// </summary>
            public const string MSG_0211 = "0211";
            /// <summary>
            /// 고객을 선택하여 주십시요.
            /// </summary>
            public const string MSG_0213 = "0213";
            /// <summary>
            /// 고객 조회 요청이 실패 하였습니다.
            /// </summary>
            public const string MSG_0214 = "0214";
            /// <summary>
            /// {0} 원 예약잔금으로 처리 하시겠습니까?
            /// </summary>
            public const string MSG_0212 = "0212";
            /// <summary>
            /// 전송에 실패하였습니다. 다시 시도하시겠습니까?
            /// </summary>
            public const string MSG_0215 = "0215";
            /// <summary>
            /// 외상 사용 요청에 실패 하였습니다.
            /// </summary>
            public const string MSG_0216 = "0216";
            /// <summary>
            /// 등록된 환율 정보가 없습니다.
            /// </summary>
            public const string MSG_0217 = "0217";
            /// <summary>
            /// 제한시간 초과로 시험을 통과하지 못하였습니다
            /// </summary>
            public const string MSG_0218 = "0218";
            /// <summary>
            /// 상품권 당일반품이 아닌경우 현금대체로 처리하여 주시기 바립니다.
            /// </summary>
            public const string MSG_0219 = "0219";
            /// <summary>
            /// 영업일자와 다릅니다. 등록하시겠습니까?
            /// </summary>
            public const string MSG_0220 = "0220";
            /// <summary>
            /// 통신에 실패하였습니다. 다시 시도 하시겠습니까?
            /// </summary>
            public const string MSG_0221 = "0221";
            /// <summary>
            /// 송신완료하였습니다.
            /// </summary>
            public const string MSG_0222 = "0222";
            /// <summary>
            /// 선불카드 사용 요청에 실패 하였습니다.
            /// </summary>
            public const string MSG_0223 = "0223";
            /// <summary>
            /// 고객명을 입력하세요.
            /// </summary>
            public const string MSG_0224 = "0224";
            /// <summary>
            /// 고객 연락처를 입력하세요.
            /// </summary>
            public const string MSG_0225 = "0225";
            /// <summary>
            /// 예약 시간을 정확하게 입력하세요.
            /// </summary>
            public const string MSG_0226 = "0226";
            /// <summary>
            /// 고객 주소/메모를 입력하세요.
            /// </summary>
            public const string MSG_0227 = "0227";
            /// <summary>
            /// 이미 등록된 고객명 입니다.
            /// </summary>
            public const string MSG_0228 = "0228";
            /// <summary>
            /// 이미 반품된 거래 입니다.
            /// </summary>
            public const string MSG_0229 = "0229";
            /// <summary>
            /// 반품 거래는 처리 할 수 없습니다.
            /// </summary>
            public const string MSG_0230 = "0230";
            /// <summary>
            /// {0} 조회 중 입니다. 기다리세요.
            /// </summary>
            public const string MSG_0231 = "0231";
            /// <summary>
            /// 적용 수량을 입력하세요
            /// </summary>
            public const string MSG_0232 = "0232";
            /// <summary>
            /// 적용 금액을 입력하세요
            /// </summary>
            public const string MSG_0233 = "0233";
            /// <summary>
            /// 적용 율을 입력하세요
            /// </summary>
            public const string MSG_0234 = "0234";
            /// <summary>
            /// 주문번호를 입력하세요
            /// </summary>
            public const string MSG_0235 = "0235";
            /// <summary>
            /// 컵 수를 입력해 주시기 바랍니다
            /// </summary>
            public const string MSG_0236 = "0236";
            /// <summary>
            /// 할인 적용할 컵 수를 입력하세요.
            /// </summary>
            public const string MSG_0237 = "0237";
            /// <summary>
            /// 대기번호를 입력하지 않으면, 주방프린터로 출력되지 않습니다.
            /// </summary>
            public const string MSG_0238 = "0238";
            /// <summary>
            /// 고객님 결제 하실 금액은 {0}원 입니다.
            /// </summary>
            public const string MSG_0239 = "0239";
            /// <summary>
            /// 임의 등록 건 입니다. 단말기 또는 전화 승인 취소하세요.
            /// </summary>
            public const string MSG_0240 = "0240";
            /// <summary>
            /// 세브란브병원 임직원 할인 - 안내문구
            /// [주  의]
            ///정보통신망법 개정에 의해 주민등록번호 입력 불가.
            ///
            ///임직원 조회시 스캐너로 임직원카드 바코드를 
            ///Reading 하시기 바랍니다.
            /// </summary>
            public const string MSG_0241 = "0241";
            /// <summary>
            /// 삼성SFC가이드메세지
            /// </summary>
            public const string MSG_0242 = "0242";
            /// <summary>
            /// 최소 {0} 원 이상만 사용 가능 합니다.
            /// </summary>
            public const string MSG_0243 = "0243";
            /// <summary>
            /// ※ 한 종류의 외화만 결제가 가능합니다.
            /// </summary>
            public const string MSG_0244 = "0244";
            /// <summary>
            /// 안녕하세요. 고객님 {0} 입니다
            /// </summary>
            public const string MSG_0245 = "0245";
            /// <summary>
            /// 결제금액이 카드잔액 보다 클 수 없습니다.
            /// </summary>
            public const string MSG_0246 = "0246";
            /// <summary>
            /// 전화취소 하시겠습니까?
            /// </summary>
            public const string MSG_0247 = "0247";
            /// <summary>
            /// 거래 데이터가 존재 하지 않습니다
            /// </summary>
            public const string MSG_0248 = "0248";
            /// <summary>
            /// 반품 영수증 입니다
            /// </summary>
            public const string MSG_0249 = "0249";
            /// <summary>
            /// 원 영수증 정보 :
            /// </summary>
            public const string MSG_0250 = "0250";
            /// <summary>
            /// 반품된 영수증 입니다
            /// </summary>
            public const string MSG_0251 = "0251";
            /// <summary>
            /// 반품 영수증 정보 :
            /// </summary>
            public const string MSG_0252 = "0252";
            /// <summary>
            /// 반품 하시겠습니까?
            /// </summary>
            public const string MSG_0253 = "0253";
            /// <summary>
            /// 내역 불러오기를 하시겠습니까?
            /// </summary>
            public const string MSG_0254 = "0254";
            /// <summary>
            /// 영수증 번호를 입력 하세요
            /// </summary>
            public const string MSG_0255 = "0255";
            /// <summary>
            /// 기존 묶음적용을 취소 후 등록 하세요
            /// </summary>
            public const string MSG_0256 = "0256";
             /// <summary>
            /// 가용포인트를 초과 할 수 없습니다.
            /// </summary>
            public const string MSG_0257 = "0257";
            /// <summary>
            /// 검색코드를 입력하여 주십시요. (고객번호, 고객명, 전화번호)
            /// </summary>
            public const string MSG_0258 = "0258";
            /// <summary>
            /// 서버 영수증 조회를 실패 하였습니다
            /// </summary>
            public const string MSG_0259 = "0259";
            /// <summary>
            /// 직원식 결제금액이 부족합니다.
            /// </summary>
            public const string MSG_0260 = "0260";           
            /// <summary>
            /// 거래를 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0261 = "0261";
            /// <summary>
            /// 판매 거래가 아닙니다
            /// </summary>
            public const string MSG_0262 = "0262";
            /// <summary>
            /// 신용카드 번호는 수입력 불가 합니다
            /// </summary>
            public const string MSG_0263 = "0263";
            /// <summary>
            /// 반품 승인된 결제 수단이 있어 종료 할 수 없습니다
            /// </summary>
            public const string MSG_0264 = "0264";            
            /// <summary>
            /// 직원식 상품이 존재합니다.\n 세브란스 결제로 진행하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0265 = "0265";
            /// <summary>
            /// 주변장치 체크를 실패하였습니다.
            /// </summary>
            public const string MSG_0266 = "0266";
            /// <summary>
            /// 이미 추후 적립된 거래 입니다
            /// </summary>
            public const string MSG_0267 = "0267";
            /// <summary>
            /// 추후 적립 가능한 거래가 아닙니다
            /// </summary>
            public const string MSG_0268 = "0268";
            /// <summary>
            /// 거래내역이 존재하지 않습니다.
            /// </summary>
            public const string MSG_0269 = "0269";
            /// <summary>
            /// 추후 적립 하시겠습니까?
            /// </summary>
            public const string MSG_0270 = "0270";
            /// <summary>
            /// 거래를 선택하여 주십시요.
            /// </summary>
            public const string MSG_0271 = "0271";
            /// <summary>
            /// 잔액 조회후 처리 하세요.
            /// </summary>
            public const string MSG_0272 = "0272";
            /// <summary>
            /// 거래 조회후 처리 하세요.
            /// </summary>
            public const string MSG_0273 = "0273";
            /// <summary>
            /// 캠페인 선착순 제한 수량을 초과 하여 캠페인 적용 되지 않습니다
            /// </summary>
            public const string MSG_0274 = "0274";
            /// <summary>
            /// 해피 포인트가 조회되어 있어 판매등록으로 갈 수 없습니다. 등록된 해피포인트를 취소하세요.
            /// </summary>
            public const string MSG_0275 = "0275";
            /// <summary>
            /// 결제가 등록되어 있어 판매등록으로 갈 수 없습니다. 등록된 결제를 취소 하세요.
            /// </summary>
            public const string MSG_0276 = "0276";
            /// <summary>
            /// 수신중입니다. 강제 종료 하시겠습니까?
            /// </summary>
            public const string MSG_0277 = "0277";
            /// <summary>
            /// 고객님 저희 매장을 단골매장으로 등록하시면 다양한 쿠폰 보내드립니다
            /// </summary>
            public const string MSG_0278 = "0278";
            /// <summary>
            /// 단골매장등록을 완료 하였습니다
            /// </summary>
            public const string MSG_0279 = "0279";
            /// <summary>
            /// 암호화 처리를 실패 하였습니다. 장치를 확인 하세요
            /// </summary>
            public const string MSG_0280 = "0280";
            /// <summary>
            /// POS 프로그램이 업데이트 되었습니다. \n POS 프로그램을 재기동 합니다.
            /// </summary>
            public const string MSG_0281 = "0281";
            /// <summary>
            /// 다운로드 중 오류가 발생 되었습니다.
            /// </summary>
            public const string MSG_0282 = "0282";
            /// <summary>
            /// 입력하신 주문번호가 존재하지 않습니다.
            /// </summary>
            public const string MSG_0283 = "0283";
            /// <summary>
            /// 더치페이 진행중에는 등록화면으로 돌아갈수 없습니다. 
            /// </summary>
            public const string MSG_0284 = "0284";
            /// <summary>
            /// 결제 하실 금액은 남은 금액 {0}원을 초과 할 수 없습니다.
            /// </summary>
            public const string MSG_0285 = "0285";
            /// <summary>
            /// 금액 더치페이 경우 사용 할 수 없습니다.
            /// </summary>
            public const string MSG_0286 = "0286";
            /// <summary>
            /// {0} 전부 결제 하시 겠습니까?
            /// </summary>
            public const string MSG_0287 = "0287";
            /// <summary>
            /// 이미 최신버전이 적용되어 있습니다.
            /// </summary>
            public const string MSG_0288 = "0288";
            /// <summary>
            /// 수신 데이터가 존재하지 않습니다.
            /// </summary>
            public const string MSG_0289 = "0289";
            /// <summary>
            /// 매출 수신을 완료 하였습니다.
            /// </summary>
            public const string MSG_0290 = "0290";
            /// <summary>
            /// 결제 금액을 확인 하세요. 현재 등록 하신 금액은 {0}원 입니다.
            /// </summary>
            public const string MSG_0291 = "0291";
            /// <summary>
            /// 등록 할 승인 내역을 선택 하세요.
            /// </summary>
            public const string MSG_0292 = "0292";
            /// <summary>
            /// 이미 등록된 거래 입니다.
            /// </summary>
            public const string MSG_0293 = "0293";
            /// <summary>
            /// 해당 조건의 데이터가 없습니다
            /// </summary>
            public const string MSG_0294 = "0294";
            /// <summary>
            /// 금액 더치페이 설정을 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0295 = "0295";
            /// <summary>
            /// 왼쪽 그램에 맞는 제품명을 선택해 주세요
            /// </summary>
            public const string MSG_0296 = "0296";
            /// <summary>
            /// 정답입니다
            /// </summary>
            public const string MSG_0297 = "0297";
            /// <summary>
            /// 오답입니다
            /// </summary>
            public const string MSG_0298 = "0298";
            /// <summary>
            /// 상품교육을 완료 하였습니다
            /// </summary>
            public const string MSG_0299 = "0299";
            /// <summary>
            /// 사용 불가능한 카드입니다.
            /// </summary>
            public const string MSG_0300 = "0300";
            /// <summary>
            /// 사용금액이 카드잔액 보다 클 수 없습니다.
            /// </summary>
            public const string MSG_0301 = "0301";
            /// <summary>
            /// 조회 내역이 없습니다.
            /// </summary>
            public const string MSG_0302 = "0302";
            /// <summary>
            /// 마감 등록 되었습니다.
            /// </summary>
            public const string MSG_0303 = "0303";
            /// <summary>
            /// 등록 할 수 있는 상품권/선불카드가 없습니다.
            /// </summary>
            public const string MSG_0304 = "0304";
            /// <summary>
            /// 묶음이 불가능한 상품입니다.
            /// </summary>
            public const string MSG_0305 = "0305";
            /// <summary>
            /// 주문이 완료된 상품은 묶음이 불가능합니다.
            /// </summary>
            public const string MSG_0306 = "0306";
            /// <summary>
            /// 세트메뉴 변경 불가능한 상품 입니다
            /// </summary>
            public const string MSG_0307 = "0307";
            /// <summary>
            /// 해당 기능을 사용할 권한이 없습니다.
            /// </summary>
            public const string MSG_0308 = "0308";
            /// <summary>
            /// 등록되지 않은 관리자 입니다.
            /// </summary>
            public const string MSG_0309 = "0309";
            /// <summary>
            /// 관리자 비밀번호를 정확하게 입력 하여 주세요.
            /// </summary>
            public const string MSG_0310 = "0310";
            /// <summary>
            /// 교육장(테스트매장) 모드 입니다. 진행 하시겠습니까?
            /// </summary>
            public const string MSG_0311 = "0311";
            /// <summary>
            /// 라벨프린터를 연결해 주십시오.
            /// </summary>
            public const string MSG_0312 = "0312";
            /// <summary>
            /// 바코드 스캔을 시작합니다.
            /// </summary>
            public const string MSG_0313 = "0313";
            /// <summary>
            /// 이미 입금취소된 거래입니다.
            /// </summary>
            public const string MSG_0314 = "0314";
            /// <summary>
            /// 입금취소가 완료 되었습니다.
            /// </summary>
            public const string MSG_0315 = "0315";
            /// <summary>
            /// 정산 완료 되었습니다.
            /// </summary>
            public const string MSG_0316 = "0316";
            /// <summary>
            /// 정산 취소 되었습니다.
            /// </summary>
            public const string MSG_0317 = "0317";
            /// <summary>
            /// 영업마감 요청 통신에 실패하였습니다. 재시도 하시겠습니까?
            /// </summary>
            public const string MSG_0318 = "0318";
            /// <summary>
            /// 이미 마감 처리 되어 있습니다.
            /// </summary>
            public const string MSG_0319 = "0319";
            /// <summary>
            /// 이미 마감취소 처리 되어 있습니다.
            /// </summary>
            public const string MSG_0320 = "0320";
            /// <summary>
            /// 실패하였습니다. 장치를 확인 하세요.
            /// </summary>
            public const string MSG_0321 = "0321";
            /// <summary>
            /// T-Money 개시를 실패 하였습니다.
            /// </summary>
            public const string MSG_0322 = "0322";
            /// <summary>
            /// CashBee 개시를 실패 하였습니다.
            /// </summary>
            public const string MSG_0323 = "0323";
            /// <summary>
            /// 전화번호를 입력하세요
            /// </summary>
            public const string MSG_0324 = "0324";
            /// <summary>
            /// 현금 보관함에 한도 금액 확인 하세요.
            /// </summary>
            public const string MSG_0325 = "0325";
            /// <summary>
            /// 서버 조회 요청에 실패 하였습니다.
            /// </summary>
            public const string MSG_0326 = "0326";
            /// <summary>
            /// 포인트 조회를 먼저 하세요
            /// </summary>
            public const string MSG_0327 = "0327";
            /// <summary>
            /// 유효하지 않은 바코드 입니다.
            /// </summary>
            public const string MSG_0328 = "0328";
            /// <summary>
            /// 유효기간이 만료 되었습니다.
            /// </summary>
            public const string MSG_0329 = "0329";
            /// <summary>
            /// 정확한 직원카드를 입력하세요.
            /// </summary>
            public const string MSG_0330 = "0330";
            /// <summary>
            /// 해당 법인에 처리 프로세스가 없습니다. 관리자에 문의 하세요.
            /// </summary>
            public const string MSG_0331 = "0331";
            /// <summary>
            /// 직원카드를 읽으시면 처리됩니다.
            /// </summary>
            public const string MSG_0332 = "0332";
            /// <summary>
            /// 등록할 담당자를 선택하세요.
            /// </summary>
            public const string MSG_0333 = "0333";
            /// <summary>
            /// 등록할 상태를 선택하세요.
            /// </summary>
            public const string MSG_0334 = "0334";
            /// <summary>
            /// 당일 날자만 출근 등록 가능합니다.
            /// </summary>
            public const string MSG_0335 = "0335";
            /// <summary>
            /// {0} 일자 퇴근처리가 되질 않았습니다. 처리를 먼저 하세요.
            /// </summary>
            public const string MSG_0336 = "0336";
            /// <summary>
            /// 등록된 주방프린터 시스템이 없습니다.
            /// </summary>
            public const string MSG_0337 = "0337";
            /// <summary>
            /// 주방 프린트 체크에 실패했습니다. 장치를 확인하세요.
            /// </summary>
            public const string MSG_0338 = "0338";
            /// <summary>
            /// 영수증 반품 완료 처리 중 입니다
            /// </summary>
            public const string MSG_0339 = "0339";
            /// <summary>
            /// 정상 등록 되었습니다.
            /// </summary>
            public const string MSG_0340 = "0340";
            /// <summary>
            /// 카드 결제 내역을 취소하세요
            /// </summary>
            public const string MSG_0341 = "0341";
            /// <summary>
            /// 마감취소 하시겠습니까?
            /// </summary>
            public const string MSG_0342 = "0342";
            /// <summary>
            /// PayOn 개시를 실패 하였습니다.
            /// </summary>
            public const string MSG_0343 = "0343";
            /// <summary>
            /// 상호인증을 실패 하였습니다.
            /// </summary>
            public const string MSG_0344 = "0344";
            /// <summary>
            /// 무결성 검사를 실패 하였습니다.
            /// </summary>
            public const string MSG_0345 = "0345";
            /// <summary>
            /// 상호인증을 성공 하였습니다.
            /// </summary>
            public const string MSG_0346 = "0346";
            /// <summary>
            /// 무결성 검사를 정상완료 하였습니다.
            /// </summary>
            public const string MSG_0347 = "0347";
            /// <summary>
            /// T-Money 개시 요청 중입니다...
            /// </summary>
            public const string MSG_0348 = "0348";
            /// <summary>
            /// T-Money 운영정보 요청 중입니다...
            /// </summary>
            public const string MSG_0349 = "0349";
            /// <summary>
            /// PayON SAM 등록 요청 중입니다...
            /// </summary>
            public const string MSG_0350 = "0350";
            /// <summary>
            /// 무결성 검사중 입니다..
            /// </summary>
            public const string MSG_0351 = "0351";
            /// <summary>
            /// 상호인증 요청중 입니다...
            /// </summary>
            public const string MSG_0352 = "0352";
            /// <summary>
            /// 서명패드 Open 실패
            /// </summary>
            public const string MSG_0353 = "0353";
            /// <summary>
            /// 지원 불가 카드입니다.
            /// </summary>
            public const string MSG_0355 = "0355";
            /// <summary>
            /// 교통카드를
            /// </summary>
            public const string MSG_0356 = "0356";
            /// <summary>
            /// 서명패드에
            /// </summary>
            public const string MSG_0357 = "0357";
            /// <summary>
            /// 놓아주십시오
            /// </summary>
            public const string MSG_0358 = "0358";
            /// <summary>
            /// CashBee 개시 요청 중입니다...
            /// </summary>
            public const string MSG_0359 = "0359";
            /// <summary>
            /// CashBee 운영정보 요청 중입니다...
            /// </summary>
            public const string MSG_0360 = "0360";
            /// <summary>
            /// 처리중 입니다. 잠시만 기다려 주십시요.
            /// </summary>
            public const string MSG_0361 = "0361";
            /// <summary>
            /// 배달(콜센터) 거래를 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0362 = "0362";
            /// <summary>
            /// 배달(배달의민족) 거래를 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0363 = "0363";
            /// <summary>
            /// 사용 불가능한 기능(업무) 입니다
            /// </summary>
            public const string MSG_0364 = "0364";
            /// <summary>
            /// 해당고객은 VIP 고객이 아닙니다
            /// </summary>
            public const string MSG_0365 = "0365";
            /// <summary>
            /// 현금 반품 하시겠습니까?\n (반품 금액은 고객님께 환불해 주시고\n {0}에서 환급 받으시기 바랍니다.
            /// </summary>
            public const string MSG_0366 = "0366";
            /// <summary>
            /// 초 후에 프로그램 재 기동 자동 승인 됩니다.
            /// </summary>
            public const string MSG_0367 = "0367";
            /// <summary>
            /// 임의등록 하시겠습니까?
            /// </summary>
            public const string MSG_0368 = "0368";
            /// <summary>
            /// 영수증을 발행 하시겠습니까?
            /// </summary>
            public const string MSG_0369 = "0369";
            /// <summary>
            /// 캠페인 취소 후 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0370 = "0370";
            /// <summary>
            /// 상품금액[3,800]이 맞지 않습니다.
            /// </summary>
            public const string MSG_0371 = "0371";
            /// <summary>
            /// 배달 대행 비용 상품을 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0372 = "0372";
            /// <summary>
            /// 해당 업무를 덮어쓰고 진행 하시겠습니까?
            /// </summary>
            public const string MSG_0373 = "0373";
            /// <summary>
            /// 매출 데이터 전송 Flag 초기화를 실패 하였습니다.
            /// </summary>
            public const string MSG_0374 = "0374";
            /// <summary>
            /// 현재 영업일자 기준으로 3개월 전 까지 데이터만 재전송 가능 합니다.
            /// </summary>
            public const string MSG_0375 = "0375";
            /// <summary>
            /// ※ 환율 저장일은 (영업일 - 1)로 저장 됩니다.        
            /// </summary>
            public const string MSG_0376 = "0376";
            /// <summary>
            /// 할인 정보 마스터가 없습니다. 관리자에 문의 하세요.
            /// </summary>
            public const string MSG_0377 = "0377";
            /// <summary>
            /// POS 유형이 설정되어 있지 않습니다. 관리자에게 문의 하세요.
            /// </summary>
            public const string MSG_0378 = "0378";
            /// <summary>
            /// 메인POS 정보가 존재하지 않습니다. 고객센터에 연락 주십시오.
            /// </summary>
            public const string MSG_0379 = "0379";
            /// <summary>
            /// 서명패드 무결성 검사 실패\n포스지원팀에 문의하세요.
            /// </summary>
            public const string MSG_0380 = "0380";
            /// <summary>
            /// 서명패드 무결성 검사중 입니다.
            /// </summary>
            public const string MSG_0381 = "0381";
            /// <summary>
            /// 서명패드 상호인증 실패\n포스지원팀에 문의하세요.
            /// </summary>
            public const string MSG_0382 = "0382";
            /// <summary>
            /// 서명패드 상호인증 요청중 입니다.
            /// </summary>
            public const string MSG_0383 = "0383";
            /// <summary>
            /// IC 보안 리더기 무결성 검사 실패\n무결성 검사 후 다시 시도하세요.
            /// </summary>
            public const string MSG_0384 = "0384";
            /// <summary>
            /// 서명패드 무결성 검사 실패\n무결성 검사 후 다시 시도하세요.
            /// </summary>
            public const string MSG_0385 = "0385";
            /// <summary>
            /// IC 리더기를 체크 해주시기 바랍니다.
            /// </summary>
            public const string MSG_0386 = "0386";
            /// <summary>
            /// 서명패드를 체크 해주시기 바랍니다.
            /// </summary>
            public const string MSG_0387 = "0387";
            /// <summary>
            /// IC보안 리더기 및 서명패드 무결성 검사 실패\n무결성 검사 후 다시 시도하세요.
            /// </summary>
            public const string MSG_0388 = "0388";
            /// <summary>
            /// IC보안 리더기가 미사용으로 설정되어 있습니다.
            /// </summary>
            public const string MSG_0389 = "0389";
            /// <summary>
            /// 서명패드가 미사용으로 설정되어 있습니다.
            /// </summary>
            public const string MSG_0390 = "0390";
            /// <summary>
            /// 캠페인 할인금액이 받을금액을 초과하여 캠페인이 적용되지 않습니다
            /// </summary>
            public const string MSG_0391 = "0391";
            /// <summary>
            /// 이미 결제가 등록되어 있습니다. 등록 불가 합니다
            /// </summary>
            public const string MSG_0392 = "0392";
            /// <summary>
            /// T-Money 운영정보 다운로드를 실패 하였습니다.
            /// </summary>
            public const string MSG_0393 = "0393";
            /// <summary>
            /// CashBee 운영정보 다운로드를 실패 하였습니다.
            /// </summary>
            public const string MSG_0394 = "0394"; 
            /// <summary>
            /// 추후적립 사용 제한 시간을 초과 하였습니다
            /// </summary>
            public const string MSG_0395 = "0395";
            /// <summary>
            /// 등록된 상품이 없습니다
            /// </summary>
            public const string MSG_0396 = "0396";
            /// <summary>
            /// 서버와 통신이 되지 않습니다.\n강제 진행 하시겠습니까?
            /// </summary>
            public const string MSG_0397 = "0397";
            /// <summary>
            /// 메뉴이동 실패 하였습니다.
            /// </summary>
            public const string MSG_0398 = "0398";
            /// <summary>
            /// 사용중인 테이블이 아닙니다.
            /// </summary>
            public const string MSG_0399 = "0399";
            /// <summary>
            /// 테이블사용을 강제해제 하시겠습니까?
            /// </summary>
            public const string MSG_0400 = "0400";
            /// <summary>
            /// 테이블사용을 강제해제에 실패하였습니다.
            /// </summary>
            public const string MSG_0401 = "0401";
            /// <summary>
            /// 테이블사용을 강제해제 하였습니다.
            /// </summary>
            public const string MSG_0402 = "0402";
            /// <summary>
            /// 좌석메모를 조회하는데 실패 하였습니다.
            /// </summary>
            public const string MSG_0403 = "0403";
            /// <summary>
            /// ※ 해피콘 사용시 타.불가-물품형-금액형 및 유효기간이 빠른 순으로 사용해 주시기 바랍니다. \n (비고2:【불가사유】표기시 선택하면 상세내역 확인 팝업)
            /// </summary>
            public const string MSG_0404 = "0404";
            /// <summary>
            /// 메모길이가 너무 깁니다.
            /// </summary>
            public const string MSG_0405 = "0405";
            /// <summary>
            /// 등록 내역을 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0406 = "0406";
            /// <summary>
            /// 해당 테이블은 좌석메모를 남길 수 없습니다.\n(주방출력대상 상품 없음)
            /// </summary>
            public const string MSG_0407 = "0407";
            /// <summary>
            /// 이미 등록된 쿠폰입니다. \n확인후 다시 시도하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0408 = "0408";
            /// <summary>
            /// 사용할 쿠폰을 선택후 사용하여 주기기 바랍니다.
            /// </summary>
            public const string MSG_0409 = "0409";
            /// <summary>
            /// 모든 쿠폰을 한번에 같이 사용해야 합니다.
            /// </summary>
            public const string MSG_0410 = "0410";
            /// <summary>
            /// 타상품 교환 불가 쿠폰입니다. 확인후 다시 시도 하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0411 = "0411";
            /// <summary>
            /// 쿠폰이력조회를 하실 가상쿠폰을 선택해 주세요.
            /// </summary>
            public const string MSG_0412 = "0412";
            /// <summary>
            /// 출력할 내역이 없습니다.
            /// </summary>
            public const string MSG_0413 = "0413";
            /// <summary>
            /// 해당 기능은 POS 옵션에서 미사용으로 되어 있습니다.
            /// </summary>
            public const string MSG_0414 = "0414";
            /// <summary>
            /// 저장 되었습니다.
            /// </summary>
            public const string MSG_0415 = "0415";
            /// <summary>
            /// 취소 되었습니다.
            /// </summary>
            public const string MSG_0416 = "0416";
            /// <summary>
            /// 저장 실패 하였습니다.
            /// </summary>
            public const string MSG_0417 = "0417";
            /// <summary>
            /// 등록된 고객불편사항이 없습니다.
            /// </summary>
            public const string MSG_0418 = "0418";
            /// <summary>
            /// 고객불편사항을 선택해 주십시오.
            /// </summary>
            public const string MSG_0419 = "0419";
            /// <summary>
            /// 고객 불편사항 전송에 실패 하였습니다.
            /// </summary>
            public const string MSG_0420 = "0420";
            /// <summary>
            /// 테이블그룹 대상 테이블과 같은 테이블을 선택하셨습니다. 테이블그룹 할 수 없습니다.
            /// </summary>
            public const string MSG_0421 = "0421";
            /// <summary>
            /// 테이블을 사용중 입니다. 테이블그룹 할 수 없습니다.
            /// </summary>
            public const string MSG_0422 = "0422";
            /// <summary>
            /// 이미 테이블그룹 설정이 되어 있습니다.
            /// </summary>
            public const string MSG_0423 = "0423";
            /// <summary>
            /// 테이블그룹 처리를 하시겠습니까?
            /// </summary>
            public const string MSG_0424 = "0424";
            /// <summary>
            /// 테이블그룹 처리에 실패하였습니다.
            /// </summary>
            public const string MSG_0425 = "0425";
            /// <summary>
            /// 테이블그룹을 해제 하시겠습니까?
            /// </summary>
            public const string MSG_0426 = "0426";
            /// <summary>
            /// 테이블그룹을 해제 실패 하였습니다.
            /// </summary>
            public const string MSG_0427 = "0427";
            /// <summary>
            /// 테이블그룹이 설정되어 있지 않습니다.
            /// </summary>
            public const string MSG_0428 = "0428";
            /// <summary>
            /// 테이블그룹이 설정이 되어 있습니다. 테이블그룹 전체를 결제 하시겠습니까?
            /// </summary>
            public const string MSG_0429 = "0429";
            /// <summary>
            /// 케익교환권 번호를 입력하여 주십시요.
            /// </summary>
            public const string MSG_0430 = "0430";
            /// <summary>
            /// 케익교환권 가능한 상품이 없습니다.
            /// </summary>
            public const string MSG_0431 = "0431";
            /// <summary>
            /// 마스터 백업 중 입니다. 잠시만 기다리세요.
            /// </summary>
            public const string MSG_0432 = "0432";
            /// <summary>
            /// ** 개점 준비 점검을 등록 할 수 있습니다. ** \n\r\n\r 오전 12시까지만 등록 가능합니다.
            /// </summary>
            public const string MSG_0433 = "0433";
            /// <summary>
            /// 단위농협/후협일 경우- 계좌번호 입력
            /// </summary>
            public const string MSG_0434 = "0434";
            /// <summary>
            /// 점검항목이 없습니다.
            /// </summary>
            public const string MSG_0435 = "0435";
            /// <summary>
            /// 빠짐없이 입력해 주십시오.
            /// </summary>
            public const string MSG_0436 = "0436";
            /// <summary>
            /// 그룹된 테이블 입니다. 테이블붙임 할 수 없습니다.
            /// </summary>
            public const string MSG_0437 = "0437";
            /// <summary>
            /// 테이블붙임 되어 있습니다. 테이블그룹 처리를 할 수 없습니다.
            /// </summary>
            public const string MSG_0438 = "0438";
            /// <summary>
            /// 등록한 사은품이 없습니다
            /// </summary>
            public const string MSG_0439 = "0439";
            /// <summary>
            /// 해당 캠페인 사은품은 추가 구매가 불가 합니다
            /// </summary>
            public const string MSG_0440 = "0440";
            /// <summary>
            /// 파일 열기에 실패하였습니다.
            /// </summary>
            public const string MSG_0441 = "0441";
            /// <summary>
            /// 출력을 실패하였습니다.
            /// </summary>
            public const string MSG_0442 = "0442";
            /// <summary>
            /// 등록자를 입력해 주십시오.
            /// </summary>
            public const string MSG_0443 = "0443";
            /// <summary>
            /// 계정을 입력해 주십시오.
            /// </summary>
            public const string MSG_0444 = "0444";
            /// <summary>
            /// 영업일자를 입력해 주십시오.
            /// </summary>
            public const string MSG_0445 = "0445";
            /// <summary>
            /// 금액을 입력해 주십시오.
            /// </summary>
            public const string MSG_0446 = "0446";
            /// <summary>
            /// 기타사유를 입력해 주십시오.
            /// </summary>
            public const string MSG_0447 = "0447";
            /// <summary>
            /// 적립가능 상품이 없거나 적립불가 결제수단이 등록 되었습니다
            /// </summary>
            public const string MSG_0448 = "0448";
            /// <summary>
            /// 사은품을 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0449 = "0449";
            /// <summary>
            /// ※ 본 팝업창은 2월 2일(월) 오전6시~오후6시까지 운영됩니다.
            /// ※ 식품 안전의 날은 매월 첫째주 월요일에 시행됩니다.
            /// </summary>
            public const string MSG_0450 = "0450";
            /// <summary>
            /// ※ 주요 사항 기업(선택사항)
            /// 우리점포의 주요 사항을 체크하여 메모하는 란입니다.
            /// </summary>
            public const string MSG_0451 = "0451";
            /// <summary>
            /// ** 유통기한 체크리스트 점검해주세요. **
            /// </summary>
            public const string MSG_0452 = "0452";
            /// <summary>
            /// 한 달에 1회, 우리 점포의 식품 안전 사항에 대한 점검 및 Risk를 특별 사전 관리하는 날 입니다.
            /// 체크리스트 자가 점검을 통한 점포의 자발적인 개선을 권장합니다.
            /// 식품 안전에 대한 관심과 함께 적극적인 참여를 부탁드립니다.
            /// 감사합니다.
            /// </summary>
            public const string MSG_0453 = "0453";
            /// <summary>
            /// 잔액교환권 사용 불가 타점에서 발행한 잔액교환권 입니다.
            /// </summary>
            public const string MSG_0454 = "0454";
            /// <summary>
            /// 해당 보류 거래를 삭제 하시겠습니까?
            /// </summary>
            public const string MSG_0455 = "0455";
            /// <summary>
            /// 본 잔액교환권은 발행점에서만 사용 가능합니다.
            /// </summary>
            public const string MSG_0456 = "0456";
            /// <summary>
            /// [잔액교환권 발행 서명]____________________
            /// </summary>
            public const string MSG_0457 = "0457";
            /// <summary>
            /// 마스터 수신을 하시겠습니까? ("예" : 전체수신, "아니오" : 변경분만 수신)
            /// </summary>
            public const string MSG_0458 = "0458";
            /// <summary>
            /// 상품권 승인 내역이 있습니다.상품권 취소후 진행하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0459 = "0459";
            /// <summary>
            /// POS번호를 입력 하세요
            /// </summary>
            public const string MSG_0460 = "0460";
            /// <summary>
            /// 교통카드 결제를 진행하시겠습니까?
            /// </summary>
            public const string MSG_0461 = "0461";
            /// <summary>
            /// 결제 잔액이 0 원 남았습니다.
            /// </summary>
            public const string MSG_0462 = "0462";
            /// <summary>
            /// 예약 시간을 정확하게 입력하세요.
            /// </summary>
            public const string MSG_0463 = "0463";
            /// <summary>
            /// 정산지 출력을 하시겠습니까?
            /// </summary>
            public const string MSG_0464 = "0464";
            /// <summary>
            /// 상품권 번호와 금액을 확인하여 주십시요.
            /// </summary>
            public const string MSG_0465 = "0465";
            /// <summary>
            /// 영업 준비금 관련 업무를 처리 하실수 있습니다.
            /// </summary>
            public const string MSG_0466 = "0466";
            /// <summary>
            /// 모든 입/출금 관련 업무 처리 하 실 수 있습니다.
            /// </summary>
            public const string MSG_0467 = "0467";
            /// <summary>
            /// 업무 마감 관련 업무를 처리 하실 수 있습니다.
            /// </summary>
            public const string MSG_0468 = "0468";
            /// <summary>
            /// POS 시스템 환경 관련 업무를 처리 할 수 있습니다.
            /// </summary>
            public const string MSG_0469 = "0469";
            /// <summary>
            /// 최신 프로그램 다운로드 하거나 매출 송/수신 업무를 처리 할 수 있습니다.
            /// </summary>
            public const string MSG_0470 = "0470";
            /// <summary>
            /// 판매등록을 위한 인증/체크 업무를 처리 하 실수 있습니다.
            /// </summary>
            public const string MSG_0471 = "0471";
            /// <summary>
            /// 매출 내역 및 승인 내역 조회 업무를 처리 하 실 수 있습니다.
            /// </summary>
            public const string MSG_0472 = "0472";
            /// <summary>
            /// 영수증 관련 재 발행 업무를 처리하 실 수 있습니다.
            /// </summary>
            public const string MSG_0473 = "0473";
            /// <summary>
            /// 기타 내역 조회 업무를 처리하 실 수  있습니다.
            /// </summary>
            public const string MSG_0474 = "0474";
            /// <summary>
            /// 기타 등록 관련 업무를 처리 하 실수 있습니다.
            /// </summary>
            public const string MSG_0475 = "0475";
            /// <summary>
            /// 기타 기능 업무를 처리 하 실 수 있습니다.
            /// </summary>
            public const string MSG_0476 = "0476";
            /// <summary>
            /// 기타 설정 업무를 처리 하 실수 있습니다.
            /// </summary>
            public const string MSG_0477 = "0477";
            /// <summary>
            /// 신상품 및 전체 상품을 대상으로 교육 하 실수 있습니다
            /// </summary>
            public const string MSG_0478 = "0478";
            /// <summary>
            /// 연습모드로 매출 등록을 하 실 수 있습니다.
            /// </summary>
            public const string MSG_0479 = "0479";
            /// <summary>
            /// 사용자 교육 및 결과 조회를 하실 수 있습니다.
            /// </summary>
            public const string MSG_0480 = "0480";
            /// <summary>
            /// 유효한 상품권번호가 아닙니다.
            /// </summary>
            public const string MSG_0481 = "0481";
            /// <summary>
            /// {0} 처리 하시겠습니까?
            /// </summary>
            public const string MSG_0482 = "0482";
            /// <summary>
            /// 현재 {0} 상태 입니다.
            /// </summary>
            public const string MSG_0483 = "0483";
            /// <summary>
            /// {0} 처리 하시겠습니까?
            /// {0} 선택 시 주문데이타 매출 처리됩니다.
            /// </summary>
            public const string MSG_0484 = "0484";
            /// <summary>
            /// 주문취소 하시겠습니까?
            /// 취소된 주문은 다시 주문할 수 없습니다.
            /// </summary>
            public const string MSG_0485 = "0485";
            /// <summary>
            /// 현재 {0} 중 입니다.
            /// 주문취소 할 수 없습니다.
            /// </summary>
            public const string MSG_0486 = "0486";
            /// <summary>
            /// 정상적으로 {0} 되었습니다.
            /// </summary>
            public const string MSG_0487 = "0487";
            /// <summary>
            /// 이전 처리가 완료되지 않았습니다.
            /// </summary>
            public const string MSG_0488 = "0488";
            /// <summary>
            /// 고객수를 입력하세요.
            /// </summary>
            public const string MSG_0489 = "0489";
            /// <summary>
            /// OCB 적립을 재시도 하시겠습니까?
            /// </summary>
            public const string MSG_0490 = "0490";
            /// <summary>
            /// 연습모드에선 돈통을 열수 없습니다.
            /// </summary>
            public const string MSG_0491 = "0491";

            /// <summary>
            /// 회사코드가 설정되어 있지 않습니다. 고객센터에 연락 주십시오.
            /// </summary>
            public const string MSG_0492 = "0492";
            /// <summary>
            /// 점포코드가 설정되어 있지 않습니다. 고객센터에 연락 주십시오.
            /// </summary>
            public const string MSG_0493 = "0493";
            /// <summary>
            /// POS 유형이 후불이 아닙니다. 고객센터에 연락 주십시오.
            /// </summary>
            public const string MSG_0494 = "0494";
            /// <summary>
            /// 테이블 정보가 없습니다.
            /// </summary>
            public const string MSG_0495 = "0495";
            /// <summary>
            /// 테이블 정보를 조회하는데 실패 하였습니다.
            /// </summary>
            public const string MSG_0496 = "0496";
            /// <summary>
            /// 현재 층의 테이블 정보를 초기화 하시겠습니까?
            /// </summary>
            public const string MSG_0497 = "0497";
            /// <summary>
            /// 변경된 테이블 정보를 저장 하시겠습니까?
            /// </summary>
            public const string MSG_0498 = "0498";
            /// <summary>
            /// 더이상 추가 할 수 없습니다.
            /// </summary>
            public const string MSG_0499 = "0499";
            /// <summary>
            /// 해당 층의 테이블 모두 삭제됩니다. 삭제 하시겠습니까? 
            /// </summary>
            public const string MSG_0500 = "0500";
            /// <summary>
            /// 층 코드를 정확하게 입력 하여 주십시오.
            /// </summary>
            public const string MSG_0501 = "0501";
            /// <summary>
            /// 층 코드를 정확하게 입력 하여 주십시오.
            /// </summary>
            public const string MSG_0502 = "0501";
            /// <summary>
            /// 층 명을 정확하게 입력 하여 주십시오.
            /// </summary>
            public const string MSG_0503 = "0503";
            /// <summary>
            /// 테이블 번호를 정확하게 입력 하여 주세요.
            /// </summary>
            public const string MSG_0504 = "0504";
            /// <summary>
            /// 테이블 이름을 정확하게 입력 하여 주세요.
            /// </summary>
            public const string MSG_0505 = "0505";
            /// <summary>
            /// 층 마스터 저장에 실패하였습니다.
            /// </summary>
            public const string MSG_0506 = "0506";
            /// <summary>
            /// 테이블 마스터 저장에 실패하였습니다.
            /// </summary>
            public const string MSG_0507 = "0507";
            /// <summary>
            /// 고객님 저희 매장을 단골매장에서 해지하시면 다양한 서비스를 받을 수 없습니다. 해지하시겠습니까?
            /// </summary>
            public const string MSG_0508 = "0508";
            /// <summary>
            /// 고객님 저희 매장을 단골매장으로 등록하시면 다양한 쿠폰을 보내드립니다. 등록하시겠습니까?
            /// </summary>
            public const string MSG_0509 = "0509";
            /// <summary>
            /// 단골고객해지을 완료 하였습니다
            /// </summary>
            public const string MSG_0510 = "0510";
            /// <summary>
            /// 갯수를 1개 이상 입력 하십시오.
            /// </summary>
            public const string MSG_0511 = "0511";
            /// <summary>
            /// 최대 갯수는 {0}개 입니다.
            /// </summary>
            public const string MSG_0512 = "0512";
            /// <summary>
            /// 접수된 주문 건이 없습니다.
            /// </summary>
            public const string MSG_0513 = "0513";
            /// <summary>
            /// 출력된 주문서를 해당 제품에 부착하여 보관해 주세요.
            /// </summary>
            public const string MSG_0514 = "0514";
            /// <summary>
            /// 주문접수출력 총 {0} 건 / 정상출력 : {1} 건 / 출력실패 : {2} 건
            /// </summary>
            public const string MSG_0515 = "0515";
            /// <summary>
            /// 받을 금액이 없습니다. 0원으로 결제 하시겠습니까?
            /// </summary>
            public const string MSG_0516 = "0516";

            /// <summary>
            /// 테이블 정보를 백업 하시겠습니까?
            /// </summary>
            public const string MSG_0517 = "0517";
            /// <summary>
            /// 테이블 정보를 복원 하시겠습니까?
            /// </summary>
            public const string MSG_0518 = "0518";
            /// <summary>
            /// 테이블 정보를 백업에 성공 하였습니다.
            /// </summary>
            public const string MSG_0519 = "0519";
            /// <summary>
            /// 테이블 정보를 백업에 실패 하였습니다.
            /// </summary>
            public const string MSG_0520 = "0520";
            /// <summary>
            /// 테이블 정보를 복원에 성공 하였습니다.
            /// </summary>
            public const string MSG_0521 = "0521";
            /// <summary>
            /// 테이블 정보를 복원에 실패 하였습니다.
            /// </summary>
            public const string MSG_0522 = "0522";
            /// <summary>
            /// 등록되지 않은 바코드 입니다.
            /// </summary>
            public const string MSG_0523 = "0523";
            /// <summary>
            /// 유통기한 확인 바랍니다. 제품을 등록하시겠습니까?
            /// </summary>
            public const string MSG_0524 = "0524";
            /// <summary>
            /// 유통기한 지난 상품입니다.제 품 명  : {0} 생산일자 : {1} 유통기한 : {2}
            /// </summary>
            public const string MSG_0525 = "0525";
            /// <summary>
            /// 로그 조회 완료 되었습니다.
            /// </summary>
            public const string MSG_0526 = "0526";
            /// <summary>
            /// 보류로 저장 하시겠습니까? 
            /// </summary>
            public const string MSG_0527 = "0527";
            /// <summary>
            /// 삼성포인트창을 이용하세요.
            /// </summary>
            public const string MSG_0528 = "0528";
            /// <summary>
            /// 해당 장비를 다시 체크 하시겠습니까?
            /// </summary>
            public const string MSG_0529 = "0529";
            /// <summary>
            /// 해피버즈 처리 중입니다.\r\n 잠시만 기다려 주세요!
            /// </summary>
            public const string MSG_0530 = "0530";
            /// <summary>
            /// 해피버즈 등록을 완료 하였습니다\r\n 대기번호 : {0}
            /// </summary>
            public const string MSG_0531 = "0531";
            /// <summary>
            /// 해피버즈 등록에 실패했습니다.
            /// </summary>
            public const string MSG_0532 = "0532";
            /// <summary>
            /// 해피버즈 취소를 완료 하였습니다\r\n 대기번호 : {0}
            /// </summary>
            public const string MSG_0533 = "0533";
            /// <summary>
            /// 해피버즈 취소에 실패했습니다.
            /// </summary>
            public const string MSG_0534 = "0534";
            /// <summary>
            /// 주변장치 연결 상태 관리
            /// </summary>
            public const string MSG_0535 = "0535";
            /// <summary>
            /// 유효하지 않은 일자입니다.
            /// </summary>
            public const string MSG_0536 = "0536";
            /// <summary>
            /// 상품단가를 입력 하세요
            /// </summary>
            public const string MSG_0537 = "0537";
            /// <summary>
            /// 상품단가를 정확하게 입력 하여 주세요
            /// </summary>
            public const string MSG_0538 = "0538";
            /// <summary>
            /// 유효한 쿠폰번호가 아닙니다.
            /// </summary>
            public const string MSG_0539 = "0539";
            /// <summary>
            /// 선택한 고객 단말기에 OTB 발급 요청이 실패 하였습니다.
            /// </summary>
            public const string MSG_0540 = "0540";
            /// <summary>
            /// 선택한 고객 단말기로 부터 OTB 수신에 실패하였습니다.
            /// </summary>
            public const string MSG_0541 = "0541";
            /// <summary>
            /// 할인대상금액이 {0}원 이상일 때 통합결제가 가능 합니다.
            /// </summary>
            public const string MSG_0542 = "0542";
            /// <summary>
            /// 일반결제(결제만)를 진행 하시겠습니까?
            /// </summary>
            public const string MSG_0543 = "0543";
            /// <summary>
            /// 통합결제(할인 + 결제)를 진행 하시겠습니까?
            /// </summary>
            public const string MSG_0544 = "0544";
            /// <summary>
            /// 비밀번호 암호화 처리에 실패하였습니다.
            /// </summary>
            public const string MSG_0545 = "0545";
            /// <summary>
            /// T페이 카드가 아닙니다.
            /// </summary>
            public const string MSG_0546 = "0546";
            /// <summary>
            /// 30일 이전 일자로 선택 할 수 없습니다
            /// </summary>
            public const string MSG_0547 = "0547";
            /// <summary>
            /// 할인 후 수량 변경 할 수 없습니다
            /// </summary>
            public const string MSG_0548 = "0548";
            /// <summary>
            /// 가용포인트가 1,000원 이상 일 때 사용이 가능 합니다
            /// </summary>
            public const string MSG_0549 = "0549";
            /// <summary>
            /// 수기서명 승인 처리 하시겠습니까?
            /// </summary>
            public const string MSG_0550 = "0550";
            /// <summary>
            /// 마감 준비 점검을 등록 할 수 있습니다.
            /// </summary>
            public const string MSG_0551 = "0551";
            /// <summary>
            /// 마스터에 등록된 원격제어 URL을 확인해 주십시오.
            /// </summary>
            public const string MSG_0552 = "0552";
            /// <summary>
            /// 충전완료 되었습니다.
            /// </summary>
            public const string MSG_0553 = "0553";
            /// <summary>
            /// 충전취소 되었습니다.
            /// </summary>
            public const string MSG_0554 = "0554";
            /// <summary>
            /// OKCASHBACK 카드등록 후 처리 할 수 없습니다
            /// </summary>
            public const string MSG_0555 = "0555";
            /// <summary>
            /// 참여 하시겠습니까?
            /// </summary>
            public const string MSG_0556 = "0556";
            /// <summary>
            /// 서명해주세요.
            /// </summary>
            public const string MSG_0557 = "0557";
            /// <summary>
            /// 축하합니다. {0}등 복권에 당첨 되었습니다
            /// </summary>
            public const string MSG_0558 = "0558";
            /// <summary>
            /// 한 달에 1회, 우리 점포의 식품 안전 사항에 대한 점검 및\r\n Risk를 특별 사전 관리하는 날 입니다.
            /// </summary>
            public const string MSG_0559 = "0559";
            /// <summary>
            /// 체크리스트 자가 점검을 통한 점포의 자발적인 개선을 권장합니다.
            /// </summary>
            public const string MSG_0560 = "0560";
            /// <summary>
            /// 식품 안전에 대한 관심과 함께 적극적인 참여를 부탁드립니다.\r\n감사합니다.
            /// </summary>
            public const string MSG_0561 = "0561";
            /// <summary>
            /// 비밀번호를 판매POS에서 입력하시겠습니까?
            /// </summary>
            public const string MSG_0562 = "0562";
            /// <summary>
            /// 결제할인 마스터가 존재 하지 않습니다
            /// </summary>
            public const string MSG_0563 = "0563";
            /// <summary>
            /// 추후 발행 하시겠습니까?
            /// </summary>
            public const string MSG_0564 = "0564";
            /// <summary>
            /// VAN 접속 정보가 없습니다.
            /// </summary>
            public const string MSG_0565 = "0565";
            /// <summary>
            /// 예약 내역이 있습니다. 확인 하시겠습니까?
            /// </summary>
            public const string MSG_0566 = "0566";
            /// <summary>
            /// 수량을 입력 후 사용하세요
            /// </summary>
            public const string MSG_0567 = "0567";
            /// <summary>
            /// 입력된 수량이 너무 큽니다.
            /// </summary>
            public const string MSG_0568 = "0568";
            /// <summary>
            /// [결제완료] 버튼을 입력하여 거래를 완료 하세요
            /// </summary>
            public const string MSG_0569 = "0569";
            /// <summary>
            /// 지금은 아이스크림 품질 관리 집중 시간입니다.
            /// </summary>
            public const string MSG_0570 = "0570";
            /// <summary>
            /// 행사 내용을 확인해 주세요.
            /// </summary>
            public const string MSG_0571 = "0571";
            /// <summary>
            /// 입고 등록해 주세요.
            /// </summary>
            public const string MSG_0572 = "0572";
            /// <summary>
            /// 금일이후 일자로만 개점 할 수 있습니다.
            /// </summary>
            public const string MSG_0573 = "0573";
            /// <summary>
            /// 포스지원팀으로 문의주세요! 080-778-8204
            /// </summary>
            public const string MSG_0574 = "0574";
            /// <summary>
            /// {0} 일자로 개점 하겠습니까?
            /// </summary>
            public const string MSG_0575 = "0575";
            /// <summary>
            /// 승인번호를 입력 하세요
            /// </summary>
            public const string MSG_0576 = "0576";
            /// <summary>
            /// 서명패드 업데이트 파일이 없습니다.
            /// </summary>
            public const string MSG_0577 = "0577";
            /// <summary>
            /// 가용금액 이상으로 수정은 불가능 합니다.
            /// </summary>
            public const string MSG_0578 = "0578";
            /// <summary>
            /// 점포 마스터가 설정되어 있지 않습니다. 고객센터로 연락하여 주세요.
            /// </summary>
            public const string MSG_0579 = "0579";
            /// <summary>
            /// 카드잔액이 부족합니다.
            /// </summary>
            public const string MSG_0580 = "0580";
            /// <summary>
            /// 유효기간을 정확하게 입력 하세요.
            /// </summary>
            public const string MSG_0581 = "0581";
            /// <summary>
            /// 조회 년/월을 정확하게 입력 하세요.
            /// </summary>
            public const string MSG_0582 = "0582";
            /// <summary>
            /// {0}원
            /// </summary>
            public const string MSG_0583 = "0583";
            /// <summary>
            /// WEB 버튼을 누르시면 해당 공지사항으로 연결 됩니다. 
            /// </summary>
            public const string MSG_0584 = "0584";
            /// <summary>
            /// 마스터 수신 중 입니다. 잠시만 기다리세요.
            /// </summary>
            public const string MSG_0585 = "0585";
            /// <summary>
            /// 예약 등록 내역까지 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0586 = "0586";
            /// <summary>
            /// IC 보안 미사용 프로그램으로 전환 하시겠습니까?
            /// </summary>
            public const string MSG_0587 = "0587";
            /// <summary>
            /// IC 보안 사용 프로그램으로 전환 하시겠습니까?
            /// </summary>
            public const string MSG_0588 = "0588";
            /// <summary>
            /// 캠페인 횟수 제한을 초과 하여 캠페인 적용 되지 않습니다.
            /// </summary>
            public const string MSG_0589 = "0589";
            /// <summary>
            /// POS 기초 환경 설정후 실행하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0590 = "0590";
            /// <summary>
            /// 주문상품이 매장내 재고가 있거나
            /// POS주문이 완료되셨습니까?
            /// </summary>
            public const string MSG_0591 = "0591";
            /// <summary>
            /// 주문상품 준비/포장이 완료되었습니까?
            /// 픽업대기 처리시 매장에서도
            /// 주문취소 불가합니다.
            /// </summary>
            public const string MSG_0592 = "0592";
            /// <summary>
            /// 쿠폰 조회 후 등록 하세요
            /// </summary>
            public const string MSG_0593 = "0593";
            /// <summary>
            /// 할인금액 {0}원, 결제금액 {1}원 \n 승인 요청 하시겠습니까?
            /// </summary>
            public const string MSG_0594 = "0594";
            /// <summary>
            /// 차세대 POS 시스템은 {0}년 {1}월 {2}일 부터 사용 가능 합니다.
            /// </summary>
            public const string MSG_0595 = "0595";
            /// <summary>
            /// 연습모드에서 사용할 수 없는 기능입니다.
            /// </summary>
            public const string MSG_0596 = "0596";
            /// <summary>
            /// 승인금액 또는 결제 금액을 확인 하세요.
            /// </summary>
            public const string MSG_0597 = "0597";
            /// <summary>
            /// 결제 대상 금액이 캠페인 할인 과 같거나 더 큽니다. \n 캠페인 할인금{0}원, 결제대상금액{1}원
            /// </summary>
            public const string MSG_0598 = "0598";
            /// <summary>
            /// 해당 선불카드 승인 요청이 실패했습니다. 고객센터에 문의하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0599 = "0599";
            /// <summary>
            /// 해당 선불카드 취소 요청이 실패했습니다. 고객센터에 문의하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0600 = "0600";
            /// <summary>
            /// 할인 대상 금액이 없습니다.
            /// </summary>
            public const string MSG_0601 = "0601";
            /// <summary>
            /// 할인 대상 금액 보다 적용하려는 금액이 더 큽니다. \n 대상 금액{0}원, 할인 적용 금액{1}원
            /// </summary>
            public const string MSG_0602 = "0602";
            /// <summary>
            /// 유효한 카드번호가 아닙니다. 확인후 다시 시도하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0603 = "0603";
            /// <summary>
            /// POS 마스터가 존재 하지 않습니다. \n 고객센터에 문의하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0604 = "0604";
            /// <summary>
            /// 특이사항이 없습니다.
            /// </summary>
            public const string MSG_0605 = "0605";
            /// <summary>
            /// 점검내역이 없습니다.
            /// </summary>
            public const string MSG_0606 = "0606";
            /// <summary>
            /// 영업일자보다 미래일자를 조회 할 수 없습니다.
            /// </summary>
            public const string MSG_0607 = "0607";
            /// <summary>
            /// 승인 데몬(fmclient.exe)이 정상적으로 실행되어 있지 않습니다.  고객센터에 문의하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0608 = "0608";

            /// <summary>
            /// 이미 등록된 쿠폰 중 중복 불가한 쿠폰이 등록 되어 있습니다
            /// </summary>
            public const string MSG_0609 = "0609";
            /// <summary>
            /// 온라인 쿠폰 할인 대상 상품이 없습니다
            /// </summary>
            public const string MSG_0610 = "0610";
            /// <summary>
            /// 초 후에 자동 처리 됩니다.
            /// </summary>
            public const string MSG_0611 = "0611";
            /// <summary>
            /// 서명패드에 업그레이드 자료가 있습니다. 진행하시겠습니까?
            /// </summary>
            public const string MSG_0612 = "0612";
            /// <summary>
            /// 동영상이 업그레이드 되었습니다.
            /// </summary>
            public const string MSG_0613 = "0613";
            /// <summary>
            /// 이미지파일이 업그레이드 되었습니다.
            /// </summary>
            public const string MSG_0614 = "0614";
            /// <summary>
            /// 펌웨어가 업그레이드 되었습니다.  잠시후 서명패드가 재시작합니다.
            /// </summary>
            public const string MSG_0615 = "0615";
            /// <summary>
            /// 사은품 판매가가 점포상품 단가보다 높아 등록 할 수 없습니다
            /// </summary>
            public const string MSG_0616 = "0616";
            /// <summary>
            /// 점포판매가가 쿠폰 액면금액 보다 작으면 등록 불가 합니다
            /// </summary>
            public const string MSG_0617 = "0617";
            /// <summary>
            /// 받을금액이 쿠폰 액면금액 보다 작으면 등록 불가 합니다
            /// </summary>
            public const string MSG_0618 = "0618";
            /// <summary>
            /// 허용 기간({0}일)이 초과 또는 정확하지 않습니다.
            /// </summary>
            public const string MSG_0619 = "0619";
            /// <summary>
            /// 더이상 등록 하실 수 없습니다. 최대 4개까지만 가능합니다.
            /// </summary>
            public const string MSG_0620 = "0620";
            /// <summary>
            /// 다운로드가 완료 되었습니다.
            /// </summary>
            public const string MSG_0621 = "0621";
            /// <summary>
            /// 캠페인 할인결제 아이템은 개별 취소 할 수 없습니다
            /// </summary>
            public const string MSG_0622 = "0622";
            /// <summary>
            /// 결락 조회중입니다. 잠시만 기다려 주십시요.
            /// </summary>
            public const string MSG_0623 = "0623";
            /// <summary>
            /// 결락 전송 준비중 입니다. 잠시만 기다려 주십시요.
            /// </summary>
            public const string MSG_0624 = "0624";
            /// <summary>
            /// 결락전송을 {0}회 재시도 하였으나 결락이 존재합니다. 결락전송을 재시도 하시겠습니까?
            /// </summary>
            public const string MSG_0625 = "0625";
            /// <summary>
            /// 연결 상태가 정상 입니다.
            /// </summary>
            public const string MSG_0626 = "0626";
            /// <summary>
            /// 마감처리 되어 있습니다. 개점 처리 하시겠습니까?
            /// </summary>
            public const string MSG_0627 = "0627";
            /// <summary>
            /// 적용 방법을 선택 하세요.
            /// </summary>
            public const string MSG_0628 = "0628";
            /// <summary>
            /// 점포 마스터에 봉사료 적용대상 구분이 적용 안함으로 되어 있어야 사용 가능합니다.
            /// </summary>
            public const string MSG_0629 = "0629";
            /// <summary>
            /// 금액 더치페이한 거래는 영수증 반품 처리 할 수 없습니다.
            /// </summary>
            public const string MSG_0630 = "0630";
            /// <summary>
            /// 해당 기능은 선불 POS 유형에서 사용할 수 없습니다.
            /// </summary>
            public const string MSG_0631 = "0631";
            /// <summary>
            /// 복합매장 구성점포 정보가 존재하지 않습니다. 고객센터로 연락하여 주세요.
            /// </summary>
            public const string MSG_0632 = "0632";
            /// <summary>
            /// IC카드를 제거해 주세요.
            /// </summary>
            public const string MSG_0633 = "0633";
            /// <summary>
            /// {0} 선택하시겠습니까?
            /// </summary>
            public const string MSG_0634 = "0634";
            /// <summary>
            /// 동영상을 업데이트 중입니다.
            /// </summary>
            public const string MSG_0635 = "0635";
            /// <summary>
            /// 이미지를 업데이트 중 입니다.
            /// </summary>
            public const string MSG_0636 = "0636";
            /// <summary>
            /// 보류 저장 가능 횟수가 초과 되었습니다.
            /// </summary>
            public const string MSG_0637 = "0637";
            /// <summary>
            /// 해피오더 거래데이터 생성 실패
            /// </summary>
            public const string MSG_0638 = "0638";
            /// <summary>
            /// 예약 완료 거래에서는 등록 할 수 없습니다.
            /// </summary>
            public const string MSG_0639 = "0639";
            /// <summary>
            /// 영수증 프린터를 초기화 하였습니다.
            /// </summary>
            public const string MSG_0640 = "0640";
            /// <summary>
            /// 예약 완료 등록을 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0641 = "0641";
            /// <summary>
            /// 주방프린터로 주문서 출력에 실패 하였습니다.
            /// 영수증프린터로 주문서를 출력 하시겠습니까?
            /// </summary>
            public const string MSG_0642 = "0642";
            /// <summary>
            /// 주방프린터 전원 및 용지를 확인 하여 주십시오. 
            /// </summary>
            public const string MSG_0643 = "0643";
            /// <summary>
            /// 테이블그룹 되어 있습니다. 이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0644 = "0644";
            /// <summary>
            /// 테이블그룹 되어 있습니다. 합석 할 수 없습니다.
            /// </summary>
            public const string MSG_0645 = "0645";      
            /// <summary>
            /// 식권번호를 정확히 입력하여 주십시요.
            /// </summary>
            public const string MSG_0646 = "0646";
            /// <summary>
            /// X-CHARGE XCTransaction2.dll 이 없습니다. 카드 승인 할 수 없습니다. 관리자에게 문의 하세요.
            /// </summary>
            public const string MSG_0647 = "0647";
            /// <summary>
            /// 기존 케익교환권을 결제 취소후 등록 하세요.
            /// </summary>
            public const string MSG_0648 = "0648";
            /// <summary>
            /// 해피기프트 카드 입니다
            /// </summary>
            public const string MSG_0649 = "0649";
            /// <summary>
            /// 백신 실행에 실패하였습니다.
            /// </summary>
            public const string MSG_0650 = "0650";
            /// <summary>
            /// POS 프로그램을 종료 하시겠습니까?
            /// </summary>
            public const string MSG_0651 = "0651";
            /// <summary>
            /// {0} 입니다. \r\n 여기서 드시겠어요? 가지고 가시겠어요?
            /// </summary>
            public const string MSG_0652 = "0652";
            /// <summary>
            /// {0} : {1} ℃ \r\n[정상] 상태입니다.
            /// </summary>
            public const string MSG_0653 = "0653";
            /// <summary>
            /// {0} : {1} ℃ \r\n[미수신] 상태입니다. 확인바랍니다.
            /// </summary>
            public const string MSG_0654 = "0654";
            /// <summary>
            /// {0} : {1} ℃ \r\n[알람] 상태입니다. 확인바랍니다.
            /// </summary>
            public const string MSG_0655 = "0655";
            /// <summary>
            /// {0} : {1} ℃ \r\n[경고] 상태입니다. 확인바랍니다.
            /// </summary>
            public const string MSG_0656 = "0656";
            /// <summary>
            /// 온도 정보가 없습니다.
            /// </summary>
            public const string MSG_0657 = "0657";
            /// <summary>
            /// 해당 캠페인은 마감(완료) 되었습니다
            /// </summary>
            public const string MSG_0658 = "0658";
            /// <summary>
            /// 디스크 용량이 부족합니다. 확인하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0659 = "0659";
            /// <summary>
            /// 이전 처리가 완료되었습니다.
            /// </summary>
            public const string MSG_0660 = "0660";
            /// <summary>
            /// 삼성페이 미 사용으로 승인 받을 수 없습니다.
            /// 사용하시려면 POS 옵션(OPT203)을 수정하세요.
            /// </summary>
            public const string MSG_0661 = "0661";
            /// <summary>
            /// 등록된 제품교환권을 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0662 = "0662";
            /// <summary>
            /// 메인POS 개점 후 주문POS 개점이 가능 합니다.
            /// </summary>
            public const string MSG_0663 = "0663";
            /// <summary>
            /// 할인 대상 금액이 없습니다.
            /// 신용카드 승인 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0664 = "0664";
            /// <summary>
            /// 부가메뉴는 상품메모 및 FIRE KEY를 등록 할 수 없습니다.
            /// </summary>
            public const string MSG_0665 = "0665";
            /// <summary>
            /// 주방출력대상이 아닌 상품은 상품메모 및 FIRE KEY를 등록 할 수 없습니다.
            /// </summary>
            public const string MSG_0666 = "0666";
            /// <summary>
            /// 주문데이터가 존재하여 층/테이블 정보를 변경 할 수 없습니다.
            /// </summary>
            public const string MSG_0667 = "0667";
            /// <summary>
            /// 주문POS는 테이블 편집 기능을 사용 할 수 없습니다.
            /// </summary>
            public const string MSG_0668 = "0668";
            /// <summary>
            /// 이미 할인이 등록되어 있습니다. 중복 불가 합니다
            /// </summary>
            public const string MSG_0669 = "0669";
            /// <summary>
            /// 테이블 주문 내역이 {0}건 있습니다. 업무마감을 진행 하시겠습니까?
            /// </summary>
            public const string MSG_0670 = "0670";
            /// <summary>
            /// 테이블 주문 내역이 {0}건 있습니다. 주문 내역을 확인 하시겠습니까?
            /// </summary>
            public const string MSG_0671 = "0671";
            /// <summary>
            /// 펌웨어 파일을 업데이트 중 입니다.
            /// </summary>
            public const string MSG_0672 = "0672";
            /// <summary>
            /// 생년을 입력하세요.
            /// </summary>
            public const string MSG_0673 = "0673";
            /// <summary>
            /// 생년을 확인하세요.
            /// </summary>
            public const string MSG_0674 = "0674";
            /// <summary>
            /// 주문 변경 내역이 존재합니다. 그래도 종료 하시겠습니까?
            /// </summary>
            public const string MSG_0675 = "0675";
            /// <summary>
            /// 등록된 URL정보가 없습니다. 마스터 확인 요망!
            /// </summary>
            public const string MSG_0676 = "0676";
            /// <summary>
            /// 취소 할 대기번호가 없습니다.
            /// </summary>
            public const string MSG_0677 = "0677";
            /// <summary>
            /// 메인POS 정보가 변경 되었습니다.\n메인POS를 재시작 후 실행하여 주십시오.
            /// </summary>
            public const string MSG_0678 = "0678";
            /// <summary>
            /// 주방프린터와 주방모니터를 동시에 사용 할 수 없습니다. 점포 옵션 마스터를 확인하여 주십시오.
            /// </summary>
            public const string MSG_0679 = "0679";
            /// <summary>
            /// 할인이 적용된 상품이 있습니다. 묶음 적용시 모든 할인은 취소됩니다.  묶음 적용을 하시겠습니까?
            /// </summary>
            public const string MSG_0680 = "0680";
            /// <summary>
            /// 할인이 적용되어 있는 상품은 전체 이동만 가능합니다.
            /// 전체 이동 하시겠습니까?
            /// </summary>
            public const string MSG_0681 = "0681";
            /// <summary>
            /// CAT단말기로 승인 처리해 주세요.
            /// </summary>
            public const string MSG_0682 = "0682";
            /// <summary>
            /// 전화번호는 숫자만 가능합니다.
            /// </summary>
            public const string MSG_0683 = "0683";
            /// <summary>
            /// 소계할인된 다른 상품도 할인 취소가 됩니다.
            /// 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0684 = "0684";
            /// <summary>
            /// 묶음할인이 적용된 상품입니다. 취소시 동일 묶음할인은 취소됩니다.
            /// 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0685 = "0685";
            /// <summary>
            /// 상품메모가 등록된 상품은 전체 이동만 가능합니다. 전체 이동 하시겠습니까?
            /// </summary>
            public const string MSG_0686 = "0686";
            /// <summary>
            /// 하위구성품이 등록된 상품은 전체 이동만 가능합니다. 전체 이동 하시겠습니까?
            /// </summary>
            public const string MSG_0687 = "0687";
            /// <summary>
            /// 소계할인 적용된 상품은 메뉴이동 할 수 없습니다.
            /// </summary>
            public const string MSG_0688 = "0688";
            /// <summary>
            /// 미인증 버튼은 인터넷 장애시 사용하시고\n 반드시 웹POS 추후 승인하셔야 합니다.
            /// </summary>
            public const string MSG_0689 = "0689";
            /// <summary>
            /// 해피포인트적립안내 {0}고객님 {1}포인트 적립되었습니다
            /// </summary>
            public const string MSG_0690 = "0690";
            /// <summary>
            /// 프린터 커버 또는 용지를 확인해 주십시요.
            /// </summary>
            public const string MSG_0691 = "0691";
            /// <summary>
            /// 거래 중 오류가 발생하였습니다. 재시도 하시겠습니까?
            /// </summary>
            public const string MSG_0692 = "0692";
            /// <summary>
            /// 캐시비 고객센터(1588-8990 / 1644-0006)로 문의하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0693 = "0693";
            /// <summary>
            /// 한국스마트카드 고객센터(1644-0088)로 문의하여 주시기 바랍니다.
            /// </summary>
            public const string MSG_0694 = "0694";
            /// <summary>
            /// 배달(요기요) 거래를 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0695 = "0695";
            /// <summary>
            /// {1}년 6월 30일 영업시간 종료 후 {1}포인트(전일기준) 실효 에정입니다.
            /// </summary>
            public const string MSG_0696 = "0696";
            /// <summary>
            /// 제조기사는 바코드를 입력하세요
            /// </summary>
            public const string MSG_0697 = "0697";
            //17.05.18 dkshin 쇼킹박스 추가
            /// <summary>
            /// 쇼킹박스 상품은 변경할 수 없습니다.
            /// </summary>
            public const string MSG_0698 = "0698";
            /// <summary>
            /// 쇼킹박스 상품은 건별 결제하세요.
            /// </summary>
            public const string MSG_0699 = "0699";
            /// <summary>
            /// 연습모드에서의 매출은 실제 매출이 아닙니다.\n(신용카드 승인 및 포인트카드 적립/사용불가)
            /// </summary>
            public const string MSG_0700 = "0700";
            // 제휴카드(통합) 할인 처리(2017.08.29) -- START
            /// <summary>
            /// 제휴할인 종류를 선택 하여 주세요.
            /// </summary>
            public const string MSG_0701 = "0701";
            // 제휴카드(통합) 할인 처리(2017.08.29) -- END

            //#20171016 IC리더기 펌웨어 업데이트 Start, srlee
            /// <summary>
            /// IC리더기에 업그레이드 자료가 있습니다. 진행하시겠습니까?
            /// </summary>
            public const string MSG_0702 = "0702";
            /// <summary>
            /// IC리더기 업데이트 파일이 없습니다.
            /// </summary>
            public const string MSG_0703 = "0703";
            /// <summary>
            /// IC리더기 펌웨어가 업그레이드 되었습니다.
            /// </summary>
            public const string MSG_0704 = "0704";
            /// <summary>
            /// -1 : 포트 열기 실패
            /// </summary>
            public const string MSG_0705 = "0705";
            /// <summary>
            /// -2 : PW 체크 실패
            /// </summary>
            public const string MSG_0706 = "0706";
            /// <summary>
            /// -3 : 리더기 버전 조회 실패
            /// </summary>
            public const string MSG_0707 = "0707";
            /// <summary>
            /// -4 : VAN정보 조회 실패
            /// </summary>
            public const string MSG_0708 = "0708";
            /// <summary>
            /// -5 : VAN 정보 불일치
            /// </summary>
            public const string MSG_0709 = "0709";
            /// <summary>
            /// -6 : 전송할 파일 없음(파일path 에러)
            /// </summary>
            public const string MSG_0710 = "0710";
            /// <summary>
            /// -7 : 듀얼아이 단말기가 아니거나 버전이 잘못 설정되어 있음
            /// </summary>
            public const string MSG_0711 = "0711";
            /// <summary>
            /// -10 : 633C리더기가 아닌데 633C FW 다운시도
            /// </summary>
            public const string MSG_0712 = "0712";
            /// <summary>
            /// -11 : 633D리더기가 아닌데 633D FW 다운시도
            /// </summary>
            public const string MSG_0713 = "0713";
            /// <summary>
            /// -12 : 635리더기가 아닌데 635 FW 다운시도
            /// </summary>
            public const string MSG_0714 = "0714";
            /// <summary>
            /// -13 : 리더기 인증 시 첫 번째 절차에러(FW 다운로드하기 위한 상호 인증 실패)
            /// </summary>
            public const string MSG_0715 = "0715";
            /// <summary>
            /// -14 : 리더기 인증 시 두 번째 절차에러(FW 다운로드하기 위한 상호 인증 실패)
            /// </summary>
            public const string MSG_0716 = "0716";
            /// <summary>
            /// -15 : 리더기 인증 시 세 번째 절차에러(FW 다운로드하기 위한 상호 인증 실패)
            /// </summary>
            public const string MSG_0717 = "0717";
            /// <summary>
            /// -16 : 바이오스 모드 인증 실패(FW 다운로드하기 위한 상호 인증 실패)
            /// </summary>
            public const string MSG_0718 = "0718";
            /// <summary>
            /// -17 : FW 파일로드 실패
            /// </summary>
            public const string MSG_0719 = "0719";
            /// <summary>
            /// -18 : FW 파일 다운로드 중 실패
            /// </summary>
            public const string MSG_0720 = "0720";
            /// <summary>
            /// -19 : FW 파일 다운로드 종료 실패
            /// </summary>
            public const string MSG_0721 = "0721";
            /// <summary>
            /// -20 : FW 파일 다운로드 후 버전 조회 실패
            /// </summary>
            public const string MSG_0722 = "0722";
            /// <summary>
            /// 1003 : 단말기에서 응답 없음 (포트 입력 오류 또는 단말기 고장)
            /// </summary>
            public const string MSG_0723 = "0723";
            /// <summary>
            /// 리더기에서 명령어 처리 못함
            /// </summary>
            public const string MSG_0724 = "0724";
            /// <summary>
            /// IC리더기 펌웨어 업그레이드 실패. 포스 고객상담실로 문의하세요.
            /// </summary>
            public const string MSG_0725 = "0725";
            //#20171016 IC리더기 펌웨어 업데이트 End, srlee

            //#20170904 IC_MSG_CARD, RF_MSG_CARD 문구 추가 start
            /// <summary>
            /// 카드를 읽혀주세요\n※메시지 클릭 시 종료됩니다.
            /// </summary>
            public const string MSG_0726 = "0726";
            /// <summary>
            /// 후불 카드를 대주십시요\n※메시지 클릭 시 종료됩니다.
            /// </summary>
            public const string MSG_0727 = "0727";
            //#20170904 IC_MSG_CARD, RF_MSG_CARD 문구 추가 end

            /// <summary>
            /// 영수증 반품 후 해피오더 고객센터(1670-3131)로 접수하셔서 전화취소 하셔야 합니다.
            /// 반품 하시겠습니까?
            /// </summary>
            public const string MSG_0728 = "0728";

            //#20170906 T페이 고도화 작업 phj, start

            /// <summary>
            /// 유효하지 않은 OTB 입니다
            /// </summary>
            public const string MSG_0729 = "0729";
   
            /// <summary>
            /// 구버전의 OTB 입니다
            /// </summary>
            public const string MSG_0730 = "0730";
          
            /// <summary>
            /// 통합결제만 가능 합니다(결제비밀번호 필수)
            /// </summary>
            public const string MSG_0731 = "0731";
      
            /// <summary>
            /// 통합결제만 가능 합니다(결제비밀번호 불필요)
            /// </summary>
            public const string MSG_0732 = "0732";
            
            /// <summary>
            /// 일반결제만 가능 합니다(결제비밀번호 필수)
            /// </summary>
            public const string MSG_0733 = "0733";
        
            /// <summary>
            /// 일반결제만 가능 합니다(결제비밀번호 불필요)
            /// </summary>
            public const string MSG_0734 = "0734";
            
            /// <summary>
            /// 해당응답코드없음
            /// </summary>
            public const string MSG_0735 = "0735";

            //#20170906 T페이 고도화 작업 phj, end

            //20171013 dkshin 해피기프트(신) IC/RF 충전 및 승인
            /// <summary>
            /// 개시되었습니다.
            /// </summary>
            public const string MSG_0736 = "0736";

            //#20170926 일반할인 존재하고 모바일 쿠폰 사용 시 팝업 오픈 start
            /// <summary>
            /// 일반 할인 내역이 있습니다.
            /// 모바일 쿠폰을 사용하시겠습니까?
            /// (기타 제휴 할인/적립 적용시 모바일쿠폰 사용불가)
            /// </summary>
            public const string MSG_0737 = "0737";
            //#20170926 일반할인 존재하고 모바일 쿠폰 사용 시 팝업 오픈 end

            //#20171016 스퀘어 점포일 때 실점포 코드로 넘기기 start, phj
            /// <summary>
            /// 한 종류의 브랜드 제품만 선택 시 사용할 수 있습니다.
            /// </summary>
            public const string MSG_0738 = "0738";
            //#20171016 스퀘어 점포일 때 실점포 코드로 넘기기 end, phj

            //#20171018 상품등록 유통기한 체크하기 start, phj
            /// <summary>
            /// 유통기한이 경과된 상품입니다.
            /// </summary>
            public const string MSG_0739 = "0739";
            //#20171018 상품등록 유통기한 체크하기 end, phj


            //#12500 해피포인트 실효정책 변경에 따른 프로그램 수정 start, phj
            /// <summary>
            /// {0}년 12월 31일 영업시간 종료 후 {1}포인트(전일기준) 실효 예정입니다. 고객님께 사용 안내해주세요
            /// </summary>
            public const string MSG_0740 = "0740";
            //#12500 해피포인트 실효정책 변경에 따른 프로그램 수정 end, phj


            //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 start, phj
            /// <summary>
            /// 해당 쿠폰은 사용할 수 없습니다.
            /// </summary>
            public const string MSG_0741 = "0741";
            //#20171116 온라인 쿠폰 제품군코드,상품코드 존재 시 할인 대상이 변경되도록 추가 end, phj

            /// <summary>
            /// 카드 등록이 되었습니다.
            /// </summary>
            public const string MSG_0742 = "0742";

            /// <summary>
            /// 카드가 삭제 되었습니다.
            /// </summary>
            public const string MSG_0743 = "0743";
        
            //#20171201, 해피기프트(신) 수정 Start
            /// <summary>
            /// 카드번호가 초기화 됩니다.
            /// </summary>
            public const string MSG_0744 = "0744";
            //#20171201, 해피기프트(신) 수정 End

            //#20171227 인천공항 포스연동 start, phj
            /// <summary>
            /// 인천공항 연동POS 입니다. 사용할 수 없습니다.
            /// </summary>
            public const string MSG_0745 = "0745";// 0745 - 인천공항 연동POS 입니다. 사용할 수 없습니다. 
            /// <summary>
            /// 인천공항 통합POS 연동 정보가 없습니다.
            /// </summary>
            public const string MSG_0746 = "0746";// 0746 - 인천공항 통합POS 연동 정보가 없습니다.
            /// <summary>
            /// 인천공항 통합POS DB 연결 실패했습니다.
            /// </summary>
            public const string MSG_0747 = "0747";// 0747 - 인천공항 통합POS DB 연결 실패했습니다.
            /// <summary>
            /// 통합POS 상품전송 성공!
            /// </summary>
            public const string MSG_0748 = "0748";// 0748 - 통합POS 상품전송 성공!
            /// <summary>
            /// 통합POS 상품전송 실패!
            /// </summary>
            public const string MSG_0749 = "0749";// 0749 - 통합POS 상품전송 실패!
            /// <summary>
            /// 통합POS 결제 리스트 전송 성공!
            /// </summary>
            public const string MSG_0750 = "0750";// 0750 - 통합POS 결제 리스트 전송 성공!
            /// <summary>
            /// 통합POS 결제 리스트 전송 실패!
            /// </summary>
            public const string MSG_0751 = "0751";// 0751 - 통합POS 결제 리스트 전송 실패!
            /// <summary>
            /// 통합POS 상품전송 실패! 통합POS 일괄취소 후 진행 해주세요.
            /// </summary>
            public const string MSG_0752 = "0752";// 0752 - 통합POS 상품전송 실패! 통합POS 일괄취소 후 진행 해주세요.
            /// <summary>
            /// 현금/수표/외화/카드 결제 건이 있기 때문에 결제 내역을 가져올 수 없습니다.
            /// </summary>
            public const string MSG_0753 = "0753";// 0753 - 현금/수표/외화/카드 결제 건이 있기 때문에 결제 내역을 가져올 수 없습니다.
            /// <summary>
            /// 판매포스의 판매금액과 통합포스의 결제금액이 같지 않습니다.
            /// </summary>
            public const string MSG_0754 = "0754";// 0754 - 판매포스의 판매금액과 통합포스의 결제금액이 같지 않습니다.
            /// <summary>
            /// 통합포스의 결제 데이터가 없습니다.
            /// </summary>
            public const string MSG_0755 = "0755";// 0755 - 통합포스의 결제 데이터가 없습니다.
            /// <summary>
            /// 판매금액과 반품금액이 맞지 않습니다.
            /// </summary>
            public const string MSG_0756 = "0756";// 0756 - 판매금액과 반품금액이 맞지 않습니다.
            /// <summary>
            /// 통합포스의 반품 데이터가 없습니다.
            /// </summary>
            public const string MSG_0757 = "0757";// 0757 - 통합포스의 반품 데이터가 없습니다.
            /// <summary>
            /// 통합POS의 마감 되었습니다.
            /// </summary>
            public const string MSG_0758 = "0758";// 0758 - 통합POS의 마감 되었습니다.
            /// <summary>
            /// 통합POS의 개점일자가 다릅니다.
            /// </summary>
            public const string MSG_0759 = "0759";// 0759 - 통합POS의 개점일자가 다릅니다.
            /// <summary>
            /// 통합POS에서 결제 대기 중 입니다.
            /// </summary>
            public const string MSG_0760 = "0760";// 0760 - 통합POS에서 결제 대기 중 입니다.
            /// <summary>
            /// 통합POS에서 이미 결제완료 되었습니다.
            /// </summary>
            public const string MSG_0761 = "0761";// 0761 - 통합POS에서 이미 결제완료 되었습니다.
            /// <summary>
            /// 통합POS에서 결제 완료되지 않았습니다.
            /// </summary>
            public const string MSG_0762 = "0762";// 0762 - 통합POS에서 결제 완료되지 않았습니다.
            /// <summary>
            /// 통합POS에서 일괄취소가 되지 않았습니다.
            /// </summary>
            public const string MSG_0763 = "0763";// 0763 - 통합POS에서 일괄취소가 되지 않았습니다.
            /// <summary>
            /// 통합POS에서 반품되지 않은 영수증 입니다.
            /// </summary>
            public const string MSG_0764 = "0764";// 0764 - 통합POS에서 반품되지 않은 영수증 입니다.
            /// <summary>
            /// 인천공항 사용 점포가 아닙니다.  
            /// </summary>
            public const string MSG_0765 = "0765";// 0765 - 통합포스의 반품 데이터가 없습니다.
            //#20171227 인천공항 포스연동 end, phj

            //#13341 신용카드 할부 개월 수 제한 기능 적용 start, phj
            /// <summary>
            /// 신용카드 할부개월수는 {0}까지 입력가능합니다
            /// </summary>
            public const string MSG_0766 = "0766";
            //#13341 신용카드 할부 개월 수 제한 기능 적용 end, phj

            //#13342 개점/마감시간 허용 시간 제한 start, phj
            /// <summary>
            /// {0} 익일개점 허용시간 이 후 가능합니다. 
            /// </summary>
            public const string MSG_0767 = "0767";
            //#13342 개점/마감시간 허용 시간 제한 end, phj

            //#13342 개점/마감시간 허용 시간 제한 start, phj
            /// <summary>
            /// {0} 이 후 개점 가능합니다. 
            /// </summary>
            public const string MSG_0768 = "0768";
            //#13342 개점/마감시간 허용 시간 제한 end, phj
            //#Rhee, 20180117 픽업 진행 추가 start
            /// <summary>
            /// 픽업완료 진행을 하시겠습니까?. 
            /// </summary>
            public const string MSG_0769 = "0769";
            //#Rhee, 20180117 픽업 진행 추가 end

            //#20180213 인천공항 빌 번호 체크 start,phj
            /// <summary>
            /// 인천공항 빌 번호 체크 실패
            /// </summary>
            public const string MSG_0770 = "0770";
            //#20180213 인천공항 빌 번호 체크 end,phj


            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
            /// <summary>
            /// 제휴코드 값을 가져오지 못했습니다.
            /// </summary>
            public const string MSG_0772 = "0772";
            //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END


            //#20180322 휴게소pos매출연동 start,phj
            /// <summary>
            /// 환경설정에서 기본정보를 설정 해주세요.
            /// </summary>
            public const string MSG_0771 = "0771"; 
            //#20180322 휴게소pos매출연동 end,phj

            //#20180322 휴게소pos매출연동 start,phj
            /// <summary>
            /// 진행하시겠습니까?
            /// </summary>
            public const string MSG_0773 = "0773"; 
            //#20180322 휴게소pos매출연동 end,phj

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start
            /// <summary>
            /// 쿠폰을 선택 해주세요.
            /// </summary>
            public const string MSG_0782 = "0782";

            /// <summary>
            /// 쿠폰 발송중입니다.
            /// </summary>
            public const string MSG_0783 = "0783";

            /// <summary>
            /// 쿠폰 발송이 완료되었습니다.
            /// </summary>
            public const string MSG_0784 = "0784";

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start, 20180508
            //[쿠폰발송] 버튼 클릭시 '쿠폰발송 기능은 추후 오픈 예정입니다.' 팝업 출력
            /// <summary>
            /// 쿠폰발송 기능은 추후 오픈 예정입니다.
            /// </summary>
            public const string MSG_0785 = "0785";
            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end, 20180508

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start, 20180510
            
            /// <summary>
            /// 해피콕 동의 점포만 쿠폰발송이 가능합니다. 담당SV에게 문의바랍니다.
            /// </summary>
            public const string MSG_0786 = "0786";

            /// <summary>
            /// 쿠폰발송기능 활성화 처리 후 사용 가능합니다. 웹POS 점포마스터 수정화면에서 수정 후 마스터 재수신 바랍니다.
            /// </summary>
            public const string MSG_0787 = "0787";

            /// <summary>
            /// 해피콕 단골고객이 아닙니다.
            /// </summary>
            public const string MSG_0788 = "0788";
            
            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end, 20180510

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start, 20180528
            //쿠폰 발송 횟수 제한 기능
            /// <summary>
            /// 일 발송횟수 {0} 회를 초과하여, 쿠폰발송이 불가합니다. 발송 가능 횟수는 웹POS [고객 구매이력 조회설정]에서 변경 가능합니다.
            /// </summary>
            public const string MSG_0789 = "0789";
            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end, 20180528

            //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end


            //#20180413 웰컴카드 신규기능 추가 start,phj
            /// <summary>
            /// 멤버십 발급/할인 기능을 사용할 수 없습니다. 옵션을 확인하세요.
            /// </summary>
            public const string MSG_0790 = "0790";
            //#20180413 웰컴카드 신규기능 추가 end,phj


            //#20180611 해피오더 주문취소 사유 start
            /// <summary>
            /// 주문 취소 사유를 입력해주세요.
            /// </summary>
            public const string MSG_0791 = "0791";
            //#20180611 해피오더 주문취소 사유 end

            /////////////////////////////////
            //#20180618_웰컴카드 수정_grayber
            /// <summary>
            /// 이미 할인이 적용되어 있습니다. 등록 불가합니다.
            /// </summary>
            public const string MSG_0792 = "0792";
            /////////////////////////////////


            //#20180413 웰컴카드 신규기능 추가 start, 20180621
            /// <summary>
            /// 해피APP고객등록 할 수 없습니다. 해피포인트 정보를 확인해주세요.
            /// </summary>
            public const string MSG_0793 = "0793";
            //#20180413 웰컴카드 신규기능 추가 end, 20180621

            //#15897 요청)점포생산제품 바코드 출력기능 수정요청 start
            /// <summary>
            /// 바코드 체크값이 맞지 않습니다.
            /// </summary>
            public const string MSG_0794 = "0794";
            //#15897 요청)점포생산제품 바코드 출력기능 수정요청 end

            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start
            /// <summary>
            /// 바코드 정보가 없습니다.
            /// </summary>
            public const string MSG_0795 = "0795";
            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end 

            //#15583 캠페인 기능 개선 요청 start
            /// <summary>
            /// 캠페인이 적용되어 있습니다. 중복 불가합니다.
            /// </summary>
            public const string MSG_0796 = "0796";
            //#15583 캠페인 기능 개선 요청 end

            //#15881 배달건 취소버튼 클릭 시 메세지 추가 start
            /// <summary>
            /// 해당 건은 고객이 배달요청한 주문으로 배달요청 시 배달업체가 점포로 방문합니다.
            /// 취소 하시겠습니까?
            /// </summary>
            public const string MSG_0797 = "0797";
            //#15881 배달건 취소버튼 클릭 시 메세지 추가 end

            //#16401 해피오더)주문내역 바코드 리딩 시 자동 완료처리 start

            /// <summary>
            /// 픽업완료 처리를 하시겠습니까?
            /// </summary>
            public const string MSG_0798 = "0798";

            /// <summary>
            /// 배달 중 처리를 하시겠습니까?
            /// </summary>
            public const string MSG_0799 = "0799";

            //#16401 해피오더)주문내역 바코드 리딩 시 자동 완료처리 end

            //#16577 결제창 내부 봉투 추가 기능 도입 start
            /// <summary>
            /// 사용 가능한 상품이 없습니다.
            /// </summary>
            public const string MSG_0800 = "0800";

            /// <summary>
            /// 결제 중 처리 할 수 없는 기능입니다., MSG2: 결제 취소 후 등록 해주세요.
            /// </summary>
            public const string MSG_0801 = "0801";

            /// <summary>
            /// 정상적으로 처리 되었습니다.
            /// </summary>
            public const string MSG_0802 = "0802";

            /// <summary>
            /// 처리 실패 하였습니다.
            /// </summary>
            public const string MSG_0803 = "0803";

            //#16577 결제창 내부 봉투 추가 기능 도입 start, 20180920
            /// <summary>
            /// 적용된 봉투 상품을 일괄 삭제 후 등록 하시겠습니까?
            /// </summary>
            public const string MSG_0804 = "0804";
            //#16577 결제창 내부 봉투 추가 기능 도입 end, 20180920

            //#16577 결제창 내부 봉투 추가 기능 도입 end

            //#17045 긴급)판매POS 대기 시 해피오더 안내 이미지 표시 start
            /// <summary>
            /// 화면 터치 시 판매등록 화면으로 전환됩니다
            /// </summary>
            public const string MSG_0805 = "0805";
            //#17045 긴급)판매POS 대기 시 해피오더 안내 이미지 표시 end

            //#14941 스마트영수증 대상고객 안내기능 도입 start
            /// <summary>
            /// 스마트영수증 신청 고객입니다.고객님의 해피앱에서 영수증을 확인하실 수 있습니다. 
            /// </summary>
            public const string MSG_0806 = "0806";
            //#14941 스마트영수증 대상고객 안내기능 도입 end
      }
        #endregion

        #region ** 영수증 **
        /// <summary>
        /// 영수증
        /// </summary>
        public class PRINT
        {
            /// <summary>
            /// [정상]
            /// </summary>
            public const string MSG_0001 = "0001";
            /// <summary>
            /// [반품]
            /// </summary>
            public const string MSG_0002 = "0002";
            /// <summary>
            /// 소     계
            /// </summary>
            public const string MSG_0003 = "0003";
            /// <summary>
            /// 면세금액
            /// </summary>
            public const string MSG_0004 = "0004";
            /// <summary>
            /// 과세금액
            /// </summary>
            public const string MSG_0005 = "0005";
            /// <summary>
            /// 부 가 세
            /// </summary>
            public const string MSG_0006 = "0006";
            /// <summary>
            /// 총매출액
            /// </summary>
            public const string MSG_0007 = "0007";
            /// <summary>
            /// 상품할인금액
            /// </summary>
            public const string MSG_0008 = "0008";
            /// <summary>
            /// 소계할인금액
            /// </summary>
            public const string MSG_0009 = "0009";
            /// <summary>
            /// 합계금액
            /// </summary>
            public const string MSG_0010 = "0010";
            /// <summary>
            /// 담당자
            /// </summary>
            public const string MSG_0011 = "0011";
            /// <summary>
            /// 거스름
            /// </summary>
            public const string MSG_0012 = "0012";
            /// <summary>
            /// 현금       
            /// </summary>
            public const string MSG_0013 = "0013";
            /// <summary>
            /// 해피포인트 적립
            /// </summary>
            public const string MSG_0014 = "0014";
            /// <summary>
            /// 적립/추가/잔여
            /// </summary>
            public const string MSG_0015 = "0015";
            /// <summary>
            /// HPY[APP] 적립
            /// </summary>
            public const string MSG_0016 = "0016";
            /// <summary>
            /// 소멸예정포인트
            /// </summary>
            public const string MSG_0017 = "0017";
            /// <summary>
            /// 받은금액
            /// </summary>
            public const string MSG_0018 = "0018";
            /// <summary>
            /// [고객불편사항]
            /// </summary>
            public const string MSG_0019 = "0019";
            /// <summary>
            /// [접수번호]
            /// </summary>
            public const string MSG_0020 = "0020";
            /// <summary>
            /// [고객정보]
            /// </summary>
            public const string MSG_0021 = "0021";
            /// <summary>
            /// 이    름
            /// </summary>
            public const string MSG_0022 = "0022";
            /// <summary>
            /// 성 별
            /// </summary>
            public const string MSG_0023 = "0023";
            /// <summary>
            /// 연 락 처
            /// </summary>
            public const string MSG_0024 = "0024";
            /// <summary>
            /// [제품정보]
            /// </summary>
            public const string MSG_0025 = "0025";
            /// <summary>
            /// 대표제품
            /// </summary>
            public const string MSG_0026 = "0026";
            /// <summary>
            /// 실구입일
            /// </summary>
            public const string MSG_0027 = "0027";
            /// <summary>
            /// LOT 번호
            /// </summary>
            public const string MSG_0028 = "0028";
            /// <summary>
            /// [고객처리사항]
            /// </summary>
            public const string MSG_0029 = "0029";
            /// <summary>
            /// 처리구분
            /// </summary>
            public const string MSG_0030 = "0030";
            /// <summary>
            /// 처리비용
            /// </summary>
            public const string MSG_0031 = "0031";
            /// <summary>
            /// 처리내용
            /// </summary>
            public const string MSG_0032 = "0032";
            /// <summary>
            /// [연습 영수증]
            /// </summary>
            public const string MSG_0033 = "0033";
            /// <summary>
            /// ---- 영 수 증  재 발 행 ----
            /// </summary>
            public const string MSG_0034 = "0034";
            /// <summary>
            /// ---- 연습 영수증 입니다. ----
            /// </summary>
            public const string MSG_0035 = "0035";
            /// <summary>
            /// 일시불
            /// </summary>
            public const string MSG_0036 = "0036";
            /// <summary>
            /// 개월
            /// </summary>
            public const string MSG_0037 = "0037";
            /// <summary>
            /// 현금영수증
            /// </summary>
            public const string MSG_0038 = "0038";
            /// <summary>
            /// 자진발급
            /// </summary>
            public const string MSG_0039 = "0039";
            /// <summary>
            /// 문의:☎126-2    http://현금영수증.kr
            /// </summary>
            public const string MSG_0040 = "0040";
            /// <summary>
            /// [현금 (소득공제)]
            /// </summary>
            public const string MSG_0041 = "0041";
            /// <summary>
            /// [현금 (지출증빙)]
            /// </summary>
            public const string MSG_0042 = "0042";
            /// <summary>
            /// 카드번호
            /// </summary>
            public const string MSG_0043 = "0043";
            /// <summary>
            /// 카드사명
            /// </summary>
            public const string MSG_0044 = "0044";
            /// <summary>
            /// 할부개월
            /// </summary>
            public const string MSG_0045 = "0045";
            /// <summary>
            /// 결제금액
            /// </summary>
            public const string MSG_0046 = "0046";
            /// <summary>
            /// 승인번호
            /// </summary>
            public const string MSG_0047 = "0047";
            /// <summary>
            /// 가맹점번호
            /// </summary>
            public const string MSG_0048 = "0048";
            /// <summary>
            /// 사용포인트
            /// </summary>
            public const string MSG_0049 = "0049";
            /// <summary>
            /// 잔여포인트
            /// </summary>
            public const string MSG_0050 = "0050";
            /// <summary>
            /// 적립포인트
            /// </summary>
            public const string MSG_0051 = "0051";
            /// <summary>
            /// 추가포인트
            /// </summary>
            public const string MSG_0052 = "0052";
            /// <summary>
            /// 현금(수표)
            /// </summary>
            public const string MSG_0053 = "0053";
            /// <summary>
            /// 예약선금
            /// </summary>
            public const string MSG_0054 = "0054";
            /// <summary>
            /// 예약잔금
            /// </summary>
            public const string MSG_0055 = "0055";
            /// <summary>
            /// 쿠폰번호
            /// </summary>
            public const string MSG_0056 = "0056";
            /// <summary>
            /// 종료일자
            /// </summary>
            public const string MSG_0057 = "0057";
            /// <summary>
            /// 해피포인트추후적립
            /// </summary>
            public const string MSG_0058 = "0058";
            /// <summary>
            /// 원거래 정보
            /// </summary>
            public const string MSG_0059 = "0059";
            /// <summary>
            /// 해피기프트 (충전)
            /// </summary>
            public const string MSG_0060 = "0060";
            /// <summary>
            /// 해피기프트 (충전취소)
            /// </summary>
            public const string MSG_0061 = "0061";
            /// <summary>
            /// 해피기프트 (환불)
            /// </summary>
            public const string MSG_0062 = "0062";
            /// <summary>
            /// 해피기프트 (환불취소)
            /// </summary>
            public const string MSG_0063 = "0063";
            /// <summary>
            /// 확인증
            /// </summary>
            public const string MSG_0064 = "0064";
            /// <summary>
            /// 충전번호
            /// </summary>
            public const string MSG_0065 = "0065";
            /// <summary>
            /// 취소번호
            /// </summary>
            public const string MSG_0066 = "0066";
            /// <summary>
            /// 유효기간
            /// </summary>
            public const string MSG_0067 = "0067";
            /// <summary>
            /// 충전금액
            /// </summary>
            public const string MSG_0068 = "0068";
            /// <summary>
            /// 취소금액
            /// </summary>
            public const string MSG_0069 = "0069";
            /// <summary>
            /// 잔액
            /// </summary>
            public const string MSG_0070 = "0070";
            /// <summary>
            /// 해피포인트 조회
            /// </summary>
            public const string MSG_0071 = "0071";
            /// <summary>
            /// 발행일자
            /// </summary>
            public const string MSG_0072 = "0072";
            /// <summary>
            /// 응모번호
            /// </summary>
            public const string MSG_0073 = "0073";
            /// <summary>
            /// 가용포인트
            /// </summary>
            public const string MSG_0074 = "0074";
            /// <summary>
            /// 조회일자
            /// </summary>
            public const string MSG_0075 = "0075";
            /// <summary>
            /// 쿠폰명
            /// </summary>
            public const string MSG_0076 = "0076";
            /// <summary>z
            /// 카드잔액
            /// </summary>
            public const string MSG_0077 = "0077";
            /// <summary>
            /// 보류거래 영수증
            /// </summary>
            public const string MSG_0078 = "0078";
            /// <summary>
            /// 할인금액
            /// </summary>
            public const string MSG_0079 = "0079";
            /// <summary>
            /// 준비금 등록 현황
            /// </summary>
            public const string MSG_0080 = "0080";
            /// <summary>
            /// 영업일자
            /// </summary>
            public const string MSG_0081 = "0081";
            /// <summary>
            /// NO
            /// </summary>
            public const string MSG_0082 = "0082";
            /// <summary>
            /// 준비금
            /// </summary>
            public const string MSG_0083 = "0083";
            /// <summary>
            /// 입력시간
            /// </summary>
            public const string MSG_0084 = "0084";
            /// <summary>
            /// 출력시간
            /// </summary>
            public const string MSG_0085 = "0085";
            /// <summary>
            /// 출하/예정 내역
            /// </summary>
            public const string MSG_0086 = "0086";
            /// <summary>
            /// 분류명/제품명
            /// </summary>
            public const string MSG_0087 = "0087";
            /// <summary>
            /// 1차
            /// </summary>
            public const string MSG_0088 = "0088";
            /// <summary>
            /// 2차
            /// </summary>
            public const string MSG_0089 = "0089";
            /// <summary>
            /// 3차
            /// </summary>
            public const string MSG_0090 = "0090";
            /// <summary>
            /// 금액
            /// </summary>
            public const string MSG_0091 = "0091";
            /// <summary>
            /// 카드 매출
            /// </summary>
            public const string MSG_0092 = "0092";
            /// <summary>
            /// 카드 매출 외
            /// </summary>
            public const string MSG_0093 = "0093";
            /// <summary>
            /// [서명]
            /// </summary>
            public const string MSG_0094 = "0094";
            /// <summary>
            /// 매출  금액
            /// </summary>
            public const string MSG_0095 = "0095";
            /// <summary>
            /// 매출외금액
            /// </summary>
            public const string MSG_0096 = "0096";
            /// <summary>
            /// 주문(대기)번호
            /// </summary>
            public const string MSG_0097 = "0097";
            /// <summary>
            /// OKCASHBACK 적립
            /// </summary>
            public const string MSG_0098 = "0098";
            /// <summary>
            /// 판매LOSS
            /// </summary>
            public const string MSG_0099 = "0099";
            /// <summary>
            /// 행사주문취합내역
            /// </summary>
            public const string MSG_0100 = "0100";
            /// <summary>
            /// 제품명
            /// </summary>
            public const string MSG_0101 = "0101";
            /// <summary>
            /// 단가
            /// </summary>
            public const string MSG_0102 = "0102";
            /// <summary>
            /// 수량
            /// </summary>
            public const string MSG_0103 = "0103";
            /// <summary>
            /// 신분번호
            /// </summary>
            public const string MSG_0104 = "0104";
            /// <summary>
            /// 승인금액
            /// </summary>
            public const string MSG_0105 = "0105";
            /// <summary>
            /// 해피포인트사용
            /// </summary>
            public const string MSG_0106 = "0106";
            /// <summary>
            /// 해피포인트(APP)사용
            /// </summary>
            public const string MSG_0107 = "0107";
            /// <summary>
            /// ** 고객님 {0} 포인트 {1} P가
            /// </summary>
            public const string MSG_0108 = "0108";
            /// <summary>
            /// 사용되어 결제대금 청구시 차감됩니다.
            /// </summary>
            public const string MSG_0109 = "0109";
            /// <summary>
            /// 사용취소 되었습니다.
            /// </summary>
            public const string MSG_0110 = "0110";
            /// <summary>
            /// 기타입출금 현황
            /// </summary>
            public const string MSG_0111 = "0111";
            /// <summary>
            /// 부터
            /// </summary>
            public const string MSG_0112 = "0112";
            /// <summary>
            /// 일자
            /// </summary>
            public const string MSG_0113 = "0113";
            /// <summary>
            /// 구분
            /// </summary>
            public const string MSG_0114 = "0114";
            /// <summary>
            /// 계정
            /// </summary>
            public const string MSG_0115 = "0115";
            /// <summary>
            /// 입금합계
            /// </summary>
            public const string MSG_0116 = "0116";
            /// <summary>
            /// 출금합계
            /// </summary>
            public const string MSG_0117 = "0117";
            /// <summary>
            /// 조회일시
            /// </summary>
            public const string MSG_0118 = "0118";
            /// <summary>
            /// 선불카드 판매 등록
            /// </summary>
            public const string MSG_0119 = "0119";
            /// <summary>
            /// 고객번호
            /// </summary>
            public const string MSG_0120 = "0120";
            /// <summary>
            /// 고 객 명
            /// </summary>
            public const string MSG_0121 = "0121";
            /// <summary>
            /// 선불카드 판매 취소
            /// </summary>
            public const string MSG_0122 = "0122";
            /// <summary>
            /// 보  관  용          
            /// </summary>
            public const string MSG_0123 = "0123";
            /// <summary>
            /// 해피포인트 추후적립 내역            
            /// </summary>
            public const string MSG_0124 = "0124";
            /// <summary>
            /// 이름            
            /// </summary>
            public const string MSG_0125 = "0125";
            /// <summary>
            /// 포인트            
            /// </summary>
            public const string MSG_0126 = "0126";
            /// <summary>
            /// ** {0} 반품 내역**            
            /// </summary>
            public const string MSG_0127 = "0127";
            /// <summary>
            /// 품목            
            /// </summary>
            public const string MSG_0128 = "0128";
            /// <summary>
            /// 요청            
            /// </summary>
            public const string MSG_0129 = "0129";
            /// <summary>
            /// 확정            
            /// </summary>
            public const string MSG_0130 = "0130";
            /// <summary>
            /// 환경사랑할인
            /// </summary>
            public const string MSG_0131 = "0131";
            /// <summary>
            /// 임의등록
            /// </summary>
            public const string MSG_0132 = "0132";
            /// <summary>
            /// 단말기
            /// </summary>
            public const string MSG_0133 = "0133";
            /// <summary>
            /// 현금환불
            /// </summary>
            public const string MSG_0134 = "0134";
            /// <summary>
            /// 비매출구분
            /// </summary>
            public const string MSG_0135 = "0135";
            /// <summary>
            /// 고  객  용
            /// </summary>
            public const string MSG_0136 = "0136";
            /// <summary>
            /// 포인트결제
            /// </summary>
            public const string MSG_0137 = "0137";
            /// <summary>
            /// 고객님
            /// </summary>
            public const string MSG_0138 = "0138";
            /// <summary>
            /// ** 고객님 신한카드 포인트가 정상적으로 취소 처리 되었습니다.
            /// </summary>
            public const string MSG_0139 = "0139";
            /// <summary>
            /// ** 고객님 신한카드 포인트는 잔여한도 내에서 결제 금액의 최대 50% 차감됩니다.
            /// </summary>
            public const string MSG_0140 = "0140";
            /// <summary>
            /// 현금영수증 추후 발행
            /// </summary>
            public const string MSG_0141 = "0141";
            /// <summary>
            /// 카드매출전표
            /// </summary>
            public const string MSG_0142 = "0142";
            /// <summary>
            /// 전화
            /// </summary>
            public const string MSG_0143 = "0143";
            /// <summary>
            /// 쿠폰금액
            /// </summary>
            public const string MSG_0144 = "0144";
            /// <summary>
            /// 쿠폰종류
            /// </summary>
            public const string MSG_0145 = "0145";
            /// <summary>
            /// 할인
            /// </summary>
            public const string MSG_0146 = "0146";
            /// <summary>
            /// 주문내역서
            /// </summary>
            public const string MSG_0147 = "0147";
            /// <summary>
            /// 테이블
            /// </summary>
            public const string MSG_0148 = "0148";
            /// <summary>
            /// 총주문액
            /// </summary>
            public const string MSG_0149 = "0149";
            /// <summary>
            /// 봉 사 료
            /// </summary>
            public const string MSG_0150 = "0150";
            /// <summary>
            /// 봉사과세
            /// </summary>
            public const string MSG_0151 = "0151";
            /// <summary>
            /// 봉사총액
            /// </summary>
            public const string MSG_0152 = "0152";
            /// <summary>
            /// 쿠폰잔액
            /// </summary>
            public const string MSG_0153 = "0153";
            /// <summary>
            /// 주 문 서
            /// </summary>
            public const string MSG_0154 = "0154";
            /// <summary>
            /// 주문시간
            /// </summary>
            public const string MSG_0155 = "0155";
            /// <summary>
            /// 주문번호
            /// </summary>
            public const string MSG_0156 = "0156";
            /// <summary>
            /// 인    원
            /// </summary>
            public const string MSG_0157 = "0157";
            /// <summary>
            /// 해피오더
            /// </summary>
            public const string MSG_0158 = "0158";
            /// <summary>
            /// 총 {0}명 (남 {1}명, 여 {2}명)
            /// </summary>
            public const string MSG_0159 = "0159";
            /// <summary>
            /// 점  포 :
            /// </summary>
            public const string MSG_0160 = "0160";
            /// <summary>
            /// 주  소 :
            /// </summary>
            public const string MSG_0161 = "0161";
            /// <summary>
            /// 대표자 :
            /// </summary>
            public const string MSG_0162 = "0162";
            /// <summary>
            /// 사업자 :
            /// </summary>
            public const string MSG_0163 = "0163";
            /// <summary>
            /// 담당자 :
            /// </summary>
            public const string MSG_0164 = "0164";
            /// <summary>
            /// 출력시간 :
            /// </summary>
            public const string MSG_0165 = "0165";

            /// <summary>
            /// 할인내역
            /// </summary>
            public const string MSG_0166 = "0166";
            /// <summary>
            /// 묶음할인
            /// </summary>
            public const string MSG_0167 = "0167";
            /// <summary>
            /// SKT 할인대상 상품금액
            /// </summary>
            public const string MSG_0168 = "0168";
            /// <summary>
            /// SKT 할인금액
            /// </summary>
            public const string MSG_0169 = "0169";
            /// <summary>
            /// KT 할인대상 상품금액
            /// </summary>
            public const string MSG_0170 = "0170";
            /// <summary>
            /// KT 할인금액
            /// </summary>
            public const string MSG_0171 = "0171";
            /// <summary>
            /// LGT 할인대상 상품금액
            /// </summary>
            public const string MSG_0172 = "0172";
            /// <summary>
            /// LGT 할인금액
            /// </summary>
            public const string MSG_0173 = "0173";
            /// <summary>
            /// OILBANK 할인대상 상품금액
            /// </summary>
            public const string MSG_0174 = "0174";
            /// <summary>
            /// OILBANK 할인금액
            /// </summary>
            public const string MSG_0175 = "0175";
            /// <summary>
            /// BLUE 할인대상 상품금액
            /// </summary>
            public const string MSG_0176 = "0176";
            /// <summary>
            /// BLUE 할인금액
            /// </summary>
            public const string MSG_0177 = "0177";
            /// <summary>
            /// RED 할인대상 상품금액
            /// </summary>
            public const string MSG_0178 = "0178";
            /// <summary>
            /// RED 할인금액
            /// </summary>
            public const string MSG_0179 = "0179";
            /// <summary>
            /// KTVIP 할인대상 상품금액
            /// </summary>
            public const string MSG_0180 = "0180";
            /// <summary>
            /// KTVIP 할인금액
            /// </summary>
            public const string MSG_0181= "0181";
            /// <summary>
            /// 쿠폰/승인번호
            /// </summary>
            public const string MSG_0182 = "0182";
            /// <summary>
            /// 카드/승인번호
            /// </summary>
            public const string MSG_0183 = "0183";
            /// <summary>
            /// 신용카드
            /// </summary>
            public const string MSG_0184 = "0184";
            /// <summary>
            /// 해피포인트
            /// </summary>
            public const string MSG_0185 = "0185";
            /// <summary>
            /// 사용
            /// </summary>
            public const string MSG_0186 = "0186";
            /// <summary>
            /// 적립
            /// </summary>
            public const string MSG_0187 = "0187";
            /// <summary>
            /// 무료 주차 영수증
            /// </summary>
            public const string MSG_0188 = "0188";
            /// <summary>
            /// 담 당 자
            /// </summary>
            public const string MSG_0189 = "0189";
            /// <summary>
            /// {0}년 6월 30일 영업시간 종료 후
            /// </summary>
            public const string MSG_0190 = "0190";
            /// <summary>
            /// {0}포인트(전일기준) 실효 예정입니다.
            /// </summary>
            public const string MSG_0191 = "0191";
            /// <summary>
            /// 점    포 : 
            /// </summary>
            public const string MSG_0200 = "0200";
            /// <summary>
            /// 대 표 자 : 
            /// </summary>
            public const string MSG_0201 = "0201";
            /// <summary>
            /// 사업자NO : 
            /// </summary>
            public const string MSG_0202 = "0202";
            /// <summary>
            /// 담 당 자 : 
            /// </summary>
            public const string MSG_0203 = "0203";
            /// <summary>
            /// POS 번호 : 
            /// </summary>
            public const string MSG_0204 = "0204";
            /// <summary>
            /// 판매일자 : 
            /// </summary>
            public const string MSG_0205 = "0205";
            /// <summary>
            /// 출력시간 : 
            /// </summary>
            public const string MSG_0206 = "0206";
            /// <summary>
            /// 현금반품 내역
            /// </summary>
            public const string MSG_0207 = "0207";
            /// <summary>
            /// 근무시간 확인서 
            /// </summary>
            public const string MSG_0208 = "0208";
            /// <summary>
            /// 직원 코드 :
            /// </summary>
            public const string MSG_0209 = "0209";
            /// <summary>
            /// 직원 성명 :
            /// </summary>
            public const string MSG_0210 = "0210";
            /// <summary>
            /// 출근 시간 :
            /// </summary>
            public const string MSG_0211 = "0211";
            /// <summary>
            /// 퇴근 시간 :
            /// </summary>
            public const string MSG_0212 = "0212";

            //#12500 해피포인트 실효정책 변경에 따른 프로그램 수정 start, phj

            /// <summary>
            /// {0} 고객님, 소멸 예정 포인트 안내
            /// </summary>
            public const string MSG_0213 = "0213";

            /// <summary>
            /// 12월31일 소멸되기 전에 사용하세요.
            /// </summary>
            public const string MSG_0214 = "0214";

            /// <summary>
            /// 실효예정포인트(전일기준) : {0} 포인트 
            /// </summary>
            public const string MSG_0215 = "0215"; 

            //#12500 해피포인트 실효정책 변경에 따른 프로그램 수정 end, phj

            //#Rhee, 20171211 중국 페이 결제 할인문구 추가 start
            /// <summary>
            /// 알리페이 할인
            /// </summary>
            public const string MSG_0216 = "0216";

            /// <summary>
            /// 위쳇페이 할인
            /// </summary>
            public const string MSG_0217 = "0217";

            /// <summary>
            /// 은련페이 할인
            /// </summary>
            public const string MSG_0218 = "0218";
            //#Rhee, 20171211 중국 페이 결제 할인문구 추가 end


            //#20180316 신한카드 잔여포인트 문구 짤리는 증상 수정 start
            /// <summary>
            /// 취소 처리 되었습니다.
            /// </summary>
            public const string MSG_0219 = "0219";

            /// <summary>
            /// 내에서 결제 금액의 최대 100% 차감됩니다.
            /// </summary>
            public const string MSG_0220 = "0220";

            //#20180316 신한카드 잔여포인트 문구 짤리는 증상 수정 end

            //#20180426 현금영수증 마스킹 변경 및 영수증 문구 변경 start
            /// <summary>
            /// 현금영수증 안내문구 line2
            /// </summary>
            public const string MSG_0221 = "0221";

            /// <summary>
            /// 현금영수증 안내문구 line3
            /// </summary>
            public const string MSG_0222 = "0222";

            //#20180426 현금영수증 마스킹 변경 및 영수증 문구 변경 end


            //#20171227, 예약증 양식 출력 Start
            /// <summary>
            /// 예약증
            /// </summary>
            public const string MSG_0300 = "0300";
            /// <summary>
            /// [접수일/직원]
            /// </summary>
            public const string MSG_0301 = "0301";
            /// <summary>
            /// [수령일자/시간]
            /// </summary>
            public const string MSG_0302 = "0302";
            /// <summary>
            /// [고객명/연락처]
            /// </summary>
            public const string MSG_0303 = "0303";
            /// <summary>
            /// [수령 구분]
            /// </summary>
            public const string MSG_0304 = "0304";
            /// <summary>
            /// 매장
            /// </summary>
            public const string MSG_0305 = "0305";
            /// <summary>
            /// 배달
            /// </summary>
            public const string MSG_0306 = "0306";
            /// <summary>
            /// [배달주소]
            /// </summary>
            public const string MSG_0307 = "0307";
            /// <summary>
            /// [상품/수량]
            /// </summary>
            public const string MSG_0308 = "0308";
            /// <summary>
            /// [총 판매가]
            /// </summary>
            public const string MSG_0309 = "0309";
            /// <summary>
            /// [계약금]
            /// </summary>
            public const string MSG_0310 = "0310";
            /// <summary>
            /// 완불/계약금
            /// </summary>
            public const string MSG_0311 = "0311";
            /// <summary>
            /// [할인적립여부]
            /// </summary>
            public const string MSG_0312 = "0312";
            /// <summary>
            /// [영수증 지급]
            /// </summary>
            public const string MSG_0313 = "0313";
            /// <summary>
            /// 발행
            /// </summary>
            public const string MSG_0314 = "0314";
            /// <summary>
            /// 발행안함
            /// </summary>
            public const string MSG_0315 = "0315";
            /// <summary>
            /// [주문여부]
            /// </summary>
            public const string MSG_0316 = "0316";
            /// <summary>
            /// 주문직원
            /// </summary>
            public const string MSG_0317 = "0317";
            /// <summary>
            /// 배송일
            /// </summary>
            public const string MSG_0318 = "0318";
            /// <summary>
            /// [수령확인(sign)]
            /// </summary>
            public const string MSG_0319 = "0319";
            /// <summary>
            /// [실제수령일자]
            /// </summary>
            public const string MSG_0320 = "0320";
            //#20171227, 예약증 양식 출력 End
            // grayber@20180110 전자영수증 주문(대기)번호표 출력 start - 매시지 추가 : 대기번호표
            // 추가
            /// <summary>
            /// 대기번호표
            /// </summary>
            public const string MSG_0321 = "0321";
            // grayber@20180110 전자영수증 주문(대기)번호표 출력 end

            //#20180122 T멤버십 경우 잔여포인트를 잔여한도로 표기하기 start,phj
            /// <summary>
            /// 잔여한도
            /// </summary>
            public const string MSG_0322 = "0322";
            //#20180122 T멤버십 경우 잔여포인트를 잔여한도로 표기하기 end,phj


            //KT 고객일 경우 아래와 같이 영수증 문구 추가 start,phj
            /// <summary>
            /// ★★ KT 더블할인 멤버십 스페셜 이벤트 ★★
            /// </summary> 
            public const string MSG_0324 = "0324";

            /// <summary>
            /// KT 멤버십 전 고객, 천원당 200원 할인
            /// </summary> 

            public const string MSG_0325 = "0325";

            /// <summary>
            /// - 상시(천원당 100원) 대비 2배 할인
            /// </summary> 

            public const string MSG_0326 = "0326";

            /// <summary>
            /// 더블할인 멤버십 내 통합 월 1회 가능
            /// </summary> 

            public const string MSG_0327 = "0327";

            /// <summary>
            /// 행사기간 : 5월1일(화) ~ 5월31일(목)
            /// </summary> 
            public const string MSG_0328 = "0328";
            //KT 고객일 경우 아래와 같이 영수증 문구 추가 end,phj

            //#20180413 웰컴카드 신규기능 추가 start,phj
            /// <summary>
            /// MC 할인대상 상품금액
            /// </summary>
            public const string MSG_0329 = "0329";
            /// <summary>
            /// MC 할인금액
            /// </summary>
            public const string MSG_0330 = "0330";
            //#20180413 웰컴카드 신규기능 추가 end,phj

            //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 start
            /// <summary>
            /// ※ 장부재고 추가등록은 [실시간재고등록]
            /// </summary>
            public const string MSG_0331 = "0331";

            /// <summary>
            /// 메뉴에서 변경 가능합니다.
            /// </summary>
            public const string MSG_0332 = "0332";
            //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 end
        }
        #endregion

        #region ** GUIDE(안내:팝업화면) **
        /// <summary>
        /// GUIDE(안내:팝업화면)
        /// </summary>
        public class GUIDE
        {
            /// <summary>
            /// 해피오더 주문 내역 있습니다./신규주문 : {0} 건/배달 : {1} 건
            /// </summary>
            public const string MSG_0001 = "0001";
            /// <summary>
            /// 해피오더 내역을 확인 하세요.
            /// </summary>
            public const string MSG_0002 = "0002";
            /// <summary>
            /// 저울에서 중량 측정 작업을 진행해 주세요.
            /// </summary>
            public const string MSG_0003 = "0003";

            /// <summary>
            /// POS 테이블 정보를 서버에 백업 중 입니다.
            /// </summary>
            public const string MSG_0004 = "0004";
            /// <summary>
            /// POS 테이블 정보를 서버로 부터 복원 중 입니다.
            /// </summary>
            public const string MSG_0005 = "0005";
            /// <summary>
            /// 핸즈프리 결제를 시작합니다.
            /// </summary>
            public const string MSG_0006 = "0006";
            /// <summary>
            /// 인접한 단말기가 없습니다.\n바코드를 스캐너 또는 키패드를 이용하여 입력하십시오.
            /// </summary>
            public const string MSG_0007 = "0007";
            /// <summary>
            /// OTB 수신 중 입니다.\n잠시만 기다려주세요.
            /// </summary>
            public const string MSG_0008 = "0008";
            /// <summary>
            /// 결제도 T페이로 도와드릴까요?
            /// </summary>
            public const string MSG_0009 = "0009";
            /// <summary>
            /// 주방 프린터를 선택해 주세요.
            /// </summary>
            public const string MSG_0010 = "0010";
            /// <summary>
            /// 해피오더 주문내역이 있습니다.
            /// 해피오더 내역조회에서 확인하세요.
            /// </summary>
            public const string MSG_0011 = "0011";

            //#20170810 추가적립 캠페인 적용 가능시 통신사 할인 하려고 하면 안내 팝업 start
            /// <summary>
            /// 통신사 할인 시 적립캠페인은 적용 되지 않습니다.
            /// 통신사 할인 하시겠습니까?
            /// </summary>
            public const string MSG_0012 = "0012";
            //#20170810 추가적립 캠페인 적용 가능시 통신사 할인 하려고 하면 안내 팝업 end

            //#Rhee, 20180212 거스름돈 안내 팝업 start
            /// <summary>
            /// 거스름돈이 있습니다.
            /// 받은돈 :
            /// 거스름돈 :
            /// </summary>
            public const string MSG_0013 = "0013";
            //#Rhee, 20180212 거스름돈 안내 팝업 end

            //#14505 PB 신월곰달래 - 해피포인트 등록 후 현대M포인트 진입안되도록 수정요청 start,phj
            /// <summary>
            /// 포인트 사용시 해피포인트 적립은 할 수 없습니다. 
            /// 그래도 하시겠습니까?
            /// </summary>
            public const string MSG_0014 = "0014";

            //#14505 PB 신월곰달래 - 해피포인트 등록 후 현대M포인트 진입안되도록 수정요청 end,phj



            //#15347 주류 경고메시지 출력 start

            /// <summary>
            /// 성인용 음료로 미성년자에게 판매할 수 없습니다.
            /// 신분증을 확인해주세요.
            /// </summary>
            public const string MSG_0015 = "0015";

            /// <summary>
            /// 주류상품은 미성년자에게 판매할 수 없습니다.
            /// 신분증을 확인해주세요.
            /// </summary>
            public const string MSG_0016 = "0016";

            //#15347 주류 경고메시지 출력 end 

            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start
            /// <summary>
            /// 바코드 번호가 맞습니까?
            /// </summary>
            public const string MSG_0017 = "0017";
            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end


            //#15945 해피오더 자동주문 상세기능 start
            /// <summary>
            /// 주문 상품을 POS주문에 자동 반영하시겠습니까?
            /// </summary>
            public const string MSG_0018 = "0018";

            /// <summary>
            /// 완제 주문 상품을 POS 주문에 자동 반영 하시겠습니까?
            /// ※ 점포제조제품은 POS주문에 자동반영이 불가 하오니 원주문 이용 바랍니다.
            /// </summary>
            public const string MSG_0019 = "0019";
            //#15945 해피오더 자동주문 상세기능 end

            //#17651 해피오더)자동주문 시 표시문구 변경 start
            //주문 상품을 POS 주문에 자동 반영하시겠습니까?
            //* 입시 상품은 자동출하 미대상 상품 입니다.
            //상시 POS주문 가능한 입시 상품(6종)은 이벤트 출하수량 확인 후
            //필요 시 원주문 으로 주문해 주시기 바랍니다.
            //[6종:명가오색찹쌀떡,명가찹쌀떡(중/소),합격소망엿(대/중),미니브라우니파이]
            public const string MSG_0020 = "0020";

            //완제 주문 상품을 POS 주문에 자동 반영하시겠습니까?
            //* 입시 상품은 자동출하 미대상 상품 입니다.
            //상시 POS주문 가능한 입시 상품(6종)은 이벤트 출하수량 확인 후
            //필요 시 원주문 으로 주문해 주시기 바랍니다.
            //[6종:명가오색찹쌀떡,명가찹쌀떡(중/소),합격소망엿(대/중),미니브라우니파이]
            public const string MSG_0021 = "0021";
            //#17651 해피오더)자동주문 시 표시문구 변경 end

        }
        #endregion

    }

    #region Message Manager
    /// <summary>
    /// Message Manager
    /// </summary>
    public class MessageManager
    {
        /// <summary>
        /// 단어(레이블, 버튼)
        /// </summary>
        private static Hashtable g_htLabelMessage;
        /// <summary>
        /// 문장(에러, 확인, 질문)
        /// </summary>
        private static Hashtable g_htErrorMessage;
        /// <summary>
        /// 안내(팝업화면)
        /// </summary>
        private static Hashtable g_htGuideMessage;
        /// <summary>
        /// 출력(영수증)
        /// </summary>
        private static Hashtable g_htPrintMessage;
        /// <summary>
        /// 정산(정산코드명)
        /// </summary>
        private static Hashtable g_htExactMessage;

        static MessageManager()
        {
            Clear();
        }

        /// <summary>
        /// Message Clear
        /// </summary>
        public static void Clear()
        {
            try
            {
                g_htLabelMessage = new Hashtable();
                g_htPrintMessage = new Hashtable();
                g_htGuideMessage = new Hashtable();
                g_htErrorMessage = new Hashtable();
                g_htExactMessage = new Hashtable();
            }
            catch { }
        }

        /// <summary>
        /// POS 메시지 설정
        /// </summary>
        /// <param name="sPosMessageType"></param>
        /// <param name="sMessageCode"></param>
        /// <param name="sMsg1"></param>
        /// <param name="sMsg2"></param>
        /// <param name="sMsg3"></param>
        /// <param name="sMsg4"></param>
        /// <param name="sMsg5"></param>
        public static void SetMessage(string sPosMessageType, string sMessageCode, string sMsg1, string sMsg2, string sMsg3, string sMsg4, string sMsg5)
        {
            string sMessage = "";

            try
            {
                sMessage = sMsg1.TrimEnd();
                if (sPosMessageType != POS_MESSAGE.TYPE.PRINT && sPosMessageType != POS_MESSAGE.TYPE.EXACT)
                {
                    if (sMsg2.Trim() != "") sMessage += "\n" + sMsg2.TrimEnd();
                    if (sMsg3.Trim() != "") sMessage += "\n" + sMsg3.TrimEnd();
                    if (sMsg4.Trim() != "") sMessage += "\n" + sMsg4.TrimEnd();
                    if (sMsg5.Trim() != "") sMessage += "\n" + sMsg5.TrimEnd();
                }

                SetMessage(sPosMessageType, sMessageCode.Trim(), sMessage);
            }
            catch { }
        }

        /// <summary>
        /// Set Message
        /// </summary>
        /// <param name="sPosMessageType"></param>
        /// <param name="sMessageCode"></param>
        /// <param name="sMessage"></param>
        /// <returns></returns>
        public static void SetMessage(string sPosMessageType, string sMessageCode, string sMessage)
        {
            try
            {
                switch (sPosMessageType)
                {
                    case POS_MESSAGE.TYPE.LABEL:
                        if (g_htLabelMessage.Contains(sMessageCode) == false)
                        {
                            g_htLabelMessage.Add(sMessageCode, sMessage);
                        }
                        break;
                    case POS_MESSAGE.TYPE.PRINT:
                        if (g_htPrintMessage.Contains(sMessageCode) == false)
                        {
                            g_htPrintMessage.Add(sMessageCode, sMessage);
                        }
                        break;
                    case POS_MESSAGE.TYPE.GUIDE:
                        if (g_htGuideMessage.Contains(sMessageCode) == false)
                        {
                            g_htGuideMessage.Add(sMessageCode, sMessage);
                        }
                        break;
                    case POS_MESSAGE.TYPE.ERROR:
                        if (g_htErrorMessage.Contains(sMessageCode) == false)
                        {
                            g_htErrorMessage.Add(sMessageCode, sMessage);
                        }
                        break;
                    case POS_MESSAGE.TYPE.EXACT:
                        if (g_htExactMessage.Contains(sMessageCode) == false)
                        {
                            g_htExactMessage.Add(sMessageCode, sMessage);
                        }
                        break;
                }
            }
            catch { }
        }

        /// <summary>
        /// Get Message
        /// </summary>
        /// <param name="sPosMessageType"></param>
        /// <param name="sMessageCode"></param>
        /// <returns></returns>
        public static string GetMessage(string sPosMessageType, string sMessageCode)
        {
            string sMessage = "";

            try
            {
                switch (sPosMessageType)
                {
                    case POS_MESSAGE.TYPE.LABEL:
                        if (g_htLabelMessage.Contains(sMessageCode))
                        {
                            sMessage = (string)g_htLabelMessage[sMessageCode];
                        }
                        break;
                    case POS_MESSAGE.TYPE.PRINT:
                        if (g_htPrintMessage.Contains(sMessageCode))
                        {
                            sMessage = (string)g_htPrintMessage[sMessageCode];
                        }
                        break;
                    case POS_MESSAGE.TYPE.GUIDE:
                        if (g_htGuideMessage.Contains(sMessageCode))
                        {
                            sMessage = (string)g_htGuideMessage[sMessageCode];
                        }
                        break;
                    case POS_MESSAGE.TYPE.ERROR:
                        if (g_htErrorMessage.Contains(sMessageCode))
                        {
                            sMessage = (string)g_htErrorMessage[sMessageCode];
                        }
                        break;
                    case POS_MESSAGE.TYPE.EXACT:
                        if (g_htExactMessage.Contains(sMessageCode))
                        {
                            sMessage = (string)g_htExactMessage[sMessageCode];
                        }
                        break;
                }
            }
            catch { }

            return sMessage;
        }

        /// <summary>
        /// Get Label Message
        /// </summary>
        /// <param name="sMessageCode"></param>
        /// <returns></returns>
        public static string GetLabelMessage(string sMessageCode)
        {
            string sMessage = "";

            try
            {
                sMessage = GetMessage(POS_MESSAGE.TYPE.LABEL, sMessageCode);
            }
            catch { }

            return sMessage;
        }

        /// <summary>
        /// Get Print Message
        /// </summary>
        /// <param name="sMessageCode"></param>
        /// <returns></returns>
        public static string GetPrintMessage(string sMessageCode)
        {
            string sMessage = "";

            try
            {
                sMessage = GetMessage(POS_MESSAGE.TYPE.PRINT, sMessageCode);
            }
            catch { }

            return sMessage;
        }

        /// <summary>
        /// Get Guide Message
        /// </summary>
        /// <param name="sMessageCode"></param>
        /// <returns></returns>
        public static string GetGuideMessage(string sMessageCode)
        {
            string sMessage = "";

            try
            {
                sMessage = GetMessage(POS_MESSAGE.TYPE.GUIDE, sMessageCode);
            }
            catch { }
            return sMessage;
        }

        /// <summary>
        /// Get Error Message
        /// </summary>
        /// <param name="sMessageCode"></param>
        /// <returns></returns>
        public static string GetErrorMessage(string sMessageCode)
        {
            string sMessage = "";

            try
            {
                sMessage = GetMessage(POS_MESSAGE.TYPE.ERROR, sMessageCode);
            }
            catch { }

            return sMessage;
        }

        /// <summary>
        /// Get Exact Message
        /// </summary>
        /// <param name="sMessageCode"></param>
        /// <returns></returns>
        public static string GetExactMessage(string sMessageCode)
        {
            string sMessage = "";

            try
            {
                sMessage = GetMessage(POS_MESSAGE.TYPE.EXACT, sMessageCode);
            }
            catch { }

            return sMessage;
        }
        #endregion

    }
}
